![luxor splash image](docs/src/assets/figures/luxor-social-media-preview.png)

| **Documentation**                       | **Build Status**                          | **Code Coverage**               |
|:---------------------------------------:|:-----------------------------------------:|:-------------------------------:|
| [![][docs-stable-img]][docs-stable-url] | [![Build Status][ci-img]][ci-url]         | [![][codecov-img]][codecov-url] |
| [![][docs-development-img]][docs-development-url] | [![Build Status][appvey-img]][appvey-url] |                                 |

PkgEval: [![PkgEval][pkgeval-img]][pkgeval-url]

## Luxor

Luxor is a Julia package for drawing simple static 2D vector graphics. It provides basic drawing functions and utilities for working with shapes, polygons, clipping masks, PNG and SVG images, turtle graphics, and simple animations.

!["luxor gallery"](docs/src/assets/figures/luxorgallery.svg)

The focus of Luxor is on simplicity and ease of use: it should be easier to use than plain [Cairo.jl](https://github.com/JuliaLang/Cairo.jl), with shorter names, fewer underscores, default contexts, and simplified functions. 

For more complex and sophisticated graphics in 2D and 3D, [Makie.jl](https://docs.makie.org/stable/) is the best choice.

Luxor is thoroughly procedural and static: your code issues a sequence of simple graphics ‘commands’ until you’ve completed a drawing, then the results are saved into a PDF, PNG, SVG, or EPS file.

Tutorials can be found in the documentation, which you find by clicking on the badges above:
![where is the documentation?](docs/src/assets/figures/where-is-the-documentation.png)

“stable” describes the current release; “development” contains changes that are still in the master branch and may change before the next release.

There are some Luxor-related videos on [YouTube](https://www.youtube.com/channel/UCfd52kTA5JpzOEItSqXLQxg), and some Luxor-related blog posts at [cormullion.github.io/](https://cormullion.github.io/).

Luxor is designed primarily for drawing static pictures and simple animations. If you want to build complex or elaborate animations, use [Javis.jl](https://github.com/JuliaAnimators/Javis.jl) and [Makie](https://docs.makie.org/stable/). 

Luxor isn't interactive: for building interactivity, look at [Pluto.jl](https://github.com/fonsp/Pluto.jl) and [Makie](https://docs.makie.org/stable/).

[docs-development-img]: https://img.shields.io/badge/docs-development-blue
[docs-development-url]: https://juliagraphics.github.io/LuxorManual/dev/

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://juliagraphics.github.io/LuxorManual/stable/

[travis-img]: https://travis-ci.org/JuliaGraphics/Luxor.jl.svg?branch=master
[travis-url]: https://travis-ci.org/JuliaGraphics/Luxor.jl

[appvey-img]: https://ci.appveyor.com/api/projects/status/6pq9v30famcoe3dd?svg=true
[appvey-url]: https://ci.appveyor.com/project/cormullion/luxor-jl/branch/master

[codecov-img]: https://codecov.io/gh/JuliaGraphics/Luxor.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaGraphics/Luxor.jl

[ci-img]: https://github.com/cormullion/Luxor.jl/workflows/CI/badge.svg
[ci-url]: https://github.com/cormullion/Luxor.jl/actions?query=workflow%3ACI

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/L/Luxor.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/L/Luxor.html

using Luxor
import Luxor:strokepath,fillpath,strokepreserve,fillpreserve,clip,clippreserve,paint
using Test

struct NewDispatcher <: Luxor.LDispatcher end

function strokepath(::NewDispatcher)
    return "new strokepath"
end
function fillpath(::NewDispatcher)
    return "new fillpath"
end
function strokepreserve(::NewDispatcher)
    return "new strokepreserve"
end
function fillpreserve(::NewDispatcher)
    return "new fillpreserve"
end
function clip(::NewDispatcher)
    return "new clip"
end
function clippreserve(::NewDispatcher)
    return "new clippreserve"
end
function paint(::NewDispatcher)
    return "new paint"
end


Luxor.DISPATCHER[1] = NewDispatcher()

@test Luxor.strokepath() == "new strokepath"
@test Luxor.fillpath() == "new fillpath"
@test Luxor.fillpreserve() == "new fillpreserve"
@test Luxor.strokepreserve() == "new strokepreserve"
@test Luxor.clip() == "new clip"
@test Luxor.clippreserve() == "new clippreserve"
@test Luxor.paint() == "new paint"

#check if setting back gets default behavior
Luxor.DISPATCHER[1] = Luxor.DefaultLuxor()

function drawthings(fname)
    Drawing(1000,1000,fname)
    circle(O,100,:fillpreserve)
    sethue("red")
    circle(O,200,:stroke)
    circle(O+Point(200,200),100,:strokepreserve)
    sethue("red")
    fillpath()
	origin()
	ngon(O,100;action=:path)
	clip()
	translate(40,0)
	ngon(O,100;action=:path)
	sethue("green")
	clippreserve()
	paint()
    @test finish() == true
    println("... finished dispatcher test , saved in $(fname)")
end

fname = "dispatcher_test.png"
drawthings(fname)

#test if defaults to luxor behavior if method is not defined
struct NewDispatcher2 <: Luxor.LDispatcher end
Luxor.DISPATCHER[1] = NewDispatcher2()

fname = "dispatcher_default_test.png"
drawthings(fname)

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function make_some_holes(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("black")
    pagetiles = Tiler(1200, 1200, 17, 19, margin=50)
    for (pos, n) in pagetiles
      randomhue()
      rad = pagetiles.tilewidth
      ngon(pos, rad/2, rand(5:12), 0, :path)
      newsubpath()
      ngon(pos, rand(1:rad/3), rand(5:12), 0, :path, reversepath=true)
      fillstroke()
    end
    @test finish() == true
end

fname = "holes.pdf"
make_some_holes(fname)
println("...finished test: output in $(fname)")

using Luxor

using Test

using Random
Random.seed!(42)

function text_path_clip(fname)
    currentwidth = 1250 # pts
    currentheight = 800 # pts
    Drawing(currentwidth, currentheight, fname)

    origin()
    background("darkslategray3")

    fontsize(600) # big text to use for clipping
    fontface("Agenda-Black")
    str = "julia" # string to be clipped
    w, h = textextents(str)[3:4] # get width and height

    translate(-(currentwidth/2) + 50, -(currentheight/2) + h)

    textpath(str) # make text into a path
    setline(3)
    setcolor("black")
    fillpreserve() # fill but keep
    clip()  # clip

    fontface("Monaco")
    fontsize(10)
    namelist = map(x->string(x), names(Base)) # list of names in Base.

    x = -20
    y = -h
    while y < currentheight
        sethue(rand(7:10)/10, rand(7:10)/10, rand(7:10)/10)
        s = namelist[rand(1:end)]
        text(s, x, y)
        se = textextents(s)
        x += se[5] # move to the right
        if x > w
           x = -20 # next row
           y += 10
        end
    end

    @test finish() == true
end

fname = "text-path-clipping.png"
text_path_clip(fname)
println("...finished test: output in $(fname)")

using Luxor
using Test
using Random
Random.seed!(3)

function test_lux_bb(; center = O)
    bx = BoundingBox(box(O + center, 200, 200, :none))
    box(bx, :stroke)
    for i in 0:14
        pt = if i < 4
            sethue("yellow")
            ang = i * π / 2
            O + center + 40 .* (cos(ang), sin(ang)) # adjust center!
        else
            sethue("grey50")
            randompoint((1.5bx)...)
        end
        arrow(O + center, pt) # adjust center!
        pt2 = pointcrossesboundingbox(pt, bx)
        circle(pt2, 3, :stroke)
    end
    snapshot()
end

function point_bb_test1(fname)
    Drawing(800, 400, :rec)
    background("brown")
    origin(200, 200)
    test_lux_bb()
    translate(400, 0)
    test_lux_bb(; center = (-45, -25))
    snapshot(; fname = fname)
    println("...finished point crosses bounding box test 1, saved in $(fname)")
end

function point_bb_test2(fname)
    Drawing(1200, 1200, fname)
    background("black")
    origin()
    boxcenter = rand(BoundingBox() * 0.8)
    bx = box(boxcenter, rand(150:500), rand(150:500))
    bbx = BoundingBox(bx)
    setline(0.5)
    sethue("gold")
    circle(boxcenter, 10, :stroke)
    box(bbx, :stroke)
    pts = randompointarray(BoundingBox(), 100)
    for pt in pts
        sethue("red")
        circle(pt, 2, :fill)
        p1 = pointcrossesboundingbox(pt, bbx)
        line(boxcenter, p1, :stroke)
        sethue("green")
        line(p1, pt, :stroke)
        sethue("cyan")
        circle(p1, 1, :fill)
    end
    finish()
    println("...finished point crosses bounding box test 2, saved in $(fname)")
end

fname = "point-crosses-bounding-box-test-1.png"
point_bb_test1(fname)

fname = "point-crosses-bounding-box-test-2.png"
point_bb_test2(fname)

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function triangle_tests(fname)
    Drawing(800, 800, fname)
    origin()
    background("white")
    fontsize(10)

    panes = Tiler(500, 500, 2, 2)

    @layer begin
        translate(first(panes[1]))
        # equilateral
        tri1 = [polar(100, θ) for θ in (0, 2π/3, 4π/3)]
        prettypoly(tri1, :stroke, close=true)

        orthocenter = triangleorthocenter(tri1...)
        incenter = triangleincenter(tri1...)
        center = trianglecenter(tri1...)
        circumcenter = trianglecircumcenter(tri1...)
        circle.((orthocenter, incenter, center, circumcenter), 2, :fill)

        # all centers are the same
        @test isapprox(orthocenter, incenter, atol=1.0e-12)
        @test isapprox(orthocenter, center,  atol=1.0e-12)
        @test isapprox(orthocenter, circumcenter, atol=1.0e-12)
    end

    @layer begin
        translate(first(panes[2]))
        # isosceles
        tri2 = [Point(0, 0), Point(80, -80), Point(160, 0)]
        prettypoly(tri2, :stroke, close=true)

        orthocenter = triangleorthocenter(tri2...)
        incenter = triangleincenter(tri2...)
        center = trianglecenter(tri2...)
        circumcenter = trianglecircumcenter(tri2...)
        circle.((orthocenter, incenter, center, circumcenter), 2, :fill)
        label.(["orthocenter", "incenter", "center", "circumcenter"], :e, (orthocenter, incenter, center, circumcenter))

        # all centers lie on the same vetical line
        @test isapprox(orthocenter.x, incenter.x)
        @test isapprox(orthocenter.x, center.x)
        @test isapprox(orthocenter.x, circumcenter.x)
    end

    @layer begin
        translate(first(panes[3]))
        # arbitrary
        tri3 = ngon(O + (50, 50), 160, 4, π/3, vertices=true)[1:3]
        prettypoly(tri3, :stroke, close=true)

        orthocenter = triangleorthocenter(tri3...)
        incenter = triangleincenter(tri3...)
        center = trianglecenter(tri3...)
        circumcenter = trianglecircumcenter(tri3...)
        circle.((orthocenter, incenter, center, circumcenter), 2, :fill)
        label.(("orthocenter", "incenter", "center", "circumcenter"), :N, (orthocenter + (0, 5), incenter +  (0, 15), center + (0, 20), circumcenter))
        # some are inside, some are outside
        @test isinside(incenter, tri3)
        @test isinside(center, tri3)
    end

    @test finish() == true
    println("...finished test: output in $(fname)")
end

triangle_tests("triangle-tests.svg")

using Luxor

using Test

using Random

Random.seed!(42)

params = (
    (3, 4.5, 10, 10),
    (4, 12, 15, 15),
    (7, 10, 6, 6),
    (5, 4, 4, 4),
    (5, 2, 7, 7),
    (5, 2, 13, 13),
    (4, 1, 1, 1),
    (4, 1, 7, 8),
    (6, 1, 7, 8),
    (2, 2, 2, 2),
    (1, 0.5, 0.5, 0.5),
    (2, 0.5, 0.5, 0.5),
    (5, 1, 1, 1),
    (3, 0.5, 0.5, 0.5),
    (2, 1, 1, 1),
    (7, 3, 4, 17),
    (2, 1, 4, 8),
    (6, 1, 4, 8),
    (7, 2, 8, 4),
    (4, 0.5, 0.5, 4),
    (8, 0.5, 0.5, 8),
    (16, 0.5, 0.5, 16),
    (3, 30, 15, 15),
    (4, 30, 15, 15))

function test_polysuper(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("black")
    tiles = Tiler(1200, 1200, 6, 4)
    for (pos, n) in tiles
        n > length(params) && break
        @layer begin
            randomhue()
            translate(pos)
            m, n1, n2, n3 = params[n]
            radius = 100
            v = polysuper(pos, m = m, n1 = n1, n2 = n2, n3 = n3, action = :path, radius = radius, vertices = true)
            bbx = 1.5 * BoundingBox(v)
            x, y = boxdiagonal(bbx), boxdiagonal(BoundingBox(box(tiles, n)))
            scale(y / x) # scale to fit
            polysuper(m = m, n1 = n1, n2 = n2, n3 = n3, action = :path, radius = radius)
            newsubpath()
            polysuper(m = m, n1 = n1, n2 = n2, n3 = n3, action = :path, radius = radius / 2, reversepath = true)
            fillpath()
            @layer begin
                scale(x/y) # reset scale to 1:1 for text
                translate(0, -tiles.tileheight/2)
                sethue("gold")
                fontsize(12)
                text(string(params[n]), halign=:center)
            end
        end
    end
    @test finish() == true
end

fname = "test-polysuper.png"
test_polysuper(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

# test polygon simplification

using Luxor

using Test

using Random
Random.seed!(42)

function sinecurves()
    gsave()
    translate(100, 100)
    setline(0.25)
    sethue(0, 0, 0)
    x_vals = collect(0:pi/180: 40pi)
    # generate array of Points
    plist = [Point(d * 2pi , -sin(d) * cos(20 * d) * 8 * sin(d/10)) for d in x_vals]
    prettypoly(plist, :stroke, () -> (gsave(); randomhue(); circle(O, 0.5, :stroke); grestore()))
    text("original " * string(length(plist)) * " vertices" , 0, -15)
    for detail in [0.01, 0.05, 0.1, 0.2, 0.5, 0.75, 1.0, 2.0]
        translate(0, 50)
        simplified = simplify(plist, detail)
        prettypoly(simplified, :stroke, () -> (gsave(); randomhue(); circle(O, 0.5, :stroke); grestore()))
        text("detail  $(detail), " * string(length(simplified)) * " vertices" , 0, -15)
    end
    grestore()
end

function test(pagewidth, pageheight)
    translate(100, pageheight/2)
    g = GridRect(O, 0, 60)
    setline(0.25)
    sethue(0, 0, 0)
    x_vals = collect(0:pi/100: 4pi)
    polyline = [Point(d * 20pi, 5 * -sin(d) * cos(12 * d) * 8 * sin(d/10)) for d in x_vals]
    poly(polyline, :stroke)
    prettypoly(polyline)
    text("original " * string(length(polyline)) * " vertices" , 0, -30)
    for detail in [0.01, 0.05, 0.075, 0.1, 0.2, 0.5, 0.75, 1.0, 2.0]
        gsave()
        translate(nextgridpoint(g))
        polysimple = simplify(polyline, detail)
        prettypoly(polysimple, :stroke, () -> (gsave(); randomhue(); circle(O, 2, :stroke); grestore()))
        text(" detail ($detail), " * string(length(polysimple)) * " vertices" , 0, -20)
        grestore()
    end
end

function simplify_poly(fname)
    pagewidth  = 1190.0 # points
    pageheight = 1684.0 # points
    Drawing(pagewidth, pageheight, fname)
    sinecurves()
    test(pagewidth, pageheight)
    @test finish() == true
    println("...finished test: output in $(fname)")
end

function simplify_square()
    poly = Point[Point(-1.0, 0.0), Point(-1.0, -1.0), Point(0.0, -1.0), Point(1.0, -1.0), Point(1.0, 0.0), Point(1.0, 1.0), Point(0.0, 1.0), Point(-1.0, 1.0)]

    poly = simplify(poly, 0.01)
    @test poly == Point[Point(-1.0, 0.0), Point(-1.0, -1.0), Point(1.0, -1.0), Point(1.0, 1.0), Point(-1.0, 1.0)]
end

simplify_poly("simplify-poly.pdf")

simplify_square()

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function run_line_intersection_test(fname)
    Drawing(2000, 2000, fname)
    origin()
    sethue("magenta")
    setline(.2)
    fontsize(4)
    tiles = Tiler(1000, 1000, 10, 10)
    for (pos, n) in tiles
        gsave()
        randomhue()
        translate(pos)
        topleft = Point(-tiles.tilewidth/2, -tiles.tileheight/2)
        bottomright = Point(tiles.tilewidth/2, tiles.tileheight/2)
        a = randompoint(topleft, bottomright)
        b = randompoint(topleft, bottomright)
        c = randompoint(topleft, bottomright)
        d = randompoint(topleft, bottomright)
        line(a, b, :stroke)
        line(c, d, :stroke)
        (flag, ip) = intersectionlines(a, b, c, d, crossingonly=true)
        text("the lines $(flag ? "do" : "don't") cross", O)
        if flag
            gsave()
            setline(.5)
            setdash("dot")
            if distance(a, ip) < distance(b, ip)
                arrow(a, ip, arrowheadlength=1)
            else
                arrow(b, ip, arrowheadlength=1)
            end
            if distance(c, ip) < distance(d, ip)
                arrow(c, ip, arrowheadlength=1)
            else
                arrow(d, ip, arrowheadlength=1)
            end
            circle(ip, 2, :fill)
            grestore()
        else
            if ip != O
                box(ip, 2, 2, :fill)
            end
            dist = distance(O, ip)
            if dist > 500
                text("intersection point is $(dist) units away", O + (0, 10))
            end
        end
        grestore()
    end
    @test finish() == true

end

fname = "line-intersection-options.pdf"
run_line_intersection_test(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_bboxes_1(fname)
    pagewidth, pageheight = 1200, 1400

    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("ivory")
    setline(40)
    sethue("blue")
    box(BoundingBox(), :stroke)
    sethue("red")
    box(BoundingBox() * 0.9, :stroke)

    sethue("green")
    box(BoundingBox(centered=false) * 0.9, :stroke)

    sethue("purple")
    setopacity(0.7)
    fontsize(100)
    box(BoundingBox("purple"), :fill)
    sethue("white")
    text("purple")

    setline(10)
    sethue("black")
    bb = BoundingBox()
    circle(midpoint(bb), 30, :stroke)
    for i in 0:0.05:1
        randomhue()
        circle(between(bb, i), 30, :fill)
    end

    # combine and intersections
    box1 = BoundingBox()/3 - (200, 200)
    box2 = BoundingBox()/4 - (300, 300)
    box3 = box1 + box2
    box4 = intersectboundingboxes(box1, box2)
    sethue("black")
    setline(2)
    box.([box1, box2, box3, box4], :stroke)


    sethue("pink")
    box(box1, :fill)

    sethue("yellow")
    box(box2, :fill)

    sethue("purple")
    box(box3, :fill)

    sethue("green")
    box(box4, :fill)

    @test isapprox(boxaspectratio(box1), 1.166, atol = 0.01)
    @test isapprox(boxdiagonal(box1), 614.636, atol = 0.01)

    # get vertices
    bv = box(box1, vertices=true)
    @test isapprox(bv[1].y, 33.333, atol = 0.1)

    setline(1)
    # contains
    for i in 1:1000
        pt = Point(rand(-1000:1000), rand(-1000:1000))
        if isinside(pt, box4)
            sethue("red")
            circle(pt, 15, :fill)
            sethue("black")
            circle(pt, 1, :fill)
        elseif isinside(pt, box2)
            sethue("white")
            circle(pt, 20, :fill)
            sethue("black")
            circle(pt, 1, :fill)
        elseif isinside(pt, box1)
            sethue("black")
            circle(pt, 5, :stroke)
        end
    end

    # poly
    s = star(O, 300, 7, 0.5, 0, vertices=true)
    box5 = BoundingBox(s)
    poly(s, :stroke, close=true)
    prettypoly(box5, :stroke, close=true, vertexlabels=(n, t) -> label(string(n)))
    @test finish() == true
    println("...finished bounding box test, saved in $(fname)")
end

Random.seed!(42)

fname = "bounding-box-test.png"

test_bboxes_1(fname)

using Luxor
using Test

function test_rule2(fname)
    Drawing(500, 500, fname)
    background("white")
    origin()
    setline(0.7)

    L = 110

    toppts = between.(Point(-250, -250), Point(250, -250), range(0, 1, length = L))
    bottompts = between.(Point(-250, 250), Point(250, 250), range(0, 1, length = L))
    
    circle.(toppts, 3, :fill)
    circle.(bottompts, 3, :fill)
    
    bbox = BoundingBox(box(O, 495, 495))
    rule.(toppts, bottompts, boundingbox = bbox)
    rule.(toppts, reverse(bottompts), boundingbox = bbox)

    leftpts = between.(Point(-250, -250), Point(-250, 250), range(0, 1, length = L))
    rightpts = between.(Point(250, -250), Point(250, 250), range(0, 1, length = L))

    rule.(leftpts, rightpts)
    rule.(leftpts, reverse(rightpts))

    @test finish() == true
    println("...finished test: output in $(fname)")
end

test_rule2("rule2.png")
println("...finished rule2 test")

using Luxor

using Typstry

"""
    text(ts::TypstString, pos::Point=O; 
        centered=false,
        place=true,
        preamble=Typstry.typst"")

Pass the text in `ts` (a TypstString) to the Typst compiler, which returns an SVG image object of type `Luxor.SVGimage`.

If `place` is true, place this image on the drawing at `pos`. Otherwise return the SVG image object. You can later place this image on the drawing using `placeimage()`.

Use keyword `centered=true` to place the center of the image, rather than the top left corner, at the specified position.

## Example

```julia
using Luxor
using Typstry

ts = typst\"\"\"\$a + b/c = sum_i x^i\$\"\"\";
ty_preamble = typst\"\"\"
#set page(fill: rgb("#eeffff"), height: 200pt, width: 300pt, margin: 0pt);
#set text(size: 40pt)
\"\"\"

@draw begin
    si = text(ts, Point(0, 0), preamble=ty_preamble)
end
```
"""
function Luxor.text(ts::TypstString, pos::Point;
        place=true,
        centered=false,
        preamble=Typstry.typst"")
    io = IOBuffer()
    show(IOContext(io, :preamble => preamble), "image/svg+xml", ts)
    svgimage = readsvg(String(take!(io)))
    if place == true
        xpos, ypos = pos
        if centered == true
            w, h = svgimage.width, svgimage.height
            xpos, ypos = xpos - (w / 2), ypos - (h / 2)
        end
        placeimage(svgimage, Point(xpos, ypos))
    else
        return svgimage
    end
end

"""
    render_typst_document(ts::TypstString)

Render the Typst string in `ts` to an array of SVG images, one 
for each page.

## Example

This example takes a Typst string which defines
a three page document. The `pages` array contains
the pages as SVG images. These are placed using
Luxor tiles.

```julia
using Luxor
using Typstry

ts = typst\"\"\"
#set page(fill: white, height:100pt, width: 100pt)
#set text(size: 8pt, fill: black)
#lorem(10)
#pagebreak()
#lorem(10)
#pagebreak()
#lorem(10)
\"\"\"

@draw begin
    pages = render_typst_document(ts)
    tiles = Tiler(500, 200, 1, length(pages))
    for p in eachindex(pages)
        cpos = first(tiles[p])
        w, h = pages[p].width, pages[p].height
        box(cpos, w, h, :stroke)
        placeimage(pages[p], cpos, centered=true)
    end
end
```
"""
function Luxor.render_typst_document(ts::TypstString)
    path = mktempdir(tempdir(), cleanup = false)
    cd(path)
    write("document{0p}.typ", ts)
    typst("compile document{0p}.typ --format svg")
    result = Luxor.SVGimage[]
    for f in filter(fn -> endswith(fn, "svg"), readdir(path, join = true))
        push!(result, readsvg(f))
    end
    return result
end

#!/usr/bin/env julia

using Luxor

using Random
Random.seed!(42)

using Test


function multitest(w, h)
    tiles = Tiler(w, h, 5, 5)
    setopacity(0.95)
    for (pos, n) in tiles
        gsave()
        translate(pos)
        bandthickness = rand(10:tiles.tileheight/4)
        ang = rand(pi/12:pi/12:pi/2)
        for l in 10:bandthickness:tiles.tileheight/2 - bandthickness/2
            for a in 0:ang:2pi
                randomhue()
                if n % 3 == 0
                    sector(l, l + bandthickness/2, a, a + pi/8, 5, :stroke)
                else
                    sector(l, l + bandthickness/2, a, a + pi/8, 5, :fill)
                end
            end
        end
        text("thickness $bandthickness | angle $(rad2deg(ang))", O)
        grestore()
    end
end

function multitest1(w, h)
    tiles = Tiler(w, h, 5, 5)
    setopacity(0.5)
    for (pos, n) in tiles
        gsave()
        translate(pos)
        cornerradius = rand(5:14)
        endangle = deg2rad(45/n)
        sector(60, 90, 0, endangle, cornerradius, :fillstroke)
        text("corner $cornerradius angle $(rad2deg(endangle))")
        grestore()
    end
end

function run_sectorround_test(fname)
    Drawing(2000, 2000, fname)
    origin()
    tiles = Tiler(2000, 2000, 2, 1)
    gsave()
    translate(tiles[1][1])
    multitest(2000, 1000)
    grestore()
    gsave()
    translate(tiles[2][1])
    multitest1(2000, 1000)
    grestore()
    @test finish() == true
    println("...finished test: output in $(fname)")
end

run_sectorround_test("sector-rounded.pdf")

"""
The Luxor package provides a set of vector drawing functions for creating graphical documents.

```julia
@draw begin
    circle(Point(0, 0), 100, :stroke)
    text("Hello World")
end
```
"""
module Luxor

using FileIO
using Base64
using Cairo
using Colors
using Dates
using FFMPEG
using Rsvg

import PolygonAlgorithms as PA

#= from Cairo use: CairoARGBSurface, CairoEPSSurface,
#CairoMatrix, CairoPDFSurface, CairoPattern,
#CairoPatternMesh, CairoSurface, CairoSVGSurface,
#CairoContext, arc, arc_negative, circle, clip,
#clip_preserve, close_path, convert_cairo_path_data,
#copy_path, copy_path_flat, curve_to, destroy, fill,
#fill_preserve, finish, get_matrix, get_operator, height,
#image, line_to, mesh_pattern_begin_patch,
#mesh_pattern_curve_to, mesh_pattern_end_patch,
#mesh_pattern_line_to, mesh_pattern_move_to,
#mesh_pattern_set_corner_color_rgba, move_to, new_path,
#new_sub_path, paint, paint_with_alpha,
#pattern_add_color_stop_rgba, pattern_create_linear,
#pattern_create_radial, pattern_set_extend, read_from_png,
#rectangle, rel_line_to, rel_move_to, reset_clip, restore,
#rotate, save, scale, select_font_face, set_antialias,
#set_fill_type, set_font_face, set_font_size, set_line_cap, set_line_join,
#set_dash, set_line_type, set_line_width, set_matrix,
#set_operator, set_source, set_source_rgba,
#set_source_surface, show_text, status, stroke,
#stroke_preserve, text, text_extents, text_path, translate,
#width, write_to_png =#

include("drawings.jl")
include("point.jl")
include("basics.jl")
include("Turtle.jl")
include("shapes.jl")
include("BoundingBox.jl")
include("Table.jl")
include("polygonalgorithms.jl")
include("polygons.jl")
include("triangles.jl")
include("hexagons.jl")
include("curves.jl")
include("tiles-grids.jl")
include("arrows.jl")
include("text.jl")
include("blends.jl")
include("matrix.jl")
include("juliagraphics.jl")
include("colors_styles.jl")
include("images.jl")
include("animate.jl")
include("bars.jl")
include("bezierpath.jl")
include("mesh.jl")
include("Boxmaptile.jl")
include("noise.jl")
include("deprecations.jl")
include("randompoints.jl")
include("Path.jl")
include("precompile.jl")
include("placeeps.jl")
include("extension_handling.jl")
# include("play.jl") # will require MiniFB
# include("shapefile.jl") # don't load unless you've loaded Shapefile.jl

export Drawing,
    cm, inch, mm,
    paper_sizes,
    Tiler, Partition,
    rescale, currentdrawing, finish, preview, snapshot,
    origin, rulers, background, @png, @pdf, @svg, @eps, @draw, @drawsvg, @savesvg,

    # @play,

    newpath, closepath, newsubpath, BezierPath, BezierPathSegment, bezier, bezier′,
    bezier′′, makebezierpath, drawbezierpath,
    bezierpathtopoly, beziertopoly, pathtobezierpaths,
    bezierfrompoints, beziercurvature, bezierstroke,
    setbezierhandles, beziersegmentangles, bezigon,
    shiftbezierhandles, brush, trimbezier, splitbezier, strokepath, fillpath, rect, box, cropmarks, setantialias, setline, getline, setlinecap, setlinejoin, setdash,
    setstrokescale, move, rmove, line, rule, rline, arrow, arrowhead,
    dimension, tickline, BoundingBox, boxwidth, boxheight, boxdiagonal,
    boxaspectratio, boxtop, boxbottom, boxtopleft,
    boxtopcenter, boxtopright, boxmiddleleft,
    boxmiddlecenter, boxmiddleright, boxbottomleft,
    boxbottomcenter, boxbottomright, intersectboundingboxes, boundingboxesintersect,
    pointcrossesboundingbox, BoxmapTile, boxmap, circle, circlepath, circlering, ellipse, hypotrochoid, epitrochoid,
    squircle, squirclepath, polysuper, center3pts, curve, arc, carc, arc2r, carc2r,
    isarcclockwise, arc2sagitta, carc2sagitta, spiral,
    sector, intersection2circles, intersection_line_circle,
    intersectionlinecircle, intersectioncirclecircle,
    ispointonline, ispointonleftofline, ispointonpoly, intersectlinepoly,
    polyintersect, polyintersections, polydifference, polyunion, polyxor,
    polyclip, circlepointtangent,
    circletangent2circles, pointinverse, pointcircletangent,
    circlecircleoutertangents, circlecircleinnertangents,
    ellipseinquad, crescent, ngon, ngonside, star, pie, polycross,
    do_action, paint, paint_with_alpha, fillstroke, AbstractPoint, Point, O, randompoint, randompointarray, midpoint,
    between, slope, intersectionlines, pointlinedistance,
    getnearestpointonline, isinside, roundcorner, 
    rotatepoint, perpendicular, crossproduct,
    dotproduct, determinant3, distance, prettypoly, polysmooth, polysplit,
    poly, simplify, polycentroid, polysortbyangle, polyhull,
    polysortbydistance, offsetpoly, polyfit, currentpoint, polybspline,
    hascurrentpoint, getworldposition, anglethreepoints, polyperimeter, polydistances, polyportion,
    polyremainder, nearestindex, polyarea, polysample, polysidelengths, 
    insertvertices!, polymove!, polyscale!, polyrotate!, polyreflect!, @polar, polar, strokepreserve, fillpreserve,
    gsave, grestore, @layer,
    scale, rotate, translate,
    clip, clippreserve, clipreset, getpath, getpathflat, pathtopoly, fontface, fontsize, text, textpath, label, textextents,
    textoutlines, textcurve, textcentred, textcentered,
    textright, textcurvecentred, textcurvecentered,
    get_fontsize, textwrap, textlines, splittext, textbox,
    texttrack, textplace, textfit, textonpoly, textformat, setcolor, setopacity, sethue, setgrey, setgray,
    randomhue, randomcolor, @setcolor_str, getcolor,
    getmatrix, setmatrix, transform, setfont, settext, Blend, setblend, blend, addstop, blendadjust,
    blendmatrix, setblendextend, rotationmatrix, scalingmatrix,
    translationmatrix, cairotojuliamatrix,
    juliatocairomatrix, getrotation, getscale,
    gettranslation, setmode, getmode, GridHex, GridRect, nextgridpoint, 
    EquilateralTriangleGrid, Table,
    highlightcells, getcells, markcells, readpng, readsvg, placeimage, placeeps,
    svgstring, julialogo, juliacircles, barchart, mesh, setmesh, add_mesh_patch, mask,

    # animation
    Movie, Scene, animate, lineartween, easeinquad, easeoutquad, easeinoutquad,
    easeincubic, easeoutcubic, easeinoutcubic, easeinquart,
    easeoutquart, easeinoutquart, easeinquint, easeoutquint,
    easeinoutquint, easeinsine, easeoutsine, easeinoutsine,
    easeinexpo, easeoutexpo, easeinoutexpo, easeincirc,
    easeoutcirc, easeinoutcirc, easingflat,
    easeinoutinversequad, easeinoutbezier,

    # noise
    noise, initnoise,

    # experimental polygon functions
    polyremovecollinearpoints,
    polytriangulate, ispointinsidetriangle, ispolyclockwise,
    polyorientation, ispolyconvex, polymorph,

    # triangles
    trianglecircumcenter, triangleincenter, trianglecenter, triangleorthocenter,

    # hexagons
    HexagonAxial, HexagonCubic, HexagonOffsetOddR, HexagonOffsetEvenR,
    # hexagon,
    hexcenter, hexcube_round, hexcube_linedraw,
    HexagonVertexIterator, hextile, hexspiral,
    HexagonNeighborIterator, hexneighbors,
    HexagonDiagonalIterator, hexdiagonals,
    HexagonDistanceIterator, hexagons_within,
    HexagonRingIterator, hexring, hexnearest_cubic,

    # misc
    image_as_matrix, @imagematrix, image_as_matrix!, @imagematrix!,

    # paths
    Path, PathClose, PathCurve, PathElement, PathLine,
    PathMove, bezierpathtopath, drawpath, storepath,
    polytopath, pathlength, pathsample, setfillrule, getfillrule,

    # experimental
    tidysvg,

    # latex 
    latextextsize, latexboundingbox, rawlatexboundingbox,

    # typst
    render_typst_document

# basic unit conversion to Cairo/PostScript points
const inch = 72.0
const cm = 28.3464566929
const mm = 2.83464566929

end # module

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function poly_split_2(fname)
    Drawing(2500, 2500, fname)
    background(1, .8, .1)
    origin()
    setopacity(0.7)
    fontsize(2)
    sethue("black")
    s = squircle(O, 600, 600, vertices=true)
    s = box(O, 60, 60, vertices=true)
    setline(2)
    tiles = Tiler(2500, 2500, 6, 6, margin=25)
    for (pos, n) in tiles
        gsave()
        s = squircle(O, tiles.tileheight/2 - 10, tiles.tileheight/2 - 10, vertices=true)
        translate(pos)
        pt1 = Point(O.x + rand(-120:120), -tiles.tileheight/2)
        pt2 = Point(O.x + rand(-120:120), tiles.tileheight/2)
        setdash("dot")
        move(pt1)
        rline(pt2 - pt1)
        strokepath()
        setdash("solid")
        poly1, poly2 = polysplit(s, pt1, pt2)
        randomhue()
        prettypoly(poly1, :fill, close=true)
        randomhue()
        translate(5, 0)
        prettypoly(poly2, :fill, close=true)
        grestore()
    end
    @test finish() == true
end

fname = "polysplit-2.pdf"
poly_split_2(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function arrow_test(fname)
    pagewidth, pageheight = 2000, 2000
    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("ivory")
    setopacity(0.8)
    pagetiles = Tiler(pagewidth, pageheight, 40, 8, margin=50)
    theta = 0
    for theta in range(0, step=π/8, stop = 2π - π/8)
        @layer begin
            rotate(theta)
            translate(120, 0)
            sethue("magenta")
            line(O, O + (230, 230), :stroke)
            sethue("grey10")
            arrow(O, O + (230, 230), [rand(-80:80), rand(-80:80)],
                :stroke,
                linewidth=3,
                startarrow=rand(Bool),
                finisharrow=rand(Bool),
                arrowheadlength=30,
                decoration = rescale(theta, 0, 2π),
                decorate=() -> (randomhue(), circle(O, rescale(theta, 0, 2π, 5, 20), :fill)))
        end
    end
    @test finish() == true
end

Random.seed!(42)
fname = "arrow-bezier-test.pdf"
arrow_test(fname)
println("...finished test: output in $(fname)")

using BenchmarkTools
using Random
using Luxor

# load some benchmarking functions
include("simple-benchmarks.jl")

# Define a parent BenchmarkGroup to contain our suite

SUITE = BenchmarkGroup()

# Add some child groups to our benchmark suite

SUITE["string"] = BenchmarkGroup(["string"])
SUITE["graphics"] = BenchmarkGroup(["graphics"])

# add some benchmarking calls ?

SUITE["string"]["tiletext"] = @benchmarkable bm_text()
SUITE["string"]["tiletextoutlines"] = @benchmarkable bm_text_outlines()
SUITE["graphics"]["tilegraphics"] = @benchmarkable bm_graphics()

using Luxor, Test

function polycliptest(fname)
    Drawing(1200, 800, fname)
    background("black")
    origin()
    pgon1 = ngon(O, 100, 5, vertices = true)
    pgon2 = ngon(O, 150, 7, vertices = true)

    pc = polyclip(pgon1, pgon2)
    @test polyarea(pc) > 0
    @test !isnothing(pc)

    pgon1 = ngon(O, 50, 5, vertices = true)
    pgon2 = ngon(O + (0, 100), 50, 7, vertices = true)
    pc = polyclip(pgon1, pgon2)
    @test isnothing(pc)

    boxleft = box(O, 50, 50, vertices = true)
    boxright = box(O + (50, 0), 50, 50, vertices = true)

    # boxes share edge
    setline(2)
    @test boxleft[3].x == boxright[1].x
    @test boxleft[4].x == boxright[2].x
    
    sethue("red")
    poly(boxleft, :stroke, close=true)
    poly(boxright, :stroke, close=true)
    
    # no clipping!
    pc = polyclip(boxleft, boxright)
    @test isnothing(pc)
    
    # but shift right poly left so it slightly overlaps
    polymove!(boxright, O, Point(-0.001, 0))
    poly(boxleft, :stroke, close=true)
    poly(boxright, :stroke, close=true)
    pc = polyclip(boxleft, boxright)

    # clipping
    @test !isnothing(pc)
    @layer begin
        sethue("gold")
        poly(pc, :stroke, close=true)    
    end

    sethue("magenta")
    dough  = hypotrochoid(320, 230, 220, vertices=true)
    cutter = ngon(O, 250, 6, vertices=true)
    poly(dough, :stroke, close=true)
    poly(cutter, :stroke, close=true)
    sethue("cyan")
    poly(polyclip(dough, cutter), :stroke, close=true)

    @test finish() == true
end

polycliptest("polycliptest.png")
println("...finished polyclip test")

using Luxor, Test

function crescent_tests(fname)
    Drawing(800, 800, fname)
    origin()
    background("midnightblue")

    tiles = Tiler(800, 800, 6, 6)
    for (pos, n) in tiles
        pts = crescent(pos, rescale(n, 36, 1, -tiles.tilewidth/2, tiles.tilewidth/2), tiles.tilewidth/2, vertices=true)
        sethue("antiquewhite")
        poly(pts, :fill)
        sethue("purple")
        crescent(pos, 15 , pos + (20, 0), 20, :stroke)
    end

    # test for null crescent, no intersections
    pts = crescent(O, 10, O, 10, vertices=true)
    @test pts == nothing
    @test finish() == true
    println("...finished test: output in $(fname)")
end

crescent_tests("crescent-tests.svg")

#!/usr/bin/env julia

using Luxor, Colors, Test, Random

Random.seed!(42)

function spirals()
    gsave()
    scale(0.3)
    r = 200
    setcolor("gray")
    for i = 0:pi/8:2pi
        gsave()
        translate(r * cos(i), r * sin(i))
        rotate(i)
        julialogo()
        grestore()
    end
    grestore()
    juliacircles(20)
end

function expandingspirals()
    gsave()
    scale(0.3)
    r = 200
    for i = pi:pi/12:6pi
        gsave()
        translate(i / 3 * r * cos(i), i / 3 * r * sin(i))
        scale(0.8)
        rotate(i)
        julialogo()
        grestore()
    end
    grestore()
end

function dropshadow()
    steps = 20
    # white-gray ramp
    gramp = range(
        colorant"white",
        stop = colorant"gray60",
        length = steps,
    )
    gsave()
    r = 200
    sethue("purple")
    rect(O, 5, 10, :stroke)
    setopacity(0.1)
    for i = 1:steps
        translate(-0.6, -0.5)
        julialogo(bodycolor = gramp[i], color = false)
    end
    julialogo()
    grestore()
end

function colorgrid()
    #cols = colormap("RdBu", 5; mid=0.5, logscale=false)
    #cols = sequential_palette(rand(10:360), 5, b=0.1)
    cols = distinguishable_colors(25)
    gsave()

    pagetiles = Tiler(500, 400, 5, 5)
    for (pos, n) in pagetiles
        gsave()
        setcolor(color(cols[n]))
        translate(pos)
        scale(0.3)
        julialogo(color = false)
        grestore()
    end
    grestore()
end

function boxes_and_rectangles(pt::Point)
    for i = 1:20
        randomhue()
        poly(
            box(pt + Point(i,i), 10i, 10i, vertices = true),
            :stroke,
            close = true,
        )
    end
    for i = 40:10:150
        randomhue()
        translate(i, 0)
        poly(squircle(O, 30, 30, vertices = true), :stroke)
    end
end

function draw_julia_logos_1(fname)
    Drawing(1600, 1600, fname)
    origin()
    background("white")

    translate(-500, -200)
    spirals()

    translate(750, 0)
    expandingspirals()

    translate(-1000, 500)
    dropshadow()

    translate(800, 50)
    colorgrid()

    translate(-700, 300)
    boxes_and_rectangles(O)

    @test finish() == true
    println("...finished test: output in $(fname)")
end


# requires Luxor >= 2.0
function julialogodims(fname)
    Drawing(1600, 1600, fname)
    origin()
    background("white")
    sethue("black")
    julialogo(action = :path, centered = true)
    p = pathtopoly()
    lox, hix =
        extrema(first.(collect(Iterators.flatten(p))))
    loy, hiy = extrema(getfield.(
        collect(Iterators.flatten(p)),
        :y,
    ))
    bbx = BoundingBox(Point(lox, loy), Point(hix, hiy))
    sethue("grey58")
    box(bbx, :stroke)
    rule(boxmiddlecenter(bbx), boundingbox = bbx)
    rule(boxmiddlecenter(bbx), π / 2, boundingbox = bbx)
    dimension(
        boxtopleft(bbx),
        format = (d) -> string(round(d)),
        boxtopright(bbx),
        offset = -50,
        textgap = 0,
        textrotation = -π / 2,
        texthorizontaloffset = 20,
    )
    dimension(
        boxtopleft(bbx),
        format = (d) -> string(round(d)),
        boxbottomleft(bbx),
        textrotation = π,
        offset = 30,
        texthorizontaloffset = 20,
    )
    julialogo(centered = true)
    @test finish() == true
    println("...finished test: output in $(fname)")
end


function test1()
    randomhue()
    @layer begin
        translate(-100, 0)
        scale(0.5)
        julialogo(action = :path, centered = true)
        strokepath()
    end

    @layer begin
        translate(100, 0)
        scale(0.5)
        julialogo(action = :path, centered = true)
        strokepath()
    end
    text(
        "action=:path, centered=true)",
        halign = :center,
        Point(0, 100),
    )
end

function test2()
    randomhue()
    @layer begin
        translate(-100, 0)
        scale(0.5)
        julialogo(action = :clip, centered = true)
        paint()
        clipreset()
    end

    @layer begin
        translate(100, 0)
        scale(0.5)
        julialogo(action = :clip, centered = true)
        paint()
        clipreset()
    end

    text(
        "action=:clip, centered=true",
        halign = :center,
        Point(0, 100),
    )
end

function test3()
    sethue("blue")
    @layer begin
        translate(-100, 0)
        scale(0.5)
        julialogo(action = :stroke, centered = true)
    end
    @layer begin
        translate(100, 0)
        scale(0.5)
        julialogo(action = :stroke, centered = true)
    end
    text(
        "OG> action=:stroke, centered=true <NEW",
        halign = :center,
        Point(0, 100),
    )
end

function test4()
    randomhue()
    @layer begin
        translate(-100, 0)
        scale(0.5)
        julialogo(
            centered = true,
            color = true,
            bodycolor = "purple",
        )
    end

    @layer begin
        translate(100, 0)
        scale(0.5)
        julialogo(
            centered = true,
            color = true,
            bodycolor = "purple",
        )
    end

    text(
        "OG> centered=true, bodycolor=\"purple\" <NEW",
        halign = :center,
        Point(0, 100),
    )
end

function test5()
    randomhue()
    @layer begin
        translate(-100, 0)
        scale(0.5)
        julialogo(
            centered = true,
            color = true,
            bodycolor = "purple",
        )
    end

    @layer begin
        translate(100, 0)
        scale(0.5)
        julialogo(
            centered = true,
            color = true,
            bodycolor = "purple",
        )
    end

    text(
        "centered=true, color=true, bodycolor=\"purple\"",
        halign = :center,
        Point(0, 100),
    )
end

function test6()
    randomhue()
    @layer begin
        translate(-100, 0)
        scale(0.5)
        julialogo(
            centered = true,
            action = :path,
            color = true,
        )
    end
    fillpath()
    @layer begin
        translate(100, 0)
        scale(0.5)
        julialogo(
            centered = true,
            action = :path,
            color = true,
        )
    end
    fillpath()

    text(
        "centered=true, color=true, bodycolor=\"purple\"",
        halign = :center,
        Point(0, 100),
    )
end

function draw_julia_logos_2(fname)
    Drawing(1600, 1600, fname)
    origin()
    background("white")
    fontsize(12)
    tiles = Tiler(1200, 1200, 3, 2)
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            n == 1 && test1()
            n == 2 && test2()
            n == 3 && test3()
            n == 4 && test4()
            n == 5 && test5()
            n == 6 && test6()
        end
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
    finish()
end

draw_julia_logos_1("julia-logo-draw.png")
julialogodims("julia-logo-dims.png")
draw_julia_logos_2("julia-logo-draw-table.png")

# using algorithms from PolygonAlgorithms.jl
# updated at version 0.4

@inline _point_to_tuple(pt::Point) = (pt.x, pt.y)
@inline _points_to_tuples(pts::Vector{Point}) = _point_to_tuple.(pts)
@inline _tuples_to_points(t::Vector{Tuple{Float64,Float64}}) = [Point(t[1], t[2]) for t in t]

"""
    polyarea(plist::Vector{Point}))

Find the area of a simple polygon. It works only for polygons that don't
self-intersect. See also `polyorientation()`.
"""
polyarea(p::Vector{Point}) = PA.area_polygon(_points_to_tuples(p))

"""
    isinside(p::Point, pointlist::Vector{Point}
        allowonedge = false)

Is a point `p` inside a polygon `pointlist`?

If `allowonedge` is false, a point lying on the polygon is not inside.

Returns true if it does, or false.
"""
isinside(pt::Point, pgon::Vector{Point}; allowonedge = false, rtol=AbstractFloat=1e-10) =
    PA.contains(_points_to_tuples(pgon), _point_to_tuple(pt),
         on_border_is_inside = allowonedge, rtol=rtol)

"""
    polyhull(ptspgon::Vector{Point})

Find all points in `pts` that form a convex hull around the
points in `pts`, and return them.

This uses the Graham Scan algorithm.
"""
function polyhull(pgon::Vector{Point};
    algorithm=PA.GrahamScanAlg())
    # in PA algorithm can either be GiftWrappingAlg() or GrahamScanAlg().
    return pgon[PA.convex_hull(algorithm, _points_to_tuples(pgon))]
end

"""
    polycentroid(pts::Vector{Point}))

Find the centroid of a simple polygon.

Returns a point. This only works for simple (non-intersecting) polygons.

You could test the point using `isinside()`.
"""
function polycentroid(pts::Vector{Point})
    return Point(PA.centroid_polygon(_points_to_tuples(pts)))
end

# the PA version gives the opposite value... :) 
# ispolyclockwise(pts::Vector{Point}) = PA.is_clockwise(_points_to_tuples(pts))

"""
    polyintersectconvex(p1::AbstractVector{Point}, p2::AbstractVector{Point})

Use `polyintersect()`.
"""
function polyintersectconvex(p1::AbstractVector{Point}, p2::AbstractVector{Point})
    # alg can either be ChasingEdgesAlg(), MartinezRuedaAlg(), PointSearchAlg() or WeilerAthertonAlg(). 
    # The two general algorithms MartinezRuedaAlg and WeilerAthertonAlg will throw an error if more than one area of intersection is found.
    return _tuples_to_points(
        PA.intersect_convex(PA.WeilerAthertonAlg(), _points_to_tuples(p1), _points_to_tuples(p2)))
end

"""
    polyintersect(pgon1::AbstractVector{Point}, pgon2::AbstractVector{Point})

Return an array (possibly empty) containing the polygon(s) that define
the intersection between the two polygons, `pgon1` and `pgon2`.

The `pgon1` and `pgon2` polygons must not have holes, and cannot be
self-intersecting.
"""
function polyintersect(pgon1::AbstractVector{Point}, pgon2::AbstractVector{Point})
    return _tuples_to_points.(
        PA.intersect_geometry(PA.MartinezRuedaAlg(), _points_to_tuples(pgon1), _points_to_tuples(pgon2))
    )
end

polyintersections(S::Vector{Point}, C::Vector{Point}) = polyintersect(S, C)

"""
    polydifference(pgon1::AbstractVector{Point}, pgon2::AbstractVector{Point})

Find polygonal areas that are inside `pg1` but not in `pg2`.
"""
function polydifference(pg1::AbstractVector{Point}, pg2::AbstractVector{Point})
    return Luxor._tuples_to_points.(PA.difference_geometry(PA.MartinezRuedaAlg(), Luxor._points_to_tuples(pg1),
        Luxor._points_to_tuples(pg2)))
end

"""
    polyunion(pgon1::AbstractVector{Point}, pgon2::AbstractVector{Point})

Find polygonal areas that are inside `pg1` or in `pg2`.

Return an array of polygons.

Boolean Union.
"""
function polyunion(pg1::AbstractVector{Point}, pg2::AbstractVector{Point})
    return Luxor._tuples_to_points.(PA.union_geometry(PA.MartinezRuedaAlg(), Luxor._points_to_tuples(pg1),
        Luxor._points_to_tuples(pg2)))
end

"""
    polyxor(pgon1::AbstractVector{Point}, pgon2::AbstractVector{Point})

Find polygon areas that are inside either `pg1` or `pg2`, but not both.

Return an array of polygons.

Boolean XOR.

Possibly returns holes but does not classify them as holes.
"""
function polyxor(pg1, pg2)
    return Luxor._tuples_to_points.(PA.xor_geometry(PA.MartinezRuedaAlg(), Luxor._points_to_tuples(pg1),
        Luxor._points_to_tuples(pg2)))
end

using Luxor
using Colors
using Test

function getcelltest(fname)
    Drawing(1200, 1200, fname)
    origin()
    a = [1, 2, 4]
    b = 2:3
    R = 6
    k = 7
    fontsize(30)
    panes = Tiler(1200, 1200, 3, 3)
    @layer begin
        translate(first(panes[1]))
        t = Tiler(260, 260, R, 4)
        for (pos, n) in t
            sethue(HSB(36n, 0.7, 0.8))
            box(t, n, :fill)
            sethue("purple")
            box(t, n, :stroke)
        end
        s = getcells(t, a, b)
        for is in s
            pt, n = is
            sethue("white")
            circle(pt, 20, :fill)
        end
    end
    @layer begin
        translate(first(panes[2]))
        t = Table(R, 4, 40, 40)
        for (pos, n) in t
            sethue(HSB(36n, 0.7, 0.8))
            box(t, n, :fill)
            sethue("purple")
            box(t, n, :stroke)
        end
        s = getcells(t, a, b)
        for is in s
            pt, n = is
            sethue("white")
            circle(pt, 20, :fill)
        end
    end

    @layer begin
        translate(first(panes[3]))
        t = Tiler(260, 260, R, 4)
        for (pos, n) in t
            sethue(HSB(36n, 0.7, 0.8))
            box(t, n, :fill)
            sethue("purple")
            box(t, n, :stroke)
        end
        s = getcells(t, k)
        for is in s
            pt, n = is
            sethue("white")
            circle(pt, 20, :fill)
            sethue("black")
            text(string(k), pt, halign=:center, valign=:middle)
        end
    end

    @layer begin
        translate(first(panes[4]))
        t = Tiler(250, 250, R, 4)
        t = Table(R, 4, 40, 40)
        for (pos, n) in t
            sethue(HSB(36n, 0.7, 0.8))
            box(t, n, :fill)
            sethue("purple")
            box(t, n, :stroke)
        end
        s = getcells(t, 22:-3:7)
        markcells(t, s,
            action=:fill,
            func=(pos, w, h, n) -> begin
                sethue("white")
                circle(pos, h / 2, :fill)
                sethue("black")
                text(string(n), pos, halign=:center, valign=:middle)
            end
        )
    end

    @layer begin
        translate(first(panes[5]))
        t = Tiler(400, 400, 5, 6)
        markcells(t, getcells(t, 1:30),
            func=(pos, w, h, n) -> begin
                sethue(["red", "green", "blue", "purple"][mod1(n, end)])
                circle(pos, w / 2, :fill)
                sethue("white")
                text(string(n), pos, halign=:center, valign=:middle)
            end)
    end

    @layer begin
        translate(first(panes[6]))
        t = Tiler(300, 300, 4, 5)
        t = Table(4, 5, 50, 60)
        for (pos, n) in t
            sethue(HSB(36n, 0.7, 0.8))
            box(t, n, :fill)
            sethue("purple")
            box(t, n, :stroke)
            text(string(n), pos, halign=:center, valign=:middle)
        end
        markcells(t, getcells(t, 1:2:10),
            func=(pos, w, h, n) -> begin
                isodd(n) ? sethue("red") : sethue("green")
                circle(pos, w / 2, :fill)
                sethue("white")
                text(string(n), pos, halign=:center, valign=:middle)
            end)

    end
    @test finish() == true
end

fname = "getcell.png"
getcelltest(fname)
println("getcell test: output in $(fname)")
println("...finished getcell tests: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random

Random.seed!(42)

function test_bboxes_2(fname)
    pagewidth, pageheight = 800, 800
    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("rebeccapurple")
    for i in 30:-0.5:2
        rotate(pi/12i^1.2)
        sethue(rescale(i, 30, 2, 0, 1), rand(), .7)
        bb = BoundingBox() * 0.7  - 5i
        circle.([
            boxtopleft(bb),
            boxtopcenter(bb),
            boxtopright(bb),
            boxmiddleleft(bb),
            boxmiddlecenter(bb),
            boxmiddleright(bb),
            boxbottomleft(bb),
            boxbottomcenter(bb),
            boxbottomright(bb)
        ], i^1.25, :fill)
    end
    @test finish() == true
    println("...finished bounding box point test, saved in $(fname)")
end

fname = "bounding-box-point-test.png"

test_bboxes_2(fname)

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function cropmarkstest(fname)
    Drawing(1300, 1300, fname)
    origin()
    background("ivory")
    sethue("grey80")
    box(O, 1200, 1200, :fill)
    tiles = Tiler(600, 600, 3, 3, margin=30)
    for (pos, n) in tiles
        gsave()
        translate(pos)
        randomhue()
        setopacity(rand())
        box(O, tiles.tilewidth - 25, tiles.tileheight - 25, :fill)
        cropmarks(O, tiles.tilewidth - 25, tiles.tileheight - 25)
        clipreset()
        grestore()
    end
    cropmarks(O, 1200, 1200)
    @test finish() == true
end

fname = "cropmarkstest.pdf"
cropmarkstest(fname)
println("...finished test: output in $(fname)")

function randomordinate(low, high)
    if low > high
      low, high = high, low
    end
    return low + rand() * abs(high - low)
end

"""
    randompoint(lowpt, highpt)

Return a random point somewhere inside the rectangle defined by the two points.
"""
function randompoint(lowpt::Point, highpt::Point)
  Point(randomordinate(lowpt.x, highpt.x), randomordinate(lowpt.y, highpt.y))
end

"""
    randompoint(lowx, lowy, highx, highy)

Return a random point somewhere inside a rectangle defined by the four values.
"""
function randompoint(lowx, lowy, highx, highy)
    Point(randomordinate(lowx, highx), randomordinate(lowy, highy))
end

"""
    randompointarray(lowpt, highpt, n)

Return an array of `n` random points somewhere inside the rectangle defined by two points.
"""
function randompointarray(lowpt::Point, highpt::Point, n)
    array = Point[]
    for i in 1:n
        push!(array, randompoint(lowpt, highpt))
    end
    array
end

"""
    randompointarray(lowx, lowy, highx, highy, n)

Return an array of `n` random points somewhere inside the rectangle defined by the four
coordinates.
"""
function randompointarray(lowx, lowy, highx, highy, n)
    array = Point[]
    for i in 1:n
        push!(array, randompoint(lowx, lowy, highx, highy))
    end
    array
end

# internal function used by Poisson disk sampling below
"""
    _empty_neighbourhood(sample, w, h, cellsize, d, points, grid)

Uses entries in `grid` to check whether the `sample`
point is more than `d` units away from any other point
in `points`.

The region we're analyzing lies between the origin and
`Point(w, h)``.
"""
function _empty_neighbourhood(sample::Point, w, h, cellsize, d, points::Vector{Point}, grid)
    if sample.x >= 0 &&
            sample.x < w &&
            sample.y >= 0 &&
            sample.y < h
        cellx    = 1 + convert(Int, ceil(sample.x/cellsize))
        celly    = 1 + convert(Int, ceil(sample.y/cellsize))
        _w, _h   = size(grid)
        sstartx  = max(1, cellx - 2)
        sfinishx = min(cellx + 2, _w)
        sstarty  = max(1, celly - 2)
        sfinishy = min(celly + 2, _h)
        for x in sstartx:sfinishx
            for y = sstarty:sfinishy
                ptindex = grid[x, y]
                if ptindex > 0
                    dist = distance(sample, points[ptindex])
                    if dist < d
                        return false
                    end
                end
            end
        end
        return true
    end
    return false
end

"""
    randompointarray(w, h, d; attempts=20)

Return an array of randomly positioned points inside the
rectangle defined by the current origin (0/0) and the
`width` and `height`. `d` determines the minimum
distance between each point. Increase `attempts` if you want
the function to try harder to fill empty spaces; decrease it
if it's taking too long to look for samples that work.

This uses Bridson's Poisson Disk Sampling algorithm:
https://www.cs.ubc.ca/~rbridson/docs/bridson-siggraph07-poissondisk.pdf

## Example

```julia
for pt in randompointarray(BoundingBox(), 20)
    randomhue()
    circle(pt, 10, :fill)
end
```
"""
function randompointarray(w, h, d;
        attempts=20)
    cellsize = d/sqrt(2)
    grid = zeros(Int,
        convert(Int, ceil(w/cellsize)),
        convert(Int, ceil(h/cellsize)))
    points = Point[]
    activepoints = Point[]
    # start with point in middle
    push!(activepoints, Point(w/2, h/2))
    while !isempty(activepoints)
        random_index = rand(1:length(activepoints))
        sample_center = activepoints[random_index]
        sample_added = false
        for i in 1:attempts
            angle = rand() * 2π
            dir = (sin(angle), cos(angle))
            sample = sample_center + dir .* (d + rand() * d)
            if _empty_neighbourhood(sample, w, h, cellsize, d, points, grid)
                push!(points, sample)
                push!(activepoints, sample)
                grid[convert(Int, ceil(sample.x/cellsize)), convert(Int, ceil(sample.y/cellsize))] = length(points)
                sample_added = true
                break
            end
        end
        if !sample_added
            deleteat!(activepoints, random_index)
        end
    end
    return points
end

"""
    randompointarray(bbox::BoundingBox, d; attempts=20)

Return an array of randomly positioned points inside the
bounding box `d` units apart.
"""
function randompointarray(bbox::BoundingBox, d; kwargs...)
    bw = boxwidth(bbox)
    bh = boxheight(bbox)
    return randompointarray(bw, bh, d; kwargs...) .- Point(bw/2, bh/2)
end

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_rulers(x, y, rot, w)
    gsave()
    translate(x, y)
    rotate(rot)
    box(0, 0, w, w, :clip)
    rulers()
    clipreset()
    grestore()
end

function drawing_png_buffer()
    width, height = 2000, 2000
    Drawing(width, height, :png)
    origin(1200, 1200)
    background("ivory")
    pagetiles = Tiler(width, height, 5, 5, margin=10)
    for (pos, n) in pagetiles
      test_rulers(pos.x, pos.y, rand() * 2pi, pagetiles.tilewidth)
    end

    println("...finished rulers in png buffer test")
    @test finish() == true
end

function drawing_svg_buffer()
    width, height = 2000, 2000
    Drawing(width, height, :svg)
    origin(1200, 1200)
    background("ivory")
    pagetiles = Tiler(width, height, 5, 5, margin=10)
    for (pos, n) in pagetiles
      test_rulers(pos.x, pos.y, rand() * 2pi, pagetiles.tilewidth)
    end

    println("...finished rulers in svg buffer test")
    @test finish() == true
end

function drawing(fname)
    width, height = 2000, 2000
    Drawing(width, height, fname)
    origin(1200, 1200)
    background("ivory")
    pagetiles = Tiler(width, height, 5, 5, margin=10)
    for (pos, n) in pagetiles
      test_rulers(pos.x, pos.y, rand() * 2pi, pagetiles.tilewidth)
    end

    @test finish() == true
    println("...finished rulers test: output in $(fname)")
end

drawing_png_buffer()
drawing_svg_buffer()
drawing("rulers-test.pdf")

#!/usr/bin/env julia

using Luxor, Test, Random
Random.seed!(42)

function testcircleintersections(fname)
    # completely overlapping circles
    c1 = (O, 100)
    c2 = (O, 100)
    cia = intersection2circles(c1..., c2...)
    @test isapprox(cia, 10000π, atol=0.1)

    # nonoverlapping circles
    c1 = (O, 100)
    c2 = (O + (200, 200), 100)
    cia = intersection2circles(c1..., c2...)
    @test isapprox(cia, 0.0, atol=0.1)

    # test for transition between inside and outside
    c1 = (O, 100)
    for v in -200:200
        c2 = (O + (100 * sqrt(2), 100 * sqrt(2)), 100 + (v * eps(Float64)))
        cia = intersection2circles(c1..., c2...)
    end
    @test 0.0 < cia < 0.000000001

    pagewidth, pageheight = 1200, 1400
    Drawing(pagewidth, pageheight, fname)
    background("grey30")
    origin() # move 0/0 to center

    @layer  begin
        scale(2)
        setopacity(0.3)
        sethue("cyan")
        circle(c1..., :fill)
        circle(c2..., :fill)
        sethue("red")
        circle(c1..., :clip)
        circle(c2..., :fill)
        clipreset()
    end

    occultations  = []
    for (pt, n) in Table(10, 10, 120, 120)
        c1 = (O, rand(5:40))
        c2 = (O + tuple(rand(-20:20, 2)...), rand(10:50))
        cia = intersection2circles(c1..., c2...)
        push!(occultations, (c1, c2, cia))
    end

    sort!(occultations, by = (x) -> last(x))

    for (pt, n) in Table(10, 10, 120, 120)
        c1, c2, cia = occultations[n]
        @layer begin
            translate(pt)
            randomhue()
            circle(c1..., :fill)
            circle(c2..., :fill)
            sethue("white")
            circle(c1..., :clip)
            circle(c2..., :fill)
            clipreset()
            text(string(round(cia)), O + (0, 50), halign=:center)
        end
    end
    fontsize(30)
    sethue("white")
    text("assorted occultations sorted by area", boxtopcenter(BoundingBox() * 0.9), halign=:center)
    @test finish() == true
    println("...finished circletest, saved in $(fname)")
end

fname = "circle-intersection-test.png"

testcircleintersections(fname)

using Luxor, Test

function test_polytriangulate(fname)
    width, height = 800, 800
    Drawing(width, height, fname)
    origin()
    background("white")

    rawpts = ngon(O, 300, 8, vertices = true)

    push!(rawpts, midpoint(rawpts[1], rawpts[4]))
    push!(rawpts, midpoint(rawpts[2], rawpts[5]))
    push!(rawpts, midpoint(rawpts[3], rawpts[6]))

    ptriangles = polytriangulate(rawpts)

    @test length(ptriangles) == 12

    fontsize(16)
    # visual inspection... :(
    setline(3)
    for (n, p) in enumerate(ptriangles)
        sethue([Luxor.julia_purple, Luxor.julia_blue,  Luxor.julia_red,  Luxor.julia_green][mod1(n, end)])
        pgon = Point[p[1], p[2], p[3]]
        poly(pgon,  :fillpreserve, close = true)
        sethue("white")
        strokepath()
        text(string(n), polycentroid(pgon), halign=:middle)
    end
    sethue("white")
    circle.(rawpts, 5, :fill)
    @test finish() == true
end

fname = "polytriangulate.png"
test_polytriangulate(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Test

function drawcircles(Δα)
    @layer begin
        setline(8)
        for r = 0:20:1500
            α = r / 100  + Δα
            circle(O + sqrt(r ) .* (cos(α), sin(α)), r, :stroke)
            settext("<span font = '16' foreground = 'darkblue' > $(string(r)) </span>",
                 O + (0, 8 - r ); markup = true)
        end
    end
end

fna(i, suf) = "test_snap_$i.$suf"

function testsnapshot(fname; cb = missing, scalefactor = missing, kwargs...)
    if ismissing(cb)
        sn = if ismissing(scalefactor)
            snapshot(;fname = fname, kwargs...)
        else
            snapshot(;fname = fname, scalefactor = scalefactor, kwargs...)
        end
        @test typeof(sn) == Drawing
    else
        if ismissing(scalefactor)
            sn = snapshot(;fname = fname, cb = cb, kwargs...)
            @test sn.width == boxwidth(cb) && sn.height == boxheight(cb)
        else
            sn = snapshot(;fname = fname, cb = cb, scalefactor = scalefactor, kwargs...)
            @test sn.width == round(boxwidth(cb) * scalefactor)
            @test sn.height == round(boxheight(cb) * scalefactor)
        end
    end
    println("...finished test: output in $fname")
    sn
end
function circles_then_snapshot(fno, suf; kwargs...)
    drawcircles(0.5 * fno)
    testsnapshot(fna(fno, suf); kwargs...)
end



function frame_then_snapshot(fno, suf, cb; kwargs...)
    @layer begin
        setline(2)
        sethue("red")
        box(cb, :stroke)
    end
    testsnapshot(fna(fno, suf); cb = cb, kwargs...)
end

function ripples_then_snapshot(fno, suf; kwargs...)
    ctm = cairotojuliamatrix(getmatrix())
    # User space coordinates for device top
    midtopx, midtopy, _ = ctm^-1 * [-ctm[1, 3] + currentdrawing().width / 2, -ctm[2, 3], 0.0]
    colos = Luxor.Colors.colormap("blues")
    for ulr in range(0, 1, length = 3 * 577)
        r = 2 * 577 * ulr^1.5
        # phase
        ϕ = 20 * sin(40ulr)
        sethue(colos[80 + Int(round(ϕ))])
        p = Point(midtopx, midtopy + 2ϕ)
        circle(p, r, :stroke)
        # Add some rays for showing shear transformation
        sethue("yellow")
        [circle(p + (r * cos(α), -r * sin(α)), 2, :stroke) for α in [0.25, 0.75, 1.25, 1.75]π]
    end
    testsnapshot(fna(fno, suf); kwargs...)
end

# 1-4: Full drawing snapshot from bounded recording surface
Drawing(640, 480, :rec)
origin(400, 280)
sethue("gold4")
circles_then_snapshot(1, "png")
sethue("gold3")
circles_then_snapshot(2, "pdf")
sethue("gold2")
circles_then_snapshot(3, "svg")
sethue("gold1")
circles_then_snapshot(4, "png", scalefactor = 0.5)

# 5-6: Crop snapshots from bounded recording surface
ptul = -Point(getmatrix()[5:6]...) # origin is not at center
ptbr = ptul + (currentdrawing().width, currentdrawing().height)
cb = BoundingBox(ptul, ptbr) - 50
frame_then_snapshot(5, "png", cb)

cb = BoundingBox(box(Point(10, -115), Point(42, -91), :stroke))
frame_then_snapshot(6, "png", cb)

# 7: Crop and scale up
frame_then_snapshot(7, "png", cb, scalefactor = 20)

# 8: Shrink full image
origin()
cb = BoundingBox()
frame_then_snapshot(8, "png", cb, scalefactor = 0.5)


# 9-10: Crop snapshot from free extents recording surface

# It seems that the svg device called by Cairo fails to find
# a size reference from unbounded recording surfaces. Botched up svgs
# include "-1.#QNAN", or very long strings. This occurs with and
# without 'Pro api' text on the drawing.
# However, it seems that if an svg has previously been rendered from a surface
# with bounds, the svg renderer works normally with unbounded surfaces.

Drawing(NaN, NaN, :rec)
@test snapshot() == false
origin(400, 280)
sethue("gold4")
cb = BoundingBox(Point(-128, -96), Point(128, 96))
circles_then_snapshot(9, :png; cb = cb)

# Large image, more effective storage as vector type svg
cb = BoundingBox(Point(-1280, -960), Point(1280, 960))
circles_then_snapshot(10, "svg"; cb = cb)

# 11-13: Full drawing snapshot from transformed recording surface
Drawing(640, 480, :rec)
origin()
scale(0.5)
ripples_then_snapshot(11, "png")
scale(2)
ripples_then_snapshot(12, "png")
origin()
scale(1, 0.5)
ctm = getmatrix()
ctm[3] = 0.1     # shear y
setmatrix(ctm)
rotate(π / 15)
ripples_then_snapshot(13, "png")

# 14-16: Crop and scale snapshot from transformed recording surface
pul = Point(-240, -380)
fontsize(36)
text("ul", pul, valign = :top)
pur = Point(80, -380)
text("ur", pur, valign = :top)
pbr = Point(80, -140)
text("br", pbr, valign = :top)
pbl = Point(-240, -140)
text("Bottom left", pbl, valign = :bottom)
cb = BoundingBox(pul, pbr)
frame_then_snapshot(14, "png", cb)
frame_then_snapshot(15, "png", cb, scalefactor = 2)
testsnapshot(fna(16, "png"))
finish()

# polygons, part of Luxor

"""
    poly(pointlist::Vector{Point}, action = :none;
        close=false,
        reversepath=false)

Draw a polygon. Create a path with the points in `pointlist` and apply `action`.
By default `poly()` doesn't close or fill the polygon.
"""
function poly(pointlist::Vector{Point};
    action = :none,
    close = false,
    reversepath = false)
    if action != :path
        newpath()
    end
    if reversepath == true
        reverse!(pointlist)
    end
    move(pointlist[1].x, pointlist[1].y)
    @inbounds for p in pointlist[2:end]
        line(p.x, p.y)
    end
    if close == true
        closepath()
    end
    do_action(action)
    return pointlist
end

poly(pts::NTuple{N,Point} where {N}; kwargs...) = poly(collect(pts); kwargs...)

poly(pointlist::Vector{Point}, a::Symbol;
    action = a,
    close = false,
    reversepath = false) = poly(pointlist, action = action, close = close, reversepath = reversepath)

"""
    polysortbyangle(pointlist::Vector{Point}, refpoint=minimum(pointlist))

Sort the points of a polygon into order. Points are sorted according to the angle they make
with a specified point.

The `refpoint` can be chosen, but the default minimum point is usually OK too:

    polysortbyangle(parray, polycentroid(parray))
"""
function polysortbyangle(pointlist::Vector{Point}, refpoint = minimum(pointlist))
    angles = Float64[]
    sizehint!(angles, length(pointlist))
    @inbounds for pt in pointlist
        push!(angles, slope(pt, refpoint))
    end
    return pointlist[sortperm(angles)]
end

"""
    polysortbydistance(p, starting::Point)

Sort a polygon by finding the nearest point to the starting point, then
the nearest point to that, and so on.

You can end up with convex (self-intersecting) polygons, unfortunately.
"""
function polysortbydistance(pointlist::Vector{Point}, starting::Point)
    route = [starting]
    sizehint!(route, length(pointlist))
    # start with the first point in pointlist
    remaining = setdiff(pointlist, route)
    while length(remaining) > 0
        # find the nearest point to the current position on the route
        nearest = first(sort!(remaining, lt = (x, y) -> distance(route[end], x) < distance(route[end], y)))
        # add this to the route and remove from remaining points
        push!(route, nearest)
        popfirst!(remaining)
    end
    return route
end

"""
     douglas_peucker(pointlist::Vector{Point}, start_index, last_index, epsilon)

Use a non-recursive Douglas-Peucker algorithm to simplify a polygon. Used by `simplify()`.
"""
function douglas_peucker(pointlist::Vector{Point}, start_index, last_index, epsilon)
    temp_stack = Tuple{Int,Int}[]
    push!(temp_stack, (start_index, last_index))
    global_start_index = start_index
    keep_list = trues(length(pointlist))
    while length(temp_stack) > 0
        start_index = first(temp_stack[end])
        last_index = last(temp_stack[end])
        pop!(temp_stack)
        dmax = 0.0
        index = start_index
        for i in (index + 1):(last_index - 1)
            if (keep_list[i - global_start_index])
                d = pointlinedistance(pointlist[i], pointlist[start_index], pointlist[last_index])
                if d > dmax
                    index = i
                    dmax = d
                end
            end
        end
        if dmax > epsilon
            push!(temp_stack, (start_index, index))
            push!(temp_stack, (index, last_index))
        else
            keep_list[(global_start_index + start_index):(global_start_index + last_index - 2)] .= false
        end
    end
    return pointlist[keep_list]
end

"""
    simplify(pointlist::Vector{Point}, detail=0.1)

Simplify a polygon.

`detail` is the maximum approximation error of simplified polygon.
"""
function simplify(pointlist::Vector{Point}, detail = 0.1)
    douglas_peucker(pointlist, 1, length(pointlist), detail)
end

"""
    polysplit(p, p1, p2)

Split a polygon into two where it intersects with a line. It returns two
polygons:

```julia
(poly1, poly2)
```

This doesn't always work, of course. For example, a polygon the shape of the
letter "E" might end up being divided into more than two parts.
"""
function polysplit(pointlist::Vector{Point}, p1::Point, p2::Point)
    # the two-pass version
    # TODO should be one-pass
    newpointlist = Point[]
    sizehint!(newpointlist, length(pointlist))
    vertex1 = Point(0, 0)
    vertex2 = Point(0, 0)
    l = length(pointlist)
    @inbounds for i in 1:l
        vertex1 = pointlist[mod1(i, l)]
        vertex2 = pointlist[mod1(i + 1, l)]
        flag, intersectpoint = intersectionlines(vertex1, vertex2, p1, p2, crossingonly = true)
        push!(newpointlist, vertex1)
        if flag
            push!(newpointlist, intersectpoint)
        end
    end
    # close?
    # push!(newpointlist, vertex2)
    # now sort points
    poly1 = Point[]
    poly2 = Point[]
    l = length(newpointlist)
    @inbounds for i in 1:l
        vertex1 = newpointlist[mod1(i, l)]
        d = pointlinedistance(vertex1, p1, p2)
        centerpoint = (p2.x - p1.x) * (vertex1.y - p1.y) > (p2.y - p1.y) * (vertex1.x - p1.x)
        if centerpoint
            push!(poly1, vertex1)
            abs(d) < 0.1 && push!(poly2, vertex1)
        else
            push!(poly2, vertex1)
            abs(d) < 0.1 && push!(poly1, vertex1)
        end
    end
    return (poly1, poly2)
end

"""
    prettypoly(points::Vector{Point}, vertexfunction = () -> circle(O, 2, :stroke);
        action=:none,
        close=false,
        reversepath=false,
        vertexlabels = (n, l) -> ()
        )

Draw the polygon defined by `points`, possibly closing and reversing it, using the current
parameters, and then evaluate the `vertexfunction` function at every vertex of the polygon.

The default vertexfunction draws a 2 pt radius circle.

To mark each vertex of a polygon with a randomly colored filled circle:

```julia
p = star(O, 70, 7, 0.6, 0, vertices=true)
prettypoly(p, action=:fill, () ->
    begin
        randomhue()
        circle(O, 10, :fill)
    end,
    close=true)
```

The optional keyword argument `vertexlabels` lets you supply a function with
two arguments that can access the current vertex number and the total number of vertices
at each vertex. For example, you can label the vertices of a triangle "1 of 3", "2 of 3",
and "3 of 3" using:

```julia
prettypoly(triangle, action=:stroke,
    vertexlabels = (n, l) -> (text(string(n, " of ", l))))
```
"""
function prettypoly(pointlist::Vector{Point}, vertexfunction = () -> circle(O, 2, :stroke);
    action = :none,
    close = false,
    reversepath = false,
    vertexlabels = (n, l) -> ())
    if isempty(pointlist)
        return nothing
    end

    if action != :path
        newpath()
    end

    if reversepath
        reverse!(pointlist)
    end

    move(pointlist[1])
    @inbounds for p in pointlist[2:end]
        line(p)
    end

    if close
        closepath()
    end
    do_action(action)
    pointnumber = 1

    for p in pointlist
        gsave()
        translate(p.x, p.y)
        vertexfunction()
        vertexlabels(pointnumber, length(pointlist))
        grestore()
        pointnumber += 1
    end

    if action == :fillpreserve || action == :strokepreserve
        move(pointlist[1])
        @inbounds for p in pointlist[2:end]
            line(p)
        end
    end

    return pointlist
end

# method with action as argument
prettypoly(pointlist::Vector{Point}, action::Symbol, vertexfunction = () -> circle(O, 2, :stroke);
    close = false,
    reversepath = false,
    vertexlabels = (n, l) -> ()) = prettypoly(pointlist, vertexfunction,
    action = action,
    close = close,
    reversepath = reversepath,
    vertexlabels = vertexlabels)

# method with default
prettypoly(pointlist, action::Symbol) = prettypoly(pointlist, () -> circle(O, 2, :stroke);
    action = action,
    close = false,
    reversepath = false,
    vertexlabels = (n, l) -> ())

function getproportionpoint(point::Point, segment, length, dx, dy)
    if isapprox(segment, 0.0) || isapprox(length, 0.0)
        throw(error("getproportionpoint: impossible construction with segment $(segment) length $(length)"))
    end
    scalefactor = segment / length
    return Point((point.x - dx * scalefactor), (point.y - dy * scalefactor))
end

function drawroundedcorner(cornerpoint::Point, p1::Point, p2::Point, radius, path; debug = false)
    dx1 = cornerpoint.x - p1.x     # vector 1
    dy1 = cornerpoint.y - p1.y
    dx2 = cornerpoint.x - p2.x     # vector 2
    dy2 = cornerpoint.y - p2.y

    # Angle between vector 1 and vector 2 divided by 2
    angle2 = (atan(dy1, dx1) - atan(dy2, dx2)) / 2

    #  length of segment between corner point and the
    #  points of intersection with the circle of a given radius
    t = abs(tan(angle2))
    segment = radius / t

    # Check the segment
    length1 = hypot(dx1, dy1)
    length2 = hypot(dx2, dy2)
    seglength = min(length1, length2)
    if segment > seglength
        segment = seglength
        radius = seglength * t
    end

    #  points of intersection are calculated by the proportion between
    #  the coordinates of the vector, length of vector and the length of the segment.
    p1_cross = getproportionpoint(cornerpoint, segment, length1, dx1, dy1)
    p2_cross = getproportionpoint(cornerpoint, segment, length2, dx2, dy2)

    #  calculation of the coordinates of the circle's center by the addition of angular vectors
    dx = cornerpoint.x * 2 - p1_cross.x - p2_cross.x
    dy = cornerpoint.y * 2 - p1_cross.y - p2_cross.y
    L = hypot(dx, dy)
    d = hypot(segment, radius)

    # this prevents impossible constructions; Cairo will crash if L is 0
    if isapprox(L, 0.0)
        L = 0.01
    end

    circlepoint = getproportionpoint(cornerpoint, d, L, dx, dy)

    # if "debugging" or you just like the circles:
    debug && circle(circlepoint, radius, :stroke)

    # start angle and end engle of arc
    startangle = atan(p1_cross.y - circlepoint.y, p1_cross.x - circlepoint.x)
    endangle   = atan(p2_cross.y - circlepoint.y, p2_cross.x - circlepoint.x)

    # add first line segment, up to the start of the arc
    push!(path, (:line, p1_cross)) # draw line to arc start

    # adjust. Cairo also does this when you draw arc()s, btw
    if endangle < 0
        endangle = 2pi + endangle
    end
    if startangle < 0
        startangle = 2pi + startangle
    end
    sweepangle = endangle - startangle

    if abs(sweepangle) > pi
        if startangle < endangle
            push!(path, (:carc, [circlepoint, radius, startangle, endangle]))
        else
            push!(path, (:arc, [circlepoint, radius, startangle, endangle]))
        end
    else
        if startangle < endangle
            push!(path, (:arc, [circlepoint, radius, startangle, endangle]))
        else
            push!(path, (:carc, [circlepoint, radius, startangle, endangle]))
        end
    end
    # line from end of arc to start of next side
    push!(path, (:line, p2_cross))
end

"""
    polysmooth(points, radius, action=:action; debug=false, close=true)
    polysmooth(points, radius; action=:none, debug=false, close=true)

Make a closed path from the `points` and round the corners by making them arcs with the
given radius. Execute the action when finished.

The arcs are sometimes different sizes: if the given radius is bigger than the length of the
shortest side, the arc can't be drawn at its full radius and is therefore drawn as large as
possible (as large as the shortest side allows).

The `debug` option also draws the construction circles at each corner.

TODO Return something more useful than a Boolean.
"""
function polysmooth(points::Vector{Point}, radius, action::Symbol; debug = false, close = true)
    temppath = Tuple[]
    l = length(points)
    if l < 3
        # there are less than three points to smooth
        return nothing
    else
        @inbounds for i in 1:(close ? l : l - 2)
            p1 = points[mod1(i, l)]
            p2 = points[mod1(i + 1, l)]
            p3 = points[mod1(i + 2, l)]
            if isapprox(distance(p1, p2), 0.0) || isapprox(distance(p2, p3), 0.0)
                throw(error("polysmooth(): impossible to round the vertex at point #$(i + 1)"))
            end
            drawroundedcorner(p2, p1, p3, radius, temppath, debug = debug)
        end
    end
    # need to close by joining to first point
    if close
        push!(temppath, temppath[1])
        temppath[1] = (:move, temppath[1][2])
    else
        pushfirst!(temppath, (:move, points[1]))
        push!(temppath, (:line, points[end]))
    end
    # draw the path
    for (c, p) in temppath
        if c == :move
            move(p)
        elseif c == :line
            line(p)    # add line segment
        elseif c == :arc
            arc(p...)  # add clockwise arc segment
        elseif c == :carc
            carc(p...) # add counterclockwise arc segment
        end
    end
    do_action(action)
end

polysmooth(points::Vector{Point}, radius; action = :none, debug = false, close = true) =
    polysmooth(points, radius, action; debug = debug, close = close)

"""
    roundcorner(p1::Point, cornerpoint::Point, p2::Point, radius)

Given a corner `cornerpoint` defined by the three points `p1`, `cornerpoint`, and `p2`,
calculate the intersection points and centerpoint for a smooth rounded corner. 
    
Returns
    
    `p1_cross`, `circlepoint`, `p2_cross`, `clockwise`
    
The corner can be drawn as:

    p1 -> p1_cross -> arc2r(circlepoint, p1_cross, p2_cross) -> p2_cross -> p2

`clockwise` is true if the arc is to drawn clockwise.
"""
function roundcorner(p1::Point, cornerpoint::Point, p2::Point, radius)
    if isapprox(radius, 0.0)
		throw(error("roundcorner: impossibly small radius $radius"))
	end
    dx1 = cornerpoint.x - p1.x     # vector 1
    dy1 = cornerpoint.y - p1.y
    dx2 = cornerpoint.x - p2.x     # vector 2
    dy2 = cornerpoint.y - p2.y

    # Angle between vector 1 and vector 2 divided by 2
    angle2 = (atan(dy1, dx1) - atan(dy2, dx2)) / 2

    #  length of segment between corner point and the
    #  points of intersection with the circle of a given radius
    t = abs(tan(angle2))
    segment = radius / t

    # Check the segment
    length1 = hypot(dx1, dy1)
    length2 = hypot(dx2, dy2)
    seglength = min(length1, length2)
    if segment > seglength
        segment = seglength
        radius = seglength * t
    end

    #  points of intersection are calculated by the proportion between
    #  the coordinates of the vector, length of vector and the length of the segment.
    p1_cross = Luxor.getproportionpoint(cornerpoint, segment, length1, dx1, dy1)
    p2_cross = Luxor.getproportionpoint(cornerpoint, segment, length2, dx2, dy2)

    #  calculation of the coordinates of the circle's center by the addition of angular vectors
    dx = cornerpoint.x * 2 - p1_cross.x - p2_cross.x
    dy = cornerpoint.y * 2 - p1_cross.y - p2_cross.y
    L = hypot(dx, dy)
    d = hypot(segment, radius)
    # this prevents impossible constructions; Cairo will crash if L is 0
    if isapprox(L, 0.0)
        L = 0.01
    end
    circlepoint = Luxor.getproportionpoint(cornerpoint, d, L, dx, dy)

    # start angle and end engle of arc
    startangle = atan(p1_cross.y - circlepoint.y, p1_cross.x - circlepoint.x)
    endangle = atan(p2_cross.y - circlepoint.y, p2_cross.x - circlepoint.x)

    if endangle < 0
        endangle = 2π + endangle
    end
    if startangle < 0
        startangle = 2π + startangle
    end
    sweepangle = endangle - startangle

    if abs(sweepangle) > π
        if startangle < endangle
            clockwise = false
        else
            clockwise = true
        end
    else
        if startangle < endangle
            clockwise = true
        else
            clockwise = false
        end
    end
    return p1_cross, circlepoint, p2_cross, clockwise
end

"""
    offsetpoly(plist::Vector{Point}, d::T) where T<:Number

Return a polygon that is offset from a polygon by `d` units.

The incoming set of points `plist` is treated as a polygon, and another set of
points is created, which form a polygon lying `d` units away from the source
poly.

Polygon offsetting is a topic on which people have written PhD theses and
published academic papers, so this short brain-dead routine will give good
results for simple polygons up to a point (!). There are a number of issues to
be aware of:

  - very short lines tend to make the algorithm 'flip' and produce larger lines

  - small polygons that are counterclockwise and larger offsets may make the new
    polygon appear the wrong side of the original
  - very sharp vertices will produce even sharper offsets, as the calculated intersection point veers off to infinity
  - duplicated adjacent points might cause the routine to scratch its head and wonder how to draw a line parallel to them
"""
function offsetpoly(plist::Vector{Point}, d::T) where {T<:Number}
    # don't try to calculate offset of two identical points
    l = length(plist)
    resultpoly = Vector{Point}(undef, l)
    previouspoint = plist[end]
    for i in 1:l
        plist[i] == previouspoint && continue
        p1 = plist[mod1(i, l)]
        p2 = plist[mod1(i + 1, l)]
        p3 = plist[mod1(i + 2, l)]

        p1 == p2 && continue
        p2 == p3 && continue

        L12 = distance(p1, p2)
        L23 = distance(p2, p3)
        # the offset line of p1 - p2
        x1p = p1.x + (d * (p2.y - p1.y)) / L12
        y1p = p1.y + (d * (p1.x - p2.x)) / L12
        x2p = p2.x + (d * (p2.y - p1.y)) / L12
        y2p = p2.y + (d * (p1.x - p2.x)) / L12

        # the offset line of p2 - p3
        x3p = p2.x + (d * (p3.y - p2.y)) / L23
        y3p = p2.y + (d * (p2.x - p3.x)) / L23
        x4p = p3.x + (d * (p3.y - p2.y)) / L23
        y4p = p3.y + (d * (p2.x - p3.x)) / L23

        intersectionpoint = intersectionlines(
            Point(x1p, y1p),
            Point(x2p, y2p),
            Point(x3p, y3p),
            Point(x4p, y4p), crossingonly = false)

        if intersectionpoint[1]
            resultpoly[i] = intersectionpoint[2]
        end
        previouspoint = plist[i]
    end
    return resultpoly
end

"""
    offsetlinesegment(p1, p2, p3, d1, d2)

Given three points, find another 3 points that are offset by
d1 at the start and d2 at the end.

Negative d values put the offset on the left.

Used by `offsetpoly()`.
"""
function offsetlinesegment(p1, p2, p3, d1, d2)
    # TODO: check this, it's not right
    if p1 == p2
        tp = perpendicular(p1, p3, d1)
        return p1, tp, p2
    elseif p1 == p3
        tp = perpendicular(p1, p2, d1)
        return p1, p2, tp
    elseif p2 == p3
        tp = perpendicular(p1, p3, d2)
        return p1, tp, p3
    end

    pt1 = perpendicular(p1, p2, -d1)
    pt2 = perpendicular(p3, p2, d2)

    L12 = distance(p1, p2)
    L23 = distance(p2, p3)

    d = (d1 + d2) / 2
    # the offset line of p1 - p2
    x1p = p1.x + (d * (p2.y - p1.y)) / L12
    y1p = p1.y + (d * (p1.x - p2.x)) / L12
    x2p = p2.x + (d * (p2.y - p1.y)) / L12
    y2p = p2.y + (d * (p1.x - p2.x)) / L12

    # the offset line of p2 - p3
    x3p = p2.x + (d * (p3.y - p2.y)) / L23
    y3p = p2.y + (d * (p2.x - p3.x)) / L23
    x4p = p3.x + (d * (p3.y - p2.y)) / L23
    y4p = p3.y + (d * (p2.x - p3.x)) / L23

    intersectionpoint = intersectionlines(
        Point(x1p, y1p),
        Point(x2p, y2p),
        Point(x3p, y3p),
        Point(x4p, y4p), crossingonly = false)

    if first(intersectionpoint)
        pt3 = intersectionpoint[2]
    else
        #  collinear probably
        pt3 = midpoint(pt1, pt2)
    end
    return pt1, pt3, pt2
end

"""
    offsetpoly(plist;
        startoffset = 10,
        endoffset   = 10,
        easingfunction = lineartween)

Return a closed polygon that is offset from and encloses an
open polygon.

The incoming set of points `plist` is treated as an open
polygon, and another set of points is created, which form a
polygon lying `...offset` units away from the source poly.

This method for `offsetpoly()` treats the list of points as
`n` vertices connected with `n - 1` lines. It allows you to
vary the offset from the start of the line to the end.

The other method `offsetpoly(plist, d)` treats the list of
points as `n` vertices connected with `n` lines.

# Extended help

This function accepts a keyword argument that allows you to
control the offset using a function, using the easing
functionality built in to Luxor. By default the function is
`lineartween()`, so the offset changes linearly between the
`startoffset` and the `endoffset`. The function:

```julia
f(a, b, c, d) = 2sin((a * π))
```

runs from 0 to 2 and back as `a` runs from 0 to 1.
The offsets are scaled by this amount.
"""
function offsetpoly(plist;
    startoffset = 10,
    endoffset = 10,
    easingfunction = lineartween)
    l = length(plist)

    # TODO: special case a plist with 2 points
    l < 3 && throw(error("variableoffsetline: not enough points, need 3 or more"))
    # can't do 3 points properly, just insert a few extras
    if l == 3
        plist = vcat(plist[1], midpoint(plist[1], plist[2]), plist[2], midpoint(plist[2], plist[3]), plist[3])
    end

    # build the poly in two halves
    leftcurve  = Point[]
    rightcurve = Point[]

    pt1 = perpendicular(plist[1], plist[2], -startoffset)
    pt2 = perpendicular(plist[1], plist[2], startoffset)

    # start the curves off
    push!(leftcurve, pt1)
    push!(rightcurve, pt2)

    for i in 1:(l - 2)
        # allow for the easing function that rescales the offset
        k1 = easingfunction(rescale(i, 0, l), 0.0, 1.0, 1.0)
        k2 = easingfunction(rescale(i + 1, 0, l), 0.0, 1.0, 1.0)

        # because easing functions are 0 to 1, use 0 here
        d1 = rescale(k1 * l, 0, l, startoffset, endoffset)
        d2 = rescale(k2 * l, 0, l, startoffset, endoffset)

        p1, mpt, p3 = offsetlinesegment(plist[i], plist[i + 1], plist[i + 2], d1, d2)
        push!(leftcurve, mpt)
        p1, mpt, p3 = offsetlinesegment(plist[i], plist[i + 1], plist[i + 2], -d1, -d2)
        push!(rightcurve, mpt)
    end
    # final point
    k = easingfunction(1, 0.0, 1.0, 1.0)
    d = rescale(k * l, 0, l, startoffset, endoffset)
    pt1 = perpendicular(plist[end], plist[end - 1], -d)
    pt2 = perpendicular(plist[end], plist[end - 1], d)
    push!(leftcurve, pt2)
    push!(rightcurve, pt1)
    return vcat(leftcurve, reverse(rightcurve))
end

# third method

"""
    offsetpoly(plist, shape::Function)

Return a closed polygon that is offset from and encloses an
polyline.

The incoming set of points `plist` is treated as an
polyline, and another set of points is created, which form a
closed polygon offset from the source poly.

There must be at least 4 points in the polyline.

This method for `offsetpoly()` treats the list of points as
`n` vertices connected with `n - 1` lines. (The other method
`offsetpoly(plist, d)` treats the list of points as `n`
vertices connected with `n` lines.)

The supplied function determines the width of the line.
`f(0, θ)` gives the width at the start (the slope of
the curve at that point is supplied in θ), `f(1, θ)` provides
the width at the end, and `f(n, θ)` is the width of point
`n/l`.

# Examples

This example draws a tilde, with the ends starting at 20
(10 + 10) units wide, swelling to 50 (10 + 10 + 15 + 15) in
the middle, as f(0.5) = 25.

```julia
f(x, θ) = 10 + 15sin(x * π)
sinecurve = [Point(50x, 50sin(x)) for x in (-π):(π / 24):π]
pgon = offsetpoly(sinecurve, f)
poly(pgon, :fill)
```

This example enhances the vertical part of the curve, and
thins the horizontal parts.

```julia
g(x, θ) = rescale(abs(sin(θ)), 0, 1, 0.1, 30)
sinecurve = [Point(50x, 50sin(x)) for x in (-π):(π / 24):π]
pgon = offsetpoly(sinecurve, g)
poly(pgon, :fill)
```

TODO - rewrite it!
"""
function offsetpoly(plist, shape::Function)
    # TODO - the code of this function really sucks, I wish
    # I could make it suck less. :) Probably the best thing
    # to do is to abandon all these amateur attempts at
    # polygon-offsetting and use the Clipper library, or
    # something that works.

    l = length(plist)
    l < 4 && throw(error("offsetpoly(): not enough points, need at least 5; try polysample()"))

    # build the poly in four parts and stitch them together
    # first half, two sides
    L = l ÷ 2

    leftcurve  = Point[]
    rightcurve = Point[]

    θ = slope(plist[1], plist[2])
    d = shape(0.0, θ)
    pt1 = perpendicular(plist[1], plist[2], -d)
    pt2 = perpendicular(plist[1], plist[2], d)
    push!(leftcurve, pt1)
    push!(rightcurve, pt2)

    for i in 1:(L - 1)
        # allow for the easing function that rescales the offset
        θ = slope(plist[i], plist[i + 1])
        d = shape(rescale(i, 0, l), θ)

        p1, mpt, p3 = Luxor.offsetlinesegment(plist[i], plist[i + 1], plist[i + 2], d, d)
        push!(leftcurve, mpt)

        p1, mpt, p3 = Luxor.offsetlinesegment(plist[i], plist[i + 1], plist[i + 2], -d, -d)
        push!(rightcurve, mpt)
    end

    # second half, both sides, going backwards

    θ = slope(plist[end], plist[end - 1])
    d = shape(1.0, θ)
    pt1 = perpendicular(plist[end], plist[end - 1], -d)
    pt2 = perpendicular(plist[end], plist[end - 1], d)

    # start the second half curves off
    leftcurve_2  = Point[]
    rightcurve_2 = Point[]

    push!(leftcurve_2, pt1)
    push!(rightcurve_2, pt2)

    # work backwards from the end
    for i in (l - 1):-1:(L + 1)
        θ = slope(plist[i - 1], plist[i])
        d = shape(rescale(i, 0, l), θ)

        p1, mpt, p3 = Luxor.offsetlinesegment(plist[i], plist[i - 1], plist[i - 2], d, d)
        push!(leftcurve_2, p1)

        p1, mpt, p3 = Luxor.offsetlinesegment(plist[i], plist[i - 1], plist[i - 2], -d, -d)
        push!(rightcurve_2, p1)
    end

    append!(leftcurve, reverse(rightcurve_2))
    append!(rightcurve, reverse(leftcurve_2))

    return vcat(leftcurve, reverse(rightcurve))
end

"""
    polyfit(plist::Vector, npoints=30)

Build a polygon that constructs a B-spine approximation to it. The resulting list of points
makes a smooth path that runs between the first and last points.
"""
function polyfit(plist::Vector{Point}, npoints = 30)
    l = length(plist)
    resultpoly = Vector{Point}(undef, 0)
    sizehint!(resultpoly, npoints)
    # start at first point
    push!(resultpoly, plist[1])
    # skip the first point
    @inbounds for i in 2:(l - 1)
        p1 = plist[mod1(i - 1, l)]
        p2 = plist[mod1(i, l)]
        p3 = plist[mod1(i + 1, l)]
        p4 = plist[mod1(i + 2, l)]
        a3 = (-p1.x + 3 * (p2.x - p3.x) + p4.x) / 6.0
        b3 = (-p1.y + 3 * (p2.y - p3.y) + p4.y) / 6.0
        a2 = (p1.x - 2p2.x + p3.x) / 2.0
        b2 = (p1.y - 2p2.y + p3.y) / 2.0
        a1 = (p3.x - p1.x) / 2.0
        b1 = (p3.y - p1.y) / 2.0
        a0 = (p1.x + 4p2.x + p3.x) / 6.0
        b0 = (p1.y + 4p2.y + p3.y) / 6.0
        for i in 1:(l - 1)
            t = i / npoints
            x = ((((a3 * t + a2) * t) + a1) * t) + a0
            y = ((((b3 * t + b2) * t) + b1) * t) + b0
            push!(resultpoly, Point(x, y))
        end
    end
    # finish at last point
    push!(resultpoly, plist[end])
    return resultpoly
end

"""
    polybspline(controlpoints::Vector{Point}, npoints; degree=3, clamped=true)

Generate a B-spline curve from a given set of control points.

# Arguments

  - `controlpoints::Vector{Point}`: An array of control points that define the B-spline.
  - `npoints=100`: The number of points to generate on the B-spline curve.
  - `degree=3`: The degree of the B-spline. Default is 3.
  - `clamped=true`: A boolean to indicate if the B-spline is clamped. Default is true.

# Returns

  - An array of points on the B-spline curve.
"""
function polybspline(controlpoints::Vector{Point}, npoints = 30; degree = 3, clamped = true)
    nCP::Int64 = length(controlpoints)
    nCP == 0 && error("Error: controlpoints array cannot be empty.")
    npoints <= 0 && error("Error: npoints must be greater than zero.")
    degree <= 0 && error("Error: degree must be greater than zero.")
    degree >= nCP && error("Error: degree cannot be greater than the number of control points.")
    points = Vector{Point}(undef, npoints)
    T = Vector{Float64}(undef, nCP + degree + 1)
    if clamped
        T[1:degree] .= 0.0
        for i in (degree + 1):(nCP + 1)
            T[i] = (i - degree - 1) / (nCP - degree)
        end
        T[(nCP + 2):end] .= 1.0
    else
        for i in 1:(nCP + degree + 1)
            T[i] = (i - 1) / (nCP + degree)
        end
    end

    """De Boor's algorithm for B-spline evaluation.
        from https://en.wikipedia.org/wiki/De_Boor%27s_algorithm
        Arguments
        ---------
        k: Index of knot interval that contains x.
        x: Position.
        t: Array of knot positions, needs to be padded as described above.
        c: Array of control points.
        p: Degree of B-spline.
    """
    function deBoor(k::Int64, x::Float64, t::Vector{Float64}, c::Vector{Point}, p::Int64)::Point
        d = Vector{Point}(undef, p + 1)
        for j in 1:(p + 1)
            d[j] = c[j + k - p]
        end
        @inbounds for r in 1:p
            for j in (p + 1):-1:(r + 1)
                alpha = (x - t[j + k - p]) / (t[j + 1 + k - r] - t[j + k - p])
                d[j] = (1 - alpha) * d[j - 1] + alpha * d[j]
            end
        end
        return d[p + 1]
    end

    @inbounds for i in 0:(npoints - 1)
        t = i / (npoints - 1)
        if !clamped
            t = t * (T[nCP + 1] - T[degree + 1]) + T[degree + 1]
        end
        k = 1 #index of knot interval
        while k < nCP
            if t < T[k + 1]
                break
            end
            k += 1
        end
        points[i + 1] = deBoor(k - 1, t, T, controlpoints, degree)
    end
    return points
end

"""
    pathtopoly()

Build a copy of the current path as an array of polygons. The current path remains active.

Returns an array of polygons, corresponding to the paths and subpaths of the original path.
"""
function pathtopoly()
    originalpath = getpathflat()
    polygonlist = Vector{Point}[]
    sizehint!(polygonlist, length(originalpath))
    if length(originalpath) > 0
        pointslist = Point[]
        for e in originalpath
            if e.element_type == Cairo.CAIRO_PATH_MOVE_TO                # 0
                push!(pointslist, Point(first(e.points), last(e.points)))
            elseif e.element_type == Cairo.CAIRO_PATH_LINE_TO            # 1
                push!(pointslist, Point(first(e.points), last(e.points)))
            elseif e.element_type == Cairo.CAIRO_PATH_CLOSE_PATH         # 3
                if last(pointslist) == first(pointslist)
                    # don’t repeat first point, we can close it ourselves
                    if length(pointslist) > 2
                        pop!(pointslist)
                    end
                end
                push!(polygonlist, pointslist)
                pointslist = Point[]
            else
                error("pathtopoly(): unknown CairoPathEntry " * repr(e.element_type))
                error("pathtopoly(): unknown CairoPathEntry " * repr(e.points))
            end
        end
        # the path was never closed, so flush
        if length(pointslist) > 0
            push!(polygonlist, pointslist)
        end
    end
    return polygonlist
end

"""
    polydistances(p::Vector{Point}; closed=true)

Return an array of the cumulative lengths of a polygon.
"""
function polydistances(p::Vector{Point}; closed = true)
    l = length(p)
    r = Float64[0.0]
    sizehint!(r, l)
    t = 0.0
    @inbounds for i in 1:(l - 1)
        t += distance(p[i], p[i + 1])
        push!(r, t)
    end
    if closed
        t += distance(p[end], p[1])
        push!(r, t)
    end
    return r
end

"""
    polyperimeter(p::Vector{Point}; closed=true)

Find the total length of the sides of polygon `p`.
"""
function polyperimeter(p::Vector{Point}; closed = true)
    return polydistances(p, closed = closed)[end]
end

"""
    nearestindex(polydistancearray, value)

Return a tuple of the index of the largest value in `polydistancearray` less
than `value`, and the difference value. Array is assumed to be sorted.

(Designed for use with `polydistances()`).
"""
function nearestindex(a::Vector{Float64}, val)
    ind = findlast(v -> (v < val), a)
    if isnothing(ind)
        throw(error("nearestindex: no index"))
    end
    surplus = 0.0
    if ind > 0.0
        surplus = val - a[ind]
    else
        ind = 1
    end
    return (ind, surplus)
end

"""
    polyportion(p::Vector{Point}, portion=0.5; 
        closed=true,
        pdist = Vector{Union{Float64, Int}}[])

Return a portion of a polygon, starting at a value between
0.0 (the beginning) and 1.0 (the end). 0.5 returns the first
half of the polygon, 0.25 the first quarter, 0.75 the first
three quarters, and so on.

Use `closed=false` to exclude the line joining the final
point to the first point from the calculations.

If you already have a list of the distances between each
point in the polygon (the "polydistances"), you can pass
them in `pdist`, otherwise they'll be calculated afresh,
using `polydistances(p, closed=closed)`.

Use the complementary `polyremainder()` function to return
the other part.
"""
function polyportion(p::Vector{Point}, portion = 0.5;
    closed = true,
    pdist = Vector{Float64}[])
    # portion is 0 to 1
    if isempty(pdist)
        pdist = polydistances(p, closed = closed)
    end

    if length(p) < 2
        throw(error("polyportion(): need at least two points in a polygon"))
    end

    portion = clamp(portion, 0.0, 1.0)
    # don't bother to do 0.0
    isapprox(portion, 0.0, atol = 0.00001) && return p[1:1]

    # do 1.0 more carefully
    if isapprox(portion, 1.0, atol = 0.00001)
        if closed == false
            return p
        else
            # include the last line from the end to the first point
            push!(p, p[1])
            return p
        end
    end
    ind, surplus = nearestindex(pdist, portion * pdist[end])
    if surplus > 0.0
        nextind = mod1(ind + 1, length(p))
        overshootpoint = between(p[ind], p[nextind], surplus / distance(p[ind], p[nextind]))
        return vcat(p[1:ind], overshootpoint)
    else
        return p[1:end]
    end
end

"""
    polyremainder(p::Vector{Point}, portion=0.5;
        closed=true,
        pdist=Vector{Union{Float64, Int}}[])

Return the rest of a polygon, starting at a value between 0.0 (the beginning)
and 1.0 (the end). 0.5 returns the last half of the polygon, 0.25 the last three
quarters, 0.75 the last quarter, and so on.

Use `closed=false` to exclude the line joining the
final point to the first point from the calculations.

If you already have a list of the distances between each point in the polygon
(the "polydistances"), you can pass them in `pdist`, otherwise they'll be
calculated afresh, using `polydistances(p, closed=closed)`.

Use the complementary `polyportion()` function to return the other part.
"""
function polyremainder(p::Vector{Point}, portion = 0.5;
    closed = true,
    pdist = Vector{Union{Float64,Int}}[])
    # portion is 0 to 1
    if isempty(pdist)
        pdist = polydistances(p, closed = closed)
    end
    if length(p) < 2
        throw(error("polyremainder(): need at least two points in a polygon"))
    end
    portion = clamp(portion, 0.0, 1.0)

    # don't bother to do 0.0
    isapprox(portion, 0.0, atol = 0.00001) && return p

    # don't bother to do 1.0
    if isapprox(portion, 1.0, atol = 0.00001)
        return p[1:1]
    end
    ind, surplus = nearestindex(pdist, portion * pdist[end])
    if surplus > 0.0
        nextind = mod1(ind + 1, length(p))
        overshootpoint = between(p[ind], p[nextind], surplus / distance(p[ind], p[nextind]))
        return vcat(overshootpoint, p[nextind:end])
    else
        return p[1:end]
    end
end

"""
    polysample(p::Vector{Point}, npoints::T where T <: Integer;
            closed=true)

Sample the polygon `p`, returning a polygon with `npoints`
to represent it. The first sampled point is:

```1/`npoints` * `perimeter of p````

away from the original first point of `p`.

If `npoints` is the same as `length(p)` the returned polygon
is the same as the original, but the first point finishes up
at the end (so `new=circshift(old, 1)`).

If `closed` is true, the entire polygon (including the edge
joining the last point to the first point) is sampled.

If `include_first` is true, the first point of `plist` is
included in the result.

If the resulting polygon's first and end points are the
same, the end point is discarded.
"""
function polysample(p::Vector{Point}, npoints::T where {T<:Integer};
    include_first = false,
    closed        = true)
    l = length(p)
    l < 2 && error("polysample(): not enough points in polygon to take samples")
    npoints < 2 && return p[[1, end]]
    distances = polydistances(p, closed = closed)
    if include_first
        result = Point[p[1]]
    else
        result = Point[]
    end
    sizehint!(result, l)
    for i in 1:npoints
        ind, surplus = nearestindex(distances, (i / npoints) * distances[end])
        if surplus > 0.0
            nextind = mod1(ind + 1, l)
            overshootpoint = between(p[ind], p[nextind], surplus / distance(p[ind], p[nextind]))
            push!(result, overshootpoint)
        else
            push!(result, p[i])
        end
    end
    if result[1] == result[end]
        return result[1:(end - 1)]
    else
        return result
    end
end

"""
    intersectlinepoly(pt1::Point, pt2::Point, C)

Return an array of the points where a line between pt1 and pt2 crosses polygon C.
"""
function intersectlinepoly(pt1::Point, pt2::Point, C::Vector{Point})
    intersectingpoints = Point[]
    @inbounds for j in eachindex(C)
        Cpointpair = (C[j], C[mod1(j + 1, length(C))])
        flag, pt = intersectionlines(pt1, pt2, Cpointpair..., crossingonly = true)
        if flag
            push!(intersectingpoints, pt)
        end
    end
    # sort by distance from pt1
    sort!(intersectingpoints, lt = (p1, p2) -> distance(p1, pt1) < distance(p2, pt1))
    return intersectingpoints
end

"""
    polyclip(s, c)

Return a polygon that defines the intersection between an
subject polygon and the clip polygon.

Return `nothing` if the function can't find one.

- S - subject polygon - can be concave or convex.

- C - clip polygon - must be convex.

Uses the Sutherland-Hodgman clipping algorithm. Calls `ispointonleftofline()`.

To find where two polygon intersections, use `polyintersect()`.
"""
function polyclip(S::Vector{Point}, C::Vector{Point})
    if !ispolyconvex(C)
        @warn "polyclip(S, C): the second argument, C, must be a convex polygon."
        return nothing
    end
    outpoly = S
    clippoint1 = C[end]
    for clippoint2 in C
        inarr = outpoly
        outpoly = Point[]
        if length(inarr) == 0
            return nothing
        end
        startpoint = inarr[end]
        for endpoint in inarr
            if ispointonleftofline(clippoint1, clippoint2, endpoint)
                if !ispointonleftofline(clippoint1, clippoint2, startpoint)
                    push!(outpoly, last(intersectionlines(clippoint1, clippoint2, startpoint, endpoint)))
                end
                push!(outpoly, endpoint)
            elseif ispointonleftofline(clippoint1, clippoint2, startpoint)
                push!(outpoly, last(intersectionlines(clippoint1, clippoint2, startpoint, endpoint)))
            end
            startpoint = endpoint
        end
        clippoint1 = clippoint2
    end
    return length(outpoly) > 0 ? outpoly : nothing
end

# TODO these experimental functions don't work all the time
# use with caution... :)

"""
    polyorientation(pgon)

Returns a number which is positive if the polygon is clockwise in Luxor...

!!! warning

    This code is still experimental...
"""
function polyorientation(pgon::Vector{Point})
    # in Luxor polys are usually clockwise
    # perhaps this is because the Y axis goes down...
    sum = 0.0
    @inbounds for i in 1:length(pgon)
        sum += crossproduct(pgon[i], pgon[mod1(i + 1, end)])
    end
    return sum
end

polyorientation(pt1, pt2, pt3) = polyorientation(Point[pt1, pt2, pt3])

"""
    ispolyclockwise(pgon)

Returns true if polygon is clockwise. WHEN VIEWED IN A LUXOR DRAWING...?

!!! warning

    This code is still experimental...
"""
function ispolyclockwise(pgon::Vector{Point})
    polyorientation(pgon) > 0.0
end

"""
    ispointinsidetriangle(p, p1, p2, p3)
    ispointinsidetriangle(p, triangle::Vector{Point})

Returns false if `p` is not inside triangle p1 p2 p3.
"""

function ispointinsidetriangle(p::Point, p1::Point, p2::Point, p3::Point)
    if polyorientation([p1, p2, p3]) < 0.0
        p1, p3 = p3, p1
    end
    # barycentric method?
    s = p1.y * p3.x - p1.x * p3.y + (p3.y - p1.y) * p.x + (p1.x - p3.x) * p.y
    t = p1.x * p2.y - p1.y * p2.x + (p1.y - p2.y) * p.x + (p2.x - p1.x) * p.y

    if s < 0 != t < 0
        return false
    end
    A = -p2.y * p3.x + p1.y * (p3.x - p2.x) + p1.x * (p2.y - p3.y) + p2.x * p3.y
    return A < 0 ?
           (s <= 0 && s + t >= A) :
           (s >= 0 && s + t <= A)
end

ispointinsidetriangle(p::Point, triangle::Vector{Point}) =
    ispointinsidetriangle(p, triangle[1], triangle[2], triangle[3])

"""
    polyremovecollinearpoints(pgon::Vector{Point})

Return copy of polygon with no collinear points.

Caution: may return an empty polygon... !

!!! warning

    This code is still experimental...
"""
function polyremovecollinearpoints(pgon::Vector{Point})
    markfordeletion = []
    @inbounds for n in 1:length(pgon)
        p1 = pgon[n]

        pfirst = pgon[mod1(n - 1, length(pgon))]
        plast = pgon[mod1(n + 1, length(pgon))]

        if ispointonline(p1, pfirst, plast, extended = true, atol = 0.1)
            push!(markfordeletion, n)
        end
    end
    return pgon[setdiff(1:length(pgon), markfordeletion)]
end

"""
    polymove!(pgon, frompoint::Point, topoint::Point)

Move (permanently) a polygon from `frompoint` to `topoint`.
"""
function polymove!(pgon, frompoint::Point, topoint::Point)
    d = topoint - frompoint
    return pgon .+= d
end

"""
    polyscale!(pgon, s;
       center=O)

Scale (permanently) a polygon by `s`, relative to `center`.
"""
function polyscale!(pgon, s; center::Point = O)
    return pgon .= between.(center, pgon, s)
end

"""
    polyscale!(pgon, sh, sv;
        center=O)

Scale (permanently) a polygon by `sh` horizontally and `sv` vertically,
relative to `center`.
"""
function polyscale!(pgon, sh, sv;
    center = O)
    return pgon .= (pgon .- center) .* Ref((sh, sv))
end

"""
    polyrotate!(pgon, θ;
        center=O)

Rotate (permanently) a polygon around `center` by `θ` radians.
"""
function polyrotate!(pgon, θ;
    center = O)
    costheta = cos(θ)
    sintheta = sin(θ)
    @inbounds for i in eachindex(pgon)
        pgon[i] = Point(
            (pgon[i].x - center.x) * costheta - ((pgon[i].y - center.y) * sintheta) + center.x,
            (pgon[i].x - center.x) * sintheta + ((pgon[i].y - center.y) * costheta) + center.y)
    end
    return pgon
end

"""
    polyreflect!(pgon, pt1 = O, pt2 = O + (0, 100)

Reflect (permanently) a polygon in a line (default to the y-axis)
joining two points.
"""
function polyreflect!(pgon, pt1 = O, pt2 = O + (0, 100))
    @inbounds for i in eachindex(pgon)
        gnp = getnearestpointonline(pt1, pt2, pgon[i])
        pgon[i] = between(pgon[i], gnp, 2.0)
    end
    return pgon
end

"""
    insertvertices!(pgon;
        ratio=0.5)

Insert a new vertex into each edge of a polygon `pgon`. The default `ratio` of
0.5 divides the original edge of the polygon into half.
"""
function insertvertices!(pgon;
    ratio = 0.5)
    counter = 1
    vertexnumber = 2
    originallength = length(pgon)
    while true
        insert!(pgon, vertexnumber,
            between(pgon[mod1(vertexnumber - 1, length(pgon))],
                pgon[mod1(vertexnumber, length(pgon))],
                ratio))
        vertexnumber += 2
        counter += 1
        if counter > originallength
            break
        end
    end
    return pgon
end

# triangulation functions

function _smallesttriangle(bb::BoundingBox)
    # find the smallest triangle that completely encloses bounding box
    diag = boxdiagonal(bb)

    # circle that encloses this box
    circ = (center = boxmiddlecenter(bb), radius = diag / 2)

    # three equally spaced points on circle
    side1pt = circ.center + polar(circ.radius, 0)
    side2pt = circ.center + polar(circ.radius, 2π / 3)
    side3pt = circ.center + polar(circ.radius, 4π / 3)

    # make them clockwise
    pgon = [side1pt, side2pt, side3pt]
    if !ispolyclockwise(pgon)
        reverse!(pgon)
    end
    return offsetpoly(pgon, circ.radius / 2)
end

mutable struct TriEdge
    spt::Point
    ept::Point
    valid::Bool
end

function _edgesequal(edge1::TriEdge, edge2::TriEdge)
    !edge1.valid && return false
    !edge2.valid && return false
    if ((edge1.spt ≈ edge2.spt) && (edge1.ept ≈ edge2.ept)) ||
       ((edge1.spt ≈ edge2.ept) && (edge1.ept ≈ edge2.spt))
        return true
    else
        return false
    end
end

"""
    polytriangulate(plist::Vector{Point}; epsilon = -0.01)

Triangulate the polygon in `plist`.

This uses the Bowyer–Watson/Delaunay algorithm to make triangles. It returns an array of triangular polygons.

!!! note

    This experimental polygon function is not very efficient, because it first
    copies the list of points (to avoid modifying the original), and sorts it,
    before making triangles.
"""
function polytriangulate(plist::Vector{Point}; epsilon = -0.001)
    trianglelist = Vector{Point}[]
    pointlist = deepcopy(plist)
    vertexcount = length(pointlist)

    # make enclosing supertriangle
    bb = BoundingBox(pointlist)
    supertriangle = Luxor._smallesttriangle(bb)

    # add the supertriangle to the trianglelist
    push!(trianglelist, supertriangle)

    # add the supertriangle’s vertices to the point list
    push!(pointlist, supertriangle[1])
    push!(pointlist, supertriangle[2])
    push!(pointlist, supertriangle[3])

    # sorting the list of points by x coordinate
    sort!(pointlist)

    @inbounds for point in pointlist
        edgebuffer = Vector{Luxor.TriEdge}() # to store edges
        tobedeleted = Int64[]

        for ntriangle in eachindex(trianglelist)
            # for each triangle currently in the trianglelist
            # calculate the triangle circumcircle center and radius
            triangle = trianglelist[ntriangle]
            cp, r = center3pts(triangle[1], triangle[2], triangle[3])

            #as soon as the x component of the distance from the current point to the
            #circumcircle center is greater than the circumcircle radius, that triangle need
            #never be considered for later points, as further points will never again be on
            #the interior of that triangles circumcircle.
            abs(point.x - cp.x) > r && continue

            # if this fails, r is zero, so no problem with adding edges/deleting triangles
            if distance(point, cp) < (r + epsilon)
                # if the point lies in the triangle’s circumcircle,
                # add the triangle’s edges to the edge buffer
                push!(edgebuffer, Luxor.TriEdge(triangle[1], triangle[2], true))
                push!(edgebuffer, Luxor.TriEdge(triangle[2], triangle[3], true))
                push!(edgebuffer, Luxor.TriEdge(triangle[3], triangle[1], true))
                # and mark the triangle to be deleted
                push!(tobedeleted, ntriangle)
            end
        end
        deleteat!(trianglelist, tobedeleted)

        # find all shared edges in the edge buffer
        # when they’re removed, the edges of the enclosing polygon are left
        j = 1
        while j <= length(edgebuffer)
            k = j + 1
            while k <= length(edgebuffer)
                if Luxor._edgesequal(edgebuffer[j], edgebuffer[k]) == true
                    edgebuffer[j].valid = false
                    edgebuffer[k].valid = false
                end
                k += 1
            end
            j += 1
        end

        # make new triangles around the current point
        # skip over any tagged edges
        j = 1
        while j <= length(edgebuffer)
            if edgebuffer[j].valid
                # the order is important
                pgon = sort([edgebuffer[j].ept, point, edgebuffer[j].spt])
                # make sure every polygon is clockwise
                if !ispolyclockwise(pgon)
                    reverse!(pgon)
                end
                push!(trianglelist, pgon)
            end
            j += 1
        end
    end # do next point

    # # tidy up
    # # remove any triangles that use the supertriangle’s vertices
    indexes = Int64[]
    for n in eachindex(trianglelist)
        triangle = trianglelist[n]
        for tpt in triangle
            for stpt in supertriangle
                if tpt ≈ stpt
                    push!(indexes, n) # mark for deletion
                end
            end
        end
    end
    deleteat!(trianglelist, unique(indexes))
    return trianglelist
end

# convex hull
function _polar_angle(pt1, pt2)
    return atan(pt1.y - pt2.y, pt1.x - pt2.x)
end

function _polarsortpoints(anchor, pt1, pt2)
    if _polar_angle(anchor, pt1) < _polar_angle(anchor, pt2)
        return true
    elseif _polar_angle(anchor, pt1) > _polar_angle(anchor, pt2)
        return false
    elseif isapprox(_polar_angle(anchor, pt1), _polar_angle(anchor, pt2))
        if distance(anchor, pt1) < distance(anchor, pt2)
            return true
        else
            return false
        end
    else
        return false
    end
end

"""
    _betweenpoly(loop1, loop2, k;
        samples = 100,
        easingfunction = easingflat)

Find a simple polygon between the two simple
polygons `loop1` and `loop2` corresponding to `k`, where
`0.0 < k < 1.0`.

By default, `easingfunction = easingflat`, so the
intermediate steps are linearly spaced. If you use another
easing function, intermediate steps are determined by the
value of the easing function at `k`.

Used by `polymorph()`.

Because `polysample()` can treat the polygon as open or
closed (with different results), you can specify how the
sampling is done here, with the `closed=` keyword:

  - closed = true
    -> polygons are sampled as closed

  - closed = false
    -> polygons are sampled as open
  - closed = (true, false)
    -> first polygon is sampled as closed, second as open
"""
function _betweenpoly(loop1, loop2, k;
    samples = 100,
    easingfunction = easingflat,
    closed = (true, true))
    if closed == true
        closed = (true, true)
    elseif closed == false
        closed = (false, false)
    end
    l1 = polysample(loop1, samples, closed = first(closed))
    l2 = polysample(loop2, samples, closed = last(closed))
    result = Point[]
    eased_k = easingfunction(k, 0.0, 1.0, 1.0)
    # don't skip first point like polysample() does :(
    push!(result, between(loop1[1], loop2[1], eased_k))
    for j in 1:samples
        push!(result, between(l1[j], l2[j], eased_k))
    end
    return result
end

"""
    polymorph(pgon1::Array{Vector{Point}}, pgon2::Array{Vector{Point}}, k;
        samples = 100,
        easingfunction = easingflat,
        kludge = true
        closed = true)

"morph" is to gradually change from one thing to another.
This function changes one polygon into another.

It returns an array of polygons, `[p_1, p_2, p_3, ... ]`,
where each polygon `p_n` is the intermediate shape between
the corresponding shape in `pgon1[1...n]` and `pgon2[1...n]`
at `k`, where `0.0 < k < 1.0`. If `k ≈ 0.0`, the
`pgon1[1...n]` is returned, and if ``k ≈ 1.0`, `pgon2[1...n]` is returned.

`pgon1` and `pgon2` can be either simple polygons with three or more points
each, or arrays of one or more polygonal shapes (eg as created by
`pathtopoly()`). For example, `pgon1` might consist of two polygonal shapes, a
square and a triangular shaped hole inside; `pgon2` might be a triangular shape
with a square hole.

It makes sense for both arguments to have the same number of
polygonal shapes. If one has more than another, some shapes
would be lost when it morphs. But the suggestively-named
`kludge` keyword argument, when set to (the default) true,
tries to compensate for this.

By default, `easingfunction = easingflat`, so the
intermediate steps are linear. If you use another easing
function, intermediate steps are determined by the value of
the easing function at `k`.

Because `polysample()` can treat the polygon as open or
closed (with different results), you can specify how the
sampling is done here, with the `closed=` keyword:

  - closed = true
    -> polygons are sampled as closed

  - closed = false
    -> polygons are sampled as open
  - closed = (true, false)
    -> first polygon is sampled as closed, second as open

This function isn't very efficient, because it copies the
polygons and resamples them.

TODO : experimental, can surely be improved.

# Extended help

### Examples

This simple morph between a small square and a larger
octagon is controlled by the easing function
`easeinoutinversequad`, which slows down around the middle
of the transition.

Only the first shape of the returned
polygon array is needed.

```julia
pgon1 = ngon(O, 30, 4, 0, vertices = true)
pgon2 = ngon(O, 220, 8, 0, vertices = true)
for i in 0:0.1:1.0
    poly(first(polymorph(pgon1, pgon2, i,
            easingfunction = easeinoutinversequad)),
        action = :stroke,
        close = true)
end
```

This next example morphs between the first shape - a circle with
a square hole - and the second shape, a square with a
circular hole.

```julia
ngon(O - (250, 0), 30, 50, 0, :path)
newsubpath()
ngon(O - (250, 0), 10, 4, 0, reversepath = true, :path)
pg1 = pathtopoly()

newpath()
ngon(O + (250, 0), 30, 4, 0, :path)
newsubpath()
ngon(O + (250, 0), 10, 50, 0, reversepath = true, :path)
pg2 = pathtopoly()

for i in reverse(0.0:0.1:1.0)
    randomhue()
    newpath()
    # use :path followed by fillpath() to preserve correct "hole"-iness
    poly.(polymorph(pg1, pg2, i), :path, close = true)
    fillpath()
end
```
"""
function polymorph(pgon1::Array{Vector{Point}}, pgon2::Array{Vector{Point}}, k;
    samples = 100,
    easingfunction = easingflat,
    kludge = true,
    closed = true)
    isapprox(k, 0.0) && return pgon1
    isapprox(k, 1.0) && return pgon2
    loopcount1 = length(pgon1)
    loopcount2 = length(pgon2)
    result = Vector{Point}[]
    centroid1 = centroid2 = O # kludge-y eh?
    for i in 1:max(loopcount1, loopcount2)
        from_ok = to_ok = false
        not_empty1 = i <= loopcount1
        not_empty2 = i <= loopcount2
        # ideally both arrays are good, but we'll copy somehow if they're not
        if (not_empty1 && length(pgon1[i]) >= 3)
            from_ok = true
        end
        if (not_empty2 && length(pgon2[i]) >= 3)
            to_ok = true
        end
        if from_ok && to_ok
            # a simple morph should suffice
            push!(result, Luxor._betweenpoly(pgon1[i], pgon2[i], k,
                samples = samples,
                easingfunction = easingfunction,
                closed = closed))
            centroid1 = polycentroid(pgon1[i])
            centroid2 = polycentroid(pgon2[i])
        elseif from_ok && !to_ok && kludge
            # nothing to morph to, so make something up
            pdir = !ispolyclockwise(pgon1[i])
            loop2 = ngon(centroid2, 0.1, reversepath = pdir, length(pgon1[i]), vertices = true)
            push!(result, Luxor._betweenpoly(pgon1[i], loop2, k,
                samples = samples,
                easingfunction = easingfunction,
                closed = closed))
            centroid1 = polycentroid(pgon1[i])
        elseif !from_ok && to_ok && kludge
            # nothing to morph from, so make something up
            pdir = !ispolyclockwise(pgon2[i])
            loop1 = ngon(centroid1, 0.1, reversepath = pdir, length(pgon2[i]), vertices = true)
            push!(result, Luxor._betweenpoly(loop1, pgon2[i], k,
                samples = samples,
                easingfunction = easingfunction,
                closed = closed))
            centroid2 = polycentroid(pgon2[i])
        end
    end
    return result
end

polymorph(pgon1::Vector{Point}, pgon2::Vector{Point}, k; kwargs...) = begin
    polymorph([pgon1], [pgon2], k; kwargs...)
end
polymorph(pgon1::Array{Vector{Point}}, pgon2::Vector{Point}, k; kwargs...) = begin
    polymorph(pgon1, [pgon2], k; kwargs...)
end
polymorph(pgon1::Vector{Point}, pgon2::Array{Vector{Point}}, k; kwargs...) = begin
    polymorph([pgon1], pgon2, k; kwargs...)
end

"""
    polysidelengths(p::Vector{Point}; closed = true)

Return an array containing the lengths of each "side" of the polygon `p`.

If `closed = false`, the side joining the last point to the first is not included.

```julia
polysidelengths(ngon(O, 100, 4))
4-element Vector{Float64}:
 141.42135623730948
 141.4213562373095
 141.4213562373095
 141.42135623730954

polysidelengths(ngon(O, 100, 4), closed=false)
3-element Vector{Float64}:
 141.42135623730948
 141.4213562373095
 141.4213562373095
```
"""
function polysidelengths(p::Vector{Point}; closed = true)
    l = length(p)
    r = Float64[]
    sizehint!(r, l)
    t = 0.0
    @inbounds for i in 1:(l - 1)
        t = distance(p[i], p[i + 1])
        push!(r, t)
    end
    if closed
        t = distance(p[end], p[1])
        push!(r, t)
    end
    return r
end

using Luxor, Test, Colors, Random

Random.seed!(42)

function noisetest(fname)
    Drawing(800, 800, fname)
    background("chartreuse4")
    origin()

    initnoise(rand(1:12))

    @test 0.0 < noise(.5) <= 1.0
    @test 0.0 < noise(0.1, 0.5) <= 1.0
    @test 0.0 < noise(0.1, 0.1, -0.1) <= 1.0
    @test 0.0 < noise(0.5, 2.0, -2.0, 0.1) <= 1.0

    freq = 0.02
    tiles = Tiler(800, 800, 150, 150)
    for k in 1:2:10
        for (pos, n) in tiles
            f, d = .01, k
            ns = noise(pos.x * freq, pos.y * freq, detail=3, persistence=.3)
            ns1 = noise(ns, detail = 3, persistence=2)
            ns2 = noise(pos.x * freq, pos.y * freq, ns, detail = 2)
            ns3 = noise(pos.x * freq, pos.y * freq, ns2)
            setopacity(ns3)
            sethue(LCHab(80ns, 100 * ns1, 360 * ns2))
            box(pos, tiles.tilewidth, tiles.tileheight, :fill)
        end
    end

    # test a custom rng
    rng = MersenneTwister(1234)
    initnoise(rng)

    @test 0.0 < noise(.5) <= 1.0
    @test 0.0 < noise(0.1, 0.5) <= 1.0
    @test 0.0 < noise(0.1, 0.1, -0.1) <= 1.0
    @test 0.0 < noise(0.5, 2.0, -2.0, 0.1) <= 1.0

    @test finish() == true
end

fname = "noise-test.png"
noisetest(fname)
println("...finished noise test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function drawpolyboundingbox(apoly)
    gsave()
    setline(0.3)
    setdash("dotted")
    poly(convert(Vector{Point}, BoundingBox(apoly)), :stroke, close=true)
    box(BoundingBox(apoly), :stroke)
    grestore()
end

function drawpoly(p, x, y, counter)
    gsave()
    translate(x, y)
    sethue("purple")

    # label old points
    @layer begin
        sethue("grey50")
        fontsize(8)
        for (n, pt) in enumerate(p)
            circle(pt, 1, :fill)
            label(string(n), :NW, pt, offset=5)
        end
    end

    psort = polysortbyangle(p)
    drawpolyboundingbox(psort)
    poly(psort, close=true, :stroke)

    # label sorted points
    for (n, pt) in enumerate(psort)
        circle(pt, 1, :fill)
        text(string(n), pt.x, pt.y)
    end

    sethue("green")
    cp = polycentroid(psort)
    circle(cp, 5, :fill)
    text(string(counter), cp.x, cp.y)

    # highlight cases where centroid isn't inside poly. Might be an error...
    if ! isinside(cp, psort)
        gsave()
        setdash("dotted")
        setopacity(0.2)
        sethue("red")
        circle(cp, 100, :fillstroke)
        grestore()
    end

    grestore()
end

function polycentroidsort(width, height)
    pagetiles = Tiler(width, height, 5, 5, margin=50)
    tilesize = pagetiles.tilewidth/2
    for (pos, n) in pagetiles

        p = randompointarray(rand(-tilesize:-tilesize), rand(-tilesize:-tilesize), rand(tilesize:tilesize), rand(tilesize:tilesize), rand(5:12))

        # check for axis-aligned edges too
        rand(1:10) > 7 && (p = Random.shuffle!(box(O, 250, 300, vertices=true)))
        drawpoly(p, pos.x, pos.y, n)
    end
end

function polycentroidtest(fname)
    width, height = 3000, 3000
    Drawing(width, height, fname)
    fontsize(20)
    background("white")
    origin()
    polycentroidsort(width, height)
    @test finish() == true
end

fname = "polycentroidsort.png"
polycentroidtest(fname)

println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Colors

using Test

using Random
Random.seed!(42)

function spiral_logo_eps()
    gsave()
    scale(.3, .3)
    r = 200
    setcolor("gray")
    for i in 0:pi/8:2pi
        gsave()
        translate(r * cos(i), r * sin(i))
        rotate(i)
        julialogo()
        grestore()
    end
    grestore()
end

function expandingspiral_eps()
    gsave()
    scale(.3, .3)
    r = 200
    for i in pi:pi/12:6pi
        gsave()
        translate(i/3 * r * cos(i), i/3 * r * sin(i))
        scale(0.8, 0.8)
        rotate(i)
        julialogo()
        grestore()
    end
    grestore()
end

function dropshadow_eps()
    steps=20
    # white-gray ramp
    gramp = range(colorant"white", stop=colorant"gray60", length=steps)
    gsave()
    r = 200
    setopacity(0.1)
    for i in 1:steps
        sethue(gramp[i])
        translate(-0.6, -0.5)
        julialogo(color=false)
    end
    julialogo()
    grestore()
end

function colorgrid_eps()
    #cols = colormap("RdBu", 5; mid=0.5, logscale=false)
    #cols = sequential_palette(rand(10:360), 5, b=0.1)
    cols = distinguishable_colors(25)
    gsave()
    c = 0
    for row in 100:100:500
        for column in 100:100:500
            gsave()
            setcolor(color(cols[c+=1]))
            translate(row, column)
            scale(0.3, 0.3)
            julialogo(color=false)
            grestore()
        end
    end
    grestore()
end

function draw_logo(fname)
    Drawing(1600, 1600, fname)
    origin()
    background("white")

    translate(-500, -200)
    spiral_logo_eps()

    translate(750, 0)
    expandingspiral_eps()

    translate(-1000, 500)
    dropshadow_eps()

    translate(700, -100)
    colorgrid_eps()

    @test finish() == true
    println("...finished test: output in $(fname)")
end

draw_logo("julia-logo-draw-eps.eps")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function get_all_png_files_alpha(folder)
    imagelist = filter(f -> !startswith(f, ".") && endswith(f, "png"), readdir(folder))
    return map(f -> string(folder, f), imagelist)
end

function alphaimages(fname)
    imagelist = get_all_png_files_alpha(dirname(@__FILE__) * "/../docs/src/assets/figures/")
    width, height = 3000, 3000
    Drawing(width, height, fname)
    origin()
    background("grey50")
    for imgfile in imagelist
        img = readpng(imgfile)
        rand(Bool) ? placeimage(img, rand(-width/2:width/2), rand(-height/2:height/2), rand(0.25:0.1:0.75)) : placeimage(img, Point(rand(-width/2:width/2), rand(-height/2:height/2)), rand(0.25:0.1:0.75))
    end
    @test finish() == true
end

fname = "images-with-alpha.pdf"
alphaimages(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random

using Colors

Random.seed!(42)

function background_text(str_array)
    colorband = diverging_palette(0, 10, 100)
    gsave()
    setopacity(0.5)
    x = -currentwidth / 2
    y = -currentheight / 2
    fontsize(12)
    while y < currentheight / 2
        sethue(colorband[rand(1:end)])
        s = str_array[rand(1:end)]
        text(s, x, y)
        se = textextents(s)
        x += se[5] # move to the right
        if x > currentwidth / 2
            x = -currentwidth / 2 # next row
            y += 10
        end
    end
    grestore()
end

function heart()
    move(127, 1) # damn, it's offset from 0/0, who drew this :/
    curve(134.2, -6.5, 134.2, -6.5, 156.1, -29.6)
    curve(185.8, -60.5, 198.1, -74.3, 213.7, -95.3)
    curve(240.4, -131, 253.3, -163.7, 253.3, -194.9)
    curve(253.3, -218, 246.4, -237.8, 232.6, -253.7)
    curve(219.1, -268.7, 204.1, -275.3, 181.9, -275.3)
    curve(154, -275.3, 136.3, -265.1, 127, -243.8)
    curve(124, -252.5, 120.4, -257.6, 112.9, -263.6)
    curve(103.6, -270.8, 88.3, -275.3, 73.3, -275.3)
    curve(59.2, -275.3, 46, -271.4, 35.2, -264.5)
    curve(14.5, -250.7, 1, -223.4, 1, -194.6)
    curve(1, -167.3, 13, -136.4, 37.3, -101)
    curve(53.8, -77, 86.5, -39.8, 127, 1)
    closepath()
end

function heart_with_julias(x = 0, y = 0)
    gsave()
    translate(x, y)
    setcolor("lavenderblush")
    heart()
    fillpreserve()
    clip()
    translate(-50, -300)
    for y in 0:30:500
        gsave()
        for x in 0:30:250
            translate(30, 0)
            gsave()
            scale(0.1, 0.1)
            julialogo()
            grestore()
        end
        grestore()
        translate(0, 20)
    end
    clipreset()
    grestore()
end

function outlined_heart()
    gsave()
    scale(1.2, 1.2)
    translate(-127, -30) # must fix that x-offset one day
    heart_with_julias()
    heart()
    setline(4)
    setcolor(1, 0, 0)
    strokepath()
    grestore()
end

function julia_heart(fname)
    global currentwidth = 1928 # pts
    global currentheight = 1064 # pts
    Drawing(currentwidth, currentheight, fname)

    origin()
    background("black")
    namelist = map(x -> string(x), names(Base)) # list of names in Base.

    background_text(namelist)
    for n in 1:5
        rotate(2pi / 5)
        outlined_heart()
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

julia_heart("heart-julia.pdf")

using Pkg
Pkg.add("PkgBenchmark")
using PkgBenchmark

import Luxor
benchmarkpkg("Luxor")


#=

shell> cd benchmark
(@v1.9) pkg> activate .
  Activating project at `~/.julia/dev/Luxor/benchmark`
julia-1.9> include("run-pkgbenchmark.jl")

=#

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function annotatedash(pos, dashes, offset)
    @layer  begin
        translate(pos)
        @layer begin
            translate(0, 15)
            fontsize(3)
            sethue("black")
            x = 0
            for n in dashes
                text(string(n), O + (-offset + x + n/2, 0), halign=:center)
                x += n
            end
            fontsize(6)
            text("offset $offset", O + (-10, -10), halign=:right)
        end
        @layer begin
            translate(0, 2.5)
            setdash(dashes, offset)
            setline(0.5)
            sethue("grey60")
            line(O + (0, 6), O +  (3 * sum(dashes), 6), :stroke)
            sethue("red")
            setline(5)
            setdash(dashes, offset)
            line(O, O + (3 * sum(dashes), 0), :stroke)
        end
    end
end

function dash_tests(fname)
    pagewidth, pageheight = 800, 600
    Drawing(pagewidth, pageheight, fname)
    origin()
    background("ivory")
    setline(3)
    dashes = [30.0,  # ink
        10.0,  # skip
        5.0,  # ink
        15.0,  # skip
        20.0,  # ink
        4. # skip
        ]
    offset = -50.0
    sethue("black")
    text("Pattern is $(dashes)", boxtopcenter(BoundingBox() * 0.9),     halign=:center)
    sethue("blue")
    for y in -pageheight/2 + 50:30:pageheight/2 - 50
        randomhue()
        annotatedash(O + (-200, y), dashes, offset)
        offset += 10
    end
    @test finish() == true
end

fname = "dash-tests.svg"
dash_tests(fname)
println("...finished dash tests: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

fname = "sector-test.pdf"
Drawing(1500, 1500, fname) # points/pixels, 2000 points is 70.56cm × 70.56cm

setline(1)
setopacity(0.8)
origin()
background("black")

# Test endangle < angle
randomhue()
sector(O, 0, 20, pi/12, 0, :fill)
sethue("black")
sector(0, 20, pi/12, 0, :stroke)

# normal
for inner in 0:20:600
    for a in 0:pi/12:2pi
        randomhue()
        sector(O, inner, inner + 20, a, a + pi/12, :fill)
        sethue("black")
        sector(inner, inner + 20, a, a + pi/12, :stroke)
    end
end

# rounded
setopacity(0.75)
for i in 1:10
    gsave()
    translate(rand(-500:500), rand(-500:500))
    for inner in 90:30:210
        for a in 0:pi/12:2pi
            randomhue()
            sector(O, inner, inner + 20, a, a + pi/12, 15, :fill)
            sethue("black")
            sector(inner, inner + 20, a, a + pi/12, 10, :stroke)
        end
    end
    grestore()
end

@test finish() == true
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function testtable(fname)
    currentwidth = 800
    currentheight = 800
    Drawing(currentwidth, currentheight, fname)
    origin()
    background("white")
    setline(0.5)

    # test single cell tables
    t = Table(1, 1, 0, 0)
    for n in t
        pt = n[1]
        i = n[2]
    end

    t = Table(
        collect(range(30, stop=85, length=10)),
        collect(range(20, stop=75, length=10)))
    for n in t
        pt = n[1]
        i = n[2]
    end

    sethue("red")
    circle.(t[:, 3], 10, :fill)
    sethue("blue")
    circle.(t[3, :], 9, :fill)
    sethue("green")
    circle(t[4, 5], 8, :fill)

    for n in 1:20
        randomhue()
        circle.(t[rand(1:10), :], 7, :fill)
    end
    for n in 1:30
        randomhue()
        circle.(t[:, rand(1:10)], 6, :fill)
    end
    setline(2)
    highlightcells(t, 1:3:length(t), offset=2)

    sethue("black")
    fontsize(10)
    for (pt, n) in t
        label(string(n), :n, t[n], offset=15)
    end

    @test finish() == true
end

fname = "table.png"
testtable(fname)
println("table test: output in $(fname)")
println("...finished table tests: output in $(fname)")

using Luxor, Random, Test

function test_tangents(fname)
    Drawing(500, 500, fname)
    background("white")
    origin()
    setline(0.5)
    sethue("black")
    for i in 1:30
        circlecenter = polar(rand(100:190), 2π * i/30)
        circleradius = rand(4:10)
        point = polar(rand(170:240), 2π * i/20)
        circle(circlecenter, 2, :fill)
        circle(point, 2, :fill)
        circle(circlecenter, circleradius, :fill)
        pt1, pt2 = pointcircletangent(point, circlecenter, circleradius)
        if pt1 != pt2
            line(point, pt1, :stroke)
            line(point, pt2, :stroke)
        end
    end
    @test finish() == true
end

fname = "point-circle-tangent.png"
test_tangents(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia
using Luxor
using Test
using Colors

function grid_test(fname)
    println("a")
    Drawing("A1landscape", fname)
    origin()
    background("white")

    panes = Tiler(Luxor._current_width(), Luxor._current_height(), 1, 2)
    @layer begin
        translate(first(panes[1]))
        circle(O, 10, :fill)
        fontsize(14)
        setline(0.2)
        rulers()
        side = 100
        grid = GridRect(O - (400, 500), side, side, 1000, 1600)
        for p in 1:121
            randomhue()
            # rectangular
            pt = nextgridpoint(grid)
            box(pt, side, side, :fill)
            sethue("white")
            text(string(p, ":", grid.rownumber, ":", grid.colnumber), pt, halign = :center, valign = :middle)
        end
    end

    @layer begin
        translate(first(panes[2]))
        for q in -5:5 # vertical
            for r in -5:5 # horizontal
                pgon = hextile(HexagonOffsetEvenR(q, r, 60))
                sethue(HSB(rand(1:360), 0.6, 0.7))
                poly(pgon, :fill)
                sethue("white")
                text("$q", hexcenter(HexagonOffsetEvenR(q, r, 60)),
                    halign = :left, valign = :top)
                text("$r", hexcenter(HexagonOffsetEvenR(q, r, 60)),
                    halign = :right, valign = :bottom)
            end
        end
        rulers()
    end
    @layer begin
        translate(first(panes[2]))
        sethue("red")
        for q in -5:5 # vertical
            for r in -5:5 # horizontal
                h = HexagonOffsetOddR(q, r, 60)
                circle(hexcenter(h), 15, :fill)
            end
        end
        rulers()
    end

    @layer begin
        h = HexagonOffsetEvenR(0, 0)
        sethue("white")
        poly.(hextile.(hexspiral(h, 10)), :stroke, close = true)
    end
    @test finish() == true
end

fname = "grid-test.png"
grid_test(fname)
println("...finished test: output in $(fname)")

#=

Base.convert() methods to convert shapefile geometry to Luxor geometry.

Use `include()` to include this file if you've installed Shapefile.jl.

Luxor y coordinates increase downwards, but maps and shapefile coordinates increase upwards.
In the Northern hemisphere, 0 longitude is North Pole, so we negate y coordinates.

```julia
using Luxor, Shapefile
worldshapefile = "TM_WORLD_BORDERS-0.3/TM_WORLD_BORDERS-0.3.shp"
include(splitdir(pathof(Luxor))[1] * "/readshapefiles.jl")
table = Shapefile.Table(worldshapefile)
geoms = Shapefile.shapes(table)
# set up Luxor drawing, then:
for shape in geoms
    pgons, bbox = convert(Vector{Luxor.Point}, shape)
    for pg in pgons
        setgray(rand(0.5:0.1:0.8))
        poly(pg, :fill)
    end
end
# tidy up
```

=#

# Convert a Shapefile rectangle to an array of points suitable for a Luxor rectangle
function Base.convert(::Type{Vector{Luxor.Point}}, R::Shapefile.Rect)
    return [R.left, R.top, R.right-R.left, R.bottom-R.top]
end

# Convert a Shapefile Point to a Luxor Point (flipping y-coordinates)
function  Base.convert(::Type{Luxor.Point}, pt::Shapefile.Point)
    return Luxor.Point(pt.x, -pt.y)
end

# Convert Shapefile PolyLine to a Luxor poly
function Base.convert(::Type{Vector{Luxor.Point}}, pl::Shapefile.Polyline)
    resultbbox = convert(Vector{Luxor.Point}, pl.MBR)
    resultpoly = Luxor.Point[]
    for pt in pl.points
        push!(resultpoly, convert(Luxor.Point, pt))
    end
    return resultbbox, resultpoly
end

# Convert Shapefile Polygon to a Luxor poly.
# some Shapefile polygons have multiple parts, but these aren't subpaths, just
# extra polygons. For example, France (in Europe) and French Guiana in (South America)
# belong to the same Shapefile.Polygon and the return value will include these and other
# polygons in the array.

function Base.convert(::Type{Vector{Luxor.Point}}, pl::Shapefile.Polygon)
    bbox = [Luxor.Point(pl.MBR.left, -pl.MBR.top), pl.MBR.right - pl.MBR.left, pl.MBR.top - pl.MBR.bottom]
    polygons = Vector{Point}[] # to hold all the polygons for a shape
    if length(pl.parts) >= 2
        points = Luxor.Point[]
        for i in 1:length(pl.parts) - 1
            subpolygonpoints = pl.points[pl.parts[i]+1: pl.parts[i + 1]]
            for pt in subpolygonpoints
                push!(points, convert(Luxor.Point, pt))
            end
            push!(polygons, points)
            points = Luxor.Point[]
        end
        # don't forget the rest
        subpolygonpoints = pl.points[pl.parts[end] + 1: end]
        for pt in subpolygonpoints
            push!(points, convert(Luxor.Point, pt))
        end
        push!(polygons, points)
    else
        points = Luxor.Point[]
        for pt in pl.points
            push!(points, convert(Luxor.Point, pt))
        end
        push!(polygons, points)
    end
    return polygons, bbox
end

using Luxor, Random, Colors

Random.seed!(42)

using Test

function test_arc_sagitta(fname)
    Drawing("A4", fname)
    origin()
    background(Colors.RGB(1, 1, 1))
    setopacity(0.6)

    translate(0, -150)
    p1 = O - (150, 0)
    p2 = O + (150, 0)
    @test_throws ErrorException arc2sagitta(p1, p2, 0)
    @test_throws ErrorException carc2sagitta(p1, p2, 0)

    sethue("red")
    for s in 1:4:150
        @test isarcclockwise(O, p1, p2) == false
        cp, r = arc2sagitta(p1, p2, s, :stroke)
        @test r >= 150
    end
    sethue("green")
    for s in 1:4:150
        cp, r = carc2sagitta(p1, p2, s, :stroke)
        @test r >= 150
    end

    translate(0, 300)

    p1 = O - (0, 150)
    p2 = O + (0, 150)
    @test_throws ErrorException arc2sagitta(p1, p2, 0)
    @test_throws ErrorException carc2sagitta(p1, p2, 0)

    sethue("red")
    for s in 1:4:150
        # the arc is neither clockwise or counterclockwise
        # because points are collinear!
        @test isarcclockwise(O, p2, p1) == false
        @test isarcclockwise(O, p1, p2) == false
        cp, r = arc2sagitta(p1, p2, s, :stroke)
        @test r >= 150
    end
    sethue("green")
    for s in 1:4:150
        cp, r = carc2sagitta(p1, p2, s, :stroke)
        @test r >= 150
    end

    @test finish() == true
end

fname = "arc-sagitta.png"
test_arc_sagitta(fname)
println("...finished arc_sagitta test: output in $(fname)")

"""
    arrowhead(target[, action=:fill];
        shaftangle=0,
        headlength=10,
        headangle=pi/8)

Draw an arrow head. The arrowhead length will be the length of the side of
the arrow's head, and the arrowhead angle is the angle between the sloping
side of the arrowhead and the arrow's shaft.

This doesn't use the current linewidth setting (`setline()`), and defaults to 1,
but you can specify another value.
"""
function arrowhead(target, action=:fill;
        shaftangle=0, headlength=10, headangle=pi/8)
    gsave()
    topangle = shaftangle + headangle
    botangle = shaftangle - headangle

    topx = target.x + cos(topangle) * headlength
    topy = target.y + sin(topangle) * headlength
    botx = target.x + cos(botangle) * headlength
    boty = target.y + sin(botangle) * headlength
    poly([Point(topx, topy), target, Point(botx, boty)], action)
    grestore()
end

"""
    arrow(startpoint::Point, endpoint::Point;
        linewidth         = 1.0,
        arrowheadlength   = 10,
        arrowheadangle    = pi/8,
        decoration        = 0.5 or range(),
        decorate          = nothing,
        arrowheadfunction = nothing)

Draw a line between two points and add an arrowhead at the
end. The arrowhead length will be the length of the side of
the arrow's head, and the arrowhead angle is the angle
between the sloping side of the arrowhead and the arrow's
shaft.

Arrows don't use the current linewidth setting
(`setline()`), and defaults to 1, but you can specify
another value. It doesn't need stroking/filling, the shaft
is stroked and the head filled with the current color.

### Decoration

The `decorate` keyword argument accepts a function with zero
arguments that can execute code at one or more locations on
the arrow's shaft. The inherited graphic environment is
centered at each point on the shaft between 0 and 1 given by
scalar or vector `decoration`, and the x-axis is aligned
with the direction of the curve at that point.

### Arrowheads

A triangular arrowhead is drawn by default. But you can pass
a function to the `arrowheadfunction` keyword argument that
accepts three arguments: the shaft end, the arrow head end,
and the shaft angle. Thsi allows you to draw any shape
arrowhead.

### Example

```julia
function redbluearrow(shaftendpoint, endpoint, shaftangle)
    @layer begin
        sethue("red")
        sidept1 = shaftendpoint  + polar(10, shaftangle + π/2 )
        sidept2 = shaftendpoint  - polar(10, shaftangle + π/2)
        poly([sidept1, endpoint, sidept2], :fill)
        sethue("blue")
        poly([sidept1, endpoint, sidept2], :stroke, close=false)
    end
end

@drawsvg begin
    background("white")
    arrow(O, O + (120, 120),
        linewidth=4,
        arrowheadlength=40,
        arrowheadangle=π/7,
        arrowheadfunction = redbluearrow)

    arrow(O, 100, 3π/2, π,
        linewidth=4,
        arrowheadlength=20,
        clockwise=false,arrowheadfunction=redbluearrow)
end 800 250
```

"""
function arrow(startpoint::Point, endpoint::Point;
        linewidth         = 1.0,
        arrowheadlength   = 10,
        arrowheadangle    = pi/8,
        decoration        = 0.5,
        decorate          = nothing,
        arrowheadfunction = nothing)

    gsave()
    setlinejoin("butt")
    setline(linewidth)

    isapprox(startpoint, endpoint) && throw(error("can't draw arrow between two identical points"))
    shaftlength = distance(startpoint, endpoint)
    shaftangle = atan(startpoint.y - endpoint.y, startpoint.x - endpoint.x)
    arrowheadtopsideangle = shaftangle + arrowheadangle
    # shorten the length so that lines
    # stop before we get to the arrow
    # thus wide shafts won't stick out through the head of the arrow.
    max_undershoot = shaftlength - ((linewidth/2) / tan(arrowheadangle))
    true_arrowheadlength = arrowheadlength * cos(arrowheadangle)
    if true_arrowheadlength < max_undershoot
        ratio = (shaftlength - true_arrowheadlength)/shaftlength
    else
        ratio = max_undershoot/shaftlength
    end
    tox = startpoint.x + (endpoint.x - startpoint.x) * ratio
    toy = startpoint.y + (endpoint.y - startpoint.y) * ratio
    fromx = startpoint.x
    fromy = startpoint.y

    # draw the shaft of the arrow
    newpath()
    line(Point(fromx, fromy), Point(tox, toy), :stroke)

    toppoint = Point(endpoint.x + cos(arrowheadtopsideangle) * arrowheadlength,
                     endpoint.y + sin(arrowheadtopsideangle) * arrowheadlength)

    arrowheadbottomsideangle = shaftangle - arrowheadangle

    bottompoint = Point(endpoint.x + cos(arrowheadbottomsideangle) * arrowheadlength,
                        endpoint.y + sin(arrowheadbottomsideangle) * arrowheadlength)

    #  use a user-supplied arrowhead function?
    if arrowheadfunction === nothing
        poly([toppoint, endpoint, bottompoint], :fill)
    else
        # shaft end, head end, angle
        arrowheadfunction(Point(tox, toy), endpoint, slope(startpoint, endpoint))
    end

    # prepare to add decorations at point along shaft
    if decorate === nothing
    else
        for decpos in decoration
            decpoint = between(startpoint, endpoint, decpos)
            # slope at this point
            slp = slope(startpoint, endpoint)
            @layer begin
                translate(decpoint)
                rotate(slp)
                decorate()
            end
        end
    end
    grestore()
end

"""
    arrow(centerpos::Point, radius, startangle, endangle;
        linewidth          = 1.0,
        arrowheadlength    = 10,
        arrowheadangle     = π/8,
        decoration         = 0.5,
        decorate           = nothing,
        arrowheadfunction  = nothing,
        clockwise          = true)

Draw a curved arrow, an arc centered at `centerpos` starting
at `startangle` and ending at `endangle` with an arrowhead
at the end. Angles are measured clockwise from the positive
x-axis.

Arrows don't use the current linewidth setting
(`setline()`); you can specify the linewidth.

The `decorate` keyword argument accepts a zero-argument
function that can execute code at one or more locations on
the arrow's shaft. The inherited graphic environment is
centered at points on the shaft between 0 and 1 given by
scalar or vector `decoration`, and the x-axis is aligned
with the direction of the curve at that point.

A triangular arrowhead is drawn by default. But you can pass
a function to the `arrowheadfunction` keyword argument that
accepts three arguments: the shaft end, the arrow head end,
and the shaft angle. Thsi allows you to draw any shape
arrowhead.
"""
function arrow(centerpos::Point, radius, startangle, endangle;
    linewidth          = 1.0,
    arrowheadlength    = 10,
    arrowheadangle     = π/8,
    decoration         = 0.5,
    decorate           = nothing,
    arrowheadfunction  = nothing,
    clockwise          = true)

    # don't bother with them if theyre too small
    if isapprox(startangle, endangle, rtol = 0.01)
        return
    end
    # circular arcs needs swapping to avoid Cairo crash
    if isapprox(startangle - endangle, 2π, rtol = 0.01)
        startangle, endangle = endangle, startangle
    end

    gsave()
    setlinejoin("butt")
    setline(linewidth)
    translate(centerpos)
    θ = mod2pi((2π + endangle) - startangle)
    if clockwise != true
        θ = 2π  - θ
    end
    arclength = radius * θ
    startpoint = Point(radius * cos(startangle), radius * sin(startangle))
    endpoint   = Point(radius * cos(endangle),   radius * sin(endangle))

    # shorten the length so that lines stop before we get to the arrow
    # thus wide shafts won't stick out through the head of the arrow.

    max_undershoot = arclength - ((linewidth/2) / tan(arrowheadangle))
    true_arrowheadlength = arrowheadlength * cos(arrowheadangle)
    if true_arrowheadlength < max_undershoot
        ratio = (arclength - true_arrowheadlength)/arclength
    else
        ratio = max_undershoot/arclength
    end

    # draw the arrow shaft
    newpath()
    move(radius * cos(startangle), radius * sin(startangle))
    newarclength = arclength * ratio
    if clockwise == true
        newendangle = startangle + (newarclength/radius)
        arc(O, radius, startangle, newendangle, :stroke)
    else
        newendangle = startangle - (newarclength/radius)
        carc(O, radius, startangle, newendangle, :stroke)
    end
    closepath()

    # draw the arrowhead
    newendpoint = Point(radius * cos(newendangle), radius * sin(newendangle))
    shaftangle = slope(newendpoint, endpoint)
    #  use a user-supplied arrowhead function?
    if arrowheadfunction === nothing
        arrowheadoutersideangle = shaftangle + pi - arrowheadangle
        arrowheadinnersideangle = shaftangle + pi + arrowheadangle
        toppoint    = Point(endpoint.x + cos(arrowheadinnersideangle) * arrowheadlength,
                            endpoint.y + sin(arrowheadinnersideangle) * arrowheadlength)
        bottompoint = Point(endpoint.x + cos(arrowheadoutersideangle) * arrowheadlength,
                            endpoint.y + sin(arrowheadoutersideangle) * arrowheadlength)
        poly([toppoint, endpoint, bottompoint], :fill)
    else
        # shaft end, head end, angle
        arrowheadfunction(newendpoint, endpoint, shaftangle)
    end

    # use-suppplied shaft decoration function?
    if decorate === nothing
    else
        gsave()
        for decpos in decoration
            decorationangle = rescale(decpos, 0, 1, startangle, newendangle)
            decorationpoint = Point(radius * cos(decorationangle), radius * sin(decorationangle))
            ptangle = atan(decorationpoint.y, decorationpoint.x)
            @layer begin
                translate(decorationpoint)
                rotate(π/2 + ptangle)
                decorate()
            end
        end
        grestore()
    end
    grestore()
end

"""
    arrow(start::Point, C1::Point, C2::Point, finish::Point, action=:stroke;
        linewidth       = 1.0,
        arrowheadlength = 10,
        arrowheadangle  = pi/8,
        startarrow      = false,
        finisharrow     = true,
        decoration      = 0.5,
        decorate        = nothing
        arrowheadfunction = nothing)

Draw a Bezier curved arrow, from `start` to `finish`, with
control points `C1` and `C2`. Arrow heads can be
added/hidden by changing `startarrow` and `finisharrow`
options.

The `decorate` keyword argument accepts a function that can
execute code at one or more locations on the arrow's shaft.
The inherited graphic environment is centered at each point
on the shaft given by scalar or vector `decoration`, and the
x-axis is aligned with the direction of the curve at that
point.

### Example

This code draws an arrow head that's filled with orange and outlined in green.

```julia
function myarrowheadfunction(originalendpoint, newendpoint, shaftangle)
    @layer begin
        setline(5)
        translate(newendpoint)
        rotate(shaftangle)
        sethue("orange")
        ngon(O, 20, 3, 0, :fill)
        sethue("green")
        ngon(O, 20, 3, 0, :stroke)
    end
end

@drawsvg begin
    background("white")
    arrow(O, 220, 0, π,
        linewidth=10,
        arrowheadlength=30,
        arrowheadangle=π/7,
        clockwise=true,
        arrowheadfunction = myarrowheadfunction)
end
```
"""
function arrow(start::Point, C1::Point, C2::Point, finish::Point, action=:stroke;
        # optional
        linewidth         = 1.0,
        arrowheadlength   = 10,
        arrowheadangle    = π/8,
        arrowheadfill     = true,
        startarrow        = false,
        finisharrow       = true,
        decoration        = 0.5,
        decorate          = nothing,
        arrowheadfunction = nothing)
    @layer begin
        setline(linewidth)
        # TODO rewrite all this?
        # arrow heads are a pain :)
        # we're going to shorten the segment so that the
        # ends hits the base of the arrowhead and doesn't
        # stick out the top. This method is brute force and
        # inefficient!
        # suggestions for alternatives welcome
        _startfrac = 0.0
        _endfrac = 1.0
        if startarrow && arrowheadfill
             true_arrowheadlength = arrowheadlength * cos(arrowheadangle)
             for i in 0:0.01:1
                 if distance(bezier(i, start, C1, C2, finish), start) > true_arrowheadlength
                     _startfrac = i
                     break
                 end
             end
             # the 0.01 adds a bit of overlap :)
             actualcurvestart = bezier(_startfrac - 0.01, start, C1, C2, finish)
         else
             actualcurvestart = start
         end

         if finisharrow && arrowheadfill
             # calculate the shorter version
             # brute force as above
             true_arrowheadlength = arrowheadlength * cos(arrowheadangle)
             for i in 1:-0.01:0.0
                 if distance(bezier(i, start, C1, C2, finish), finish) > true_arrowheadlength
                     _endfrac = i + 0.01 # use previous
                     break
                 end
             end
             actualcurvefinish = bezier(_endfrac, start, C1, C2, finish)
         else
             actualcurvefinish = finish
         end

         # finally draw Bezier starting at _startfrac and ending at _endfrac
        move(actualcurvestart)
        newcurve = trimbezier(BezierPathSegment(start, C1, C2, finish), _startfrac, _endfrac)
        curve(newcurve.cp1, newcurve.cp2, newcurve.p2) # in Cairo form finally
        do_action(action)

        start_shaftangle  = slope(start, C1)
        finish_shaftangle = slope(C2, finish)

        if arrowheadfunction === nothing
            finisharrow && arrowhead(finish, arrowheadfill == true ? :fill : :stroke, headlength = arrowheadlength, headangle = arrowheadangle, shaftangle = π + finish_shaftangle)
            startarrow && arrowhead(start, arrowheadfill == true ? :fill : :stroke, headlength = arrowheadlength, headangle = arrowheadangle,   shaftangle = start_shaftangle)
        else
            # shaftangle starts at end and continues outwards
            finisharrow && arrowheadfunction(actualcurvefinish, finish, finish_shaftangle)
            startarrow && arrowheadfunction(actualcurvestart, start, start_shaftangle)
        end

        # prepare to add decorations at points along shaft
        if decorate === nothing
        else
            for decpos in decoration
                decpoint = bezier(decpos, start, C1, C2, finish)
                bp = bezier′(decpos, start, C1, C2, finish)
                slp = atan(bp.y, bp.x)
                @layer begin
                    translate(decpoint)
                    rotate(slp)
                    decorate()
                end
            end
        end
    end # layer
end

"""
    arrow(start::Point, finish::Point, height::Vector, action=:stroke;
        keyword arguments...)

Draw a Bézier arrow between `start` and `finish`, with control points
defined to fit in an imaginary box defined by the two supplied `height`
values (see `bezierfrompoints()`). If the height values are different signs,
the arrow will change direction on its way.

Keyword arguments are the same as [`arrow(pt1, pt2, pt3, pt4)`](@ref).

### Example

```julia
arrow(pts[1], pts[end], [15, 15],
    decoration = 0.5,
    decorate = () -> text(string(pts[1])))
```

"""
function arrow(start::Point, finish::Point, height::Vector, action=:stroke;
        # optional kwargs
        linewidth=1.0,
        arrowheadlength=10,
        arrowheadangle=pi/8,
        arrowheadfill=true,
        startarrow=false,
        finisharrow=true,
        decoration = 0.5,
        decorate = nothing,
        arrowheadfunction = nothing)

    @layer begin
        s = slope(start, finish)
        perp1 = start +  polar(height[1], s - π/2)
        perp2 = finish + polar(height[2], s - π/2)
    end

    cpt1 = between(perp1, perp2, 0.33)
    cpt2 = between(perp1, perp2, 0.66)
    pts = bezierfrompoints([start,
        cpt1,
        cpt2,
        finish])

    # i've forgotten how to do this better...
    arrow(pts[1], pts[2], pts[3], pts[4], action,
        linewidth=linewidth,
        arrowheadlength=arrowheadlength,
        arrowheadangle=arrowheadangle,
        arrowheadfill=arrowheadfill,
        startarrow=startarrow,
        finisharrow=finisharrow,
        decoration = decoration,
        decorate = decorate,
        arrowheadfunction = arrowheadfunction)
end

"""
    dimension(p1::Point, p2::Point;
        format::Function   = (d) -> string(d), # process the measured value into a string
        offset             = 0.0,              # left/right, parallel with x axis
        fromextension      = (10.0, 10.0),     # length of extensions lines left and right
        toextension        = (10.0, 10.0),     #
        textverticaloffset = 0.0,              # range 1.0 (top) to -1.0 (bottom)
        texthorizontaloffset = 0.0,            # range 1.0 (top) to -1.0 (bottom)
        textgap            = 5,                # gap between start of each arrow (≈ fontsize?)
        textrotation       = 0.0,
        arrowlinewidth     = 1.0,
        arrowheadlength    = 10,
        arrowheadangle     = π/8)

Calculate and draw dimensioning graphics for the distance between `p1` and `p2`.
The value can be formatted with function `format`.

`p1` is the lower on the page (ie probably the higher y value) point, `p2` is
the higher on the page (ie probably lower y) point.

`offset` is to the left (-x) when negative.

Dimension graphics will be rotated to align with a line between `p1` and `p2`.

In `textverticaloffset`, "vertical" and "horizontal" are best understood by
"looking" along the line from the first point to the second.
`textverticaloffset` ranges from -1 to 1, `texthorizontaloffset` in default units.

```
        toextension
        [5  ,  5]
       <---> <--->
                             to
       -----------            +
            ^
            |

           -50

            |
            v
       ----------            +
                            from
       <---> <--->
         [5 , 5]
       fromextension

            <---------------->
                  offset
```

Returns the measured distance and the text.
"""
function dimension(p1::Point, p2::Point;
    format::Function   = (d) -> string(d), # process the measured value into a string
    offset             = 0.0,              # left/right, parallel with x axis
    fromextension      = (10.0, 10.0),     # length of extensions lines left and right
    toextension        = (10.0, 10.0),     #
    textverticaloffset = 0.0,              # range 1.0 (top) to -1.0 (bottom)
    texthorizontaloffset = 0.0,            #
    textgap            = 5,                # gap between start of each arrow (≈ fontsize?)
    textrotation       = 0.0,
    arrowlinewidth     = 1.0,
    arrowheadlength    = 10,
    arrowheadangle     = π/8)

    p1 == p2 && throw(error("dimension(): the two points are the same, can't draw dimensions"))
    d     = distance(p1, p2)
    midpt = midpoint(p1, p2)
    s     = slope(p1, p2)
    t     = format(d)
    @layer begin
        o = perpendicular(midpt, p2, offset)
        translate(o)
        rotate(π/2 + s)

        line(Point(-fromextension[1], d/2), Point(fromextension[2], d/2), :stroke)
        line(Point(-toextension[1], -d/2), Point(toextension[2], -d/2), :stroke)

        # top (lower y)
        apos = O + (0, -textgap - rescale(textverticaloffset, 0, 1, 0, d/2))
        arrow(apos, Point(0, -d/2), linewidth = arrowlinewidth, arrowheadlength = arrowheadlength, arrowheadangle = arrowheadangle)

        # bottom (higher y)
        bpos = O + (0, textgap + rescale(-textverticaloffset, 0, 1, 0, d/2))
        arrow(bpos, Point(0, d/2), linewidth = arrowlinewidth, arrowheadlength = arrowheadlength, arrowheadangle = arrowheadangle)

        te = textextents(t)
        tpos = O + (texthorizontaloffset, -textverticaloffset * d/2)
        @layer begin
            translate(tpos)
            rotate(textrotation)
            text(t, halign=:center, valign=:middle)
        end
    end
    return (d, t)
end

"""
    tickline(startpos, finishpos;
        startnumber         = 0,
        finishnumber        = 1,
        major               = 1,
        minor               = 0,
        major_tick_function = nothing,
        minor_tick_function = nothing,
        rounding            = 2,
        axis                = true, # draw the line?
        log                 = false,
        vertices            = false # just return the points
        )

Draw a line with ticks. `major` is the number of ticks
required between the start and finish point. So `1` divides
the line in half. `minor` is the number of ticks between
each major tick.

## Examples

```julia
tickline(Point(0, 0), Point(100, 0))
tickline(Point(0, 0), Point(100, 0), major = 4)
majorticks, minorticks = tickline(Point(0, 0), Point(100, 0), axis=false)
```

## Custom ticks

Supply functions to make custom ticks. Custom tick functions
should have arguments as follows:

```julia
function mtick(n, pos;
        startnumber         = 0,
        finishnumber        = 1,
        nticks = 1)
        ...
```
and

```julia
function mntick(n, pos;
        startnumber        = 0,
        finishnumber       = 1,
        nticks             = 1,
        majorticklocations = [])
        ...
```

For example:

```julia
tickline(O - (300, 0), Point(300, 0),
    startnumber  = -10,
    finishnumber = 10,
    minor        = 0,
    major        = 4,
    axis         = false,
    major_tick_function = (n, pos;
        startnumber=30, finishnumber=40, nticks=10) -> begin
        @layer begin
            translate(pos)
            ticklength = get_fontsize()
            line(O, O + polar(ticklength, 3π/2), :stroke)
            k = rescale(n, 0, nticks - 1, startnumber, finishnumber)
            ticklength = get_fontsize() * 1.3
            text("\$(round(k, digits=2))",
                O + (0, ticklength),
                halign=:center,
                valign=:middle,
                angle = -getrotation())
        end
    end)
```
"""
function tickline(startpos, finishpos;
        startnumber         = 0,
        finishnumber        = 1,
        major               = 1,
        minor               = 0,
        major_tick_function = nothing,
        minor_tick_function = nothing,
        rounding            = 2,
        axis                = true,
        log                 = false,
        vertices            = false)

    # this function is too long
    # the default function to draw major ticks
    function _maj_func(n, pos;
        startnumber         = 0,
        finishnumber        = 1,
        nticks = 1)
        @layer begin
            translate(pos)
            ticklength = get_fontsize() * 2
            line(O, O + polar(ticklength, π/2), :stroke)
            k = rescale(n, 0, nticks - 1, startnumber, finishnumber)
            text("$(round(k, digits=rounding))",
                O + (0, ticklength * 1.3),
                halign=:center,
                valign=:top,
                angle = -getrotation())
        end
    end
    # default to draw minor ticks
    function _min_func(n, pos;
        startnumber        = 0,
        finishnumber       = 1,
        nticks             = 1,
        majorticklocations = Point[])
        @layer begin
            translate(pos)
            ticklength = get_fontsize()
            line(O, O + polar(ticklength, π/2), :stroke)
            k = rescale(n, 0, nticks - 1, startnumber, finishnumber)

            # if there's a major tick here, skip
            if pos ∈ majorticklocations

            else
                text("$(round(k, digits=rounding))",
                    O + (0, ticklength * 1.3),
                    halign=:center,
                    valign=:top,
                    angle=-getrotation())
            end
        end
    end

    if startnumber == finishnumber
        throw(error("tickline(): start and finish numbers should be different"))
    end

    @layer begin
        translate(startpos)
        rotate(slope(startpos, finishpos))
        newfinishpos =  O + polar(distance(startpos, finishpos), 0)

        # draw the axis
        if axis == true && vertices == false
            line(O, newfinishpos, :stroke)
        end

        # 1 major/minor division means 3 ticks (beginning, middle, end)

        if log == true
            majorticklocations = between.(O, newfinishpos, log10.(range(1, 10, length=(major+2))))
            n_minorticks = ((major + 1) * (minor + 1)) + 1
            minorticklocations = between.(O, newfinishpos, log10.(range(1, 10, length=n_minorticks)))
        else
            majorticklocations = between.(O, newfinishpos, range(0, 1, length=(major+2)))
            n_minorticks = ((major + 1) * (minor + 1)) + 1
            minorticklocations = between.(O, newfinishpos, range(0, 1, length=n_minorticks))
        end
        if vertices == true
        else
            # draw the ticks using the supplied functions, or the default ones
            if major > 0
                for (n, majorticklocation) in enumerate(majorticklocations)
                    if major_tick_function === nothing
                        _maj_func(n - 1, majorticklocation,
                            startnumber  = startnumber,
                            finishnumber = finishnumber,
                            nticks       = length(majorticklocations))
                    else
                        # start counting at 0, remember :)
                        major_tick_function(n - 1, majorticklocation,
                            startnumber  = startnumber,
                            finishnumber = finishnumber,
                            nticks       = length(majorticklocations))
                    end
                end
            end

            if minor >= 1
                for (n, minorticklocation) in enumerate(minorticklocations)
                    if minor_tick_function === nothing
                        _min_func(n - 1, minorticklocation,
                            startnumber  = startnumber,
                            finishnumber = finishnumber,
                            nticks = length(minorticklocations),
                            majorticklocations = majorticklocations)
                    else
                        # start counting at 0!
                        minor_tick_function(n - 1, minorticklocation,
                            startnumber  = startnumber,
                            finishnumber = finishnumber,
                            nticks = length(minorticklocations),
                            majorticklocations = majorticklocations)
                    end
                end
            end # minor
        end # vertices = true
    end # layer
    # calculate where the tick locations would be in reality
    shifter(pt) = rotatepoint(Point(startpos.x + pt.x, startpos.y + pt.y), startpos, slope(startpos, finishpos))
    majpts = map(shifter, majorticklocations)
    minpts = map(shifter, minorticklocations)
    return (majpts, minpts)
end

using Luxor, Test, Colors

function strokescale()
    Drawing(10, 10, :png, strokescale = true)
    @test getline() == 2 # default linewidth is 2.0    

    # was the scale set correctly when the Drawing was created?
    @test setstrokescale() == true

    background("white")
    setcolor(0, 0, 0)

    # scale the canvas to use coordinates [0, 1]
    scale(10)

    # set our stroke width to the width of the canvas
    setline(1)

    @test getline() == 1

    # a line the width of the canvas drawn at 0 should cover 50% of the canvas
    line(Point(0, 0), Point(0, 1), :stroke)

    mat = image_as_matrix()
    @test RGBA{Float32}(0, 0, 0, 1) == convert(RGBA{Float32}, mat[5, 3])

    background("white")

    setstrokescale(false)
    @test setstrokescale() == false

    # set our stroke width to size 1, independent of scaling
    setline(1)
    @test getline() == 1

    # An unscaled line of size 1 will not cover 50% of the canvas
    line(Point(0, 0), Point(0, 1), :stroke)
    mat = image_as_matrix()

    # assert that the same pixel is now white
    @test RGBA{Float32}(1, 1, 1, 1) == convert(RGBA{Float32}, mat[5, 3])
    @test finish() == true
end

strokescale()

println("...finished strokescaletest")

# arcs, circles, ellipses, curves, pie, sector, bezier

function circle(x::Real, y::Real, r::Real;
    action = :none)
    if action != :path
        newpath()
    end
    Cairo.arc(_get_current_cr(), x, y, r, 0, pi/2)
    Cairo.arc(_get_current_cr(), x, y, r, pi/2, pi)
    Cairo.arc(_get_current_cr(), x, y, r, pi, 3pi/2)
    Cairo.arc(_get_current_cr(), x, y, r, 3pi/2, 2pi)
    closepath()
    do_action(action)
    return (Point(x, y) - (r, r), Point(x, y) + (r, r))
end

"""
    circle(centerpoint::Point, r; action=:none)
    circle(centerpoint::Point, r, action)

Make a circle of radius `r` centered at 'centerpoint', and add it to the current path.

`action` is one of the actions applied by `do_action()`, defaulting to `:none`.

Returns a tuple of two points, the corners of a bounding box that encloses the circle.

You can also use `ellipse()` to draw circles and place them by their centerpoint.

`circlepath()` builds a circle using Bézier curves, and add it to the current path.

`squircle()` builds a superellipse. `polysuper()` build a 'supershape', a
generalization of the superellipse.

`juliacircles()` draws three circles in a familiar formation.

See also: `arc()`, `arc2r()`, `arc2sagitta()`, `carc()`, `carc2r()`,
`carc2sagitta()`, `circlering()`, `crescent()`, `curve()`, `spiral()`, etc.
"""
circle(centerpoint::Point, r::Real; action = :none) =
    circle(centerpoint.x, centerpoint.y, r, action = action)

circle(pt::Point, r::Real, action::Symbol) = circle(pt, r, action = action::Symbol)

circle(x::Real, y::Real, r::Real, action::Symbol) = circle(Point(x, y), r, action = action::Symbol)

"""
    circle(pt1::Point, pt2::Point; action=:none)
    circle(pt1::Point, pt2::Point, action)

Make a circle that passes through two points that define the diameter, and add it to the current path.
"""
function circle(pt1::Point, pt2::Point;
    action = :none)
    center = midpoint(pt1, pt2)
    radius = distance(pt1, pt2) / 2
    circle(center, radius, action = action)
end

circle(pt1::Point, pt2::Point, action::Symbol) = circle(pt1, pt2, action = action)

"""
    circle(pt1::Point, pt2::Point, pt3::Point; action=:none)
    circle(pt1::Point, pt2::Point, pt3::Point, action)

Make a circle that passes through three points, and add it to the current path.
"""
function circle(pt1::Point, pt2::Point, pt3::Point;
    action = :none)
    center = midpoint(pt1, pt2)
    radius = distance(pt1, pt2) / 2
    circle(center3pts(pt1, pt2, pt3)..., action = action)
end

circle(pt1::Point, pt2::Point, pt3::Point, action::Symbol) =
    circle(pt1, pt2, pt3; action = action)

"""
    center3pts(a::Point, b::Point, c::Point)

Find the radius and center point for three points lying on a circle.

returns `(centerpoint, radius)` of a circle.

If there's no such circle, the function returns `(Point(0, 0), 0)`.

If two of the points are the same, use `circle(pt1, pt2)` instead.
"""
function center3pts(p1::Point, p2::Point, p3::Point)
    norm2(p::Point) = (p.x)^2 + (p.y)^2

    α1 = norm2(p3 - p2) * (norm2(p2 - p1) + norm2(p1 - p3) - norm2(p3 - p2))
    α2 = norm2(p1 - p3) * (norm2(p3 - p2) + norm2(p2 - p1) - norm2(p1 - p3))
    α3 = norm2(p2 - p1) * (norm2(p1 - p3) + norm2(p3 - p2) - norm2(p2 - p1))

    if α1 + α2 + α3 ≠ 0.0
        c = (α1 * p1 + α2 * p2 + α3 * p3) / (α1 + α2 + α3)
        r = √(norm2(p1 - c))
        return c, r
    else
        @warn "center3pts(): There are no circles which pass through $p1, $p2 and $p3."
        return (Point(0, 0), 0)
    end
end

"""
    circlering(o_center, o_radius, count=3)

Find `count` circles that fit inside an imaginary circle centered at o_center with radius
and are tangent to it.

Returns:

  - an array of center/radius tuples defining each of the circles
  - a single center/radius tuple defining the circle that fits inside the calculated circles


```julia
cs, ic = circlering(Point(0, 0), 200, 3)

(Tuple
    [(Point(-53.59246086870698, 92.82486512724742), 92.815078262586),
     (Point(-53.59246086870705, -92.82486512724739), 92.815078262586),
     (Point(107.184921737414, -2.6252734264516723e-14), 92.815078262586)
   ],
    (Point(0.0, 0.0), 14.369843474828002))

@draw begin
    cs, ic = circlering(Point(0, 0), 200, 3)
    map(c -> circle(first(c), last(c), :fill), cs)
    circle(first(ic), last(ic), :fill)
end
```
"""
function circlering(o_center, o_radius, count = 3)
    if count < 3
        # set it to 2
        r = o_radius / 2
        c1 = Point(o_center.x - r, o_center.y)
        c2 = Point(o_center.x + r, o_center.y)
        return ([(c1, r), (c2, r)], (o_center, 0.0))
    end
    circles = Tuple[]
    mastercircumference = 2π * o_radius
    innerradius = mastercircumference / π / 2
    circleradius = 0
    maxcalc = 1000
    radian = 2π / count
    while maxcalc > 0
        dist = distance(
            Point(innerradius + o_center.x, o_center.y),
            Point(cos(radian) * innerradius + o_center.x,
                sin(radian) * innerradius + o_center.y))
        if abs(dist / 2 - circleradius) < 0.01
            break
        end
        circleradius = dist / 2
        innerradius = o_radius - circleradius
        maxcalc -= 1
    end
    for index in 1:count
        radian = (2π / count) * index
        centerp = Point(cos(radian) * innerradius + o_center.x, sin(radian) * innerradius + o_center.y)
        radius = circleradius
        push!(circles, (centerp, radius))
    end
    return (circles, (o_center, innerradius - circleradius))
end

function ellipse(xc::Real, yc::Real, w::Real, h::Real;
    action = :none)
    x = xc - w / 2
    y = yc - h / 2
    # kappa = 4.0 * (sqrt(2.0) - 1.0) / 3.0
    kappa = 0.5522847498307936
    ox = (w / 2) * kappa  # control point offset horizontal
    oy = (h / 2) * kappa  # control point offset vertical
    xe = x + w            # x-end
    ye = y + h            # y-end
    xm = x + w / 2        # x-middle
    ym = y + h / 2        # y-middle
    move(x, ym)
    curve(x, ym - oy, xm - ox, y, xm, y)
    curve(xm + ox, y, xe, ym - oy, xe, ym)
    curve(xe, ym + oy, xm + ox, ye, xm, ye)
    curve(xm - ox, ye, x, ym + oy, x, ym)
    do_action(action)
    return (Point(xc, yc) - (w / 2, h / 2), Point(xc, yc) + (w / 2, h / 2))
end

ellipse(xc::Real, yc::Real, w::Real, h::Real, action::Symbol) =
    ellipse(xc, yc, w, h, action = action)

"""
    ellipse(centerpoint::Point, w, h; action=:none)
    ellipse(centerpoint::Point, w, h; action)

Make an ellipse, centered at `centerpoint`, with width `w`, and height `h`, and add it to the current path.

Returns a tuple of two points, the corners of a bounding box that encloses the ellipse.

See also: `circle()`, `squircle()`, `ellipseinquad()`...

"""
ellipse(c::Point, w::Real, h::Real; action = :none) = ellipse(c.x, c.y, w, h, action = action)

ellipse(c::Point, w::Real, h::Real, action::Symbol) = ellipse(c, w, h, action = action)

"""
    squircle(center::Point, hradius, vradius;
        action=:none,
        rt = 0.5, stepby = pi/40, vertices=false)
    squircle(center::Point, hradius, vradius, action;
        rt = 0.5, stepby = pi/40, vertices=false)

Make a squircle or superellipse (basically a rectangle with rounded corners). 
Specify the center position, horizontal radius
(distance from center to a side), and vertical radius (distance from center to
top or bottom):

The root (`rt`) option defaults to 0.5, and gives an intermediate shape. Values
less than 0.5 make the shape more rectangular. Values above make the shape more
round. The horizontal and vertical radii can be different.

This function generates a series of points and makes a polygon or returns an array of Points.

See also: `polysuper()` and `squirclepath()`.
"""
function squircle(center::Point, hradius::Real, vradius::Real;
    action = :none,
    rt = 0.5,
    vertices = false,
    stepby = pi / 40,
    reversepath = false)
    points = Point[]
    for theta in 0:stepby:(2pi)
        xpos = center.x + ^(abs(cos(theta)), rt) * hradius * sign(cos(theta))
        ypos = center.y + ^(abs(sin(theta)), rt) * vradius * sign(sin(theta))
        push!(points, Point(xpos, ypos))
    end
    result = reversepath ? reverse(points) : points
    if !vertices
        poly(points, action, close = true, reversepath = reversepath)
    end
    return result
end

squircle(center::Point, hradius::Real, vradius::Real, action::Symbol;
    rt = 0.5,
    vertices = false,
    stepby = pi / 40,
    reversepath = false) =
    squircle(center, hradius, vradius;
        action = action,
        rt = rt,
        vertices = false,
        stepby = pi / 40,
        reversepath = false)

"""
    squirclepath(cpos, w, h;
        action = :none,
        kappa = 0.75,
        reversepath = false)

Make a squircle or superellipse (basically a rectangle with rounded corners).
Specify the center position, width, and height. 

`kappa` is a value (usually between 0 and 1) that determines the circularity of
the shape. If `kappa` is `4.0 * (sqrt(2.0) - 1.0) / 3.0` (ie `0.5522847498307936`),
the shape is a resonable approximation to a circle. 

Use the `reversepath` option to construct the path in the opposite direction.

The difference betweeen `squircle()` and `squirclepath()` is that the former
builds polygons from points, the latter uses Bezier curves to build paths. 

See also `circlepath()`.
"""
function squirclepath(cpos, w, h;
        action = :none,
        kappa = 0.75,
        reversepath = false)
    @layer begin
        translate(cpos)
        if reversepath
            bottom_left, top_left, top_right, bottom_right = reverse(box(O, 2w, 2h))
        else
            bottom_left, top_left, top_right, bottom_right = box(O, 2w, 2h)
        end
        top_center = midpoint(top_left, top_right)
        right_center = midpoint(top_right, bottom_right)
        bottom_center = midpoint(bottom_left, bottom_right)
        left_center = midpoint(top_left, bottom_left)
        move(left_center)
        curve(between(left_center, top_left, kappa), between(top_center, top_left, kappa), top_center)
        curve(between(top_center, top_right, kappa), between(right_center, top_right, kappa), right_center)
        curve(between(right_center, bottom_right, kappa), between(bottom_center, bottom_right, kappa), bottom_center)
        curve(between(bottom_center, bottom_left, kappa), between(left_center, bottom_left, kappa), left_center)
        closepath()
        result = storepath()
        do_action(action)
    end
    return result
end

squirclepath(cpos, w, h, the_action::Symbol;
        action = :none,
        kappa = 0.75,
        reversepath = false) = squirclepath(cpos, w, h;
        action = the_action,
        kappa = kappa,
        reversepath = reversepath)

function arc(xc, yc, radius, angle1, angle2;
    action = :none)
    Cairo.arc(_get_current_cr(), xc, yc, radius, angle1, angle2)
    do_action(action)
end

arc(xc, yc, radius, angle1, angle2, the_action::Symbol) =
    arc(xc, yc, radius, angle1, angle2, action = the_action)

"""
    arc(centerpoint::Point, radius, angle1, angle2; action=:none)
    arc(centerpoint::Point, radius, angle1, angle2, action)

Add an arc to the current path from `angle1` to `angle2` going clockwise, centered
at `centerpoint`.

Angles are defined relative to the x-axis, positive clockwise.

See also: `carc()`, `arc2r()`, `arc2sagitta()`, ...
"""
arc(centerpoint::Point, radius, angle1, angle2; action = :none) =
    arc(centerpoint.x, centerpoint.y, radius, angle1, angle2, action = action)

arc(centerpoint::Point, radius, angle1, angle2, action::Symbol) =
    arc(centerpoint.x, centerpoint.y, radius, angle1, angle2, action = action)

function carc(xc, yc, radius, angle1, angle2;
    action = :none)
    Cairo.arc_negative(_get_current_cr(), xc, yc, radius, angle1, angle2)
    do_action(action)
end

"""
    carc(centerpoint::Point, radius, angle1, angle2; action=:none)
    carc(centerpoint::Point, radius, angle1, angle2, action)

Add an arc centered at `centerpoint` to the current path from `angle1` to
`angle2`, going counterclockwise.

Angles are defined relative to the x-axis, positive clockwise.

See also: `arc()`, `carc2r()`, `carc2sagitta()`, ...
"""
carc(centerpoint::Point, radius, angle1, angle2; action = :none) =
    carc(centerpoint.x, centerpoint.y, radius, angle1, angle2, action = action)

carc(centerpoint::Point, radius, angle1, angle2, action::Symbol) =
    carc(centerpoint.x, centerpoint.y, radius, angle1, angle2, action = action)

carc(x::Real, y::Real, radius, angle1, angle2, action::Symbol = :none) =
    carc(x, y, radius, angle1, angle2, action = action)

"""
    arc2r(c1::Point, p2::Point, p3::Point; action=:none)
    arc2r(c1::Point, p2::Point, p3::Point, action)

Add a circular arc centered at `c1` that starts at `p2` and ends at `p3`, going clockwise,
to the current path.

`c1`-`p2` really determines the radius. If `p3` doesn't lie on the circular path,
it will be used only as an indication of the arc's length, rather than its position.
"""
function arc2r(c1::Point, p2::Point, p3::Point;
    action = :none)
    r          = distance(c1, p2)
    startangle = atan(p2.y - c1.y, p2.x - c1.x)
    endangle   = atan(p3.y - c1.y, p3.x - c1.x)
    if endangle < startangle
        endangle = mod2pi(endangle + 2pi)
    end
    arc(c1, r, startangle, endangle, action = action)
end

arc2r(c1::Point, p2::Point, p3::Point, action::Symbol) = arc2r(c1, p2, p3, action = action)

"""
    carc2r(c1::Point, p2::Point, p3::Point; action=:none)

Add a circular arc centered at `c1` that starts at `p2` and ends at `p3`,
going counterclockwise, to the current path.

`c1`-`p2` really determines the radius. If `p3` doesn't lie on the circular
path, it will be used only as an indication of the arc's length, rather than its position.
"""
function carc2r(c1::Point, p2::Point, p3::Point;
    action = :none)
    r          = distance(c1, p2)
    startangle = atan(p2.y - c1.y, p2.x - c1.x)
    endangle   = atan(p3.y - c1.y, p3.x - c1.x)
    if startangle < endangle
        startangle = mod2pi(startangle + 2pi)
    end
    carc(c1, r, startangle, endangle, action = action)
end

carc2r(c1::Point, p2::Point, p3::Point, action::Symbol) = carc2r(c1, p2, p3, action = action)

"""
    isarcclockwise(c::Point, A::Point, B::Point)

Return `true` if an arc centered at `c` going from `A` to `B` is clockwise.

If `c`, `A`, and `B` are collinear, then a hemispherical arc could be
either clockwise or not.
"""
function isarcclockwise(c::Point, A::Point, B::Point)
    a = A - c
    b = B - c
    return crossproduct(a, b) > 0
end

"""
    sector(centerpoint::Point, innerradius, outerradius, startangle, endangle;
        action=:none)

Make an annular sector centered at `centerpoint`, and add it to the current path.

TODO - return something more useful than a Boolean

See also: `pie()`.
"""
function sector(centerpoint::Point, innerradius::Real, outerradius::Real,
    startangle::Real, endangle::Real;
    action = :none)
    (innerradius > outerradius) && throw(DomainError(outerradius, "outer radius must be larger than inner radius $(innerradius)"))
    gsave()
    translate(centerpoint)
    newpath()
    move(innerradius * cos(startangle), innerradius * sin(startangle))
    line(outerradius * cos(startangle), outerradius * sin(startangle))
    arc(0, 0, outerradius, startangle, endangle, action = :none)
    line(innerradius * cos(endangle), innerradius * sin(endangle))
    carc(0, 0, innerradius, endangle, startangle, action = :none)
    closepath()
    grestore()
    do_action(action)
end

sector(centerpoint::Point, innerradius::Real, outerradius::Real,
    startangle::Real, endangle::Real, action::Symbol) =
    sector(centerpoint, innerradius, outerradius, startangle, endangle, action = action)

"""
    sector(innerradius::Real, outerradius::Real, startangle::Real, endangle::Real;
       action=:none)

Make an annular sector centered at the origin, and add it to the current path.
"""
sector(innerradius::Real, outerradius::Real, startangle::Real, endangle::Real;
    action = :none) =
    sector(O, innerradius, outerradius, startangle, endangle, action = action)

sector(innerradius::Real, outerradius::Real, startangle::Real, endangle::Real, action::Symbol) =
    sector(innerradius, outerradius, startangle, endangle, action = action)

"""
    sector(centerpoint::Point, innerradius, outerradius,
            startangle, endangle, cornerradius;
           action:none)

Make an annular sector with rounded corners, basically a bent sausage shape,
centered at `centerpoint`, and add it to the current path.

TODO: The results aren't 100% accurate at the moment. There are small
discontinuities where the curves join.

TODO - return something more useful than a Boolean

The cornerradius is reduced from the supplied value if neceesary to prevent overshoots.
"""
function sector(centerpoint::Point, innerradius::Real, outerradius::Real, startangle::Real,
    endangle::Real, cornerradius::Real;
    action = :none)
    (innerradius > outerradius) && throw(DomainError(outerradius, "outer radius must be larger than inner radius $(innerradius)"))
    gsave()
    translate(centerpoint)
    # some work is done using polar coords to calculate the points

    # attempts to prevent pathological cases
    cornerradius = min(cornerradius, abs(outerradius - innerradius) / 2)
    if endangle < startangle
        endangle = mod2pi(endangle + 2pi)
    end

    # TODO reduce given corner radius to prevent messes when spanning angle too small
    # 4 is a magic number
    while abs(endangle - startangle) < 4.0(atan(cornerradius, innerradius))
        cornerradius *= 0.75
    end

    # first inner corner
    alpha1 = asin(cornerradius / (innerradius + cornerradius))
    p1p2center = (innerradius + cornerradius, startangle + alpha1)
    p1 = (innerradius, startangle + alpha1)
    p2 = (innerradius + cornerradius, startangle)
    # first outer
    alpha2 = asin(cornerradius / (outerradius - cornerradius))
    p3p4center = (outerradius - cornerradius, startangle + alpha2)
    p3 = (outerradius - cornerradius, startangle)
    p4 = (outerradius, startangle + alpha2)
    # last outer
    p5p6center = (outerradius - cornerradius, endangle - alpha2)
    p5 = (outerradius, endangle - alpha2)
    p6 = (outerradius - cornerradius, endangle)
    # last inner
    p7p8center = (innerradius + cornerradius, endangle - alpha1)
    p7 = (innerradius + cornerradius, endangle)
    p8 = (innerradius, endangle - alpha1)

    # make path
    move(@polar(p1))
    newpath()
    # inner corner
    arc(@polar(p1p2center), cornerradius, slope(@polar(p1p2center), @polar(p1)),
        slope(@polar(p1p2center), @polar(p2)), action = :none)
    line(@polar(p3))
    # outer corner
    arc(@polar(p3p4center), cornerradius, slope(@polar(p3p4center), @polar(p3)),
        slope(@polar(p3p4center), @polar(p4)), action = :none)
    # outside arc
    arc(O, outerradius, slope(O, @polar(p4)), slope(O, @polar(p5)), action = :none)
    # last outside corner
    arc(@polar(p5p6center), cornerradius, slope(@polar(p5p6center), @polar(p5)),
        slope(@polar(p5p6center), @polar(p6)), action = :none)
    line(@polar(p7))
    # last inner corner
    arc(@polar(p7p8center), cornerradius, slope(@polar(p7p8center), @polar(p7)),
        slope(@polar(p7p8center), @polar(p8)), action = :none)
    s1, s2 = slope(O, @polar(p8)), slope(O, @polar(p1))
    if s1 < s2
        s2 = mod2pi(s2 + 2pi)
    end
    carc(O, innerradius, s1, s2, action = :none)
    closepath()
    do_action(action)
    grestore()
end

sector(centerpoint::Point, innerradius::Real, outerradius::Real, startangle::Real, endangle::Real,
    cornerradius::Real, action::Symbol) = sector(centerpoint,
    innerradius, outerradius, startangle, endangle,
    cornerradius, action = action)

"""
    sector(innerradius::Real, outerradius::Real, startangle::Real, endangle::Real,
       cornerradius::Real, action)

Make an annular sector with rounded corners, centered at the
current origin, and add it to the current path.
"""
sector(innerradius::Real, outerradius::Real, startangle::Real, endangle::Real,
    cornerradius::Real, action::Symbol) =
    sector(O, innerradius, outerradius, startangle, endangle, cornerradius, action = action)

sector(innerradius::Real, outerradius::Real, startangle::Real, endangle::Real, cornerradius::Real; action = :stroke) =
    sector(O, innerradius, outerradius, startangle, endangle, cornerradius, action = action)

"""
    pie(x, y, radius, startangle, endangle; action=:none)
    pie(centerpoint, radius, startangle, endangle; action=:none)

Make a pie shape centered at `x`/`y`. Angles start at the positive x-axis and
are measured clockwise, and add it to the current path.

See also `sector()`.

TODO - return something more useful than a Boolean
"""
function pie(x::Real, y::Real, radius::Real, startangle::Real, endangle::Real;
    action = :none)
    gsave()
    translate(x, y)
    newpath()
    move(0, 0)
    line(radius * cos(startangle), radius * sin(startangle))
    arc(0, 0, radius, startangle, endangle, action = :none)
    closepath()
    grestore()
    do_action(action)
end

pie(x::Real, y::Real, radius::Real, startangle::Real, endangle::Real, action::Symbol) =
    pie(x, y, radius, startangle, endangle, action = action)

pie(centerpoint::Point, radius::Real, startangle::Real, endangle::Real; action = :none) =
    pie(centerpoint.x, centerpoint.y, radius, startangle, endangle, action = action)

"""
    pie(centerpoint::Point, radius::Real, startangle::Real, endangle::Real, action::Symbol)
"""
pie(centerpoint::Point, radius::Real, startangle::Real, endangle::Real, action::Symbol) =
    pie(centerpoint.x, centerpoint.y, radius, startangle, endangle, action = action)

"""
    pie(radius, startangle, endangle;
        action=:none)

Make a pie shape centered at the origin, and add it to the current path.
"""
pie(radius::Real, startangle::Real, endangle::Real; action = :none) =
    pie(O, radius, startangle, endangle, action = action)

pie(radius::Real, startangle::Real, endangle::Real, action::Symbol) =
    pie(O, radius, startangle, endangle, action = action)

"""
    curve(x1, y1, x2, y2, x3, y3)
    curve(p1, p2, p3)

Add a Bézier curve to the current path.

The spline starts at the current position, finishing at `x3/y3` (`p3`),
following two control points `x1/y1` (`p1`) and `x2/y2` (`p2`).
"""
curve(x1, y1, x2, y2, x3, y3) = Cairo.curve_to(_get_current_cr(), x1, y1, x2, y2, x3, y3)
curve(pt1, pt2, pt3) = curve(pt1.x, pt1.y, pt2.x, pt2.y, pt3.x, pt3.y)

"""
    circlepath(center::Point, radius;
        action=:none,
        reversepath=false,
        kappa = 0.5522847498307936)
    circlepath(center::Point, radius, action;
        reversepath=false,
        kappa = 0.5522847498307936)

Make a circle using Bézier curves, and add it to the current
path.

One benefit of using this rather than `circle()` is
that you can use the `reversepath` option to draw the circle
clockwise rather than `circle`'s counterclockwise.

The magic value, `kappa`, is `4.0 * (sqrt(2.0) - 1.0) / 3.0`.

Return two points, the corners of a bounding box.
"""
function circlepath(center::Point, radius;
    action = :none,
    reversepath = false,
    kappa = 0.5522847498307936)
    function northtoeast(center::Point, radius, kappa)
        curve(center.x + (radius * kappa), center.y + radius, center.x + radius,
            center.y + (radius * kappa), center.x + radius, center.y)
    end

    function easttosouth(center::Point, radius, kappa)
        curve(center.x + radius, center.y - (radius * kappa), center.x + (radius * kappa),
            center.y - radius, center.x, center.y - radius)
    end

    function southtowest(center::Point, radius, kappa)
        curve(center.x - (radius * kappa), center.y - radius, center.x - radius,
            center.y - (radius * kappa), center.x - radius, center.y)
    end

    function westtonorth(center::Point, radius, kappa)
        curve(center.x - radius, center.y + (radius * kappa), center.x - (radius * kappa),
            center.y + radius, center.x, center.y + radius)
    end

    function northtowest(center::Point, radius, kappa)
        curve(center.x - (radius * kappa), center.y + radius, center.x - radius,
            center.y + (radius * kappa), center.x - radius, center.y)
    end

    function westtosouth(center::Point, radius, kappa)
        curve(center.x - radius, center.y - (radius * kappa), center.x - (radius * kappa),
            center.y - radius, center.x, center.y - radius)
    end

    function southtoeast(center::Point, radius, kappa)
        curve(center.x + (radius * kappa), center.y - radius, center.x + radius,
            center.y - (radius * kappa), center.x + radius, center.y)
    end

    function easttonorth(center::Point, radius, kappa)
        curve(center.x + radius, center.y + (radius * kappa), center.x + (radius * kappa),
            center.y + radius, center.x, center.y + radius)
    end

    move(center.x, center.y + radius)
    if !reversepath
        northtoeast(center, radius, kappa)
        easttosouth(center, radius, kappa)
        southtowest(center, radius, kappa)
        westtonorth(center, radius, kappa)
    else
        northtowest(center, radius, kappa)
        westtosouth(center, radius, kappa)
        southtoeast(center, radius, kappa)
        easttonorth(center, radius, kappa)
    end
    do_action(action)
    return (center - (radius, radius), center + (radius, radius))
end

circlepath(center::Point, radius, action::Symbol; reversepath = false, kappa = 0.5522847498307936) = circlepath(center, radius;
    action = action,
    reversepath = reversepath,
    kappa = kappa)

"""
    ellipse(focus1::Point, focus2::Point, k;
            action=:none,
            stepvalue=pi/100,
            vertices=false,
            reversepath=false)

Build a polygon approximation to an ellipse, given two
points and a distance, `k`, which is the sum of the
distances to the focii of any points on the ellipse (or the
shortest length of string required to go from one focus to
the perimeter and on to the other focus), and add it to the
current path.
"""
function ellipse(focus1::Point, focus2::Point, k;
    action = :none,
    stepvalue = pi / 100,
    vertices = false,
    reversepath = false)
    a = k / 2  # a = ellipse's major axis, the widest part
    cpoint = midpoint(focus1, focus2)
    dc = distance(focus1, cpoint)
    b = sqrt(abs(a^2 - dc^2)) # minor axis, hopefuly not 0
    phi = slope(focus1, focus2) # angle between the major axis and the x-axis
    points = Point[]
    drawing = false
    for t in 0:stepvalue:(2pi)
        xt = cpoint.x + a * cos(t) * cos(phi) - b * sin(t) * sin(phi)
        yt = cpoint.y + a * cos(t) * sin(phi) + b * sin(t) * cos(phi)
        push!(points, Point(xt, yt))
    end
    vertices ? points : poly(points, action, close = true, reversepath = reversepath)
end

ellipse(f1::Point, f2::Point, k, action::Symbol;
    stepvalue = pi / 100,
    vertices = false,
    reversepath = false) =
    ellipse(f1, f2, k,
        action = action,
        stepvalue = stepvalue,
        vertices = vertices,
        reversepath = reversepath)

"""
    ellipse(focus1::Point, focus2::Point, pt::Point;
        action=:none,
        stepvalue=pi/100,
        vertices=false,
        reversepath=false)

Build a polygon approximation to an ellipse, given two points and a point somewhere on the
ellipse.
"""
function ellipse(focus1::Point, focus2::Point, pt::Point;
    action = :none,
    stepvalue = pi / 100,
    vertices = false,
    reversepath = false)
    k = distance(focus1, pt) + distance(focus2, pt)
    ellipse(focus1, focus2, k, action = action, stepvalue = stepvalue,
        vertices = vertices, reversepath = reversepath)
end

ellipse(focus1::Point, focus2::Point, pt::Point, action::Symbol;
    stepvalue = pi / 100,
    vertices = false,
    reversepath = false) = ellipse(focus1, focus2, pt;
    action = action,
    stepvalue = stepvalue,
    vertices = vertices,
    reversepath = reversepath)

"""
    hypotrochoid(R, r, d;
        action=:none,
        stepby=0.01,
        period=0.0,
        vertices=false)
    hypotrochoid(R, r, d, action;
        stepby=0.01,
        period=0.0,
        vertices=false)

Make a hypotrochoid with short line segments, and add it to
the current path. (Like a Spirograph.) The curve is traced
by a point attached to a circle of radius `r` rolling around
the inside  of a fixed circle of radius `R`, where the point
is a distance `d` from  the center of the interior circle.
Things get interesting if you supply non-integral values.

Special cases include the hypocycloid, if `d` = `r`, and an
ellipse, if `R` = `2r`.

`stepby`, the angular step value, controls the amount of
detail, ie the smoothness of the polygon,

If `period` is not supplied, or 0, the lowest period is
calculated for you.

The function can return a polygon (a list of points), or
draw the points directly using the supplied `action`. If the
points are drawn, the function returns a tuple showing how
many points were drawn and what the period was (as a
multiple of `pi`).
"""
function hypotrochoid(R, r, d;
    action   = :none,
    close    = true,
    stepby   = 0.01,
    period   = 0.0,
    vertices = false)
    function nextposition(t)
        x = (R - r) * cos(t) + (d * cos(((R - r) / r) * t))
        y = (R - r) * sin(t) - (d * sin(((R - r) / r) * t))
        return Point(x, y)
    end
    # try to calculate the period exactly
    if isapprox(period, 0)
        period = 2pi * (r / gcd(convert(Int, floor(R)), convert(Int, floor(r))))
    end
    counter = 1
    points = Point[]
    for t in 0:stepby:period
        push!(points, nextposition(t))
    end
    # don't repeat end point if it's more or less the same as the start point
    isapprox(points[1], points[end]) && pop!(points)
    vertices ? points : (poly(points, action, close = close); (length(points), period / pi))
end

hypotrochoid(R, r, d, action::Symbol;
    close    = true,
    stepby   = 0.01,
    period   = 0.0,
    vertices = false) = hypotrochoid(R, r, d;
    action   = action,
    close    = close,
    stepby   = stepby,
    period   = period,
    vertices = vertices)

"""
    epitrochoid(R, r, d;
        action=:none,
        stepby=0.01,
        period=0,
        vertices=false)
    epitrochoid(R, r, d, action;
        stepby=0.01,
        period=0,
        vertices=false)

Make a epitrochoid with short line segments, and add it to
the current path. (Like a Spirograph.) The curve is traced
by a point attached to a circle of radius `r` rolling around
the outside of a fixed circle of radius `R`, where the point
is a distance `d` from the center of the circle. Things get
interesting if you supply non-integral values.

`stepby`, the angular step value, controls the amount of
detail, ie the smoothness of the polygon.

If `period` is not supplied, or 0, the lowest period is
calculated for you.

The function can return a polygon (a list of points), or
draw the points directly using the supplied `action`. If the
points are drawn, the function returns a tuple showing how
many points were drawn and what the period was (as a
multiple of `pi`).
"""
function epitrochoid(R, r, d;
    action   = :none,
    close    = true,
    stepby   = 0.01,
    period   = 0,
    vertices = false)
    function nextposition(t)
        x = (R + r) * cos(t) - (d * cos(((R - r) / r) * t))
        y = (R + r) * sin(t) - (d * sin(((R - r) / r) * t))
        return Point(x, y)
    end
    # try to calculate the period exactly
    if isapprox(period, 0)
        period = 2pi * (r / gcd(convert(Int, floor(R)), convert(Int, floor(r))))
    end
    counter = 1
    points = Point[]
    for t in 0:stepby:period
        push!(points, nextposition(t))
    end
    # don't repeat end point if it's more or less the same as the start point
    isapprox(points[1], points[end]) && pop!(points)
    vertices ? points : (poly(points, action, close = close); (length(points), period / pi))
end

epitrochoid(R, r, d, action::Symbol;
    close    = true,
    stepby   = 0.01,
    period   = 0.0,
    vertices = false) = epitrochoid(R, r, d;
    action   = action,
    close    = close,
    stepby   = stepby,
    period   = period,
    vertices = vertices)

"""
    spiral(a, b;
        action = :none,
        stepby = 0.01,
        period = 4pi,
        vertices = false,
        log =false)
    spiral(a, b, action;
        stepby = 0.01,
        period = 4pi,
        vertices = false,
        log =false)

Make a spiral, and add it to the current path. The two
primary parameters `a` and `b` determine the start radius,
and the tightness.

For linear spirals (`log=false`), `b` values are:

- lituus: -2

- hyperbolic spiral: -1

- Archimedes' spiral: 1

- Fermat's spiral: 2

For logarithmic spirals (`log=true`):

- golden spiral: b = ln(phi) / (pi/2) (about 0.30)

Values of `b` around 0.1 produce tighter, staircase-like spirals.
"""
function spiral(a, b;
    action = :none,
    stepby = 0.01,
    period = 4pi,
    vertices = false,
    log = false)
    function nextpositionlog(t)
        ebt = exp(t * b)
        if abs(ebt) < 10^8 # arbitrary cutoff to avoid NaNs and Infs
            x = a * ebt * cos(t)
            y = a * ebt * sin(t)
            return Point(x, y)
        else
            return nothing
        end
    end
    function nextpositionlin(t)
        tpn = t^(1 / b)
        if tpn < 10^8
            x = a * tpn * cos(t)
            y = a * tpn * sin(t)
            return Point(x, y)
        else
            return nothing
        end
    end
    log ? nextpos = nextpositionlog : nextpos = nextpositionlin
    points = Point[]
    for t in 0:stepby:period
        pt = nextpos(t)
        if isa(nextpos(t), Point)
            push!(points, pt)
        end
    end
    if vertices == false
        poly(points, action) # no close by default :)
    end
    return points
end

spiral(a, b, action::Symbol;
    stepby = 0.01,
    period = 4pi,
    vertices = false,
    log = false) = spiral(a, b;
    action = action,
    stepby = stepby,
    period = period,
    vertices = vertices,
    log = log)
"""
    intersection2circles(pt1, r1, pt2, r2)

Find the area of intersection between two circles, the first centered at `pt1` with radius
`r1`, the second centered at `pt2` with radius `r2`.

If one circle is entirely within another, that circle's area is returned.
"""
function intersection2circles(pt1::Point, rad1::Real, pt2::Point, rad2::Real)
    # via casey and jùlio on slack
    # squared radii
    rr1, rr2 = rad1 * rad1, rad2 * rad2
    d = distance(pt1, pt2)

    # trivial cases
    d ≥ rad1 + rad2 && return 0.0
    d ≤ abs(rad2 - rad1) && return π * min(rr1, rr2)

    # First center point to the middle line
    a_distancecenterfirst = (rr1 - rr2 + (d^2)) / (2d)

    # Second centre point to the middle line
    b_distancecentersecond = d - a_distancecenterfirst

    # Half of the middle line
    h_height = sqrt(rr1 - a_distancecenterfirst^2)

    # central angle for the first circle
    alpha = mod2pi(atan(h_height, a_distancecenterfirst) * 2.0 + 2π)

    # Central angle for the second circle
    beta = mod2pi(atan(h_height, b_distancecentersecond) * 2.0 + 2π)

    #  Area of the first circular segment
    A1 = rr1 / 2.0 * (alpha - sin(alpha))
    # Area of the second circular segment
    A2 = rr2 / 2.0 * (beta - sin(beta))
    return A1 + A2
end

"""
    intersectioncirclecircle(cp1, r1, cp2, r2)

Find the two points where two circles intersect, if they do. The first circle is centered
at `cp1` with radius `r1`, and the second is centered at `cp1` with radius `r1`.

Returns

    (flag, ip1, ip2)

where `flag` is a Boolean `true` if the circles intersect at the points `ip1` and `ip2`. If
the circles don't intersect at all, or one is completely inside the other, `flag` is `false`
and the points are both Point(0, 0).

Use `intersection2circles()` to find the area of two overlapping circles.

In the pure world of maths, it must be possible that two circles 'kissing' only have a
single intersection point. At present, this unromantic function reports that two kissing
circles have no intersection points.
"""
function intersectioncirclecircle(cp1, r1, cp2, r2)
    r1squared = r1^2
    r2squared = r2^2
    d = distance(cp1, cp2)
    if d > (r2 + r1) # circles do not overlap
        return (false, O, O)
    elseif (d <= abs(r1 - r2)) && (r1 >= r2)
        # second circle is completely inside first circle
        return (false, O, O)
    elseif (d <= abs(r1 - r2)) && (r1 < r2)
        # first circle is completely inside second circle
        return (false, O, O)
    end
    a = (r1squared - r2squared + d^2) / 2d
    h = sqrt(r1squared - a^2)
    p0 = cp1 + a * (cp2 - cp1) / d
    p3 = Point(
        p0.x + h * (cp2.y - cp1.y) / d,
        p0.y - h * (cp2.x - cp1.x) / d)
    p4 = Point(
        p0.x - h * (cp2.y - cp1.y) / d,
        p0.y + h * (cp2.x - cp1.x) / d)
    return (true, p3, p4)
end

"""
    circlepointtangent(through::Point, radius, targetcenter::Point, targetradius)

Find the centers of up to two circles of radius `radius` that pass through point
`through` and are tangential to a circle that has radius `targetradius` and
center `targetcenter`.

This function returns a tuple:

  - (0, O, O)      - no circles exist
  - (1, pt1, O)    - 1 circle exists, centered at pt1
  - (2, pt1, pt2)  - 2 circles exist, with centers at pt1 and pt2

(The O are just dummy points so that three values are always returned.)
"""
function circlepointtangent(through::Point, radius, targetcenter::Point, targetradius)
    distx = targetcenter.x - through.x
    disty = targetcenter.y - through.y
    dsq = distance(through, targetcenter)^2
    if isless(dsq, 10e-6) # coincident
        return (0, O, O)
    else
        sqinv = 0.5 / dsq
        s = dsq - ((2radius + targetradius) * targetradius)
        root = 4(radius^2) * dsq - s^2
        s *= sqinv
        if isless(dsq, 0.0) # no center possible
            return (0, O, O)
        else
            if isless(root, 10e-6) # only one circle possible
                x = through.x + distx * s
                y = through.y + disty * s
                if isless(abs(distance(through, Point(x, y)) - radius), 10e-6)
                    return (1, Point(x, y), O)
                else
                    return (0, O, O)
                end
            else # two circles are possible
                root = sqrt(root) * sqinv
                xconst = through.x + distx * s
                yconst = through.y + disty * s
                xvar = disty * root
                yvar = distx * root
                return (2, Point(xconst - xvar, yconst + yvar), Point(xconst + xvar, yconst - yvar))
            end
        end
    end
end

"""
    circletangent2circles(radius, circle1center::Point, circle1radius, circle2center::Point, circle2radius)

Find the centers of up to two circles of radius `radius` that are tangent to the
two circles defined by `circle1...` and `circle2...`. These two circles can
overlap, but one can't be inside the other.

  - (0, O, O)      - no such circles exist
  - (1, pt1, O)    - 1 circle exists, centered at pt1
  - (2, pt1, pt2)  - 2 circles exist, with centers at pt1 and pt2

(The O are just dummy points so that three values are always returned.)
"""
function circletangent2circles(radius, circle1center::Point, circle1radius, circle2center::Point, circle2radius)
    modradius1 = radius + circle1radius
    modradius2 = circle2radius - circle1radius
    return circlepointtangent(circle1center, modradius1, circle2center, modradius2)
end

"""
    arc2sagitta(p1::Point, p2::Point, s;
        action=:none)

Make a clockwise arc starting at `p1` and ending at `p2`
that reaches a height of `s`, the sagitta, at the middle,
and add it to the current path.

Return tuple of the center point and the radius of the arc.
"""
function arc2sagitta(p1::Point, p2::Point, s::Real;
    action = :none)
    if isapprox(s, 0.0)
        throw(error("Height of arc $s should be greater than 0.0"))
    end
    l = distance(p1, p2) / 2
    r = (s^2 + l^2) / 2s
    flag, ip1, ip2 = intersectioncirclecircle(p1, r, p2, r)
    if flag
        if r <= s
            arc2r(ip1, p1, p2, action = action)
            result = (ip1, r)
        else
            arc2r(ip2, p1, p2, action = action)
            result = (ip2, r)
        end
    else
        result = (O, 0.0)
    end
    return result
end

arc2sagitta(p1::Point, p2::Point, s::Real, action::Symbol) = arc2sagitta(p1, p2, s; action = action)

"""
    carc2sagitta(p1::Point, p2::Point, s;
        action=:none)

Make a counterclockwise arc starting at `p1` and ending at
`p2` that reaches a height of `s`, the sagitta, at the
middle, and add it to the current path.

Return tuple of center point and radius of arc.
"""
function carc2sagitta(p1::Point, p2::Point, s::Real;
    action = :none)
    if isapprox(s, 0.0)
        throw(error("Height of arc $s should be greater than 0.0"))
    end
    l = distance(p1, p2) / 2
    r = (s^2 + l^2) / 2s
    flag, ip1, ip2 = intersectioncirclecircle(p1, r, p2, r)
    if flag
        if r <= s
            carc2r(ip2, p1, p2, action = action)
            result = (ip1, r)
        else
            carc2r(ip1, p1, p2, action = action)
            result = (ip2, r)
        end
    else
        result = (O, 0.0)
    end
    return result
end

carc2sagitta(p1::Point, p2::Point, s::Real, action::Symbol) = carc2sagitta(p1, p2, s; action = action)

"""
    circlecircleoutertangents(cpt1::Point, r1, cpt2::Point, r2)

Return four points, `p1`, `p2, `p3`, `p4`, where a line through `p1`and`p2`,
and a line through `p3`and`p4`, form the outer tangents to the circles defined
by `cpt1/r1`and`cpt2/r2`.

Returns four identical points (`O`) if one of the circles lies inside the other.
"""
function circlecircleoutertangents(cpt1::Point, r1, cpt2::Point, r2)
    dx = cpt2.x - cpt1.x
    dy = cpt2.y - cpt1.y
    dist = distance(cpt1, cpt2)

    if dist <= abs(r2 - r1)
        # the circles overlap, no tangents
        @debug "circlecircleoutertangents: circles overlap"
        return O, O, O, O
    end

    # rotation from the x-axis.
    angle1 = atan(dy, dx)

    # relative angle of the normals
    angle2 = acos((r1 - r2) / dist)

    pt1 = Point(cpt1.x + r1 * cos(angle1 + angle2),
        cpt1.y + r1 * sin(angle1 + angle2))

    pt2 = Point(cpt2.x + r2 * cos(angle1 + angle2),
        cpt2.y + r2 * sin(angle1 + angle2))

    pt3 = Point(cpt1.x + r1 * cos(angle1 - angle2),
        cpt1.y + r1 * sin(angle1 - angle2))

    pt4 = Point(cpt2.x + r2 * cos(angle1 - angle2),
        cpt2.y + r2 * sin(angle1 - angle2))

    return pt1, pt2, pt3, pt4
end

"""
    pointcircletangent(point::Point, circlecenter::Point, circleradius)

Find the two points on a circle that lie on tangent lines
passing through an external point.

If both points are O, the external point is inside the
circle, and the result is `(O, O)`.
"""
function pointcircletangent(point::Point, circlecenter::Point, circleradius)
    d = distance(circlecenter, point)
    if d <= circleradius # isinside
        @debug "pointcircletangent: external point is inside circle"
        # for type stability, return two points anyway?
        return O, O
    end
    dx, dy = point.x - circlecenter.x, point.y - circlecenter.y
    dxr, dyr = -dy, dx # rotate
    ρ = circleradius / d
    ad = ρ^2
    bd = ρ * sqrt(1 - ρ^2)
    tangentpoint1x = circlecenter.x + (ad * dx) + (bd * dxr)
    tangentpoint1y = circlecenter.y + (ad * dy) + (bd * dyr)
    tangentpoint2x = circlecenter.x + (ad * dx) - (bd * dxr)
    tangentpoint2y = circlecenter.y + (ad * dy) - (bd * dyr)
    return Point(tangentpoint1x, tangentpoint1y), Point(tangentpoint2x, tangentpoint2y)
end

"""
    circlecircleinnertangents(circle1center::Point, circle1radius, circle2center::Point, circle2radius)

Find the inner tangents of two circles. These are tangent lines that
cross as they skim past one circle and touch the other.

Returns the four points: tangentpoint1 on circle 1,
tangentpoint1 on circle2, tangentpoint2 on circle 1,
tangentpoint2 on circle2.

Returns `(O, O, O, O)` if inner tangents can't be found (eg when the circles overlap).

Use `circlecircleoutertangents()` to find the outer tangents.
"""
function circlecircleinnertangents(circle1center::Point, circle1radius, circle2center::Point, circle2radius)
    # point where the inner tangents will cross
    ip = (circle2center * circle1radius + circle1center * circle2radius) / (circle1radius + circle2radius)
    d = distance(circle1center, circle2center)
    # circles overlap?
    d <= (circle1radius + circle2radius) && return O, O, O, O
    tp1, tp2 = pointcircletangent(ip, circle1center, circle1radius)
    tp3, tp4 = pointcircletangent(ip, circle2center, circle2radius)
    # double check tp1 and tp3 are collinear, just in case the order was wrong
    if slope(tp1, ip) ≈ slope(ip, tp3)
        return tp1, tp3, tp2, tp4
    elseif slope(tp1, ip) ≈ slope(ip, tp4)
        return tp1, tp4, tp2, tp3
    end
end

"""
    ellipseinquad(qgon; action=:none)
    ellipseinquad(qgon, action)

Calculate a Bézier-based ellipse that fits inside the
quadrilateral `qgon`, an array with at least four Points
that form a convex polygon, and add it to the current path.

It returns `ellipsecenter, ellipsesemimajor, ellipsesemiminor, ellipseangle`:

  - `ellipsecenter` the ellipse center
  - `ellipsesemimajor` ellipse semimajor axis
  - `ellipsesemiminor` ellipse semiminor axis
  - `ellipseangle` ellipse rotation

The function returns `O, 0, 0, 0` if a suitable ellipse
can't be found. (The qgon is probably not a convex polygon.)

## Examples

```julia
ellipseinquad(box(O, 130, 130); action = :stroke)
```

```julia
ellipseinquad(box(O, 140, 230), :stroke)
```

### References

http://faculty.mae.carleton.ca/John_Hayes/Papers/InscribingEllipse.pdf
"""
function ellipseinquad(qgon;
    action = :none)
    p1, p2, p3, p4 = qgon
    length(unique([p1, p2, p3, p4])) != 4 && throw(error("ellipseinquad() the 4 points must be different: $(qgon)"))
    if !ispolyclockwise(qgon)
        reverse!(qgon)
    end
    if !ispolyconvex(qgon)
        return O, 0, 0, 0
    end
    r = [p1.x, p1.y, 1]
    s = [p2.x, p2.y, 1]
    t = [p3.x, p3.y, 1]
    u = [p4.x, p4.y, 1]

    # Create the 'projective collineation' matrix
    # whatever that is
    e1 = s[1] * t[1] * u[2] - r[1] * t[1] * u[2] - s[1] * t[2] * u[1] + r[1] * t[2] * u[1] - r[1] * s[2] * u[1] + r[2] * s[1] * u[1] + r[1] * s[2] * t[1] - r[2] * s[1] * t[1]
    e2 = r[1] * t[1] * u[2] - r[1] * s[1] * u[2] - s[1] * t[2] * u[1] + s[2] * t[1] * u[1] - r[2] * t[1] * u[1] + r[2] * s[1] * u[1] + r[1] * s[1] * t[2] - r[1] * s[2] * t[1]
    e3 = s[1] * t[1] * u[2] - r[1] * s[1] * u[2] - r[1] * t[2] * u[1] - s[2] * t[1] * u[1] + r[2] * t[1] * u[1] + r[1] * s[2] * u[1] + r[1] * s[1] * t[2] - r[2] * s[1] * t[1]
    e4 = s[2] * t[1] * u[2] - r[2] * t[1] * u[2] - r[1] * s[2] * u[2] + r[2] * s[1] * u[2] - s[2] * t[2] * u[1] + r[2] * t[2] * u[1] + r[1] * s[2] * t[2] - r[2] * s[1] * t[2]
    e5 = -s[1] * t[2] * u[2] + r[1] * t[2] * u[2] + s[2] * t[1] * u[2] - r[1] * s[2] * u[2] - r[2] * t[2] * u[1] + r[2] * s[2] * u[1] + r[2] * s[1] * t[2] - r[2] * s[2] * t[1]
    e6 = s[1] * t[2] * u[2] - r[1] * t[2] * u[2] + r[2] * t[1] * u[2] - r[2] * s[1] * u[2] - s[2] * t[2] * u[1] + r[2] * s[2] * u[1] + r[1] * s[2] * t[2] - r[2] * s[2] * t[1]
    e7 = s[1] * u[2] - r[1] * u[2] - s[2] * u[1] + r[2] * u[1] - s[1] * t[2] + r[1] * t[2] + s[2] * t[1] - r[2] * t[1]
    e8 = t[1] * u[2] - s[1] * u[2] - t[2] * u[1] + s[2] * u[1] + r[1] * t[2] - r[2] * t[1] - r[1] * s[2] + r[2] * s[1]
    e9 = t[1] * u[2] - r[1] * u[2] - t[2] * u[1] + r[2] * u[1] + s[1] * t[2] - s[2] * t[1] + r[1] * s[2] - r[2] * s[1]
    mat = [e1 e2 e3; e4 e5 e6; e7 e8 e9]
    matinv = inv(mat)
    #  coefficients of the ellipse equation ax2 + 2bxy + cy2 + 2dx + 2fy + g = 0
    a = matinv[1, 1] * matinv[1, 1] + matinv[2, 1] * matinv[2, 1] - matinv[3, 1] * matinv[3, 1]
    b = matinv[1, 1] * matinv[1, 2] + matinv[2, 1] * matinv[2, 2] - matinv[3, 1] * matinv[3, 2]
    c = matinv[1, 2] * matinv[1, 2] + matinv[2, 2] * matinv[2, 2] - matinv[3, 2] * matinv[3, 2]
    d = matinv[1, 1] * matinv[1, 3] + matinv[2, 1] * matinv[2, 3] - matinv[3, 1] * matinv[3, 3]
    f = matinv[1, 2] * matinv[1, 3] + matinv[2, 2] * matinv[2, 3] - matinv[3, 2] * matinv[3, 3]
    g = matinv[1, 3] * matinv[1, 3] + matinv[2, 3] * matinv[2, 3] - matinv[3, 3] * matinv[3, 3]

    #  ellipse centre
    b2ac = b * b - a * c
    ellipsecenter = Point((c * d - b * f) / b2ac, (a * f - b * d) / b2ac)

    #  axes
    k = 2(a * f * f + c * d * d + g * b * b - 2 * b * d * f - a * c * g) / b2ac
    ac24b2 = sqrt((a - c) * (a - c) + 4b * b)
    ellipsesemimajor = sqrt(abs(k / abs(ac24b2 - a - c)))
    ellipsesemiminor = sqrt(abs(k / abs(-ac24b2 - a - c)))

    #  rotation angle
    if b == 0
        ellipseangle = (a < c) ? 0 : π / 2
    else
        ellipseangle = (a < c) ? 0.5 * atan(2b / (a - c)) : π / 2 + 0.5 * atan(2b / (a - c))
    end

    # finally
    @layer begin
        translate(ellipsecenter)
        rotate(ellipseangle)
        ellipse(O, 2ellipsesemimajor, 2ellipsesemiminor, action = action)
    end
    return ellipsecenter, ellipsesemimajor, ellipsesemiminor, ellipseangle
end

ellipseinquad(qgon, action) = ellipseinquad(qgon, action = action)

"""
    crescent(pos, innerradius, outeradius;
        action=nothing,
        vertices=false,
        reversepath=false,
        steps = 30)

Create a crescent-shaped polygon, aligned with the current
x-axis, and add it to the current path. If the inner radius
is 0, you'll get a semicircle.

See also `crescent(pos1, innerradius, pos2, outeradius...)`.

## Examples

Create a filled crescent shape with outer radius of 200, inner radius of 130.

```julia
crescent(O, 130, 200, :fill) # or
crescent(O, 130, 200, action=:fill)
```

Create a stroked crescent shape - the inner radius of 0
produces a semicircle - and add it to the current path.

```julia
crescent(O, 0, 200, :stroke) # or
crescent(O, 0, 200, action=:stroke)
```
"""
function crescent(pos::Point, innerradius::Real, outerradius::Real;
    action = nothing,
    vertices = false,
    reversepath = false,
    steps = 30)
    Δ = π / steps
    ptlist = Point[]
    move(pos + Point(innerradius * sin(0), outerradius * cos(0)))
    push!(ptlist, currentpoint())
    for i in 1:steps
        pt = pos + Point(innerradius * sin(Δ * i), outerradius * cos(Δ * i))
        push!(ptlist, pt)
    end
    for i in 1:steps
        pt = pos + Point(outerradius * sin(π - (Δ * i)), outerradius * cos(π - (Δ * i)))
        push!(ptlist, pt)
    end
    if !vertices
        poly(ptlist, action, close = true, reversepath = reversepath)
    end
    return ptlist
end

crescent(pos::Point, innerradius::Real, outerradius::Real, action::Symbol;
    vertices = false,
    reversepath = false,
    steps = 30) = crescent(pos, innerradius, outerradius;
    action = action,
    vertices = vertices,
    reversepath = reversepath,
    steps = steps)

"""
    crescent(cp1, r1, cp2, r2;
        action=nothing,
        vertices=false,
        reversepath=false)

Create a crescent-shaped polygon, aligned with the current
x-axis, by finding the intersection of two circles, and add
it to the current path. The two center positions should be
different.

See also `crescent(point, innerradius, outeradius...)`.

## Examples

Create a filled crescent shape from two circles.

```julia
crescent(O, 100, O + (60, 0), 150, :fill) # or
crescent(O, 100, O + (60, 0), 150, action=:fill)
```
"""
function crescent(cp1::Point, r1::Real, cp2::Point, r2::Real;
    action = nothing,
    vertices = false,
    reversepath = false)
    flag, ip1, ip2 = intersectioncirclecircle(cp1, r1, cp2, r2)
    if flag
        move(ip2)
        carc(cp2, r2, slope(cp2, ip2), slope(cp2, ip1), action = :path)
        arc(cp1, r1, slope(cp1, ip1), slope(cp1, ip2), action = :path)
        ptlist = pathtopoly()[1]
        if !vertices
            poly(ptlist, action, close = true, reversepath = reversepath)
        end
        return ptlist
    else
        @info "crescent(): the two arcs won't intersect "
    end
end

crescent(cp1::Point, r1::Real, cp2::Point, r2::Real, action::Symbol;
    vertices = false,
    reversepath = false) = crescent(cp1, r1, cp2, r2;
    action = action,
    vertices = vertices,
    reversepath = reversepath)
# eof

"""
    polysuper(center::Point = Point(0, 0);
        n1 = 1,
        n2 = 1,
        n3 = 1,
        m = 2,
        a = 1,
        b = 1,
        radius = 100,
        action = :none,
        vertices = false,
        reversepath = false,
        stepby = π / 120)

Build a supershape, a generalization of the superellipse, and apply `action`.

Based upon equations by Johan Gielis.

See also: `squircle()`...

## Example

```julia
polysuper(m=4,
    n1=13, n2=11, n3=3,
    a=3, b=4,
    action=:fill,
    radius=200)
```

produces a weird eye/lemon shape, a bit like this:

```plain
                        @@@@@@S
                  @@@@@@@@@@@@@@@@@@
               @@@@@@@@@@@@@@@@@@@@@@@@
            R@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
          @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
      @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
   @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
     @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
         @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
            @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
              E@@@@@@@@@@@@@@@@@@@@@@@@@
                  @@@@@@@@@@@@@@@@@@o
                      @@@@@@@@@@
```
"""
function polysuper(center::Point = Point(0, 0);
        n1 = 1,
        n2 = 1,
        n3 = 1,
        m = 2,
        a = 1,
        b = 1,
        radius = 100,
        action = :none,
        vertices = false,
        reversepath = false,
        stepby = π / 120)

    points = Point[]
    for theta in 0:stepby:(2π - stepby)
        t1 = abs(cos((m / 4) * theta) / a)
        t1 = t1^n2
        t2 = abs(sin((m / 4) * theta) / b)
        t2 = t2^n3
        r = min(10e12, (t1 + t2)^(1 / n1)) # clip
        if abs(r) < 10e-3
            pt = center + Point(0, 0)
        else
            r = 1 / r
            pt = center + Point(radius * r * cos(theta), radius * r * sin(theta))
        end
        push!(points, pt)
    end
    result = reversepath ? reverse(points) : points
    if !vertices
        poly(result, action, close = true)
    end
    return result
end

# get current versions of packages from registry
# https://github.com/JuliaLang/Pkg.jl/issues/3926

import Pkg: Pkg, API, Operations, Registry

function search(pkgname; min_version=v"0.0.0", max_version=nothing)
    registries = Registry.reachable_registries()
    reg_ind = findfirst(r -> r.name == "General", registries)
    reg = registries[reg_ind]
    pkguuids_in_registry = collect(keys(reg.pkgs))
    pkgnames_in_registry = [reg.pkgs[key].name for key in pkguuids_in_registry]

    pkgname_ind = findfirst(==(pkgname), pkgnames_in_registry)
    pkguuid = pkguuids_in_registry[pkgname_ind]

    reg_pkg = get(reg, pkguuid, nothing)  # Pkg.Registry.PkgEntry

    info = Registry.registry_info(reg_pkg)
    reg_compat_info = Registry.compat_info(info)
    versions = keys(reg_compat_info)
    versions = Base.filter(v -> !Registry.isyanked(info, v), collect(versions))
    versions_sorted = sort(versions, rev=true)

    # filter between min_version and max_version
    max_version = isnothing(max_version) ? maximum(versions_sorted; init=v"0") : max_version
    filter!(v -> min_version <= v <= max_version, versions_sorted)

    version_list = versions_sorted[1:min(3, length(versions_sorted))]
    pkg_url = info.repo

    # Prints what is shown above
    print("Package '$pkgname' ")
    println("$(join(version_list, ", ")) ... ")
    nothing
end

for pk in ["Aqua",
     #"Base64",
     "Cairo","Colors","DataStructures",
     #"Dates",
     "FFMPEG","FileIO","ImageIO","LaTeXStrings","MathTeXEngine","PolygonAlgorithms","PrecompileTools",
    #"Random",
     "Rsvg",
     #"Test"
     ]

    search(pk)
end 

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function drawdot(pos)
    gsave()
    sethue("red")
    circle(pos, 5, :fill)
    grestore()
end

function showt(c, p, ha, va, n)
  text(c, p, halign=ha, valign=va)
  gsave()
  setopacity(0.1)
  text(string(n), p, angle=0)
  grestore()
end

function text_alignment_tests(fname)
    legend = String[]
    Drawing(1400, 1400, fname)
    origin()
    setopacity(0.8)
    sethue("black")
    fontsize(65)
    tiles = Tiler(1000, 1000, 4, 3, margin=50)
    # Test for :centre (synonym for :center) works, and unknown is treated as :left
    haligns = (:left, :center, :right, :centre, :foo)
    # Test for unknown is treated as :baseline
    valigns = (:baseline, :top, :middle, :bottom, :bar)
    current_h = 1
    current_v = 1
    for (pos, n) in tiles
        gsave()
        h = haligns[current_h]
        v = valigns[current_v]
        drawdot(pos)
        showt("Å˰̀Ά", pos, h, v, n)
        grestore()
        push!(legend, "$n h: $h v: $v")
        current_h += 1
        if current_h > 5
            current_v += 1
            current_h = 1
        end
        if current_v > 5
            break
        end
    end
    fontsize(8)
    text(join(legend, "; "), 0, 600, halign=:center)
    @test finish() == true
    println("...finished test: output in $(fname)")
end

text_alignment_tests("text-alignment-tests.pdf")

mutable struct Drawing
    width::Float64
    height::Float64
    filename::AbstractString
    surface::CairoSurface
    cr::CairoContext
    surfacetype::Symbol
    redvalue::Float64
    greenvalue::Float64
    bluevalue::Float64
    alpha::Float64
    buffer::IOBuffer
    strokescale::Bool

    function Drawing(img::Matrix{T}, f::AbstractString = ""; strokescale = false) where {T<:Union{RGB24,ARGB32}}
        w, h = size(img)
        iobuf = IOBuffer(UInt8[], read = true, write = true)
        the_surfacetype = :image
        the_surface = Cairo.CairoImageSurface(img)
        the_cr = Cairo.CairoContext(the_surface)
        currentdrawing = new(w, h, f, the_surface, the_cr, the_surfacetype, 0.0, 0.0, 0.0, 1.0, iobuf, strokescale)
        if !isassigned(_current_drawing(), _current_drawing_index())
            push!(_current_drawing(), currentdrawing)
            _current_drawing_index(lastindex(_current_drawing()))
        else
            _current_drawing()[_current_drawing_index()] = currentdrawing
        end
        return currentdrawing
    end

    function Drawing(w, h, stype::Symbol, f::AbstractString = ""; strokescale = false)
        iobuf = IOBuffer(UInt8[], read = true, write = true)
        the_surfacetype = stype
        if stype == :pdf
            the_surface = Cairo.CairoPDFSurface(iobuf, w, h)
        elseif stype == :png # default to PNG
            the_surface = Cairo.CairoARGBSurface(w, h)
        elseif stype == :eps
            the_surface = Cairo.CairoEPSSurface(iobuf, w, h)
        elseif stype == :svg
            the_surface = Cairo.CairoSVGSurface(iobuf, w, h)
        elseif stype == :rec
            if isnan(w) || isnan(h)
                the_surface = Cairo.CairoRecordingSurface()
            else
                extents = Cairo.CairoRectangle(0.0, 0.0, w, h)
                bckg = Cairo.CONTENT_COLOR_ALPHA
                the_surface = Cairo.CairoRecordingSurface(bckg, extents)
                # Both the CairoSurface and the Drawing stores w and h in mutable structures.
                # Cairo.RecordingSurface does not set the w and h properties,
                # probably because that could be misinterpreted (width and height
                # does not tell everything).
                # However, the image_as_matrix() function uses Cairo's values instead of Luxor's.
                # Setting these values here is the less clean, less impact solution. NOTE: Switch back
                # if revising image_as_matrix to use Drawing: width, height.
                the_surface.width = w
                the_surface.height = h
            end
        elseif stype == :image
            the_surface = Cairo.CairoImageSurface(w, h, Cairo.FORMAT_ARGB32)
        else
            error("Unknown Luxor surface type \"$stype\"")
        end
        the_cr = Cairo.CairoContext(the_surface)
        # @info("drawing '$f' ($w w x $h h) created in $(pwd())")
        currentdrawing = new(w, h, f, the_surface, the_cr, the_surfacetype, 0.0, 0.0, 0.0, 1.0, iobuf, strokescale)
        if !isassigned(_current_drawing(), _current_drawing_index())
            push!(_current_drawing(), currentdrawing)
            _current_drawing_index(lastindex(_current_drawing()))
        else
            _current_drawing()[_current_drawing_index()] = currentdrawing
        end
        return currentdrawing
    end
end

# we need a thread safe way to store a global stack of drawings and the current active index into this stack
#  access to the stack is only possible using the global functions:
#   - predefine all needed Dict entries in a thread safe way
#   - each thread has it's own stack, separated by threadid
# this is not enough for Threads.@spawn (TODO, but no solution yet)
let _CURRENTDRAWINGS = Ref{Dict{Int,Union{Vector{Drawing},Nothing}}}(Dict(0 => nothing)),
    _CURRENTDRAWINGINDICES = Ref{Dict{Int,Int}}(Dict(0 => 0))

    global _current_drawing
    function _current_drawing()
        id = Threads.threadid()
        if !haskey(_CURRENTDRAWINGS[], id)
            # predefine all needed Dict entries
            lc = ReentrantLock()
            lock(lc)
            for preID in 1:Threads.nthreads()
                _CURRENTDRAWINGS[][preID] = Vector{Drawing}()
            end
            unlock(lc)
        end
        if isnothing(_CURRENTDRAWINGS[][id])
            # all Dict entries are predefined, so we should never reach this error
            error("(1)thread id should be preallocated")
        end
        # thread specific stack
        return _CURRENTDRAWINGS[][id]
    end
    global _current_drawing_index
    function _current_drawing_index()
        id = Threads.threadid()
        if !haskey(_CURRENTDRAWINGINDICES[], id)
            # predefine all needed Dict entries
            lc = ReentrantLock()
            lock(lc)
            for preID in 1:Threads.nthreads()
                _CURRENTDRAWINGINDICES[][preID] = 0
            end
            unlock(lc)
        end
        if isnothing(_CURRENTDRAWINGINDICES[][id])
            # all Dict entries are predefined, so we should never reach this error
            error("(2)thread id should be preallocated")
        end
        # thread specific current index
        return _CURRENTDRAWINGINDICES[][id]
    end
    function _current_drawing_index(i::Int)
        id = Threads.threadid()
        if !haskey(_CURRENTDRAWINGINDICES[], id)
            # predefine all needed Dict entries
            lc = ReentrantLock()
            lock(lc)
            for preID in 1:Threads.nthreads()
                _CURRENTDRAWINGINDICES[][preID] = 0
            end
            unlock(lc)
        end
        if isnothing(_CURRENTDRAWINGINDICES[][id])
            # all Dict entries are predefined, so we should never reach this error
            error("(3)thread id should be preallocated")
        end
        # set and return the thread specific current index
        _CURRENTDRAWINGINDICES[][id] = i
    end
    global _reset_all_drawings
    function _reset_all_drawings()
        empty!(_CURRENTDRAWINGS[])
        empty!(_CURRENTDRAWINGINDICES[])
        return true
    end
end

# utility functions that access the internal current Cairo drawing object, which is
# stored as item at index _current_drawing_index() in a constant global array

function _get_current_drawing_save()
    # check if drawing is not corrupted (has been observed using PrecompileTools)
    #   checking fields:
    #     surface::CairoSurface
    #     cr::CairoSurface
    #   not checked but perhaps needed:
    #     buffer::IOBuffer
    if _current_drawing_index() <= 0 ||
       (
        _current_drawing_index() > 0 &&
        getfield(getfield(_current_drawing()[_current_drawing_index()], :cr), :ptr) == C_NULL &&
        getfield(getfield(_current_drawing()[_current_drawing_index()], :surface), :ptr) == C_NULL &&
        1 == 1
    )
        error("There isn't a current drawing. Create one with `Drawing()` or one of the `@draw`/`@png` etc macros.")
    end
    return _current_drawing()[_current_drawing_index()]
end

function _get_current_cr()
    getfield(_get_current_drawing_save(), :cr)
end

_get_current_redvalue()   = getfield(_get_current_drawing_save(), :redvalue)
_get_current_greenvalue() = getfield(_get_current_drawing_save(), :greenvalue)
_get_current_bluevalue()  = getfield(_get_current_drawing_save(), :bluevalue)
_get_current_alpha()      = getfield(_get_current_drawing_save(), :alpha)
function _get_current_color()
    d = _get_current_drawing_save()
    return (
        getfield(d, :redvalue),
        getfield(d, :greenvalue),
        getfield(d, :bluevalue),
        getfield(d, :alpha),
    )
end
function _get_current_cr_color()
    d = _get_current_drawing_save()
    return (
        getfield(d, :cr),
        getfield(d, :redvalue),
        getfield(d, :greenvalue),
        getfield(d, :bluevalue),
        getfield(d, :alpha),
    )
end

_set_current_redvalue(r)   = setfield!(_get_current_drawing_save(), :redvalue, convert(Float64, r))
_set_current_greenvalue(g) = setfield!(_get_current_drawing_save(), :greenvalue, convert(Float64, g))
_set_current_bluevalue(b)  = setfield!(_get_current_drawing_save(), :bluevalue, convert(Float64, b))
_set_current_alpha(a)      = setfield!(_get_current_drawing_save(), :alpha, convert(Float64, a))
function _set_current_color(r, g, b, a)
    _set_current_color(r, g, b)
    d = _get_current_drawing_save()
    setfield!(d, :redvalue, convert(Float64, r))
    setfield!(d, :greenvalue, convert(Float64, g))
    setfield!(d, :bluevalue, convert(Float64, b))
    setfield!(d, :alpha, convert(Float64, a))
end
function _set_current_color(r, g, b)
    d = _get_current_drawing_save()
    setfield!(d, :redvalue, convert(Float64, r))
    setfield!(d, :greenvalue, convert(Float64, g))
    setfield!(d, :bluevalue, convert(Float64, b))
end

_current_filename()     = getfield(_get_current_drawing_save(), :filename)
_current_width()        = getfield(_get_current_drawing_save(), :width)
_current_height()       = getfield(_get_current_drawing_save(), :height)
_current_surface()      = getfield(_get_current_drawing_save(), :surface)
_current_surface_ptr()  = getfield(getfield(_get_current_drawing_save(), :surface), :ptr)
_current_surface_type() = getfield(_get_current_drawing_save(), :surfacetype)

_current_buffer()     = getfield(_get_current_drawing_save(), :buffer)

_get_current_strokescale() = getfield(_get_current_drawing_save(), :strokescale)
_set_current_strokescale(s) = setfield!(_get_current_drawing_save(), :strokescale, s)

"""
    Luxor._drawing_indices()

Get a UnitRange over all available indices of drawings.

With Luxor you can work on multiple drawings simultaneously. Each drawing is stored
in an internal array. The first drawing is stored at index 1 when you start a
drawing with `Drawing(...)`. To start a second drawing you call `Luxor._set_next_drawing_index()`,
which returns the new index. Calling another `Drawing(...)` stores the second drawing
at this new index. `Luxor._set_next_drawing_index()` will return and set the next available index
which is available for a new drawing. This can be a new index at the end of drawings, or,
if you already finished a drawing with `finish()`, the index of this finished drawing.
To specify on which drawing the next graphics command should be applied you call
`Luxor._set_drawing_index(i)`. All successive Luxor commands work on this drawing.
With `Luxor._get_drawing_index()` you get the current active drawing index.

Multiple drawings is especially helpful for interactive graphics with live windows
like MiniFB.

Example:

```julia
using Luxor
Drawing(500, 500, "1.svg")
origin()
setcolor("red")
circle(Point(0, 0), 100, action = :fill)

Luxor._drawing_indices()               # returns 1:1

Luxor._get_next_drawing_index()        # returns 2 but doesn't change current drawing
Luxor._set_next_drawing_index()        # returns 2 and sets current drawing to it
Drawing(500, 500, "2.svg")
origin()
setcolor("green")
circle(Point(0, 0), 100, action = :fill)

Luxor._drawing_indices()               # returns 1:2
Luxor._set_drawing_index(1)            # returns 1

finish()
preview()                              # presents the red circle 1.svg

Luxor._drawing_indices()               # returns 1:2
Luxor._set_next_drawing_index()        # returns 1 because drawing 1 was finished before

Drawing(500, 500, "3.svg")
origin()
setcolor("blue")
circle(Point(0, 0), 100, action = :fill)

finish()
preview()                              # presents the blue circle 3.svg

Luxor._set_drawing_index(2)            # returns 2
finish()
preview()                              # presents the green circle 2.svg

Luxor._drawing_indices()               # returns 1:2, but all are finished
Luxor._set_drawing_index(1)            # returns 1

preview()                              # presents the blue circle 3.svg again

Luxor._set_drawing_index(10)           # returns 1 as 10 does not existing
Luxor._get_drawing_index()             # returns 1
Luxor._get_next_drawing_index()        # returns 1, because 1 was finished
```
"""
_drawing_indices() = length(_current_drawing()) == 0 ? (1:1) : (1:length(_current_drawing()))

"""
    Luxor._get_drawing_index()

Returns the index of the current drawing. If there isn't any drawing yet returns 1.
"""
_get_drawing_index() = _current_drawing_index() == 0 ? 1 : _current_drawing_index()

"""
    Luxor._set_drawing_index(i::Int)

Set the active drawing for successive graphic commands to index i if exist. if index i doesn't exist,
the current drawing is unchanged.

Returns the current drawing index.

Example:

```julia
next_index = 5
if Luxor._set_drawing_index(next_index) == next_index
    # do some additional graphics on the existing drawing
    ...
else
    @warn "Drawing "*string(next_index)*" doesn't exist"
end
```
"""
function _set_drawing_index(i::Int)
    if isassigned(_current_drawing(), i)
        _current_drawing_index(i)
    end
    return _get_drawing_index()
end

"""
    Luxor._get_next_drawing_index()

Returns the next available drawing index. This can either be a new index or an existing
index where a finished (`finish()`) drawing was stored before.
"""
function _get_next_drawing_index()
    i = 1
    if isempty(_current_drawing())
        return i
    end
    i = findfirst(x -> getfield(getfield(x, :surface), :ptr) == C_NULL, _current_drawing())
    if isnothing(i)
        return _current_drawing_index() + 1
    else
        return i
    end
end

"""
    Luxor._set_next_drawing_index()

Set the current drawing to the next available drawing index. This can either be a new index or an existing
index where a finished (`finish()`) drawing was stored before.

Returns the current drawing index.
"""
function _set_next_drawing_index()
    if _has_drawing()
        _current_drawing_index(_get_next_drawing_index())
    else
        return _get_next_drawing_index()
    end
    return _current_drawing_index()
end

"""
    Luxor._has_drawing()

Returns true if there is a current drawing available or finished, otherwise false.
"""
function _has_drawing()
    return _current_drawing_index() != 0
end

"""
    currentdrawing(d::Drawing)

Sets and returns the current Luxor drawing overwriting an existing drawing if exists.
"""
function currentdrawing(d::Drawing)
    if !isassigned(_current_drawing(), _current_drawing_index())
        push!(_current_drawing(), d)
        _current_drawing_index(lastindex(_current_drawing()))
    else
        _current_drawing()[_current_drawing_index()] = d
    end
    return d
end

"""
    currentdrawing()

Return the current Luxor drawing, if there currently is one.
"""
function currentdrawing()
    if !isassigned(_current_drawing(), _current_drawing_index()) ||
       isempty(_current_drawing()) ||
       _current_surface_ptr() == C_NULL ||
       false
        # Already finished or not even started
        @info "There is no current drawing"
        return false
    else
        return _current_drawing()[_current_drawing_index()]
    end
end

# How Luxor output works. You start by creating a drawing
# either aimed at a file (PDF, EPS, PNG, SVG) or aimed at an
# in-memory buffer (:svg, :png, :rec, or :image); you could be
# working in Jupyter or Pluto or Atom, or a terminal, and on
# either Mac, Linux, or Windows.  (The @svg/@png/@pdf macros
# are shortcuts to file-based drawings.) When a drawing is
# finished, you go `finish()` (that's the last line of the
# @... macros.). Then, if you want to actually see it, you
# go `preview()`, which returns the current drawing.

# Then the code has to decide where you're working, and what
# type of file it is, then sends it to the right place,
# depending on the OS.

function Base.show(io::IO, ::MIME"text/plain", d::Drawing)
    @debug "show MIME:text/plain"
    
    # IJulia call the `show` function twice: once for
    # the image MIME and a second time for the text/plain MIME.
    # We check if this is such a 'second call':
    if get(io, :jupyter, false) &&
        (d.surfacetype == :svg || d.surfacetype == :png)
        return d.filename
    end

    if (isdefined(Main, :VSCodeServer) && Main.VSCodeServer.PLOT_PANE_ENABLED[]) && (d.surfacetype == :svg || d.surfacetype == :png)
        return d.filename
    end

    # perhaps drawing hasn't started yet, eg in the REPL
    if !ispath(d.filename)
        location = !isempty(d.filename) ? d.filename : "in memory"
        println(" Luxor drawing: (type = :$(d.surfacetype), width = $(d.width), height = $(d.height), location = $(location))")
    else
        returnvalue = d.filename
        # open the image file
        if Sys.isapple()
            run(`open $(returnvalue)`)
        elseif Sys.iswindows()
            cmd = get(ENV, "COMSPEC", "cmd")
            run(`$(ENV["COMSPEC"]) /c start $(returnvalue)`)
        elseif Sys.isunix()
            run(`xdg-open $(returnvalue)`)
        end
    end
end

"""
    tidysvg(fname)

Read the SVG image in `fname` and write it to a file
`fname-tidy.svg` with modified glyph names.

Return the name of the modified file.

SVG images use 'named defs' for text, which cause errors
problem when used in browsers and notebooks.
See [this github issue](https://github.com/jupyter/notebook/issues/333) for
details.

A kludgy workround is to rename the elements.
"""
function tidysvg(fname)
    # I pinched this from Simon's RCall.jl
    path, ext = splitext(fname)
    outfile = ""
    if ext == ".svg"
        outfile = "$(path * "-tidy" * ext)"
        open(fname) do f
            # random alpha strings
            r = join(Char.(append!(rand(65:90, 6), rand(97:122, 6))))
            d = read(f, String)
            d = replace(d, "id=\"glyph" => "id=\"glyph" * r)
            d = replace(d, "href=\"#glyph" => "href=\"#glyph" * r)
            open(outfile, "w") do out
                write(out, d)
            end
            @debug "modified SVG file copied to $(outfile)"
        end
    end
    return outfile
end

"""
    tidysvg(fromfile, tofile)

Read the SVG image in `fromfile` and write it to `tofile` with modified glyph names.
"""
function tidysvg(fromfile, tofile)
    path, ext = splitext(fromfile)
    if ext == ".svg"
        open(fromfile) do f
            r = join(Char.(append!(rand(65:90, 6), rand(97:122, 6))))
            d = read(f, String)
            d = replace(d, "id=\"glyph" => "id=\"glyph" * r)
            d = replace(d, "href=\"#glyph" => "href=\"#glyph" * r)
            open(tofile, "w") do out
                write(out, d)
            end
            @debug "modified SVG file copied to $(tofile)"
        end
    end
    return tofile
end

# in memory:

Base.showable(::MIME"image/svg+xml", d::Luxor.Drawing) = d.surfacetype == :svg
Base.showable(::MIME"image/png", d::Luxor.Drawing) = d.surfacetype == :png

# prefix all glyphids with a random number
function Base.show(f::IO, ::MIME"image/svg+xml", d::Luxor.Drawing)
    @debug "show MIME:svg "
    r = string(rand(100000:999999))
    # regex is faster
    seekstart(d.buffer)
    drawingdata = read(d.buffer, String)
    smod = replace(drawingdata, r"glyph" => "glyph-$r")
    write(f, smod)
end

function Base.show(f::IO, ::MIME"image/png", d::Luxor.Drawing)
    @debug "show MIME:png "
    seekstart(d.buffer)
    write(f, read(d.buffer, String))
end

"""
    paper_sizes

The `paper_sizes` Dictionary holds a few paper sizes, width is first, so default is Portrait:

```
"A0"      => (2384, 3370),
"A1"      => (1684, 2384),
"A2"      => (1191, 1684),
"A3"      => (842, 1191),
"A4"      => (595, 842),
"A5"      => (420, 595),
"A6"      => (298, 420),
"A"       => (612, 792),
"Letter"  => (612, 792),
"Legal"   => (612, 1008),
"Ledger"  => (792, 1224),
"B"       => (612, 1008),
"C"       => (1584, 1224),
"D"       => (2448, 1584),
"E"       => (3168, 2448))
```
"""
const paper_sizes = Dict{String,Tuple}(
    "A0"     => (2384, 3370),
    "A1"     => (1684, 2384),
    "A2"     => (1191, 1684),
    "A3"     => (842, 1191),
    "A4"     => (595, 842),
    "A5"     => (420, 595),
    "A6"     => (298, 420),
    "A"      => (612, 792),
    "Letter" => (612, 792),
    "Legal"  => (612, 1008),
    "Ledger" => (792, 1224),
    "B"      => (612, 1008),
    "C"      => (1584, 1224),
    "D"      => (2448, 1584),
    "E"      => (3168, 2448))

"""
Create a new drawing, and optionally specify file type (PNG, PDF, SVG, EPS),
file-based or in-memory, and dimensions.

    Drawing(width=600, height=600, file="luxor-drawing.png")

# Extended help

```julia
Drawing()
```

creates a drawing, defaulting to PNG format, default filename "luxor-drawing.png",
default size 800 pixels square.

You can specify dimensions, and assume the default output filename:

```julia
Drawing(400, 300)
```

creates a drawing 400 pixels wide by 300 pixels high, defaulting to PNG format, default
filename "luxor-drawing.png".

```julia
Drawing(400, 300, "my-drawing.pdf")
```

creates a PDF drawing in the file "my-drawing.pdf", 400 by 300 pixels.

```julia
Drawing(1200, 800, "my-drawing.svg")
```

creates an SVG drawing in the file "my-drawing.svg", 1200 by 800 pixels.

```julia
Drawing(width, height, surfacetype | filename)
```

creates a new drawing of the given surface type (e.g. :svg, :png), storing the picture
only in memory if no filename is provided.

```julia
Drawing(1200, 1200/Base.Mathconstants.golden, "my-drawing.eps")
```

creates an EPS drawing in the file "my-drawing.eps", 1200 wide by 741.8 pixels (= 1200 ÷ ϕ)
high. Only for PNG files must the dimensions be integers.

```julia
Drawing("A4", "my-drawing.pdf")
```

creates a PDF drawing in ISO A4 size (595 wide by 842 high) in the file "my-drawing.pdf".
Other sizes available are: "A0", "A1", "A2", "A3", "A4", "A5", "A6", "Letter", "Legal",
"A", "B", "C", "D", "E". Append "landscape" to get the landscape version.

```julia
Drawing("A4landscape")
```

creates the drawing A4 landscape size.

PNG and PDF default to transparent backgrounds, unless you specify one using
`background()`.

```julia
Drawing(width, height, :image)
```

creates the drawing in an image buffer in memory. You can obtain the data as a matrix with
`image_as_matrix()`.

```julia
Drawing(width, height, :rec)
```

creates the drawing in a recording surface in memory. `snapshot(fname, ...)` to any file format and bounding box,
or render as pixels with `image_as_matrix()`.

```julia
Drawing(width, height, strokescale=true)
```

creates the drawing and enables stroke scaling (strokes will be scaled according to the current transformation).
(Stroke scaling is disabled by default.)

```julia
Drawing(img, strokescale=true)
```

creates the drawing from an existing image buffer of type `Matrix{Union{RGB24,ARGB32}}`, e.g.:

```julia
using Luxor, Colors
buffer=zeros(ARGB32, 100, 100)
d=Drawing(buffer)
```
"""
function Drawing(w = 800.0, h = 800.0, f::AbstractString = "luxor-drawing.png"; strokescale = false)
    (path, ext) = splitext(f)
    currentdrawing = Drawing(w, h, Symbol(ext[2:end]), f, strokescale = strokescale)
    return currentdrawing
end

function Drawing(paper_size::AbstractString, f = "luxor-drawing.png"; strokescale = false)
    if occursin("landscape", paper_size)
        psize = replace(paper_size, "landscape" => "")
        h, w = paper_sizes[psize]
    else
        w, h = paper_sizes[paper_size]
    end
    Drawing(w, h, f, strokescale = strokescale)
end

@doc raw"""
    _adjust_background_rects(buffer::UInt8[]; addmarker = true)

See issue  https://github.com/JuliaGraphics/Luxor.jl/issues/150 for discussion details.

Setting backgrounds in a recording surface (:rec) and creating a svg from it result in elements as

```xml
<rect x="0" y="0" width="16777215" height="16777215" .../>
```
independent of an existing transformation matrix (e.g. set with origin(...) or snapshot with a crop bounding box).
An existing transformation matrix manifests in the svg file as

```xml
<use xlink:href="#surface199" transform="matrix(3 1 -1 3 30 40)"/>
```
which is applied to every element including the background rects.
This transformation needs to be inversed for the background rects which is added in this function.

If `addmarker` is not set to false, a class property is set as marker:
```xml
<rect class="luxor_adjusted" x="0" y="0" width="16777215" height="16777215" .../>
```
"""
function _adjust_background_rects(buffer; addmarker = true)
    seekstart(buffer)
    adjusted_buffer = read(buffer, String)
    # check if there is any transform= part, if not we do not need the next heavy regex
    m = match(r"transform=\"matrix\((.+?),(.+?),(.+?),(.+?),(.+?),(.+?)\)\"/>"is, adjusted_buffer)
    if !isnothing(m) && length(m.captures) == 6
        # get SVG viewbox coordinates to replace the generic 16777215 values
        #   expected example:
        #     <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="300pt" height="300pt" viewBox="0 0 300 300" version="1.1">
        m = match(r"<svg\s+?[^>]*?viewBox=\"(.+?)\s+(.+?)\s+(.+?)\s+(.+?)\".*?>"is, adjusted_buffer)
        adjust_vb = false
        if !isnothing(m) && length(m.captures) == 4
            (vbx, vby, vbw, vbh) = string.([parse(Float64, m[i]) for i in 1:4])
            adjust_vb = true
        end
        # do adjustment for all <use ...> elements (after <defs>) which have a transform attribute as matrix
        #   expected example:
        #     </defs>...<use xlink:href="#surface5" transform="matrix(1,0,0,1,150,150)"/>...</svg>
        #       xlink:href is deprecated and can be replaced by just href
        #       a group block with id "surface5" must exist: <g id="surface5" clip-path="url(#clip1)">
        #       in this group block adjust all background rects with the inverse transform matrix like:
        #       from:
        #          <rect x="0" y="0" width="16777215" height="16777215" style="..."/>
        #       to:
        #          <rect class="luxor_adjusted" x="0" y="0" width="300" height="300" style="..." transform="matrix(1,0,0,1,-150,-150)"/>
        #       adding class as verification that tweak was applied.
        m = findall(r"<defs\s*?>"is, adjusted_buffer)
        # check if there is exactly 1 <defs> element
        if !isnothing(m) && length(m) == 1
            # get SVG part after </defs> to search for <use ...>
            #   could be done in a single RegEx but can produce ERROR: PCRE.exec error: match limit exceeded
            m = match(r"</defs\s*?>(.*)$"is, adjusted_buffer)
            if !isnothing(m) && length(m.captures) == 1
                adjusted_buffer_part = m[1]
                for m in eachmatch(r"<use[^>]*?(xlink:)*?href=\"#(.*?)\"[^>]*?transform=\"matrix\((.+?),(.+?),(.+?),(.+?),(.+?),(.+?)\)\"/>"is, adjusted_buffer_part)
                    if !isnothing(m) && length(m.captures) == 8
                        # id of group block
                        id = m[2]
                        # transform matrix applied to all elements in group block
                        transform = vcat(reshape([parse(Float64, m[i]) for i in 3:8], 2, 3), [0.0 0.0 1.0])
                        # inverse transform matrix must be applied to background rect to neutralize transform matrix
                        it = inv(transform)
                        # get the group block with id into mid::String
                        (head, mid, tail, split_ok) = _split_string_into_head_mid_tail(adjusted_buffer, id)
                        if split_ok
                            # add inverse transform matrix to every background rect
                            #   background rects look like:
                            #     <rect x="0" y="0" width="16777215" height="16777215" style="fill:rgb(0%,69.803922%,93.333333%);fill-opacity:1;stroke:none;"/>
                            # add class="luxor_adjusted" too, for future reference that element has been tweaked
                            invtransformstring = "transform=\"matrix(" * join(string.(it[1:2, 1:3][:]), ",") * ")\""
                            marker = ""
                            if addmarker
                                marker = "class=\"luxor_adjusted\" "
                            end
                            mid = replace(mid, r"(<rect) (x=\"0\" y=\"0\" width=\"16777215\" height=\"16777215\".*?)/>"is => SubstitutionString("\\1 $(marker)\\2 $(invtransformstring)/>"))
                            if adjust_vb
                                # some SVG tools don't like this huge rects (e.g. inkscape)
                                # => replace 0,0,16777215,16777215 with viewBox coordinates
                                mid = replace(mid, r"(?<a><rect\s+?.*?\s+?x=\")0(?<b>\" y=\")0(?<c>\" width=\")16777215(?<d>\" height=\")16777215(?<e>\".*?/>)"is => SubstitutionString("\\g<a>$(vbx)\\g<b>$(vby)\\g<c>$(vbw)\\g<d>$(vbh)\\g<e>"))
                            end
                            adjusted_buffer = head * mid * tail
                        end
                    end
                end
            end
        end
    end
    adjusted_buffer = UInt8.(collect(adjusted_buffer))
    return adjusted_buffer
end

@doc raw"""
    _split_string_into_head_mid_tail(s::String,id::String)

splits s into head, mid and tail string.
Example:

```julia
s="head...<g id="\$id">...</g>...tail"
```
  results in

```julia
head="head..."
mid="<g id="\$id">...</g>"
tail="...tail"
```
"""
function _split_string_into_head_mid_tail(s, id)
    head = ""
    mid = s
    tail = ""
    split_ok = false
    # find all group start elements <g ...>
    startgroups = findall(r"<g(?:>|\s+?.*?>)"is, s)
    # find all group end elements </g...>
    endgroups = findall(r"</g\s*>"is, s)
    # there must be as many start elements as end elements
    if length(startgroups) == length(endgroups)
        #if length(startgroups) != length(endgroups)
        #    @warn "number of group starting tags <g ...> do not match number of closing tags </g> in SVG"
        #else
        # find the group start element with the proper id
        first_group = findfirst(Regex("<g\\s+?[^>]*?id=\"$(id)\".*?>", "is"), s)
        group_start_index = findfirst(e -> e == first_group, startgroups)
        if !isnothing(group_start_index) && !isempty(group_start_index)
            mid_start = first_group[1]
            group_end_index = 0
            # starting with group start element with the proper id traverse the end group elements
            # and the start group elements until the number traversed are equal the first time
            while group_start_index - group_end_index !== 0 && group_start_index < length(startgroups) && group_end_index <= length(endgroups)
                group_end_index += 1
                while group_end_index <= length(endgroups) && endgroups[group_end_index][1] < startgroups[group_start_index][1]
                    group_end_index += 1
                end
                while group_start_index < length(startgroups) && startgroups[group_start_index + 1][1] < endgroups[group_end_index][1]
                    group_start_index += 1
                end
            end
            if group_start_index - group_end_index == 0
                mid_end = endgroups[group_end_index][end]
                # start and end character of mid is found, construct the substrings
                if prevind(s, mid_start) > 0
                    head = s[1:prevind(s, mid_start)]
                end
                if nextind(s, mid_end) > 0
                    tail = s[nextind(s, mid_end):end]
                end
                mid = s[mid_start:mid_end]
                split_ok = true
            end
        end
    end
    return (head, mid, tail, split_ok)
end

@doc raw"""
    finish(; svgpostprocess = false, addmarker = true)

Finish the drawing, close any related files. You may be able to view the drawing
in another application with `preview()`.

Returns `true` if successful.

For more information about `svgpostprocess` and `addmarker` see help for
`Luxor._adjust_background_rects`
"""
function finish(; svgpostprocess = false, addmarker = true)
    if _current_surface_ptr() == C_NULL
        # Already finished
        return false
    end
    if _current_surface_type() == :png
        Cairo.write_to_png(_current_surface(), _current_buffer())
    end

    if _current_surface_type() == :image &&
       (
           typeof(_current_surface()) == Cairo.CairoSurfaceImage{ARGB32} ||
           typeof(_current_surface()) == Cairo.CairoSurfaceImage{RGB24}
       ) && endswith(_current_filename(), r"\.png"i)
        Cairo.write_to_png(_current_surface(), _current_buffer())
    end

    Cairo.finish(_current_surface())
    Cairo.destroy(_current_surface())

    if _current_filename() != ""
        @debug " ... finish() $(_current_filename())"
        if (_current_surface_type() != :svg) || !svgpostprocess
            @debug " ... finish() not :svg or not svgpostprocess)"
            @debug _current_surface_type()
            @debug !svgpostprocess
            seekstart(_current_buffer())
            drawingdata = read(_current_buffer(), String)
            write(_current_filename(), drawingdata)
        else
            @debug " ... finish() :svg || svgpostprocess"
            # next function call adresses the issue in
            # https://github.com/JuliaGraphics/Luxor.jl/issues/150
            #   short: setting a background in svg results in
            #          <rect x="0" y="0" width="16777215" height="16777215" .../>
            #          independent of an existing transform matrix (e.g. set with origin(...)
            #          or snapshot with a negative crop bounding box).
            #          An existing transform matrix manifests in the svg file as
            #          <use xlink:href="#surface199" transform="matrix(3 1 -1 3 30 40)"/>
            #          which is applied to every element including the background rects.
            #          This transformation needs to be inversed for the background rects
            #          which is added in this function.
            seekstart(_current_buffer())
            modified_buffer = _adjust_background_rects(copy(_current_buffer()); addmarker = addmarker)
            # hopefully safe as we are at the end of finish:
            _current_drawing()[_current_drawing_index()].buffer = IOBuffer(modified_buffer)
            write(_current_filename(), read(_current_buffer(), String))
        end
    end

    return true
end

@doc raw"""
    snapshot(;
        fname = :png,
        cb = missing,
        scalefactor = 1.0,
        addmarker = true)

    snapshot(fname, cb, scalefactor)
    -> finished snapshot drawing, for display

Take a snapshot and save to 'fname' name and suffix. This requires
that the current drawing is a recording surface. You can continue drawing
on the same recording surface.

Returns the snapshot as a drawing.

### Arguments

`fname` the file name or symbol, see [`Drawing`](@ref)

`cb` crop box::BoundingBox - what's inside is copied to snapshot

`scalefactor` snapshot width/crop box width. Same for height.

`addmarker` for more information about `addmarker` see help for `Luxor._adjust_background_rects`

    ?Luxor._adjust_background_rects

### Examples

```julia
snapshot()
snapshot(fname = "temp.png")
snaphot(fname = :svg)
cb = BoundingBox(Point(0, 0), Point(102.4, 96))
snapshot(cb = cb)
pngdrawing = snapshot(fname = "temp.png", cb = cb, scalefactor = 10)
```

The last example would return and also write a png drawing with 1024 x 960 pixels to storage.
"""
function snapshot(;
    fname = :png,
    cb = missing,
    scalefactor = 1.0,
    addmarker = true)
    rd = currentdrawing()
    isbits(rd) && return false  # currentdrawing provided 'info'
    if ismissing(cb)
        if isnan(rd.width) || isnan(rd.height)
            @info "The current recording surface has no bounds. Define a crop box for snapshot."
            return false
        end
        # When no cropping box is given, we take the intention
        # to be a snapshot of the entire rectangular surface,
        # regardless of recording surface current scaling and rotation.
        gsave()
        origin()
        sn = snapshot(fname, BoundingBox(), scalefactor; addmarker = addmarker)
        grestore()
    else
        if typeof(cb) !== BoundingBox
            throw(error("Luxor.snapshot(): $(cb) is not a BoundingBox"))
        end
        sn = snapshot(fname, cb, scalefactor; addmarker = addmarker)
    end
    sn
end

function snapshot(fname, cb, scalefactor; addmarker = true)
    # Prefix r: recording
    # Prefix n: new snapshot
    # Device coordinates, device space: (x_d, y_d), origin at top left for Luxor implemented types
    # ctm: current transformation matrix - since it's symmetric, Cairo simplifies to a vector.
    # User coordinates, user space: (x_u,y_u ) = ctm⁻¹ * (x_d, y_d)
    rd = currentdrawing()
    isbits(rd) && return false  # currentdrawing provided 'info'
    rs = _current_surface()
    if typeof(rd) !== Drawing
        throw(error("Luxor.snapshot(): there is not current drawing"))
    end

    if _current_surface_type() !== :rec
        throw(error("Luxor.snapshot(): drawing type should be :rec"))
    end

    # The check for an 'alive' drawing should be performed by currentdrawing()
    # Working on a dead drawing causes ugly crashes.
    # Empty the working buffer to the recording surface:
    Cairo.flush(rs)

    # Recording surface device origin is assumed to be the
    # upper left corner of extents (which is true given how Luxor currently makes these,
    # but Cairo now has more options)

    # Recording surface current transformation matrix (ctm)
    rma = getmatrix()

    # Recording surface inverse ctm - for device to user coordinates
    rmai = juliatocairomatrix(cairotojuliamatrix(rma)^-1)

    # Recording surface user coordinates of crop box top left
    rtlxu, rtlyu = boxtopleft(cb)

    # Recording surface device coordinates of crop box top left
    rtlxd, rtlyd, _ = cairotojuliamatrix(rma) * [rtlxu, rtlyu, 1]

    # Position of recording surface device origin, in new drawing user space.
    x, y = -rtlxd, -rtlyd

    # New drawing dimensions
    nw = Float64(round(scalefactor * boxwidth(cb)))
    nh = Float64(round(scalefactor * boxheight(cb)))

    # New drawing ctm - user space origin and device space origin at top left
    nm = scalefactor .* [rmai[1], rmai[2], rmai[3], rmai[4], 0.0, 0.0]

    # Create new drawing, to which we'll project a snapshot
    nd = Drawing(round(nw), round(nh), fname)
    setmatrix(nm)

    # Define where to play the recording
    # The proper Cairo.jl name would be set_source_surface,
    # which is actually called by this Cairo.jl method.
    # Cairo docs phrases this as "Desination user space coordinates at which the
    # recording surface origin should appear". This seems to mean DEVICE origin.
    set_source(nd.cr, rs, x, y)

    # Draw the recording here
    paint()

    # Even in-memory drawings are finished, since such drawings are displayed.
    finish(; svgpostprocess = true, addmarker = addmarker)

    # Switch back to continue recording
    _current_drawing()[_current_drawing_index()] = rd
    # Return the snapshot in case it should be displayed
    nd
end

"""
    preview()

If you're working in a notebook (eg Jupyter/IJulia), display a PNG or SVG file
in the notebook.

If you're working in VS-Code, display a PNG or SVG file in the Plots pane.

Drawings of type :image should be converted to a matrix with `image_as_matrix()`
before calling `finish()`.

Otherwise:

  - on macOS, open the file in the default application, which is probably the
    Preview.app for PNG and PDF, and Safari for SVG
  - on Unix, open the file with `xdg-open`
  - on Windows, refer to `COMSPEC`.

Returns the drawing.
"""
function preview()
    @debug "preview()"
    return _get_current_drawing_save()
end

# for filenames, the @pdf/png/svg macros may pass either
# a string or an expression (with
# interpolation) which may or may not contain a valid
# extension ... yikes

function _add_ext(fname, ext)
    if isa(fname, Expr)
        # fname is an expression
        if endswith(string(last(fname.args)), string(ext))
            # suffix has been passed
            return fname
        else
            # there was no suffix
            push!(fname.args, string(".", ext))
            return fname
        end
    else
        # fname is a string
        if endswith(fname, string(ext))
            # file had a suffix
            return fname
        else
            # file did not have a suffix
            return string(fname, ".", ext)
        end
    end
end

"""
    @svg drawing-instructions [width] [height] [filename]

Create and preview an SVG drawing, optionally specifying width and height (the
default is 600 by 600). The file is saved in the current working directory as
`filename` if supplied, or `luxor-drawing-(timestamp).svg`.

### Examples

```julia
@svg circle(O, 20, :fill)
```

```julia
@svg circle(O, 20, :fill) 400
```

```julia
@svg circle(O, 20, :fill) 400 1200
```

```julia
@svg circle(O, 20, :fill) 400 1200 "/tmp/test"
```

```julia
@svg circle(O, 20, :fill) 400 1200 "/tmp/test.svg"
```

```julia
@svg begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end
```

```julia
@svg begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end 1200 1200
```
"""
macro svg(body, width = 600, height = 600, fname = "luxor-drawing-$(Dates.format(Dates.now(), "HHMMSS_s")).svg")
    quote
        local lfname = _add_ext($(esc(fname)), :svg)
        Drawing($(esc(width)), $(esc(height)), lfname)
        origin()
        background("white")
        sethue("black")
        $(esc(body))
        finish()
        preview()
    end
end

"""
    @png drawing-instructions [width] [height] [filename]

Create and preview an PNG drawing, optionally specifying width and height (the
default is 600 by 600). The file is saved in the current working directory as
`filename`, if supplied, or `luxor-drawing(timestamp).png`.

These 'short-cut' macros are designed for convenience and to save typing.
The macro `@png ⟦ body ⟧ width height` expands to:

```julia
Drawing(width, height, :png)
origin()
background("white")
sethue("black")
⟦ body ⟧
finish()
preview()
```

For full control of the drawing construction, use these functions directly
rather than the short-cut macros.

### Examples

```julia
@png circle(O, 20, :fill)
```

```julia
@png circle(O, 20, :fill) 400
```

```julia
@png circle(O, 20, :fill) 400 1200
```

```julia
@png circle(O, 20, :fill) 400 1200 "/tmp/round"
```

```julia
@png circle(O, 20, :fill) 400 1200 "/tmp/round.png"
```

```julia
@png begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end
```

```julia
@png begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end 1200 1200
```
"""
macro png(body, width = 600, height = 600, fname = "luxor-drawing-$(Dates.format(Dates.now(), "HHMMSS_s")).png")
    quote
        local lfname = _add_ext($(esc(fname)), :png)
        Drawing($(esc(width)), $(esc(height)), lfname)
        origin()
        background("white")
        sethue("black")
        $(esc(body))
        finish()
        preview()
    end
end

"""
    @pdf drawing-instructions [width] [height] [filename]

Create and preview an PDF drawing, optionally specifying width and height (the
default is 600 by 600). The file is saved in the current working directory as
`filename` if supplied, or `luxor-drawing(timestamp).pdf`.

These 'short-cut' macros are designed for convenience and to save typing.
The macro `@pdf ⟦ body ⟧ width height` expands to:

```julia
Drawing(width, height, :pdf)
origin()
background("white")
sethue("black")
⟦ body ⟧
finish()
preview()
```

For full control of the drawing construction, use these functions directly
rather than the short-cut macros.

### Examples

```julia
@pdf circle(O, 20, :fill)
```

```julia
@pdf circle(O, 20, :fill) 400
```

```julia
@pdf circle(O, 20, :fill) 400 1200
```

```julia
@pdf circle(O, 20, :fill) 400 1200 "/tmp/A0-version"
```

```julia
@pdf circle(O, 20, :fill) 400 1200 "/tmp/A0-version.pdf"
```

```julia
@pdf begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end
```

```julia
@pdf begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end 1200 1200
```
"""
macro pdf(body, width = 600, height = 600, fname = "luxor-drawing-$(Dates.format(Dates.now(), "HHMMSS_s")).pdf")
    quote
        local lfname = _add_ext($(esc(fname)), :pdf)
        Drawing($(esc(width)), $(esc(height)), lfname)
        origin()
        background("white")
        sethue("black")
        $(esc(body))
        finish()
        preview()
    end
end

"""
    @eps drawing-instructions [width] [height] [filename]

Create and preview an EPS drawing, optionally specifying width and height (the
default is 600 by 600). The file is saved in the current working directory as
`filename` if supplied, or `luxor-drawing(timestamp).eps`.

On some platforms, EPS files are converted automatically to PDF when previewed.

These 'short-cut' macros are designed for convenience and to save typing.
The macro `@draw ⟦ body ⟧ width height filename` expands to:

```julia
Drawing(width, height, filename)
origin()
background("white")
sethue("black")
⟦ body ⟧
finish()
preview()
```

For full control of the drawing construction, use these functions directly
rather than the short-cut macros.

### Examples

```julia
@eps circle(O, 20, :fill)
```

```julia
@eps circle(O, 20, :fill) 400
```

```julia
@eps circle(O, 20, :fill) 400 1200
```

```julia
@eps circle(O, 20, :fill) 400 1200 "/tmp/A0-version"
```

```julia
@eps circle(O, 20, :fill) 400 1200 "/tmp/A0-version.eps"
```

```julia
@eps begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end
```

```julia
@eps begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end 1200 1200
```
"""
macro eps(body, width = 600, height = 600, fname = "luxor-drawing-$(Dates.format(Dates.now(), "HHMMSS_s")).eps")
    quote
        local lfname = _add_ext($(esc(fname)), :eps)
        Drawing($(esc(width)), $(esc(height)), lfname)
        origin()
        background("white")
        sethue("black")
        $(esc(body))
        finish()
        preview()
    end
end

"""
    @draw drawing-instructions [width] [height]

Create and preview an PNG drawing, optionally specifying width and height (the
default is 600 by 600). The drawing is stored in memory, not in a file on disk.

These 'short-cut' macros are designed for convenience and to save typing.
The macro `@draw ⟦ body ⟧ width height` expands to:

```julia
Drawing(width, height, :png)
origin()
background("white")
sethue("black")
⟦ body ⟧
finish()
preview()
```

For full control of the drawing construction, use these functions directly
rather than the short-cut macros.

### Examples

```julia
@draw circle(O, 20, :fill)
```

```julia
@draw circle(O, 20, :fill) 400
```

```julia
@draw circle(O, 20, :fill) 400 1200
```

```julia
@draw begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end
```

```julia
@draw begin
    setline(10)
    sethue("purple")
    circle(O, 20, :fill)
end 1200 1200
```
"""
macro draw(body, width = 600, height = 600)
    quote
        Drawing($(esc(width)), $(esc(height)), :png)
        origin()
        background("white")
        sethue("black")
        $(esc(body))
        finish()
        preview()
    end
end

"""
    image_as_matrix()

Return an Array of the current state of the picture as an
array of ARGB32.

A matrix 50 wide and 30 high => a table 30 rows by 50 cols

```julia
using Luxor, Images

Drawing(50, 50, :png)
origin()
background(randomhue()...)
sethue("white")
fontsize(40)
fontface("Georgia")
text("42", halign=:center, valign=:middle)
mat = image_as_matrix()
finish()
```
"""
function image_as_matrix()
    if !isassigned(_current_drawing(), _current_drawing_index())
        error("no current drawing")
    end
    w = Int(_current_surface().width)
    h = Int(_current_surface().height)
    z = zeros(UInt32, w, h)
    # create a new image surface to receive the data from the current drawing
    # flipxy: see issue https://github.com/Wikunia/Javis.jl/pull/149
    imagesurface = CairoImageSurface(z, Cairo.FORMAT_ARGB32, flipxy = false)
    cr = Cairo.CairoContext(imagesurface)
    Cairo.set_source_surface(cr, _current_surface(), 0, 0)
    Cairo.paint(cr)
    data = imagesurface.data
    Cairo.finish(imagesurface)
    Cairo.destroy(imagesurface)
    return reinterpret(ARGB32, permutedims(data, (2, 1)))
end

"""
    @imagematrix drawing-instructions [width=256] [height=256]

Create a drawing and return a matrix of the image.

This macro returns a matrix of pixels that represent the drawing
produced by the vector graphics instructions. It uses the `image_as_matrix()`
function.

The default drawing is 256 by 256 points.

You don't need `finish()` (the macro calls it), and it's not previewed by `preview()`.

```julia
julia> m = @imagematrix begin
               sethue("red")
               box(O, 20, 20, :fill)
           end 60 60;

julia> m[1220:1224]
5-element Array{ARGB32,1} with eltype ColorTypes.ARGB32:
 ARGB32(0.0N0f8,0.0N0f8,0.0N0f8,0.0N0f8)
 ARGB32(1.0N0f8,0.0N0f8,0.0N0f8,1.0N0f8)
 ARGB32(1.0N0f8,0.0N0f8,0.0N0f8,1.0N0f8)
 ARGB32(1.0N0f8,0.0N0f8,0.0N0f8,1.0N0f8)
 ARGB32(1.0N0f8,0.0N0f8,0.0N0f8,1.0N0f8)
```

If, for some strange reason you want to draw the matrix as another
Luxor drawing again, use code such as this:

```julia
m = @imagematrix begin
        sethue("red")
        box(O, 20, 20, :fill)
        sethue("blue")
        box(O, 10, 40, :fill)
    end 60 60

function convertmatrixtocolors(m)
    return convert.(Colors.RGBA, m)
end

function drawimagematrix(m)
    d = Drawing(500, 500, "/tmp/temp.png")
    origin()
    w, h = size(m)
    t = Tiler(500, 500, w, h)
    mi = convertmatrixtocolors(m)
    for (pos, n) in t
        c = mi[t.currentrow, t.currentcol]
        setcolor(c)
        box(pos, t.tilewidth -1, t.tileheight - 1, :fill)
    end
    finish()
    return d
end

drawimagematrix(m)
```

Transparency

The default value for the cells in an image matrix is
transparent black. (Luxor's default color is opaque black.)

```julia
julia> @imagematrix begin
       end 2 2
2×2 reinterpret(ColorTypes.ARGB32, ::Matrix{UInt32}):
 ARGB32(0.0,0.0,0.0,0.0)  ARGB32(0.0,0.0,0.0,0.0)
 ARGB32(0.0,0.0,0.0,0.0)  ARGB32(0.0,0.0,0.0,0.0)
```

Setting the background to a partially or completely
transparent value may give unexpected results:

```julia
julia> @imagematrix begin
           background(1, 0.5, 0.0, 0.5) # semi-transparent orange
       end 2 2
2×2 reinterpret(ColorTypes.ARGB32, ::Matrix{UInt32}):
 ARGB32(0.502,0.251,0.0,0.502)  ARGB32(0.502,0.251,0.0,0.502)
 ARGB32(0.502,0.251,0.0,0.502)  ARGB32(0.502,0.251,0.0,0.502)
```

here the semi-transparent orange color has been partially
applied to the transparent background.

```julia
julia> @imagematrix begin
           sethue(1., 0.5, 0.0)
           paint()
       end 2 2
2×2 reinterpret(ColorTypes.ARGB32, ::Matrix{UInt32}):
 ARGB32(1.0,0.502,0.0,1.0)  ARGB32(1.0,0.502,0.0,1.0)
 ARGB32(1.0,0.502,0.0,1.0)  ARGB32(1.0,0.502,0.0,1.0)
```

picks up the default alpha of 1.0.
"""
macro imagematrix(body, width = 256, height = 256)
    quote
        Drawing($(esc(width)), $(esc(height)), :image)
        origin()
        $(esc(body))
        m = image_as_matrix()
        finish()
        m
    end
end

"""
    image_as_matrix!(buffer)

Like `image_as_matrix()`, but use an existing UInt32 buffer.

`buffer` is a buffer of UInt32.

```julia
w = 200
h = 150
buffer = zeros(UInt32, w, h)
Drawing(w, h, :image)
origin()
juliacircles(50)
m = image_as_matrix!(buffer)
finish()
# collect(m) is Array{ARGB32,2}
Images.RGB.(m)
```
"""
function image_as_matrix!(buffer)
    if !isassigned(_current_drawing(), _current_drawing_index())
        error("no current drawing")
    end
    # create a new image surface to receive the data from the current drawing
    # flipxy: see issue https://github.com/Wikunia/Javis.jl/pull/149
    imagesurface = Cairo.CairoImageSurface(buffer, Cairo.FORMAT_ARGB32, flipxy = false)
    cr = Cairo.CairoContext(imagesurface)
    Cairo.set_source_surface(cr, Luxor._current_surface(), 0, 0)
    Cairo.paint(cr)
    data = imagesurface.data
    Cairo.finish(imagesurface)
    Cairo.destroy(imagesurface)
    return reinterpret(ARGB32, permutedims(data, (2, 1)))
end

"""
    @imagematrix! buffer drawing-instructions [width=256] [height=256]

Like `@imagematrix`, but use an existing UInt32 buffer.

```julia
w = 200
h  = 150
buffer = zeros(UInt32, w, h)
m = @imagematrix! buffer juliacircles(40) 200 150;
Images.RGB.(m)
```
"""
macro imagematrix!(buffer, body, width = 256, height = 256)
    quote
        Drawing($(esc(width)), $(esc(height)), :image)
        origin()
        $(esc(body))
        m = image_as_matrix!($(esc(buffer)))
        finish()
        m
    end
end

"""
    svgstring()

Return the current and recently completed SVG drawing as a string of SVG commands.

Returns `""` if there is no SVG information available.

To display the SVG string as a graphic, try the `HTML()` function in Base.

```julia
...
HTML(svgstring())
```

In a Pluto notebook, you can also display the SVG using:

```julia
# using PlutoUI
...
PlutoUI.Show(MIME"image/svg+xml"(), svgstring())
```

(This lets you right-click to save the SVG.)

## Example

This example examines the generated SVG code produced by drawing
the Julia logo.

```julia-repl
julia> Drawing(500, 500, :svg)

julia> origin()

julia> julialogo()

julia> finish()

julia> s = svgstring()

julia> eachmatch(r"rgb.*?;", s) |> collect
6-element Vector{RegexMatch}:
 RegexMatch("rgb(100%,100%,100%);")
 RegexMatch("rgb(0%,0%,0%);")
 RegexMatch("rgb(79.6%,23.5%,20%);")
 RegexMatch("rgb(25.1%,38.8%,84.7%);")
 RegexMatch("rgb(58.4%,34.5%,69.8%);")
 RegexMatch("rgb(22%,59.6%,14.9%);")
```

Here's another example, post-processing the SVG file with the `svgo` optimizer.

```julia
@drawsvg begin
    background("midnightblue")
    fontface("JuliaMono-Regular")
    fontsize(20)
    sethue("gold")
    text("JuliaMono: a monospaced font ", halign=:center)
    text("with reasonable Unicode support", O + (0, 22), halign=:center)
end 500 150
write("txt.svg", svgstring())
# minimize SVG
run(`svgo txt.svg -o txt-min.svg`)
```
"""
function svgstring()
    if Luxor._current_surface_type() == :svg
        seekstart(_current_buffer())
        drawingdata = read(_current_buffer(), String)
        return drawingdata
    else
        @warn "Drawing is not SVG"
        return ""
    end
end

"""
    @drawsvg begin
        body
    end w h

Create and preview an SVG drawing. Like `@draw` but using SVG format, but unlike `@draw` (PNG), there is no background, by default.
"""
macro drawsvg(body, width = 600, height = 600)
    quote
        Drawing($(esc(width)), $(esc(height)), :svg)
        origin()
        # background("white")
        sethue("black")
        $(esc(body))
        finish()
        preview()
    end
end

"""
    @savesvg begin
        body
    end w h

Like `@drawsvg` but returns the raw SVG code of the drawing in a
string. Uses `svgstring`.

Unlike `@draw` (PNG), there is no background, by default.

This example scans the generated SVG for color values:

```julia-repl
julia> s = @savesvg begin
           julialogo()
       end

julia> eachmatch(r"rgb.*?;", s) |> collect
5-element Vector{RegexMatch}:
 RegexMatch("rgb(0%,0%,0%);")
 RegexMatch("rgb(25.1%,38.8%,84.7%);")
 RegexMatch("rgb(22%,59.6%,14.9%);")
 RegexMatch("rgb(58.4%,34.5%,69.8%);")
 RegexMatch("rgb(79.6%,23.5%,20%);")
```
"""
macro savesvg(body, width = 600, height = 600)
    quote
        Drawing($(esc(width)), $(esc(height)), :svg)
        origin()
        # background("white")
        sethue("black")
        $(esc(body))
        finish()
        svgstring()
    end
end

const Blend = CairoPattern

"""
    blend(from::Point, to::Point)

Create an empty linear blend.

A blend is a specification of how one color changes into another. Linear blends are
defined by two points: parallel lines through these points define the start and stop
locations of the blend. The blend is defined relative to the current axes origin. This means
that you should be aware of the current axes when you define blends, and when you use them.

To add colors, use `addstop()`.
"""
function blend(from::Point, to::Point)
    return Cairo.pattern_create_linear(from.x, from.y, to.x, to.y)
end

"""
    blend(centerpos1, rad1, centerpos2, rad2, color1, color2)

Create a radial blend.

Example:
```julia
redblue = blend(
    pos, 0,                   # first circle center and radius
    pos, tiles.tilewidth/2,   # second circle center and radius
    "red",
    "blue",
)
```
"""
function blend(centerpos1::Point, rad1, centerpos2::Point, rad2, color1, color2)
    newblend = blend(centerpos1, rad1, centerpos2, rad2)
    addstop(newblend, 0, color1)
    addstop(newblend, 1, color2)
    return newblend
end

"""
    blend(pt1::Point, pt2::Point, color1, color2)

Create a linear blend.

Example:

    redblue = blend(pos, pos, "red", "blue")
"""
function blend(pt1::Point, pt2::Point, color1, color2)
    newblend = blend(pt1, pt2)
    addstop(newblend, 0, color1)
    addstop(newblend, 1, color2)
    return newblend
end

"""
    blend(from::Point, startradius, to::Point, endradius)

Create an empty radial blend.

Radial blends are defined by two circles that define the start and stop locations. The
first point is the center of the start circle, the first radius is the radius of the first
circle.

A new blend is empty. To add colors, use `addstop()`.
"""
function blend(from::Point, startradius::Real, to::Point, endradius::Real)
    return Cairo.pattern_create_radial(from.x, from.y, startradius, to.x, to.y, endradius)
end

"""
    addstop(b::Blend, offset, col)
    addstop(b::Blend, offset, (r, g, b, a))
    addstop(b::Blend, offset, string)

Add a color stop to a blend. The offset specifies the location along the blend's 'control
vector', which varies between 0 (beginning of the blend) and 1 (end of the blend). For
linear blends, the control vector is from the start point to the end point. For radial
blends, the control vector is from any point on the start circle, to the corresponding point
on the end circle.

Examples:

    blendredblue = blend(Point(0, 0), 0, Point(0, 0), 1)
    addstop(blendredblue, 0, setcolor(sethue("red")..., .2))
    addstop(blendredblue, 1, setcolor(sethue("blue")..., .2))
    addstop(blendredblue, 0.5, sethue(randomhue()...))
    addstop(blendredblue, 0.5, setcolor(randomcolor()...))

"""
function addstop(b::Blend, offset, col::Colors.Colorant)
    temp = convert(RGBA,  col)
    Cairo.pattern_add_color_stop_rgba(b, offset, temp.r, temp.g, temp.b, temp.alpha)
end

function addstop(b::Blend, offset, col::AbstractString)
    temp = parse(RGBA, col)
    Cairo.pattern_add_color_stop_rgba(b, offset, temp.r, temp.g, temp.b, temp.alpha)
end

function addstop(b::Blend, offset, col::NTuple{4, Number})
    Cairo.pattern_add_color_stop_rgba(b, offset, col[1], col[2], col[3], col[4])
end

function addstop(b::Blend, offset, col::NTuple{3, Number})
    currentopacity = _get_current_alpha()
    Cairo.pattern_add_color_stop_rgba(b, offset, col[1], col[2], col[3], currentopacity)
end

"""
    setblend(blend)

Start using the named blend for filling graphics.

This aligns the original coordinates of the blend definition with the current axes.
"""
function setblend(b::Blend)
    Cairo.set_source(_get_current_cr(), b)
end

"""
    blendadjust(ablend, center::Point, xscale, yscale, rot=0)

Modify an existing blend by scaling, translating, and rotating it so that it will fill a
shape properly even if the position of the shape is nowhere near the original location of
the blend's definition.

For example, if your blend definition was this (notice the `1`)

```julia
blendgoldmagenta = blend(
    Point(0, 0), 0,                   # first circle center and radius
    Point(0, 0), 1,                   # second circle center and radius
    "gold",
    "magenta"
)
```

you can use it in a shape that's 100 units across and centered at `pos`,
by calling this:

    blendadjust(blendgoldmagenta, Point(pos.x, pos.y), 100, 100)

then use `setblend()`:

    setblend(blendgoldmagenta)
"""
function blendadjust(ablend, center::Point, xscale, yscale, rot=0)
    blendmatrix(ablend,
        juliatocairomatrix(
            rotationmatrix(-rot) *
            scalingmatrix(1/xscale, 1/yscale) *
            translationmatrix(-center.x, -center.y) *
        cairotojuliamatrix([1 0 0 1 0 0])))
end

"""
    blendmatrix(b::Blend, m)

Set the matrix of a blend.

To apply a sequence of matrix transforms to a blend:

```julia
A = [1 0 0 1 0 0]
Aj = cairotojuliamatrix(A)
Sj = scalingmatrix(2, .2) * Aj
Tj = translationmatrix(10, 0) * Sj
A1 = juliatocairomatrix(Tj)
blendmatrix(b, As)
```
"""
function blendmatrix(b::Blend, m)
    cm = Cairo.CairoMatrix(m[1], m[2], m[3], m[4], m[5], m[6])
    Cairo.set_matrix(b, cm)
end

"""
    setblendextend(blend::Blend, mode)

Specify how color blend patterns are repeated/extended. Supply the blend and one of the following strings:

- "repeat":  the pattern is repeated

- "reflect": the pattern is reflected (repeated in reverse)

- "pad": outside the pattern, use the closest color

- "none": outside of the pattern, use transparent pixels

"""
function setblendextend(blend::Blend, mode)
    if mode == "repeat" || mode == :repeat
        Cairo.pattern_set_extend(blend, Cairo.EXTEND_REPEAT)
    elseif mode == "reflect" || mode == :reflect
        Cairo.pattern_set_extend(blend, Cairo.EXTEND_REFLECT)
    elseif mode == "pad" || mode == :pad
        Cairo.pattern_set_extend(blend, Cairo.EXTEND_PAD)
    else
        Cairo.pattern_set_extend(blend, Cairo.EXTEND_NONE)
    end
end

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function randompoly(rad, n)
    result = Point[]
    for i in 1:n
        push!(result, Point(rand(-rad:rad), rand(-rad:rad)))
    end
    return polysortbyangle(result)
end

function testapoly(pos)
    gsave()
    translate(pos)

    sethue("white")

    # try both regular and irregular polygons
    if rand(Bool)
        p1 = ngon(O, 80, rand(3:8), rand(0:pi/10:2pi), vertices=true)
    else
        p1 = star(O, 90, rand(3:12), 0.5, 0, vertices=true)
    end
    setline(1.5)

    # poly(p1, close=true, :fillstroke)
    # for p in p1
    #     gsave()
    #     sethue("black")
    #     circle(p, 1, :fill)
    #     grestore()
    # end


    randomline = [Point(rand(-50:50), -170), Point(rand(-50:50), 170)]


    # split the polygon
    twopolys = polysplit(p1, randomline[1], randomline[2])

    # draw each poly
    for ply in twopolys
        if length(ply) > 1
            gsave()
            randomhue()
            poly(ply, close=true, :fill)
            grestore()
        end
    end

    gsave()
    sethue("red")
    setdash("dotted")
    line(randomline[1], randomline[2], :stroke)
    grestore()

    grestore()
end

fname = "polysplit.pdf"
width, height = 2000, 2000
Drawing(width, height, fname)
origin()
background("ivory")
setlinecap("round")
setopacity(0.6)

pagetiles = Tiler(width, height, 6, 5, margin=50)
for (pos, n) in pagetiles
    sethue("green")
    squircle(pos, pagetiles.tilewidth/2 - 2, pagetiles.tileheight/2 - 2, :stroke)
    testapoly(pos)
end

@test finish() == true
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Test, Random

Random.seed!(42)

function main()
    w, h = 600, 600

    fname = "polysidelengths-test.png"
    Drawing(w, h, fname)
    background("white")
    origin()
    setline(0.5)

    pg = ngon(O, 100, 4, vertices = true)

    r = polysidelengths(pg)
    @test all(isapprox(141.42135623), r)
    @test length(r) == 4

    r = polysidelengths(pg, closed = false)
    @test all(isapprox(141.42135623), r)
    @test length(r) == 3

    for S in 3:10
        D = rand(9:173)
        pg = ngonside(rand(BoundingBox()), D, S, vertices = true)
        @test isapprox(sum(polysidelengths(pg)), S * D)
    end

    @test finish() == true
    println("...finished test: output in $(fname)")
end

main()

# noise, using OpenSimplex algorithm (patent free)

using Random

"""
    noise(x)          ; detail = 1, persistence = 1.0) # 1D
    noise(x, y)       ; detail = 1, persistence = 1.0) # 2D
    noise(x, y, z)    ; detail = 1, persistence = 1.0) # 3D
    noise(x, y, z, w) ; detail = 1, persistence = 1.0) # 4D

Generate a noise value between 0.0 and 1.0 corresponding to the `x`, `y`,
`z`, and `w` values. An `x` value on its own produces 1D noise, `x` and `y`
make 2D noise, and so on.

The `detail` value is an integer (>= 1) specifying how many octaves of noise
you want.

The `persistence` value, typically between 0.0 and 1.0, controls how quickly the
amplitude diminishes for each successive octave for values of `detail` greater
than 1.
"""
noise(x; detail::T = 1, persistence = 1.0) where T <: Integer =
    _octaves([x], octaves=detail, persistence=persistence)

noise(x, y; detail::T = 1, persistence = 1.0) where T <: Integer =
    _octaves([x, y], octaves=detail, persistence=persistence)

noise(x, y, z; detail::T = 1, persistence = 1.0) where T <: Integer =
    _octaves([x, y, z], octaves=detail, persistence=persistence)

noise(x, y, z, w; detail::T = 1, persistence = 1.0) where T <: Integer =
    _octaves([x, y, z, w], octaves=detail, persistence=persistence)

# call simplexnoise on values in array
# coords is [x] or [x, y] or [x, y, z] or [x, y, z, w]
function _octaves(coords::Vector{T} where T <: Real;
        octaves::Int = 1,
        persistence=1.0)
    total     = 0.0
    frequency = 1.0
    amplitude = 1.0
    maxval    = 0.0

    l = length(coords)

    for i in 1:octaves
        if l == 1
            total += simplexnoise(coords[1] * frequency) * amplitude
        elseif l == 2
            total += simplexnoise(coords[1] * frequency, coords[2] * frequency) * amplitude
        elseif l == 3
            total += simplexnoise(coords[1] * frequency, coords[2] * frequency, coords[3] * frequency) * amplitude
        elseif l == 4
            total += simplexnoise(coords[1] * frequency, coords[2] * frequency, coords[3] * frequency, coords[4] * frequency) * amplitude
        end

        maxval += amplitude
        amplitude *= persistence
        frequency *= 2
    end

    return total / maxval
end

# Most of this code is the original OpenSimplexNoise code.
# I converted it to Julia but I don't understand it all... [cormullion]

# OpenSimplex Noise
# by Kurt Spencer
#
# v1.1 (October 5, 2014)
# - Added 2D and 4D implementations.
# - Proper gradient sets for all dimensions, from a
#   dimensionally-generalizable scheme with an actual
#   rhyme and reason behind it.
# - Removed default permutation array in favor of
#   default seed.
# - Changed seed-based constructor to be independent
#   of any particular randomization library, so results
#   will be the same when ported to other languages.

const STRETCH_CONSTANT_2D = -0.211324865405187    # (1/sqrt(2+1)-1)/2
const SQUISH_CONSTANT_2D  =  0.366025403784439    # (sqrt(2+1)-1)/2
const STRETCH_CONSTANT_3D = -0.16666              # (1/sqrt(3+1)-1)/3
const SQUISH_CONSTANT_3D  =  0.333333             # (sqrt(3+1)-1)/3
const STRETCH_CONSTANT_4D = -0.138196601125011    # (1/sqrt(4+1)-1)/4
const SQUISH_CONSTANT_4D  =  0.309016994374947    # (sqrt(4+1)-1)/4

const NORM_CONSTANT_2D    = 47
const NORM_CONSTANT_3D    = 103
const NORM_CONSTANT_4D    = 30

const DEFAULT_SEED        = 0

# Gradients for 2D. They approximate the directions to the
# vertices of an octagon from the center.

const gradients2D = Int8[
 5,  2,  2,  5,
-5,  2, -2,  5,
 5, -2,  2, -5,
-5, -2, -2, -5]

# Gradients for 3D. They approximate the directions to the
# vertices of a rhombicuboctahedron from the center, skewed so
# that the triangular and square facets can be inscribed inside
# circles of the same radius.

const gradients3D = Int8[
-11,  4,  4,     -4,  11,  4,    -4,  4,  11,
 11,  4,  4,      4,  11,  4,     4,  4,  11,
-11, -4,  4,     -4, -11,  4,    -4, -4,  11,
 11, -4,  4,      4, -11,  4,     4, -4,  11,
-11,  4, -4,     -4,  11, -4,    -4,  4, -11,
 11,  4, -4,      4,  11, -4,     4,  4, -11,
-11, -4, -4,     -4, -11, -4,    -4, -4, -11,
 11, -4, -4,      4, -11, -4,     4, -4, -11]

# Gradients for 4D. They approximate the directions to the
# vertices of a disprismatotesseractihexadecachoron from the center,
# skewed so that the tetrahedral and cubic facets can be inscribed inside
# spheres of the same radius.

# [yes, a disprismatotesseractihexadecachoron !]

const gradients4D = Int8[
 3,  1,  1,  1,      1,  3,  1,  1,      1,  1,  3,  1,      1,  1,  1,  3,
-3,  1,  1,  1,     -1,  3,  1,  1,     -1,  1,  3,  1,     -1,  1,  1,  3,
 3, -1,  1,  1,      1, -3,  1,  1,      1, -1,  3,  1,      1, -1,  1,  3,
-3, -1,  1,  1,     -1, -3,  1,  1,     -1, -1,  3,  1,     -1, -1,  1,  3,
 3,  1, -1,  1,      1,  3, -1,  1,      1,  1, -3,  1,      1,  1, -1,  3,
-3,  1, -1,  1,     -1,  3, -1,  1,     -1,  1, -3,  1,     -1,  1, -1,  3,
 3, -1, -1,  1,      1, -3, -1,  1,      1, -1, -3,  1,      1, -1, -1,  3,
-3, -1, -1,  1,     -1, -3, -1,  1,     -1, -1, -3,  1,     -1, -1, -1,  3,
 3,  1,  1, -1,      1,  3,  1, -1,      1,  1,  3, -1,      1,  1,  1, -3,
-3,  1,  1, -1,     -1,  3,  1, -1,     -1,  1,  3, -1,     -1,  1,  1, -3,
 3, -1,  1, -1,      1, -3,  1, -1,      1, -1,  3, -1,      1, -1,  1, -3,
-3, -1,  1, -1,     -1, -3,  1, -1,     -1, -1,  3, -1,     -1, -1,  1, -3,
 3,  1, -1, -1,      1,  3, -1, -1,      1,  1, -3, -1,      1,  1, -1, -3,
-3,  1, -1, -1,     -1,  3, -1, -1,     -1,  1, -3, -1,     -1,  1, -1, -3,
 3, -1, -1, -1,      1, -3, -1, -1,      1, -1, -3, -1,      1, -1, -1, -3,
-3, -1, -1, -1,     -1, -3, -1, -1,     -1, -1, -3, -1,     -1, -1, -1, -3]

function extrapolate(xsb::Int, ysb::Int, dx::Float64, dy::Float64)
    index::Int = perm[1 + (perm[1 + xsb & 0xFF] + ysb) & 0xFF] & 0x0E
    return gradients2D[mod1(1 + index, end)]     * dx +
           gradients2D[mod1(1 + index + 1, end)] * dy
end

function extrapolate(xsb::Int, ysb::Int, zsb::Int, dx, dy, dz)
    index::Int = permGradIndex3D[1 + (perm[1 + (perm[1 + xsb & 0xFF] + ysb) & 0xFF] + zsb) & 0xFF]
    return gradients3D[mod1(index, end)]     * dx +
           gradients3D[mod1(1 + index + 1, end)] * dy +
           gradients3D[mod1(1 + index + 2, end)] * dz
end

function extrapolate(xsb::Int, ysb::Int, zsb::Int, wsb::Int, dx, dy, dz, dw)
    index::Int = perm[1 + (perm[1 + (perm[1 + (perm[1 + xsb & 0xFF] + ysb) & 0xFF] + zsb) & 0xFF] + wsb) & 0xFF] & 0xFC
    return gradients4D[mod1(index, end)]  * dx +
           gradients4D[mod1(1 + index + 1, end)] * dy +
           gradients4D[mod1(1 + index + 2, end)] * dz +
           gradients4D[mod1(1 + index + 3, end)] * dw
end

###############################################################################
# Initializing the random stuff

# I couldn't get the original's wacky bit twiddling and overflow random code to
# produce nice results. So I'm just using Julia's standard random number
# generation here...
# TODO Investigate the original Linear Congruential Generators approach to sowing
# seeds...

# Initialize the two main arrays that are used by all noise functions

const perm            = Vector{Int8}(undef, 256)
const permGradIndex3D = Vector{Int8}(undef, 256)

"""
    initnoise(seed::Int)
    initnoise()

Initialize the noise generation code.

```julia-repl
julia> initnoise(); noise(1)
0.7453148982810598

julia> initnoise(); noise(1)
0.7027617067916981
```

If you provide an integer seed, it will be used
to seed `Random.seed!()` when the noise code is initialized:

```julia-repl
julia> initnoise(41); noise(1) # yesterday
0.7134000046640385

julia> initnoise(41); noise(1) # today
0.7134000046640385
```

If you need to control which type of random number generator is used, you can provide
your own and it will be used instead of the default Julia implementation.

```julia-repl
julia> rng = MersenneTwister(1234) # any AbstractRNG
julia> initnoise(rng)
```
"""
function initnoise(seed)
    Random.seed!(seed)
    for i in 1:256
        perm[i]            = rand(Int8)
        permGradIndex3D[i] = rand(Int8)
    end
end

function initnoise()
    for i in 1:256
        perm[i]            = rand(Int8)
        permGradIndex3D[i] = rand(Int8)
    end
end

function initnoise(rng::AbstractRNG)
    for i in 1:256
        perm[i]            = rand(rng, Int8)
        permGradIndex3D[i] = rand(rng, Int8)
    end
end

initnoise()

###############################################################################
#
# 1D OpenSimplex Noise is really 2D noise
simplexnoise(x) = simplexnoise(x, 0)
#
###############################################################################

###############################################################################
#
# 2D OpenSimplex Noise
#
# comments from original Java source
# TODO convert to Julia properly
###############################################################################
function simplexnoise(x, y)
    # Place input coordinates onto grid.
    stretchOffset = (x + y) * STRETCH_CONSTANT_2D
    xs = x + stretchOffset
    ys = y + stretchOffset

    # Floor to get grid coordinates of rhombus (stretched square) super-cell origin.
    xsb = convert(Int, floor(xs))
    ysb = convert(Int, floor(ys))

    # Skew out to get actual coordinates of rhombus origin. We'll need these later.
    squishOffset = (xsb + ysb) * SQUISH_CONSTANT_2D
    xb = xsb + squishOffset
    yb = ysb + squishOffset

    # Compute grid coordinates relative to rhombus origin.
    xins = xs - xsb
    yins = ys - ysb

    # Sum those together to get a value that determines which region we're in.
    inSum = xins + yins

    # Positions relative to origin point.
    dx0 = x - xb
    dy0 = y - yb

    # We'll be defining these inside the next block and using them afterwards.
    # dx_ext, dy_ext, xsv_ext, ysv_ext

    value = 0.0

    # Contribution (1,0)
    dx1 = dx0 - 1 - SQUISH_CONSTANT_2D
    dy1 = dy0 - 0 - SQUISH_CONSTANT_2D
    attn1 = 2 - dx1 * dx1 - dy1 * dy1
    if attn1 > 0
        attn1 *= attn1
        value += attn1 * attn1 * extrapolate(xsb + 1, ysb + 0, dx1, dy1)
    end

    # Contribution (0,1)
    dx2 = dx0 - 0 - SQUISH_CONSTANT_2D
    dy2 = dy0 - 1 - SQUISH_CONSTANT_2D
    attn2 = 2 - dx2 * dx2 - dy2 * dy2
    if attn2 > 0
        attn2 *= attn2
        value += attn2 * attn2 * extrapolate(xsb + 0, ysb + 1, dx2, dy2)
    end

    if inSum <= 1 # We're inside the triangle (2-Simplex) at (0,0)
        zins = 1 - inSum
        if (zins > xins) || (zins > yins) # (0,0) is one of the closest two triangular vertices
            if xins > yins
                xsv_ext = xsb + 1
                ysv_ext = ysb - 1
                dx_ext = dx0 - 1
                dy_ext = dy0 + 1
            else
                xsv_ext = xsb - 1
                ysv_ext = ysb + 1
                dx_ext = dx0 + 1
                dy_ext = dy0 - 1
            end
        else # (1,0) and (0,1) are the closest two vertices.
            xsv_ext = xsb + 1
            ysv_ext = ysb + 1
            dx_ext = dx0 - 1 - 2 * SQUISH_CONSTANT_2D
            dy_ext = dy0 - 1 - 2 * SQUISH_CONSTANT_2D
        end
    else # We're inside the triangle (2-Simplex) at (1,1)
        zins = 2 - inSum
        if (zins < xins) || (zins < yins) # (0,0) is one of the closest two triangular vertices
            if xins > yins
                xsv_ext = xsb + 2
                ysv_ext = ysb + 0
                dx_ext = dx0 - 2 - 2 * SQUISH_CONSTANT_2D
                dy_ext = dy0 + 0 - 2 * SQUISH_CONSTANT_2D
            else
                xsv_ext = xsb + 0
                ysv_ext = ysb + 2
                dx_ext = dx0 + 0 - 2 * SQUISH_CONSTANT_2D
                dy_ext = dy0 - 2 - 2 * SQUISH_CONSTANT_2D
            end
        else  # (1,0) and (0,1) are the closest two vertices.
            dx_ext = dx0
            dy_ext = dy0
            xsv_ext = xsb
            ysv_ext = ysb
        end
        xsb += 1
        ysb += 1
        dx0 = dx0 - 1 - 2 * SQUISH_CONSTANT_2D
        dy0 = dy0 - 1 - 2 * SQUISH_CONSTANT_2D
    end

    # Contribution (0,0) or (1,1)
    attn0 = 2 - dx0 * dx0 - dy0 * dy0
    if attn0 > 0
        attn0 *= attn0
        value += attn0 * attn0 * extrapolate(xsb, ysb, dx0, dy0)
    end

    # Extra Vertex
    attn_ext = 2 - dx_ext * dx_ext - dy_ext * dy_ext
    if attn_ext > 0
        attn_ext *= attn_ext
        value += attn_ext * attn_ext * extrapolate(xsv_ext, ysv_ext, dx_ext, dy_ext)
    end

    # convert to [0, 1]
    res = value / NORM_CONSTANT_2D
    return clamp((res + 1) / 2, 0.0, 1.0)
end

# 3D OpenSimplex Noise.
# TODO convert to Julia properly
function simplexnoise(x, y, z)
    # Place input coordinates on simplectic honeycomb.
    stretchOffset = (x + y + z) * STRETCH_CONSTANT_3D
    xs = x + stretchOffset
    ys = y + stretchOffset
    zs = z + stretchOffset

    # Floor to get simplectic honeycomb coordinates of rhombohedron (stretched cube) super-cell origin.
    xsb = convert(Int, floor(xs))
    ysb = convert(Int, floor(ys))
    zsb = convert(Int, floor(zs))

    # Skew out to get actual coordinates of rhombohedron origin. We'll need these later.
    squishOffset = (xsb + ysb + zsb) * SQUISH_CONSTANT_3D
    xb = xsb + squishOffset
    yb = ysb + squishOffset
    zb = zsb + squishOffset

    # Compute simplectic honeycomb coordinates relative to rhombohedral origin.
    xins = xs - xsb
    yins = ys - ysb
    zins = zs - zsb

    # Sum those together to get a value that determines which region we're in.
    inSum = xins + yins + zins

    # Positions relative to origin point.
    dx0 = x - xb
    dy0 = y - yb
    dz0 = z - zb

    # We'll be defining these inside the next block and using them afterwards.
    # dx_ext0, dy_ext0, dz_ext0
    # dx_ext1, dy_ext1, dz_ext1
    # int xsv_ext0, ysv_ext0, zsv_ext0
    # int xsv_ext1, ysv_ext1, zsv_ext1
    value = 0.0

    if inSum <= 1 # We're inside the tetrahedron (3-Simplex) at (0,0,0)
        # Determine which two of (0,0,1), (0,1,0), (1,0,0) are closest.
        aPoint = 0x01
        aScore = xins
        bPoint = 0x02
        bScore = yins
        if (aScore >= bScore) && (zins > bScore)
            bScore = zins
            bPoint = 0x04
        elseif (aScore < bScore) && (zins > aScore)
            aScore = zins
            aPoint = 0x04
        end
        # Now we determine the two lattice points not part of the tetrahedron that may contribute.
        # This depends on the closest two tetrahedral vertices, including (0,0,0)
        wins = 1 - inSum
        if (wins > aScore) || (wins > bScore) # (0,0,0) is one of the closest two tetrahedral vertices.
            c = (bScore > aScore) ? bPoint : aPoint # Our other closest vertex is the closest out of a and b.
            if (c & 0x01) == 0
                xsv_ext0 = xsb - 1
                xsv_ext1 = xsb
                dx_ext0 = dx0 + 1
                dx_ext1 = dx0
            else
                xsv_ext0 = xsv_ext1 = xsb + 1
                dx_ext0 = dx_ext1 = dx0 - 1
            end
            if (c & 0x02) == 0
                ysv_ext0 = ysv_ext1 = ysb
                dy_ext0 = dy_ext1 = dy0
                if (c & 0x01) == 0
                    ysv_ext1 -= 1
                    dy_ext1 += 1
                else
                    ysv_ext0 -= 1
                    dy_ext0 += 1
                end
            else
                ysv_ext0 = ysv_ext1 = ysb + 1
                dy_ext0 = dy_ext1 = dy0 - 1
            end
            if (c & 0x04) == 0
                zsv_ext0 = zsb
                zsv_ext1 = zsb - 1
                dz_ext0 = dz0
                dz_ext1 = dz0 + 1
            else
                zsv_ext0 = zsv_ext1 = zsb + 1
                dz_ext0 = dz_ext1 = dz0 - 1
            end
        else  # (0,0,0) is not one of the closest two tetrahedral vertices.
            c = (aPoint | bPoint) # Our two extra vertices are determined by the closest two.
            if (c & 0x01) == 0
                xsv_ext0 = xsb
                xsv_ext1 = xsb - 1
                dx_ext0 = dx0 - 2 * SQUISH_CONSTANT_3D
                dx_ext1 = dx0 + 1 - SQUISH_CONSTANT_3D
            else
                xsv_ext0 = xsv_ext1 = xsb + 1
                dx_ext0 = dx0 - 1 - 2 * SQUISH_CONSTANT_3D
                dx_ext1 = dx0 - 1 - SQUISH_CONSTANT_3D
            end
            if (c & 0x02) == 0
                ysv_ext0 = ysb
                ysv_ext1 = ysb - 1
                dy_ext0 = dy0 - 2 * SQUISH_CONSTANT_3D
                dy_ext1 = dy0 + 1 - SQUISH_CONSTANT_3D
            else
                ysv_ext0 = ysv_ext1 = ysb + 1
                dy_ext0 = dy0 - 1 - 2 * SQUISH_CONSTANT_3D
                dy_ext1 = dy0 - 1 - SQUISH_CONSTANT_3D
            end
            if (c & 0x04) == 0
                zsv_ext0 = zsb
                zsv_ext1 = zsb - 1
                dz_ext0 = dz0 - 2 * SQUISH_CONSTANT_3D
                dz_ext1 = dz0 + 1 - SQUISH_CONSTANT_3D
            else
                zsv_ext0 = zsv_ext1 = zsb + 1
                dz_ext0 = dz0 - 1 - 2 * SQUISH_CONSTANT_3D
                dz_ext1 = dz0 - 1 - SQUISH_CONSTANT_3D
            end
        end
        # Contribution (0,0,0)
        attn0 = 2 - dx0 * dx0 - dy0 * dy0 - dz0 * dz0
        if attn0 > 0
            attn0 *= attn0
            value += attn0 * attn0 * extrapolate(xsb + 0, ysb + 0, zsb + 0, dx0, dy0, dz0)
        end
        # Contribution (1,0,0)
        dx1 = dx0 - 1 - SQUISH_CONSTANT_3D
        dy1 = dy0 - 0 - SQUISH_CONSTANT_3D
        dz1 = dz0 - 0 - SQUISH_CONSTANT_3D
        attn1 = 2 - dx1 * dx1 - dy1 * dy1 - dz1 * dz1
        if attn1 > 0
            attn1 *= attn1
            value += attn1 * attn1 * extrapolate(xsb + 1, ysb + 0, zsb + 0, dx1, dy1, dz1)
        end
        # Contribution (0,1,0)
        dx2 = dx0 - 0 - SQUISH_CONSTANT_3D
        dy2 = dy0 - 1 - SQUISH_CONSTANT_3D
        dz2 = dz1
        attn2 = 2 - dx2 * dx2 - dy2 * dy2 - dz2 * dz2
        if attn2 > 0
            attn2 *= attn2
            value += attn2 * attn2 * extrapolate(xsb + 0, ysb + 1, zsb + 0, dx2, dy2, dz2)
        end
        # Contribution (0,0,1)
        dx3 = dx2
        dy3 = dy1
        dz3 = dz0 - 1 - SQUISH_CONSTANT_3D
        attn3 = 2 - dx3 * dx3 - dy3 * dy3 - dz3 * dz3
        if attn3 > 0
            attn3 *= attn3
            value += attn3 * attn3 * extrapolate(xsb + 0, ysb + 0, zsb + 1, dx3, dy3, dz3)
        end
    elseif inSum >= 2  # We're inside the tetrahedron (3-Simplex) at (1,1,1)
        # Determine which two tetrahedral vertices are the closest, out of (1,1,0), (1,0,1), (0,1,1) but not (1,1,1).
        aPoint = 0x06
        aScore = xins
        bPoint = 0x05
        bScore = yins
        if (aScore <= bScore) && (zins < bScore)
            bScore = zins
            bPoint = 0x03
        elseif (aScore > bScore) && (zins < aScore)
            aScore = zins
            aPoint = 0x03
        end
        # Now we determine the two lattice points not part of the tetrahedron that may contribute.
        # This depends on the closest two tetrahedral vertices, including (1,1,1)
        wins = 3 - inSum
        if wins < aScore || wins < bScore  # (1,1,1) is one of the closest two tetrahedral vertices.
            c = (bScore < aScore ? bPoint : aPoint) # Our other closest vertex is the closest out of a and b.
            if (c & 0x01) != 0
                xsv_ext0 = xsb + 2
                xsv_ext1 = xsb + 1
                dx_ext0 = dx0 - 2 - 3 * SQUISH_CONSTANT_3D
                dx_ext1 = dx0 - 1 - 3 * SQUISH_CONSTANT_3D
            else
                xsv_ext0 = xsv_ext1 = xsb
                dx_ext0 = dx_ext1 = dx0 - 3 * SQUISH_CONSTANT_3D
            end
            if (c & 0x02) != 0
                ysv_ext0 = ysv_ext1 = ysb + 1
                dy_ext0 = dy_ext1 = dy0 - 1 - 3 * SQUISH_CONSTANT_3D
                if (c & 0x01) != 0
                    ysv_ext1 += 1
                    dy_ext1 -= 1
                else
                    ysv_ext0 += 1
                    dy_ext0 -= 1
                end
            else
                ysv_ext0 = ysv_ext1 = ysb
                dy_ext0 = dy_ext1 = dy0 - 3 * SQUISH_CONSTANT_3D
            end
            if (c & 0x04) != 0
                zsv_ext0 = zsb + 1
                zsv_ext1 = zsb + 2
                dz_ext0 = dz0 - 1 - 3 * SQUISH_CONSTANT_3D
                dz_ext1 = dz0 - 2 - 3 * SQUISH_CONSTANT_3D
            else
                zsv_ext0 = zsv_ext1 = zsb
                dz_ext0 = dz_ext1 = dz0 - 3 * SQUISH_CONSTANT_3D
            end
        else  # (1,1,1) is not one of the closest two tetrahedral vertices.
            c = (aPoint & bPoint) # Our two extra vertices are determined by the closest two.
            if (c & 0x01) != 0
                xsv_ext0 = xsb + 1
                xsv_ext1 = xsb + 2
                dx_ext0 = dx0 - 1 - SQUISH_CONSTANT_3D
                dx_ext1 = dx0 - 2 - 2 * SQUISH_CONSTANT_3D
            else
                xsv_ext0 = xsv_ext1 = xsb
                dx_ext0 = dx0 - SQUISH_CONSTANT_3D
                dx_ext1 = dx0 - 2 * SQUISH_CONSTANT_3D
            end
            if (c & 0x02) != 0
                ysv_ext0 = ysb + 1
                ysv_ext1 = ysb + 2
                dy_ext0 = dy0 - 1 - SQUISH_CONSTANT_3D
                dy_ext1 = dy0 - 2 - 2 * SQUISH_CONSTANT_3D
            else
                ysv_ext0 = ysv_ext1 = ysb
                dy_ext0 = dy0 - SQUISH_CONSTANT_3D
                dy_ext1 = dy0 - 2 * SQUISH_CONSTANT_3D
            end
            if (c & 0x04) != 0
                zsv_ext0 = zsb + 1
                zsv_ext1 = zsb + 2
                dz_ext0 = dz0 - 1 - SQUISH_CONSTANT_3D
                dz_ext1 = dz0 - 2 - 2 * SQUISH_CONSTANT_3D
            else
                zsv_ext0 = zsv_ext1 = zsb
                dz_ext0 = dz0 - SQUISH_CONSTANT_3D
                dz_ext1 = dz0 - 2 * SQUISH_CONSTANT_3D
            end
        end
        # Contribution (1,1,0)
        dx3 = dx0 - 1 - 2 * SQUISH_CONSTANT_3D
        dy3 = dy0 - 1 - 2 * SQUISH_CONSTANT_3D
        dz3 = dz0 - 0 - 2 * SQUISH_CONSTANT_3D
        attn3 = 2 - dx3 * dx3 - dy3 * dy3 - dz3 * dz3
        if attn3 > 0
            attn3 *= attn3
            value += attn3 * attn3 * extrapolate(xsb + 1, ysb + 1, zsb + 0, dx3, dy3, dz3)
        end
        # Contribution (1,0,1)
        dx2 = dx3
        dy2 = dy0 - 0 - 2 * SQUISH_CONSTANT_3D
        dz2 = dz0 - 1 - 2 * SQUISH_CONSTANT_3D
        attn2 = 2 - dx2 * dx2 - dy2 * dy2 - dz2 * dz2
        if attn2 > 0
            attn2 *= attn2
            value += attn2 * attn2 * extrapolate(xsb + 1, ysb + 0, zsb + 1, dx2, dy2, dz2)
        end
        # Contribution (0,1,1)
        dx1 = dx0 - 0 - 2 * SQUISH_CONSTANT_3D
        dy1 = dy3
        dz1 = dz2
        attn1 = 2 - dx1 * dx1 - dy1 * dy1 - dz1 * dz1
        if attn1 > 0
            attn1 *= attn1
            value += attn1 * attn1 * extrapolate(xsb + 0, ysb + 1, zsb + 1, dx1, dy1, dz1)
        end
        # Contribution (1,1,1)
        dx0 = dx0 - 1 - 3 * SQUISH_CONSTANT_3D
        dy0 = dy0 - 1 - 3 * SQUISH_CONSTANT_3D
        dz0 = dz0 - 1 - 3 * SQUISH_CONSTANT_3D
        attn0 = 2 - dx0 * dx0 - dy0 * dy0 - dz0 * dz0
        if attn0 > 0
            attn0 *= attn0
            value += attn0 * attn0 * extrapolate(xsb + 1, ysb + 1, zsb + 1, dx0, dy0, dz0)
        end
    else # We're inside the octahedron (Rectified 3-Simplex) in between.
        # Decide between point (0,0,1) and (1,1,0) as closest
        p1 = xins + yins
        if p1 > 1
            aScore = p1 - 1
            aPoint = 0x03
            aIsFurtherSide = true
        else
            aScore = 1 - p1
            aPoint = 0x04
            aIsFurtherSide = false
        end
        # Decide between point (0,1,0) and (1,0,1) as closest
        p2 = xins + zins
        if p2 > 1
            bScore = p2 - 1
            bPoint = 0x05
            bIsFurtherSide = true
        else
            bScore = 1 - p2
            bPoint = 0x02
            bIsFurtherSide = false
        end
        # The closest out of the two (1,0,0) and (0,1,1) will replace the furthest out of the two decided above, if closer.
        p3 = yins + zins
        if p3 > 1
            score = p3 - 1
            if (aScore <= bScore) && (aScore < score)
                aScore = score
                aPoint = 0x06
                aIsFurtherSide = true
            elseif (aScore > bScore) && (bScore < score)
                bScore = score
                bPoint = 0x06
                bIsFurtherSide = true
            end
        else
            score = 1 - p3
            if (aScore <= bScore) && (aScore < score)
                aScore = score
                aPoint = 0x01
                aIsFurtherSide = false
            elseif (aScore > bScore) && (bScore < score)
                bScore = score
                bPoint = 0x01
                bIsFurtherSide = false
            end
        end
        # Where each of the two closest points are determines how the extra two vertices are calculated.
        if aIsFurtherSide == bIsFurtherSide
            if aIsFurtherSide # Both closest points on (1,1,1) side
                # One of the two extra points is (1,1,1)
                dx_ext0 = dx0 - 1 - 3 * SQUISH_CONSTANT_3D
                dy_ext0 = dy0 - 1 - 3 * SQUISH_CONSTANT_3D
                dz_ext0 = dz0 - 1 - 3 * SQUISH_CONSTANT_3D
                xsv_ext0 = xsb + 1
                ysv_ext0 = ysb + 1
                zsv_ext0 = zsb + 1
                # Other extra point is based on the shared axis.
                c = aPoint & bPoint
                if (c & 0x01) != 0
                    dx_ext1 = dx0 - 2 - 2 * SQUISH_CONSTANT_3D
                    dy_ext1 = dy0 - 2 * SQUISH_CONSTANT_3D
                    dz_ext1 = dz0 - 2 * SQUISH_CONSTANT_3D
                    xsv_ext1 = xsb + 2
                    ysv_ext1 = ysb
                    zsv_ext1 = zsb
                elseif (c & 0x02) != 0
                    dx_ext1 = dx0 - 2 * SQUISH_CONSTANT_3D
                    dy_ext1 = dy0 - 2 - 2 * SQUISH_CONSTANT_3D
                    dz_ext1 = dz0 - 2 * SQUISH_CONSTANT_3D
                    xsv_ext1 = xsb
                    ysv_ext1 = ysb + 2
                    zsv_ext1 = zsb
                else
                    dx_ext1 = dx0 - 2 * SQUISH_CONSTANT_3D
                    dy_ext1 = dy0 - 2 * SQUISH_CONSTANT_3D
                    dz_ext1 = dz0 - 2 - 2 * SQUISH_CONSTANT_3D
                    xsv_ext1 = xsb
                    ysv_ext1 = ysb
                    zsv_ext1 = zsb + 2
                end
            else # Both closest points on (0,0,0) side
                # One of the two extra points is (0,0,0)
                dx_ext0 = dx0
                dy_ext0 = dy0
                dz_ext0 = dz0
                xsv_ext0 = xsb
                ysv_ext0 = ysb
                zsv_ext0 = zsb
                # Other extra point is based on the omitted axis.
                c = aPoint | bPoint
                if (c & 0x01) == 0 # other extra omitted axis
                    dx_ext1 = dx0 + 1 - SQUISH_CONSTANT_3D
                    dy_ext1 = dy0 - 1 - SQUISH_CONSTANT_3D
                    dz_ext1 = dz0 - 1 - SQUISH_CONSTANT_3D
                    xsv_ext1 = xsb - 1
                    ysv_ext1 = ysb + 1
                    zsv_ext1 = zsb + 1
                elseif (c & 0x02) == 0
                    dx_ext1 = dx0 - 1 - SQUISH_CONSTANT_3D
                    dy_ext1 = dy0 + 1 - SQUISH_CONSTANT_3D
                    dz_ext1 = dz0 - 1 - SQUISH_CONSTANT_3D
                    xsv_ext1 = xsb + 1
                    ysv_ext1 = ysb - 1
                    zsv_ext1 = zsb + 1
                else
                    dx_ext1 = dx0 - 1 - SQUISH_CONSTANT_3D
                    dy_ext1 = dy0 - 1 - SQUISH_CONSTANT_3D
                    dz_ext1 = dz0 + 1 - SQUISH_CONSTANT_3D
                    xsv_ext1 = xsb + 1
                    ysv_ext1 = ysb + 1
                    zsv_ext1 = zsb - 1
                end
            end
        else # One point on (0,0,0) side, one point on (1,1,1) side
            if aIsFurtherSide
                c1 = aPoint
                c2 = bPoint
            else
                c1 = bPoint
                c2 = aPoint
            end
            # One contribution is a permutation of (1,1,-1)
            if c1 & 0x01 == 0
                dx_ext0 = dx0 + 1 - SQUISH_CONSTANT_3D
                dy_ext0 = dy0 - 1 - SQUISH_CONSTANT_3D
                dz_ext0 = dz0 - 1 - SQUISH_CONSTANT_3D
                xsv_ext0 = xsb - 1
                ysv_ext0 = ysb + 1
                zsv_ext0 = zsb + 1
            elseif c1 & 0x02 == 0
                dx_ext0 = dx0 - 1 - SQUISH_CONSTANT_3D
                dy_ext0 = dy0 + 1 - SQUISH_CONSTANT_3D
                dz_ext0 = dz0 - 1 - SQUISH_CONSTANT_3D
                xsv_ext0 = xsb + 1
                ysv_ext0 = ysb - 1
                zsv_ext0 = zsb + 1
            else
                dx_ext0 = dx0 - 1 - SQUISH_CONSTANT_3D
                dy_ext0 = dy0 - 1 - SQUISH_CONSTANT_3D
                dz_ext0 = dz0 + 1 - SQUISH_CONSTANT_3D
                xsv_ext0 = xsb + 1
                ysv_ext0 = ysb + 1
                zsv_ext0 = zsb - 1
            end
            # One contribution is a permutation of (0,0,2)
            dx_ext1 = dx0 - 2 * SQUISH_CONSTANT_3D
            dy_ext1 = dy0 - 2 * SQUISH_CONSTANT_3D
            dz_ext1 = dz0 - 2 * SQUISH_CONSTANT_3D
            xsv_ext1 = xsb
            ysv_ext1 = ysb
            zsv_ext1 = zsb
            if (c2 & 0x01) != 0
                dx_ext1 -= 2
                xsv_ext1 += 2
            elseif (c2 & 0x02) != 0
                dy_ext1 -= 2
                ysv_ext1 += 2
            else
                dz_ext1 -= 2
                zsv_ext1 += 2
            end
        end
        # Contribution (1,0,0)
        dx1 = dx0 - 1 - SQUISH_CONSTANT_3D
        dy1 = dy0 - 0 - SQUISH_CONSTANT_3D
        dz1 = dz0 - 0 - SQUISH_CONSTANT_3D
        attn1 = 2 - dx1 * dx1 - dy1 * dy1 - dz1 * dz1
        if attn1 > 0
            attn1 *= attn1
            value += attn1 * attn1 * extrapolate(xsb + 1, ysb + 0, zsb + 0, dx1, dy1, dz1)
        end

        # Contribution (0,1,0)
        dx2 = dx0 - 0 - SQUISH_CONSTANT_3D
        dy2 = dy0 - 1 - SQUISH_CONSTANT_3D
        dz2 = dz1
        attn2 = 2 - dx2 * dx2 - dy2 * dy2 - dz2 * dz2
        if attn2 > 0
            attn2 *= attn2
            value += attn2 * attn2 * extrapolate(xsb + 0, ysb + 1, zsb + 0, dx2, dy2, dz2)
        end

        # Contribution (0,0,1)
        dx3 = dx2
        dy3 = dy1
        dz3 = dz0 - 1 - SQUISH_CONSTANT_3D
        attn3 = 2 - dx3 * dx3 - dy3 * dy3 - dz3 * dz3
        if attn3 > 0
            attn3 *= attn3
            value += attn3 * attn3 * extrapolate(xsb + 0, ysb + 0, zsb + 1, dx3, dy3, dz3)
        end
        # Contribution (1,1,0)
        dx4 = dx0 - 1 - 2 * SQUISH_CONSTANT_3D
        dy4 = dy0 - 1 - 2 * SQUISH_CONSTANT_3D
        dz4 = dz0 - 0 - 2 * SQUISH_CONSTANT_3D
        attn4 = 2 - dx4 * dx4 - dy4 * dy4 - dz4 * dz4
        if attn4 > 0
            attn4 *= attn4
            value += attn4 * attn4 * extrapolate(xsb + 1, ysb + 1, zsb + 0, dx4, dy4, dz4)
        end
        # Contribution (1,0,1)
        dx5 = dx4
        dy5 = dy0 - 0 - 2 * SQUISH_CONSTANT_3D
        dz5 = dz0 - 1 - 2 * SQUISH_CONSTANT_3D
        attn5 = 2 - dx5 * dx5 - dy5 * dy5 - dz5 * dz5
        if attn5 > 0
            attn5 *= attn5
            value += attn5 * attn5 * extrapolate(xsb + 1, ysb + 0, zsb + 1, dx5, dy5, dz5)
        end
        # Contribution (0,1,1)
        dx6 = dx0 - 0 - 2 * SQUISH_CONSTANT_3D
        dy6 = dy4
        dz6 = dz5
        attn6 = 2 - dx6 * dx6 - dy6 * dy6 - dz6 * dz6
        if attn6 > 0
            attn6 *= attn6
            value += attn6 * attn6 * extrapolate(xsb + 0, ysb + 1, zsb + 1, dx6, dy6, dz6)
        end
    end
    # First extra vertex
    attn_ext0 = 2 - dx_ext0 * dx_ext0 - dy_ext0 * dy_ext0 - dz_ext0 * dz_ext0
    if attn_ext0 > 0
        attn_ext0 *= attn_ext0
        value += attn_ext0 * attn_ext0 * extrapolate(xsv_ext0, ysv_ext0, zsv_ext0, dx_ext0, dy_ext0, dz_ext0)
    end
    # Second extra vertex
    attn_ext1 = 2 - dx_ext1 * dx_ext1 - dy_ext1 * dy_ext1 - dz_ext1 * dz_ext1
    if attn_ext1 > 0
        attn_ext1 *= attn_ext1
        value += attn_ext1 * attn_ext1 * extrapolate(xsv_ext1, ysv_ext1, zsv_ext1, dx_ext1, dy_ext1, dz_ext1)
    end

    res = value / NORM_CONSTANT_3D
    # convert to [0, 1]
    return clamp((res + 1) / 2, 0.0, 1.0)
end

# 4D OpenSimplex Noise.
function simplexnoise(x, y, z, w)
    # TODO convert to Julia properly
    # Place input coordinates on simplectic honeycomb.
    stretchOffset = (x + y + z + w) * STRETCH_CONSTANT_4D
    xs = x + stretchOffset
    ys = y + stretchOffset
    zs = z + stretchOffset
    ws = w + stretchOffset

    # Floor to get simplectic honeycomb coordinates of rhombo-hypercube super-cell origin.
    xsb = convert(Int, floor(xs))
    ysb = convert(Int, floor(ys))
    zsb = convert(Int, floor(zs))
    wsb = convert(Int, floor(ws))

    # Skew out to get actual coordinates of stretched rhombo-hypercube origin. We'll need these later.
    squishOffset = (xsb + ysb + zsb + wsb) * SQUISH_CONSTANT_4D
    xb = xsb + squishOffset
    yb = ysb + squishOffset
    zb = zsb + squishOffset
    wb = wsb + squishOffset

    # Compute simplectic honeycomb coordinates relative to rhombo-hypercube origin.
    xins = xs - xsb
    yins = ys - ysb
    zins = zs - zsb
    wins = ws - wsb

    # Sum those together to get a value that determines which region we're in.
    inSum = xins + yins + zins + wins

    # Positions relative to origin point.
    dx0 = x - xb
    dy0 = y - yb
    dz0 = z - zb
    dw0 = w - wb

    value = 0.0

    if inSum <= 1  # We're inside the pentachoron (4-Simplex) at (0,0,0,0)
        # Determine which two of (0,0,0,1), (0,0,1,0), (0,1,0,0), (1,0,0,0) are closest.
        aPoint = 0x01
        aScore = xins
        bPoint = 0x02
        bScore = yins
        if (aScore >= bScore) && (zins > bScore)
            bScore = zins
            bPoint = 0x04
        elseif (aScore < bScore) && (zins > aScore)
            aScore = zins
            aPoint = 0x04
        end
        if (aScore >= bScore) && (wins > bScore)
            bScore = wins
            bPoint = 0x08
        elseif (aScore < bScore) && (wins > aScore)
            aScore = wins
            aPoint = 0x08
        end
        # Now we determine the three lattice points not part of the pentachoron that may contribute.
        # This depends on the closest two pentachoron vertices, including (0,0,0,0)
        uins = 1 - inSum
        if (uins > aScore) || (uins > bScore)  # (0,0,0,0) is one of the closest two pentachoron vertices.
            c = (bScore > aScore ? bPoint : aPoint) # Our other closest vertex is the closest out of a and b.
            if (c & 0x01) == 0
                xsv_ext0 = xsb - 1
                xsv_ext1 = xsv_ext2 = xsb
                dx_ext0 = dx0 + 1
                dx_ext1 = dx_ext2 = dx0
            else
                xsv_ext0 = xsv_ext1 = xsv_ext2 = xsb + 1
                dx_ext0 = dx_ext1 = dx_ext2 = dx0 - 1
            end
            if (c & 0x02) == 0
                ysv_ext0 = ysv_ext1 = ysv_ext2 = ysb
                dy_ext0 = dy_ext1 = dy_ext2 = dy0
                if (c & 0x01) == 0x01
                    ysv_ext0 -= 1
                    dy_ext0 += 1
                else
                    ysv_ext1 -= 1
                    dy_ext1 += 1
                end
            else
                ysv_ext0 = ysv_ext1 = ysv_ext2 = ysb + 1
                dy_ext0 = dy_ext1 = dy_ext2 = dy0 - 1
            end
            if (c & 0x04) == 0
                zsv_ext0 = zsv_ext1 = zsv_ext2 = zsb
                dz_ext0 = dz_ext1 = dz_ext2 = dz0
                if (c & 0x03) != 0
                    if (c & 0x03) == 0x03
                        zsv_ext0 -= 1
                        dz_ext0 += 1
                    else
                        zsv_ext1 -= 1
                        dz_ext1 += 1
                    end
                else
                    zsv_ext2 -= 1
                    dz_ext2 += 1
                end
            else
                zsv_ext0 = zsv_ext1 = zsv_ext2 = zsb + 1
                dz_ext0 = dz_ext1 = dz_ext2 = dz0 - 1
            end
            if (c & 0x08) == 0
                wsv_ext0 = wsv_ext1 = wsb
                wsv_ext2 = wsb - 1
                dw_ext0 = dw_ext1 = dw0
                dw_ext2 = dw0 + 1
            else
                wsv_ext0 = wsv_ext1 = wsv_ext2 = wsb + 1
                dw_ext0 = dw_ext1 = dw_ext2 = dw0 - 1
            end
        else  # (0,0,0,0) is not one of the closest two pentachoron vertices.
            c = aPoint | bPoint # Our three extra vertices are determined by the closest two.
            if (c & 0x01) == 0
                xsv_ext0 = xsv_ext2 = xsb
                xsv_ext1 = xsb - 1
                dx_ext0 = dx0 - 2 * SQUISH_CONSTANT_4D
                dx_ext1 = dx0 + 1 - SQUISH_CONSTANT_4D
                dx_ext2 = dx0 - SQUISH_CONSTANT_4D
            else
                xsv_ext0 = xsv_ext1 = xsv_ext2 = xsb + 1
                dx_ext0 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
                dx_ext1 = dx_ext2 = dx0 - 1 - SQUISH_CONSTANT_4D
            end

            if (c & 0x02) == 0
                ysv_ext0 = ysv_ext1 = ysv_ext2 = ysb
                dy_ext0 = dy0 - 2 * SQUISH_CONSTANT_4D
                dy_ext1 = dy_ext2 = dy0 - SQUISH_CONSTANT_4D
                if (c & 0x01) == 0x01
                    ysv_ext1 -= 1
                    dy_ext1 += 1
                else
                    ysv_ext2 -= 1
                    dy_ext2 += 1
                end
            else
                ysv_ext0 = ysv_ext1 = ysv_ext2 = ysb + 1
                dy_ext0 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
                dy_ext1 = dy_ext2 = dy0 - 1 - SQUISH_CONSTANT_4D
            end

            if (c & 0x04) == 0
                zsv_ext0 = zsv_ext1 = zsv_ext2 = zsb
                dz_ext0 = dz0 - 2 * SQUISH_CONSTANT_4D
                dz_ext1 = dz_ext2 = dz0 - SQUISH_CONSTANT_4D
                if (c & 0x03) == 0x03
                    zsv_ext1 -= 1
                    dz_ext1 += 1
                else
                    zsv_ext2 -= 1
                    dz_ext2 += 1
                end
            else
                zsv_ext0 = zsv_ext1 = zsv_ext2 = zsb + 1
                dz_ext0 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
                dz_ext1 = dz_ext2 = dz0 - 1 - SQUISH_CONSTANT_4D
            end

            if (c & 0x08) == 0
                wsv_ext0 = wsv_ext1 = wsb
                wsv_ext2 = wsb - 1
                dw_ext0 = dw0 - 2 * SQUISH_CONSTANT_4D
                dw_ext1 = dw0 - SQUISH_CONSTANT_4D
                dw_ext2 = dw0 + 1 - SQUISH_CONSTANT_4D
            else
                wsv_ext0 = wsv_ext1 = wsv_ext2 = wsb + 1
                dw_ext0 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
                dw_ext1 = dw_ext2 = dw0 - 1 - SQUISH_CONSTANT_4D
            end
        end

        # Contribution (0,0,0,0)
        attn0 = 2 - dx0 * dx0 - dy0 * dy0 - dz0 * dz0 - dw0 * dw0
        if attn0 > 0
            attn0 *= attn0
            value += attn0 * attn0 * extrapolate(xsb + 0, ysb + 0, zsb + 0, wsb + 0, dx0, dy0, dz0, dw0)
        end

        # Contribution (1,0,0,0)
        dx1 = dx0 - 1 - SQUISH_CONSTANT_4D
        dy1 = dy0 - 0 - SQUISH_CONSTANT_4D
        dz1 = dz0 - 0 - SQUISH_CONSTANT_4D
        dw1 = dw0 - 0 - SQUISH_CONSTANT_4D
        attn1 = 2 - dx1 * dx1 - dy1 * dy1 - dz1 * dz1 - dw1 * dw1
        if attn1 > 0
            attn1 *= attn1
            value += attn1 * attn1 * extrapolate(xsb + 1, ysb + 0, zsb + 0, wsb + 0, dx1, dy1, dz1, dw1)
        end

        # Contribution (0,1,0,0)
        dx2 = dx0 - 0 - SQUISH_CONSTANT_4D
        dy2 = dy0 - 1 - SQUISH_CONSTANT_4D
        dz2 = dz1
        dw2 = dw1
        attn2 = 2 - dx2 * dx2 - dy2 * dy2 - dz2 * dz2 - dw2 * dw2
        if attn2 > 0
            attn2 *= attn2
            value += attn2 * attn2 * extrapolate(xsb + 0, ysb + 1, zsb + 0, wsb + 0, dx2, dy2, dz2, dw2)
        end

        # Contribution (0,0,1,0)
        dx3 = dx2
        dy3 = dy1
        dz3 = dz0 - 1 - SQUISH_CONSTANT_4D
        dw3 = dw1
        attn3 = 2 - dx3 * dx3 - dy3 * dy3 - dz3 * dz3 - dw3 * dw3
        if attn3 > 0
            attn3 *= attn3
            value += attn3 * attn3 * extrapolate(xsb + 0, ysb + 0, zsb + 1, wsb + 0, dx3, dy3, dz3, dw3)
        end

        # Contribution (0,0,0,1)
        dx4 = dx2
        dy4 = dy1
        dz4 = dz1
        dw4 = dw0 - 1 - SQUISH_CONSTANT_4D
        attn4 = 2 - dx4 * dx4 - dy4 * dy4 - dz4 * dz4 - dw4 * dw4
        if attn4 > 0
            attn4 *= attn4
            value += attn4 * attn4 * extrapolate(xsb + 0, ysb + 0, zsb + 0, wsb + 1, dx4, dy4, dz4, dw4)
        end
    elseif (inSum >= 3) # We're inside the pentachoron (4-Simplex) at (1,1,1,1)
        # Determine which two of (1,1,1,0), (1,1,0,1), (1,0,1,1), (0,1,1,1) are closest.
        aPoint  = 0x0E
        aScore = xins
        bPoint = 0x0D
        bScore = yins
        if (aScore <= bScore && zins < bScore)
            bScore = zins
            bPoint = 0x0B
        elseif (aScore > bScore && zins < aScore)
            aScore = zins
            aPoint = 0x0B
        end
        if (aScore <= bScore && wins < bScore)
            bScore = wins
            bPoint = 0x07
        elseif (aScore > bScore && wins < aScore)
            aScore = wins
            aPoint = 0x07
        end

        # Now we determine the three lattice points not part of the pentachoron that may contribute.
        # This depends on the closest two pentachoron vertices, including (0,0,0,0)
        uins = 4 - inSum
        if (uins < aScore || uins < bScore)  # (1,1,1,1) is one of the closest two pentachoron vertices.
            c = (bScore < aScore ? bPoint : aPoint) # Our other closest vertex is the closest out of a and b.

            if ((c & 0x01) != 0)
                xsv_ext0 = xsb + 2
                xsv_ext1 = xsv_ext2 = xsb + 1
                dx_ext0 = dx0 - 2 - 4 * SQUISH_CONSTANT_4D
                dx_ext1 = dx_ext2 = dx0 - 1 - 4 * SQUISH_CONSTANT_4D
            else
                xsv_ext0 = xsv_ext1 = xsv_ext2 = xsb
                dx_ext0 = dx_ext1 = dx_ext2 = dx0 - 4 * SQUISH_CONSTANT_4D
            end

            if ((c & 0x02) != 0)
                ysv_ext0 = ysv_ext1 = ysv_ext2 = ysb + 1
                dy_ext0 = dy_ext1 = dy_ext2 = dy0 - 1 - 4 * SQUISH_CONSTANT_4D
                if ((c & 0x01) != 0)
                    ysv_ext1 += 1
                    dy_ext1 -= 1
                else
                    ysv_ext0 += 1
                    dy_ext0 -= 1
                end
            else
                ysv_ext0 = ysv_ext1 = ysv_ext2 = ysb
                dy_ext0 = dy_ext1 = dy_ext2 = dy0 - 4 * SQUISH_CONSTANT_4D
            end

            if ((c & 0x04) != 0)
                zsv_ext0 = zsv_ext1 = zsv_ext2 = zsb + 1
                dz_ext0 = dz_ext1 = dz_ext2 = dz0 - 1 - 4 * SQUISH_CONSTANT_4D
                if ((c & 0x03) != 0x03)
                    if ((c & 0x03) == 0)
                        zsv_ext0 += 1
                        dz_ext0 -= 1
                    else
                        zsv_ext1 += 1
                        dz_ext1 -= 1
                    end
                else
                    zsv_ext2 += 1
                    dz_ext2 -= 1
                end
            else
                zsv_ext0 = zsv_ext1 = zsv_ext2 = zsb
                dz_ext0 = dz_ext1 = dz_ext2 = dz0 - 4 * SQUISH_CONSTANT_4D
            end

            if ((c & 0x08) != 0)
                wsv_ext0 = wsv_ext1 = wsb + 1
                wsv_ext2 = wsb + 2
                dw_ext0 = dw_ext1 = dw0 - 1 - 4 * SQUISH_CONSTANT_4D
                dw_ext2 = dw0 - 2 - 4 * SQUISH_CONSTANT_4D
            else
                wsv_ext0 = wsv_ext1 = wsv_ext2 = wsb
                dw_ext0 = dw_ext1 = dw_ext2 = dw0 - 4 * SQUISH_CONSTANT_4D
            end
        else  # (1,1,1,1) is not one of the closest two pentachoron vertices.
            c = aPoint & bPoint # Our three extra vertices are determined by the closest two.

            if ((c & 0x01) != 0)
                xsv_ext0 = xsv_ext2 = xsb + 1
                xsv_ext1 = xsb + 2
                dx_ext0 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
                dx_ext1 = dx0 - 2 - 3 * SQUISH_CONSTANT_4D
                dx_ext2 = dx0 - 1 - 3 * SQUISH_CONSTANT_4D
            else
                xsv_ext0 = xsv_ext1 = xsv_ext2 = xsb
                dx_ext0 = dx0 - 2 * SQUISH_CONSTANT_4D
                dx_ext1 = dx_ext2 = dx0 - 3 * SQUISH_CONSTANT_4D
            end

            if (c & 0x02) != 0
                ysv_ext0 = ysv_ext1 = ysv_ext2 = ysb + 1
                dy_ext0 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
                dy_ext1 = dy_ext2 = dy0 - 1 - 3 * SQUISH_CONSTANT_4D
                if (c & 0x01) != 0
                    ysv_ext2 += 1
                    dy_ext2 -= 1
                else
                    ysv_ext1 += 1
                    dy_ext1 -= 1
                end
            else
                ysv_ext0 = ysv_ext1 = ysv_ext2 = ysb
                dy_ext0 = dy0 - 2 * SQUISH_CONSTANT_4D
                dy_ext1 = dy_ext2 = dy0 - 3 * SQUISH_CONSTANT_4D
            end

            if (c & 0x04) != 0
                zsv_ext0 = zsv_ext1 = zsv_ext2 = zsb + 1
                dz_ext0 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
                dz_ext1 = dz_ext2 = dz0 - 1 - 3 * SQUISH_CONSTANT_4D
                if (c & 0x03) != 0
                    zsv_ext2 += 1
                    dz_ext2 -= 1
                else
                    zsv_ext1 += 1
                    dz_ext1 -= 1
                end
            else
                zsv_ext0 = zsv_ext1 = zsv_ext2 = zsb
                dz_ext0 = dz0 - 2 * SQUISH_CONSTANT_4D
                dz_ext1 = dz_ext2 = dz0 - 3 * SQUISH_CONSTANT_4D
            end

            if (c & 0x08) != 0
                wsv_ext0 = wsv_ext1 = wsb + 1
                wsv_ext2 = wsb + 2
                dw_ext0 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
                dw_ext1 = dw0 - 1 - 3 * SQUISH_CONSTANT_4D
                dw_ext2 = dw0 - 2 - 3 * SQUISH_CONSTANT_4D
            else
                wsv_ext0 = wsv_ext1 = wsv_ext2 = wsb
                dw_ext0 = dw0 - 2 * SQUISH_CONSTANT_4D
                dw_ext1 = dw_ext2 = dw0 - 3 * SQUISH_CONSTANT_4D
            end
        end

        # Contribution (1,1,1,0)
        dx4 = dx0 - 1 - 3 * SQUISH_CONSTANT_4D
        dy4 = dy0 - 1 - 3 * SQUISH_CONSTANT_4D
        dz4 = dz0 - 1 - 3 * SQUISH_CONSTANT_4D
        dw4 = dw0 - 3 * SQUISH_CONSTANT_4D
        attn4 = 2 - dx4 * dx4 - dy4 * dy4 - dz4 * dz4 - dw4 * dw4
        if attn4 > 0
            attn4 *= attn4
            value += attn4 * attn4 * extrapolate(xsb + 1, ysb + 1, zsb + 1, wsb + 0, dx4, dy4, dz4, dw4)
        end

        # Contribution (1,1,0,1)
        dx3 = dx4
        dy3 = dy4
        dz3 = dz0 - 3 * SQUISH_CONSTANT_4D
        dw3 = dw0 - 1 - 3 * SQUISH_CONSTANT_4D
        attn3 = 2 - dx3 * dx3 - dy3 * dy3 - dz3 * dz3 - dw3 * dw3
        if attn3 > 0
            attn3 *= attn3
            value += attn3 * attn3 * extrapolate(xsb + 1, ysb + 1, zsb + 0, wsb + 1, dx3, dy3, dz3, dw3)
        end

        # Contribution (1,0,1,1)
        dx2 = dx4
        dy2 = dy0 - 3 * SQUISH_CONSTANT_4D
        dz2 = dz4
        dw2 = dw3
        attn2 = 2 - dx2 * dx2 - dy2 * dy2 - dz2 * dz2 - dw2 * dw2
        if attn2 > 0
            attn2 *= attn2
            value += attn2 * attn2 * extrapolate(xsb + 1, ysb + 0, zsb + 1, wsb + 1, dx2, dy2, dz2, dw2)
        end

        # Contribution (0,1,1,1)
        dx1 = dx0 - 3 * SQUISH_CONSTANT_4D
        dz1 = dz4
        dy1 = dy4
        dw1 = dw3
        attn1 = 2 - dx1 * dx1 - dy1 * dy1 - dz1 * dz1 - dw1 * dw1
        if attn1 > 0
            attn1 *= attn1
            value += attn1 * attn1 * extrapolate(xsb + 0, ysb + 1, zsb + 1, wsb + 1, dx1, dy1, dz1, dw1)
        end

        # Contribution (1,1,1,1)
        dx0 = dx0 - 1 - 4 * SQUISH_CONSTANT_4D
        dy0 = dy0 - 1 - 4 * SQUISH_CONSTANT_4D
        dz0 = dz0 - 1 - 4 * SQUISH_CONSTANT_4D
        dw0 = dw0 - 1 - 4 * SQUISH_CONSTANT_4D
        attn0 = 2 - dx0 * dx0 - dy0 * dy0 - dz0 * dz0 - dw0 * dw0
        if attn0 > 0
            attn0 *= attn0
            value += attn0 * attn0 * extrapolate(xsb + 1, ysb + 1, zsb + 1, wsb + 1, dx0, dy0, dz0, dw0)
        end
    elseif inSum <= 2 # We're inside the first dispentachoron (Rectified 4-Simplex)
        aIsBiggerSide = true
        bIsBiggerSide = true

        # Decide between (1,1,0,0) and (0,0,1,1)
        if (xins + yins) > (zins + wins)
            aScore = xins + yins
            aPoint = 0x03
        else
            aScore = zins + wins
            aPoint = 0x0C
        end

        # Decide between (1,0,1,0) and (0,1,0,1)
        if (xins + zins) > (yins + wins)
            bScore = xins + zins
            bPoint = 0x05
        else
            bScore = yins + wins
            bPoint = 0x0A
        end

        # Closer between (1,0,0,1) and (0,1,1,0) will replace the further of a and b, if closer.
        if (xins + wins > yins + zins)
            score = xins + wins
            if (aScore >= bScore) && (score > bScore)
                bScore = score
                bPoint = 0x09
            elseif (aScore < bScore) && (score > aScore)
                aScore = score
                aPoint = 0x09
            end
        else
            score = yins + zins
            if (aScore >= bScore) && (score > bScore)
                bScore = score
                bPoint = 0x06
            elseif (aScore < bScore) && (score > aScore)
                aScore = score
                aPoint = 0x06
            end
        end

        # Decide if (1,0,0,0) is closer.
        p1 = 2 - inSum + xins
        if (aScore >= bScore) && (p1 > bScore)
            bScore = p1
            bPoint = 0x01
            bIsBiggerSide = false
        elseif (aScore < bScore) && (p1 > aScore)
            aScore = p1
            aPoint = 0x01
            aIsBiggerSide = false
        end

        # Decide if (0,1,0,0) is closer.
        p2 = 2 - inSum + yins
        if (aScore >= bScore) && (p2 > bScore)
            bScore = p2
            bPoint = 0x02
            bIsBiggerSide = false
        elseif (aScore < bScore) && (p2 > aScore)
            aScore = p2
            aPoint = 0x02
            aIsBiggerSide = false
        end
        # Decide if (0,0,1,0) is closer.
        p3 = 2 - inSum + zins
        if (aScore >= bScore) && (p3 > bScore)
            bScore = p3
            bPoint = 0x04
            bIsBiggerSide = false
        elseif (aScore < bScore) && (p3 > aScore)
            aScore = p3
            aPoint = 0x04
            aIsBiggerSide = false
        end
        # Decide if (0,0,0,1) is closer.
        p4 = 2 - inSum + wins
        if (aScore >= bScore) && (p4 > bScore)
            bScore = p4
            bPoint = 0x08
            bIsBiggerSide = false
        elseif (aScore < bScore) && (p4 > aScore)
            aScore = p4
            aPoint = 0x08
            aIsBiggerSide = false
        end
        # Where each of the two closest points are determines how the extra three vertices are calculated.
        if aIsBiggerSide == bIsBiggerSide
            if aIsBiggerSide  # Both closest points on the bigger side
                c1 = aPoint | bPoint
                c2 = aPoint & bPoint
                if (c1 & 0x01) == 0
                    xsv_ext0 = xsb
                    xsv_ext1 = xsb - 1
                    dx_ext0 = dx0 - 3 * SQUISH_CONSTANT_4D
                    dx_ext1 = dx0 + 1 - 2 * SQUISH_CONSTANT_4D
                else
                    xsv_ext0 = xsv_ext1 = xsb + 1
                    dx_ext0 = dx0 - 1 - 3 * SQUISH_CONSTANT_4D
                    dx_ext1 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
                end

                if (c1 & 0x02) == 0
                    ysv_ext0 = ysb
                    ysv_ext1 = ysb - 1
                    dy_ext0 = dy0 - 3 * SQUISH_CONSTANT_4D
                    dy_ext1 = dy0 + 1 - 2 * SQUISH_CONSTANT_4D
                else
                    ysv_ext0 = ysv_ext1 = ysb + 1
                    dy_ext0 = dy0 - 1 - 3 * SQUISH_CONSTANT_4D
                    dy_ext1 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
                end

                if (c1 & 0x04) == 0
                    zsv_ext0 = zsb
                    zsv_ext1 = zsb - 1
                    dz_ext0 = dz0 - 3 * SQUISH_CONSTANT_4D
                    dz_ext1 = dz0 + 1 - 2 * SQUISH_CONSTANT_4D
                else
                    zsv_ext0 = zsv_ext1 = zsb + 1
                    dz_ext0 = dz0 - 1 - 3 * SQUISH_CONSTANT_4D
                    dz_ext1 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
                end

                if (c1 & 0x08) == 0
                    wsv_ext0 = wsb
                    wsv_ext1 = wsb - 1
                    dw_ext0 = dw0 - 3 * SQUISH_CONSTANT_4D
                    dw_ext1 = dw0 + 1 - 2 * SQUISH_CONSTANT_4D
                else
                    wsv_ext0 = wsv_ext1 = wsb + 1
                    dw_ext0 = dw0 - 1 - 3 * SQUISH_CONSTANT_4D
                    dw_ext1 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
                end

                # One combination is a permutation of (0,0,0,2) based on c2
                xsv_ext2 = xsb
                ysv_ext2 = ysb
                zsv_ext2 = zsb
                wsv_ext2 = wsb
                dx_ext2 = dx0 - 2 * SQUISH_CONSTANT_4D
                dy_ext2 = dy0 - 2 * SQUISH_CONSTANT_4D
                dz_ext2 = dz0 - 2 * SQUISH_CONSTANT_4D
                dw_ext2 = dw0 - 2 * SQUISH_CONSTANT_4D
                if (c2 & 0x01) != 0
                    xsv_ext2 += 2
                    dx_ext2 -= 2
                elseif (c2 & 0x02) != 0
                    ysv_ext2 += 2
                    dy_ext2 -= 2
                elseif (c2 & 0x04) != 0
                    zsv_ext2 += 2
                    dz_ext2 -= 2
                else
                    wsv_ext2 += 2
                    dw_ext2 -= 2
                end
            else  # Both closest points on the smaller side
                # One of the two extra points is (0,0,0,0)
                xsv_ext2 = xsb
                ysv_ext2 = ysb
                zsv_ext2 = zsb
                wsv_ext2 = wsb
                dx_ext2 = dx0
                dy_ext2 = dy0
                dz_ext2 = dz0
                dw_ext2 = dw0

                # Other two points are based on the omitted axes.
                c = aPoint | bPoint

                if (c & 0x01) == 0
                    xsv_ext0 = xsb - 1
                    xsv_ext1 = xsb
                    dx_ext0 = dx0 + 1 - SQUISH_CONSTANT_4D
                    dx_ext1 = dx0 - SQUISH_CONSTANT_4D
                else
                    xsv_ext0 = xsv_ext1 = xsb + 1
                    dx_ext0 = dx_ext1 = dx0 - 1 - SQUISH_CONSTANT_4D
                end

                if (c & 0x02) == 0
                    ysv_ext0 = ysv_ext1 = ysb
                    dy_ext0 = dy_ext1 = dy0 - SQUISH_CONSTANT_4D
                    if (c & 0x01) == 0x01

                        ysv_ext0 -= 1
                        dy_ext0 += 1
                    else
                        ysv_ext1 -= 1
                        dy_ext1 += 1
                    end
                else
                    ysv_ext0 = ysv_ext1 = ysb + 1
                    dy_ext0 = dy_ext1 = dy0 - 1 - SQUISH_CONSTANT_4D
                end

                if (c & 0x04) == 0
                    zsv_ext0 = zsv_ext1 = zsb
                    dz_ext0 = dz_ext1 = dz0 - SQUISH_CONSTANT_4D
                    if (c & 0x03) == 0x03

                        zsv_ext0 -= 1
                        dz_ext0 += 1
                    else
                        zsv_ext1 -= 1
                        dz_ext1 += 1
                    end
                else
                    zsv_ext0 = zsv_ext1 = zsb + 1
                    dz_ext0 = dz_ext1 = dz0 - 1 - SQUISH_CONSTANT_4D
                end

                if (c & 0x08) == 0
                    wsv_ext0 = wsb
                    wsv_ext1 = wsb - 1
                    dw_ext0 = dw0 - SQUISH_CONSTANT_4D
                    dw_ext1 = dw0 + 1 - SQUISH_CONSTANT_4D
                else
                    wsv_ext0 = wsv_ext1 = wsb + 1
                    dw_ext0 = dw_ext1 = dw0 - 1 - SQUISH_CONSTANT_4D
                end

            end
        else  # One point on each "side"
            if aIsBiggerSide
                c1 = aPoint
                c2 = bPoint
            else
                c1 = bPoint
                c2 = aPoint
            end

            # Two contributions are the bigger-sided powith each 0 replaced with -1.
            if (c1 & 0x01) == 0
                xsv_ext0 = xsb - 1
                xsv_ext1 = xsb
                dx_ext0 = dx0 + 1 - SQUISH_CONSTANT_4D
                dx_ext1 = dx0 - SQUISH_CONSTANT_4D
            else
                xsv_ext0 = xsv_ext1 = xsb + 1
                dx_ext0 = dx_ext1 = dx0 - 1 - SQUISH_CONSTANT_4D
            end

            if (c1 & 0x02) == 0
                ysv_ext0 = ysv_ext1 = ysb
                dy_ext0 = dy_ext1 = dy0 - SQUISH_CONSTANT_4D
                if ((c1 & 0x01) == 0x01)
                    ysv_ext0 -= 1
                    dy_ext0 += 1
                else
                    ysv_ext1 -= 1
                    dy_ext1 += 1
                end
            else
                ysv_ext0 = ysv_ext1 = ysb + 1
                dy_ext0 = dy_ext1 = dy0 - 1 - SQUISH_CONSTANT_4D
            end

            if (c1 & 0x04) == 0
                zsv_ext0 = zsv_ext1 = zsb
                dz_ext0 = dz_ext1 = dz0 - SQUISH_CONSTANT_4D
                if (c1 & 0x03) == 0x03
                    zsv_ext0 -= 1
                    dz_ext0 += 1
                else
                    zsv_ext1 -= 1
                    dz_ext1 += 1
                end
            else
                zsv_ext0 = zsv_ext1 = zsb + 1
                dz_ext0 = dz_ext1 = dz0 - 1 - SQUISH_CONSTANT_4D
            end

            if (c1 & 0x08) == 0
                wsv_ext0 = wsb
                wsv_ext1 = wsb - 1
                dw_ext0 = dw0 - SQUISH_CONSTANT_4D
                dw_ext1 = dw0 + 1 - SQUISH_CONSTANT_4D
            else
                wsv_ext0 = wsv_ext1 = wsb + 1
                dw_ext0 = dw_ext1 = dw0 - 1 - SQUISH_CONSTANT_4D
            end

            # One contribution is a permutation of (0,0,0,2) based on the smaller-sided point
            xsv_ext2 = xsb
            ysv_ext2 = ysb
            zsv_ext2 = zsb
            wsv_ext2 = wsb
            dx_ext2 = dx0 - 2 * SQUISH_CONSTANT_4D
            dy_ext2 = dy0 - 2 * SQUISH_CONSTANT_4D
            dz_ext2 = dz0 - 2 * SQUISH_CONSTANT_4D
            dw_ext2 = dw0 - 2 * SQUISH_CONSTANT_4D
            if (c2 & 0x01) != 0
                xsv_ext2 += 2
                dx_ext2 -= 2
            elseif (c2 & 0x02) != 0
                ysv_ext2 += 2
                dy_ext2 -= 2
            elseif (c2 & 0x04) != 0
                zsv_ext2 += 2
                dz_ext2 -= 2
            else
                wsv_ext2 += 2
                dw_ext2 -= 2
            end
        end

        # Contribution (1,0,0,0)
        dx1 = dx0 - 1 - SQUISH_CONSTANT_4D
        dy1 = dy0 - 0 - SQUISH_CONSTANT_4D
        dz1 = dz0 - 0 - SQUISH_CONSTANT_4D
        dw1 = dw0 - 0 - SQUISH_CONSTANT_4D
        attn1 = 2 - dx1 * dx1 - dy1 * dy1 - dz1 * dz1 - dw1 * dw1
        if attn1 > 0
            attn1 *= attn1
            value += attn1 * attn1 * extrapolate(xsb + 1, ysb + 0, zsb + 0, wsb + 0, dx1, dy1, dz1, dw1)
        end

        # Contribution (0,1,0,0)
        dx2 = dx0 - 0 - SQUISH_CONSTANT_4D
        dy2 = dy0 - 1 - SQUISH_CONSTANT_4D
        dz2 = dz1
        dw2 = dw1
        attn2 = 2 - dx2 * dx2 - dy2 * dy2 - dz2 * dz2 - dw2 * dw2
        if attn2 > 0
            attn2 *= attn2
            value += attn2 * attn2 * extrapolate(xsb + 0, ysb + 1, zsb + 0, wsb + 0, dx2, dy2, dz2, dw2)
        end

        # Contribution (0,0,1,0)
        dx3 = dx2
        dy3 = dy1
        dz3 = dz0 - 1 - SQUISH_CONSTANT_4D
        dw3 = dw1
        attn3 = 2 - dx3 * dx3 - dy3 * dy3 - dz3 * dz3 - dw3 * dw3
        if attn3 > 0
            attn3 *= attn3
            value += attn3 * attn3 * extrapolate(xsb + 0, ysb + 0, zsb + 1, wsb + 0, dx3, dy3, dz3, dw3)
        end

        # Contribution (0,0,0,1)
        dx4 = dx2
        dy4 = dy1
        dz4 = dz1
        dw4 = dw0 - 1 - SQUISH_CONSTANT_4D
        attn4 = 2 - dx4 * dx4 - dy4 * dy4 - dz4 * dz4 - dw4 * dw4
        if attn4 > 0
            attn4 *= attn4
            value += attn4 * attn4 * extrapolate(xsb + 0, ysb + 0, zsb + 0, wsb + 1, dx4, dy4, dz4, dw4)
        end

        # Contribution (1,1,0,0)
        dx5 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
        dy5 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
        dz5 = dz0 - 0 - 2 * SQUISH_CONSTANT_4D
        dw5 = dw0 - 0 - 2 * SQUISH_CONSTANT_4D
        attn5 = 2 - dx5 * dx5 - dy5 * dy5 - dz5 * dz5 - dw5 * dw5
        if attn5 > 0
            attn5 *= attn5
            value += attn5 * attn5 * extrapolate(xsb + 1, ysb + 1, zsb + 0, wsb + 0, dx5, dy5, dz5, dw5)
        end

        # Contribution (1,0,1,0)
        dx6 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
        dy6 = dy0 - 0 - 2 * SQUISH_CONSTANT_4D
        dz6 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
        dw6 = dw0 - 0 - 2 * SQUISH_CONSTANT_4D
        attn6 = 2 - dx6 * dx6 - dy6 * dy6 - dz6 * dz6 - dw6 * dw6
        if attn6 > 0
            attn6 *= attn6
            value += attn6 * attn6 * extrapolate(xsb + 1, ysb + 0, zsb + 1, wsb + 0, dx6, dy6, dz6, dw6)
        end

        # Contribution (1,0,0,1)
        dx7 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
        dy7 = dy0 - 0 - 2 * SQUISH_CONSTANT_4D
        dz7 = dz0 - 0 - 2 * SQUISH_CONSTANT_4D
        dw7 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
        attn7 = 2 - dx7 * dx7 - dy7 * dy7 - dz7 * dz7 - dw7 * dw7
        if attn7 > 0
            attn7 *= attn7
            value += attn7 * attn7 * extrapolate(xsb + 1, ysb + 0, zsb + 0, wsb + 1, dx7, dy7, dz7, dw7)
        end

        # Contribution (0,1,1,0)
        dx8 = dx0 - 0 - 2 * SQUISH_CONSTANT_4D
        dy8 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
        dz8 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
        dw8 = dw0 - 0 - 2 * SQUISH_CONSTANT_4D
        attn8 = 2 - dx8 * dx8 - dy8 * dy8 - dz8 * dz8 - dw8 * dw8
        if attn8 > 0
            attn8 *= attn8
            value += attn8 * attn8 * extrapolate(xsb + 0, ysb + 1, zsb + 1, wsb + 0, dx8, dy8, dz8, dw8)
        end

        # Contribution (0,1,0,1)
        dx9 = dx0 - 0 - 2 * SQUISH_CONSTANT_4D
        dy9 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
        dz9 = dz0 - 0 - 2 * SQUISH_CONSTANT_4D
        dw9 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
        attn9 = 2 - dx9 * dx9 - dy9 * dy9 - dz9 * dz9 - dw9 * dw9
        if attn9 > 0
            attn9 *= attn9
            value += attn9 * attn9 * extrapolate(xsb + 0, ysb + 1, zsb + 0, wsb + 1, dx9, dy9, dz9, dw9)
        end

        # Contribution (0,0,1,1)
        dx10 = dx0 - 0 - 2 * SQUISH_CONSTANT_4D
        dy10 = dy0 - 0 - 2 * SQUISH_CONSTANT_4D
        dz10 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
        dw10 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
        attn10 = 2 - dx10 * dx10 - dy10 * dy10 - dz10 * dz10 - dw10 * dw10
        if attn10 > 0
            attn10 *= attn10
            value += attn10 * attn10 * extrapolate(xsb + 0, ysb + 0, zsb + 1, wsb + 1, dx10, dy10, dz10, dw10)
        end
    else  # We're inside the second dispentachoron (Rectified 4-Simplex)
        aIsBiggerSide = true
        bIsBiggerSide = true
        # Decide between (0,0,1,1) and (1,1,0,0)
        if (xins + yins) < (zins + wins)
            aScore = xins + yins
            aPoint = 0x0C
        else
            aScore = zins + wins
            aPoint = 0x03
        end

        # Decide between (0,1,0,1) and (1,0,1,0)
        if (xins + zins) < (yins + wins)
            bScore = xins + zins
            bPoint = 0x0A
        else
            bScore = yins + wins
            bPoint = 0x05
        end

        # Closer between (0,1,1,0) and (1,0,0,1) will replace the further of a and b, if closer.
        if (xins + wins) < (yins + zins)
            score = xins + wins
            if (aScore <= bScore) && (score < bScore)
                bScore = score
                bPoint = 0x06
            elseif (aScore > bScore) && (score < aScore)
                aScore = score
                aPoint = 0x06
            end
        else
            score = yins + zins
            if (aScore <= bScore) && (score < bScore)
                bScore = score
                bPoint = 0x09
            elseif (aScore > bScore) && (score < aScore)
                aScore = score
                aPoint = 0x09
            end
        end

        # Decide if (0,1,1,1) is closer.
        p1 = 3 - inSum + xins
        if (aScore <= bScore) && (p1 < bScore)
            bScore = p1
            bPoint = 0x0E
            bIsBiggerSide = false
        elseif (aScore > bScore) && (p1 < aScore)
            aScore = p1
            aPoint = 0x0E
            aIsBiggerSide = false
        end

        # Decide if (1,0,1,1) is closer.
        p2 = 3 - inSum + yins
        if (aScore <= bScore) && (p2 < bScore)
            bScore = p2
            bPoint = 0x0D
            bIsBiggerSide = false
        elseif (aScore > bScore) && (p2 < aScore)
            aScore = p2
            aPoint = 0x0D
            aIsBiggerSide = false
        end

        # Decide if (1,1,0,1) is closer.
        p3 = 3 - inSum + zins
        if (aScore <= bScore) && (p3 < bScore)
            bScore = p3
            bPoint = 0x0B
            bIsBiggerSide = false
        elseif (aScore > bScore) && (p3 < aScore)
            aScore = p3
            aPoint = 0x0B
            aIsBiggerSide = false
        end

        # Decide if (1,1,1,0) is closer.
        p4 = 3 - inSum + wins
        if (aScore <= bScore) && (p4 < bScore)
            bScore = p4
            bPoint = 0x07
            bIsBiggerSide = false
        elseif (aScore > bScore) && (p4 < aScore)
            aScore = p4
            aPoint = 0x07
            aIsBiggerSide = false
        end

        # Where each of the two closest points are determines how the extra three vertices are calculated.
        if aIsBiggerSide == bIsBiggerSide
            if aIsBiggerSide  # Both closest points on the bigger side
                c1 = aPoint & bPoint
                c2 = aPoint | bPoint
                # Two contributions are permutations of (0,0,0,1) and (0,0,0,2) based on c1
                xsv_ext0 = xsv_ext1 = xsb
                ysv_ext0 = ysv_ext1 = ysb
                zsv_ext0 = zsv_ext1 = zsb
                wsv_ext0 = wsv_ext1 = wsb
                dx_ext0 = dx0 - SQUISH_CONSTANT_4D
                dy_ext0 = dy0 - SQUISH_CONSTANT_4D
                dz_ext0 = dz0 - SQUISH_CONSTANT_4D
                dw_ext0 = dw0 - SQUISH_CONSTANT_4D
                dx_ext1 = dx0 - 2 * SQUISH_CONSTANT_4D
                dy_ext1 = dy0 - 2 * SQUISH_CONSTANT_4D
                dz_ext1 = dz0 - 2 * SQUISH_CONSTANT_4D
                dw_ext1 = dw0 - 2 * SQUISH_CONSTANT_4D
                if (c1 & 0x01) != 0
                    xsv_ext0 += 1
                    dx_ext0 -= 1
                    xsv_ext1 += 2
                    dx_ext1 -= 2
                elseif (c1 & 0x02) != 0
                    ysv_ext0 += 1
                    dy_ext0 -= 1
                    ysv_ext1 += 2
                    dy_ext1 -= 2
                elseif (c1 & 0x04) != 0
                    zsv_ext0 += 1
                    dz_ext0 -= 1
                    zsv_ext1 += 2
                    dz_ext1 -= 2
                else
                    wsv_ext0 += 1
                    dw_ext0 -= 1
                    wsv_ext1 += 2
                    dw_ext1 -= 2
                end

                # One contribution is a permutation of (1,1,1,-1) based on c2
                xsv_ext2 = xsb + 1
                ysv_ext2 = ysb + 1
                zsv_ext2 = zsb + 1
                wsv_ext2 = wsb + 1
                dx_ext2 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
                dy_ext2 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
                dz_ext2 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
                dw_ext2 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
                if (c2 & 0x01) == 0
                    xsv_ext2 -= 2
                    dx_ext2 += 2
                elseif (c2 & 0x02) == 0
                    ysv_ext2 -= 2
                    dy_ext2 += 2
                elseif (c2 & 0x04) == 0
                    zsv_ext2 -= 2
                    dz_ext2 += 2
                else
                    wsv_ext2 -= 2
                    dw_ext2 += 2
                end
            else  # Both closest points on the smaller side
                # One of the two extra points is (1,1,1,1)
                xsv_ext2 = xsb + 1
                ysv_ext2 = ysb + 1
                zsv_ext2 = zsb + 1
                wsv_ext2 = wsb + 1
                dx_ext2 = dx0 - 1 - 4 * SQUISH_CONSTANT_4D
                dy_ext2 = dy0 - 1 - 4 * SQUISH_CONSTANT_4D
                dz_ext2 = dz0 - 1 - 4 * SQUISH_CONSTANT_4D
                dw_ext2 = dw0 - 1 - 4 * SQUISH_CONSTANT_4D

                # Other two points are based on the shared axes.
                c = aPoint & bPoint

                if (c & 0x01) != 0
                    xsv_ext0 = xsb + 2
                    xsv_ext1 = xsb + 1
                    dx_ext0 = dx0 - 2 - 3 * SQUISH_CONSTANT_4D
                    dx_ext1 = dx0 - 1 - 3 * SQUISH_CONSTANT_4D
                else
                    xsv_ext0 = xsv_ext1 = xsb
                    dx_ext0 = dx_ext1 = dx0 - 3 * SQUISH_CONSTANT_4D
                end

                if (c & 0x02) != 0
                    ysv_ext0 = ysv_ext1 = ysb + 1
                    dy_ext0 = dy_ext1 = dy0 - 1 - 3 * SQUISH_CONSTANT_4D
                    if (c & 0x01) == 0
                        ysv_ext0 += 1
                        dy_ext0 -= 1
                    else
                        ysv_ext1 += 1
                        dy_ext1 -= 1
                    end
                else
                    ysv_ext0 = ysv_ext1 = ysb
                    dy_ext0 = dy_ext1 = dy0 - 3 * SQUISH_CONSTANT_4D
                end

                if (c & 0x04) != 0
                    zsv_ext0 = zsv_ext1 = zsb + 1
                    dz_ext0 = dz_ext1 = dz0 - 1 - 3 * SQUISH_CONSTANT_4D
                    if (c & 0x03) == 0
                        zsv_ext0 += 1
                        dz_ext0 -= 1
                    else
                        zsv_ext1 += 1
                        dz_ext1 -= 1
                    end
                else
                    zsv_ext0 = zsv_ext1 = zsb
                    dz_ext0 = dz_ext1 = dz0 - 3 * SQUISH_CONSTANT_4D
                end

                if (c & 0x08) != 0
                    wsv_ext0 = wsb + 1
                    wsv_ext1 = wsb + 2
                    dw_ext0 = dw0 - 1 - 3 * SQUISH_CONSTANT_4D
                    dw_ext1 = dw0 - 2 - 3 * SQUISH_CONSTANT_4D
                else
                    wsv_ext0 = wsv_ext1 = wsb
                    dw_ext0 = dw_ext1 = dw0 - 3 * SQUISH_CONSTANT_4D
                end
            end
        else  # One point on each "side"
            if aIsBiggerSide
                c1 = aPoint
                c2 = bPoint
            else
                c1 = bPoint
                c2 = aPoint
            end
            # Two contributions are the bigger-sided point with each 1 replaced with 2.
            if (c1 & 0x01) != 0
                xsv_ext0 = xsb + 2
                xsv_ext1 = xsb + 1
                dx_ext0 = dx0 - 2 - 3 * SQUISH_CONSTANT_4D
                dx_ext1 = dx0 - 1 - 3 * SQUISH_CONSTANT_4D
            else
                xsv_ext0 = xsv_ext1 = xsb
                dx_ext0 = dx_ext1 = dx0 - 3 * SQUISH_CONSTANT_4D
            end
            if (c1 & 0x02) != 0
                ysv_ext0 = ysv_ext1 = ysb + 1
                dy_ext0 = dy_ext1 = dy0 - 1 - 3 * SQUISH_CONSTANT_4D
                if (c1 & 0x01) == 0
                    ysv_ext0 += 1
                    dy_ext0 -= 1
                else
                    ysv_ext1 += 1
                    dy_ext1 -= 1
                end
            else
                ysv_ext0 = ysv_ext1 = ysb
                dy_ext0 = dy_ext1 = dy0 - 3 * SQUISH_CONSTANT_4D
            end
            if (c1 & 0x04) != 0
                zsv_ext0 = zsv_ext1 = zsb + 1
                dz_ext0 = dz_ext1 = dz0 - 1 - 3 * SQUISH_CONSTANT_4D
                if ((c1 & 0x03) == 0)
                    zsv_ext0 += 1
                    dz_ext0 -= 1
                else
                    zsv_ext1 += 1
                    dz_ext1 -= 1
                end
            else
                zsv_ext0 = zsv_ext1 = zsb
                dz_ext0 = dz_ext1 = dz0 - 3 * SQUISH_CONSTANT_4D
            end
            if (c1 & 0x08) != 0
                wsv_ext0 = wsb + 1
                wsv_ext1 = wsb + 2
                dw_ext0 = dw0 - 1 - 3 * SQUISH_CONSTANT_4D
                dw_ext1 = dw0 - 2 - 3 * SQUISH_CONSTANT_4D
            else
                wsv_ext0 = wsv_ext1 = wsb
                dw_ext0 = dw_ext1 = dw0 - 3 * SQUISH_CONSTANT_4D
            end

            # One contribution is a permutation of (1,1,1,-1) based on the smaller-sided point
            xsv_ext2 = xsb + 1
            ysv_ext2 = ysb + 1
            zsv_ext2 = zsb + 1
            wsv_ext2 = wsb + 1
            dx_ext2 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
            dy_ext2 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
            dz_ext2 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
            dw_ext2 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
            if (c2 & 0x01) == 0
                xsv_ext2 -= 2
                dx_ext2 += 2
            elseif (c2 & 0x02) == 0
                ysv_ext2 -= 2
                dy_ext2 += 2
            elseif (c2 & 0x04) == 0
                zsv_ext2 -= 2
                dz_ext2 += 2
            else
                wsv_ext2 -= 2
                dw_ext2 += 2
            end
        end

        # Contribution (1,1,1,0)
        dx4 = dx0 - 1 - 3 * SQUISH_CONSTANT_4D
        dy4 = dy0 - 1 - 3 * SQUISH_CONSTANT_4D
        dz4 = dz0 - 1 - 3 * SQUISH_CONSTANT_4D
        dw4 = dw0 - 3 * SQUISH_CONSTANT_4D
        attn4 = 2 - dx4 * dx4 - dy4 * dy4 - dz4 * dz4 - dw4 * dw4
        if attn4 > 0
            attn4 *= attn4
            value += attn4 * attn4 * extrapolate(xsb + 1, ysb + 1, zsb + 1, wsb + 0, dx4, dy4, dz4, dw4)
        end

        # Contribution (1,1,0,1)
        dx3 = dx4
        dy3 = dy4
        dz3 = dz0 - 3 * SQUISH_CONSTANT_4D
        dw3 = dw0 - 1 - 3 * SQUISH_CONSTANT_4D
        attn3 = 2 - dx3 * dx3 - dy3 * dy3 - dz3 * dz3 - dw3 * dw3
        if attn3 > 0
            attn3 *= attn3
            value += attn3 * attn3 * extrapolate(xsb + 1, ysb + 1, zsb + 0, wsb + 1, dx3, dy3, dz3, dw3)
        end

        # Contribution (1,0,1,1)
        dx2 = dx4
        dy2 = dy0 - 3 * SQUISH_CONSTANT_4D
        dz2 = dz4
        dw2 = dw3
        attn2 = 2 - dx2 * dx2 - dy2 * dy2 - dz2 * dz2 - dw2 * dw2
        if attn2 > 0
            attn2 *= attn2
            value += attn2 * attn2 * extrapolate(xsb + 1, ysb + 0, zsb + 1, wsb + 1, dx2, dy2, dz2, dw2)
        end

        # Contribution (0,1,1,1)
        dx1 = dx0 - 3 * SQUISH_CONSTANT_4D
        dz1 = dz4
        dy1 = dy4
        dw1 = dw3
        attn1 = 2 - dx1 * dx1 - dy1 * dy1 - dz1 * dz1 - dw1 * dw1
        if attn1 > 0
            attn1 *= attn1
            value += attn1 * attn1 * extrapolate(xsb + 0, ysb + 1, zsb + 1, wsb + 1, dx1, dy1, dz1, dw1)
        end

        # Contribution (1,1,0,0)
        dx5 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
        dy5 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
        dz5 = dz0 - 0 - 2 * SQUISH_CONSTANT_4D
        dw5 = dw0 - 0 - 2 * SQUISH_CONSTANT_4D
        attn5 = 2 - dx5 * dx5 - dy5 * dy5 - dz5 * dz5 - dw5 * dw5
        if attn5 > 0
            attn5 *= attn5
            value += attn5 * attn5 * extrapolate(xsb + 1, ysb + 1, zsb + 0, wsb + 0, dx5, dy5, dz5, dw5)
        end

        # Contribution (1,0,1,0)
        dx6 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
        dy6 = dy0 - 0 - 2 * SQUISH_CONSTANT_4D
        dz6 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
        dw6 = dw0 - 0 - 2 * SQUISH_CONSTANT_4D
        attn6 = 2 - dx6 * dx6 - dy6 * dy6 - dz6 * dz6 - dw6 * dw6
        if attn6 > 0
            attn6 *= attn6
            value += attn6 * attn6 * extrapolate(xsb + 1, ysb + 0, zsb + 1, wsb + 0, dx6, dy6, dz6, dw6)
        end

        # Contribution (1,0,0,1)
        dx7 = dx0 - 1 - 2 * SQUISH_CONSTANT_4D
        dy7 = dy0 - 0 - 2 * SQUISH_CONSTANT_4D
        dz7 = dz0 - 0 - 2 * SQUISH_CONSTANT_4D
        dw7 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
        attn7 = 2 - dx7 * dx7 - dy7 * dy7 - dz7 * dz7 - dw7 * dw7
        if attn7 > 0
            attn7 *= attn7
            value += attn7 * attn7 * extrapolate(xsb + 1, ysb + 0, zsb + 0, wsb + 1, dx7, dy7, dz7, dw7)
        end

        # Contribution (0,1,1,0)
        dx8 = dx0 - 0 - 2 * SQUISH_CONSTANT_4D
        dy8 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
        dz8 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
        dw8 = dw0 - 0 - 2 * SQUISH_CONSTANT_4D
        attn8 = 2 - dx8 * dx8 - dy8 * dy8 - dz8 * dz8 - dw8 * dw8
        if attn8 > 0
            attn8 *= attn8
            value += attn8 * attn8 * extrapolate(xsb + 0, ysb + 1, zsb + 1, wsb + 0, dx8, dy8, dz8, dw8)
        end

        # Contribution (0,1,0,1)
        dx9 = dx0 - 0 - 2 * SQUISH_CONSTANT_4D
        dy9 = dy0 - 1 - 2 * SQUISH_CONSTANT_4D
        dz9 = dz0 - 0 - 2 * SQUISH_CONSTANT_4D
        dw9 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
        attn9 = 2 - dx9 * dx9 - dy9 * dy9 - dz9 * dz9 - dw9 * dw9
        if attn9 > 0
            attn9 *= attn9
            value += attn9 * attn9 * extrapolate(xsb + 0, ysb + 1, zsb + 0, wsb + 1, dx9, dy9, dz9, dw9)
        end

        # Contribution (0,0,1,1)
        dx10 = dx0 - 0 - 2 * SQUISH_CONSTANT_4D
        dy10 = dy0 - 0 - 2 * SQUISH_CONSTANT_4D
        dz10 = dz0 - 1 - 2 * SQUISH_CONSTANT_4D
        dw10 = dw0 - 1 - 2 * SQUISH_CONSTANT_4D
        attn10 = 2 - dx10 * dx10 - dy10 * dy10 - dz10 * dz10 - dw10 * dw10
        if attn10 > 0
            attn10 *= attn10
            value += attn10 * attn10 * extrapolate(xsb + 0, ysb + 0, zsb + 1, wsb + 1, dx10, dy10, dz10, dw10)
        end
    end

    # First extra vertex
    attn_ext0 = 2 - dx_ext0 * dx_ext0 - dy_ext0 * dy_ext0 - dz_ext0 * dz_ext0 - dw_ext0 * dw_ext0
    if attn_ext0 > 0
        attn_ext0 *= attn_ext0
        value += attn_ext0 * attn_ext0 * extrapolate(xsv_ext0, ysv_ext0, zsv_ext0, wsv_ext0, dx_ext0, dy_ext0, dz_ext0, dw_ext0)
    end

    # Second extra vertex
    attn_ext1 = 2 - dx_ext1 * dx_ext1 - dy_ext1 * dy_ext1 - dz_ext1 * dz_ext1 - dw_ext1 * dw_ext1
    if attn_ext1 > 0
        attn_ext1 *= attn_ext1
        value += attn_ext1 * attn_ext1 * extrapolate(xsv_ext1, ysv_ext1, zsv_ext1, wsv_ext1, dx_ext1, dy_ext1, dz_ext1, dw_ext1)
    end

    # Third extra vertex
    attn_ext2 = 2 - dx_ext2 * dx_ext2 - dy_ext2 * dy_ext2 - dz_ext2 * dz_ext2 - dw_ext2 * dw_ext2
    if attn_ext2 > 0
        attn_ext2 *= attn_ext2
        value += attn_ext2 * attn_ext2 * extrapolate(xsv_ext2, ysv_ext2, zsv_ext2, wsv_ext2, dx_ext2, dy_ext2, dz_ext2, dw_ext2)
    end

    res = value / NORM_CONSTANT_4D
    # convert to [0 -> 1]
    return clamp((res + 1) / 2, 0.0, 1.0)
end

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

fname = "tiler-test1.pdf"
pagewidth, pageheight = 600, 900
Drawing(pagewidth, pageheight, fname)
origin() # move 0/0 to center
setantialias(6)
background("ivory")
setopacity(0.9)
setline(0.6)

# width, height, nrows, ncols, margin
pagetiles = Tiler(pagewidth, pageheight, 8, 2, margin=20)
t = length(pagetiles)

setopacity(0.5)

for (pos, n) in pagetiles
  randomhue()
  ellipse(pos, pagetiles.tilewidth, pagetiles.tileheight, :fill)
end

for tile in pagetiles
    cpos, n =  tile
    for j in 1:20
        box(cpos, 5j, 5j, :stroke)
    end
end

pagetiles = Tiler(200, 300, 4, 5, margin=20)
t = length(pagetiles)

for (pos, n) in pagetiles
  randomhue()
  ellipse(pos, pagetiles.tilewidth, pagetiles.tileheight, :fill)
end

@test finish() == true

#!/usr/bin/env julia

using Luxor, Test, Random

Random.seed!(42)

function image_testing(fname)
    width, height = 4000, 4000
    margin = 500
    Drawing(width, height, fname)
    origin()
    background("grey25")
    setline(5)
    sethue("green")

    # try a nonpng
    @test_throws ErrorException readpng(dirname(dirname(pathof(Luxor))) * "/test/test-image.jl")

    image = readpng(dirname(dirname(pathof(Luxor))) * "/test/stackoverflow.png")
    w = image.width
    h = image.height
    pagetiles = Tiler(width, height, 7, 9)
    tw = pagetiles.tilewidth/2
    for (pos, n) in pagetiles
        circle(pos, tw, :stroke)
        circle(pos, tw, :clip)
        gsave()
        translate(pos)
        scale(25, 25)
        rotate(rand(0.0:pi/8:2pi))
        placeimage(image, O, centered=true)
        grestore()
        clipreset()
    end
    @test finish() == true
end

function placetesting(fname)
    # make svg file
    Drawing(200, 200, "svgimage.svg")
    origin()
    setline(40)
    sethue("rebeccapurple")
    squircle(O, 80, 80, :strokepreserve)
    sethue("white")
    fillpath()
    fontsize(40)
    sethue("black")
    text("SVG", halign=:center, valign=:middle)
    finish()

    # make png file
    Drawing(200, 200, "pngimage.png")
    origin()
    setline(40)
    sethue("red")
    squircle(O, 80, 80, :strokepreserve)
    sethue("white")
    fillpath()
    fontsize(40)
    sethue("black")
    text("PNG", halign=:center, valign=:middle)
    finish()

    Drawing(1200, 1200, fname)
    origin()
    svgimg = readsvg("svgimage.svg")
    svgimg = readsvg(read("svgimage.svg", String))
    pngimg = readpng("pngimage.png")
    for (pt, n) in Tiler(1200, 1200, 4, 4)
        @layer begin
            translate(pt)
            isodd(n) && placeimage(svgimg, O, centered=true)
            iseven(n) && placeimage(pngimg, O, centered=true)
        end
    end
    finish()
end

fname = "test-image.png"
image_testing(fname)

fname = "test-image-place.png"
placetesting(fname)


println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function point_intersect(fname)
    Drawing(1000, 1000, fname)
    origin()
    setopacity(0.4)

    for i in 1:100
        randomhue()
        p1 = Point(rand(-450:450), rand(-450:450))
        p2 = Point(rand(-450:450), rand(-450:450))
        p3 = Point(rand(-450:450), rand(-450:450))
        p4 = Point(rand(-450:450), rand(-450:450))
        flag, intersection_point = intersectionlines(p1, p2, p3, p4, crossingonly=true)
        if flag
            circle(intersection_point, 5, :fill)
            move(p1)
            line(p2)
            strokepath()
            move(p3)
            line(p4)
            strokepath()
        end
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

point_intersect("line_intersection.pdf")

using Luxor
using Test
using Random
Random.seed!(42)

function test_roundcorner(fname)
    @draw begin
        p1, p2, p3 = ngon(O, 100, 3, vertices = true)
        s, cp, f = roundcorner(p1, p2, p3, 50)
        line(p1, s, :stroke)
        line(f, p3, :stroke)
        arc2r(cp, s, f, :stroke)

        @test ispointonline(s, p1, p2) == true
        @test ispointonline(f, p2, p3) == true
    end

    return Drawing(700, 700, fname)
    background("black")
    origin()
        setline(1)
        bx = ngon(O, 250, 4, vertices = true)
        for radius in 0.0000001:10:400
            for (n, pt) in enumerate(bx)
                randomhue()
                p1 = bx[mod1(n - 1, end)]
                p2 = bx[mod1(n, end)]
                p3 = bx[mod1(n + 1, end)]
                startc, centerp, endc, flag = roundcorner(
                    p1, p2, p3, radius
                )
                arc2r(centerp, startc, endc, :stroke)
            end
        end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

test_roundcorner("round-corner-test-1.png")
println("...finished roundcorner test")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

w, h = 600, 600

fname = "stars.png"
Drawing(w, h, fname)
origin()
cols = [RGB(rand(3)...) for i in 1:50]
background("grey20")
x = -w/2
for y in 100 * randn(h, 1)
    setcolor(cols[rand(1:end)])
    # star(x::Real, y::Real, radius::Real, npoints::Int=5, ratio::Real=0.5, orientation=0, action=:none; vertices = false, reversepath=false)
    star(x, y, 10, rand(4:7), rand(3:7)/10, 0, :fill)
    global x += 2
end
@test finish() == true
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function testbezierstroke(fname)
    Random.seed!(3)
    currentwidth = 1200
    currentheight = 1200
    Drawing(currentwidth, currentheight, fname)
    origin()
    background("pink")
    setopacity(0.5)
    path1 = [Point(-50, 50), Point(60, -60)]
    path4 = ngon(O, 40, 2, vertices=true)
    path2 = ngon(O, 40, 3, vertices=true)
    path3 = ngon(O, 40, 4, vertices=true)
    path5 = ngon(O, 40, 5, vertices=true)
    path6 = ngon(O, 40, 6, vertices=true)

    paths = [path1, path2, path3, path4, path5, path6]
    paths = vcat(paths, paths, paths)

    t = Table(3, 6, 120, 150, Point(0, 300))
    for (i, path) in enumerate(paths)
        @layer begin
        translate(t[i])
        poly(path, :path)
        bpatharray = pathtobezierpaths()
        for (n, bpath) in enumerate(bpatharray)
            randomhue()
            drawbezierpath(bpath, :stroke)
            for bps in bpath
                randomhue()
                drawbezierpath(setbezierhandles(bps, angles=[2rand(), 2rand()], handles=[3rand(), 2rand()]), :fill)
            end
            # close needs doing manually
            if length(bpath) >= 1
                closingsegment = BezierPathSegment(bpath[end].cp2, bpath[end].p2, bpath[1].p1, bpath[1].cp1)
                seg = setbezierhandles(closingsegment, angles=[2rand(), -2rand()], handles=[3rand(), 2rand()])
                drawbezierpath(seg, :fill)
            end
        end
        end
    end

    # Julia!
    fontsize(500)
    fontface("Times-Bold")
    translate(-450, 100)

    textpath("julia")
    bp = pathtobezierpaths()
    newpath() # clear current path
    for i in 1:5
    for b in bp
        for bps in b
            randomhue()
            drawbezierpath(setbezierhandles(bps,
                angles=[3rand(), 3rand()], handles=[4rand(), 4rand()]),
                :fill)
        end
        # close needs doing manually
        if length(b) >= 1
            closingsegment = BezierPathSegment(b[end].cp2, b[end].p2, b[1].p1, b[1].cp1)
            seg = setbezierhandles(closingsegment, angles=[4rand(), -4rand()], handles=[4rand(), 4rand()])
            drawbezierpath(seg, :fill)
        end
    end

    setmode("overlay")
    textpath("julia")
    sethue("blue")
    fillpath()

end
    @test finish() == true
end

fname = "bezierstroke.png"
testbezierstroke(fname)
println("...finished bezier stroke tests: output in $(fname)")

using Luxor
using MathTeXEngine
using LaTeXStrings
using Test

#ENV["JULIA_DEBUG"] = "LuxorExtLatex"
ENV["JULIA_DEBUG"] = ""

# these are from MathTeXENgine tests/
inputs = Dict()

inputs["accents"] = [
    L"\dot{Q} \dot{q}",
    L"\vec{A} \vec{a}",
    L"\bar{L} \bar{l}",
    L"\hat{\Phi} \bar{\varphi}",
]

inputs["delimiters"] = [
    L"(1 + 2) (\frac{1}{2})",
    L"\left(1 + 2\right) \left(\frac{1}{2}\right)",
    L"\left[a + b\right] \left[\frac{a}{b}\right]",
    # ???
    #L"\left{A + B \right} + \left{\frac{A}{B}\right}",
    #L"\left{\alpha + \beta \right} + \left{\frac{\alpha}{\beta}\right}",
    #L"\left{1 + \left[2 + \left(3 + 4\right)\right]\right}"
]

inputs["fonts"] = [
    L"\mathrm{bonjour}",
    L"\mathbb{R} \mathbb{Q} \mathbb{C}",
    L"\mathcal{N} \mathcal{K}",
]

inputs["fractions"] = [
    L"\frac{a + b + c}{c + b + a}",
    L"\frac{a}{A + B + C}",
    L"\frac{j - f}{f - j}",
]

inputs["functions"] = [
    L"\sin{\omega} + \cos{\theta}",
    L"\exp{\log{2}} = 2",
    L"\inf_{x} \tan(x) \leq \sup_{x} \tan(x)",
]

inputs["infix"] = [
    L"T + V",
    L"7 - 2",
    L"v \cdot w",
    L"E = m c^2",
]

inputs["integrals"] = [
    L"\int_a^b",
    L"\int \int \int",
]

inputs["linebreaks"] = [
    L"we see $x = 22$\\and $y > x^2$",
]

inputs["punctuation"] = [
    L"x!",
    L"23.17",
    L"10,000",
]

inputs["spaces"] = [
    L"a \! b",
    L"a \; b",
    L"a \quad b",
    L"a \qquad b",
]

inputs["square_roots"] = [
    L"\sqrt{2}",
    L"\sqrt{\frac{1}{2}}",
    L"\sqrt{b^2 - 4ac}",
    L"\sqrt{1 + \frac{A + B}{J + U}}",
]

inputs["subsuper"] = [
    L"V^1_2",
    L"U_{ij}",
    L"W^{(i + j)}",
    L"x_L x_y x_{y \rightarrow 0}",
    L"N_\nu L_\nu A_\nu J_\nu",
    L"N^\nu L^\nu A^\nu J^\nu",
    L"^{87} Rb",
]

inputs["symbols"] = [
    L"\alpha \beta \gamma \delta \epsilon",
    L"\omega \theta \phi \varphi \psi",
    L"\Gamma \Delta \Omega \Theta \Phi \Psi",
    L"\nabla \rightarrow \neq \leq \hbar",
    L"\text{phi} \rightarrow \phi \quad",
    L"\text{varphi} \rightarrow \varphi",
    L"\text{epsilon} \rightarrow \epsilon",
    L"\quad \text{varepsilon} \rightarrow \varepsilon",
]

inputs["underover"] = [
    L"\sum_{n = 1}^{m^2}",
    L"\sum_{N = 1}^{M^2}",
    L"\prod_{n \neq m}",
    L"\prod_{N \neq M}",
]

function latex_test_harder(fname)
    Drawing(1400, 900, fname)
    origin()
    background("black")
    table = Table(9, 7, 170, 85)
    setline(0.5)
    let cell = 1
        for (group, exprs) in inputs
            for expr in exprs
                fontsize(22)
                sethue("white")
                text(expr, table[cell], halign = :center)
                fontsize(10)
                sethue("green")
                rawtext = replace(expr.s, "\$" => "")
                text(rawtext, table[cell] + (0, 35), halign = :center)
                cell += 1
                box(table, cell, :stroke)
            end
        end
    end
    @test finish() == true
end

fname = "latex-test-harder.svg"
latex_test_harder(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function text_rotation_tests(fname)
    Drawing(800, 800, fname)
    origin()
    background("white")
    fontsize(10)

    for (n, θ) in enumerate(range(0, 2π, length=11))
        pt = polar(100, θ)
        @layer begin
            sethue("red")
            circle(pt, 5, :fill)
        end
        text("LEFT BOTTOM",  pt, halign=:left, valign=:bottom, angle=θ)
        text("RIGHT BOTTOM", pt, halign=:right, valign=:bottom, angle=θ)
        text("LEFT TOP",     pt, halign=:left, valign=:top, angle=θ)
        text("RIGHT TOP",    pt, halign=:right, valign=:top, angle=θ)
    end

    for (n, θ) in enumerate(range(0, 2π, length=15))
        pt = polar(300, θ)
        @layer begin
            sethue("red")
            circle(pt, 5, :fill)
        end
        text("CENTER BOTTOM",  pt, halign=:center, valign=:bottom, angle=θ)
        text("CENTER TOP",     pt, halign=:center, valign=:top, angle=θ)
    end

    @test finish() == true
    println("...finished test: output in $(fname)")
end

text_rotation_tests("text-rotation-tests.svg")

using MiniFB

function onclick(window, button, mod, isPressed)::Cvoid
    if Bool(isPressed)
        println("mouse clicked")
    end
    mousex = mfb_get_mouse_x(window)
    mousey = mfb_get_mouse_y(window)
    println("x: $mousex y: $mousey")
end

function active_fn(win::Ptr{Cvoid}, is_active::Bool)
    println("Window is now ",  is_active ? "" : "in", "active")
end

macro play(w, h, body)
    quote
        window = mfb_open_ex("Luxor -> Julia", $(esc(w)), $(esc(h)), MiniFB.WF_RESIZABLE)

        mfb_set_active_callback(window, active_fn)
        mfb_set_mouse_button_callback(window, onclick)

        buffer = zeros(UInt32, $(esc(w)), $(esc(h)))
        while true
            Drawing($(esc(w)), $(esc(h)), :image)
            origin()
            $(esc(body))
            m = permutedims(image_as_matrix!(buffer), (2, 1))
            finish()
            state = mfb_update(window, m)
            if state != MiniFB.STATE_OK
                break
            end
        end
        mfb_close(window)
    end
end

#= Examples:

1 clock

using Luxor, Colors, Dates, ColorSchemes

include(dirname(pathof(Luxor)) * "/play.jl")

function clock(cscheme=ColorSchemes.leonardo)
    @play 400 600 begin
        fontface("JuliaMono-Regular")

        sethue(get(cscheme, .0))
        paint()
        fontsize(30)

        sethue(get(cscheme, .2))
        h = Dates.hour(now())
        sector(O, 180, 200, 3π/2, 3π/2 + rescale(h, 0, 24, 0, 2pi), :fill)

        sethue(get(cscheme, .4))
        m = Dates.minute(now())
        sector(O, 160, 180, 3π/2, 3π/2 + rescale(m, 0, 60, 0, 2pi), :fill)

        sethue(get(cscheme, .6))
        s = Dates.second(now())
        sector(O, 140, 160, 3π/2, 3π/2 + rescale(s, 0, 60, 0, 2pi), :fill)

        sethue(get(cscheme, .8))
        ms = Dates.value(Dates.Millisecond(Dates.now()))
        sector(O, 137, 140, 3π/2, 3π/2 + rescale(ms, 0, 1000, 0, 2pi), :fill)

        sethue(get(cscheme, 1.0))
        text(Dates.format(Dates.now(), "HH:MM:SS"), halign=:center)
    end
end

clock(ColorSchemes.botticelli)

=#


#=

2: bezier path thingy

using Luxor, Colors, Dates

function bez()
    j = rand(1:15)
    n = 1
    pgon = [Point(-100, -100), Point(100, 100), Point(100, -50), Point(-50, 100)]
    @play 500 500 begin
        t1 = time_ns()
        background(0, 0, 0)
        sethue(HSB(285, .7, .9))
        k = 3
        #        for i in 1:5
        for s in 1:30
            setopacity(rescale(s, 1, 30, 0.1, 1.0))
            pgon[1] += (k * rand(-1:1), k * rand(-1:1))
            pgon[2] += (k * rand(-1:1), k * rand(-1:1))
            pgon[3] += (k * rand(-1:1), k * rand(-1:1))
            pgon[4] += (k * rand(-1:1), k * rand(-1:1))
            bp = makebezierpath(pgon)
            drawbezierpath(bp, :stroke)
        end
        #        end
        if !isinside(polycentroid(pgon), box(BoundingBox() * 0.8), allowonedge=true)
            pgon = [Point(-100, -100), Point(100, 100), Point(100, -50), Point(-50, 100)]
        end

        n = mod1(n + 1, 200)


        sethue("white")
        fontface("JuliaMono-Black")
        fontsize(20)
        text(Dates.format(now(), "HH:MM:SS"), halign=:center)

        # time calc
        sethue("white")
        t2 = time_ns()
        text(string("fps: ", round(1E9/(t2-t1), digits=2)), boxtopleft(BoundingBox() * 0.9))
        t1 = t2
        sleep(0.1)
    end
end

bez()

=#

#=

3 some balls

using Luxor, Colors, Dates

mutable struct Ball
    position::Point
    velocity::Point
    radius::Float64
    hue::Float64
end

function f()
    balls = [Ball(rand(BoundingBox(Point(-300, -300), Point(300, 300))),
                  rand(BoundingBox(Point(-300, -300), Point(300, 300))),
                  rand(1:10),
                  rand(0:360))
             for i in 1:450]
    @play 600 600 begin
        w = 500
        h = 500
        background("black")

        for ball in balls
            sethue(HSB(ball.hue, .8, 0.8))
            circle(ball.position, ball.radius, :fill)

            if !(-w/2 < ball.position.x < w/2)
                ball.velocity = -ball.velocity
                ball.position = Point(-w/2, ball.position.y)
            end
            if !(-h/2 < ball.position.y < h/2)
                ball.velocity = -ball.velocity
                ball.position = Point(ball.position.x, -h/2)
            end
            ball.velocity = Point(rand(-4:4, 2) ...)

            ball.position = ball.position + ball.velocity
        end
        sleep(0.01)
    end
end

f()
=#

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function unit_conversions_test(fname)
    pagewidth, pageheight = 2000, 2000
    Drawing(pagewidth, pageheight, fname)
    origin()
    background("ivory")
    setline(0.5)
    tiles = Tiler(pagewidth, pageheight, 10, 4, margin=10)
    p = rand()
    for (pos, n) in tiles
        gsave()
        sethue("blue")
        translate(pos)
        if n % 2 == 0
            rect(O, 2inch, 1inch, :stroke)
            circle(O, 3inch/10, :stroke)

            rect(O + Point(-5mm, 3mm), 2cm, 1cm, :stroke)
            circle(O, 1cm, :stroke)

            rect(O, p*cm, p*cm, :stroke)
            circle(O, p*cm, :stroke)

        else
            sethue("darkorange")
            rect(O, 2*72, 72, :stroke)
            circle(O, 216/10, :stroke)

            rect(O + Point(-5 * 2.83464566929, 3 * 2.83464566929), 2 * 28.3464566929, 28.3464566929, :stroke)
            circle(O, 28.3464566929, :stroke)

            rect(O, p * 28.3464566929, p * 28.3464566929, :stroke)
            circle(O, p * 28.3464566929, :stroke)
        end
        grestore()
    end
    @test finish() == true
end

@test isapprox(1inch, 72)
@test isapprox(72, 1inch)
@test isapprox(2.54cm, 1inch)
@test isapprox(72, 2.54cm)

fname = "unit-conversions-test.pdf"
unit_conversions_test(fname)
println("...finished test: output in $(fname)")

using Luxor
using Test

function checkpoints(points, hull)
    flag = true
    for hullpoint in hull
        if hullpoint ∉ points
            flag = false
        end
    end
    return flag
end

function testpolyhull1(fname)
    Drawing(800, 1200, fname)
    origin()
    setopacity(0.5)
    tiles = Tiler(600, 600, 4, 4)
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            if n == 1
                pts = box(O, 100, 100, vertices=true)
            elseif n == 2
                pts = ngon(O, 60, 3, vertices=true)
            elseif n == 3
                pts = randompointarray(BoundingBox(box(O, 100, 100, vertices=true)), 25)
            elseif n == 4
                pts = star(O, 60, 5, 0.2, vertices=true)
            else
                pts = ngon(O, 60, n, vertices=true)
            end
            hull = polyhull(pts)
            @test checkpoints(pts, hull)
            sethue("black")
            setline(10)
            poly(pts, :fill, close=true)
            sethue("red")
            setline(2)
            poly(hull, :stroke, close=true)
        end
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

function testpolyhull2(fname)
    Drawing(800, 1200, fname)
    origin()
    setopacity(0.5)
    points = randompointarray(BoundingBox(), 30)
    while length(points) > 2
        hull = polyhull(points)
        randomhue()
        prettypoly(hull, close=true, :fill)
        # discard this hull and repeat
        points = setdiff(points, hull)
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

testpolyhull1("polyhull-test-1.png")
testpolyhull2("polyhull-test-2.png")

using Luxor, Test

function polyconvextest()

    Drawing(100, 100, :png)
    origin()

    # polygons are convex
    for i in 3:16
        @test ispolyconvex(ngon(O, 100, i, vertices=true)) == true
    end

    # 4+ pointed stars aren't convex
    # 3 pointed star is effectively a triangle
    for i in 4:16
        @test ispolyconvex(star(O, 100, i, 0.5, 0, vertices=true)) == false
    end

    pts = [Point(x, 0) for x in 0:100]
    @test ispolyconvex(pts) == true

    @test finish() == true
end

function polyclockwisetest()

    Drawing(100, 100, :png)
    origin()

    # polygons are clockwise
    for i in 3:16
        @test ispolyclockwise(ngon(O, 100, i, vertices=true)) == true
    end
    # stars are too
    for i in 3:16
        @test ispolyclockwise(star(O, 100, i, 0.5, 0, vertices=true)) == true
    end

    pts = [Point(x, 0) for x in 0:100]
    @test ispolyclockwise(pts) == false

    pts = [Point(10cos(x), 10sin(x)) for x in 0:100]
    @test ispolyclockwise(pts) == true

    @test finish() == true
end

polyconvextest()
polyclockwisetest()

println("...finished convex and clockwise tests")

#!/usr/bin/env

using Luxor

using Test

using Random
Random.seed!(42)

function test_circle_intersections(fname)
    Drawing(2000, 2000, fname)
    origin()
    setopacity(0.995)
    setline(0.1)
    tiles = Tiler(2000, 2000, 5, 5)
    setmode("darken")
    for (pos, n) in tiles
            @layer begin
                translate(pos)
                circle1 = (O, rand(30:tiles.tilewidth/3))
                circle2 = (O + (rand(40:70), rand(-20:20)), rand(40:tiles.tilewidth/3))
                flag, C, D = intersectioncirclecircle(circle1[1], circle1[2], circle2[1], circle2[2])
                if flag
                    sethue("slategray3")
                    circle(circle1..., :fill)
                    sethue("orange3")
                    circle(circle2..., :fill)
                    sethue("black")
                    circle(circle1..., :stroke)
                    circle(circle2..., :stroke)
                    sethue("red")
                    circle.([C, D], 4, :fill)
                else
                    sethue("black")
                    circle.([circle1[1], circle2[1]], [circle1[2], circle2[2]], :stroke)
                end
            end
    end
    @test finish() == true
end

fname = "intersection_circle_circle_test.png"
test_circle_intersections(fname)
println("...finished test: output in $(fname)")

"""
The `Movie` and `Scene` types and the `animate()` function are designed to help you
create the frames that can be used to make an animated GIF or movie.

1. Provide width, height, title, and optionally a frame range to the Movie constructor:
   ```julia
   demo = Movie(400, 400, "test", 1:500)
   ```

2. Define one or more scenes and scene-drawing functions.

3. Run the `animate()` function, calling those scenes.

Example

```julia
bang = Movie(400, 100, "bang")

backdrop(scene, framenumber) =  background("black")

function frame1(scene, framenumber)
    background("white")
    sethue("black")
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(O, 40 * eased_n, :fill)
end

animate(bang, [
    Scene(bang, backdrop, 0:200),
    Scene(bang, frame1, 0:200, easingfunction=easeinsine)],
    creategif=true,
    pathname="/tmp/animationtest.gif")
```
"""
struct Movie
    width::Float64
    height::Float64
    movietitle::AbstractString
    movieframerange::AbstractRange
end

"""
    Movie(width, height, movietitle)

Define a movie, specifying the width, height, and a title. The title will be used to
make the output file name. The range defaults to `1:250`.
"""
Movie(width, height, movietitle::AbstractString) = Movie(width, height, movietitle, 1:250)

"""default linear transition - no easing, no acceleration"""
function lineartween(t, b, c, d)
   return c * t/d + b
end

"""
The Scene type defines a function to be used to render a range of frames in a movie.

- the `movie` created by Movie()
- the `framefunction` is a function taking two arguments: the scene and the framenumber.
- the `framerange` determines which frames are processed by the function. Defaults to the entire movie.
- the optional `easingfunction` can be accessed by the framefunction to vary the transition speed
- the optional `opts` which is a single argument of an abstract type which can be accessed within the framefunction
"""
mutable struct Scene
    movie::Movie
    framefunction::Function
    framerange::AbstractRange
    easingfunction::Function
    opts::Any
end

"""
    Scene(movie, function, range;
        easingfunction=easinoutquad,
        optarg=nothing)

Use the Scene() constructor function to create a scene. Supply a movie, a function
to generate the scene, and a range of frames. Optionally you can supply an
easing function, and other information, in `optarg`, which can be accessed as
`scene.opts`.

### Example

```julia
function initial(scene, framenumber)
    balls = scene.opts
    ...
end

animate(poolmovie, [
    Scene(poolmovie, initial, optarg=balls, 1:20),
    ...
    ])
```

To use an easing function inside the frame-generating function, you can create a normalized
value with, for example:

```julia
eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
```

Or, if the scene doesn't start at frame 1, calculate normalized easing function like this:

```julia
eased_n = scene.easingfunction(framenumber - scene.framerange.start,
    0, 1, scene.framerange.stop - scene.framerange.start)
```
"""
Scene(movie::Movie, framefunction::Function;
    easingfunction=lineartween, optarg=nothing) =
    Scene(movie, framefunction, movie.movieframerange, easingfunction, optarg)
Scene(movie::Movie, framefunction::Function, framerange::AbstractRange;
    easingfunction=lineartween, optarg=nothing) =
    Scene(movie, framefunction, framerange, easingfunction, optarg)

"Wraps the location of an animated gif so that it can be displayed"
struct AnimatedGif
    filename::String
end

"""
    animate(movie::Movie, scenelist::Vector{Scene};
        creategif = false,
        createmovie = false,
        framerate = 30,
        pathname = "",
        tempdirectory = "")

Create all the frames of the `movie``, using the array of scenes
defined in `scenelist`.

If `creategif` is `true`, also create an animated GIF (".gif").

If `createmovie` is `true`, also create a movie (".mkv", ".mp4", or ".webm") file.

The file will be stored in the `pathname` keyword argument, or otherwise in a
temporary directory.

In suitable environments, a GIF animation is displayed in the Plots
window.

### Example

```julia
animate(bang, [
    Scene(bang, backdrop, 0:200),
    Scene(bang, frame1, 0:200, easingfunction=easeinsine)],
    creategif=true,
    pathname="/tmp/animationtest.gif")
```

If you prefer, you can use the FFMPEG.jl package (or the `ffmpeg` executable)
separately on the set of still images that have been generated. For example,
use code like this:

```julia
using Luxor
using FFMPEG

...

tempdirectory = "/tmp/temp/"

animate(movie, [
        Scene(movie, frame, 1:50)
    ],
    creategif=false,
    tempdirectory=tempdirectory)

FFMPEG.exe(`-r 30 -f image2 -i \$(tempdirectory)/%10d.png -c:v libx264 -r 30 -pix_fmt yuv420p -y /tmp/animation.mp4`)

```
"""
function animate(movie::Movie, scenelist::Vector{Scene};
    creategif = false,
    createmovie = false,
    framerate = 30,
    pathname = "",
    tempdirectory = "",
    usenewffmpeg = true,
    debug = false)

    # error if pathname is directory
    if isdir(pathname)
        suggestedpathname = joinpath(pathname, "myanimation.gif or mp4 or mkv")
        @error("Parameter pathname=$pathname points to a directory. Please pass a filename like '$suggestedpathname' as pathname parameter!")
        return false
    end

    if tempdirectory == ""
        tempdirectory = mktempdir()
    else
        if !isdir(tempdirectory)
            @info "$(tempdirectory) does not exist, using an autogenerated one."
            tempdirectory = mktempdir()
        end
    end
    @info("Frames for animation \"$(movie.movietitle)\" are being stored in directory: \n\t $(tempdirectory)")
    filecounter = 1
    rangelist = 0:-1
    for scene in scenelist
        rangelist = vcat(rangelist, collect(scene.framerange))
    end
    rangelist = unique(rangelist) # remove shared frames
    if rangelist[end] < movie.movieframerange.stop
        @warn("Movie framerange is longer than scene frame range: \n\t $(movie.movieframerange) > $(rangelist[end])")
    end
    for currentframe in rangelist[1]:rangelist[end]
        Drawing(movie.width, movie.height, "$(tempdirectory)/$(lpad(filecounter, 10, "0")).png")
        origin()
        # this frame needs doing, see if each of the scenes defines it
        for scene in scenelist
            if currentframe in scene.framerange
                scene.framefunction(scene, currentframe)
            end
        end
        finish()
        filecounter += 1
    end
    @info("... $(filecounter-1) frames saved in directory:\n\t $(tempdirectory)")

    if creategif == false && createmovie == false
        @info "to create a GIF or a movie, use `creategif = true` or `createmovie=true`."
        return true # we're done
    end

    # # we could do both I suppose, but if not:
    # if creategif == true && createmovie == true
    #     throw(error("animate() - GIF or Movie?"))
    # end

    ### gif creation?

    if creategif == true
        # the FFMPEG commands create a palette and then create an animated GIF from the resulting images
        if !usenewffmpeg
            # old version of ffmpeg up to 2.1.3
            # these two commands create a palette and then an animated GIF from the resulting images using the palette
            Luxor.FFMPEG.exe(`-loglevel panic -f image2 -i $(tempdirectory)/%10d.png -vf palettegen -y $(tempdirectory)/$(movie.movietitle)-palette.png`)
            Luxor.FFMPEG.exe(`-loglevel panic -framerate $(framerate) -f image2 -i $(tempdirectory)/%10d.png -i $(tempdirectory)/$(movie.movietitle)-palette.png -lavfi paletteuse -y $(tempdirectory)/$(movie.movietitle).gif`)
        else
            @debug "we're running bundled FFMPEG", Luxor.FFMPEG.exe("-version")
            # the latest version of ffmpeg uses built-in palettes and allegedly does transparency using complex filters ¯\\\_(ツ)_/¯
            if debug
                @info "$(framerate)"
                @info "$(tempdirectory)"
                @info "$(tempdirectory)/$(movie.movietitle).gif"
                Luxor.FFMPEG.exe(`-r $(framerate) -f image2 -i $(tempdirectory)/%10d.png -filter_complex "[0:v] split [a][b]; [a] palettegen=stats_mode=full:reserve_transparent=on:transparency_color=FFFFFF [p]; [b][p] paletteuse=new=1:alpha_threshold=128" -y $(tempdirectory)/$(movie.movietitle).gif`)
            else
                # reduce verbosity !
                Luxor.FFMPEG.exe(`-loglevel panic -r $(framerate) -f image2 -i $(tempdirectory)/%10d.png -filter_complex "[0:v] split [a][b]; [a] palettegen=stats_mode=full:reserve_transparent=on:transparency_color=FFFFFF [p]; [b][p] paletteuse=new=1:alpha_threshold=128" -y $(tempdirectory)/$(movie.movietitle).gif`)
            end
        end

        if !isempty(pathname)
            targetdir, movieformat = splitext(pathname)
            if movieformat != ".gif"
                pathname = targetdir * ".gif"
                movieformat = ".gif"
            end
            mv("$(tempdirectory)/$(movie.movietitle).gif", pathname, force = true)
            @info("GIF is: $pathname")
            giffn = pathname
        else
            @info("GIF is: $(tempdirectory)/$(movie.movietitle).gif")
            giffn = tempdirectory * "/" * movie.movietitle * ".gif"
        end
        return Luxor.AnimatedGif(giffn)
    end

    ## movie creation?

    if createmovie == true
        if pathname == ""
            # default to mkv
            pathname = tempdirectory * "/" * movie.movietitle * ".mkv"
        end
        targetdir, movieformat = splitext(pathname)
        if movieformat ∉ [".mkv", ".mp4", ".webm"]
            @info "using default movie format .mkv"
            movieformat = ".mkv"
            pathname = targetdir * movieformat
        end
        _make_video(movieformat, pathname, framerate, tempdirectory)
        return true
    end
end

function _make_video(movieformat, pathname, framerate, tempdirectory)
    if movieformat == ".mkv"
        @ffmpeg_env run(`ffmpeg
        -loglevel panic
        -f image2
        -i $(tempdirectory)/%10d.png
        -r $(framerate)
        -pixel_format rgb24
        -c:v libx264
        -pix_fmt yuv420p
        -an
        -y $(pathname)`)
    elseif movieformat == ".mp4"
        @ffmpeg_env run(`ffmpeg
        -loglevel panic
        -f image2
        -i $(tempdirectory)/%10d.png
        -r $(framerate)
        -pixel_format rgb24
        -c:v libx264
        -pix_fmt yuv420p
        -an
        -y $(pathname)`)
    elseif movieformat == ".webm"
        @ffmpeg_env run(`ffmpeg
        -loglevel panic
        -f image2
        -i $(tempdirectory)/%10d.png
        -r $(framerate)
        -lossless 0
        -c:v libvpx-vp9
        -b:v 0
        -pix_fmt yuv420p
        -an
        -y $(pathname)`)
    else
        throw(error("animate() can't do $(movieformat) videos "))
    end
    @info "saved video in $(pathname)"
end
"""
    animate(movie::Movie, scene::Scene; creategif=false, framerate=30)

Create the movie defined in `movie` by rendering the frames define in `scene`.
"""
animate(movie::Movie, scene::Scene; kwargs...) = animate(movie, [scene]; kwargs...)

# write out the HTML to view the gif
function Base.show(io::IO, ::MIME"text/html", agif::AnimatedGif)
    ext = last(splitext(agif.filename))
    if ext == ".gif"
        html = "<img src=\"data:image/gif;base64," * base64encode(read(agif.filename)) * "\" />"
    elseif ext in (".mov", ".mp4")
        mimetype = ext == ".mov" ? "video/quicktime" : "video/mp4"
        html = "<video controls><source src=\"data:$mimetype;base64," *
               base64encode(read(agif.filename)) *
               "\" type = \"$mimetype\"></video>"
    else
        error("Cannot show animation with extension $ext: $agif")
    end

    write(io, html)
    return nothing
end

# Only gifs can be shown via image/gif
Base.showable(::MIME"image/gif", agif::AnimatedGif) = lowercase(last(splitext(agif.filename))) == ".gif"

function Base.show(io::IO, ::MIME"image/gif", agif::AnimatedGif)
    open(fio -> write(io, fio), agif.filename)
end

"""
    easingflat(t, b, c, d)

A flat easing function, same as `lineartween()`.

For all easing functions, the four parameters are:

- `t` time, ie the current framenumber
- `b` beginning position or bottom value of the range
- `c` total change in position or top value of the range
- `d` duration, ie a framecount

1. `t/d` or `t/=d` normalizes `t` to between 0 and 1
2. `... * c` scales up to the required range value
3. `... + b` adds the initial offset

"""
function easingflat(t, b, c, d)
    return c * t / d + b
end

"""
    easeinquad(t, b, c, d)

quadratic easing in - accelerating from zero velocity
"""
function easeinquad(t, b, c, d)
   t /= d
   return c * t * t + b
end

"""
    easeoutquad(t, b, c, d)

quadratic easing out - decelerating to zero velocity
"""
function easeoutquad(t, b, c, d)
   t /= d
   return -c * t * (t - 2) + b
end

"""
    easeinoutquad(t, b, c, d)

quadratic easing in/out - acceleration until halfway, then deceleration
"""
function easeinoutquad(t, b, c, d)
   t /= d/2
   if t < 1
      return  (c/2) * t * t + b
    end
   t -= 1
   return -(c/2) * (t * (t - 2) - 1) + b
end

"""
    easeincubic(t, b, c, d)

cubic easing in - accelerating from zero velocity
"""
function easeincubic(t, b, c, d)
   t /= d
   return c * t * t * t + b
end

"""
    easeoutcubic(t, b, c, d)

cubic easing out - decelerating to zero velocity
"""
function easeoutcubic(t, b, c, d)
   t /= d
   t -= 1
   return c * (t * t * t + 1) + b
end

"""
    easeinoutcubic(t, b, c, d)

cubic easing in/out - acceleration until halfway, then deceleration
"""
function easeinoutcubic(t, b, c, d)
   t /= d/2
   if t < 1
       return c/2 * t * t * t + b
   end
   t -= 2
   return c/2 * (t * t * t + 2) + b
end

"""
    easeinquart(t, b, c, d)

quartic easing in - accelerating from zero velocity
"""
function easeinquart(t, b, c, d)
   t /= d
   return c * t * t * t * t + b
end

"""
    easeoutquart(t, b, c, d)

quartic easing out - decelerating to zero velocity
"""
function easeoutquart(t, b, c, d)
   t /= d
   t -= 1
   return -c * (t * t * t * t - 1) + b
end

"""
    easeinoutquart(t, b, c, d)

quartic easing in/out - acceleration until halfway, then deceleration
"""
function easeinoutquart(t, b, c, d)
   t /= d/2
   if t < 1
       return c/2 * t * t * t * t + b
   end
   t -= 2
   return -c/2 * (t * t * t * t - 2) + b
end

"""
    easeinquint(t, b, c, d)

quintic easing in - accelerating from zero velocity
"""
function easeinquint(t, b, c, d)
   t /= d
   return c * t * t * t * t * t + b
end

"""
    easeoutquint(t, b, c, d)

quintic easing out - decelerating to zero velocity
"""
function easeoutquint(t, b, c, d)
   t /= d
   t -= 1
   return c * (t * t * t * t * t + 1) + b
end

"""
    easeinoutquint(t, b, c, d)

quintic easing in/out - acceleration until halfway, then deceleration
"""
function easeinoutquint(t, b, c, d)
   t /= d/2
   if t < 1
       return c/2 * t * t * t * t * t + b
   end
   t -= 2
   return c/2 * (t * t * t * t * t + 2) + b
end

"""
    easeinsine(t, b, c, d)

sinusoidal easing in - accelerating from zero velocity
"""
function easeinsine(t, b, c, d)
   return -c * cos(t/d * (pi/2)) + c + b
end

"""
    easeoutsine(t, b, c, d)

sinusoidal easing out - decelerating to zero velocity
"""
function easeoutsine(t, b, c, d)
   return c * sin(t/d * (pi/2)) + b
end

"""
    easeinoutsine(t, b, c, d)

sinusoidal easing in/out - accelerating until halfway, then decelerating
"""
function easeinoutsine(t, b, c, d)
   return -c/2 * (cos(pi * t/d) - 1) + b
end

"""
    easeinexpo(t, b, c, d)

exponential easing in - accelerating from zero velocity
"""
function easeinexpo(t, b, c, d)
    if isapprox(t, 0.0, atol=1e-3)
        return 0.0
    else
        return c * 2 ^ (10 * (t/d - 1)) + b
    end
end

"""
    easeoutexpo(t, b, c, d)

exponential easing out - decelerating to zero velocity
"""
function easeoutexpo(t, b, c, d)
   return c * (-(2 ^ (-10 * t/d)) + 1) + b
end

"""
    easeinoutexpo(t, b, c, d)

exponential easing in/out - accelerating until halfway, then decelerating
"""
function easeinoutexpo(t, b, c, d)
   t /= d/2
   if t < 1
       return c/2 * 2 ^ (10 * (t - 1)) + b
   end
   t -= 1
   return c/2 * (-(2 ^ (-10 * t)) + 2) + b
end

"""
    easeincirc(t, b, c, d)

circular easing in - accelerating from zero velocity
"""
function easeincirc(t, b, c, d)
   t /= d
   return -c * (sqrt(abs((1 - t * t))) - 1) + b
end

"""
    easeoutcirc(t, b, c, d)

circular easing out - decelerating to zero velocity
"""
function easeoutcirc(t, b, c, d)
   t /= d
   t -= 1
   return c * sqrt(abs((1 - t * t))) + b
end

"""
    easeinoutcirc(t, b, c, d)

circular easing in/out - acceleration until halfway, then deceleration
"""
function easeinoutcirc(t, b, c, d)
   t /= d/2
   if (t < 1)
       return -c/2 * ((sqrt(abs(1 - t * t))) - 1) + b
   end
   t -= 2
   return c/2 * (sqrt(abs(1 - t * t)) + 1) + b
end

"""
    easeinoutinversequad(t, b, c, d)

ease in, then slow down, then speed up, and ease out
"""
function easeinoutinversequad(t, b, c, d)
   t /= d/2
   if t <= 1
      return -(c/2) * (t * (t - 2)) + b
    end
   t -= 1
   return c/2 * (t * t * t + 1) + b
end

"""
    easeinoutbezier(t, b, c, d, cpt1, cpt2)

This easing function takes six arguments, the usual `t`, `b`, `c`, and `d`, but
also two points. These are the normalized control points of a Bezier curve drawn
between `Point(0, 0)` to `Point(1.0, 1.0)`. The `y` value of the Bezier is the
eased value for `t`.

In your `frame()` generating function, if a Scene specifies the `easeinoutbezier` easing function, you can use this:

```julia
...
lineareasing = rescale(framenumber, 1, scene.framerange.stop)
beziereasing = scene.easingfunction(lineareasing, 0, 1, 1,
    Point(0.25, 0.25), Point(0.75, 0.75))
...
```

These two control points lie on the line between `0/0` and `1/1`, so it's equivalent to a linear easing (`lineartween()` or `easingflat`).

However, in the next example, the two control points define a wave-like curve
that changes direction before changing back. When animating with this easing
function, an object will 'go retrograde' for a while.

```julia
lineareasing = rescale(framenumber, 1, scene.framerange.stop)
beziereasing = scene.easingfunction(lineareasing, 0, 1, 1,
    Point(0.01, 1.99), Point(0.99, -1.5))
```

"""
function easeinoutbezier(t, b, c, d, cpt1::Point=Point(0.25, 0.25), cpt2::Point=Point(0.75, 0.75))
    t /= d + b
    bez = bezier(t, Point(0, 0), cpt1, cpt2, Point(1.0, 1.0))
    return bez.y * c
end

easingfunctions = [lineartween,
                    easeinquad,
                    easeoutquad,
                    easeinoutquad,
                    easeincubic,
                    easeoutcubic,
                    easeinoutcubic,
                    easeinquart,
                    easeoutquart,
                    easeinoutquart,
                    easeinquint,
                    easeoutquint,
                    easeinoutquint,
                    easeinsine,
                    easeoutsine,
                    easeinoutsine,
                    easeinexpo,
                    easeoutexpo,
                    easeinoutexpo,
                    easeincirc,
                    easeoutcirc,
                    easeinoutcirc,
                    easingflat,
                    easeinoutinversequad,
                    easeinoutbezier]

"""
    trianglecircumcenter(pt1::Point, pt2::Point, pt3::Point)

Return the circumcenter of the triangle defined by `pt1`,
`pt2`, and `pt3`. The circumcenter is the center of a circle
that passes through the vertices of the triangle.

"""
function trianglecircumcenter(pt1::Point, pt2::Point, pt3::Point)
    d = 2(pt1.x * (pt2.y - pt3.y) + pt2.x * (pt3.y - pt1.y) + pt3.x * (pt1.y - pt2.y))
    x = ((pt1.x^2 + pt1.y^2) * (pt2.y - pt3.y) + (pt2.x^2 + pt2.y^2) * (pt3.y - pt1.y) + (pt3.x^2 + pt3.y * pt3.y) * (pt1.y - pt2.y)) / d
    y = ((pt1.x^2 + pt1.y^2) * (pt3.x - pt2.x) + (pt2.x^2 + pt2.y^2) * (pt1.x - pt3.x) + (pt3.x^2 + pt3.y * pt3.y) * (pt2.x - pt1.x)) / d
    return Point(x, y)
end

"""
    triangleincenter(pt1::Point, pt2::Point, pt3::Point)

Return the incenter of the triangle defined by `pt1`, `pt2`,
and `pt3`. The incenter is the center of a circle inscribed
inside the triangle.
"""
function triangleincenter(pt1::Point, pt2::Point, pt3::Point)
    a = distance(pt2, pt3)
    b = distance(pt1, pt3)
    c = distance(pt1, pt2)
    x = ((a * pt1.x) + (b * pt2.x) + (c * pt3.x)) / (a + b + c)
    y = ((a * pt1.y) + (b * pt2.y) + (c * pt3.y)) / (a + b + c)
    return Point(x, y)
end

"""
    trianglecenter(pt1::Point, pt2::Point, pt3::Point)

Return the centroid of the triangle defined by `pt1`, `pt2`, and `pt3`.
"""
function trianglecenter(pt1::Point, pt2::Point, pt3::Point)
    return 1/3 * (pt1 + pt2  + pt3)
end

"""
    triangleorthocenter(pt1::Point, pt2::Point, pt3::Point)

Return the orthocenter of the triangle defined by `pt1`, `pt2`, and `pt3`.
"""
function triangleorthocenter(pt1::Point, pt2::Point, pt3::Point)
    return pt1 + pt2 + pt3 - 2trianglecircumcenter(pt1, pt2, pt3)
end

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function triangle(points, degree)
    sethue(cols[degree])
    poly(points, :fill)
end

function sierpinski(points, degree)
    triangle(points, degree)
    if degree > 1
        p1, p2, p3 = points
        sierpinski([p1, midpoint(p1, p2),
                        midpoint(p1, p3)], degree-1)
        sierpinski([p2, midpoint(p1, p2),
                        midpoint(p2, p3)], degree-1)
        sierpinski([p3, midpoint(p3, p2),
                        midpoint(p1, p3)], degree-1)
    end
end

function draw(fname, n)
  Drawing(200, 200, fname)
  origin()
  background("ivory")
  circle(O, 75, :clip)
  my_points = ngon(O, 150, 3, -pi/2, vertices=true)
  depth = 8 # 12 is ok, 20 is right out
  sierpinski(my_points, n)
  @test finish() == true
end

cols = distinguishable_colors(8)
fname = "sierpinski.pdf"
draw(fname, 8)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Colors

using Test

using Random
Random.seed!(2)

function meshtest1(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("ivory")
    tiles = Partition(1200, 1200, 120, 120)
    fontsize(120)
    fontface("Courier-Bold")
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            setcolor("black")
            setline(1)
            box(O, tiles.tilewidth-8, tiles.tileheight-8, :stroke)
            circle(O, 20, :fill)
            pl = ngon(O, tiles.tilewidth/2, 4, pi/4, vertices=true)
            # some of these should be transparent
            mesh1 = mesh(pl, [
                "red",
                Colors.RGBA(randomcolor()...),
                Colors.RGBA(randomcolor()...),
                Colors.RGBA(randomcolor()...)
                ])
            setmesh(mesh1)
            # box(O, tiles.tilewidth-10, tiles.tileheight-10, :fillpreserve)
            text(string(Char(rand(64:89))), halign=:center, valign=:middle)
        end
    end
    @test finish() == true
end

function meshtest2(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("ivory")
    setcolor("black")
    fontsize(60)
    text("illuminati", halign=:center)
    pl = ngon(O, 300, 3, pi/6, vertices=true)
    mesh1 = mesh(pl, [
        "purple",
        Colors.RGBA(randomcolor()...),
        "yellow"
        ])
    setmesh(mesh1)
    setline(260)
    ngon(O, 300, 3, pi/6, :strokepreserve)
    setline(5)
    sethue("black")
    strokepath()
    @test finish() == true
end

function meshtest3(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("ivory")
    bp = makebezierpath(ngon(O, 600, 3, pi/6, vertices=true))
    mesh1 = mesh(bp, [
        "purple",
        Colors.RGBA(randomcolor()...),
        "yellow"
        ])
    add_mesh_patch(mesh1, makebezierpath(ngon(O, 400, 4, vertices=true)), ["red", "blue", "green"])
    setmesh(mesh1)
    setline(550)
    drawbezierpath(bp, :strokepreserve)

    setline(5)
    sethue("black")
    strokepath()
    setcolor("black")
    fontsize(60)
    text("illuminati", halign=:center)
    @test finish() == true
end

fname = "meshtest1.png"
meshtest1(fname)
println("...finished mesh test 1: output in $(fname)")

fname = "meshtest2.png"
meshtest2(fname)
println("...finished mesh test 2: output in $(fname)")

fname = "meshtest3.png"
meshtest3(fname)
println("...finished mesh test 3: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function boxmaptest(fname)
    Drawing(850, 850, fname)
    origin()
    background("ivory")

    # fibonacci
    tiles = boxmap([1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89], O - (400, 400), 800, 800)
    for (n, t) in enumerate(tiles)
    randomhue()

    #box(t, :fill) # box() would work, but BoundingBoxes are fun too

    bb = BoundingBox(t)
    sethue("black")
    box(bb - 2, :stroke)

    randomhue()
    box(bb - 4, :fill)

    # text labels
    sethue("white")
    # rescale text to fit better
    fontsize(boxwidth(bb) > boxheight(bb) ? boxheight(bb)/4 : boxwidth(bb)/4)
    text(string(sort([1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89], rev=true)[n]),
        midpoint(bb[1], bb[2]),
        halign=:center,
        valign=:middle)
    end

    @test finish() == true
end

fname = "boxmaptest.pdf"
boxmaptest(fname)
println("...finished test: output in $(fname)")

using Luxor
using Test

function textfit_test(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("antiquewhite")
    t = Tiler(1200, 1200, 4, 4)
    for (pos, n) in t
        @layer begin
            translate(pos)
            r = rescale(n, 1, length(t), 0.2, 1)
            bx = BoundingBox(O - Point(t.tilewidth, t.tileheight)/2, O + Point(t.tilewidth, t.tileheight)/2) * r
            sethue("purple")
            box(bx, :fill)
            sethue("white")
            textfit("this text is supposed to fit inside the box.", bx, 100, horizontalmargin=1)
        end
    end

    @test finish() == true
    println("...finished test: output in $(fname)")
end

textfit_test("textfit-test.png")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_spirals(fname)
    Drawing(2000, 2000, fname)
    origin()
    setopacity(0.5)
    setline(2)
    for i in 0:pi/6:2pi
        rotate(i)
        randomhue()
        v1 = spiral(10, log(Base.MathConstants.golden)/(pi/2), log=true, stepby=pi/5, period=4pi, vertices=true)
        poly(v1, :fill)
        for j in 1:length(v1) - 3
            poly([v1[j], v1[j+1], v1[j+2]], :fill)
        end
    end
    for i in 0:pi/6:2pi
        rotate(i)
        v2 = spiral(30, 1, log=false, stepby=pi/10, period=4pi, vertices=true)
        poly(v2, :stroke)
        rand(Bool) ? sethue("white") : sethue("black")
        for j in 1:length(v2) - 3
            poly([v2[j], v2[j+1], v2[j+2]], :fill)
        end
    end
    @test finish() == true
end

fname = "spirals.pdf"
test_spirals(fname)
println("...finished test: output in $(fname)")

using Luxor
using Test
using Random
Random.seed!(42)

function f(pos, str)
    @layer begin
        setline(0.4)
        for i in 10:5:100
            circle(pos, i, :stroke)
        end
    end
end

function textformat_tests(fname)
    Drawing(800, 800, fname)
    origin()
    background("black")
    sethue("white")
    fontsize(40)
    tiles = Tiler(800, 800, 4, 4)
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            n == 1 &&
                textformat("tile 1")
            n == 2 &&
                textformat(
                    (text = "tile 2",
                    color = "green"))
            n == 3 &&
                textformat("tile 3")
            n == 4 &&
                textformat(
                    (text = "tile 4",))
            n == 5 &&
                textformat(
                    (text = "tile 5",
                    color = "red",
                    prolog = f,
                ),)
            n == 6 &&
                textformat(
                    (text = "tile 6",
                    color = "purple",
                    fontsize = 30,
                ),)
            n == 7 &&
                textformat(
                    (text = "tile 7",
                    color = "blue",
                    fontsize = 20,
                    advance = 40,
                ),)
            n == 8 &&
                textformat(
                    (
                    baseline = 50,
                    prolog = f,
                    text = "tile 8",
                    color = "cyan",
                ),)
            n == 9 &&
                textformat(
                    (text = "one",
                        color = "magenta",
                        baseline = 10,
                    ),
                    "two",
                    "three, four,",
                    (text = "five,",
                        color = "magenta",
                    ),
                    fontsize = 30,
                    width = 140,
                )
            n == 10 &&
                textformat(
                    (text = "tile 10",
                    color = "orange",
                ),)
            n == 11 &&
                textformat(
                    (text = "tile 11",
                    color = "yellow",
                ),)
            n == 12 &&
                textformat(
                    (prolog = f,
                    text = "tile 12",
                    fontsize = 24,
                    color = "orange",
                ),)
            n == 13 &&
                textformat(
                    (text = "tile 13",
                    color = "grey70",
                ),)
            n == 14 &&
                textformat(
                    (text = "tile 14",
                    color = "hotpink",
                ),)
            n == 15 &&
                begin
                    pt = textformat(
                        (text = "15",
                        color = "magenta",
                        fontsize = 30,
                        advance = 0,
                    ))

                    pt = textformat("15",
                        position = pt,
                        color = "magenta",
                        fontsize = 30,
                        advance = 0,
                    )
                    textformat("15",
                        position = pt,
                        color = "magenta",
                        fontsize = 30,
                        advance = 0,
                    )
                end
            n == 16 &&
                begin
                    pt = textformat(
                        (text = "tile16",
                        color = "cyan",
                        fontsize = 30,
                        advance = 600), width=400)
                    textformat(
                        (text = "tile 16",
                        color = "cyan",
                        fontsize = 20),
                        position = pt)
                    
                end
        end
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

textformat_tests("text-format-tests.png")

import Base: +, -, *, /, ^, !=, <, >, ==
import Base: isequal, isless, isapprox, cmp, size, getindex, broadcastable

abstract type AbstractPoint end

"""
The Point type holds two coordinates. It's immutable, you can't
change the values of the x and y values directly.
"""
struct Point <: AbstractPoint
    x::Float64
    y::Float64
end

"""
`O` is a shortcut for the current origin, `0/0`
"""
const O = Point(0, 0)
Base.zero(::Type{Point}) = O
Base.zero(::Point) = O

# basics
+(p1::Point, p2::Point) = Point(p1.x + p2.x, p1.y + p2.y)
-(p1::Point, p2::Point) = Point(p1.x - p2.x, p1.y - p2.y)
-(p::Point) = Point(-p.x, -p.y)
*(k::Number, p2::Point) = Point(k * p2.x, k * p2.y)
*(p2::Point, k::Number) = Point(k * p2.x, k * p2.y)
/(p2::Point, k::Number) = Point(p2.x / k, p2.y / k)

# some refinements
# modifying points with tuples
+(p1::Point, shift::NTuple{2,Real}) = Point(p1.x + shift[1], p1.y + shift[2])
-(p1::Point, shift::NTuple{2,Real}) = Point(p1.x - shift[1], p1.y - shift[2])
*(p1::Point, shift::NTuple{2,Real}) = Point(p1.x * shift[1], p1.y * shift[2])
/(p1::Point, shift::NTuple{2,Real}) = Point(p1.x / shift[1], p1.y / shift[2])

# convenience
Point((x, y)::Tuple{Real,Real}) = Point(x, y)

# for broadcasting
# Base.size(::Point) = (2,)
Base.getindex(p::Point, i) = (p.x, p.y)[i]
Broadcast.broadcastable(x::Point) = Ref(x)

# for iteration
Base.eltype(::Type{Point}) = Float64
Base.iterate(p::Point, state = 1) = state > length(p) ? nothing : (p[state], state + 1)
Base.length(::Point) = 2

# matrix

"""
    *(m::Matrix, pt::Point)

Transform a point `pt` by the 3×3 matrix `m`.

```julia
julia> M = [2 0 0; 0 2 0; 0 0 1]
3×3 Matrix{Int64}:
 2  0  0
 0  2  0
 0  0  1

julia> M * Point(20, 20)
Point(40.0, 40.0)
```

To convert between Cairo matrices (6-element Vector{Float64}) to a 3×3 Matrix,
use `cairotojuliamatrix()` and `juliatocairomatrix()`.
"""
function Base.:*(m::AbstractMatrix, pt::Point)
    if size(m) != (3, 3)
        throw(error("matrix should be (3, 3), not $(size(m))"))
    end
    x, y, _ = m * [pt.x, pt.y, 1]
    return Point(x, y)
end

"""
    dotproduct(a::Point, b::Point)

Return the scalar dot product of the two points.
"""
function dotproduct(a::Point, b::Point)
    result = 0.0
    result += a.x * b.x
    result += a.y * b.y
    return result
end

"""
    determinant3(p1::Point, p2::Point, p3::Point)

Find the determinant of the 3×3 matrix:

```math
\\begin{bmatrix}
p1.x & p1.y & 1 \\\\
p2.x & p2.y & 1 \\\\
p3.x & p3.y & 1  \\\\
\\end{bmatrix}
```

If the value is 0.0, the points are collinear.
"""
function determinant3(p1::Point, p2::Point, p3::Point)
    (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y)
end

# comparisons

"""
    isequal(p1::Point, p2::Point) =
        isapprox(p1.x, p2.x, atol = 0.00000001) &&
        isapprox(p1.y, p2.y, atol = 0.00000001)

Compare points.
"""
isequal(p1::Point, p2::Point) =
    (isapprox(p1.x, p2.x, atol = 0.00000001)) && (isapprox(p1.y, p2.y, atol = 0.00000001))

# allow kwargs
"""
    isapprox(p1::Point, p2::Point; atol = 1e-6, kwargs...)

Compare points.
"""
function Base.isapprox(p1::Point, p2::Point;
    atol = 1e-6, kwargs...)
    return isapprox(p1.x, p2.x, atol = atol, kwargs...) &&
           isapprox(p1.y, p2.y, atol = atol, kwargs...)
end

isless(p1::Point, p2::Point) = (p1.x < p2.x || (isapprox(p1.x, p2.x) && p1.y < p2.y))
<(p1::Point, p2::Point) = isless(p1, p2)
==(p1::Point, p2::Point) = isequal(p1, p2)

# a unique that works better on points?
# I think this uses ==
# TODO perhaps unique(x -> round(x, sigdigits=13), myarray) ?
# "any implementation of unique with a tolerance will have some odd behaviors" Steven GJohnson
function Base.unique(pts::Vector{Point})
    apts = Point[]
    for pt in pts
        if pt ∉ apts
            push!(apts, pt)
        end
    end
    return apts
end

"""
    distance(p1::Point, p2::Point)

Find the distance between two points (two argument form).
"""
function distance(p1::Point, p2::Point)
    dx = p2.x - p1.x
    dy = p2.y - p1.y
    return sqrt(dx * dx + dy * dy)
end

"""
    pointlinedistance(p::Point, a::Point, b::Point)

Find the distance between a point `p` and a line between two points `a` and `b`.
"""
function pointlinedistance(p::Point, a::Point, b::Point)
    dx = b.x - a.x
    dy = b.y - a.y
    return abs(p.x * dy - p.y * dx + b.x * a.y - b.y * a.x) / hypot(dx, dy)
end

"""
    getnearestpointonline(pt1::Point, pt2::Point, startpt::Point)

Given a line passing through `pt1` and `pt2`, return the point where a line
starting at `startpt` would meet the line at right angles. The point may or may
not lie on the line between `pt1` and `pt2` - use `ispointonline()` to see if it does.

See aalso `perpendicular()`.
"""
function getnearestpointonline(pt1::Point, pt2::Point, startpt::Point)
    perpendicular(pt1, pt2, startpt)
end

"""
    midpoint(p1, p2)

Find the midpoint between two points.
"""
midpoint(p1::Point, p2::Point) = Point((p1.x + p2.x) / 2.0, (p1.y + p2.y) / 2.0)

"""
    midpoint(a)

Find midpoint between the first two elements of an array of points.
"""
midpoint(pt::Array) = midpoint(pt[1], pt[2])

"""
    between(p1::Point, p2::Point, x)
    between((p1::Point, p2::Point), x)

Find the point between point `p1` and point `p2` for `x`, where `x` is typically between 0
and 1. `between(p1, p2, 0.5)` is equivalent to `midpoint(p1, p2)`.
"""
function between(p1::Point, p2::Point, x)
    return p1 + (x * (p2 - p1))
end

function between(couple::NTuple{2,Point}, x)
    p1, p2 = couple
    return p1 + (x * (p2 - p1))
end

# convenience functions for my own use :)
"""
    between(p1::Point, p2::Point, r:range)
    between(p1::Point, p2::Point, a:array)

Return an array of Points between point `p1` and point `p2` for
every `x` in range `r` or array `a`.

If `x` is 0.0, that point will be at `p1`; if `x` is 1.0, that point will be at `p2`.

When `x` is 0.5, that point is the midpoint between `p1` and `p2`.
"""
function between(pt1::Point, pt2::Point, r::AbstractRange)
    [between(pt1, pt2, e) for e in r]
end

function between(pt1::Point, pt2::Point, a::AbstractArray)
    [between(pt1, pt2, e) for e in a]
end

"""
    perpendicular(p1::Point, p2::Point, p3::Point)

Return a point on a line passing through `p1` and `p2` that
is perpendicular to `p3`.
"""
function perpendicular(p1::Point, p2::Point, p3::Point)
    v2 = p2 - p1
    return p1 + (dotproduct(p3 - p1, v2) / dotproduct(v2, v2)) * v2
end

"""
    perpendicular(p1, p2, k)

Return a point `p3` that is `k` units away from `p1`, such that a line `p1 p3`
is perpendicular to `p1 p2`.

Convention? to the right?
"""
function perpendicular(p1::Point, p2::Point, k)
    px = p2.x - p1.x
    py = p2.y - p1.y
    l = hypot(px, py)
    if l > 0.0
        ux = -py / l
        uy = px / l
        return Point(p1.x + (k * ux), p1.y + (k * uy))
    else
        error("these two points are the same")
    end
end

"""
    perpendicular(p1, p2)

Return two points `p3` and `p4` such that a line from `p3` to `p4` is perpendicular to a line
from `p1` to `p2`, the same length, and the lines intersect at their midpoints.
"""
function perpendicular(p1::Point, p2::Point)
    if isequal(p1, p2)
        throw(error("perpendicular(); no line, the two points are the same"))
    end
    ip = p2 - p1
    ep1 = Point(-ip.y, ip.x) / 2 + (p1 + p2) / 2
    ep2 = Point(ip.y, -ip.x) / 2 + (p1 + p2) / 2
    return (ep1, ep2)
end

"""
    perpendicular(p::Point)

Returns point `Point(p.y, -p.x)`.
"""
function perpendicular(p::Point)
    return Point(p.y, -p.x)
end

"""
    crossproduct(p1::Point, p2::Point)

This is the *perp dot product*, really, not the crossproduct proper (which is 3D):
"""
function crossproduct(p1::Point, p2::Point)
    return dotproduct(p1, perpendicular(p2))
end

"""
    ispointonline(pt::Point, pt1::Point, pt2::Point;
        extended = false,
        atol = 10E-5)

Return `true` if the point `pt` lies on a straight line between `pt1` and `pt2`.

If `extended` is false (the default) the point must lie on the line segment between
`pt1` and `pt2`. If `extended` is true, the point lies on the line if extended in
either direction.
"""
function ispointonline(pt::Point, pt1::Point, pt2::Point;
    atol = 10E-5, extended = false)
    dxc = pt.x - pt1.x
    dyc = pt.y - pt1.y
    dxl = pt2.x - pt1.x
    dyl = pt2.y - pt1.y
    cpr = (dxc * dyl) - (dyc * dxl)

    # point not on line
    if !isapprox(cpr, 0.0, atol = atol)
        return false
    end

    # point somewhere on extended line
    if extended == true
        return true
    end

    # point on the line
    if (abs(dxl) >= abs(dyl))
        return dxl > 0 ? pt1.x <= pt.x + atol && pt.x <= pt2.x + atol : pt2.x <= pt.x + atol && pt.x <= pt1.x + atol
    else
        return dyl > 0 ? pt1.y <= pt.y + atol && pt.y <= pt2.y + atol : pt2.y <= pt.y + atol && pt.y <= pt1.y + atol
    end
end

"""
    ispointonpoly(pt::Point, pgon;
        atol=10E-5)

Return `true` if `pt` lies on the polygon `pgon.`
"""
function ispointonpoly(pt::Point, pgon::Vector{Point};
    atol = 10E-5)
    @inbounds for i in 1:length(pgon)
        p1 = pgon[i]
        p2 = pgon[mod1(i + 1, end)]
        if ispointonline(pt, p1, p2, atol = atol)
            return true
        end
    end
    return false
end

"""
    slope(pointA::Point, pointB::Point)

Find angle of a line starting at `pointA` and ending at `pointB`.

Return a value between 0 and 2pi. Value will be relative to the current axes.

```julia
julia> slope(O, Point(0, 100)) |> rad2deg # y is positive down the page
90.0

julia> slope(Point(0, 100), O) |> rad2deg
270.0
```

The slope isn't the same as the gradient. A vertical line going up has a
slope of 3π/2.
"""
function slope(pointA, pointB)
    return mod2pi(atan(pointB.y - pointA.y, pointB.x - pointA.x))
end

function intersection_line_circle(p1::Point, p2::Point, cpoint::Point, r)
    a = (p2.x - p1.x)^2 + (p2.y - p1.y)^2
    b = 2.0 * ((p2.x - p1.x) * (p1.x - cpoint.x) + (p2.y - p1.y) * (p1.y - cpoint.y))
    c = (
        (cpoint.x)^2 + (cpoint.y)^2 + (p1.x)^2 + (p1.y)^2 -
        2.0 * (cpoint.x * p1.x + cpoint.y * p1.y) - r^2
    )
    i = b^2 - 4.0 * a * c
    if i < 0.0
        number_of_intersections = 0
        intpoint1 = O
        intpoint2 = O
    elseif isapprox(i, 0.0)
        number_of_intersections = 1
        mu = -b / (2.0 * a)
        intpoint1 = Point(p1.x + mu * (p2.x - p1.x), p1.y + mu * (p2.y - p1.y))
        intpoint2 = O
    elseif i > 0.0
        number_of_intersections = 2
        # first intersection
        mu = (-b + sqrt(i)) / (2.0 * a)
        intpoint1 = Point(p1.x + mu * (p2.x - p1.x), p1.y + mu * (p2.y - p1.y))
        # second intersection
        mu = (-b - sqrt(i)) / (2.0 * a)
        intpoint2 = Point(p1.x + mu * (p2.x - p1.x), p1.y + mu * (p2.y - p1.y))
    end
    return number_of_intersections, intpoint1, intpoint2
end

"""
    intersectionlinecircle(p1::Point, p2::Point, cpoint::Point, r)

Find the intersection points of a line (extended through points `p1` and `p2`) and a circle.

Return a tuple of `(n, pt1, pt2)`

where

  - `n` is the number of intersections, `0`, `1`, or `2`
  - `pt1` is first intersection point, or `Point(0, 0)` if none
  - `pt2` is the second intersection point, or `Point(0, 0)` if none

The calculated intersection points won't necessarily lie on the line segment between `p1` and `p2`.
"""
intersectionlinecircle(p1::Point, p2::Point, cpoint::Point, r) =
    intersection_line_circle(p1, p2, cpoint, r)

"""
    @polar (p)

Convert a tuple of two numbers to a Point of x, y Cartesian coordinates.

```julia
julia> @polar 10, pi/4
Point(7.0710678118654755, 7.071067811865475)
```

Example usage
```julia
@polar (10, pi/4)
@polar [10, pi/4]
@polar 10, pi/4
```
"""
macro polar(p)
    quote
        Point($(esc(p))[1] * cos($(esc(p))[2]), $(esc(p))[1] * sin($(esc(p))[2]))
    end
end

"""
    polar(r, theta)

Convert a point specified in polar form (radius and angle) to a Point.

```julia
julia> polar(10, pi/4)
Point(7.0710678118654755, 7.071067811865475)
```
"""
polar(r, theta) = Point(r * cos(theta), r * sin(theta))

"""
    intersectionlines(p0, p1, p2, p3;
        crossingonly=false)

Find the point where two lines intersect.

Return `(resultflag, resultip)`, where `resultflag` is a Boolean, and `resultip` is a Point.

If `crossingonly == true` the point of intersection must lie on both lines.

If `crossingonly == false` the point of intersection can be where the lines meet
if extended almost to 'infinity'.

Accordng to this function, collinear, overlapping, and parallel lines never
intersect. Ie, the line segments might be collinear but have no points in
common, or the lines segments might be collinear and have many points in
common, or the line segments might be collinear and one is entirely contained
within the other.

If the lines are collinear and share a point in common, that
is the intersection point.
"""
function intersectionlines(p0::Point, p1::Point, p2::Point, p3::Point;
    crossingonly = false)
    resultflag = false
    resultip = Point(0.0, 0.0)
    if p0 == p1 # no lines at all
    elseif p2 == p3
    elseif p0 == p2 && p1 == p3 # lines are the same
    elseif p0 == p3 && p1 == p2
    elseif p0 == p2 # common end points
        resultflag = true
        resultip = p0
    elseif p0 == p3
        resultflag = true
        resultip = p0
    elseif p1 == p2
        resultflag = true
        resultip = p1
    elseif p1 == p3
        resultflag = true
        resultip = p1
    else
        # Cramers rule
        a1 = p0.y - p1.y
        b1 = p1.x - p0.x
        c1 = p0.x * p1.y - p1.x * p0.y

        l1 = (a1, b1, -c1)

        a2 = p2.y - p3.y
        b2 = p3.x - p2.x
        c2 = p2.x * p3.y - p3.x * p2.y

        l2 = (a2, b2, -c2)

        d = l1[1] * l2[2] - l1[2] * l2[1]
        dx = l1[3] * l2[2] - l1[2] * l2[3]
        dy = l1[1] * l2[3] - l1[3] * l2[1]

        if !iszero(d)
            resultip = pt = Point(dx / d, dy / d)
            if crossingonly == true
                if ispointonline(resultip, p0, p1) && ispointonline(resultip, p2, p3)
                    resultflag = true
                else
                    resultflag = false
                end
            else
                if ispointonline(resultip, p0, p1, extended = true) &&
                   ispointonline(resultip, p2, p3, extended = true)
                    resultflag = true
                else
                    resultflag = false
                end
            end
        else
            resultflag = false
            resultip = Point(0, 0)
        end
    end
    return (resultflag, resultip)
end

"""
    pointinverse(A::Point, centerpoint::Point, rad)

Find `A′`, the inverse of a point A with respect to a circle `centerpoint`/`rad`, such that:

```julia
distance(centerpoint, A) * distance(centerpoint, A′) == rad^2
```

Return (true, A′) or (false, A).
"""
function pointinverse(A::Point, centerpoint, rad)
    A == centerpoint &&
        throw(error("pointinverse(): point $A and centerpoint $centerpoint are the same"))
    result = (false, A)
    n, C, pt2 = intersectionlinecircle(centerpoint, A, centerpoint, rad)
    if n > 0
        B = polar(rad, 0.7)                # arbitrary point on circle
        h = getnearestpointonline(B, C, A) # perp
        d = between(A, h, 2)               # reflection
        flag, A′ = intersectionlines(B, d, centerpoint, A, crossingonly = false)
        if flag == true
            result = (true, A′)
        end
    end
    return result
end

"""
    currentpoint()

Return the current point. This is the most recent point in the current path, as
defined by one of the path building functions such as `move()`, `line()`,
`curve()`, `arc()`, `rline()`, and `rmove()`.

To see if there is a current point, use `hascurrentpoint()`.
"""
function currentpoint()
    x, y = Cairo.get_current_point(_get_current_cr())
    return Point(x, y)
end

"""
    hascurrentpoint()

Return true if there is a current point. This is the most recent point in the
current path, as defined by one of the path building functions such as `move()`,
`line()`, `curve()`, `arc()`, `rline()`, and `rmove()`.

To obtain the current point, use `currentpoint()`.

There's no current point after `strokepath()` and `strokepath()` calls.
"""
function hascurrentpoint()
    return Cairo.has_current_point(_get_current_cr())
end

"""
    getworldposition(pt::Point = O;
        centered=true)

Return the world coordinates of `pt`.

The default coordinate system for Luxor drawings is that the top left corner is
0/0. If you use `origin()` (or the various `@-` macro shortcuts), everything
moves to the center of the drawing, and this function with the default
`centered` option assumes an `origin()` function. If you choose
`centered=false`, the returned coordinates will be relative to the top left
corner of the drawing.

```julia
origin()
translate(120, 120)
@show currentpoint()      # => Point(0.0, 0.0)
@show getworldposition()  # => Point(120.0, 120.0)
```
"""
function getworldposition(pt::Point = O;
    centered = true)
    x, y = cairotojuliamatrix(getmatrix()) * [pt.x, pt.y, 1]
    return Point(x, y) -
           (centered ? (Luxor._current_width() / 2.0, Luxor._current_height() / 2.0) : (0, 0))
end

"""
    anglethreepoints(p1::Point, p2::Point, p3::Point)

Find the angle formed by two lines defined by three points.

If the angle is less than π, the line heads to the left.
"""
function anglethreepoints(A::Point, B::Point, C::Point)
    v1 = B - A # line from A to B
    v2 = B - C
    d1 = sqrt(v1.x^2 + v1.y^2) # length v1
    d2 = sqrt(v2.x^2 + v2.y^2)
    if iszero(d1) || iszero(d2)
        return 0
    end
    result = dotproduct(v1, v2) / (d1 * d2)
    if -1 <= result <= 1
        # AB̂C is convex if (B − A)₉₀ · (C − B) < 0
        # v₉₀ is a vector rotated by 90° anti-clockwise
        convexity = dotproduct(-perpendicular(B - A), C - B)
        if convexity >= 0
            return acos(result)
        else
            return 2π - acos(result)
        end
    else
        return 0
    end
end

anglethreepoints(pgon) = anglethreepoints(pgon[1], pgon[2], pgon[3])

"""
    ispolyconvex(pts)

Return true if polygon is convex. This tests that every interior
angle is less than or equal to 180°.
"""
function ispolyconvex(pts)
    for n in eachindex(pts)
        angle = anglethreepoints(pts[n], pts[mod1(n + 1, end)], pts[mod1(n + 2, end)])
        if angle > π # angle > 180°
            return false
        end
    end
    return true
end

"""
    rotatepoint(targetpt::Point, originpt::Point, angle)

Rotate a target point around another point by an angle specified in radians.

Returns the new point.
"""
function rotatepoint(targetpt::Point, originpt::Point, angle)
    x1 = targetpt.x - originpt.x
    y1 = targetpt.y - originpt.y
    x2 = x1 * cos(angle) - y1 * sin(angle)
    y2 = x1 * sin(angle) + y1 * cos(angle)
    return Point(x2 + originpt.x, y2 + originpt.y)
end

"""
    rotatepoint(targetpt::Point, angle)

Rotate a target point around the current origin by an angle specified in radians.

Returns the new point.
"""
rotatepoint(targetpt::Point, angle) = rotatepoint(targetpt, O, angle)

"""
    ispointonleftofline(A::Point, B::Point, C::Point)

For a line passing through points A and B:

  - return true if point C is on the left of the line

  - return false if point C lies on the line
  - return false if point C is on the right of the line
"""
function ispointonleftofline(A::Point, B::Point, C::Point)
    z = ((B.x - A.x) * (C.y - A.y)) - ((B.y - A.y) * (C.x - A.x))
    if z > 10e-6
        return true
    elseif z < -10e-6
        return false
    else
        return false # point is on the line
    end
end

#!/usr/bin/env julia

using Luxor
using Test
using Random
Random.seed!(42)

function bezierarithmetic()
    bps = BezierPathSegment(ngon(O, 100, 4, vertices=true)...)
    @test length(bps) == 4
    @test Luxor.get_bezier_length(bps) ≈ 281.4703644162024
    @test Luxor.get_bezier_length(bps, steps=100) ≈ 282.8313796714682
    l, r = splitbezier(bps, 0.5)
    @test last(l) ≈ first(r)
    @test first(l) ≈ first(bps)
    @test last(r) ≈ last(bps)
end

function bezierpathtest(fname)
    Random.seed!(3)
    currentwidth = 1200
    currentheight = 1200
    Drawing(currentwidth, currentheight, fname)
    origin()
    background(setgray(0.8)...)
    tiles = Tiler(currentwidth, currentheight, 4, 4, margin=20)
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            pts = randompointarray(Point(-tiles.tilewidth/2, -tiles.tilewidth/2), Point(tiles.tilewidth/2, tiles.tilewidth/2), rand(3:5))
            setopacity(0.7)
            sethue("black")
            prettypoly(pts, :stroke, close=true)
            randomhue()
            drawbezierpath(makebezierpath(pts, smoothing=rand(0:0.1:1)), :fill)
        end
    end
    @test finish() == true
end

function pathtobezierpath(fname)
    Random.seed!(3)
    currentwidth = 800
    currentheight = 800
    Drawing(currentwidth, currentheight, fname)
    origin()
    background("white")
    st = "julia"
    setopacity(0.7)
    thefontsize = 200
    sethue("red")
    fontsize(thefontsize)
    move(Point(-350, 0))
    textpath(st)
    nbps = pathtobezierpaths()
    for nbp in nbps
        setline(.25)
        sethue("grey50")
        drawbezierpath(nbp, :stroke)
        # exaggerate position of Bezier control points
        for p in nbp
            sethue("magenta")
            exthandle1 = between(p[2], p[1], -3)
            exthandle2 = between(p[3], p[4], -3)
            circle(exthandle1, 1, :fill)
            circle(exthandle2, 1, :fill)
            line(p[1], exthandle1, :stroke)
            line(exthandle2, p[4], :stroke)
            if p[1] != p[4]
                sethue("black")
                circle(p[1], 1, :fill)
                circle(p[4], 1, :fill)
            end
        end
    end
    @test finish() == true
end

bezierarithmetic()

fname = "bezierpath.png"
bezierpathtest(fname)
println("...finished bezier tests 1: output in $(fname)")

fname = "pathtobezierpath.svg"
pathtobezierpath(fname)
println("...finished bezier tests 2: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function rule_test(fname)
    Drawing(2000, 2000, fname)
    origin()
    setline(0.15)

    for x in 10 .^ range(0, stop=3, length=200) # good bye logspace
        rule(Point(0 + x, 0), pi/2, boundingbox=BoundingBox() * x/9)
        rule(Point(0 - x, 0), pi/2, boundingbox=BoundingBox() * x/9)
        rotate(0.05)
    end
    for y in 10 .^ range(0, stop=3, length=200) # you served us well
        rule(Point(0, 0 + y), 0, boundingbox=BoundingBox() * y/9)
        rule(Point(0, 0 - y), 0, boundingbox=BoundingBox() * y/9)
        rotate(0.05)
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

rule_test("rules.pdf")

"""
    rect(xmin, ymin, w, h; action=:none)
    rect(xmin, ymin, w, h, action)

Create a rectangle with one corner at (`xmin`/`ymin`) with
width `w` and height `h`, and add it to the current path.
Then apply `action`.

Returns a tuple of two points, the corners of a bounding box
that encloses the rectangle.

See `box()` for more ways to do similar things, such as
supplying two opposite corners, placing by centerpoint and
dimensions.
"""
function rect(xmin::Real, ymin::Real, w::Real, h::Real;
        action = :none)
    if action ∉ [:path, :none]
        newpath()
    end
    Cairo.rectangle(_get_current_cr(), xmin, ymin, w, h)
    do_action(action)
    return Point(xmin, ymin), Point(xmin + w, ymin + h)
end

rect(xmin::Real, ymin::Real, w::Real, h::Real, action::Symbol) = rect(xmin, ymin, w, h, action = action)

"""
    rect(cornerpoint, w, h; action = none, reversepath=false,
        vertices=false)
    rect(cornerpoint, w, h, action; reversepath=false,
        vertices=false)

Create a rectangle with one corner at `cornerpoint` with
width `w` and height `h`, and add it to the current path.
Then apply `action`.

Use `vertices=true` to return an array of the four corner
points: bottom left, top left, top right, bottom right.

`reversepath` reverses the direction of the path (and
returns points in the order: bottom left, bottom right, top
right, top left).

Returns the four corner vertices.
"""
function rect(cornerpoint::Point, w::Real, h::Real;
        action = :none,
        reversepath = false,
        vertices = false)

    pts =  [
        Point(cornerpoint.x,     cornerpoint.y + h),
        Point(cornerpoint.x,     cornerpoint.y),
        Point(cornerpoint.x + w, cornerpoint.y),
        Point(cornerpoint.x + w, cornerpoint.y + h)
        ]
    if reversepath == true
        pts = pts[[1, 4, 3, 2]]
    end
    if vertices == false && action != :none
        move(pts[1])
        line(pts[2])
        line(pts[3])
        line(pts[4])
        closepath()
        do_action(action)
    end
    return pts
end

rect(cornerpoint::Point, w::Real, h::Real, action::Symbol;
        reversepath = false,
        vertices = false) = rect(cornerpoint, w, h;
                action = action,
                reversepath = reversepath,
                vertices = vertices)

"""
    box(cornerpoint1, cornerpoint2; action=:none, vertices=false, reversepath=false)
    box(cornerpoint1, cornerpoint2, action; vertices=false, reversepath=false)

Create a box (rectangle) between two points and add it to
the current path. Then apply `action`.

Use `vertices=true` to return an array of the four corner
points: bottom left, top left, top right, bottom right
rather than execute action.

`reversepath` reverses the direction of the path (and
returns points in the order: bottom left, bottom right, top
right, top left).
"""
function box(corner1::Point, corner2::Point;
        action::Symbol=:none,
        reversepath=false,
        vertices=false)
    # rearrange to get topleft -> bottom right
    # I'm not sure whether this is worth doing just
    # to get the order of vertices correct
    xmin, xmax = extrema((corner1.x, corner2.x))
    ymin, ymax = extrema((corner1.y, corner2.y))

    c1 = Point(xmin, ymin)
    c2 = Point(xmax, ymax)
    pts = [
        Point(c1.x, c2.y),
        Point(c1.x, c1.y),
        Point(c2.x, c1.y),
        Point(c2.x, c2.y)
        ]
    if reversepath == true
        pts = pts[[1, 4, 3, 2]]
    end
    if vertices == false && action != :none
        move(pts[1])
        line(pts[2])
        line(pts[3])
        line(pts[4])
        closepath()
        do_action(action)
    end
    return pts
end

box(corner1::Point, corner2::Point, action::Symbol;
        reversepath=false,
        vertices=false) = box(corner1, corner2;
                action=action,
                reversepath=reversepath,
                vertices=vertices)

"""
    box(points::Array; action=:none,
        reversepath=reversepath,
        vertices=vertices)
    box(points::Array; action=:none,
        reversepath=reversepath,
        vertices=vertices)

Create a box/rectangle using the first two points of an
array of Points to defined opposite corners, and add it to
the current path. Then apply `action`.

Use `vertices=true` to return an array of the four corner
points: bottom left, top left, top right, bottom right
rather than execute action.
"""
box(bbox::Array, action::Symbol; kwargs...) =
    box(bbox[1], bbox[2], action; kwargs...)

box(bbox::Array; kwargs...) =
    box(bbox[1], bbox[2]; kwargs...)

"""
    box(pt::Point, width, height; action=:none, vertices=false)
    box(pt::Point, width, height, action=:none; vertices=false)

Create a box/rectangle centered at point `pt` with width and
height. Use `vertices=true` to return an array of the four
corner points rather than apply the action.

`reversepath` reverses the direction of the path.
"""
function box(pt::Point, width, height;
        action = :none,
        reversepath = false,
        vertices = false)
    pts = [
        Point(pt.x - width/2, pt.y + height/2),
        Point(pt.x - width/2, pt.y - height/2),
        Point(pt.x + width/2, pt.y - height/2),
        Point(pt.x + width/2, pt.y + height/2)
        ]
    if reversepath == true
        pts = pts[[1, 4, 3, 2]]
    end
    if vertices == false && action != :none
        move(pts[1])
        line(pts[2])
        line(pts[3])
        line(pts[4])
        closepath()
        do_action(action)
    end
    return pts
end

box(pt::Point, width, height, action::Symbol;
        reversepath = false,
        vertices = false) = box(pt, width, height;
                action = action,
                reversepath = reversepath,
                vertices = vertices)

box(x::Real, y::Real, width::Real, height::Real, action::Symbol) =
    rect(x - width/2.0, y - height/2.0, width, height, action)

box(x::Real, y::Real, width::Real, height::Real; action::Symbol=:none) =
    rect(x - width/2.0, y - height/2.0, width, height, action)

"""
    box(pt, width, height, cornerradius, action=:none)
    box(pt, width, height, cornerradius; action=:none)

Draw a box/rectangle centered at point `pt` with `width` and `height` and
round each corner by `cornerradius`.

The constructed path consists of arcs and straight lines.
"""
box(centerpoint::Point, width, height, cornerradius::Real, action::Symbol) =
    box(centerpoint, width, height, fill(cornerradius, 4), action=action)

box(centerpoint::Point, width, height, cornerradius::Real; action=:none) =
    box(centerpoint, width, height, fill(cornerradius, 4), action=action)

"""
    box(pt, width, height, cornerradii::Array; action=:none)
    box(pt, width, height, cornerradii::Array, action=:none)

Draw a box/rectangle centered at point `pt` with `width` and `height` and
round each corner by the corresponding value in the array `cornerradii`.

The constructed path consists of arcs and straight lines.

The first corner is the one at the bottom left, the second at
the top left, and so on.

## Example

```julia
@draw begin
    box(O, 120, 120, [0, 20, 40, 60], :fill)
end
```
"""
function box(centerpoint::Point, width, height, cornerradii::Array;
        action=:none)
    gsave()
    translate(centerpoint)

    length(cornerradii) != 4 && throw(error("box() must have four values to specify rounded corners"))

    # bottom left
    p1start  = Point(O.x - width/2 + cornerradii[1], O.y + height/2)
    p1center = Point(O.x - width/2 + cornerradii[1], O.y + height/2 - cornerradii[1])
    p1end    = Point(O.x - width/2, O.y + height/2 - cornerradii[1])

    # top left
    p2start  = Point(O.x - width/2, O.y - height/2 + cornerradii[2])
    p2center = Point(O.x - width/2 + cornerradii[2], O.y - height/2 + cornerradii[2])
    p2end    = Point(O.x - width/2 + cornerradii[2], O.y - height/2)

    # top right
    p3start  = Point(O.x + width/2 - cornerradii[3], O.y - height/2)
    p3center = Point(O.x + width/2 - cornerradii[3], O.y - height/2 + cornerradii[3])
    p3end    = Point(O.x + width/2, O.y - height/2 + cornerradii[3])

    # bottom right
    p4start  = Point(O.x + width/2, O.y + height/2 - cornerradii[4])
    p4center = Point(O.x + width/2 - cornerradii[4], O.y + height/2 - cornerradii[4])
    p4end    = Point(O.x + width/2 - cornerradii[4], O.y + height/2)

    #  start at bottom center then bottomleft→topleft→topright→bottomright
    if action ∉ [:path, :none]
        newpath()
    end
    move(Point(O.x, O.y + height/2))

    line(p1start)
    arc(p1center, cornerradii[1], π/2, π, :none)
    line(p1end)

    line(p2start)
    arc(p2center, cornerradii[2], π, (3π)/2, :none)
    line(p2end)

    line(p3start)
    arc(p3center, cornerradii[3], 3π/2, 0, :none)
    line(p3end)

    line(p4start)
    arc(p4center, cornerradii[4], 0, π/2, :none)
    line(p4end)

    closepath()
    grestore()
    do_action(action)
    return Point(centerpoint.x - width/2, centerpoint.y - height/2),
           Point(centerpoint.x + width/2, centerpoint.y + height/2)
end

box(centerpoint::Point, width, height, cornerradii::Array, action::Symbol) =
     box(centerpoint::Point, width, height, cornerradii::Array, action=action)

"""
    ngon(x, y, radius, sides=5, orientation=0;
        action = :none,
        vertices = false,
        reversepath = false)

Draw a regular polygon centered at point `Point(x,y)`.
"""
function ngon(x::Real, y::Real, radius::Real, sides::Int=5, orientation=0.0;
            action=:none,
            vertices=false,
            reversepath=false)
    ptlist = [Point(x+cos(orientation + n * 2pi/sides) * radius,
                    y+sin(orientation + n * 2pi/sides) * radius) for n in 1:sides]
    if !vertices
        poly(ptlist, action=action, close=true, reversepath=reversepath)
    end
    if reversepath
        return reverse(ptlist)
    else
        return ptlist
    end
end

ngon(x::Real, y::Real, radius::Real, sides::Int, action::Symbol) =
    ngon(x, y, radius, sides, action=action, vertices=false, reversepath=false)

ngon(x::Real, y::Real, radius::Real, sides::Int, orientation::Real, action::Symbol) =
    ngon(x, y, radius, sides, orientation, action=action, vertices=false, reversepath=false)

# Point version
"""
    ngon(centerpos, radius, sides=5, orientation=0;
        action=:none,
        vertices=false,
        reversepath=false)

Draw a regular polygon centered at point `centerpos`.

Find the vertices of a regular n-sided polygon centered at `x`, `y` with
circumradius `radius`.

The polygon is constructed counterclockwise, starting with the first vertex
drawn below the positive x-axis.

If you just want the raw points, use keyword argument `vertices=true`, which
returns the array of points. Compare:

```julia
julia> ngon(0, 0, 4, 4, 0, vertices=true) # returns the polygon's points:
4-element Vector{Point}:
 Point(2.4492935982947064e-16, 4.0)
 Point(-4.0, 4.898587196589413e-16)
 Point(-7.347880794884119e-16, -4.0)
 Point(4.0, -9.797174393178826e-16)
```

whereas

```julia
ngon(0, 0, 4, 4, 0, :close) # draws a polygon
```
"""
ngon(centerpoint::Point, radius, sides::Int=5, orientation=0.0;
        action=:none, vertices=false, reversepath=false) = ngon(centerpoint.x, centerpoint.y, radius, sides, orientation,
        action=action, vertices=vertices, reversepath=reversepath)

# action as argument

# this is a bit untidy?
ngon(centerpoint::Point, radius::Real, sides::Int, orientation::Real, a::Symbol;
        action=:none, vertices=false, reversepath=false) = ngon(centerpoint, radius, sides, orientation,
        action=a, vertices=vertices, reversepath=reversepath)

"""
    ngonside(centerpoint::Point, sidelength::Real, sides::Int=5, orientation=0;
            action=:none,
            vertices=false,
            reversepath=false)
    ngonside(centerpoint::Point, sidelength::Real, sides::Int, orientation, action;
            vertices=false,
            reversepath=false)

Draw a regular polygon centered at `centerpoint` with `sides` sides of length `sidelength`.
"""
function ngonside(centerpoint::Point, sidelength::Real, sides::Int=5, orientation=0;
        action=:none,
        vertices=false,
        reversepath=false)
    radius = 0.5 * sidelength * csc(pi/sides)
    ngon(centerpoint, radius, sides, orientation, action=action,
        vertices=vertices,
        reversepath=reversepath)
end

ngonside(centerpoint::Point, sidelength::Real, sides::Int, orientation::Real, action::Symbol;
        vertices=false,
        reversepath=false) = ngonside(centerpoint, sidelength, sides, orientation, action=action,
        vertices=vertices, reversepath=reversepath)

ngonside(centerpoint::Point, sidelength::Real, sides::Int, action::Symbol;
        vertices=false,
        reversepath=false) = ngonside(centerpoint, sidelength, sides, action=action,
        vertices=vertices, reversepath=reversepath)

function star(x::Real, y::Real, radius::Real, npoints::Int=5, ratio::Real=0.5, orientation=0;
        action=:none,
        vertices = false,
        reversepath=false)
    outerpoints = [Point(x+cos(orientation + n * 2pi/npoints) * radius,
                         y+sin(orientation + n * 2pi/npoints) * radius) for n in 1:npoints]
    innerpoints = [Point(x+cos(orientation + (n + 1/2) * 2pi/npoints) * (radius * ratio),
                         y+sin(orientation + (n + 1/2) * 2pi/npoints) * (radius * ratio)) for n in 1:npoints]
    result = Point[]
    for i in eachindex(outerpoints)
        push!(result, outerpoints[i])
        push!(result, innerpoints[i])
    end
    if reversepath
        result = reverse(result)
    end
    if !vertices
        poly(result, action=action, close=true)
    end
    return result
end

"""
    star(center, radius, npoints, ratio=0.5, orientation, action=:none;
        vertices = false, reversepath=false)
    star(center, radius, npoints, ratio=0.5, orientation=0.0;
        action=:none, vertices = false, reversepath=false)

Make a star centered at `center` with `npoints` sections oriented by `orientation`.
`ratio` specifies the height of the smaller radius of the
star relative to the larger.

Returns the vertices of the star.

Use `vertices=true` to only return the vertices of a star
instead of making it.

## Examples

```julia
star(O, 120, 5, 0.5, 0.0, :fill,
    vertices = false,
    reversepath=false)
```

```julia
star(O, 220, 5, 0.5;
    action=:stroke,
    vertices = false,
    reversepath=false)
```
"""
function star(centerpoint::Point, radius::Real, npoints::Int=5, ratio::Real=0.5, orientation=0;
              action=:none,
              vertices=false,
              reversepath=false)
    star(centerpoint.x, centerpoint.y, radius, npoints, ratio, orientation, action=action,
         vertices = vertices, reversepath=reversepath)
end

star(x::Real, y::Real, radius::Real, npoints::Int, ratio::Real, orientation, a::Symbol;
    action=:none,
    vertices = false,
    reversepath=false) = star(Point(x, y), radius, npoints, ratio, orientation,
    action=a, vertices = vertices, reversepath=reversepath)

star(pt::Point, radius::Real, npoints::Int, ratio::Real, orientation, a::Symbol;
    action=:none,
    vertices = false,
    reversepath=false) = star(pt, radius, npoints, ratio, orientation,
    action=a, vertices = vertices, reversepath=reversepath)

"""
    cropmarks(center, width, height)

Draw cropmarks (also known as trim marks). Use current color.
"""
function cropmarks(center, width, height)
    gap = 5
    crop = 15
    gsave()
    setline(0.5)
    setdash("solid")
    # horizontal top left
    line(Point(-width/2 - gap - crop, -height/2),
         Point(-width/2 - gap, -height/2),
         :stroke)

    # horizontal bottom left
    line(Point(-width/2 - gap - crop, height/2),
         Point(-width/2 - gap, height/2),
         :stroke)

    # horizontal top right
    line(Point(width/2 + gap, -height/2),
         Point(width/2 + gap + crop, -height/2),
         :stroke)

    # horizontal bottom right
    line(Point(width/2 + gap, height/2),
         Point(width/2 + gap + crop, height/2),
         :stroke)

    # vertical top left
    line(Point(-width/2, -height/2 - gap - crop),
         Point(-width/2, -height/2 - gap),
         :stroke)

    # vertical bottom left
    line(Point(-width/2, height/2 + gap),
         Point(-width/2, height/2 + gap + crop),
         :stroke)

    # vertical top right
    line(Point(width/2, -height/2 - gap - crop),
         Point(width/2, -height/2 - gap),
         :stroke)

    # vertical bottom right
    line(Point(width/2, height/2 + gap),
         Point(width/2, height/2 + gap + crop),
         :stroke)

    grestore()
end

"""
    polycross(pt::Point, radius, npoints::Int, ratio=0.5, orientation=0.0;
        action      = :none,
        splay       = 0.5,
        vertices    = false,
        reversepath = false)
    polycross(pt::Point, radius, npoints::Int, ratio=0.5, orientation=0.0, action;
        splay       = 0.5,
        vertices    = false,
        reversepath = false)

Make a cross-shaped polygon with `npoints` arms to fit
inside a circle of radius `radius` centered at `pt`.

`ratio` specifies the ratio of the two sides of each arm.
`splay` makes the arms ... splayed.

Use `vertices=true` to return the vertices of the shape
instead of executing the action.

(Adapted from Compose.jl.xgon()))

## Examples

```julia
polycross(O, 100, 5,
    action = :fill,
    splay  = 0.5)
```

```julia
polycross(O, 120, 5, 0.5, 0.0, :stroke,
    splay  = 0.5)
```
"""
function polycross(pt::Point, radius::Real, npoints::Int, ratio=0.5, orientation=0.0;
        action      = :none,
        splay       = .5,
        vertices    = false,
        reversepath = false)
    # adapted from:    Compose.jl, https://github.com/GiovineItalia/Compose.jl/src/form.jl
    # original author: mattriks

    ratio = clamp(ratio, 0.0, 1.0)

    θ₁ = range(π/2 + orientation + 0, stop = π/2 + orientation + 2π, length = npoints + 1)[1:end-1]

    width = 2radius * ratio * sin(π/npoints)

    dₒ = asin(clamp(splay * width/radius, -1.0, 1.0))
    dᵢ = asin(0.5 * width/(radius * ratio))

    r₂ = repeat([radius * ratio, radius, radius], outer = npoints)
    θ₂ = vec([mod2pi(θ + x) for x in [-dᵢ, -dₒ, dₒ], θ in θ₁])

    pts = @. Point.(pt.x .+ r₂ .* cos.(θ₂), pt.y .+ r₂ .* sin.(θ₂))
    if reversepath
        reverse!(pts)
    end
    if !vertices
        poly(pts, action=action, close=true)
    end
    return pts
end

polycross(pt::Point, radius::Real, npoints::Int, ratio, orientation::Real, action::Symbol;
    splay       = .5,
    vertices    = false,
    reversepath = false) = polycross(pt, radius, npoints, ratio, orientation,
        action = action,
        splay       = splay,
        vertices    = vertices,
        reversepath = reversepath)

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_intersections(fname)
    Drawing(2000, 2000, fname)
    origin()
    sethue("black")
    setline(2)
    setopacity(0.95)

    tiles = Tiler(2000, 2000, 5, 5)

    for (pos, n) in tiles
        gsave()
        translate(pos)
        box(O, tiles.tilewidth, tiles.tileheight, :clip)
        p1 = Point(rand(-tiles.tilewidth/2:tiles.tilewidth/2), rand(-tiles.tileheight/2:tiles.tilewidth/2))
        p2 = Point(rand(-tiles.tilewidth/2:tiles.tilewidth/2), rand(-tiles.tileheight/2:tiles.tilewidth/2))
        p3 = Point(rand(-tiles.tilewidth/2:tiles.tilewidth/2), rand(-tiles.tileheight/2:tiles.tilewidth/2))
        map(pt -> circle(pt, 2, :fill), [p1, p2, p3])

        gsave()
        randomhue()
        rad = rand(20:tiles.tilewidth/3)
        circle(p2, rad, :fill)
        sethue("black")
        line(p1, p3, :stroke)

        sethue("green")
        setdash("dot")
        setline(0.5)
        line(between(p1, p3, -5), between(p1, p3, 5), :stroke)
        grestore()

        sethue("red")
        n, int1, int2 = intersectionlinecircle(p1, p3, p2, rad)
        if n == 1
            circle(int1, 10, :fill)
        elseif n == 2
            circle(int1, 10, :fill)
            circle(int2, 10, :fill)
        end
        sethue("black")
        text("$n intersection(s)")
        box(O, tiles.tilewidth, tiles.tileheight, :stroke)
        grestore()
    end
    l1 = Luxor.Point(-100.0, -100.0)
    l2 = Luxor.Point(300.0, 200.0)
    cpoint = Point(0, 0)
    @test intersectionlinecircle(l1, l2, cpoint, 15)[1] == 0
    @test intersectionlinecircle(l1, l2, cpoint, 20)[1] == 1
    @test intersectionlinecircle(l1, l2, cpoint, 25)[1] == 2
    @test finish() == true
end

test_intersections("intersection_line_circle_test.pdf")
println("...finished test: output in $(fname)")

"""
BezierPathSegment is an array of four points:

- `p1`  - start point
- `cp1` - control point for start point
- `cp2` - control point for finishpoint
- `p2`  - finish point
"""
mutable struct BezierPathSegment <: AbstractVector{Point}
    p1::Point
    cp1::Point
    cp2::Point
    p2::Point
end

Base.size(bps::BezierPathSegment) = (4,)
Base.length(bps::BezierPathSegment) = 4
Base.eltype(::Type{BezierPathSegment}) = Luxor.Point
Base.getindex(bps::BezierPathSegment, i::T) where {T<:Integer} = [bps.p1, bps.cp1, bps.cp2, bps.p2][i]
Base.setindex!(bps::BezierPathSegment, v, i::T) where {T<:Integer} = [bps.p1, bps.cp1, bps.cp2, bps.p2][i] = v
Base.IndexStyle(::Type{<:BezierPathSegment}) = IndexLinear()

# state is integer referring to one of the four points
function Base.iterate(bps::BezierPathSegment)
    return (bps.p1, 2)
end

function Base.iterate(bps::BezierPathSegment, s)
    if s > length(bps)
        return
    end
    return bps[s], s + 1
end

BezierPathSegment(a::Vector{Point}) =
    BezierPathSegment(a[1], a[2], a[3], a[4])

# function Base.show(io::IO, bps::BezierPathSegment)
#     println(io, "p1  $(bps.p1)  cp1 $(bps.cp1)")
#     println(io, "cp2  $(bps.cp2)  p2 $(bps.p2)")
# end

"""
BezierPath is an array of BezierPathSegments.
`segments` is `Vector{BezierPathSegment}`.
"""
mutable struct BezierPath <: AbstractVector{BezierPathSegment}
    segments::Vector{BezierPathSegment}
end

BezierPath(bps::BezierPathSegment) = BezierPath([bps])
BezierPath() = BezierPath(BezierPathSegment[])

Base.size(bp::BezierPath) = size(bp.segments)
Base.length(bp::BezierPath) = length(bp.segments)
Base.eltype(::Type{BezierPath}) = BezierPathSegment
Base.getindex(bp::BezierPath, i::T) where {T<:Integer} = bp.segments[i]
Base.setindex!(bp::BezierPath, v, i::T) where {T<:Integer} = bp.segments[i] = v
Base.IndexStyle(::Type{<:BezierPath}) = IndexLinear()

Base.push!(bp::BezierPath, v::BezierPathSegment) = Base.push!(bp.segments, v)

# Base.show(io::IO, bp::BezierPath) =
#     print(io, "BezierPath with $(length(bp.segments)) segments")

"""
    bezier(t, A::Point, A1::Point, B1::Point, B::Point)

Return the result of evaluating the Bézier cubic curve function, `t` going from
0 to 1, starting at A, finishing at B, control points A1 (controlling A), and B1
(controlling B).
"""
bezier(t, A::Point, A1::Point, B1::Point, B::Point) =
    A * (1.0 - t)^3 +
    (A1 * 3t * (1.0 - t)^2) +
    (B1 * 3t^2 * (1.0 - t)) +
    (B * t^3)

bezier(t, bps::BezierPathSegment) =
    bezier(t, bps.p1, bps.cp1, bps.cp1, bps.p2)

"""
    bezier′(t, A::Point, A1::Point, B1::Point, B::Point)

Return the first derivative of the Bézier function.
"""
bezier′(t, A, A1, B1, B) = 3(1.0 - t)^2 * (A1 - A) + 6(1.0 - t) * t * (B1 - A1) + 3t^2 * (B - B1)

bezier′(t, bps::BezierPathSegment) =
    bezier′(t, bps.p1, bps.cp1, bps.cp1, bps.p2)

"""
    bezier′′(t, A::Point, A1::Point, B1::Point, B::Point)

Return the second derivative of Bézier function.
"""
bezier′′(t, A, A1, B1, B) = 6(1 - t) * (B1 - 2A1 + A) + 6t * (B - 2B1 + A1)

bezier′′(t, bps::BezierPathSegment) =
    bezier′′(t, bps.p1, bps.cp1, bps.cp1, bps.p2)

"""
    beziercurvature(t, A::Point, A1::Point, B1::Point, B::Point)

Return the curvature of the Bézier curve at `t` in [0, 1], given start and end
points A and B, and control points A1 and B1. The value (kappa) will typically
be a value between -0.001 and 0.001 for points with coordinates in the 100-500
range.

``κ(t)`` is the curvature of the curve at point t, which for a parametric planar
curve is:

```math
\\begin{equation}
κ = \\frac{\\left| ẋ ÿ - ẏ ẍ \\right|}{(ẋ^2 + ẏ^2)^{\\frac{3}{2}}}
\\end{equation}
```

The radius of curvature, or the radius of an osculating circle at a point, is
1/κ(t). Values of 1/κ will typically be in the range -1000 to 1000 for points
with coordinates in the 100-500 range.

TODO Fix overshoot...

...The value of kappa can sometimes collapse near 0, returning NaN (and Inf for
radius of curvature).
"""
function beziercurvature(t, A::Point, A1::Point, B1::Point, B::Point)
    x′ = bezier′(t, A, A1, B1, B).x
    y′ = bezier′(t, A, A1, B1, B).y
    x′′ = bezier′′(t, A, A1, B1, B).x
    y′′ = bezier′′(t, A, A1, B1, B).y
    return ((x′ * y′′) - (y′ * x′′)) / (x′^2 + y′^2)^(3 / 2)
end

beziercurvature(t, bps::BezierPathSegment) =
    beziercurvature(t, bps.p1, bps.cp1, bps.cp1, bps.p2)

"""
    findbeziercontrolpoints(
        previouspt::Point,
        pt1::Point,
        pt2::Point,
        nextpt::Point;
            smoothing = 0.5)

Find the Bézier control points for the line between `pt1` and `pt2`, where the
point before `pt1` is `previouspt` and the next point after `pt2` is `nextpt`.
"""
function findbeziercontrolpoints(
    previouspt::Point,
    point1::Point,
    point2::Point,
    nextpt::Point;
    smoothing = 0.5)
    xc1 = (previouspt.x + point1.x) / 2.0
    yc1 = (previouspt.y + point1.y) / 2.0
    xc2 = (point1.x + point2.x) / 2.0
    yc2 = (point1.y + point2.y) / 2.0
    xc3 = (point2.x + nextpt.x) / 2.0
    yc3 = (point2.y + nextpt.y) / 2.0

    l1, l2, l3 = distance(previouspt, point1), distance(point2, point1), distance(nextpt, point2)
    k1 = l1 / (l1 + l2)
    k2 = l2 / (l2 + l3)
    xm1 = xc1 + (xc2 - xc1) * k1
    ym1 = yc1 + (yc2 - yc1) * k1
    xm2 = xc2 + (xc3 - xc2) * k2
    ym2 = yc2 + (yc3 - yc2) * k2
    c1x = xm1 + (xc2 - xm1) * smoothing + point1.x - xm1
    c1y = ym1 + (yc2 - ym1) * smoothing + point1.y - ym1
    c2x = xm2 + (xc2 - xm2) * smoothing + point2.x - xm2
    c2y = ym2 + (yc2 - ym2) * smoothing + point2.y - ym2
    return (Point(c1x, c1y), Point(c2x, c2y))
end

"""
    makebezierpath(pgon::Vector{Point};
        smoothing=1.0)

Return a Bézier path (a BezierPath) that represents a polygon (an array of points).
The Bézier path is an array of segments (tuples of 4 points); each segment
contains the four points that make up a section of the entire Bézier path.

`smoothing` determines how closely the curve follows the
polygon. A value of 0 returns a straight-sided path; as
values move above 1 the paths deviate further from the
original polygon's edges.
"""
function makebezierpath(pgon::Vector{Point};
    smoothing = 1.0)
    lpg = length(pgon)
    newpath = BezierPath()
    for i in 1:lpg
        cp1, cp2 = findbeziercontrolpoints(
            pgon[mod1(i - 1, lpg)],
            pgon[mod1(i, lpg)],
            pgon[mod1(i + 1, lpg)],
            pgon[mod1(i + 2, lpg)], smoothing = smoothing)
        push!(newpath, BezierPathSegment(pgon[mod1(i, lpg)], cp1, cp2, pgon[mod1(i + 1, lpg)]))
    end
    return newpath
end

"""
    drawbezierpath(bezierpath::BezierPath, action=:none;
        close=true)
    drawbezierpath(bezierpath::BezierPath;
        action=:none,
        close=true)

Draw the Bézier path, and apply the action, such as `:none`, `:stroke`, `:fill`,
etc. By default the path is closed.

TODO Return something more useful than a Boolean.
"""
function drawbezierpath(bezierpath::BezierPath, action;
    close = true)
    move(bezierpath[1].p1)
    for i in 1:(length(bezierpath) - 1)
        c = bezierpath[i]
        curve(c.cp1, c.cp2, c.p2)
    end
    if close == true
        c = bezierpath[end]
        curve(c.cp1, c.cp2, c.p2)
    end
    do_action(action)
end

drawbezierpath(bezierpath; action = :none, close = true) =
    drawbezierpath(bezierpath, action; close = close)

"""
    drawbezierpath(bps::BezierPathSegment;
        action=:none,
        close=false)

Draw the Bézier path segment, and apply the action, such as `:none`, `:stroke`,
`:fill`, etc. By default the path is open.

TODO Return something more useful than a Boolean.
"""
function drawbezierpath(bps::BezierPathSegment;
    action = :none,
    close = false)
    move(bps.p1)
    curve(bps.cp1, bps.cp2, bps.p2)
    if close == true
        closepath()
    end
    do_action(action)
end

# allow drawbezierpath(bps, :stroke)
drawbezierpath(bps::BezierPathSegment, action::Symbol; close = true) =
    drawbezierpath(bps, action = action, close = close)

drawbezierpath(bpsa::Vector{BezierPathSegment}, action = :none) =
    foreach(b -> drawbezierpath(b, action), bpsa)

"""
    beziertopoly(bpseg::BezierPathSegment;
        steps=10)

Convert a BezierPathsegment to a polygon (an array of points).
"""
function beziertopoly(bpseg::BezierPathSegment;
    steps = 10)
    thepolygon = Point[]
    anchor1, control1, control2, anchor2 = bpseg.p1, bpseg.cp1, bpseg.cp2, bpseg.p2
    dx1 = control1.x - anchor1.x
    dy1 = control1.y - anchor1.y
    dx2 = control2.x - control1.x
    dy2 = control2.y - control1.y
    dx3 = anchor2.x - control2.x
    dy3 = anchor2.y - control2.y

    ss1 = 1.0 / (steps + 1)
    ss2 = ss1 * ss1
    ss3 = ss2 * ss1

    p1 = 3.0 * ss1
    p2 = 3.0 * ss2
    p4 = 6.0 * ss2
    p5 = 6.0 * ss3

    t1x = anchor1.x - control1.x * 2.0 + control2.x
    t1y = anchor1.y - control1.y * 2.0 + control2.y

    t2x = (control1.x - control2.x) * 3.0 - anchor1.x + anchor2.x
    t2y = (control1.y - control2.y) * 3.0 - anchor1.y + anchor2.y

    fx = anchor1.x
    fy = anchor1.y

    dfx = (control1.x - anchor1.x) * p1 + t1x * p2 + t2x * ss3
    dfy = (control1.y - anchor1.y) * p1 + t1y * p2 + t2y * ss3

    d2fx = t1x * p4 + t2x * p5
    d2fy = t1y * p4 + t2y * p5
    d3fx = t2x * p5
    d3fy = t2y * p5

    n = steps
    push!(thepolygon, Point(anchor1.x, anchor1.y))
    while n > 0
        fx   += dfx
        fy   += dfy
        dfx  += d2fx
        dfy  += d2fy
        d2fx += d3fx
        d2fy += d3fy
        push!(thepolygon, Point(fx, fy))
        n -= 1
    end
    # should we add the last point? no, do that downstream if required:
    # push!(thepolygon, Point(x4, y4))
    return thepolygon
end

"""
    bezierpathtopoly(bezierpath::BezierPath;
        steps=10)

Convert a Bézier path (an array of BezierPathSegments, where each is a
tuple of four points: anchor1, control1, control2, anchor2), to a polygon.

To make a Bézier path, use `makebezierpath()` on a polygon.

The `steps` optional keyword determines how many straight
line sections are used for each path.
"""
function bezierpathtopoly(bezierpath::BezierPath;
    steps = 10)
    resultpoly = Point[]
    for bp in bezierpath
        p = beziertopoly(bp, steps = steps)
        append!(resultpoly, p)
    end
    if resultpoly[1] == resultpoly[end]
        pop!(resultpoly)
    end
    return resultpoly
end

"""
    pathtobezierpaths(
        ; flat=true)

Convert the current Cairo path (which may consist of one or more paths) to an array of
Bézier paths, each of which is an array of BezierPathSegments. Each path
segment is a tuple of four points. A straight line is converted to a Bézier segment
in which the control points are set to be the same as the end points.

If `flat` is true, use `getpathflat()` rather than `getpath()`.

# Example

This code draws the BezierPathSegments and shows the control points as "handles", like
a vector-editing program might.

```julia
@svg begin
    fontface("MyanmarMN-Bold")
    st = "goo"
    thefontsize = 100
    fontsize(thefontsize)
    sethue("red")
    fontsize(thefontsize)
    textpath(st)
    nbps = pathtobezierpaths()
    for nbp in nbps
        setline(.15)
        sethue("grey50")
        drawbezierpath(nbp, :stroke)
        for p in nbp
            sethue("red")
            circle(p[2], 0.16, :fill)
            circle(p[3], 0.16, :fill)
            line(p[2], p[1], :stroke)
            line(p[3], p[4], :stroke)
            if p[1] != p[4]
                sethue("black")
                circle(p[1], 0.26, :fill)
                circle(p[4], 0.26, :fill)
            end
        end
    end
end
```
"""
function pathtobezierpaths(;
    flat = true)
    flat ? (originalpath = getpath()) : (originalpath = getpathflat())
    # to store all the Bezier paths
    result = BezierPath[]
    # to store one Bezier path
    newbezpath = BezierPath()
    # to store a Bezier segment
    currentpos = Point(0, 0)
    if length(originalpath) > 0
        for e in originalpath
            if e.element_type == Cairo.CAIRO_PATH_MOVE_TO                # 0
                currentpos = Point(e.points[1], e.points[2])
            elseif e.element_type == Cairo.CAIRO_PATH_LINE_TO            # 1
                # add a straight line segment in the form of a bezsegment
                bezsegment = BezierPathSegment(currentpos,
                    currentpos,
                    Point(e.points[1], e.points[2]),
                    Point(e.points[1], e.points[2]))
                push!(newbezpath, bezsegment)
                currentpos = Point(e.points[1], e.points[2])
            elseif e.element_type == Cairo.CAIRO_PATH_CURVE_TO           # 2
                bezsegment = BezierPathSegment(currentpos,
                    Point(e.points[1], e.points[2]),
                    Point(e.points[3], e.points[4]),
                    Point(e.points[5], e.points[6]))
                currentpos = Point(e.points[5], e.points[6])
                push!(newbezpath, bezsegment)
            elseif e.element_type == Cairo.CAIRO_PATH_CLOSE_PATH         # 3
                # finish this path and store it away
                if length(newbezpath) > 0
                    push!(result, newbezpath)
                end
                # make new path
                newbezpath = BezierPath()
            else
                error("unknown CairoPathEntry " * repr(e.element_type))
                error("unknown CairoPathEntry " * repr(e.points))
            end
        end
        # tidy up, not everything gets closed
        if length(newbezpath) > 0
            push!(result, newbezpath)
        end
    end
    return result
end

# More Bezier madness

function _solvexy(a, b, c, d, e, f)
    # solve linear equation ai + bj = c and di + ej = f
    j = (c - a / d * f) / (b - a * e / d)
    i = (c - (b * j)) / a
    return i, j
end

# basis functions
_b0(t) = (1 - t)^3
_b1(t) = t * (1 - t) * (1 - t) * 3
_b2(t) = (1 - t) * t * t * 3
_b3(t) = (t^3)

"""
    bezierfrompoints(startpoint::Point,
        pointonline1::Point,
        pointonline2::Point,
        endpoint::Point)

Given four points, return the Bézier curve that passes through all four points,
starting at `startpoint` and ending at `endpoint`. The two middle points of the
returned BezierPathSegment are the two control points that make the curve pass
through the two middle points supplied.
"""
function bezierfrompoints(startpoint::Point,
    pointonline1::Point,
    pointonline2::Point,
    endpoint::Point)
    # chord lengths
    c1 = sqrt((pointonline1.x - startpoint.x) * (pointonline1.x - startpoint.x) + (pointonline1.y - startpoint.y) * (pointonline1.y - startpoint.y))
    c2 = sqrt((pointonline2.x - pointonline1.x) * (pointonline2.x - pointonline1.x) + (pointonline2.y - pointonline1.y) * (pointonline2.y - pointonline1.y))
    c3 = sqrt((endpoint.x - pointonline2.x) * (endpoint.x - pointonline2.x) + (endpoint.y - pointonline2.y) * (endpoint.y - pointonline2.y))
    # best guess for t
    t1 = c1 / (c1 + c2 + c3)
    t2 = (c1 + c2) / (c1 + c2 + c3)
    (x1, x2) = _solvexy(_b1(t1), _b2(t1), pointonline1.x - (startpoint.x * _b0(t1)) - (endpoint.x * _b3(t1)), _b1(t2), _b2(t2), pointonline2.x - (startpoint.x * _b0(t2)) - (endpoint.x * _b3(t2)))
    (y1, y2) = _solvexy(_b1(t1), _b2(t1), pointonline1.y - (startpoint.y * _b0(t1)) - (endpoint.y * _b3(t1)), _b1(t2), _b2(t2), pointonline2.y - (startpoint.y * _b0(t2)) - (endpoint.y * _b3(t2)))
    return BezierPathSegment(startpoint, Point(x1, y1), Point(x2, y2), endpoint)
end

"""
    bezierfrompoints(ptslist::Vector{Point})

Given four points, return the Bézier curve that passes through all four points.
"""
bezierfrompoints(ptslist::Vector{Point}) = bezierfrompoints(ptslist...)

"""
    bezierstroke(point1, point2, width=0.0)

Return a BezierPath, a stroked version of a straight line between two points.

It wil have 2 or 6 Bezier path segments that define a brush or pen shape. If
width is 0, the brush shape starts and ends at a point. Otherwise the brush shape
starts and ends with the thick end.

To draw it, use eg `drawbezierpath(..., :fill)`.
"""
function bezierstroke(p1::Point, p2::Point, width = 0.0)
    bezpath = BezierPath()
    if isapprox(width, 0.0)
        # simple wavy stroke starting ending at point
        push!(bezpath, BezierPathSegment(p1, p1, p2, p2))
        push!(bezpath, BezierPathSegment(p2, p2, p1, p1))
        result = setbezierhandles.(bezpath, angles = [0.1, -0.1], handles = [0.3, 0.3])
    else
        # stroke with broad opening and closing
        # make the paths, then give them some control power
        cp1 = perpendicular(p1, p2, -width)
        seg = BezierPathSegment(p1, p1, cp1, cp1)
        adjustedseg = setbezierhandles(seg, angles = [0.1, -0.1], handles = [0.3, 0.3])
        push!(bezpath, adjustedseg)

        cp2 = perpendicular(p2, p1, width)
        seg = BezierPathSegment(cp1, cp1, cp2, cp2)
        adjustedseg = setbezierhandles(seg, angles = [0.1, -0.1], handles = [0.3, 0.3])
        push!(bezpath, adjustedseg)

        seg = BezierPathSegment(cp2, cp2, p2, p2)
        adjustedseg = setbezierhandles(seg, angles = [0.1, -0.1], handles = [0.3, 0.3])
        push!(bezpath, adjustedseg)

        # TODO the segments should be collinear, perhaps?
        cp3 = perpendicular(p2, p1, -width)
        seg = BezierPathSegment(p2, p2, cp3, cp3)
        adjustedseg = setbezierhandles(seg, angles = [0.1, -0.1], handles = [0.3, 0.3])
        push!(bezpath, adjustedseg)

        cp4 = perpendicular(p1, p2, width)
        seg = BezierPathSegment(cp3, cp3, cp4, cp4)
        adjustedseg = setbezierhandles(seg, angles = [0.1, -0.1], handles = [0.3, 0.3])
        push!(bezpath, adjustedseg)

        seg = BezierPathSegment(cp4, cp4, p1, p1)
        adjustedseg = setbezierhandles(seg, angles = [0.1, -0.1], handles = [0.3, 0.3])
        push!(bezpath, adjustedseg)
        result = bezpath
    end
    return result
end

"""
    setbezierhandles(bps::BezierPathSegment;
            angles  = [0.05, -0.1],
            handles = [0.3, 0.3])

Return a new BezierPathSegment with new locations for the Bezier control
points in the BezierPathSegment `bps`.

`angles` are the two angles that the "handles" make with the line direciton.

`handles` are the lengths of the "handles". 0.3 is a typical value.
"""
function setbezierhandles(bps::BezierPathSegment;
    angles = [0.05, -0.1],
    handles = [0.3, 0.3])
    d = distance(bps[1], bps[4])
    s = slope(bps[1], bps[4])
    bezhandle1 = bps[1] + polar(d * handles[1], s - angles[1])
    s = slope(bps[4], bps[1])
    bezhandle2 = bps[4] + polar(d * handles[2], s + angles[2])
    return BezierPathSegment(bps[1], bezhandle1, bezhandle2, bps[4])
end

"""
    setbezierhandles(bezpath::BezierPath;
        angles=[0 .05, -0.1],
        handles=[0.3, 0.3])

Return a new BezierPath with new locations for the Bézier control points in
every Bézier path segment of the BezierPath in `bezpath`.

`angles` are the two angles that the "handles" make with the line direciton.

`handles` are the lengths of the "handles". 0.3 is a typical value.
"""
function setbezierhandles(bezpath::BezierPath;
    angles = [0.05, -0.1],
    handles = [0.4, 0.4])
    newbezpath = BezierPath()
    for bps in bezpath
        push!(newbezpath, setbezierhandles(bps, angles = angles, handles = handles))
    end
    return newbezpath
end

"""
    shiftbezierhandles(bps::BezierPathSegment;
        angles=[0.1, -0.1],
        handles=[1.1, 1.1])

Return a new BezierPathSegment that modifies the Bézier path in `bps` by moving
the control handles. The values in `angles` increase the angle of the handles;
the values in `handles` modifies the lengths: 1 preserves the length, 0.5 halves
the length of the  handles, 2 doubles them.
"""
function shiftbezierhandles(bps::BezierPathSegment;
    angles  = [0.1, -0.1],
    handles = [0.1, 0.1])
    p1, cp1, cp2, p2 = bps
    # find slope of curve at the end points
    spt1 = bezier′(0.0, p1, cp1, cp2, p2)
    spt2 = bezier′(1.0, p1, cp1, cp2, p2)
    # angle of handle to curve
    s1 = slope(p1, cp1)
    s2 = slope(p2, cp2)
    # length of handles
    l1 = distance(p1, cp1)
    l2 = distance(p2, cp2)
    # new angle
    s1 += angles[1]
    s2 += angles[2]
    # new handle lengths
    l1 = l1 * handles[1]
    l2 = l2 * handles[2]
    newcontrolpoint1 = p1 + polar(l1, s1)
    newcontrolpoint2 = p2 + polar(l2, s2)
    return BezierPathSegment(p1, newcontrolpoint1, newcontrolpoint2, p2)
end

"""
    brush(pt1, pt2, width=10;
        strokes=10,
        minwidth=0.01,
        maxwidth=0.03,
        twist = -1,
        lowhandle  = 0.3,
        highhandle = 0.7,
        randomopacity = true,
        tidystart = false,
        action = :fill,
        strokefunction = (nbpb) -> nbpb))

Draw a composite brush stroke made up of some randomized individual filled
Bezier paths.

`strokefunction` allows a function to process a BezierPathSegment or do other things before it's drawn.

!!! note

    There is a lot of randomness in this function. Results are unpredictable.
"""
function brush(pt1, pt2, width = 10;
    strokes = 10,
    minwidth = 0.01,
    maxwidth = 0.03,
    twist = -1,
    lowhandle = 0.3,
    highhandle = 0.7,
    randomopacity = true,
    tidystart = false,
    action = :fill,
    strokefunction = (nbpb) -> nbpb)
    @layer begin
        sl = slope(pt1, pt2)
        n = distance(pt1, pt2)
        translate(pt1)
        rotate(sl - pi / 2)
        widthsteps = (maxwidth - minwidth) / 10
        for j in 1:strokes
            shiftedline = [O + (0, 0), O + (0, n)]
            if tidystart
                shiftedline .+= Point(rand((-width/2):(width/2)), 0)
            else
                shiftedline .+= Point(rand((-width/2):(width/2)), rand((-width/2):(width/2)))
            end
            pbp = bezierstroke(shiftedline[1],
                shiftedline[2],
                rand(Bool) ? 0.0 : rand(minwidth:widthsteps:maxwidth),
            )
            for bps in pbp
                randomopacity ? setopacity(rand(0.3:0.1:0.9)) : setopacity(1.0)
                nbpb = shiftbezierhandles(bps,
                    angles  = [twist * rand(minwidth:widthsteps:maxwidth), -twist * rand(minwidth:widthsteps:maxwidth)],
                    handles = [rand(lowhandle:0.01:highhandle, 2)...],
                )
                strokefunction(nbpb)
                drawbezierpath(nbpb, action, close = false)
            end
        end
    end
end

"""
    beziersegmentangles(pt1, pt2;
        out = deg2rad(45),
        in  = deg2rad(135),
        l   = 100)

Return a BezierPathSegment joining `pt1` and `pt2` making
the angles `out` at the start and `in` at the end.

It's similar to the tikZ `(a) to [out=135, in=45] (b)`
drawing instruction (but in radians obviously).

`out` is the angle that a line from `pt1` to the outgoing
Bézier handle makes with the horizontal. `in` is the angle
that a line joining `pt2` from the preceding Bézier handle
makes with the horizontal.

The function finds the interesction point of two lines with
the two angles and constructs a BezierPathSegment that fits.

See also the `bezierfrompoints()` function that makes a
BezierPathSegment that passes through four points.

### Example

```julia
drawbezierpath(beziersegmentangles(O, O + (100, 0),
    out = deg2rad(45),
    in  = 2π - deg2rad(45)),
    :stroke)
```
"""
function beziersegmentangles(pt1, pt2;
    out = deg2rad(45),
    in  = deg2rad(135))
    # find intersection of the tangents
    tangent1 = (pt1, pt1 + polar(1, out)) # arbitrary length "ray" :(
    tangent2 = (pt2, pt2 + polar(1, in))
    flag, ip = intersectionlines(tangent1..., tangent2...)
    if flag
        bp = BezierPathSegment(pt1, ip, ip, pt2)
    else
        cpt1 = pt1 + polar(1, out)
        cpt2 = pt2 + polar(1, in)
        bp = BezierPathSegment(pt1, cpt1, cpt2, pt2)
    end
    return bp
end

"""
    splitbezier(bps::BezierPathSegment, t)

Split the Bezier path segment at t, where t is between 0 and 1.

Use Paul de Casteljaus' algorithm (the man who really
introduced Bezier curves...).

Returns a tuple of two BezierPathSegments, the 'lower' one
(0 to `t`) followed by the 'higher' one (`t` to 1).

## Example

```julia-repl
julia> bps = BezierPathSegment(ngon(O, 200, 4, vertices=true)...)
4-element BezierPathSegment:
 Point(1.2246467991473532e-14, 200.0)
 Point(-200.0, 2.4492935982947064e-14)
 Point(-3.6739403974420595e-14, -200.0)
 Point(200.0, -4.898587196589413e-14)

julia> l, h = splitbezier(bps::BezierPathSegment, 0.5)
(Point[Point(1.2246467991473532e-14, 200.0), Point(-100.0, 100.00000000000001), Point(-100.0, 1.4210854715202004e-14), Point(-50.00000000000001, -49.99999999999999)], Point[Point(-50.00000000000001, -49.99999999999999), Point(-1.4210854715202004e-14, -100.0), Point(99.99999999999999, -100.00000000000003), Point(200.0, -4.898587196589413e-14)])

julia> h
4-element BezierPathSegment:
 Point(-50.00000000000001, -49.99999999999999)
 Point(-1.4210854715202004e-14, -100.0)
 Point(99.99999999999999, -100.00000000000003)
 Point(200.0, -4.898587196589413e-14)

julia> l.p2 == h.p1
true
```
"""
function splitbezier(bps::BezierPathSegment, t)
    p1, cp1, cp2, p2 = bps.p1, bps.cp1, bps.cp2, bps.p2
    icp1 = (1.0 - t)p1 + (t * cp1)
    M = (1.0 - t)cp1 + (t * cp2) # unused center point
    icp4 = (1.0 - t)cp2 + (t * p2)
    icp2 = (1.0 - t)icp1 + (t * M)
    icp3 = (1.0 - t)M + (t * icp4)
    mp = (1.0 - t)icp2 + (t * icp3)
    return (BezierPathSegment(p1, icp1, icp2, mp), BezierPathSegment(mp, icp3, icp4, p2))
end

"""
    trimbezier(bps::BezierPathSegment, lowpt, highpt)

Chop the ends of a BezierPathSegment at `lowpt` and
`highpt`. `lowpt` and `highpt` should be between 0 and 1.

Returns a trimmed BezierPathSegment.
"""
function trimbezier(bps::BezierPathSegment, lowpt, highpt)
    if lowpt > highpt
        lowpt, highpt = highpt, lowpt
    end
    _, highptbezier = splitbezier(bps, lowpt)
    centerbezier, _ = splitbezier(highptbezier, highpt)
    return centerbezier
end

"""
    bezigon(corners::Vector{Point}, sides;
        close = false,
        action = :none))

Construct a bezigon, a path made of Bezier curves.

`corners` is an array of points, the corners of the bezigon, eg this triangle:

```julia
[Point(0, 0), Point(50, 50), Point(100, 0)]
```

`sides` is an array of arrays of points, where each array contains two control
points, eg:

```julia
sides = [
    [Point(-10, -20), Point(40, -120)], # control points for first side
    [Point(120, -120), Point(180, -20)],
]
```

The first pair of `sides` (two points) are control points, which combine with
the first two points in corners to define a Bezier curve. And so on for the next pair.

Returns a path.
"""
function bezigon(pts::Vector{Point}, sides;
        close = false,
        action = :none)
    if isempty(sides)
        sides = [[O, O]]
    end
    move(pts[1])
    for i in 1:length(pts)
        if i <= length(sides)
            cp1 = sides[mod1(i, end)][1]
            cp2 = sides[mod1(i, end)][2]
        else
            cp1 = pts[mod1(i, end)]
            cp2 = pts[mod1(i + 1, end)]
        end
        all(x -> x isa Point, [cp1, cp2]) && curve(cp1, cp2, pts[mod1(i + 1, end)])
    end
    if close
        closepath()
    end
    path = storepath()
    do_action(action)
    return path
end

bezigon(pts::Vector{Point}, sides, the_action::Symbol; close::Bool=false) = begin
    bezigon(pts, sides, action = the_action, close = close)
end

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_boxes(fname)
    pagewidth, pageheight = 1200, 1400

    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("ivory")
    setopacity(0.5)
    gsave()
    t = Tiler(1000, 1000, 20, 20)
    for (pos, n) in t
        randomhue()
        box(pos, rand(5:50), rand(5:50), rand(5:55), :fillpreserve)
        randomhue()
        rotate(2pi * rand())
        strokepath()
    end

    grestore()

    sethue("black") # hide
    setline(4)
    # round corners with different radii
    box(O, 200, 150, collect(range(5, 20, step=4)), :stroke)

    for (pos, n) in t
        randomhue()

        polysmooth(box(O, 200, 150, vertices=true), 10, :stroke)

        box(pos, rand(5:50), rand(5:50), rand(5:15), :path)
        randomhue()
        strokepath()
        p = pathtopoly()
        for pl in p
            prettypoly(pl, :fill, () -> circle(O, 5, :stroke))
        end
    end

    @test finish() == true
    println("...finished boxtest, saved in $(fname)")
end

fname = "box-test.png"
test_boxes(fname)

using Luxor, Test

@draw begin
    # initially O
    @test currentpoint() == Point(0.0, 0.0)
    @test hascurrentpoint() == false
    move(Point(30, 30))
    @test currentpoint() == Point(30.0, 30.0)
    @test hascurrentpoint() == true
    line(Point(50, -50))
    @test currentpoint() == Point(50.0, -50.0)
    closepath()
    @test hascurrentpoint() == true
    newpath()
    @test hascurrentpoint() == false
    @test currentpoint() == Point(0.0, 0.0)
end
println("...finished currentpoint tests")

#!/usr/bin/env julia

using Luxor, Test

using Random
Random.seed!(42)

@testset "General tests" begin
    pt1 = Point(rand() * 4, rand() * 4)

    # number - Point (#270)
    @test Point(10, 10) .- Point(1, 1) == Point(10 - 1, 10 - 1) == Point(9, 9) == -Point(1, 1) .+ Point(10, 10)
    @test Point(1, 1) .- Point(10, 10) == Point(1 - 10, 1 - 10) == Point(1, 1) .+ Point(-10, -10) == -Point(10, 10) .+ Point(1, 1)

    # arithmetic with tuples
    @test pt1 + (5, 8) == Point(pt1.x + 5, pt1.y + 8)
    @test pt1 * (5, 8) == Point(pt1.x * 5, pt1.y * 8)
    @test pt1 - (5, 8) == Point(pt1.x - 5, pt1.y - 8)
    @test pt1 / (5, 8) == Point(pt1.x / 5, pt1.y / 8)

    @test -pt1 == Point(-pt1.x, -pt1.y)

    # constructor with tuple
    @test Point((1, 2)) == Point(1, 2)
    @test [Point(3, 1), Point(4.0, 1.0), Point(2//3,3//4)] == Point.([(3.0, 1.0), (4, 1), (2//3,3//4)])

    # origin point with Base.zero
    @test zero(Point) == zero(Point(1,2)) == O
    @test zeros(Point, 5) == fill(O, 5)
    @test iszero(O)
    @test !iszero(Point(1,2))

    # is point/4 inside a box
    # a: we now have to wrap arguments with Ref() to ensure they  broadcast as scalar
    @test isinside(Ref(pt1) ./ 4, box(O, 10, 10, vertices=true))

    # b: but we defined Point as broadcastable, so we shouldn't need that
    @test isinside(pt1 ./ 4, box(O, 10, 10, vertices=true))

    # is point not in every corner of box
    @test all(Point(1, 1) .< box(O, 10, 10, vertices=true)) == false
    @test any(Point(0, 0) .< [Point(1, 1), Point(1, 2), Point(2, 3)]) == true
    # is point outside every corner of box
    @test all(Ref(Point(10, 10))  .> box(O, 10, 10, vertices=true)) == true

    # ? do these need Ref()?
    @test all(.>=(Point(5, 5),  Point(5, 5)))
    @test all(.>=(Point(5, 5),  Point(5, 5)))

    @test perpendicular(Point(10, 5)) == Point(5.0, -10.0)
    @test perpendicular(Point(-10, -5)) == Point(-5.0,10.0)

    @test crossproduct(Point(2, 3), Point(3, 2)) == -5.0
    @test crossproduct(Point(-20, 30), Point(60, 20)) < 2000

    @test pointlinedistance(Point(1, 1), Point(0, 0), Point(2, 0)) == 1
    @test pointlinedistance(Point(1, 1), Point(2, 0), Point(3, 0)) == 1
    @test pointlinedistance(Point(-1, -1), Point(1, -3), Point(1, 3)) == 2
    
    # shared end points
    # intersection of (A == C) || (B == C) || (A == D) || (B == D)
    pt1 = Point(5, 5)
    pt2 = Point(6, 5)
    @test pt1 + pt2 == Point(11.0,10.0)
    @test intersectionlines(pt1, pt1, pt1, pt1)[1] == false
    @test intersectionlines(pt1, pt2, pt1, pt2, crossingonly=true)[1] == false
    @test intersectionlines(pt1, pt2, pt2, pt1)[1] == false
    pt3 = Point(6, 6)
    pt4 = Point(5, 6)
    @test intersectionlines(pt1, pt2, pt3, pt4)[1] == false

    @test intersectionlines(pt1, pt2, pt3, pt2) == (true,Luxor.Point(6.0,5.0))

    # not crossing
    pt1 = Point(5, 5)
    pt2 = Point(5, 5)
    pt3 = Point(5, 5)
    pt4 = Point(5, 5)
    @test intersectionlines(shuffle([pt1, pt2, pt3, pt4])...)[1] == false

    # parallel
    pt1 = Point(5, 5)
    pt2 = Point(5, 6)
    pt3 = Point(6, 5)
    pt4 = Point(6, 6)
    @test intersectionlines(pt1, pt2, pt3, pt4)[1] == false

    # Now `pt .^ 2` etc. are now allowed.
    @test Point(Tuple(pt1) .* Tuple(pt2)) == Point(25.0, 30.0)
    @test Point(Tuple(pt1) .^ 2) == Point(25.0, 25.0)
    @test Point(Tuple(pt1) .^ 3) == Point(125.0,125.0)

    @test all(Point(Tuple(pt1) .^ 1.5) < Point(Tuple(pt1) .^ 1.6))
    @test all(Point(Tuple(pt1) .^ 1.6) > Point(Tuple(pt1) .^ 1.5))

    # test between interpolation
    @test isequal(midpoint(pt1, pt3), between(pt1, pt3, 0.5))
    @test isequal(between(pt1, pt3, 0.0), pt1)
    @test isequal(between(pt1, pt3, 1.0), pt3)

    # test uniqueness and those pesky -0.0s
    @test length(unique([pt1, pt2, pt3, pt4])) == 4
    @test length(unique([pt1, pt2, pt3, pt3])) == 3
    @test length(unique([pt1, pt3, pt3, pt3])) == 2
    @test length(unique([pt3, pt3, pt3, pt3])) == 1
    @test length(unique([])) == 0
    @test length(unique([Point(0.0, 0.0), Point(0.0, 0.0)])) == 1
    @test length(unique([Point(0.0, -0.0), Point(0.0, 0.0)])) == 1
    @test length(unique([Point(0.0, -0.0), Point(-0.0, 0.0)])) == 1
    @test length(unique([Point(0.0, -0.0), Point(-0.0, -0.0)])) == 1
    @test length(unique([Point(0.0, 0.0), Point(0, 0)])) == 1
    @test length(unique([Point(0, 0), Point(-0, -0)])) == 1

    # test drop perpendicular
    p1 = Point(0, 0)
    p2 = Point(0, 50)
    @test perpendicular(p1, p2, 10) == Luxor.Point(-10.0, 0.0)
    @test perpendicular(p1, p2, 20) == Luxor.Point(-20.0, 0.0)

    # test pointinverse
    p1 = Point(10, 10)
    cpt = O
    rad = 50
    flag, antipoint = pointinverse(p1, cpt, rad)
    @test flag == true
    @test isapprox(antipoint, Point(125, 125))

    p2 = Point(20, 0.0)
    flag, antipoint = pointinverse(p2, cpt, rad)
    @test flag == true
    @test isapprox(antipoint.y, 0.0)

    # point shouldn't be centerpoint
    @test_throws ErrorException pointinverse(cpt, cpt, rad)
end

@testset "point_arithmetic_test" begin
    fname = "point-arithmetic.pdf"
    npoints = 100

    Drawing(1200, 1200, fname)
    background("white")
    sethue("thistle")
    box(BoundingBox(), :stroke)
    scale(0.5, 0.5)
    setline(2.5)
    setopacity(0.5)
    fontsize(8)
    origin()
    randompoints = randompointarray(Point(-600, -600), Point(600, 600), npoints)

    # +
    pl1 = map(pt -> pt + Point(2,2), randompoints)
    pl1a = map(pt -> Point(2,2) + pt, randompoints)

    # -
    pl2 = map(pt -> pt - Point(2,2), randompoints)
    pl2a = map(pt -> Point(2,2) - pt, randompoints)

    # *
    pl3 = map(pt -> pt * rand(), randompoints)
    pl3a = map(pt -> rand() * pt, randompoints)

    # /
    pl4 = map(pt -> pt / rand(), randompoints)

    # .*
    pl5 = 1.012 .* randompoints
    pl5a = randompoints .* 1.012
    pl5b = [1.03, 0.97, -1.05] .* randompoints[1:3]

    # ./
    pl6 = randompoints[1:3] ./ [1.03, 0.97, -1.05]
    pl6a =  [1.03, 0.97, -1.05] .* randompoints[1:3]

    # ^
    pl7 = map(pt -> Point(.^(Tuple(pt/2), 2)), randompoints)

    # ^ FAILS
    # pl8 = map(pt -> ^(pt, 1.2), randompoints)


    # issue #20615 now fixed in v0.6
    sethue("red")
    for p in zip(pl1, pl1a, pl2, pl2a, pl3, pl3a, pl4, pl5, pl5a, pl5b, pl6, pl6a, pl7)
       map(pt -> circle(pt, 3, :fill), p)
       poly(collect(p), :stroke)
    end

    # comparisons
    testfunctions = [isequal, isless, <, >, ==]
    sethue("green")
    for f in testfunctions
        for i in 1:length(randompoints)-1
            if f(randompoints[i], randompoints[i+1])
                circle(randompoints[i], 18, :fill)
                circle(randompoints[i+1], 7, :fill)
                text(string("$f"), randompoints[i] - Point(12, 12))
            end
        end
    end

    testfunctions = [<, >, >=, <=]
    sethue("orange")
    for f in testfunctions
        for i in 1:length(randompoints)-1
            if f.(randompoints[1:npoints], randompoints[npoints:-1:1]) != true
                ellipse(randompoints[i], 19, 32, :fill)
                text(string("v6"), randompoints[i] - Point(6, 6))
            end
        end
    end

    sethue("purple")
    for i in 1:length(randompoints)-1
        v = cmp(randompoints[i], randompoints[i+1])
        text(string(round(v, digits=1)), randompoints[i] + Point(15, 15))
    end

    sethue("cyan")
    for i in 1:length(randompoints)-1
        n = distance(randompoints[i], randompoints[i+1])
        text(string(round(n, digits=1)), randompoints[i])
    end

    sethue("magenta")
    map(pt -> circle(pt, 6, :stroke), [midpoint(randompoints), randompoints[1], randompoints[2]])

    if all(randompoints .== randompoints)
        text("the points compare elementwise")
    else
        error("elementwise comparison failed")
    end

    if any(randompoints .!= randompoints)
        error("elementwise comparison failed")
    else
        text("the points really do compare elementwise", O + Point(15, 15))
    end

    @test finish() == true

    println("...finished test: output in $(fname)")
end

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_ellipse(fname)
    pagewidth, pageheight = 1200, 1400
    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("ivory")
    setopacity(0.5)
    setline(0.3)

    @test_throws ErrorException Partition(0, pageheight, 200, 200)
    @test_throws ErrorException Partition(pagewidth, 0, 200, 200)

    pagetiles = Partition(pagewidth, pageheight, 200, 200)
    for (pos, n) in pagetiles
        randomhue()
        ellipse(pos, rand(50:pagetiles.tilewidth), rand(50:pagetiles.tileheight), :strokepreserve)
        clip()
        for i in 1:10
            ellipse(pos, rand(50:pagetiles.tilewidth), rand(50:pagetiles.tileheight), :fill)
            randomhue()
            ellipse(pos, Point(pos.x + rand(50:pagetiles.tilewidth), pos.y), rand(50:pagetiles.tileheight), :stroke)
        end
        setline(1)
        sethue("black")
        fillstroke()
        ellipse(pos, 5, 5, :fill)
        clipreset()
        # test three point version
        circle.((pos - (50, 0), pos + (50, 0), pos + (0, 2n)), 4, :fill)
        ellipse(pos - (50, 0), pos + (50, 0), pos + (0, 2n), :stroke)
    end


    # test ellipseinquad
    pg = ngon(O, 250, 6, π/6, vertices=true)

    top = vcat(O, pg[[3, 4, 5]])
    left = vcat(O, pg[[1, 2, 3]])
    right = vcat(O, pg[[5, 6, 1]])

    for (n, side) in enumerate((top, left, right))
        sethue([Luxor.julia_green, Luxor.julia_red, Luxor.julia_purple, Luxor.julia_blue][n])
        poly(side, :path, reversepath=true, close=true)
        results = ellipseinquad(polyscale!(side, 0.5, center = polycentroid(side)), :fill)
        @test results[1] != O
        @test !iszero(results[2])
        @test !iszero(results[3])
        @test !iszero(results[4])
    end

    @test finish() == true
end

fname = "ellipse-test1.png"
test_ellipse(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor
using Test

using Random
Random.seed!(42)

function drawctrlpoints(bezpath, r)
    @layer begin
        for seg in bezpath
            circle.(seg, r, :fill)
        end
    end
end

function bezpathtopolytest(fname)

    ng = ngon(O, 300, 5, vertices=true)

    bprough = makebezierpath(ng, smoothing=0.5)
    bpsmooth = makebezierpath(ng, smoothing=0.25)

    @test length(bprough) == 5
    @test typeof(bprough[1][1]) == Luxor.Point

    @test length(bpsmooth) == 5
    @test typeof(bpsmooth[1][1]) == Luxor.Point

    p1 = bezierpathtopoly(bprough)
    p2 = bezierpathtopoly(bpsmooth)

    @test length(p1) == 55
    @test typeof(p1[1]) == Luxor.Point
    @test length(p2) == 55
    @test typeof(p2[1]) == Luxor.Point

    Random.seed!(3)
    setline(0.01)
    currentwidth = 800
    currentheight = 800
    Drawing(currentwidth, currentheight, fname)
    origin()
    background("white")
    setopacity(0.5)

    # draw original polygon
    sethue("purple")
    prettypoly(ng, :stroke, close=true, () -> circle(O, 26, :fill))

    # draw the rough (non-smoothed) bezierpath
    sethue("green")
    drawctrlpoints(bprough, 15)
    drawbezierpath(bprough, :stroke)

    # draw the smoother bezierpath
    sethue("blue")
    drawctrlpoints(bpsmooth, 10)
    drawbezierpath(bpsmooth, :stroke)

    sethue("orange")
    prettypoly(p1, :stroke, () -> circle(O, 6, :fill))

    @test 254257 < polyarea(p1) < 254258
    @test 234992 < polyarea(p2) < 234993
    @test 213987 < polyarea(ng) < 213988

    @test finish() == true

end

fname = "bezpathtopolytest.svg"
bezpathtopolytest(fname)

println("...finished bezier path conversion tests: output in $(fname)")

#!/usr/bin/env julia -

using Luxor

using Test

function svgstring_test()
    @testset "svg string test" begin
        Drawing(400, 800, :svg)
        origin()
        juliacircles()
        @test finish() == true
        svgsource = svgstring()
        matches = collect(eachmatch(r"<.*?>", svgsource))
        @test first(matches).match == """<?xml version="1.0" encoding="UTF-8"?>"""
        @test last(matches).match == "</svg>"
    end
    println("...finished svgstring_test")
end

function place_svgtest(fnamein, fnameout)
    svgin = readsvg(fnamein)
    @testset "readsvg" begin
        @test svgin.xpos == 400
        @test svgin.ypos == 400
        @test svgin.width == 400
        @test svgin.height == 400
    end
    @testset "placeimage" begin
        Drawing(400, 800, fnameout)
        origin()
        background("green")
        placeimage(svgin, O, centered = true)
        @test finish() == true
        svgin2 = readsvg(fnameout)
        @test svgin2.xpos == 400
        @test svgin2.ypos == 800
        @test svgin2.width == 400
        @test svgin2.height == 800
    end
    println("...finished test: output in $(fnameout)")
end

function svg_rec_format()
    # Checking for specific expectations when using recordings (:rec) and svg snapshots.
    # These tests are especially intended to help in case cairo changes the svg elements
    # which are used to tweak the result by function _adjust_background_rects(buffer) in drawings.jl
    Drawing(NaN, NaN, :rec)
    background("deepskyblue2")
    setcolor("grey")
    rect(-140,-140,280,280, :fill)
    setcolor("black")
    circle(O, 100, :stroke)
    circle(O, 100, :clip)
    background("magenta")
    # now doing what
    #   snapshot(;fname="test.svg",cb=BoundingBox(Point(-150,-150),Point(150,150)))
    # does without the _adjust_background_rects(buffer) tweak
    fname="test.svg"
    cb=BoundingBox(Point(-150,-150),Point(150,150))
    scalefactor = 1.0
    rd = currentdrawing()
    rs = Luxor._current_surface()
    Luxor.Cairo.flush(rs)
    rma = getmatrix()
    rmai = juliatocairomatrix(cairotojuliamatrix(rma)^-1)
    rtlxu, rtlyu = boxtopleft(cb)
    rtlxd, rtlyd, _ = cairotojuliamatrix(rma) * [rtlxu, rtlyu, 1]
    x, y = -rtlxd, -rtlyd
    nw = Float64(round(scalefactor * boxwidth(cb)))
    nh = Float64(round(scalefactor * boxheight(cb)))
    nm = scalefactor.* [rmai[1], rmai[2], rmai[3], rmai[4], 0.0, 0.0]
    nd = Drawing(round(nw), round(nh), fname)
    setmatrix(nm)
    Luxor.set_source(nd.cr, rs, x, y)
    paint()
    # now doing what
    #   finish()
    # does without the _adjust_background_rects(buffer) tweak
    Luxor.Cairo.finish(Luxor._current_surface())
    Luxor.Cairo.destroy(Luxor._current_surface())
    
    #= pre Julia v1.11
    buffer=copy(Luxor._current_bufferdata())
    currentdrawing(rd)
    #Luxor._current_drawing()[Luxor._current_drawing_index()] = rd
    finish()

    testsvg=String(buffer)
    =#

    # Julia v1.11 and up
    seekstart(Luxor._current_buffer())
    buffer=copy(Luxor._current_buffer())
    currentdrawing(rd)
    finish()
    testsvg=read(buffer, String)

    # check if the SVG contains lines like
    #   <use xlink:href="#surface31" transform="matrix(1,0,0,1,150,150)"/>
    # or
    #   <use href="#surface31" transform="matrix(1,0,0,1,150,150)"/>
    # after </defs>
    m=match(r"</defs\s*?>(.*)$"is,testsvg)
    @test length(m.captures) == 1
    if length(m.captures) == 1
        testsvg_part=m[1]
        m=match(r"<use[^>]*?(xlink:)*?href=\"#(.*?)\"[^>]*?transform=\"matrix\((.+?),(.+?),(.+?),(.+?),(.+?),(.+?)\)\"/>"is,testsvg_part)
        @test !isnothing(m) && length(m.captures) == 8
        id=m[2]
        # check if the SVG contains line like
        #   <g id="surface31" clip-path="url(#clip1)">
        m=match(Regex("<g\\s+?[^>]*?id=\"($(id))\".*?>","is"),testsvg)
        @test !isnothing(m) && m[1] == id
        # check if <g id="$id">...</g> is extracted correct
        group="<g id=\"other\"></g><g id=\""*id*"\"><g><g></g></g><g></g></g><g id=\"other\"></g>"
        (head,mid,tail,split_ok)=Luxor._split_string_into_head_mid_tail(group,id)
        @test split_ok == true
        @test head == "<g id=\"other\"></g>"
        @test mid == "<g id=\""*id*"\"><g><g></g></g><g></g></g>"
        @test tail == "<g id=\"other\"></g>"
        # _split_string_into_head_mid_tail(group,id) needs to be robust
        # do nothing if split fails
        group="</g><g id=\"other\"></g><g id=\""*id*"\"><g><g></g></g>"
        (head,mid,tail,split_ok)=Luxor._split_string_into_head_mid_tail(group,id)
        @test split_ok == false
        group="</g></g><g><g id=\""*id*"\">"
        (head,mid,tail,split_ok)=Luxor._split_string_into_head_mid_tail(group,id)
        @test split_ok == false
        group="<g><g id=\"other\"></g></g>"
        (head,mid,tail,split_ok)=Luxor._split_string_into_head_mid_tail(group,id)
        @test split_ok == false
        group="<g><g><g id=\""*id*"\"></g></g>"
        (head,mid,tail,split_ok)=Luxor._split_string_into_head_mid_tail(group,id)
        @test split_ok == false
    end
    return
end

svgstring_test()
place_svgtest("polysample.svg", "place-svg.svg")
svg_rec_format()

#!/usr/bin/env julia

using Luxor

using Test

using Random

Random.seed!(42)

function get_png_files()
    folder = dirname(dirname(pathof(Luxor))) * "/docs/src/assets/figures/"
    imagelist = filter(f -> !startswith(f, ".") && endswith(f, "png"), readdir(folder))
    imagepathlist = map(fn -> folder * "/" * fn, imagelist)
    return imagepathlist
end

function addimagetile(imgfile, xcenter, ycenter, tilewidth, tileheight; cropping=true)
    gsave()
    box(xcenter, ycenter, tilewidth, tileheight, :clip)
    img = readpng(imgfile)
    w = img.width
    h = img.height
    if cropping == true
        # expand image to fill tile
        if w < h
            scalefactor = max(tilewidth, tileheight)/w
        else
            scalefactor = max(tilewidth, tileheight)/h
        end
    else
        # shrink image to fit inside tile
        if w > h
            scalefactor = min(tilewidth, tileheight)/w
        else
            scalefactor = min(tilewidth, tileheight)/h
        end
    end
    translate(xcenter, ycenter)
    scale(scalefactor, scalefactor)
    placeimage(img, O, centered=true)
    clipreset()
    grestore()
end


imagelist = get_png_files()

shuffle!(imagelist)

width, height = 1600, 1000
fname = "tiled-images.png"
Drawing(width, height, fname)
origin()
background("grey50")
setopacity(0.5)
pagetiles = Tiler(width, height, 8, 8, margin=50)
for (pos, n) in pagetiles
  if n > length(imagelist) # run out of images
    break
  end
  addimagetile(imagelist[n], pos.x, pos.y, pagetiles.tilewidth, pagetiles.tileheight, cropping=true)
end
@test finish() == true
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function hipster(fname)
    Drawing(400, 350, fname) # hide
    origin() # hide

    # test text on poly
    pts = squircle(O, 150, 150, rt = 0.7, vertices=true)
    fontsize(13.6)
    sethue("white")
    textonpoly("Hipster Logo • " ^ 11, pts)
    
    rotate(pi/8)

    circle(O, 135, :clip)
    sethue("antiquewhite2")
    paint()

    sethue("gray20")
    setline(3)
    circle(O, 130, :stroke)
    circle(O, 135, :stroke)
    circle(O, 125, :fill)

    sethue("antiquewhite2")
    circle(O, 85, :fill)

    sethue("wheat")
    fontsize(24)
    fontface("Helvetica-Bold")
    # Try both synonyms (long live the Queen, and UK spelling!)
    textcurvecentered("• LUXOR •", (3pi)/2, 100, O, clockwise=true, baselineshift = -4)
    textcurvecentred("• VECTOR GRAPHICS •", pi/2, 100, O, clockwise=false, letter_spacing=2, baselineshift = -15)

    sethue("gray20")
    map(pt -> star(pt, 40, 3, 0.5, -pi/2, :fill), ngon(O, 40, 3, 0, vertices=true))
    circle(O.x + 30, O.y - 55, 15, :fill)

    sethue("antiquewhite2")
    setline(0.2)
    setdash("dotdotdashed")
    for i in 1:500
        line(randompoint(Point(-200, -350), Point(200, 350)),
             randompoint(Point(-200, -350), Point(200, 350)),
             :stroke)
    end
    @test finish() == true
end

fname = "text-curve-centered.png"
hipster(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Random

Random.seed!(42)

using Test

function test_circular_arrows_1(pos)
    gsave()
    froma = rescale(rand(1:100), 1, 100, 0, 2pi)
    toa =   rescale(rand(1:100), (1, 100), (0, 2pi))
    sethue("black")
    arrow(pos, 100, froma, toa, linewidth=rand(1:6), arrowheadlength=rand(10:30))
    text(string("from: ", round(rad2deg(froma), digits=1)), pos)
    text(string("to: ", round(rad2deg(toa), digits=1)), pos.x, pos.y+10)
    sethue("magenta")
    arrow(pos, 100, toa, froma; linewidth=rand(1:6), arrowheadlength=rand(10:30))
    text(string("from: ", round(rad2deg(toa), digits=1)), pos.x, pos.y+20)
    text(string("to: ", round(rad2deg(froma), digits=1)), pos.x, pos.y+30)
    grestore()
end

function test_circular_arrows_2(pos, w)
  sethue("black")
  for a in 50:10:w
    randomhue()
    starta = rand(0:pi/12:2pi)
    finisha = rand(0:pi/12:2pi)
    arrow(pos, a, starta, finisha, linewidth=rand(1:6), arrowheadlength=rand(1:20))
  end
end

function arrow_arc_test(fname)
  pagewidth, pageheight = 2000, 2000
  Drawing(pagewidth, pageheight, fname)
  origin() # move 0/0 to center
  background(1, 1, 0.9, 1)
  setopacity(0.5)
  setline(2)
  pagetiles = Tiler(pagewidth, pageheight, 4, 4, margin=50)
  for (pos, n) in pagetiles
    if isodd(n)
      test_circular_arrows_1(pos)
    else
      test_circular_arrows_2(pos, pagetiles.tilewidth/2)
    end
  end

  # test Bezier arrow
  setopacity(1.0)
  sethue("red")
  arrow(pagetiles[1][1], pagetiles[3][1], pagetiles[6][1], pagetiles[7][1],
    linewidth=5,
    arrowheadlength=50,
    arrowheadfill = false,
    arrowheadangle=π/4,
    startarrow=true)

  @test finish() == true
  println("...finished arrow-test: saved in $(fname)")
end

fname = "arrow-arctest.png"
arrow_arc_test(fname)

#!/usr/bin/env julia

using Luxor

using Test

using Colors

using Random
Random.seed!(42)

function draw_color_bars(x, y, n, colmap, label)
    setcolor(1, 1, 1)
    fontsize(8)

    number_of_colours = n
    text(label, x, y - 10)

    tilesize = (currentheight - 40 * 2) / number_of_colours

    for c in colmap
        setcolor(c)
        rect(x, y, tilesize, tilesize, :fill)
        setcolor((1, 1, 1))
        text("$(c.r), $(c.g), $(c.b)", x + tilesize + 5, y + tilesize/2)
        y +=tilesize
    end
end


function palette_test(fname)
    global currentwidth = 1000 # pts
    global currentheight = 1000 # pts
    Drawing(currentwidth, currentheight, fname)

    # background
    setcolor("grey50")
    rect(0,0,currentwidth, currentheight, :fill)

    # sequential_palette(h, [N::Int=100; c=0.88, s=0.6, b=0.75, w=0.15, d=0.0, wcolor=RGB(1,1,0), dcolor=RGB(0,0,1), logscale=false])
    # diverging_palette(h1, h2 [, N::Int=100; mid=0.5,c=0.88, s=0.6, b=0.75, w=0.15, d1=0.0, d2=0.0, wcolor=RGB(1,1,0), dcolor1=RGB(1,0,0), dcolor2=RGB(0,0,1), logscale=false])
    # colormap(cname::AbstractString [, N::Int=100; mid=0.5, logscale=false, kvs...])

    draw_color_bars(20, 20, 50, diverging_palette(0, 360, 50, mid=0.1), "diverging 0 360 mid 0.1")
    draw_color_bars(120, 20, 50, sequential_palette(0, 50), "sequential 0 #50")
    draw_color_bars(220, 20, 50, sequential_palette(128, 50), "sequential 128 #50")
    draw_color_bars(320, 20, 50, sequential_palette(200, 50), "sequential 200 #50")
    draw_color_bars(420, 20, 50, diverging_palette(120, 140, 50, mid=0.1), "diverging 120 140 #50 ")
    draw_color_bars(520, 20, 50, distinguishable_colors(50), "distinguishable")
    draw_color_bars(620,  20, 50, diverging_palette(120, 140, 50, b=1.0), "diverging 120 140 b 0.5")
    draw_color_bars(720,  20, 50, diverging_palette(120, 140, 50, mid=1.0), "diverging 120 140 mid 1.0")

    @test finish() == true
    println("...finished test: output in $(fname)")
end

palette_test("color-palette.pdf")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function poly_fit(fname)
    currentwidth = 2400 # pts
    currentheight = 2400 # pts
    Drawing(currentwidth, currentheight, fname)

    origin()
    background("white")

    fontsize(20)
    setopacity(0.7)
    tiles = Tiler(2400, 2400, 5, 5, margin=20)
    setline(1)
    for (pos, n) in tiles
        @layer  begin
            translate(pos)
            randomhue()
            box(O, -tiles.tilewidth, tiles.tilewidth, :fill)
            pts = [Point(x, rand(-tiles.tilewidth/3:tiles.tilewidth/3)) for x in -tiles.tileheight/2:30:tiles.tileheight/2]
            begin
                for (i, pt) in enumerate(pts)
                    sethue("red")
                    circle(pt, 6, :fill)
                    sethue("black")
                    text(string(i), pt)
                end
            end
            poly(polyfit(pts, rand(30:130)), :stroke)
        end
    end
    @test finish() == true
end

fname = "polyfit.pdf"
poly_fit(fname)

using Test
using Random
using Luxor
using Aqua

Random.seed!(42)

ENV["JULIA_DEBUG"] = Main

function run_all_tests()

    Aqua.test_all(Luxor)

    @testset "Basics" begin
        include("basic-test.jl")
    end

    @testset "multiple drawings" begin
        include("multi-draw.jl")
    end

    @testset "animation (Unix only)" begin
        if ! Sys.iswindows()
            include("animation-test.jl")
        end
        include("easingfunctions.jl")
    end

    @testset "despatch methds" begin
        include("action-testing.jl")
    end

    @testset "polygons" begin
        include("boxtests.jl")
        include("offset-poly-tests.jl")
        include("path-to-poly.jl")
        include("point-arithmetic.jl")
        include("point-inside-polygon.jl")
        include("point-on-polygon.jl")
        include("point-intersection.jl")
        include("polycross-test.jl")
        include("polyfit-test.jl")
        include("polybspline-test.jl")
        include("polysample.jl")
        include("polygon-centroid-sort-test.jl")
        include("polygon-test.jl")
        include("polysplit.jl")
        include("polysplit-2.jl")
        include("polysmooth-tests.jl")
        include("polysidelengths-test.jl")
        include("pretty-poly-test.jl")
        include("simplify-polygons.jl")
        include("spirals.jl")
        include("star-test-1.jl")
        include("star-test.jl")
        include("test-holes.jl")
        include("morepolytests.jl")
        include("polytriangulate.jl")
        include("pointcircletangent-test.jl")
        include("convexandclockwise.jl")
        include("various-points-tests.jl")
        include("polyhull-test.jl")
        include("polymorph-test.jl")
        include("polysuper-test.jl")
    end

    @testset "text" begin
        include("text-alignment.jl")
        include("text-rotations.jl")
        include("pro-text-test.jl")
        include("text-curve-centered.jl")
        include("text-path-clipping.jl")
        include("text-wrapping.jl")
        include("text-boxes.jl")
        include("label-tests.jl")
        include("textfit-tests.jl")
        include("textformat.jl")
    end

    @testset "curves" begin
        include("arc-twopoints.jl")
        include("circletests.jl")
        include("circleintersectiontests.jl")
        include("circle-as-path.jl")
        include("randomsinecurves.jl")
        include("sector-test.jl")
        include("sector-rounded.jl")
        include("ellipse-test.jl")
        include("hypertrochoid-test.jl")
        include("epitrochoid-test.jl")
        include("pie-test.jl")
        include("bezierpath.jl")
        include("bezierpathtopoly.jl")
        include("bezierstroke-test.jl")
        include("circletangent-test.jl")
        include("arc-sagitta-test.jl")
        include("circlecircletangent-test.jl")
        include("crescent-test.jl")
        include("round-corner-test.jl")
    end

    @testset "color" begin
        include("color-blend-test.jl")
        include("blendmodes.jl")
        include("palette_test.jl")
        include("meshtest.jl")
    end

    @testset "images" begin
        include("images-with-alpha.jl")
        include("test-image.jl")
#        include("tiling-images.jl")
        include("test-snapshot.jl")
    end

    @testset "imagematrix" begin
        include("imagematrix.jl")
        include("imagematrix2.jl")
    end

    @testset "arrows and dimensions" begin
        include("arrow-arc-test.jl")
        include("arrow-bezier-test.jl")
        include("arrow-line-test.jl")
        include("dimensioning.jl")
    end

    @testset "paths" begin
        include("get_path.jl")
        include("get_path_flat.jl")
        include("paths.jl")
    end

    @testset "julia logos" begin
        include("heart-julia.jl")
        include("julia-logo-draw-eps.jl")
        include("julia-logo-draw.jl")
        include("julia-logo-testing.jl")
    end

    @testset "rulers" begin
        include("rulers-test.jl")
    end

    @testset "boundingbox" begin
        include("boundingboxtests.jl")
        include("boundingboxpointtests.jl")
    end

    @testset "clipping" begin
        include("clipping-test.jl")
    end

    @testset "tilerstables" begin
        include("pagetiler-test.jl")
        include("table-tests.jl")
        include("getcell-test.jl")
    end
    @testset "matrix" begin
        include("matrix-tests.jl")
    end
    @testset "sierpinski" begin
        include("sierpinski-svg.jl")
        include("sierpinski.jl")
    end
    @testset "turtle" begin
        include("turtle-test.jl")
    end
    @testset "intersection" begin
        include("line-intersection-options.jl")
        include("intersection-line-circle.jl")
        include("line-intersections.jl")
        include("polygonintersect-test.jl")
        include("pointcrossesboundingboxtests.jl")
        include("polyclip-tests.jl")
    end
    @testset "misc" begin
        include("luxor-test1.jl")
        include("rules.jl")
        include("rules2.jl")
        include("barstest.jl")
        include("unit-conversions.jl")
        include("grid-test.jl")
        include("hex-grid-test.jl")
        include("cropmarkstest.jl")
        include("boxmaptest.jl")
        include("noise-test.jl")
        include("dashtests.jl")
        include("triangles.jl")
        include("place-svg.jl")
        include("strokescale-test.jl")
        include("dispatcher.jl")
        include("tidy-svg.jl")
    end
end

if get(ENV, "LUXOR_KEEP_TEST_RESULTS", false) == "true"
        cd(mktempdir(cleanup=false))
        @info("...Keeping the results in: $(pwd())")
        run_all_tests()
        @info("Test images were saved in: $(pwd())")
else
    mktempdir() do tmpdir
        cd(tmpdir) do
            @info("running tests in: $(pwd())")
            @info("but not keeping the results")
            @info("because you didn't do: ENV[\"LUXOR_KEEP_TEST_RESULTS\"] = \"true\"")
            run_all_tests()
            @info("Test images weren't saved. To see the test images, next time do this before running:")
            @info(" ENV[\"LUXOR_KEEP_TEST_RESULTS\"] = \"true\"")
        end
    end
end

import MathTeXEngine
# We don't add new methods to functions from MathTeXEngine. Hence, we 'use' these:
using MathTeXEngine:
    generate_tex_elements, inkwidth, inkheight, bottominkbound, TeXChar, HLine
using LaTeXStrings
import Luxor
import Luxor: text, latextextsize, latexboundingbox, rawlatexboundingbox
using Luxor: Point, @layer, translate, rotate, move,
    fontface, fontsize, get_fontsize, setfont,
    setline, line, poly, closepath, newsubpath, BoundingBox, newpath,
    currentpoint, pathtopoly, boxbottomleft, boxwidth, boxheight

"""
    texalign(halign, valign, bottom_pt, top_pt, font_size)

Helper function to align LaTeX text properly. Returns
`translate_x` and `translate_y` which consists of the amount
to be shifted depending on the type of alignment chosen
and the bounding box of the text.
"""
function texalign(halign, valign, bottom_pt::Point, top_pt::Point, font_size)
    textw = top_pt[1] - bottom_pt[1]
    translate_x, translate_y = 0, 0

    if halign === :left
        translate_x = 0
    elseif halign === :right
        translate_x = -textw * font_size
    elseif halign === :center
        translate_x = -textw / 2 * font_size
    end

    if valign === :baseline
        translate_y = 0
    elseif valign === :bottom
        translate_y = 0
    elseif valign === :top
        translate_y = -top_pt[2] * font_size
    elseif valign === :middle
        translate_y = -(bottom_pt[2] + top_pt[2]) * font_size / 2
    end
    return translate_x, translate_y
end

"""
    rawlatexboundingbox(lstr::LaTeXString, font_size=1)

Helper function that returns the coordinate points
of the bounding box containing the specific LaTeX text.
"""
function rawlatexboundingbox(lstr::LaTeXString)
    sentence = generate_tex_elements(lstr)
    els = filter(x -> x[1] isa TeXChar, sentence)
    texchars = [x[1] for x in els]
    pos_x = [x[2][1] for x in els]
    pos_y = [x[2][2] for x in els]
    scales = [x[3] for x in els]
    textw = maximum(inkwidth.(texchars) .* scales .+ pos_x)
    bottom = bottominkbound.(texchars)
    bottom_pt = Point(0, maximum(-bottom .* scales .- pos_y))
    top_pt = Point(textw, -maximum(inkheight.(texchars) .* scales .+ pos_y .+ bottom))

    return (bottom_pt, top_pt)
end

"""
    latexboundingbox(lstr::LaTeXString, font_size=get_fontsize(); halign=:left, valign=:right)

Returns the bounding box containing the latex text with
`(Lower Left Point, Upper Right Point)`.
Use `box(latex_bb(testext)...,:stroke)` to draw the bounding box.
"""
function latexboundingbox(lstr::LaTeXString, font_size = get_fontsize();
    halign = :left, valign = :right)
    bottom_pt, top_pt = rawlatexboundingbox(lstr)

    translate_x, translate_y = texalign(halign, valign, bottom_pt, top_pt, font_size)
    translate_pt = Point(translate_x, translate_y)

    return (bottom_pt * font_size + translate_pt, top_pt * font_size + translate_pt)
end

"""
    latextextsize(lstr::LaTeXString)

Returns the width and height of a latex string.
"""
function latextextsize(lstr::LaTeXString)
    bottom_pt, top_pt = latexboundingbox(lstr)
    textw = top_pt[1] - bottom_pt[1]
    texth = -(top_pt[2] - bottom_pt[2])
    return textw, texth
end

"""
    text(lstr::LaTeXString, pt::Point;
        valign=:baseline,
        halign=:left,
        rotationfixed = false,
        angle=0,
        paths=false,
        kwargs...)

Draws LaTeX string using `MathTexEngine.jl`. Hence, uses
ModernCMU as font family. When `rotationfixed = true`,
the text will rotate around its own axis, instead of
rotating around `pt`.

If `paths` is true, text paths are added to the current
path, rather than drawn.

```julia
using Luxor
using MathTeXEngine
using LaTeXStrings
@draw begin
    fontsize(70)
    text(L"e^{i\\pi} + 1 = 0", halign = :center)
end
```
"""
function text(lstr::LaTeXString, pt::Point;
    valign = :baseline,
    halign = :left,
    angle = 0::Real,
    rotationfixed = false,
    paths = false,
    kwargs...)

    # Function from MathTexEngine
    sentence = generate_tex_elements(lstr)

    # Get current font size.
    font_size = get_fontsize()

    textw, texth = latextextsize(lstr)
    bottom_pt, top_pt = rawlatexboundingbox(lstr)

    translate_x, translate_y = texalign(halign, valign, bottom_pt, top_pt, font_size)

    # Writes text using ModernCMU font.
    for text in sentence
        @layer begin
            translate(pt)
            if !rotationfixed
                rotate(angle)
                translate(translate_x, translate_y)
            else
                l_pt, r_pt = latexboundingbox(lstr, halign = halign, valign = valign)
                translate((l_pt + r_pt) / 2)
                rotate(angle)
                translate(Point(translate_x, translate_y) - (l_pt + r_pt) / 2)
            end

            if text[1] isa TeXChar
                if paths == true
                    fontface(text[1].font.family_name)
                    fontsize(font_size * text[3])
                    newsubpath()
                    move(Point(text[2]...) * font_size * (1, -1))
                    Luxor.textoutlines(string(text[1].represented_char),
                        Point(text[2]...) * font_size * (1, -1),
                        action = :path,
                        startnewpath = false)
                else
                    writelatexchar(text, font_size)
                end
            elseif text[1] isa HLine
                # text is eg (HLine{Float64}(0.7105, 0.009), [0.0, 0.2106], 1.0))
                #                            width   thick    x     y      scale
                if paths == true
                    pointstart = Point(text[2]...) * font_size * (1, -1)
                    pointend = pointstart + Point(text[1].width, 0) * font_size
                    poly([pointstart, pointend], :path)
                    closepath()
                    newsubpath()
                else
                    pointstart = Point(text[2]...) * font_size * (1, -1)
                    pointend = pointstart + Point(text[1].width, 0) * font_size
                    setline(0.5)
                    line(pointstart, pointend, :stroke)
                end
            end
        end
    end
end

"""
    writelatexchar(t::AbstractString)

Helper function to handle extra chars that are not supported
in MathTeXEngine.
"""
function writelatexchar(text, font_size)
    # Extra chars not supported by MathTeXEngine
    extrachars = ["⨟", "{", "}", "𝔸", "𝔹", "ℂ", "𝔻", "𝔽", "𝔾", "ℍ", "𝕀", "𝕁", "𝕂", "𝕃", "𝕄", "ℕ", "𝕆", "ℙ", "ℚ", "ℝ", "𝕊", "𝕋", "𝕌", "𝕎", "𝕍", "𝕏", "ℤ", "𝔄", "𝔅", "ℭ", "𝔇", "𝔈", "𝔉", "𝔊", "ℌ", "ℑ", "𝔍", "𝔎", "𝔏", "𝔐", "𝔑", "𝔒", "𝔓", "𝔔", "ℜ", "𝔖", "𝔗", "𝔘", "𝔙", "𝔚", "𝔛", "𝔜", "ℨ", "𝕬", "𝕭", "𝕮", "𝕯", "𝕰", "𝕱", "𝕲", "𝕳", "𝕴", "𝕵", "𝕶", "𝕷", "𝕸", "𝕹", "𝕺", "𝕻", "𝕼", "𝕽", "𝕾", "𝕿", "𝖀", "𝖁", "𝖂", "𝖃", "𝖄", "𝖅", "𝒜", "ℬ", "𝒞", "𝒟", "ℰ", "ℱ", "𝒢", "ℋ", "ℐ", "𝒥", "𝒦", "ℒ", "ℳ", "𝒩", "𝒪", "𝒫", "𝒬", "ℛ", "𝒮", "𝒯", "𝒰", "𝒱", "𝒲", "𝒳", "𝒴", "𝒵", "𝕒", "𝕓", "𝕔", "𝕕", "𝕖", "𝕗", "𝕘", "𝕙", "𝕚", "𝕛", "𝕜", "𝕝", "𝕞", "𝕟", "𝕠", "𝕡", "𝕢", "𝕣", "𝕤", "𝕥", "𝕦", "𝕧", "𝕩", "𝕨", "𝕪", "𝕫", "𝐚", "𝐛", "𝐜", "𝐝", "𝐞", "𝐟", "𝐠", "𝐡", "𝐢", "𝐣", "𝐤", "𝐥", "𝐦", "𝐧", "𝐨", "𝐩", "𝐪", "𝐫", "𝐬", "𝐭", "𝐮", "𝐯", "𝐱", "𝐰", "𝐲", "𝐳", "𝐀", "𝐁", "𝐂", "𝐃", "𝐄", "𝐅", "𝐆", "𝐇", "𝐈", "𝐉", "𝐊", "𝐋", "𝐌", "𝐍", "𝐎", "𝐏", "𝐐", "𝐑", "𝐒", "𝐓", "𝐔", "𝐕", "𝐗", "𝐖", "𝐘", "𝐙", "𝓐", "𝓑", "𝓒", "𝓓", "𝓔", "𝓕", "𝓖", "𝓗", "𝓘", "𝓙", "𝓚", "𝓛", "𝓜", "𝓝", "𝓞", "𝓟", "𝓠", "𝓡", "𝓢", "𝓣", "𝓤", "𝓥", "𝓧", "𝓦", "𝓨", "𝓩"]

    fontface(text[1].font.family_name)
    fontsize(font_size * text[3])

    if string(text[1].represented_char) == "⨟"
        setfont(text[1].font.family_name, font_size * text[3])
        Luxor.settext(string(text[1].represented_char), Point(text[2]...) * font_size * (1, -1) + Point(0.25, 0.3) * font_size)

    elseif text[1].represented_char == '{' || text[1].represented_char == '}'
        Luxor.text(string(text[1].represented_char), Point(text[2]...) * font_size * (1, -1) + Point(0, -0.8) * font_size)

    elseif string(text[1].represented_char) in extrachars
        setfont(text[1].font.family_name, 1.3font_size * text[3])
        Luxor.settext(string(text[1].represented_char), Point(text[2]...) * font_size * (1, -1) + Point(0, 0.3) * font_size)

    else
        Luxor.text(string(text[1].represented_char), Point(text[2]...) * font_size * (1, -1))
    end
end

# versions of _textformat that accept LaTeXString

function Luxor._textformat(str::LaTeXString, pos::Point, defaultparams)
    text(str, Point(pos.x, pos.y + -defaultparams.baseline))
    pos = Luxor.currentpoint()
    if isapprox(defaultparams.advance, 1.0)
        space = Luxor.textextents(" ")
        pos = Point(pos.x + space[5], pos.y)
    else
        space = [0, 0, 0, 0, defaultparams.advance, 0]
        pos = Point(pos.x + space[5], pos.y)
    end
    return pos
end

function Luxor._textformat_tuple(str::LaTeXString, pos::Point, tempparams, defaultparams)
    # if there's a prolog function defined, do it now
    if tempparams.prolog isa Function
        # remember to use baseline shift when passing details to prolog function
        tempparams.prolog(Point(pos.x, pos.y + -tempparams.baseline), str)
    end
    text(str, Point(pos.x, pos.y + -tempparams.baseline))
    pos = Luxor.currentpoint()
    if isapprox(tempparams.advance, 1.0)
        space = Luxor.textextents(" ")
        pos = Point(pos.x + space[5], pos.y)
    else
        space = [0, 0, 0, 0, tempparams.advance, 0]
        pos = Point(pos.x + space[5], pos.y)
    end
    return pos
end

using Luxor, Test

# test all points the same
pt1 = pt2 = pt3 = pt4 = O
flag, _ = intersectionlines(pt1, pt1, pt1, pt1)
@test flag == false

# test all points the same but not 0.0
pt1 = pt2 = pt3 = pt4 = Point(0.5, 0.75)
flag, _ = intersectionlines(pt1, pt1, pt1, pt1)
@test flag == false

#first pair of points the same
pt1 = pt2 = O
pt3 = Point(20, 20)
pt4 = Point(30, 20)
flag, _ = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == false

#last pair of points the same
pt1 = Point(20, 20)
pt2 = Point(30, 20)
pt3 = pt4 = O
flag, _ = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == false

#first point same as one of second pair
pt1 = Point(20, 20)
pt2 = Point(30, 20)
pt3 = Point(20, 20)
pt4 = Point(40, 50)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == true
@test ip == Point(20.0, 20.0)

# first point same as one of second pair, crossing only
pt1 = Point(20, 20)
pt2 = Point(30, 20)
pt3 = Point(20, 20)
pt4 = Point(40, 50)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == true
@test ip == Point(20.0, 20.0)

#testing overlapping collinear horizontal lines
pt1 = Point(0, 0)
pt2 = Point(100, 0)
pt3 = Point(50, 0)
pt4 = Point(200, 0)
flag, _ = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == false

# testing overlapping collinear horizontal lines, with crossingonly
pt1 = Point(0, 0)
pt2 = Point(100, 0)
pt3 = Point(50, 0)
pt4 = Point(200, 0)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == false

# testing shared endpoints horizontal crossingonly = true
pt1 = Point(0, 0)
pt2 = Point(200, 0)
pt3 = Point(200, 0)
pt4 = Point(100, 40)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == true
@test ip == Point(200.0, 0.0)

# testing shared endpoints vertical
pt1 = Point(0, 0)
pt2 = Point(0, 100)
pt3 = Point(0, 0)
pt4 = Point(0, 200)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == true
@test ip == O

# testing shared endpoints vertical crossingonly = true
pt1 = Point(0, 0)
pt2 = Point(0, 100)
pt3 = Point(0, 10)
pt4 = Point(0, 100)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == true
@test ip == Point(0.0, 100.0)

# testing nonoverlapping vertical lines
pt1 = Point(0, 0)
pt2 = Point(0, 100)
pt3 = Point(0, 100)
pt4 = Point(0, 200)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == true
@test ip == Point(0.0, 100.0)

# testing nonoverlapping vertical lines
pt1 = Point(0, 0)
pt2 = Point(0, 100)
pt3 = Point(0, 200)
pt4 = Point(0, 300)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == false

# testing overlapping vertical lines
pt1 = Point(0, 0)
pt2 = Point(0, 100)
pt3 = Point(0, 50)
pt4 = Point(0, 150)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == false

# testing overlapping vertical lines crossingonly true"
pt1 = Point(0, 0)
pt2 = Point(0, 100)
pt3 = Point(0, 50)
pt4 = Point(0, 150)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == false

# testing intersecting line segments not crossing"
pt1 = Point(0, 0)
pt2 = Point(150, -150)
pt3 = Point(150, 0)
pt4 = Point(0, -150)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == true
@test ip == Point(75.0, -75.0)

# testing nearly vertical lines
pt1 = Point(0, 0)
pt2 = Point(0, -1500)
pt3 = Point(1, 0)
pt4 = Point(0.99, -1500)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == true

# testing nearly vertical lines crossing only
pt1 = Point(0, 0)
pt2 = Point(0, -15000)
pt3 = Point(1, 0)
pt4 = Point(0.999999, -150000)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == false

# testing nearly vertical lines, they meet eventually
pt1 = Point(0, 0)
pt2 = Point(0, -15000)
pt3 = Point(1, 0)
pt4 = Point(0.999999, -150000)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test isapprox(ip.x, 0.0)
@test flag == true

# parallel vertical lines
pt1 = Point(0, 0)
pt2 = Point(0, -1500)
pt3 = Point(1, 0)
pt4 = Point(1, -1500)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == false

# parallel vertical lines crossingonly
pt1 = Point(0, 0)
pt2 = Point(0, -1500)
pt3 = Point(1, 0)
pt4 = Point(1, -1500)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == false

# parallel horizontal lines
pt1 = Point(-1000, 0)
pt2 = Point(1000,  0)
pt3 = Point(-1000, -10)
pt4 = Point(1000,  -10)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == false

# parallel horizontal lines crossingonly
pt1 = Point(-1000, 0)
pt2 = Point(1000,  0)
pt3 = Point(-1000, -10)
pt4 = Point(1000,  -10)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == false

# nearly parallel horizontal lines (they meet eventually)
pt1 = Point(-1000, 0)
pt2 = Point(1000,  0)
pt3 = Point(-1000, -10)
pt4 = Point(1000,  -9.99)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4)
@test flag == true
@test ip.x > 1000.0
@test iszero(ip.y)

# nearly parallel horizontal lines crossing only
pt1 = Point(-100, 0)
pt2 = Point(100,  0)
pt3 = Point(-100, -10)
pt4 = Point(100,  -9.99)
flag, ip = intersectionlines(pt1, pt2, pt3, pt4, crossingonly=true)
@test flag == false

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function draw_luxor_demo(fname, flag)
    Drawing("A2landscape", fname)

    origin() # move 0/0 to center
    background("purple")

    setopacity(0.7)     # opacity from 0 to 1
    sethue(0.3, 0.7, 0.9) # sethue sets the color but doesn't change the opacity
    setline(20)         # line width
    # graphics functions use :fill, :stroke, :fillstroke, :clip, or leave blank
    rect(-400, -400, 800, 800, :fill)
    Random.seed!(42)
    randomhue()
    circle(0, 0, 460, :stroke)

    # clip the following graphics to a circle positioned above the x axis
    circle(0, -200, 400, :clip)
    sethue("gold")
    setopacity(0.7)
    setline(10)

    # simple line drawing
    for i in 0:pi/36:2pi - pi/36
        move(0, 0)
        line(cos(i) * 600, sin(i) * 600)
        strokepath()
        move(cos(i) * 300, sin(i) * 300)
        rline(0, 5)
        rline(5, 0)
        rline(0, -5)
        rline(-5, 0)
        rmove(10, 0)
        rline(-10, 0)
        strokepath()
    end

    # finish clipping
    clipreset()

    # here using Mac OS X fonts
    fontsize(20)
    setcolor"turquoise"
    fontface("Optima-ExtraBlack")
    textwidth = textextents("Luxor")[5]
    # move the text by half the width
    flag ? textcentered("Luxor centered", 0, 300) :  textcentred("Luxor centred", 0, 300)
    # check that using a Point instead of x, y works
    pnt = Point(0, 330)
    flag ? textcentered("Centered", pnt) :  textcentred("Centred", pnt)

    textright("Right", 0, 360)
    textright("Right Point", Point(0, 390))

    # Check that this just takes default (:baseline)
    text("Invalid valign", Point(0, 420), valign=:foobar)

    # text on curve
    fontsize(18)
    fontface("Avenir-Black")

    textcurve("THIS IS TEXT ON A CURVE " ^ 14, 0, 550, O)
    @test finish() == true

    # Test that calling finish() twice doesn't segfault.
    @test finish() == false
end

# Try both synonyms of textcentered/textcentred
fname = "luxor-test1.png"
draw_luxor_demo(fname, false)
println("...basic test: output in $(fname)")
fname = "luxor-test2.png"
draw_luxor_demo(fname, true)
println("...finished basic test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Colors

using Test

using Random
Random.seed!(42)

function blend_mode_test(fname)
    Drawing(600, 600, fname)
    origin()
    # transparent, no background
    fontsize(15)
    setline(1)
    tiles = Tiler(600, 600, 4, 5, margin=30)
    modes = length(Luxor.blendingmodes)
    setgrey(0.15)
    for (pos, n) in tiles
        n > modes && break
        gsave()
        translate(pos)
        box(O, tiles.tilewidth-10, tiles.tileheight-10, :clip)

        # diagonal
        diag = (Point(-tiles.tilewidth/2, -tiles.tileheight/2),
                Point(tiles.tilewidth/2,  tiles.tileheight/2))
        upper = between(diag, 0.4)
        lower = between(diag, 0.6)

        # first red shape uses default blend operator
        setcolor(0.7, 0, 0, .8)
        circle(upper, tiles.tilewidth/4, :fill)

        # second blue shape shows results of blend operator
        setcolor((0, 0, 0.9, 0.4))
        blendingmode = Luxor.blendingmodes[mod1(n, modes)]
        setmode(blendingmode)
        circle(lower, tiles.tilewidth/4, :fill)

        clipreset()
        grestore()

        gsave()
        translate(pos)
        text(Luxor.blendingmodes[mod1(n, modes)], O.x, O.y + tiles.tilewidth/2, halign=:center)
        grestore()
    end
    @test finish() == true
end

fname = "blend_mode_test.png"
blend_mode_test(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function circle_as_path(fname)
    currentwidth = 1200
    currentheight = 1200 # pts
    Drawing(currentwidth, currentheight, fname)
    origin()
    background(setgray(0.8)...)
    tiles = Tiler(currentwidth, currentheight, 8, 8, margin=20)
    for (pos, n) in tiles
        randomhue()
        circlepath(pos, 70, :path)
        newsubpath()
        circlepath(pos, rand(5:65), :fill, reversepath=true)
    end
    @test finish() == true
end

fname = "circlepath.pdf"
circle_as_path(fname)
println("...finished test: output in $(fname)")

"""
This extension is loaded and used by Luxor if both LaTeXStrings and MathTeXEngine is loaded.

The functions are accessed through Luxor as usual.
"""
module LuxorExtLatex

include("latex.jl")

end # module

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function getpath_1(fname)
    Drawing(400, 250, fname)

    background("white")
    origin()
    setline(0.75)
    sethue("black")

    fontsize(220)
    t = "N" # no curves on this one
    translate(-textextents(t)[3]/2, textextents(t)[4]/2)
    textpath(t)
    pathdata = getpath()
    outline = Point[]
    for i in pathdata[1:end-1]
        if length(i.points) == 2
            x = i.points[1]
            y = i.points[2]
            push!(outline, Point(x, y))
        end
    end
    poly(outline, :stroke, close=true)
    for i in 5:5:35
        poly(offsetpoly(outline, i), :stroke, close=true)
    end
    @test finish() == true
end

fname= "figures-get-path.pdf"
getpath_1(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_circles(fname)
    pagewidth, pageheight = 1200, 1400
    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("ivory")
    setopacity(0.8)
    setline(0.4)
    fontsize(2)
    gsave()
    translate(0, -pageheight / 2)
    pagetiles = Tiler(pagewidth, pageheight, 20, 20, margin=50)
    rad = 40
    for (pos, n) in pagetiles
        diameter = rand(10:50)
        secondpos = Point(pos.x + diameter, pos.y)
        sethue("black")
        circle(pos, 1, :fill)
        circle(secondpos, 1, :fill)
        randomhue()
        circle(pos, secondpos, :fill)
    end
    grestore()

    gsave()
    translate(0, pageheight / 2)
    pagetiles = Tiler(pagewidth, pageheight, 20, 20, margin=50)
    rad = 40
    for (p1, n) in pagetiles
        p2, p3 = Point(p1.x + rand(-15:15), p1.y + rand(-15:15)), Point(p1.x + rand(-15:15), p1.y + rand(-15:15))
        cpoint, rad = center3pts(p1, p2, p3) # returns (0/0, 0) if points are collinear
        randomcolor()
        if rad > 0
            circle(cpoint, rad, :stroke)
            sethue("black")
            circle(p1, 1, :fill)
            circle(p2, 1, :fill)
            circle(p3, 1, :fill)
            p4 = getnearestpointonline(p1, p2, cpoint)
            line(p1, p2, :stroke)
            line(cpoint, p4, :stroke)
            text(string(round(pointlinedistance(cpoint, p1, p2), digits=1)), cpoint)
        end
        setopacity(0.8)
    end
    grestore()

    @test finish() == true
    println("...finished circletest, saved in $(fname)")
end

function test_circle_ring(fname)
    pagewidth, pageheight = 1200, 1200
    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("black")
    setline(3)
    tiles = Tiler(1200, 1200, 3, 3)
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            circle(Point(0, 0), tiles.tilewidth/2, :stroke)
            cs, ic = circlering(Point(0, 0), tiles.tilewidth/2, n)
            for c in cs
                randomhue()
                circle(c..., :stroke)
                ics, iic = circlering(first(c), last(c), n)
                for iic in ics
                    randomhue()
                    circle(iic..., :stroke)
                end
                randomhue()
                circle(iic..., :stroke)
            end
            lcs, lic = circlering(Point(0, 0), last(ic), n)
            for liic in lcs
                randomhue()
                circle(liic..., :stroke)
            end
            randomhue()
            circle(lic..., :stroke)
        end
    end
    @test finish() == true
    println("...finished circle-ring-test, saved in $(fname)")
end


fname = "circle-test.png"

test_circles(fname)

fname = "circle-ring-test.png"

test_circle_ring(fname)

#!/usr/bin/env julia

using Luxor

using Test
# some of these tests produce errors on Linux versions of Cairo
# but no errors on MacOS X Cairo.

using Random
Random.seed!(42)

function pointmatrix(fname)
    # transform points using 3 by 3 matrix

    identitym = [1 0 0; 0 1 0; 0 0 1]
    tm = [1 0 50; 0 1 250; 0 0 1] # translate 50 in x, 250 in y
    sm = [2 0 0; 0 0.5 0; 0 0 1] # scale 2 in x 0.5 in y
    θ = π / 4
    rm = [cos(θ) sin(θ) 0; -sin(θ) cos(θ) 0; 0 0 1] # rotate clockwise by θ
    shx = [1 3 0; 0 1 0; 0 0 1] # shear by 3 in x
    shy = [1 0 0; 2 1 0; 0 0 1] # shear by 2 in y
    ro = [-1 0 0; 0 -1 0; 0 0 1] # reflect about origin
    rx = [1 0 0; 0 -1 0; 0 0 1] # reflect in x
    ry = [-1 0 0; 0 1 0; 0 0 1] # reflect in y

    Drawing(1000, 1000, fname)
    origin()
    fontsize(200)
    setopacity(0.6)
    tiles = Tiler(1000, 1000, 3, 3)

    mnames = ["identitym", "tm", "sm", "rm", "shx", "shy", "ro", "rx", "ry"]

    textoutlines("t")
    pts = pathtopoly()[1]
    for (n, mat) in enumerate([identitym, tm, sm, rm, shx, shy, ro, rx, ry])
        @layer begin
            translate(first(tiles[n]))
            pts1 = map(pt -> mat * pt, pts)
            sethue(Luxor.HSB(35n, 0.8, 0.8))
            poly(pts1, :fill, close = true)
            sethue("white")
            fontsize(20)
            text(mnames[n], halign = :center)
        end
    end

    sethue("white")
    # compose matrix multiplications ? 
    poly(map(pt -> sm * tm * ro * shy * pt, pts), :fill)
    poly(map(pt -> sm * inv(tm) * ro * inv(shy) * pt, pts), :fill)

    @test finish() == true
    println("...finished test: output in $(fname)")
end



@testset "matrix tests" begin
    fname = "matrix-tests.pdf"
    # matrix tests

    # translate(dx, dy) =   transform([1,  0, 0,  1, dx, dy])                shift by
    # scale(fx, fy)     =   transform([fx, 0, 0, fy,  0, 0])                 scale by
    # rotate(A)         =   transform([c, s, -c, c,   0, 0])                 rotate to A radians
    # x-skew(a)         =   transform([1,  0, tan(a), 1,   0, 0])            xskew by A
    # y-skew(a)         =   transform([1, tan(a), 0, 1, 0, 0])               yskew by A
    # flip HV           =   transform([fx, 0, 0, fy, cx(*1-fx), cy* (fy-1)]) flip

    Drawing(1000, 1000, fname)

    # get rotation
    @test isapprox(getrotation(cairotojuliamatrix(getmatrix())), 0.0)
    rotate(pi / 2)
    @test isapprox(getrotation(), pi / 2)
    @test isapprox(getrotation(cairotojuliamatrix(getmatrix())), pi / 2)
    origin()
    @test isapprox(getrotation(cairotojuliamatrix(getmatrix())), 0.0)

    # get translation
    tx, ty = gettranslation(cairotojuliamatrix(getmatrix()))
    @test tx == 500.0
    @test ty == 500.0
    translate(5, 10)
    tx, ty = gettranslation()
    @test tx == 505.0
    @test ty == 510.0
    origin()
    tx, ty = gettranslation(cairotojuliamatrix(getmatrix()))
    @test tx == 500.0
    @test ty == 500.0

    # get scale
    sx, sy = getscale(cairotojuliamatrix(getmatrix()))
    @test sx == 1.0
    @test sy == 1.0
    scale(5, 10)
    sx, sy = getscale()
    @test sx == 5.0
    @test sy == 10.0
    origin()
    sx, sy = getscale(cairotojuliamatrix(getmatrix()))
    @test sx == 1.0
    @test sy == 1.0

    original_matrix = getmatrix()

    # absolute position 200, 250 relative to top left origin (0, 0)
    setmatrix([1, 0, 0, 1, 200, 250.0])
    sethue("red")
    fontsize(20)
    text("hello world")

    sethue("green")
    # absolute position 400, 500 from top left origin (0, 0)
    setmatrix([1, 0, 0, 1, 400, 500.0])
    text("hello world")

    sethue("white")
    # absolute position 230 230
    setmatrix([1, 0, 0, 1, 230, 230.0])
    text("hello world")

    # shift relative by 10 x (right) and 20 y (down) after moving to absolute 300 300
    setmatrix([1, 0, 0, 1, 300, 300])
    transform([1, 0, 0, 1, 10, 20])
    sethue("yellow")
    text("hello world")

    setmatrix([1, 0, 0, 1, 300, 300])
    transform([1, 0, 0, 1, 0, 0])
    sethue("gray")
    text("hello world")

    # scale by 2 x (right) and 3 y after moving to 300 300
    setmatrix([1, 0, 0, 1, 300, 300.0])
    transform([2, 0, 0, 3, 0, 0.0])
    sethue("purple")
    text("hello world")

    # using rotate by angle, not using matrix
    # absolute move to 100, 100
    setmatrix([1, 0, 0, 1, 100.0, 100])
    fontsize(20)
    sethue("brown")
    for i in 1:4
        # rotate by pi/2 radians
        rotate(pi / 2)
        text("hello world")
    end

    # rotate by angle, around current position
    # absolute move to 500 across 500 down
    setmatrix([1, 0, 0, 1, 300.0, 600])
    fontsize(20)
    sethue("cyan")
    n = 10
    angle = 2pi / n
    for i in 1:n
        # rotate another 'angle' radians
        transform([cos(angle), sin(angle), -sin(angle), cos(angle), 0, 0])
        text("$i hello world")
    end

    fontsize(20)
    # skew X
    setopacity(0.5)
    sethue("purple")
    # move to 800 across 300 down
    setmatrix([1, 0, 0, 1, 800, 300])
    # Cairo doesn't like tan(90) skews (or the matrix that results)
    for i in 0:5:40
        transform([1, 0, tand(i), 1, 0, 20])    # xskew by i° and move down by 20 for each one
        text("hello world")
    end

    # skew y
    setopacity(0.75)
    sethue("orange")
    setmatrix([1, 0, 0, 1, 800, 500])
    # Cairo doesn't like tan(90) skews
    for i in 0:5:40
        transform([1, tand(i), 0, 1, 0, 20])    # yskew by i° and move down by 20 for each one
        text("hello world")
    end

    # flip hv
    # Flip H/V with center shifted by cx:cy

    sethue("magenta")
    setmatrix([1, 0, 0, 1, 800, 200.0])
    fx = 1
    fy = -1
    cx = cy = 50
    transform([fx, 0, 0, fy, cx * (1 - fx), cy * (fy - 1)])
    text("hello world")

    setmatrix(original_matrix)
    text("0/0", O + Point(15, 15))

    @test finish() == true
    println("...finished test: output in $(fname)")
end

pointmatrix("matrix-point-tests.png")

#!/usr/bin/env julia

using Luxor, Colors

using Test

using Random
Random.seed!(42)

function poly_areas()
    # test area calculations
    @test polyarea(ngon(O, 100, 4, 0, vertices=true)) ≈ 20_000
    @test polyarea(ngonside(O, 100, 4, 0, vertices=true)) < polyarea(ngonside(O, 100, 5, 0, vertices=true))
    @test polyarea(ngonside(O, 100, 3, 0, vertices=true)) ≈ 2500sqrt(3)
end

function simple_polys()
    gsave()
    sethue(0, 0, 0)
    vstep = 50
    hstep = 50
    x = 0
    y = 0
    translate(-currentwidth/2 + 50, -currentheight/2 + 50)
    for sides in 3:12
        ngon(x, y, 20, sides, 0, :stroke)
        x += hstep
        if x > currentwidth
            x = 0
            y += vstep
        end
    end
    translate(0, currentheight - 150)
    x = 0
    for sides in 3:12
        ngon(x, y, 20, sides, 0, :fill)
        x += hstep
        if x > currentwidth
            x = 0
            y += vstep
        end
    end
    grestore()

    @layer begin
        translate(BoundingBox()[1] + (0, 130))
        pgon = ngonside(O, 20, 5, vertices=true)
        for i in 1:10
            polymove!(pgon, O, Point(50, 0))
            poly(pgon, :stroke, close=true)
            polyrotate!(pgon, rand() * π, center=polycentroid(pgon))
            polyscale!(pgon, isodd(i) ? 1.5 : 1/1.5, center=polycentroid(pgon))
        end
    end
end

function hex_mixtures()
    gsave()
    vstep = 50
    hstep = 50
    for y in -currentheight:vstep:currentheight
        for x in -currentwidth:hstep:currentwidth
            setopacity(0.2)
            setline(rand()*10)
            sethue(backgroundcolors[rand(1:end)])
            gsave()
                 translate(x, y)
                 rotate(rand() * pi)
                 # point version
                 poly(hexagon(rand() * 5, rand() * 5, 15 + rand() * 5), :fill, close=true)
                 setopacity(0.1)
                 poly(hexagon(rand() * 10, rand() * 5, 15 + rand() * 5))
                 setopacity(0.3)
                 randomhue()
                 poly([
                        Point(rand() * -100, rand() * 100),
                        Point(rand() * -100, rand() * 100),
                        Point(rand() * -100, rand() * 100),
                        Point(rand() * -100, rand() * 100)
                     ], :fill)
            grestore()
            sethue(backgroundcolors[rand(1:end)])
            gsave()
                 translate(x, y)
                 ngon(x, y, 50, rand(3:13), 0, :stroke)
                 rotate(rand() * pi)
                 poly(hexagon(rand() * 5, rand() * 5, 15 + rand() * 5), :stroke)
                 ngon(x, y, 50, rand(3:13), 0, :fill)
                 rect(0, 0, hstep-5, vstep-5, :stroke)
                 ngon(x, y, 50, rand(3:13), 0, :none)
            grestore()
        end
    end
    grestore()
end

hexagon(x, y, size) = [Point(x + size * cos(2pi/6 * i), y + size * sin(2pi/6 * i)) for i in 1:6]

function polygon_test(fname)
    global currentwidth = 595 # pts
    global currentheight = 842 # pts
    Drawing(currentwidth, currentheight, fname)

    origin()
    background("antiquewhite")

    # test polyareas
    poly_areas()

    global foregroundcolors = diverging_palette(230, 280, 200, s = 0.99, b=0.8)
    global backgroundcolors = diverging_palette(200, 260, 280, s = 0.8, b=0.5)
    setline(2)
    # fill, then clip to heptagon
    setcolor("lightcyan")
    setline(3)
    ngon(0, 0, 270, 7, 0, :fillpreserve) # fill it
    sethue("orange")
    strokepreserve()                     # stroke it
    clip()                               # then use to clip
    hex_mixtures()
    clipreset()
    simple_polys()
    @test finish() == true
    println("...finished test: output in $(fname)")
end

polygon_test("polygon-test.pdf")

using Luxor, Test, Random
Random.seed!(42)

function point_on_polygon_test(fname)

    Drawing(1200, 1200, fname)
    origin()
    background("grey20")
    polys = [ngon(Point(x, y), rand(20:100), rand(3:8), rand() * 2π, vertices=true) for x in -500:200:500, y in -500:200:500]
    for pol in polys
        randomhue()
        poly(pol, :fill)

        pt1 = rand(1:length(pol))
        pt2 = mod1(pt1 + 1, length(pol))

        # all these should lie on their polygons
        pt = between(pol[pt1], pol[pt2], rand())
        flag = ispointonpoly(pt, pol)
        if flag
            sethue("black")
            circle(pt, 10, :fill)
        else
            sethue("red")
            circle(pt, 20, :fill)
        end

        # move the point, then it shouldn't
        pt = pt + (0.01, 0.01)
        flag = ispointonpoly(pt, pol)
        if flag
            sethue("red")
            circle(pt, 6, :fill)
        else
            sethue("green")
            circle(pt, 20, :stroke)
        end

    end

    @test finish() == true
    println("...finished test: output in $(fname)")
end

point_on_polygon_test("point-on-polygon.png")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function star_test_1(fname)
    width, height = 2000, 2000
    Drawing(width, height, fname)
    origin()
    background("grey10")
    setopacity(0.85)
    setline(0.4)
    # stars with star-shaped holes in
    pagetiles = Tiler(width, height, 4, 5, margin=50)
    for (pos, n) in pagetiles
        randomhue()
        # outer path
        star(
            pos.x,                    # xcenter
            pos.y,                    # ycenter
            pagetiles.tilewidth/2,  # outer radius
            rand(4:8),            # number of points
            rand(),               # ratio of inner to outer
            2pi * rand(),         # orientation
            :path)
        newsubpath()
        # inner path
        star(
            pos.x,                    # xcenter
            pos.y,                    # ycenter
            pagetiles.tilewidth/2,  # outer radius
            rand(3:5),            # number of points
            rand(),               # ratio of inner to outer
            2pi * rand(),         # orientation
            :path,
            reversepath=true)
        fillstroke()
    end
    @test finish() == true
end

fname = "star.pdf"
star_test_1(fname)
println("...finished test: output in $(fname)")

"""
    tiles = Tiler(areawidth, areaheight, nrows, ncols, margin=20)

A Tiler is an iterator that, for each iteration, returns a tuple of:

  - the `x`/`y` point of the center of each tile in a set of tiles that divide up a
    rectangular space such as a page into rows and columns (relative to current 0/0)

  - the number of the tile

`areawidth` and `areaheight` are the dimensions of the area to be tiled, `nrows`/`ncols`
are the number of rows and columns required, and `margin` is applied to all four
edges of the area before the function calculates the tile sizes required.

Tiler and Partition are similar:

  - Partition lets you specify the width and height of a cell

  - Tiler lets you specify how many rows and columns of cells you want, and a margin:

```julia
tiles = Tiler(1000, 800, 4, 5, margin=20)
for (pos, n) in tiles
    # the point pos is the center of the tile
end
```

You can access the calculated tile width and height like this:

```julia
tiles = Tiler(1000, 800, 4, 5, margin=20)
for (pos, n) in tiles
    ellipse(pos.x, pos.y, tiles.tilewidth, tiles.tileheight, :fill)
end
```

It's sometimes useful to know which row and column you're currently on.
`tiles.currentrow` and `tiles.currentcol` should have that information for you.

To use a Tiler to make grid points:

```julia
first.(collect(Tiler(800, 800, 4, 4)))
```

which returns an array of points that are the center points of the grid.
"""
mutable struct Tiler
    areawidth::Union{Float64, Int}
    areaheight::Union{Float64, Int}
    tilewidth::Union{Float64, Int}
    tileheight::Union{Float64, Int}
    nrows::Int
    ncols::Int
    currentrow::Int
    currentcol::Int
    margin::Union{Float64,Int}
    function Tiler(areawidth, areaheight, nrows::Int, ncols::Int; margin = 10.0)
        tilewidth = (areawidth - 2margin) / ncols
        tileheight = (areaheight - 2margin) / nrows
        currentrow = 1
        currentcol = 1
        new(areawidth, areaheight, tilewidth, tileheight, nrows, ncols, currentrow, currentcol, margin)
    end
end

function Base.iterate(pt::Tiler)
    x = -(pt.areawidth / 2) + pt.margin + (pt.tilewidth / 2)
    y = -(pt.areaheight / 2) + pt.margin + (pt.tileheight / 2)
    tilenumber = 1
    x1 = x + pt.tilewidth
    y1 = y
    if x1 > (pt.areawidth / 2) - pt.margin
        y1 += pt.tileheight
        x1 = -(pt.areawidth / 2) + pt.margin + (pt.tilewidth / 2)
    end
    pt.currentrow, pt.currentcol = (div(tilenumber - 1, pt.ncols) + 1, mod1(tilenumber, pt.ncols))
    return ((Point(x, y), tilenumber), (Point(x1, y1), tilenumber + 1))
end

function Base.iterate(pt::Tiler, state)
    if state[2] > (pt.nrows * pt.ncols)
        return
    end
    x = state[1].x
    y = state[1].y
    tilenumber = state[2]
    x1 = x + pt.tilewidth
    y1 = y
    if x1 > (pt.areawidth / 2) - pt.margin
        y1 += pt.tileheight
        x1 = -(pt.areawidth / 2) + pt.margin + (pt.tilewidth / 2)
    end
    pt.currentrow, pt.currentcol = (div(tilenumber - 1, pt.ncols) + 1, mod1(tilenumber, pt.ncols))
    return ((Point(x, y), tilenumber), (Point(x1, y1), tilenumber + 1))
end

function Base.length(pt::Tiler)
    pt.nrows * pt.ncols
end

function Base.getindex(pt::Tiler, i::Int)
    1 <= i <= pt.ncols * pt.nrows || throw(BoundsError(pt, i))
    xcoord = -pt.areawidth / 2 + pt.margin + mod1(i, pt.ncols) * pt.tilewidth - pt.tilewidth / 2
    ycoord = -pt.areaheight / 2 + pt.margin + (div(i - 1, pt.ncols) * pt.tileheight) + pt.tileheight / 2
    return (Point(xcoord, ycoord), i)
end

function Base.getindex(t::Tiler, r::Int, c::Int)
    n = ((r - 1) * t.ncols) + c
    return first(t[n])
end

function Base.size(pt::Tiler)
    return (pt.nrows, pt.ncols)
end

Base.lastindex(pt::Tiler) = length(pt)
Base.firstindex(pt::Tiler) = 1

Base.eltype(::Type{Tiler}) = Tuple

Base.getindex(pt::Tiler, I) = [pt[i] for i in I]

"""
    GridRect(startpoint, xspacing, yspacing, width, height)

Define a rectangular grid, to start at `startpoint` and proceed along the x-axis in
steps of `xspacing`, then along the y-axis in steps of `yspacing`.

    GridRect(startpoint, xspacing=100.0, yspacing=100.0, width=1200.0, height=1200.0)

For a column, set the `xspacing` to 0:

    grid = GridRect(O, 0, 40)

To get points from the grid, use `nextgridpoint(g::Grid)`.
```julia
julia> grid = GridRect(O, 0, 40);

julia> nextgridpoint(grid)
Point(0.0, 0.0)

julia> nextgridpoint(grid)
Point(0.0, 40.0)
```

When you run out of grid points, you'll wrap round and start again.
"""
mutable struct GridRect
    startpoint::Point
    currentpoint::Point
    xspacing::Float64
    yspacing::Float64
    width::Float64
    height::Float64
    rownumber::Int
    colnumber::Int
    function GridRect(startpoint, xspacing, yspacing, width = 1200.0, height = 1200.0)
        rownumber = 1
        colnumber = 0
        # find the "previous" point, so that the first call gets the real first point
        xspacing == 0 ? sp = startpoint.y - yspacing : sp = startpoint.y
        currentpoint = Point(startpoint.x - xspacing, sp)
        new(startpoint, currentpoint, xspacing, yspacing, width, height, rownumber, colnumber)
    end
end

"""
    GridHex(startpoint, radius, width=1200.0, height=1200.0)

Define a hexagonal grid, to start at `startpoint` and proceed along the x-axis and
then along the y-axis, `radius` is the radius of a circle that encloses each hexagon.
The distance in `x` between the centers of successive hexagons is:

``\\frac{\\sqrt{(3)} \\text{radius}}{2}``

To get the next point from the grid, use `nextgridpoint(g::Grid)`.

When you run out of grid points, you'll wrap round and start again.
"""
mutable struct GridHex
    startpoint::Point
    radius::Float64
    currentpoint::Point
    width::Float64
    height::Float64
    rownumber::Int
    colnumber::Int
    function GridHex(startpoint, radius, width = 1200.0, height = 1200.0)
        rownumber = 1
        colnumber = 0
        # find the "previous" point, so that the first call gets the real first point
        currentpoint = Point(startpoint.x - (sqrt(3) * radius), startpoint.y)
        new(startpoint, radius, currentpoint, width, height, rownumber, colnumber)
    end
end

"""
    nextgridpoint(g::GridRect)

Returns the next available (or even the first) grid point of a grid.
"""
function nextgridpoint(g::GridRect)
    temp = Point(g.currentpoint.x + g.xspacing, g.currentpoint.y)
    if g.xspacing == 0
        g.rownumber += 1
        g.colnumber = 1
        g.currentpoint = Point(g.startpoint.x, temp.y + g.yspacing)
    else
        g.colnumber += 1
        g.currentpoint = temp
    end
    if abs(g.startpoint.x - temp.x) >= g.width # next row?
        g.rownumber += 1
        g.colnumber = 1
        g.currentpoint = Point(g.startpoint.x, temp.y + g.yspacing)
    end
    if g.currentpoint.y >= g.height   # finished, start again?
        g.rownumber = 1
        g.colnumber = 1
        g.currentpoint = Point(g.startpoint.x, g.startpoint.y)
    end
    return g.currentpoint
end

"""
    nextgridpoint(g::GridHex)

Returns the next available grid point of a hexagonal grid.
"""
function nextgridpoint(g::GridHex)
    g.currentpoint = Point(g.currentpoint.x + (g.radius * sqrt(3)), g.currentpoint.y)
    g.colnumber += 1
    if g.currentpoint.x >= g.width                 # next row
        g.rownumber += 1
        g.colnumber = 1
        if g.rownumber % 2 == 0
            g.currentpoint = Point(g.startpoint.x + (sqrt(3) * g.radius) / 2, g.currentpoint.y + (3 / 2) * g.radius)
        else
            g.currentpoint = Point(g.startpoint.x, g.currentpoint.y + (3 / 2) * g.radius)
        end
    end
    if g.currentpoint.y >= g.height     # finished?
        g.rownumber = 1                 # start again...
        g.colnumber = 1
        g.currentpoint = Point(g.startpoint.x, g.startpoint.y)
    end
    return g.currentpoint
end

"""
    p = Partition(areawidth, areaheight, tilewidth, tileheight)

A Partition is an iterator that, for each iteration, returns a tuple of:

  - the `x`/`y` point of the center of each tile in a set of tiles that divide up a
    rectangular space such as a page into rows and columns (relative to current 0/0)

  - the number of the tile

`areawidth` and `areaheight` are the dimensions of the area to be tiled,
`tilewidth`/`tileheight` are the dimensions of the tiles.

Tiler and Partition are similar:

  - Partition lets you specify the width and height of a cell

  - Tiler lets you specify how many rows and columns of cells you want, and a margin

    ```julia
    tiles = Partition(1200, 1200, 30, 30)
    for (pos, n) in tiles

        # the point pos is the center of the tile

    end
    ```

You can access the calculated tile width and height like this:

```julia
tiles = Partition(1200, 1200, 30, 30)
for (pos, n) in tiles
    ellipse(pos.x, pos.y, tiles.tilewidth, tiles.tileheight, :fill)
end
```

It's sometimes useful to know which row and column you're currently on:

    tiles.currentrow
    tiles.currentcol

should have that information for you.

Unless the tilewidth and tileheight are exact multiples of the area width and height, you'll
see a border at the right and bottom where the tiles won't fit.
"""
mutable struct Partition
    areawidth::Union{Float64, Int}
    areaheight::Union{Float64, Int}
    tilewidth::Union{Float64, Int}
    tileheight::Union{Float64, Int}
    nrows::Int
    ncols::Int
    currentrow::Int
    currentcol::Int
    function Partition(areawidth, areaheight, tilewidth, tileheight)
        ncols = areawidth / tilewidth |> floor |> Integer
        nrows = areaheight / tileheight |> floor |> Integer
        if ncols < 1 || nrows < 1
            throw(error("partition(): not enough space for tiles that size"))
        end
        currentrow = 1
        currentcol = 1
        new(areawidth, areaheight, tilewidth, tileheight, nrows, ncols, currentrow, currentcol)
    end
end

function Base.iterate(pt::Partition)
    x = -(pt.areawidth / 2) + (pt.tilewidth / 2)
    y = -(pt.areaheight / 2) + (pt.tileheight / 2)
    tilenumber = 1
    x1 = x + pt.tilewidth
    y1 = y
    if (x1 + pt.tilewidth / 2) > (pt.areawidth / 2)
        y1 += pt.tileheight
        x1 = -(pt.areawidth / 2) + (pt.tilewidth / 2)
    end
    pt.currentrow, pt.currentcol = (div(tilenumber - 1, pt.ncols) + 1, mod1(tilenumber, pt.ncols))
    return ((Point(x, y), tilenumber), (Point(x1, y1), tilenumber + 1))
end

function Base.iterate(pt::Partition, state)
    if state[2] > (pt.nrows * pt.ncols)
        return
    end
    x = state[1].x
    y = state[1].y
    tilenumber = state[2]
    x1 = x + pt.tilewidth
    y1 = y
    if (x1 + pt.tilewidth / 2) > (pt.areawidth / 2)
        y1 += pt.tileheight
        x1 = -(pt.areawidth / 2) + (pt.tilewidth / 2)
    end
    pt.currentrow, pt.currentcol = (div(tilenumber - 1, pt.ncols) + 1, mod1(tilenumber, pt.ncols))
    return ((Point(x, y), tilenumber), (Point(x1, y1), tilenumber + 1))
end

function Base.length(pt::Partition)
    pt.nrows * pt.ncols
end

function Base.getindex(pt::Partition, i::Int)
    1 <= i <= pt.ncols * pt.nrows || throw(BoundsError(pt, i))
    xcoord = -pt.areawidth / 2 + mod1(i, pt.ncols) * pt.tilewidth - pt.tilewidth / 2
    ycoord = -pt.areaheight / 2 + (div(i - 1, pt.ncols) * pt.tileheight) + pt.tileheight / 2
    return (Point(xcoord, ycoord), i)
end

"""
    box(tiles::Tiler, n::Integer; action=:none, vertices=false, reversepath=false)
    box(tiles::Tiler, n::Integer, action::Symbol=:none; vertices=false, reversepath=false)

Draw a box in tile `n` of tiles `tiles`.
"""
function box(tiles::Tiler, n::Integer;
    action = :none,
    vertices = false,
    reversepath = false)
    tilew, tileh = tiles.tilewidth, tiles.tileheight
    if vertices == true || action == :none
        box(first(tiles[n]), tilew, tileh, action = :none, vertices = true, reversepath = reversepath)
    else
        box(first(tiles[n]), tilew, tileh, action = action, vertices = false, reversepath = reversepath)
    end
end

box(tiles::Tiler, n::Integer, action::Symbol;
    vertices = false, reversepath = false) =
    box(tiles, n, action = action, vertices = vertices, reversepath = reversepath)

"""
    BoundingBox(t::Tiler, n)

Return the Bounding Box enclosing tile `n`.
"""
function BoundingBox(t::Tiler, n)
    BoundingBox(box(first.(t)[n], t.tilewidth, t.tileheight))
end

"""
    BoundingBox(t::Tiler, r, c)

Return the Bounding Box enclosing the tile at row `r` column `c`.
"""
function BoundingBox(t::Tiler, r, c)
    return BoundingBox(t, ((r - 1) * t.ncols) + c)
end

"""
    markcells(t::Union{Tiler, Table}, cells;
        action = :stroke,
        func = nothing)

Mark the cells of Tiler/Table `t` in the `cells`.

By default a box is drawn around the cell using the current settings and filled or stroked according to `action`.

You can supply a function for the `func` keyword that can do anything you want.
The function should accept four arguments, `position`, `width`, `height`, and
`number`.

## Example

This code draws 30 circles in 5 rows and 6 columns, numbered and colored
sequentially in four colors. `getcells()` obtains a selection of the cells
from the Tiler.

```julia
@draw begin
    fontsize(30)
    #t = Table(5, 6, 60, 60)
    t = Tiler(400, 400, 5, 6)
    markcells(t, getcells(t, 1:30),
        func = (pos, w, h, n) -> begin
            sethue(["red", "green", "blue", "purple"][mod1(n, end)])
            circle(pos, w / 2, :fill)
            sethue("white")
            text(string(n), pos, halign = :center, valign = :middle)
        end)
end
```
"""
function markcells(t::Union{Tiler,Table}, cells;
        action = :stroke,
        func = nothing)
    @layer begin
        for cell in cells
            pos, n = cell
            row, col = (1 + div(n - 1, t.ncols)), mod1(n, t.ncols)
            if t isa Table
                w = t.colwidths[col]
                h = t.rowheights[row]
            else
                w = t.tilewidth
                h = t.tileheight
            end
            if isnothing(func)
                # just draw a box with current settings
                box(pos, w, h, action)
            else
                func(pos, w, h, n)
            end
        end
    end
end

"""
    getcells(t, rows, columns)

Get the Tiler or Table cells in `t` corresponding to `rows` and `columns`.

- `t` is a Tiler or Table

- `rows` is an array or range of row numbers
- `cols` is an array or range of column numbers

Use `:` for "all rows" or "all columns".

Returns an array of Tuples, where each Tuple is `(Point, Number)`.

`markcells()` can use the result of this function to mark selected cells.

## Example

```julia
@draw begin
    chessboard = Tiler(600, 600, 8, 8)
    # odd rows odd columns
    s = getcells(chessboard, 1:2:12, 1:2:12)
    markcells(chessboard, s, action = :fill)
    # even rows even columns
    s = getcells(chessboard, 2:2:12, 2:2:12)
    markcells(chessboard, s, action = :fill)
end
```
"""
function getcells(t::Union{Table,Tiler}, rows, columns)
    result = Tuple[]
    for r in rows
        r < 1 && continue
        r > t.nrows && continue
        for c in columns
            c < 1 && continue
            c > t.ncols && continue
            n = ((r - 1) * t.ncols) + c
            push!(result, (t[r, c], n))
        end
    end
    return result
end

getcells(t::Table, ::Colon, ::Colon) = getcells(t, 1:(t.nrows), 1:(t.ncols))
getcells(t::Table, ::Colon, columns) = getcells(t, 1:(t.nrows), columns)
getcells(t::Table, rows, ::Colon) = getcells(t, rows, 1:(t.ncols))

getcells(t::Tiler, ::Colon, ::Colon) = getcells(t, 1:(t.nrows), 1:(t.ncols))
getcells(t::Tiler, ::Colon, columns) = getcells(t, 1:(t.nrows), columns)
getcells(t::Tiler, rows, ::Colon) = getcells(t, rows, 1:(t.ncols))

"""
    getcells(t, n::T) where T <: AbstractRange

Get the Tiler/Table cells with numbers in range `n`.

Returns an array of Tuples, where each Tuple is `(Point, Number)`.
"""
function getcells(t, n::T) where {T<:AbstractRange}
    result = Tuple[]
    for i in n
        append!(result, getcells(t, i))
    end
    return result
end

"""
    getcells(t, a::T) where T <: AbstractArray

Get the Tiler/Table cells with numbers in array `a`.

Returns an array of Tuples, where each Tuple is `(Point, Number)`.
"""
function getcells(t, a::T) where {T<:AbstractArray}
    result = Tuple[]
    for i in a
        append!(result, getcells(t, i))
    end
    return result
end

"""
    getcells(t, n::Int)

Get the cell `n` in Tiler or Table `t`.

Returns an array of Tuples, where each Tuple is `(Point, Number)`.

!!! note

    Luxor Tables and Tilers are numbered by row then column, rather than the usual Julia column-major numbering:

```
 1  2  3  4  5
 6  7  8  9 10
11 12 13 14 15
16 17 18 19 20
```
"""
getcells(t::Table, n::Int) = [(t[n], n)] # array of tuples
getcells(t::Tiler, n::Int) = [(t[n])] # array of tuples

"""
An EquilateralTriangleGrid is an iterator that makes a grid of equilateral
triangles with side length `side` positioned on a rectangular grid with `nrows`
and `ncols`.

```julia
EquilateralTriangleGrid(startpoint::Point, side, nrows, ncols; up = true)
```

The first triangle is centered at `startpoint` and points up if `up` is true.

###Example

```julia
nrows = 5
ncols = 8
side = 150
eqtg = EquilateralTriangleGrid(O, side, nrows, ncols)

@show first(eqtg)
# (Point[Point(-75.0, 64.9519052838329), 
         Point(0.0, -64.9519052838329), 
         Point(75.0, 64.9519052838329)], 1)

# now you can use the iterator to generate (and draw) triangles:
for tri in eqtg
    vertices, trianglenumber = tri
    randomhue()
    poly(vertices, :fill)
end
```
"""
mutable struct EquilateralTriangleGrid
    startpoint::Point
    side::Union{Float64,Int}
    nrows::Int64
    ncols::Int64
    currentrow::Int64
    currentcol::Int64
    up::Bool
    function EquilateralTriangleGrid(startpoint, side, nrows, ncols; up = true)
        if nrows < 1 || ncols < 1
            throw(error("EquilateralTriangleGrid: grid must have rows and columns, not $nrows rows, $ncols columns"))
        end
        currentrow = 1
        currentcol = 1
        new(startpoint, side, nrows, ncols, currentrow, currentcol, up)
    end
end

"""
    _equilateral_triangle(center::Point, side, dir=:up)

Return vertices of equilateral triangle, `center` is the centroid,
`side` is the side length, `dir` is `:up` for △ (or something else for ▽)
"""
function _equilateral_triangle(center::Point, side, dir = :up)
    h = (sqrt(3) * side) / 2
    if dir == :up
        return Point[
            Point(center.x - side / 2, center.y + h / 2),
            Point(center.x, center.y - h / 2),
            Point(center.x + side / 2, center.y + h / 2),
        ]
    else
        return Point[
            Point(center.x - side / 2, center.y - h / 2),
            Point(center.x + side / 2, center.y - h / 2),
            Point(center.x, center.y + h / 2),
        ]
    end
end

function Base.iterate(eqt::EquilateralTriangleGrid)
    eqt.currentrow, eqt.currentcol = 1, 1
    cellnumber = (eqt.currentrow - 1) * eqt.nrows + eqt.currentcol
    h = (sqrt(3) * eqt.side) / 2
    r = (eqt.side * sqrt(3)) / 3 # circumradius
    pointup = (isodd(eqt.currentrow) && isodd(eqt.currentcol)) || (iseven(eqt.currentrow) && iseven(eqt.currentcol)) ? eqt.up : !eqt.up
    # the first triangle
    cpt_c = Point(eqt.startpoint.x + ((eqt.side / 2) * eqt.currentcol) - eqt.side / 2,
        eqt.startpoint.y + (h * eqt.currentrow) - h)
    pts_c = _equilateral_triangle(cpt_c, eqt.side, pointup ? :up : :down)
    # next one
    cpt_n = Point(eqt.startpoint.x + (eqt.side / 2 * eqt.currentcol),
        eqt.startpoint.y + (h * eqt.currentrow))
    pts_n = _equilateral_triangle(cpt_n, eqt.side, pointup ? :down : :up)
    return ((pts_c, cellnumber), (pts_n, cellnumber + 1))
end

function Base.iterate(eqt::EquilateralTriangleGrid, state)
    cellnumber = state[2]
    if cellnumber > (eqt.nrows * eqt.ncols)
        return
    end
    eqt.currentcol += 1
    if eqt.currentcol > eqt.ncols
        eqt.currentcol = 1
        eqt.currentrow += 1
    end
    h = (sqrt(3) * eqt.side) / 2
    r = (eqt.side * sqrt(3)) / 3
    pointup = (isodd(eqt.currentrow) && isodd(eqt.currentcol)) || (iseven(eqt.currentrow) && iseven(eqt.currentcol)) ? eqt.up : !eqt.up

    cpt_c = Point(eqt.startpoint.x + ((eqt.side / 2) * eqt.currentcol) - eqt.side / 2,
        eqt.startpoint.y + (h * eqt.currentrow) - h)
    pts_c = _equilateral_triangle(cpt_c, eqt.side, pointup ? :up : :down)
    cpt_n = Point(eqt.startpoint.x + (eqt.side / 2 * eqt.currentcol), eqt.startpoint.y + (h * eqt.currentrow))
    pts_n = _equilateral_triangle(cpt_n, eqt.side, pointup ? :down : :up)
    return ((pts_c, cellnumber), (pts_n, cellnumber + 1))
end

function Base.length(eqt::EquilateralTriangleGrid)
    eqt.nrows * eqt.ncols
end

function Base.getindex(eqt::EquilateralTriangleGrid, i::Int)
    1 <= i <= eqt.ncols * eqt.nrows || throw(BoundsError(eqt, i))
    h = (sqrt(3) * eqt.side) / 2
    c = mod1(i, eqt.ncols)
    r = 1 + div(i - 1, eqt.ncols)
    pointup = (isodd(r) && isodd(c)) || (iseven(r) && iseven(c)) ? eqt.up : !eqt.up
    cpt_c = Point(eqt.startpoint.x + (eqt.side / 2 * c), eqt.startpoint.y + (h * r))
    pts_c = _equilateral_triangle(cpt_c, eqt.side, pointup ? :up : :down)
    return pts_c
end

function Base.size(eqt::EquilateralTriangleGrid)
    return (eqt.nrows, eqt.ncols)
end

#!/usr/bin/env julia

using Luxor, Test

using Random
Random.seed!(42)

function findanddrawsometangentialcircles(c1center, c1radius, c2center, c2radius)
    for requiredradius in 1:150
        res = circletangent2circles(requiredradius, c1center, c1radius, c2center, c2radius)
        setopacity(0.5)
        if first(res) == 1
            circle(res[2], requiredradius, :stroke)
        elseif first(res) == 2
            circle(res[2], requiredradius, :stroke)
            circle(res[3], requiredradius, :stroke)
        elseif first(res) == 0
            sethue("red")
            circle(c1center, 5, :fill)
            circle(c2center, 5, :fill)
        end
    end
end

function test_circletangents(fname)
    pagewidth, pageheight = 1200, 1400
    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("ivory")
    setline(0.5)
    tiles = Tiler(1200, 1400, 5, 5)
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            circle1 = (O + Point(rand(-20:20), rand(-20:20)), rand(20:40))
            circle2 = (O + Point(rand(-20:20), rand(-20:20)), rand(20:40))
            sethue("black")
            setopacity(0.5)
            circle(circle1..., :fill)
            circle(circle2..., :fill)
            setopacity(1.0)
            circle(circle1..., :stroke)
            circle(circle2..., :stroke)
            sethue("purple")
            findanddrawsometangentialcircles(circle1[1], circle1[2], circle2[1], circle2[2])
        end
    end

    @test finish() == true
    println("...finished circle tangent test, saved in $(fname)")
end

fname = "circletangent-test.pdf"

test_circletangents(fname)

struct BoxmapTile
    x::Float64
    y::Float64
    w::Float64
    h::Float64
end


"""
    buildrow(A, x, y, w, h)

Make a row of tiles from A.
"""
function buildrow(A, x, y, w, h)
    covered = sum(A)
    width = covered/h
    tiles = BoxmapTile[]
    for value in A
        push!(tiles, BoxmapTile(x, y, width, value/width))
        y += value/width
    end
    return tiles
end

"""
    buildcolumn(A, x, y, w, h)

Make a column of tiles from A.
"""
function buildcolumn(A, x, y, w, h)
    covered = sum(A)
    height = covered/w
    tiles = BoxmapTile[]
    for value in A
        push!(tiles, BoxmapTile(x, y, value/height, height))
        x += value/height
    end
    return tiles
end

"""
    layout(A, x, y, w, h)

From A, make a row of tiles (if wider than tall) or a column of tiles (if taller than wide).
"""
function layout(A, x, y, w, h)
    if w >= h
        return buildrow(A, x, y, w, h)
    else
        return buildcolumn(A, x, y, w, h)
    end
end

function rowlayoutleftover(A, x, y, w, h)
    covered = sum(A)
    width = covered/h
    layoutleftoverx = x + width
    layoutleftoverw = w - width
    return layoutleftoverx, y, layoutleftoverw, h
end

function columnlayoutleftover(A, x, y, w, h)
    covered = sum(A)
    height = covered/w
    layoutleftovery = y + height
    layoutleftoverh = h - height
    return x, layoutleftovery, w, layoutleftoverh
end

function layoutleftover(A, x, y, w, h)
    if w >= h
        return rowlayoutleftover(A, x, y, w, h)
    else
        return columnlayoutleftover(A, x, y, w, h)
    end
end

"""
    highestaspectratio()

Find the highest aspect ratio of a list of rectangles, given the length
of the side along which they are to be laid out.
"""
function highestaspectratio(A, x, y, w, h)
    return maximum([max(tile.w/tile.h, tile.h/tile.w) for tile in layout(A, x, y, w, h)])
end

function buildboxmap(A, x, y, w, h)
    length(A) == 0 && return []
    length(A) == 1 && return layout(A, x, y, w, h)
    i = 1
    while i < length(A) &&
        (highestaspectratio(A[1:i], x, y, w, h) >= highestaspectratio(A[1:i+1], x, y, w, h))
        i += 1
    end
    layoutleftoverx, layoutleftovery, layoutleftoverw, layoutleftoverh = layoutleftover(A[1:i], x, y, w, h)
    return append!(
        layout(A[1:i], x, y, w, h),
        buildboxmap(A[(i+1):end], layoutleftoverx, layoutleftovery, layoutleftoverw, layoutleftoverh)
    )
end

"""
    boxmap(A::Array, pt, w, h)

Build a box map of the values in `A` with one corner at `pt` and width `w` and
height `h`. There are `length(A)` boxes. The areas of the boxes are proportional
to the original values, scaled as necessary.

The return value is an array of BoxmapTiles. For example:

```julia
[BoxmapTile(0.0, 0.0, 10.0, 20.0)
 BoxmapTile(10.0, 0.0, 10.0, 13.3333)
 BoxmapTile(10.0, 13.3333, 10.0, 6.66667)]
```

with each tile containing `(x, y, w, h)`. `box()` and `BoundingBox()` can work with
BoxmapTiles as well.

# Example

```julia
using Luxor
@svg begin
    fontsize(16)
    fontface("HelveticaBold")
    pt = Point(-200, -200)
    a = rand(10:200, 15)
    tiles = boxmap(a, Point(-200, -200), 400, 400)
    for (n, t) in enumerate(tiles)
        randomhue()
        bb = BoundingBox(t)
        box(bb - 2, :stroke)
        box(bb - 5, :fill)
        sethue("white")
        text(string(n), midpoint(bb[1], bb[2]), halign=:center)
    end
end 400 400 "boxmap.svg"
```
"""
function boxmap(A::Array, pt::Point, w, h)
    # algorithm basically from Bruls, Huizing, van Wijk, "Squarified Treemaps"
    # without the silly name
    !all(n -> n > 0, A) && error("all values must be positive")
    sort!(A, rev=true)
    totalvalue = sum(A)
    totalarea = w * h
    normalizedA = A .* (totalarea/totalvalue)
    return buildboxmap(normalizedA, pt.x, pt.y, w, h)
end

"""
    box(tile::BoxmapTile, action::Symbol=:none; vertices=false)
    box(tile::BoxmapTile, action=:none, vertices=false)

Use a Boxmaptile to make or draw a rectangular box. Use `vertices=true` to obtain
the coordinates.

Create boxmaps using `boxmap()`.
"""
function box(tile::BoxmapTile, action::Symbol; vertices=false)
    if vertices
        return [Point(tile.x,           tile.y + tile.h),
                Point(tile.x,           tile.y),
                Point(tile.x + tile.w,  tile.y),
                Point(tile.x + tile.w,  tile.y + tile.h)]
    end
    rect(tile.x, tile.y, tile.w, tile.h, action)
end

box(tile::BoxmapTile; action=:none, vertices=false) =
    box(tile, action, vertices=vertices)

"""
    BoundingBox(tile::BoxmapTile)

Return a BoundingBox of a BoxmapTile (as created with `boxmap()`).
"""
function BoundingBox(tile::BoxmapTile)
    lcorner = Point(tile.x, tile.y)
    ocorner = Point(lcorner.x + tile.w, lcorner.y + tile.h)
    return BoundingBox(lcorner, ocorner)
end

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_epitrochoid(fname)
    Drawing(1400, 1400, fname)
    origin()
    background("grey20")
    sethue("antiquewhite")
    setopacity(0.8)
    tiles = Tiler(1200, 1200, 6, 6)
    for (pos, n) in tiles
        gsave()
        setline(.5)
        translate(pos)

        R = 20; r = n; d = 20
        sethue("antiquewhite")
        poly(epitrochoid(R, n, d, :stroke, stepby=pi/300, vertices=true), :stroke, close=true)
        text(string("R = $(R), r = $(r), d = $(d)"), halign=:center, O.x, O.y+tiles.tileheight/2)

        # test perimeterlength
        ptslist = epitrochoid(R, n, d, :stroke, stepby=pi/300, vertices=true)
        polyperimeter(ptslist)

        R = 20; r = 12; d = 5
        sethue("orange")
        (R == r) && (r += 1)
        p = epitrochoid(R, r, d, :none, stepby=pi/305, vertices=true)
        polydistances(p)
        text(string("R = $(R), r = $(r), d = $(d)"), halign=:center, O.x, O.y+tiles.tileheight/2 + 10)
        poly(p, :stroke, close=true)

        # testing portions of polys
        sethue("magenta")
        portion = rand()
        poly(polyportion(p, portion), :stroke, close=false)
        text(string("portion ", round(portion, digits=2)), halign=:center, O.x, O.y+tiles.tileheight/2 + 30)

        sethue("cyan")
        setline(0.3)
        poly(offsetpoly(p, 5), :stroke, close=true)
        text("offset 15", halign=:center, O.x, O.y+tiles.tileheight/2 + 20)

        grestore()
    end
    @test finish() == true
end

Random.seed!(42)

fname = "epitrochoid-test.pdf"
test_epitrochoid(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor


using Random
Random.seed!(42)

using Test

function get_text_path()
    translate(-400, -400)
    fontsize(60)
    textpath("get polygons from paths")
    plist = pathtopoly()
    setline(0.5)
    for (n, pgon) in enumerate(plist)
        randomhue()
        prettypoly(pgon, :stroke, close=true)
    end
end

function get_circle_path()
    translate(200, 200)
    circlepath(O, 50, :path)
    plist = pathtopoly()
    setline(0.5)
    for (n, pgon) in enumerate(plist)
        sethue(rand(), 0.5, 0.6)
        poly(offsetpoly(pgon, 5), close=true, :stroke)
        prettypoly(pgon, :stroke, close=true)
    end
end

function get_line_path()
    origin()
    translate(0, 200)
    translate(0, 200)
    pts = ngon(O, 100, 7, vertices=true)
    move(pts[1])
    line(pts[2])
    line(pts[3])
    line(pts[4])
    line(pts[5])
    line(pts[6])
    line(pts[7])
    closepath()
    plist = pathtopoly()
    setline(0.5)
    for (n, pgon) in enumerate(plist)
        for i in 0:4:50
            sethue(i/50, 0.5, 0.6)
            poly(offsetpoly(pgon, i), :stroke, close=true)
        end
    end
end

function outline_string(s)
    origin()
    setlinejoin("butt")
    fontface("Times")
    fontsize(400)
    textpath(s)
    plist = pathtopoly()
    for (n, pgon) in enumerate(plist)
        for i in -10:4:10
            sethue(rand(), 0.5, 0.6)
            setopacity(rescale(i, -10, 10, 3, 0.2))
            poly(offsetpoly(pgon, i), :stroke, close=true)
        end
    end
end

function main_path_to_poly(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("white")
    get_text_path()
    get_circle_path()
    get_line_path()
    outline_string("πü")
    @test finish() == true
    println("...finished test: output in $(fname)")
end

main_path_to_poly("pathtopoly.pdf")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function textbox_tests(fname)
    Drawing(1000, 1000, fname)
    origin()
    setopacity(0.8)
    sethue("black")
    fontface("Georgia-Bold")
    tiles = Tiler(1000, 1000, 4, 3, margin=50)
    for (pos, n) in tiles
        fsize = 10
        fontsize(fsize)
        @layer begin
            translate(pos)
            sethue("ivory")
            box(O, tiles.tilewidth-2, tiles.tileheight-2, :fill)
            sethue("black")
            # even-numbered boxes split and count
            if iseven(n)
                opacity = 1.0
                # split on ., (, and )
                textbox(split("Luxor is a city in Upper (southern) Egypt. " ^ 6, r"\.|\(|\)"),
                O - (tiles.tilewidth/2 - 2, tiles.tileheight/2 - 2),
                # l is linenumber, t is the text of a line, p is the position of the start of the line, h is the interline height
                linefunc = (l, t, p, h) ->
                    begin
                        # add length of line at end
                        @layer begin
                            fontsize(8)
                            fontface("Menlo")
                            text(string(length(t)), p + (tiles.tilewidth - 20, 0))
                        end
                    end,
                    leading=10)
            else
                # odd-numbered boxes number and fade
                # split on the letter "y"
               textbox(split("Luxor is a city in Upper (southern) Egypt. " ^ 6, "y"),
                O - (tiles.tilewidth/2 - 2, tiles.tileheight/2 - 2),
                linefunc = (l, t, p, h) ->
                    begin
                        text(string(l), p + (tiles.tilewidth - 20, 0))
                        setopacity(rescale(l, 1, 10, 1.0, 0.3))
                    end,
                    leading=12)
            end
        end
    end

    fontsize(80)
    textbox("LUXOR", alignment=:center)
    
    @test finish() == true
    println("...finished test: output in $(fname)")
end

textbox_tests("textbox-tests.png")

using DataStructures: Stack

"""
    placeeps(epsfile; log=false)

This function loads and interprets an EPS file previously exported by
Cairo. Commands are 'applied' to the current drawing.

The primary intention is to extract some geometry  - points and curves,
etc. - from an EPS vector graphic.

!!! warning

    This function reads only 'Cairo-flavoured' EPS files. Every application that
    exports EPS files defines its own chosen set of PostScript functions in a
    prolog. There's no standard. The 'Cairo-flavoured' EPS prolog is hard-coded into
    EPS files exported from Cairo so it's predictable, but other EPS exporters
    define their own flavour, defining and calling who knows what PostScript
    functions. So it's unlikely that EPS files from other sources will be
    successfully processed with this function.

Also note:

- ignores clipping for now; I'm not sure how the Cairo->EPS->Cairo transformations work yet

- ignores `rectfill`` commands for now - I think these are often used just for
  the initial BoundingBoxes/clipping, but if they're used matrix transforms
  they'll need interpreting somehow

- ignores blends and gradients, embedded images, embedded fonts, among many other things...

Use `log` to print the commands to the REPL as well as execute them.

## Examples

```julia
@draw begin
    translate(boxtopleft())
    Luxor.placeeps("/tmp/julia.eps")
end
```

You can convert an SVG file to EPS by reading the SVG into Luxor, saving as EPS, then
placing that saved EPS file onto a new drawing:

```julia
svgfile = readsvg("julia.svg")
@eps begin
    placeimage(svgfile, centered = true)
end 800 500 "/tmp/julia.eps"
@draw begin
    translate(boxtopleft())
    placeeps("/tmp/julia.eps")
end
```

If you want to put the list of Luxor commands in a text file for pasting into
another file, you could try this (Julia v.1.7 and up). Let's say you have an SVG
called `julia.svg`.

```julia
# load an SVG and save as EPS
@eps begin
    svgf = readsvg("julia.svg")
    placeimage(svgf, centered = true)
end 500 500 "/tmp/t.eps"

# convert EPS to Luxor commands
redirect_stdio(stdout = "/tmp/output.jl") do
    placeeps("/tmp/t.eps", log = true)
end

# include Luxor commands and save as a new SVG:
@svg begin
    translate(boxtopleft())
    include("/tmp/output.jl")
end 500 500 "/tmp/julia.svg"
```
"""
function placeeps(epsfile;
        log = false)
    if !isfile(epsfile)
        @warn " $epsfile is not a file that I can find..."
        return false
    end
    lines = readlines(epsfile)
    prolog = false
    s = Stack{Any}() # holds numbers, string commands, etc...
    log && println("# start EPS import")
    for i in lines
        if i == "%%EndPageSetup"
            prolog = false
        end
        if startswith(i, "%%Creator")
            if !occursin("cairo", i)
                @warn "This EPS file was not created with Cairo. Expect disappointment and failure in equal measure."
            end
        end
        if startswith(i, "%!PS-Adobe-3.0")
            prolog = true
        end
        if prolog == true
            continue
        end
        if startswith(i, "%")
            continue
        end
        tkns = split(i)
        for tkn in tkns
            if length(tkn) > 32
                # long tokens are probably image or font data
                # so ignore them
                continue
            end
            # hopefully there are some numbers in this file?
            n = tryparse(Float64, tkn)
            if !isnothing(tryparse(Float64, tkn))
                # push numbers onto stack
                push!(s, parse(Float64, tkn))
            elseif tkn == "m"
                p1 = pop!(s)
                p2 = pop!(s)
                move(Point(p2, (p1)))
                log && println("move(Point($(p2), $(p1)))")
            elseif tkn == "l" # lineto
                p1 = pop!(s)
                p2 = pop!(s)
                line(Point(p2, p1))
                log && println("line(Point($(p2), $(p1)))")
            elseif tkn == "c" # curveto
                p1 = pop!(s)
                p2 = pop!(s)
                p3 = pop!(s)
                p4 = pop!(s)
                p5 = pop!(s)
                p6 = pop!(s)
                curve(Point(p6, p5), Point(p4, p3), Point(p2, p1))
                log && println("curve(Point($(p6), $(p5)), Point($(p4), $(p3)), Point($(p2), $(p1)))")
            elseif tkn == "h" # closepath
                closepath()
                log && println("closepath()")
            elseif tkn == "S" # stroke
                strokepath()
                log && println("strokepath()")
            elseif tkn == "f" # fill
                fillpath()
                log && println("fillpath()")
            elseif tkn == "f*" # eofill
                log && println("# eofill?")
            elseif tkn == "n" # newpath
                newpath()
                log && println("newpath()")
            elseif tkn == "g"
                p1 = pop!(s)
                setgray(p1)
                log && println("setgray($(p1))")
            elseif tkn == "rg"
                p1 = pop!(s)
                p2 = pop!(s)
                p3 = pop!(s)
                sethue(p3, p2, p1)
                log && println("sethue($(p3), $(p2), $(p1))")
            elseif tkn == "q" # gsave
                gsave()
                log && println("gsave()")
            elseif tkn == "Q" # grestore
                grestore()
                clipreset() # does clipping get reset by grestore ?
                log && println("grestore(); clipreset()")
            elseif tkn == "cm" # matrix
                p1 = pop!(s)
                p2 = pop!(s)
                p3 = pop!(s)
                p4 = pop!(s)
                p5 = pop!(s)
                p6 = pop!(s)
                m = [p6, p5, p4, p3, p2, p1]
                # matrix transforms ignored
                # setmatrix([$p6, $p5, $p4, $p3, $p2, $p1])
                log && println("# setmatrix([$p6, $p5, $p4, $p3, $p2, $p1])")
            elseif tkn == "w" # linewidth
                p1 = pop!(s)
                setline(p1)
                log && println("setline($(p1))")
            elseif tkn == "J"
                # 0 (butt caps), 1 (round caps), or 2 (extended butt caps)
                p1 = convert(Int, pop!(s) + 1)
                v = ["butt", "round", "square"][p1]
                setlinecap("\"$(v)\"")
                log && println("setlinecap(\"$(v)\")")
            elseif tkn == "j"
                # 0 (miter join), 1 (round join), or 2 (bevel join)
                p1 = convert(Int, pop!(s) + 1)
                v = ["miter", "round", "bevel"][p1]
                setlinejoin("\"$(v)\"")
                log && println("setlinejoin(\"$(v)\")")
            elseif tkn == "[]" # tis an empty array
                push!(s, "[")
                push!(s, "]")
            elseif tkn == "d"  # dash patterns are an array of numbers
                darray = Float64[]
                for e in Iterators.reverse(s)
                    if e isa Number
                        push!(darray, e)
                    end
                    if e == "]"
                        break
                    end
                end
                setdash(darray)
            elseif tkn == "W"  # clip
                clip()
            elseif tkn == "M"  # miterlimit
                p1 = pop!(s)
                # setmiterlimit($p1)") # is this in Luxor or Cairo yet?
                log && println("# setmiterlimit($(p1))")
            elseif tkn == "re" # ????
                # 0 0 500 174 re W n
                p1 = pop!(s)
                p2 = pop!(s)
                p3 = pop!(s)
                p4 = pop!(s)
                rect(Point(p4, p3), p2, p1, action = :path)
                log && println("# re command... ")
                log && println(" rect(Point($p4, $p3), $p2, $p1, action = :path)")
            elseif tkn == "rectfill"
                # probably used for the initial crop box, so don't draw
                p1 = pop!(s)
                p2 = pop!(s)
                p3 = pop!(s)
                p4 = pop!(s)
                # rectfill
                # rect(Point($(p4), $(p3)), $(p2), $(p1), action=:stroke)
                log && println("# rect(Point($(p4), $(p3)), $(p2), $(p1), action=:stroke)")
            elseif endswith(tkn, "]")
                val = chop(tkn)
                if tryparse(Float64, val) == true
                    push!(s, parse(Float64, val))
                end
                push!(s, "]")
            elseif tkn == "["
                push!(s, tkn)
            elseif startswith(tkn, "[")
                val = chop(tkn, head = 1, tail = 0)
                push!(s, "[")
                push!(s, parse(Float64, val))
            elseif tkn == "rectclip"
                p1 = pop!(s)
                p2 = pop!(s)
                p3 = pop!(s)
                p4 = pop!(s)
                # a rectclip, will be ignored for now:
                # rect(Point($(p4), $(p3)), $(p2), $(p1), action=:clip)
                log && println("# rectclip ignored ")
                log && println("# rect(Point($(p4), $(p3)), $(p2), $(p1), action=:clip) ")
            elseif tkn == "showpage" || tkn == "end"
                #
            elseif tkn == "cairo_image"
                # AAARGH! file contains image and binary data ...
                log && println("# file contains image data, ignoring... ")
            else
                log && println("# &tkn ")
            end
        end
    end
    log && println("# end EPS import")
    return true # anything better to return?
end

const Mesh = Cairo.CairoPattern

"""
    add_mesh_patch(pattern::Mesh, bezierpath::BezierPath,
        colors=Vector{Colors.Colorant})

Add a new patch to the mesh pattern in `pattern`.

The first three or four elements of the supplied `bezierpath`
define the three or four sides of the mesh shape.

The `colors` array define the color of each corner point. Colors are reused
if necessary. At least one color should be supplied.

Use `setmesh()` to select the mesh, which will be used to fill shapes.
"""
function add_mesh_patch(pattern::Mesh, bezierpath::BezierPath, colors=Vector{Colors.Colorant})
    Cairo.mesh_pattern_begin_patch(pattern)
    # we must do 3 or 4 vertices, so need 2, 3, and possibly 4
    if length(bezierpath) == 3
        pts = bezierpath[2:3]
        vcount = 3
    elseif length(bezierpath) >= 4
        pts = bezierpath[2:4]
        vcount = 4
    else
        throw(error("_add_mesh_patch(): patch should provide 3 or 4 points, not $(length(bezierpath))"))
    end
    # use first point
    Cairo.mesh_pattern_move_to(pattern, bezierpath[1][1].x, bezierpath[1][1].y)
    # then get next 2 or 3
    for bp in bezierpath
        Cairo.mesh_pattern_curve_to(pattern, bp[2].x, bp[2].y, bp[3].x, bp[3].y, bp[4].x, bp[4].y)
    end

    for n in 1:vcount
        col = colors[mod1(n, length(colors))]
        if !(col isa Colorant)
            col = parse(RGBA, col)
        end
        # always use RGBA, even if RGB supplied
        col = convert(RGBA, col)
        Cairo.mesh_pattern_set_corner_color_rgba(pattern, n - 1, col.r, col.g, col.b, col.alpha)
    end
    Cairo.mesh_pattern_end_patch(pattern)
    return pattern
end

"""
    add_mesh_patch(pattern::Mesh, plist::Array{Point}, colors=Vector{Colors.Colorant})

Add a new patch to the mesh pattern in `pattern`.

The first three or four sides of the supplied `points` polygon
define the three or four sides of the mesh shape.

The `colors` array define the color of each corner point. Colors are reused
if necessary. At least one color should be supplied.
"""
function add_mesh_patch(pattern::Mesh, plist::Array{Point}, colors=Vector{Colors.Colorant})
    Cairo.mesh_pattern_begin_patch(pattern)
    # we must do 3 or 4 vertices, so need 2, 3, and possibly 4
    if length(plist) == 3
        pts = plist[2:3]
        vcount = 3
    elseif length(plist) >= 4
        pts = plist[2:4]
        vcount = 4
    else
        throw(error("_add_mesh_patch(): patch should provide 3 or 4 points, not $(length(plist))"))
    end
    # use first point
    Cairo.mesh_pattern_move_to(pattern, plist[1].x, plist[1].y)
    # then get next 2 or 3
    for pt in pts
        Cairo.mesh_pattern_line_to(pattern, pt.x, pt.y)
    end

    for n in 1:vcount
        col = colors[mod1(n, length(colors))]
        if !(col isa Colorant)
            col = parse(RGBA, col)
        end
        # always use RGBA, even if RGB supplied
        col = convert(RGBA, col)
        Cairo.mesh_pattern_set_corner_color_rgba(pattern, n - 1, col.r, col.g, col.b, col.alpha)
    end
    Cairo.mesh_pattern_end_patch(pattern)
    return pattern
end


"""
    mesh(bezierpath::BezierPath,
         colors=Vector{Colors.Colorant})

Create a mesh. The first three or four elements of the supplied `bezierpath`
define the three or four sides of the mesh shape.

The `colors` array define the color of each corner point. Colors are reused
if necessary. At least one color should be supplied.

Use `setmesh()` to select the mesh, which will be used to fill shapes.

# Example

```julia
@svg begin
    bp = makebezierpath(ngon(O, 50, 4, 0, vertices=true))
    mesh1 = mesh(bp, [
        "red",
        Colors.RGB(0, 1, 0),
        Colors.RGB(0, 1, 1),
        Colors.RGB(1, 0, 1)
        ])
    setmesh(mesh1)
    box(O, 500, 500, :fill)
end
```
"""
function mesh(bezierpath::BezierPath, colors=Vector{Colors.Colorant})
    pattern = Cairo.CairoPatternMesh()
    return add_mesh_patch(pattern, bezierpath, colors)
end

# old style for compatibility
mesh(bezierpath::Array{NTuple{4, Point}}, colors=Vector{Colors.Colorant}) =
    mesh(BezierPath(bezierpath), colors)

"""
    mesh(points::Array{Point}, colors=Vector{Colors.Colorant})

Create a mesh.

The first three or four sides of the supplied `points` polygon
define the three or four sides of the mesh shape.

The `colors` array define the color of each corner point. Colors are reused
if necessary. At least one color should be supplied.

# Example
```julia
@svg begin
    pl = ngon(O, 250, 3, pi/6, vertices=true)
    mesh1 = mesh(pl, [
        "purple",
        Colors.RGBA(0.0, 1.0, 0.5, 0.5),
        "yellow"
        ])
    setmesh(mesh1)
    setline(180)
    ngon(O, 250, 3, pi/6, :strokepreserve)
    setline(5)
    sethue("black")
    strokepath()
end
```
"""
function mesh(plist::Array{Point}, colors=Vector{Colors.Colorant})
    pattern = Cairo.CairoPatternMesh()
    return add_mesh_patch(pattern, plist, colors)
end

"""
    setmesh(mesh::Mesh)

Select a mesh, previously created with `mesh()`, for filling
and stroking subsequent graphics.
"""
function setmesh(m::Mesh)
    Cairo.set_source(Luxor._get_current_cr(), m)
end

"""
    origin()

Reset the current position, scale, and orientation, and then set the 0/0 origin to the center of the drawing
(otherwise it will stay at the top left corner, the default).

You can refer to the 0/0 point as `O`. (O = `Point(0, 0)`),
"""
function origin()
    setmatrix([1.0, 0.0, 0.0, 1.0, 0.0, 0.0])
    Cairo.translate(_get_current_cr(), _current_width() / 2.0, _current_height() / 2.0)
end

function origin(x, y)
    setmatrix([1.0, 0.0, 0.0, 1.0, 0.0, 0.0])
    Cairo.translate(_get_current_cr(), x, y)
end

"""
    origin(pt:Point)

Reset the current position, scale, and orientation, then move the `0/0` position to `pt`.
"""
function origin(pt)
    setmatrix([1.0, 0.0, 0.0, 1.0, 0.0, 0.0])
    Cairo.translate(_get_current_cr(), pt.x, pt.y)
end

"""
    rescale(x, from_min, from_max, to_min = 0.0, to_max = 1.0;
        easingfunction=easingflat)

Convert `x` from one scale (`from_min` to `from_max`) to another
(`to_min` to `to_max`).

The scales can also be supplied in tuple form:

```julia
rescale(x, (from_min, from_max), (to_min, to_max))
```

## Examples

```julia
julia> rescale(15, 0, 100, 0, 1)
0.15

julia> rescale(15, (0, 100), (0, 1))
0.15

julia> rescale(pi/20, 0, 2pi, 0, 1)
0.025

julia> rescale(pi/20, (0, 2pi), (0, 1))
0.025

julia> rescale(25, 0, 1, 0, 1.609344)
40.2336

julia> rescale(15, (0, 100), (1000, 0))
850.0
```

The function provides linear interpolation; but you can pass an
easing function to the `easingfunction` keyword.
"""

function rescale(x, from_min, from_max, to_min = 0.0, to_max = 1.0;
        easingfunction=easingflat)
    t = (x - from_min) / (from_max - from_min)
    t_eased = easingfunction(t, 0.0, 1.0, 1.0)
    return to_min + t_eased * (to_max - to_min)
end

rescale(x, from::NTuple{2,Number}, to::NTuple{2,Number}; easingfunction=easingflat) =
    rescale(x, from[1], from[2], to[1], to[2]; easingfunction=easingflat)

"""
    background(col::Colors.Colorant)

Paint the drawing (or the current clipping region, if there is one) with the
`color``. Previously-drawn graphics will be wholly or partly obscured depending on
the opacity of the color.

Returns a tuple `(r, g, b, a)` of the color that was used to paint the background.

The macros `@png`, `@draw`, and `@svg` use `background("white")` as part of the drawing set-up.

# Examples:

```julia
background("antiquewhite")
background(1, 0.0, 1.0)
background(1, 0.0, 1.0, .5)
background(Luxor.Colors.RGB(0, 1, 0))
```

If Colors.jl has been imported:

```julia
background(RGB(0, 1, 0))
background(RGBA(0, 1, 0))
background(RGBA(0, 1, 0, .5))
background(Luv(20, -20, 30))
```

If you don't specify a background color for a PNG drawing, the background will
be transparent. You can set a partly or completely transparent background for
PNG files by passing a color with an alpha value, such as this 'transparent
black':

```julia
background(RGBA(0, 0, 0, 0))
```

or

```julia
background(0, 0, 0, 0)
```

Returns a tuple `(r, g, b, a)` of the color that was used to paint the background.
"""
function background(col::Colors.Colorant)
    gsave()
    setcolor(col)
    paint()
    r, g, b, a = _get_current_redvalue(), _get_current_greenvalue(), _get_current_bluevalue(), _get_current_alpha()
    grestore()
    return (r, g, b, a)
end

function background(col::T) where {T<:AbstractString}
    return background(parse(Colorant, col))
end

function background(r, g, b, a = 1)
    return background(RGBA(r, g, b, a))
end

"""
    setantialias(n)

Set the current antialiasing to a value between 0 and 6:

    antialias_default  = 0, the default antialiasing for the subsystem and target device
    antialias_none     = 1, use a bilevel alpha mask
    antialias_gray     = 2, use single-color antialiasing (using shades of gray for black text on a white background, for example)
    antialias_subpixel = 3, take advantage of the order of subpixel elements on devices such as LCD panels
    antialias_fast     = 4, perform some antialiasing but prefer speed over quality
    antialias_good     = 5, balance quality against performance
    antialias_best     = 6, render at the highest quality, sacrificing speed if necessary

This affects subsequent graphics, but not text, and it
doesn't apply to all types of output file.
"""
setantialias(n) = Cairo.set_antialias(_get_current_cr(), n)

"""
    newpath()

Discard the current path's contents. After this, the current path is empty, and there's
no current point.
"""
newpath() = Cairo.new_path(_get_current_cr())

"""
    newsubpath()

Start a new subpath in the current path. After this, there's no current point.
"""
newsubpath() = Cairo.new_sub_path(_get_current_cr())

"""
    closepath()

Draw a line from the current point to the first point of the current subpath.
This is Cairo's `close_path()` function.
"""
closepath() = Cairo.close_path(_get_current_cr())

abstract type LDispatcher end
# Packages which want to override strokepath/fillpath/strokepreserve/fillpreserve
# can subtype an empty struct from this abstract type and dispatch on them .
# Make sure Luxor.DISPATCHER[1] is set to an instance of the struct you want to
# dispatch on in your module.

#Default luxor behaviour dispatches on `DefaultLuxor`
struct DefaultLuxor <: LDispatcher end
#global constant to decide dispatch, a single element array which
const DISPATCHER = Array{LDispatcher}([DefaultLuxor()])

"""
    strokepath()

Stroke the current path with the current line width, line join, line cap, dash,
and stroke scaling settings. The current path is then emptied.
"""
strokepath() = strokepath(DISPATCHER[1])
strokepath(::DefaultLuxor) = _get_current_strokescale() ? Cairo.stroke_transformed(_get_current_cr()) : Cairo.stroke(_get_current_cr())
strokepath(::LDispatcher) = strokepath(DefaultLuxor())

"""
    fillpath()

Fill the current path according to the current settings. The current path is then emptied.
"""
fillpath() = fillpath(DISPATCHER[1])
fillpath(::DefaultLuxor) = Cairo.fill(_get_current_cr())
fillpath(::LDispatcher) = fillpath(DefaultLuxor())

"""
    paint()

Paint the current clip region with the current settings.
"""
paint() = paint(DISPATCHER[1])
paint(::DefaultLuxor) = Cairo.paint(_get_current_cr())
paint(::LDispatcher) = paint(DefaultLuxor())

"""
    strokepreserve()

Stroke the current path with current line width, line join, line cap, dash, and
stroke scaling settings, but then keep the path current.
"""
strokepreserve() = strokepreserve(DISPATCHER[1])
strokepreserve(::DefaultLuxor) = _get_current_strokescale() ? Cairo.stroke_preserve_transformed(_get_current_cr()) : Cairo.stroke_preserve(_get_current_cr())
strokepreserve(::LDispatcher) = strokepreserve(DefaultLuxor())

"""
    fillpreserve()

Fill the current path with current settings, but then keep the path current.
"""
fillpreserve() = fillpreserve(DISPATCHER[1])
fillpreserve(::DefaultLuxor) = Cairo.fill_preserve(_get_current_cr())
fillpreserve(::LDispatcher) = fillpreserve(DefaultLuxor())

"""
    fillstroke()

Fill and stroke the current path.
After this, the current path is empty, and there is no current point.
"""
function fillstroke()
    fillpreserve()
    strokepath()
end

"""
    do_action(action)

This is usually called by other graphics functions. Actions for graphics commands include
`:fill`, `:stroke`, `:clip`, `:fillstroke`, `:fillpreserve`, and `:strokepreserve`.

The `:path` action adds the graphics to the current path.
"""
function do_action(action)
    if action == :fill
        fillpath()
    elseif action == :stroke
        strokepath()
    elseif action == :clip
        clip()
    elseif action == :fillstroke
        fillstroke()
    elseif action == :fillpreserve
        fillpreserve()
    elseif action == :strokepreserve
        strokepreserve()
    end
    # ignore any other value for action
    return true
end

"""
    clip()

Establish a new clipping region by intersecting the current clipping region with the
current path and then clearing the current path.

An existing clipping region is enforced through and after a
`gsave()`-`grestore()` block, but a clipping region set inside a
`gsave()`-`grestore()` block is lost after `grestore()`. [?]
"""
clip() = clip(DISPATCHER[1])
clip(::DefaultLuxor) = Cairo.clip(_get_current_cr())
clip(::LDispatcher) = clip(DefaultLuxor())

"""
    clippreserve()

Establish a new clipping region by intersecting the current clipping region with the current
path, but keep the current path.
"""
clippreserve() = clippreserve(DISPATCHER[1])
clippreserve(::DefaultLuxor) = Cairo.clip_preserve(_get_current_cr())
clippreserve(::LDispatcher) = clippreserve(DefaultLuxor())

"""
    clipreset()

Reset the clipping region to the current drawing's extent.
"""
clipreset() = Cairo.reset_clip(_get_current_cr())

"""
    setline(n)

Set the line width, in points.

Use `getline()` to get the current value.
"""
setline(n) = Cairo.set_line_width(_get_current_cr(), n)

"""
    getline()

Get the current line width, in points.

Use `setline()` to set the value.
"""
function getline()
    ccall((:cairo_get_line_width, Cairo.libcairo),
        Float64, (Ptr{Nothing},), Luxor._get_current_cr().ptr)
end

"""
    setlinecap(s)

Set the line ends. `s` can be "butt" or `:butt` (the
default), "square" or `:square`, or "round" or `:round`.
"""
function setlinecap(str::String = "butt")
    if str == "round"
        Cairo.set_line_cap(_get_current_cr(), Cairo.CAIRO_LINE_CAP_ROUND)
    elseif str == "square"
        Cairo.set_line_cap(_get_current_cr(), Cairo.CAIRO_LINE_CAP_SQUARE)
    else
        Cairo.set_line_cap(_get_current_cr(), Cairo.CAIRO_LINE_CAP_BUTT)
    end
end

function setlinecap(sym::Symbol)
    if sym == :round
        Cairo.set_line_cap(_get_current_cr(), Cairo.CAIRO_LINE_CAP_ROUND)
    elseif sym == :square
        Cairo.set_line_cap(_get_current_cr(), Cairo.CAIRO_LINE_CAP_SQUARE)
    else
        Cairo.set_line_cap(_get_current_cr(), Cairo.CAIRO_LINE_CAP_BUTT)
    end
end

"""
    setlinejoin("miter")
    setlinejoin("round")
    setlinejoin("bevel")

Set the way line segments are joined when the path is stroked.

The default joining style is "mitered".
"""
function setlinejoin(str = "miter")
    if str == "round"
        Cairo.set_line_join(_get_current_cr(), Cairo.CAIRO_LINE_JOIN_ROUND)
    elseif str == "bevel"
        Cairo.set_line_join(_get_current_cr(), Cairo.CAIRO_LINE_JOIN_BEVEL)
    else
        Cairo.set_line_join(_get_current_cr(), Cairo.CAIRO_LINE_JOIN_MITER)
    end
end

"""
    setlinejoin(:miter)
    setlinejoin(:round)
    setlinejoin(:bevel)

Set the way line segments are joined when the path is stroked.

The default joining style is mitered.
"""
function setlinejoin(sym::Symbol)
    if sym === :round
        Cairo.set_line_join(_get_current_cr(), Cairo.CAIRO_LINE_JOIN_ROUND)
    elseif sym === :bevel
        Cairo.set_line_join(_get_current_cr(), Cairo.CAIRO_LINE_JOIN_BEVEL)
    else
        Cairo.set_line_join(_get_current_cr(), Cairo.CAIRO_LINE_JOIN_MITER)
    end
end

"""
    setdash(::String)

Set the dash pattern of lines to one of: "solid", "dotted", "dot", "dotdashed",
"longdashed", "shortdashed", "dash", "dashed", "dotdotdashed",
"dotdotdotdashed".

Use `setdash(dashes::Vector)` to specify the pattern numerically.
"""
function setdash(dashing::AbstractString)
    Cairo.set_line_type(_get_current_cr(), dashing)
end

"""
    setdash(::Symbol)

Set the dash pattern of lines to one of: :solid, :dotted, :dot, :dotdashed,
:longdashed, :shortdashed, :dash, :dashed, :dotdotdashed,
:dotdotdotdashed.

Use `setdash(dashes::Vector)` to specify the pattern numerically.
"""
function setdash(dashing::Symbol)
    Cairo.set_line_type(Luxor._get_current_cr(), string(dashing))
end

"""
    setdash(dashes::Vector, offset=0.0)

Set the dash pattern for lines to the values in `dashes`. The first number is the length
of the inked portion, the second the space, and so on.

The `offset` specifies an offset into the pattern at which the stroke begins. So
an offset of 10 means that the stroke starts at `dashes[1] + 10` into the
pattern.

Or use `setdash("dot")` etc.
"""
function setdash(dashes::Vector, offset = 0.0)
    # no negative dashes
    Cairo.set_dash(_get_current_cr(), abs.(Float64.(dashes)), offset)
end

"""
    setstrokescale()

Return the current stroke scaling setting.
"""
setstrokescale() = _get_current_strokescale()

"""
    setstrokescale(state::Bool)

Enable/disable stroke scaling for the current drawing.
"""
setstrokescale(state::Bool) = _set_current_strokescale(state)

"""
    move(pt)

Begin a new subpath in the current path, and set the current path's current point
to `pt`, without drawing anything.

Other path-building functions are `line()`, `curve()`, `arc()`, `rline()`, and
`rmove()`.

`hascurrentpoint()` returns true if there is a current point.
"""
move(x, y) = Cairo.move_to(_get_current_cr(), x, y)
move(pt) = move(pt.x, pt.y)

"""
    rmove(pt)

Begin a new subpath in the current path, add `pt` to the current path's current
point, then update the current point.

Other path-building functions are `move()`, `line()`, `curve()`, `arc()`, and `rline()`.

There must be a current point before you call this function.

See also `currentpoint()` and `hascurrentpoint()`.
"""
rmove(x, y) = Cairo.rel_move_to(_get_current_cr(), x, y)
rmove(pt) = rmove(pt.x, pt.y)

"""
    line(pt::Point)

Add a straight line to the current path that joins the path's current point to `pt`. The
current point is then updated to `pt`.

Other path-building functions are `move()`, `curve()`, `arc()`, `rline()`, and
`rmove()`.

See also `currentpoint()` and `hascurrentpoint()`.
"""
line(x, y) = Cairo.line_to(_get_current_cr(), x, y)
line(pt) = line(pt.x, pt.y)

"""
    line(pt1::Point, pt2::Point; action=:path)
    line(pt1::Point, pt2::Point, action=:path)

Add a straight line between two points `pt1` and `pt2`, and do the action.
"""
function line(pt1::Point, pt2::Point;
    action = :path)
    move(pt1)
    line(pt2)
    do_action(action)
end

line(pt1::Point, pt2::Point, action::Symbol) = line(pt1, pt2, action = action)

"""
    rline(pt)

Add a line relative to the current position to the `pt`.
"""
rline(x, y) = Cairo.rel_line_to(_get_current_cr(), x, y)
rline(pt) = rline(pt.x, pt.y)

"""
    rule(pos, theta;
        boundingbox=BoundingBox(),
        vertices=false)

Draw a straight line through `pos` at an angle `theta` from the x axis.

By default, the line spans the entire drawing, but you can supply a BoundingBox
to change the extent of the line.

```julia
rule(O)       # draws an x axis
rule(O, pi/2) # draws a  y axis
```

The function:

```julia
rule(O, pi/2, boundingbox=BoundingBox()/2)
```

draws a line that spans a bounding box half the width and height of the drawing. 

Returns the two end points in a Vector.

Use `vertices=true` to just return the end points, without drawing a line.
"""
function rule(pos, theta = 0.0;
    boundingbox = BoundingBox(),
    vertices = false)
    #TODO interaction with clipping regions needs work

    #TODO which boundingbox is providing the default???
    bbox       = box(boundingbox, vertices = true)
    topside    = bbox[2:3]
    rightside  = bbox[3:4]
    bottomside = vcat(bbox[4], bbox[1])
    leftside   = bbox[1:2]

    # ruled line could be as long as the diagonal so make it longer
    r = boxdiagonal(boundingbox) * 2
    rcosa = r * cos(theta)
    rsina = r * sin(theta)
    ruledline = (pos - (rcosa, rsina), pos + (rcosa, rsina))

    interpoints = Vector{Point}()

    # check for intersection with top of bounding box
    flag, ip = intersectionlines(ruledline[1], ruledline[2], topside[1], topside[2], crossingonly = true)
    if flag
        if !(ip.x > topside[2].x || ip.x < topside[1].x)
            push!(interpoints, ip)
        end
    end

    # check for right intersection
    flag, ip = intersectionlines(ruledline[1], ruledline[2], rightside[1], rightside[2], crossingonly = true)
    if flag
        if !(ip.y > rightside[2].y || ip.y < rightside[1].y)
            push!(interpoints, ip)
        end
    end

    # check for bottom intersection
    flag, ip = intersectionlines(ruledline[1], ruledline[2], bottomside[1], bottomside[2], crossingonly = true)
    if flag
        if !(ip.x < bottomside[2].x || ip.x > bottomside[1].x)
            push!(interpoints, ip)
        end
    end

    # check for left intersection
    flag, ip = intersectionlines(ruledline[1], ruledline[2], leftside[1], leftside[2], crossingonly = true)
    if flag
        if !(ip.y > leftside[1].y || ip.y < leftside[2].y)
            push!(interpoints, ip)
        end
    end

    # eliminate duplicates due to rounding errors
    ruledline = unique(interpoints)

    if length(ruledline) != 2
        @debug "bounding box doesn't contain this line"
    end 
    # finally draw the line if we have two points
    if vertices == false && length(ruledline) == 2
        line(ruledline..., :stroke)
    end
    return ruledline
end

"""

    rule1(point1::Point, point2::Point;
        boundingbox=BoundingBox(),
        vertices=false)

Draw a straight line passing through points `point1` and `point2`.

```julia
rule(Point(10, 10), Point(30, -30))
```

Supply a BoundingBox to restrict the ruled lines to a rectangular area.

Returns the two end points in a Vector.

Use `vertices=true` to just return the end points, without drawing a line.
"""
function rule(point1::Point, point2::Point;
        boundingbox=BoundingBox(),
        vertices=false) 
    theta = slope(point1, point2)
    rule(point1, theta; 
        boundingbox=boundingbox,
        vertices=vertices)
end

# we need a thread safe way to store the color palette as a stack:
#  access to the stack is only possible using the global function:
#   - predefine all needed Dict entries in a thread safe way
#   - each thread has it's own stack, separated by threadid
# this is not enough for Threads.@spawn (TODO, but no solution yet)
let _SAVED_COLORS_STACK = Ref{Dict{Int,Vector{NTuple{4,Float64}}}}(Dict(0 => Vector{NTuple{4,Float64}}()))
    global _saved_colors
    function _saved_colors()
        id = Threads.threadid()
        if !haskey(_SAVED_COLORS_STACK[], id)
            # predefine all needed Dict entries
            lc = ReentrantLock()
            lock(lc)
            for preID in 1:Threads.nthreads()
                _SAVED_COLORS_STACK[][preID] = Vector{NTuple{4,Float64}}()
            end
            unlock(lc)
        end
        if isnothing(_SAVED_COLORS_STACK[][id])
            # all Dict entries are predefined, so we should never reach this error
            error("(4)thread id should be preallocated")
        end
        # thread specific stack
        return _SAVED_COLORS_STACK[][id]
    end
end

# I originally used simple Cairo save() but the colors/opacity
# thing I've got going didn't save/restore properly, hence the stack
"""
    gsave()

Save the current graphics environment, including current color settings.
"""
function gsave()
    Cairo.save(_get_current_cr())
    r, g, b, a = (_get_current_redvalue(),
        _get_current_greenvalue(),
        _get_current_bluevalue(),
        _get_current_alpha(),
    )
    push!(_saved_colors(), (r, g, b, a))
    return (r, g, b, a)
end

"""
    grestore()

Replace the current graphics state with the one previously saved by the most recent
`gsave()`.
"""
function grestore()
    Cairo.restore(_get_current_cr())
    try
        (r, g, b, a) = pop!(_saved_colors())
        _set_current_redvalue(r)
        _set_current_greenvalue(g)
        _set_current_bluevalue(b)
        _set_current_alpha(a)
    catch err
        println("$err Not enough colors on the stack to restore.")
    end
end

"""
The `@layer` macro is a shortcut for `gsave()` ... `grestore()`.
"""
macro layer(a)
    quote
        gsave()
        $(esc(a))
        grestore()
    end
end

"""
    scale(x, y)

Scale the current workspace by different values in `x` and `y`.

Values are relative to the current scale.
Example:

```julia
scale(0.2, 0.3)
```
"""
scale(sx::Real, sy::Real) = Cairo.scale(_get_current_cr(), sx, sy)

"""
    scale(f)

Scale the current workspace by `f` in both `x` and `y` directions.

Values are relative to the current scale.
"""
scale(f::Real) = Cairo.scale(_get_current_cr(), f, f)

"""
    rotate(a::Float64)

Rotate the current workspace by `a` radians clockwise (from positive x-axis to positive y-axis).

Values are relative to the current orientation.
"""
rotate(a) = Cairo.rotate(_get_current_cr(), a)

"""
    translate(point)
    translate(x::Real, y::Real)

Translate the current workspace to `x` and `y` or to `pt`.

Values are relative to the current location.
"""
translate(tx::Real, ty::Real) = Cairo.translate(_get_current_cr(), tx, ty)
translate(pt::Point) = translate(pt.x, pt.y)

"""
    getpath()

Get the current path and return a CairoPath object, which is an array of `element_type` and
`points` objects. With the results you can step through and examine each entry like this:

```julia
o = getpath()
x, y = currentpoint()
for e in o
    if e.element_type == Cairo.CAIRO_PATH_MOVE_TO
        (x, y) = e.points
        move(x, y)
    elseif e.element_type == Cairo.CAIRO_PATH_LINE_TO
        (x, y) = e.points
        # straight lines
        line(x, y)
        strokepath()
        circle(x, y, 1, :stroke)
    elseif e.element_type == Cairo.CAIRO_PATH_CURVE_TO
        (x1, y1, x2, y2, x3, y3) = e.points
        # Bezier control lines
        circle(x1, y1, 1, :stroke)
        circle(x2, y2, 1, :stroke)
        circle(x3, y3, 1, :stroke)
        move(x, y)
        curve(x1, y1, x2, y2, x3, y3)
        strokepath()
        (x, y) = (x3, y3) # update current point
    elseif e.element_type == Cairo.CAIRO_PATH_CLOSE_PATH
        closepath()
    else
        error("unknown CairoPathEntry " * repr(e.element_type))
        error("unknown CairoPathEntry " * repr(e.points))
    end
end
```
"""
getpath() = Cairo.convert_cairo_path_data(Cairo.copy_path(_get_current_cr()))

"""
    getpathflat()

Get the current path, like `getpath()` but flattened so that there are no Bézier curves.

Returns a CairoPath which is an array of `element_type` and `points` objects.
"""
getpathflat() = Cairo.convert_cairo_path_data(Cairo.copy_path_flat(_get_current_cr()))

"""
    rulers()

Draw and label two CAD-style rulers starting at `O`, the current 0/0, and continuing out
along the current positive x and y axes.
"""
function rulers()
    @layer begin
        n = 200
        w = 20
        setopacity(0.5)
        setline(0.25)
        sethue(1.0, 0.549, 0.0) # darkorange
        #x axis
        box(O, O + (n, -w), :fillstroke)
        #y axis
        box(O - (w, 0), O + (0, n), :fillstroke)
        sethue(0.722, 0.525, 0.043) # darkgoldenrod
        setopacity(1)
        [line(Point(x, 0), Point(x, -w / 4), :stroke) for x in 0:10:n]
        [line(Point(-w / 4, y), Point(0, y), :stroke) for y in 0:10:n]
        [line(Point(x, 0), Point(x, -w / 6), :stroke) for x in 0:5:n]
        [line(Point(-w / 6, y), Point(0, y), :stroke) for y in 0:5:n]
        fontsize(2)
        [text(string(x), Point(x, -w / 3), halign = :right) for x in 10:10:n]
        @layer begin
            rotate(pi / 2)
            [text(string(x), Point(x, w / 3), halign = :right) for x in 10:10:n]
        end
        fontsize(15)
        text("X", O + (n - w / 2, w), halign = :right, valign = :middle)
        text("Y", O + (-3w / 2, n - w), halign = :right, valign = :middle, angle = pi / 2)
        sethue(1.0, 1.0, 1.0)
        text("X", O + (w, -w / 2), halign = :right, valign = :middle)
        text("Y", O + (-w / 3, w / 3), halign = :right, valign = :middle, angle = pi / 2)
        #center
        circle(O, 2, :strokepreserve)
        setopacity(0.5)
        fillpath()
    end
    return true
end

"""
    hcat(D::Drawing...; valign=:top, hpad=0, clip=true)

Create a new SVG drawing by horizontal concatenation of SVG drawings. If drawings
have different height, the `valign` option can be used in order to define
how to align. The `hpad` argument can be used to add padding between
concatenated images.

The `clip` argument is a boolean for whether
the concatenated images should be clipped before concatenation.
Note that drawings sometimes have elements that go beyond it's margins,
and they only show when the image is drawn in a larger canvas. The `clip`
argument ensures that these elements are not drawn in the concatenated drawing.

Example:

```julia
d1 = Drawing(200, 100, :svg)
origin()
circle(O, 60, :fill)
finish()

d2 = Drawing(200, 200, :svg)
rect(O, 200, 200, :fill)
finish()
hcat(d1, d2; hpad = 10, valign = :top, clip = true)
```
"""
function Base.hcat(D::Drawing...; valign = :top, hpad = 0, clip = true)
    dheight, dwidth = 0, -hpad
    for d in D
        dheight = max(dheight, d.height)
        dwidth += d.width + hpad
        if d.surfacetype !== :svg
            throw(error("hcat(): Drawing must be SVG, not $(d.surfacetype)"))
        end
    end
    dcat = Drawing(dwidth, dheight, :svg)
    @layer begin
        for d in D
            if valign === :top
                pt = O
                clip ? rect(pt, d.width, d.height, :clip) : nothing
                placeimage(d, pt)
            elseif valign === :bottom
                pt = Point(0, dheight - d.height)
                clip ? rect(pt, d.width, d.height, :clip) : nothing
                placeimage(d, pt)
            elseif valign === :middle
                pt = Point(0, dheight - d.height) / 2
                clip ? rect(pt, d.width, d.height, :clip) : nothing
                placeimage(d, pt)
            else
                throw("`valign` option not valid. Use either `:top`, `:bottom` or `:middle`.")
            end
            clipreset()
            translate(Point(d.width + hpad, 0))
        end
    end
    finish()
    dcat
end

"""
    vcat(D::Drawing...; halign=:left, vpad=0, clip=true)

Creates a new SVG drawing by vertical concatenation of SVG drawings. If drawings
have different widths, the `halign` option can be used in order to define
how to align. The `vpad` argument can be used to add padding between
concatenated images.

The `clip` argument is a boolean for whether
the concatenated images should be clipped before concatenation.
Note that drawings sometimes have elements that go beyond it's margins,
and they only show when the image is drawn in a larger canvas. The `clip`
argument ensures that these elements are not drawn in the concatenated drawing.

Example:

```julia
d1 = Drawing(200, 100, :svg)
origin()
circle(O, 60, :fill)
finish()

d2 = Drawing(200, 200, :svg)
rect(O, 200, 200, :fill)
finish()
vcat(d1, d2; vpad = 10, halign = :left, clip = true)
```
"""
function Base.vcat(D::Drawing...; halign = :left, vpad = 0, clip = true)
    dheight, dwidth = -vpad, 0
    for d in D
        dwidth = max(dwidth, d.width)
        dheight += d.height + vpad
        if d.surfacetype !== :svg
            throw(error("vcat(): Drawing must be SVG, not $(d.surfacetype)"))
        end
    end
    dcat = Drawing(dwidth, dheight, :svg)
    @layer begin
        for d in D
            if halign === :left
                pt = O
                clip ? rect(pt, d.width, d.height, :clip) : nothing
                placeimage(d, pt)
            elseif halign === :right
                pt = Point(dwidth - d.width, 0)
                clip ? rect(pt, d.width, d.height, :clip) : nothing
                placeimage(d, pt)
            elseif halign === :center
                pt = Point(dwidth - d.width, 0) / 2
                clip ? rect(pt, d.width, d.height, :clip) : nothing
                placeimage(d, pt)
            else
                throw("`halign` option not valid. Use either `:left`, `:right` or `:center`.")
            end
            clipreset()
            translate(Point(0, d.height + vpad))
        end
    end
    finish()
    dcat
end

"""
    setfillrule(rule::Symbol)

Set the fill rule for paths for the current drawing.

`rule` can be `:winding` or `:even_odd`

The fill rule is used to select how subpaths are filled. For both fill rules,
whether or not a point is included in the fill is determined by taking a ray
from that point to infinity and looking at intersections with the path. The ray
can be in any direction, as long as it doesn't pass through the end point of a
segment or have a tricky intersection such as intersecting tangent to the path.
(Note that filling is not actually implemented in this way. This is just a
description of the rule that is applied.)

The default fill rule is `:winding`.

`:winding`: If the path crosses the ray from left-to-right, counts +1. If the
path crosses the ray from right to left, counts -1. (Left and right are
determined from the perspective of looking along the ray from the starting
point.) If the total count is non-zero, the point will be filled.

`even_odd`: counts the total number of intersections, without regard to the
orientation of the contour. If the total number of intersections is odd, the
point will be filled. (Since 1.0)

See [`getfillrule`](@ref).
"""
function setfillrule(rule::Symbol = :winding)
    if rule === :even_odd
        Cairo.set_fill_type(_get_current_cr(), Cairo.CAIRO_FILL_RULE_EVEN_ODD)
    else
        Cairo.set_fill_type(_get_current_cr(), Cairo.CAIRO_FILL_RULE_WINDING)
    end
end

"""
    getfillrule()

Get the current fill rule for paths for the current drawing.

The `rule` can be `:winding` or `:even_odd`.

See [`setfillrule`](@ref).
"""
function getfillrule()
    c = ccall((:cairo_get_fill_rule, Luxor.Cairo.libcairo),
        Int64, (Ptr{Nothing},), Luxor._get_current_cr().ptr)
    if c == 0
        return Symbol(:winding)
    elseif c == 1
        return Symbol(:even_odd)
    else
        throw(error("getfillrule(): no information available"))
    end
end

# matrix and transformations

"""
    getmatrix()

Get the current workspace (position, scale, and orientation) as a 6-element
vector:

```julia
[xx, yx, xy, yy, x0, y0]
```

  - `xx` component of the affine transformation
  - `yx` component of the affine transformation
  - `xy` component of the affine transformation
  - `yy` component of the affine transformation
  - `x0` translation component of the affine transformation
  - `y0` translation component of the affine transformation

When a drawing is first created, the 'matrix' looks like this:
```
getmatrix() = [1.0, 0.0, 0.0, 1.0, 0.0, 0.0]
```

When the origin is moved to 400/400, it looks like this:
```
getmatrix() = [1.0, 0.0, 0.0, 1.0, 400.0, 400.0]
```

To reset the 'matrix' to the original:
```
setmatrix([1.0, 0.0, 0.0, 1.0, 0.0, 0.0])
```

To modify the current 'matrix' by multiplying it by a 6 element 'matrix' `a`,
see `transform(a::Array)`.

To convert between Luxor/Cairo 'matrix' format (6-element Vector{Float64}) and a
3x3 Julia matrix, use `cairotojuliamatrix(c)` and `juliatocairomatrix(c)`.

See also `rotationmatrix(a)`, `translationmatrix()`, and `scalingmatrix()`.

# Extended help

Here are some basic matrix transforms:

  - translate

    `transform([1, 0, 0, 1, dx, dy])` shifts by `dx`, `dy`

  - scale

    `transform([fx 0 0 fy 0 0])` scales by `fx` and `fy`

  - rotate

    `transform([cos(a), -sin(a), sin(a), cos(a), 0, 0])` rotates around to `a` radians

    rotate around O: [c -s s c 0 0]

  - shear

    `transform([1 0 a 1 0 0])` shears in x direction by `a`

    shear in y direction by `a`: `[1 a 0 1 0 0]`

  - x-skew

    `transform([1, 0, tan(a), 1, 0, 0])` skews in x by `a`

  - y-skew

    `transform([1, tan(a), 0, 1, 0, 0])` skews in y by `a`

  - flip

    `transform([fx, 0, 0, fy, centerx * (1 - fx), centery * (fy-1)])` flips with center at `centerx`/`centery`

  - reflect

    `transform([1 0 0 -1 0 0])` reflects in xaxis

    `transform([-1 0 0 1 0 0])` reflects in yaxis
"""
function getmatrix()
    gm = Cairo.get_matrix(_get_current_cr())
    return ([gm.xx, gm.yx, gm.xy, gm.yy, gm.x0, gm.y0])
end

"""
    setmatrix(m::Array)

Change the current matrix to 6-element matrix `m`.

See `getmatrix()` for details.
"""
function setmatrix(m::Array)
    if eltype(m) != Float64
        m = map(Float64, m)
    end
    # some matrices make Cairo freak out and need reset. Not sure what the rules are yet…
    if length(m) < 6
        throw("didn't like that matrix $m: not enough values")
    elseif count(!iszero, m) == 0
        throw("didn't like that matrix $m: too many zeroes")
    else
        cm = Cairo.CairoMatrix(m[1], m[2], m[3], m[4], m[5], m[6])
        Cairo.set_matrix(_get_current_cr(), cm)
    end
end

"""
    transform(a::Array)

Modify the current matrix by multiplying it by matrix `a`.

For example, to skew the current state by 45 degrees in x and move by 20 in y direction:
```julia
transform([1, 0, tand(45), 1, 0, 20])
```
See `getmatrix()` for details.
"""
function transform(a::Array)
    b = Cairo.get_matrix(_get_current_cr())
    setmatrix([
        (a[1] * b.xx) + a[2] * b.xy,             # xx
        (a[1] * b.yx) + a[2] * b.yy,             # yx
        (a[3] * b.xx) + a[4] * b.xy,             # xy
        (a[3] * b.yx) + a[4] * b.yy,             # yy
        (a[5] * b.xx) + (a[6] * b.xy) + b.x0,     # x0
        (a[5] * b.yx) + (a[6] * b.yy) + b.y0,      # y0
    ])
end

"""
    rotationmatrix(a)

Return a 3x3 Julia matrix that will apply a rotation through `a` radians.

See `getmatrix()` for details.
"""
function rotationmatrix(a)
    return ([cos(a) -sin(a) 0.0
        sin(a) cos(a) 0.0
        0.0 0.0 1.0])
end

"""
    translationmatrix(x, y)

Return a 3x3 Julia matrix that will apply a translation in `x` and `y`.

See `getmatrix()` for details.
"""
function translationmatrix(x, y)
    return ([1.0 0.0 x
        0.0 1.0 y
        0.0 0.0 1.0])
end

"""
    scalingmatrix(sx, sy)

Return a 3x3 Julia matrix that will apply a scaling by `sx` and `sy`.

See `getmatrix()` for details.
"""
function scalingmatrix(sx, sy)
    return ([sx 0.0 0.0
        0.0 sy 0.0
        0.0 0.0 1.0])
end

"""
    cairotojuliamatrix(c)

Return a 3x3 Julia matrix that's the equivalent of the six-element matrix in `c`.

See `getmatrix()` for details.
"""
function cairotojuliamatrix(c::Array)
    return [c[1] c[3] c[5]; c[2] c[4] c[6]; 0.0 0.0 1.0]
end

"""
    juliatocairomatrix(c)

Return a six-element matrix that's the equivalent of the 3x3 Julia matrix in `c`.

See `getmatrix()` for details.
"""
function juliatocairomatrix(c::Matrix)
    return [c[1] c[2] c[4] c[5] c[7] c[8]]
end

"""
    getrotation(R::Matrix)
    getrotation()

Get the rotation of a Julia 3x3 matrix, or the current Luxor rotation.

```julia-repl
julia> getrotation()
0.0
```

```math
\\begin{bmatrix}
a & b & tx \\\\
c & d & ty \\\\
0 & 0 & 1  \\\\
\\end{bmatrix}
```

The rotation angle is `atan(-b, a)` or `atan(c, d)`.

See `getmatrix()` for details.
"""
function getrotation(R::Matrix)
    # t = atan(-R[4], R[1]) # should be the same as:
    t = atan(R[2], R[5])
    return mod2pi(t)
end

function getrotation()
    getrotation(cairotojuliamatrix(getmatrix()))
end

"""
    getscale(R::Matrix)
    getscale()

Get the current scale of a 3x3 matrix, or the current Luxor scale.

Returns a tuple of x and y values.

```julia-repl
julia> getscale()
(1.0, 1.0)
```

See `getmatrix()` for details.
"""
function getscale(R::Matrix)
    sx = hypot(R[1], R[2])
    sy = hypot(R[4], R[5])
    return (sx, sy)
end

function getscale()
    getscale(cairotojuliamatrix(getmatrix()))
end

"""
    gettranslation(R::Matrix)
    gettranslation()

Get the current translation of a 3x3 matrix R, or get the current Luxor translation.

Returns a tuple of x and y values.

See `getmatrix()` for details.
"""
function gettranslation(R::Matrix)
    return (R[7], R[8])
end

function gettranslation()
    gettranslation(cairotojuliamatrix(getmatrix()))
end

mutable struct Table
    rowheights::Vector{T} where {T<:Real}
    colwidths::Vector{T} where {T<:Real}
    nrows::Int
    ncols::Int
    currentrow::Int
    currentcol::Int
    leftmargin::Real
    topmargin::Real
    center::Point
end

"""
    t = Table(nrows, ncols)
    t = Table(nrows, ncols, colwidth, rowheight)
    t = Table(rowheights, columnwidths)

Tables are centered at `O`, but you can supply a point after the specifications.

    t = Table(nrows, ncols, centerpoint)
    t = Table(nrows, ncols, colwidth, rowheight, centerpoint)
    t = Table(rowheights, columnwidths, centerpoint)

## Examples

Simple tables

    t = Table(4, 3) # 4 rows and 3 cols, default is 100w, 50 h
    t = Table(4, 3, 80, 30)   # 4 rows of 30pts high, 3 cols of 80pts wide
    t = Table(4, 3, (80, 30)) # same
    t = Table((4, 3), (80, 30)) # same

Specify row heights and column widths instead of quantities:

    t = Table([60, 40, 100], 50) # 3 different height rows, 1 column 50 wide
    t = Table([60, 40, 100], [100, 60, 40]) # 3 rows, 3 columns
    t = Table(fill(30, (10)), [50, 50, 50]) # 10 rows 30 high, 3 columns 10 wide
    t = Table(50, [60, 60, 60]) # just 1 row (50 high), 3 columns 60 wide
    t = Table([50], [50]) # just 1 row, 1 column, both 50 units wide
    t = Table(50, 50, 10, 5) # 50 rows, 50 columns, 10 units wide, 5 units high
    t = Table([6, 11, 16, 21, 26, 31, 36, 41, 46], [6, 11, 16, 21, 26, 31, 36, 41, 46])
    t = Table(15:5:55, vcat(5:2:15, 15:-2:5))
     #  table has 108 cells, with:
     #  row heights: 15 20 25 30 35 40 45 50 55
     #  col widths:  5 7 9 11 13 15 15 13 11 9 7 5
    t = Table(vcat(5:10:60, 60:-10:5), vcat(5:10:60, 60:-10:5))
    t = Table(vcat(5:10:60, 60:-10:5), 50) # 1 column 50 units wide
    t = Table(vcat(5:10:60, 60:-10:5), 1:5:50)

A Table is an iterator that, for each iteration, returns a tuple of:

  - the `x`/`y` point of the center of cells arranged in rows and columns (relative to current 0/0)

  - the number of the cell (left to right, then top to bottom)

`nrows`/`ncols` are the number of rows and columns required.

It's sometimes useful to know which row and column you're currently on while iterating:

```julia
t.currentrow
t.currentcol
```

and row heights and column widths are available in:

```julia
t.rowheights
t.colwidths
```

`box(t::Table, r, c)` can be used to fill table cells:

```julia
@svg begin
    for (pt, n) in (t = Table(8, 3, 30, 15))
        randomhue()
        box(t, t.currentrow, t.currentcol, :fill)
        sethue("white")
        text(string(n), pt)
    end
end
```

or without iteration, using cellnumber:

```julia
@svg begin
    t = Table(8, 3, 30, 15)
    for n in eachindex(t)
        randomhue()
        box(t, n, :fill)
        sethue("white")
        text(string(n), t[n])
    end
end
```

To use a Table to make grid points:

```julia-repl
julia> first.(collect(Table(10, 6)))
60-element Vector{Point}:
 Luxor.Point(-10.0, -18.0)
 Luxor.Point(-6.0, -18.0)
 Luxor.Point(-2.0, -18.0)
 ⋮
 Luxor.Point(2.0, 18.0)
 Luxor.Point(6.0, 18.0)
 Luxor.Point(10.0, 18.0)
```

which returns an array of points that are the center points of the cells in the table.

## Selecting cells

You can select cells using `getcells(table, rows, columns)`. This returns a list
of `(point, index)` tuples.

- `getcells(t, :, :)` returns a list of all cells

- `getcells(t, 1, :)` returns a list of all cells in row 1

- `getcells(t, :, 3)` returns a list of all cells in column 3

- `getcells(t, 2:4, [3, 5])` returns a list of cells in rows 2-4, columns 3 and 5

"""
function Table(nrows::Int, ncols::Int, cellwidth, cellheight, center = O)
    currentrow = 1
    currentcol = 1
    rowheights = fill(cellheight, nrows)
    colwidths  = fill(cellwidth, ncols)
    leftmargin = center.x - sum(colwidths) / 2
    topmargin  = center.y - sum(rowheights) / 2
    Table(rowheights, colwidths, nrows, ncols, currentrow, currentcol, leftmargin, topmargin, center)
end

# simple: nrows, ncols, (width, height)
Table(nrows::Int, ncols::Int, wh::NTuple{2,T}, center = O) where {T<:Real} =
    Table(nrows, ncols, wh[1], wh[2], center)

# simple: (nrows, ncols)
Table(rc::NTuple{2,T}, center = O) where {T<:Int} =
    Table(rc[1], rc[2], center)

# simple: (nrows, ncols), (width, height)
Table(rc::NTuple{2,T1}, wh::NTuple{2,T2}, center = O) where {T1<:Int} where {T2<:Real} =
    Table(rc[1], rc[2], wh[1], wh[2], center)

# simple: nrows, ncols using default of 100w 50 h
function Table(nrows::Int, ncols::Int, center = O)
    cellwidth  = 100
    cellheight = 50
    Table(nrows, ncols, cellwidth, cellheight, center)
end

# row heights in array, column widths in array
function Table(rowheights::Vector{T1}, colwidths::Vector{T2}, center = O) where {T1<:Real} where {T2<:Real}
    rowheights = collect(Iterators.flatten(rowheights))
    colwidths  = collect(Iterators.flatten(colwidths))
    nrows      = length(rowheights)
    ncols      = length(colwidths)
    currentrow = 1
    currentcol = 1
    leftmargin = center.x - sum(colwidths) / 2
    topmargin  = center.y - sum(rowheights) / 2
    Table(rowheights, colwidths, nrows, ncols, currentrow, currentcol, leftmargin, topmargin, center)
end

# row heights in array, a single column width
Table(rowheights::Vector{T1}, colwidth::T2, center = O) where {T1<:Real} where {T2<:Real} =
    Table(rowheights, [colwidth], center)

# a single row height, column widths in an array
Table(row_height::T1, colwidths::Vector{T2}, center = O) where {T1<:Real} where {T2<:Real} =
    Table([row_height], colwidths, center)

# a range of row heights, a range of column widths
Table(rowheights::AbstractRange{T1}, colwidths::AbstractRange{T2}, center = O) where {T1<:Real} where {T2<:Real} =
    Table(collect(rowheights), collect(colwidths), center)

# an array of row heights, a range of column widths
Table(rowheights::Vector{T1}, colwidths::AbstractRange{T2}, center = O) where {T1<:Real} where {T2<:Real} =
    Table(rowheights, collect(colwidths), center)

# a range of row heights, an array of column widths
Table(rowheights::AbstractRange{T1}, colwidths::Vector{T2}, center = O) where {T1<:Real} where {T2<:Real} =
    Table(collect(rowheights), colwidths, center)

# interfaces

function Base.iterate(t::Table)
    x = t.leftmargin + (t.colwidths[1] / 2)
    y = t.topmargin + (t.rowheights[1] / 2)
    cellnumber = 2
    t.currentrow = min(div(cellnumber - 1, t.ncols) + 1, 1)
    t.currentcol = mod1(cellnumber - 1, t.ncols)
    x1 = t.leftmargin + sum(t.colwidths[1:(t.currentcol - 1)]) + t.colwidths[t.currentcol] / 2
    y1 = t.topmargin + sum(t.rowheights[1:(t.currentrow - 1)]) + t.rowheights[t.currentrow] / 2
    nextpoint = Point(x1, y1)
    return ((Point(x, y), 1), (nextpoint, 2))
end

function Base.iterate(t::Table, state)
    if state[2] > t.nrows * t.ncols
        return
    end
    # state[1] is the Point
    x = state[1].x
    y = state[1].y
    # state[2] is the cellnumber
    cellnumber = state[2]
    # next pos
    t.currentrow = div(cellnumber - 1, t.ncols) + 1
    t.currentcol = mod1(cellnumber, t.ncols)
    x1 = t.leftmargin + sum(t.colwidths[1:(t.currentcol - 1)]) + t.colwidths[t.currentcol] / 2
    y1 = t.topmargin + sum(t.rowheights[1:(t.currentrow - 1)]) + t.rowheights[t.currentrow] / 2
    nextpoint = Point(x1, y1)
    return ((nextpoint, cellnumber), (nextpoint, cellnumber + 1))
end

function Base.size(t::Table)
    return (t.nrows, t.ncols)
end

function Base.size(t::Table, n::Int)
    return n == 1 ? t.nrows :
           n == 2 ? t.ncols : 1
end

function Base.length(t::Table)
    t.nrows * t.ncols
end

Base.lastindex(t::Table) = length(t)

Base.eltype(::Type{Table}) = Tuple

function Base.getindex(t::Table, i::Int)
    1 <= i <= t.ncols * t.nrows || throw(BoundsError(t, i))
    currentrow = div(i - 1, t.ncols) + 1
    currentcol = mod1(i, t.ncols)
    x1 = t.leftmargin + sum(t.colwidths[1:(currentcol - 1)]) + t.colwidths[currentcol] / 2
    y1 = t.topmargin + sum(t.rowheights[1:(currentrow - 1)]) + t.rowheights[currentrow] / 2
    return Point(x1, y1)
end

# t[r, c] -> Luxor.Point(0.0, -192.5)
function Base.getindex(t::Table, r::Int, c::Int)
    r <= t.nrows || throw(BoundsError(t, r))
    c <= t.ncols || throw(BoundsError(t, c))
    x1 = t.leftmargin + sum(t.colwidths[1:(c - 1)]) + t.colwidths[c] / 2
    y1 = t.topmargin + sum(t.rowheights[1:(r - 1)]) + t.rowheights[r] / 2
    return Point(x1, y1)
end

Base.getindex(t::Table, I) = [t[i] for i in I]

# get row:    t[1, :]
Base.getindex(t::Table, r::T, ::Colon) where {T<:Integer} = [t[r, n] for n in 1:(t.ncols)]

# get column: t[:, 3]
Base.getindex(t::Table, ::Colon, c::T) where {T<:Integer} = [t[n, c] for n in 1:(t.nrows)]

Base.eachindex(t::Table) = 1:length(t)

# box extensions
"""
    box(t::Table, r::Integer, c::Integer, action::Symbol)
    box(t::Table, r::Integer, c::Integer; action=:none)

Draw a box in table `t` at row `r` and column `c`.
"""
function box(t::Table, r::Integer, c::Integer, action::Symbol; kwargs...)
    cellw, cellh = t.colwidths[c], t.rowheights[r]
    box(t[r, c], cellw, cellh, action; kwargs...)
end

box(t::Table, r::Integer, c::Integer; action = :none, reversepath = false, vertices = false) =
    box(t, r, c, action, reversepath = reversepath, vertices = vertices)

"""
    box(t::Table, cellnumber::Int, action::Symbol=:none; vertices=false)
    box(t::Table, cellnumber::Int; action=:none, vertices=false)

Make box around cell `cellnumber` in table `t`.
"""
function box(t::Table, cellnumber::Int, action::Symbol; vertices = false)
    r = div(cellnumber - 1, t.ncols) + 1
    c = mod1(cellnumber, t.ncols)

    cellw, cellh = t.colwidths[c], t.rowheights[r]
    box(t[r, c], cellw, cellh, action; vertices = vertices)
end

box(t::Table, cellnumber::Int; action = :none, vertices = false) = box(t, cellnumber, action, vertices = vertices)

# superseded, will be deprecated
function highlightcells(t::Table, cellnumbers, action::Symbol = :stroke;
    color::Colorant = colorant"red",
    offset = 0)
    sethue(color)
    for cell in cellnumbers
        if isa(cell, Tuple)
            row, col = cell
            box(t[row, col], t.colwidths[col] + offset, t.rowheights[row] + offset, action)
        else
            ci = CartesianIndices((t.ncols, t.nrows))[cell]
            col = ci.I[1]
            row = ci.I[2]
            box(t[cell], t.colwidths[col] + offset, t.rowheights[row] + offset, action)
        end
    end
end

"""
    BoundingBox(t::table)

Return a BoundingBox that encloses the table `t`.
"""
function BoundingBox(t::Table)
    h = sum(t.rowheights)
    w = sum(t.colwidths)
    return BoundingBox(box(t.center, w, h))
end

"""
    BoundingBox(t::table, cell)

Return a BoundingBox that encloses cell `cell` of table `t`.
"""
function BoundingBox(t::Table, cellnumber)
    1 <= cellnumber <= t.ncols * t.nrows || throw(BoundsError(t, cellnumber))
    currentrow = div(cellnumber - 1, t.ncols) + 1
    currentcol = mod1(cellnumber, t.ncols)
    h = t.colwidths[currentcol]
    w = t.rowheights[currentrow]
    cpos = t[cellnumber]
    return BoundingBox(box(cpos, h, w))
end

"""
    BoundingBox(t::table, rownumber, columnnumber)

Return a BoundingBox that encloses cell at row `rownumber`, column `colnumber` of table `t`.
"""
function BoundingBox(t::Table, rownumber, columnnumber)
    h = t.colwidths[columnnumber]
    w = t.rowheights[rownumber]
    cpos = t[rownumber, columnnumber]
    return BoundingBox(box(cpos, h, w))
end

using Luxor, Test, Random
Random.seed!(42)
function circlecircletangent_test(fname)
    Drawing(800, 800, fname)
    origin()
    background("white")
    setopacity(0.7)
    sethue("black")
    # overlapping circles will return four Os
    c1center = c2center = O
    c1radius = 50
    c2radius = 100
    p1, p2, p3, p4 = circlecircleoutertangents(c1center, c1radius, c2center, c2radius)
    @test all(pt -> isequal(pt, O), (p1, p2, p3, p4)) == true
    for i in 1:30
        randomhue()
        c1center = rand(BoundingBox() * 0.5)
        c2center = rand(BoundingBox() * 0.75)
        c1radius = rand(5:30)
        c2radius = rand(30:50)
        circle(c1center, c1radius, :fill)
        circle(c2center, c2radius, :fill)
        pt1, pt2, pt3, pt4 = circlecircleoutertangents(c1center, c1radius, c2center, c2radius)
        poly([pt1, pt2, pt4, pt3], :fill)
        sethue("black")
        circle(c2center, c2radius, :stroke)
        circle(c1center, c1radius, :stroke)
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

function circlecircletangent_test2(fname)
    Drawing(800, 800, fname)
    origin()
    background("white")
    setline(0.5)
    sethue("black")
    # overlapping circles will return four Os
    c1center = c2center = O
    c1radius = 50
    c2radius = 100
    p1, p2, p3, p4 = circlecircleinnertangents(c1center, c1radius, c2center, c2radius)
    @test all(pt -> isequal(pt, O), (p1, p2, p3, p4)) == true

    for θ in range(0, step=2π/12, length=12)
        @layer begin
            randomhue()
            c1center = polar(100, θ)
            c2center = polar(300, θ)
            c1radius = 20
            c2radius = rand(50:70)
            circle(c1center, c1radius, :fill)
            circle(c2center, c2radius, :fill)

            pt1, pt2, pt3, pt4 = circlecircleinnertangents(c1center, c1radius, c2center, c2radius)

            if !all(pt -> isequal(pt, O), (pt1, pt2, pt3, pt4))
                sethue("green")
                circle(c2center, c2radius, :stroke)
                circle(c1center, c1radius, :stroke)
                circle.((pt1, pt2, pt3, pt4), 4, :fill)
                sethue("black")
                arrow(pt1, pt2, linewidth=2)
                arrow(pt3, pt4, linewidth=2)
            end

            pt1, pt2, pt3, pt4 = circlecircleoutertangents(c1center, c1radius, c2center, c2radius)

            if !all(pt -> isequal(pt, O), (pt1, pt2, pt3, pt4))
                sethue("red")
                arrow(pt1, pt2, linewidth=2)
                arrow(pt3, pt4, linewidth=2)
                circle.((pt1, pt2, pt3, pt4), 3, :fill)
            end
        end
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

circlecircletangent_test("circlecircletangent-outer.png")
circlecircletangent_test2("circlecircletangent-inner.png")

# Extensions are modules that depend on Luxor and other modules.
# They are loaded when Luxor and these modules are loaded.
# Extensions (LuxorExt...) cannot however reliably introduce new symbols
# into Luxor. Hence, placeholder functions with catchall argument types:
function latextextsize(catch_all)
    if Base.get_extension(Luxor, :LuxorExtLatex) isa Module
        throw(MethodError(latextextsize, catch_all))
    else
        throw(ErrorException("Modules LaTeXStrings and MathTeXEngine are not loaded."))
    end
end
function latexboundingbox(catch_all; kwargs...)
    if Base.get_extension(Luxor, :LuxorExtLatex) isa Module
        throw(MethodError(latexboundingbox, catch_all))
    else
        throw(ErrorException("Modules LaTeXStrings and MathTeXEngine are not loaded."))
    end
end
function rawlatexboundingbox(catch_all)
    if Base.get_extension(Luxor, :LuxorExtLatex) isa Module
        throw(MethodError(rawlatexboundingbox, catch_all))
    else
        throw(ErrorException("Modules LaTeXStrings and MathTeXEngine are not loaded."))
    end
end

using Luxor
using MathTeXEngine
using LaTeXStrings
using Test

#ENV["JULIA_DEBUG"] = "LuxorExtLatex"
ENV["JULIA_DEBUG"] = ""

function latex_test_with_a_vengeance(fname)
    Drawing(800, 800, fname)
    origin()
    translate(boxtopcenter() + (-300, 6))
    background("grey6")
    fontsize(40)
    sethue("white")
    t1 = L"e^{i\pi} + 1 = 0"
    t2 = L"e^x = \sum^\infty_{n=0} \frac{x^n}{n!} = \lim_{n\to\infty}(1+\frac{x}{n})^n"
    t3 = L"\sin(\theta)"
    t4 = L"\cos(\theta)"
    t5 = L"⨟ { } @%&* () -+ !? |~ "
    t6 = L"doublestruck: 𝔸 𝔹 ℂ 𝔻 𝔽 𝔾 ℍ 𝕀 𝕁 𝕂 𝕃 𝕄 ℕ 𝕆 ℙ ℚ ℝ 𝕊 𝕋 𝕌 𝕎 𝕍 𝕏 ℤ "
    t7 = L"fraktur: 𝔄 𝔅 ℭ 𝔇 𝔈 𝔉 𝔊 ℌ ℑ 𝔍 𝔎 𝔏 𝔐 𝔑 𝔒 𝔓 𝔔 ℜ 𝔖 𝔗 𝔘 𝔙 𝔚 𝔛 𝔜 ℨ"
    t8 = L"fraktur: 𝕬 𝕭 𝕮 𝕯 𝕰 𝕱 𝕲 𝕳 𝕴 𝕵 𝕶 𝕷 𝕸 𝕹 𝕺 𝕻 𝕼 𝕽 𝕾 𝕿 𝖀 𝖁 𝖂 𝖃 𝖄 𝖅"
    t9 = L"script: 𝒜 ℬ 𝒞 𝒟 ℰ ℱ 𝒢 ℋ ℐ 𝒥 𝒦 ℒ ℳ 𝒩 𝒪 𝒫 𝒬 ℛ 𝒮 𝒯 𝒰 𝒱 𝒲 𝒳 𝒴 𝒵"
    t10 = L"doublestruck lowercase: 𝕒 𝕓 𝕔 𝕕 𝕖 𝕗 𝕘 𝕙 𝕚 𝕛 𝕜 𝕝 𝕞 𝕟 𝕠 𝕡 𝕢 𝕣 𝕤 𝕥 𝕦 𝕧 𝕩 𝕨 𝕪 𝕫"
    t11 = L"bold: 𝐚 𝐛 𝐜 𝐝 𝐞 𝐟 𝐠 𝐡 𝐢 𝐣 𝐤 𝐥 𝐦 𝐧 𝐨 𝐩 𝐪 𝐫 𝐬 𝐭 𝐮 𝐯 𝐱 𝐰 𝐲 𝐳 "
    t12 = L"bold: 𝐀 𝐁 𝐂 𝐃 𝐄 𝐅 𝐆 𝐇 𝐈 𝐉 𝐊 𝐋 𝐌 𝐍 𝐎 𝐏 𝐐 𝐑 𝐒 𝐓 𝐔 𝐕 𝐗 𝐖 𝐘 𝐙"
    t13 = L"bold script: 𝓐 𝓑 𝓒 𝓓 𝓔 𝓕 𝓖 𝓗 𝓘 𝓙 𝓚 𝓛 𝓜 𝓝 𝓞 𝓟 𝓠 𝓡 𝓢 𝓣 𝓤 𝓥 𝓧 𝓦 𝓨 𝓩"

    for t in [t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13]
        text(t, O, halign = :left, valign = :baseline)
        translate(0, 60)
    end
    @test finish() == true
end

fname = "latex-test-with-a-vengeance.svg"
latex_test_with_a_vengeance(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function testlabels(fname)
    pagewidth, pageheight = 800, 800

    Drawing(pagewidth, pageheight, fname)
    origin() # move 0/0 to center
    background("ivory")
    sethue("black")

    # compasspoint version
    compass = [:E, :SE, :S, :SW, :W, :NW, :N, :NE]

    fontsize(7)
    setline(1)
    for i in 0:pi/64:2pi
        pt = polar(250, i)
        line(between(O, pt, 0.5), pt, :stroke)
        circle(pt, 2, :fill)
        n = mod1(convert(Int, div(i + pi/8, pi/4) + 1), 8)
        @layer begin
            setline(.5)
            label(string(compass[n]),
                compass[n],
                pt,
                offset=30,
                leaderoffsets=[0.2, 0.8],
                leader = isodd(n) ? true : false)
        end
    end

    # angle version
    fontsize(4)
    setline(0.5)
    pg = ngon(O, 80, 32, 0, vertices=true)
    poly(pg, :stroke, close=true)
    for pt in pg
        circle(pt, 3, :fill)
        s = slope(O, pt)
        label(string(round(s, digits=1)), s, pt, leader=true, leaderoffsets=[0.3, 0.9], offset=15)
        label(string(round(s, digits=1)), s, pt, offset=-15)
    end

    @test finish() == true
    println("...finished labels test, saved in $(fname)")
end

fname = "label-test.svg"
testlabels(fname)

"""
    setcolor("gold")
    setcolor("darkturquoise")

Set the current color to a named color. This use the definitions in Colors.jl to convert a
string to RGBA eg `setcolor("gold")` or "green", "darkturquoise", "lavender", etc. The list
is at `Colors.color_names`.

Use `sethue()` for changing colors without changing current opacity level.

`sethue()` and `setcolor()` return the three or four values that were used:

```julia
julia> setcolor(sethue("red")..., .8)
(1.0N0f8, 0.0N0f8, 0.0N0f8, 0.8)

julia> sethue(setcolor("red")[1:3]...)
(1.0N0f8, 0.0N0f8, 0.0N0f8)
```

You can also do:

    using Colors
    sethue(colorant"red")

See also [`setcolor`](@ref).
"""
function setcolor(col::AbstractString)
    temp = parse(RGBA, col)
    # set Luxor settings
    _set_current_color(temp.r, temp.g, temp.b, temp.alpha)
    # and set Cairo context too
    Cairo.set_source_rgba(_get_current_cr(), temp.r, temp.g, temp.b, temp.alpha)
    return (temp.r, temp.g, temp.b, temp.alpha)
end

"""
    setcolor(r, g, b)
    setcolor(r, g, b, alpha)
    setcolor(color)
    setcolor(col::Colors.Colorant)
    setcolor(sethue("red")..., .2)

Set the current color.

Examples:

    setcolor(convert(Colors.HSV, Colors.RGB(0.5, 1, 1)))
    setcolor(.2, .3, .4, .5)
    setcolor(convert(Colors.HSV, Colors.RGB(0.5, 1, 1)))

    for i in 1:15:360
       setcolor(convert(Colors.RGB, Colors.HSV(i, 1, 1)))
       ...
    end

See also [`sethue`](@ref).
"""
function setcolor(col::Colors.Colorant)
    temp = convert(RGBA, col)
    setcolor(temp.r, temp.g, temp.b, temp.alpha)
    return (temp.r, temp.g, temp.b, temp.alpha)
end

function setcolor(r, g, b, a = 1.0)
    _set_current_color(r, g, b, a)
    Cairo.set_source_rgba(_get_current_cr(), r, g, b, a)
    return (r, g, b, a)
end

"""
Set the current color to a string using a macro.

For example:

    setcolor"red"
"""
macro setcolor_str(ex)
    isa(ex, String) || error("colorant requires literal strings")
    col = parse(RGBA, ex)
    quote
        _set_current_color($col.r, $col.g, $col.b, $col.alpha)
        (cr, r, g, b, a) = _get_current_cr_color()
        Cairo.set_source_rgba(cr, r, g, b, a)
    end
end

"""
    sethue("black")
    sethue(0.3, 0.7, 0.9)
    setcolor(sethue("red")..., .2)

Set the color without changing opacity.

`sethue()` is like `setcolor()`, but we sometimes want to change the current color without
changing alpha/opacity. Using `sethue()` rather than `setcolor()` doesn't change the current
alpha opacity.

See also [`setcolor`](@ref).
"""
function sethue(col::AbstractString)
    temp = parse(RGBA, col)
    _set_current_color(temp.r, temp.g, temp.b)
    # use current alpha, not incoming one
    (cr, _, _, _, a) = _get_current_cr_color()
    Cairo.set_source_rgba(cr, temp.r, temp.g, temp.b, a)
    return (temp.r, temp.g, temp.b)
end

"""
    sethue(col::Colors.Colorant)

Set the color without changing the current alpha/opacity:
"""
function sethue(col::Colors.Colorant)
    temp = convert(RGBA, col)
    _set_current_color(temp.r, temp.g, temp.b)
    # use current alpha
    (cr, _, _, _, a) = _get_current_cr_color()
    Cairo.set_source_rgba(cr, temp.r, temp.g, temp.b, a)
    return (temp.r, temp.g, temp.b)
end

"""
    sethue(0.3, 0.7, 0.9)

Set the color's `r`, `g`, `b` values. Use `setcolor(r, g, b, a)` to set transparent colors.
"""
function sethue(r, g, b)
    _set_current_color(r, g, b)
    # use current alpha
    (cr, _, _, _, a) = _get_current_cr_color()
    Cairo.set_source_rgba(cr, r, g, b, a)
    return (r, g, b)
end

"""
    sethue((r, g, b))

Set the color to the tuple's values.
"""
sethue(col::NTuple{3,Number}) = sethue(col...)

"""
    sethue((r, g, b, a))

Set the color to the tuple's values.
"""
sethue(col::NTuple{4,Number}) = sethue(col...)

"""
    setcolor((r, g, b))

Set the color to the tuple's values.
"""
setcolor(col::NTuple{3,Number}) = setcolor(col...)

"""
    setcolor((r, g, b, a))

Set the color to the tuple's values.
"""
setcolor(col::NTuple{4,Number}) = setcolor(col...)

"""
    setopacity(alpha)

Set the current opacity to a value between 0 and 1. This modifies the alpha value of the
current color.
"""
function setopacity(a)
    # use current RGB values
    _set_current_alpha(a)
    (cr, r, g, b, _) = _get_current_cr_color()
    Cairo.set_source_rgba(cr, r, g, b, a)
    return a
end

"""
    setgray(n)
    setgrey(n)

Set the color to a gray level of `n`, where `n` is between 0 and 1.
"""
setgray(n) = sethue(n, n, n)
setgrey(n) = setgray(n)

""" sethue() returns the current RGB color """
sethue() = RGB(first(Luxor._get_current_color(), 3)...)

""" setcolor() returns the current RGBA color """
setcolor() = get_current_color()

""" setopacity() returns the current opacity value """
setopacity()  = last(_get_current_color())

"""
    randomhue()

Set a random hue, without changing the current alpha opacity.
"""
function randomhue()
    rrand, grand, brand = rand(3)
    sethue(rrand, grand, brand)
    return (rrand, grand, brand)
end

"""
    randomcolor()

Set a random color. This may change the current alpha opacity too.
"""
function randomcolor()
    rrand, grand, brand, arand = rand(4)
    setcolor(rrand, grand, brand, arand)
    return (rrand, grand, brand, arand)
end

# compositing operators
const blendingmodes = ["clear", "source", "over", "in", "out", "atop", "dest", "dest_over", "dest_in", "dest_out", "dest_atop", "xor", "add", "saturate", "multiply", "screen", "overlay", "darken", "lighten"]

const blendingoperators = [Cairo.OPERATOR_CLEAR, Cairo.OPERATOR_SOURCE, Cairo.OPERATOR_OVER, Cairo.OPERATOR_IN, Cairo.OPERATOR_OUT, Cairo.OPERATOR_ATOP, Cairo.OPERATOR_DEST, Cairo.OPERATOR_DEST_OVER, Cairo.OPERATOR_DEST_IN, Cairo.OPERATOR_DEST_OUT, Cairo.OPERATOR_DEST_ATOP, Cairo.OPERATOR_XOR, Cairo.OPERATOR_ADD, Cairo.OPERATOR_SATURATE, Cairo.OPERATOR_MULTIPLY, Cairo.OPERATOR_SCREEN, Cairo.OPERATOR_OVERLAY, Cairo.OPERATOR_DARKEN, Cairo.OPERATOR_LIGHTEN]

#=
Not yet supported in Cairo.jl?

Cairo.OPERATOR_COLOR_DODGE, Cairo.OPERATOR_COLOR_BURN, Cairo.OPERATOR_HARD_LIGHT, Cairo.OPERATOR_SOFT_LIGHT, Cairo.OPERATOR_DIFFERENCE, Cairo.OPERATOR_EXCLUSION, Cairo.OPERATOR_HSL_HUE, Cairo.OPERATOR_HSL_SATURATION, Cairo.OPERATOR_HSL_COLOR, Cairo.OPERATOR_HSL_LUMINOSITY
=#

"""
    setmode(mode::AbstractString)

Set the compositing/blending mode. `mode` can be one of:

  - `"clear"` Where the second object is drawn, the first is completely removed.
  - `"source"` The second object is drawn as if nothing else were below.
  - `"over"` The default mode: like two transparent slides overlapping.
  - `"in"` The first object is removed completely, the second is only drawn where the first was.
  - `"out"` The second object is drawn only where the first one wasn't.
  - `"atop"` The first object is mostly intact, but mixes both objects in the overlapping area. The second object is not drawn elsewhere.
  - `"dest"` Discard the second object completely.
  - `"dest_over"` Like "over" but draw second object below the first
  - `"dest_in"` Keep the first object whereever the second one overlaps.
  - `"dest_out"` The second object is used to reduce the visibility of the first where they overlap.
  - `"dest_atop"` Like "over" but draw second object below the first.
  - `"xor"` XOR where the objects overlap
  - `"add"` Add the overlapping areas together
  - `"saturate"` Increase Saturation where objects overlap
  - `"multiply"` Multiply where objects overlap
  - `"screen"` Input colors are complemented and multiplied, the product is complemented again. The result is at least as light as the lighter of the input colors.
  - `"overlay"` Multiplies or screens colors, depending on the lightness of the destination color.
  - `"darken"` Selects the darker of the color values in each component.
  - `"lighten"` Selects the lighter of the color values in each component.

See the [Cairo documentation](https://www.cairographics.org/operators/) for details.
"""
function setmode(operator::AbstractString)
    indx = findfirst(isequal(operator), blendingmodes)
    if indx !== nothing
        Cairo.set_operator(_get_current_cr(), blendingoperators[indx])
    end
end

"""
    getmode()

Return the current compositing/blending mode as a string.
"""
function getmode()
    return blendingmodes[Cairo.get_operator(_get_current_cr()) + 1]
end

"""
    mask(point::Point, focus::Point, radius)
        max = 1.0,
        min = 0.0,
        easingfunction = easingflat)

Calculate a value between 0 and 1 for a `point` relative to a circular area
defined by `focus` and `radius`. The value will approach `max` (1.0) at the
center of the circular area, and `min` (0.0) at the circumference.
"""
function mask(point::Point, focus::Point, radius;
    max = 1.0,
    min = 0.0,
    easingfunction = easingflat)
    angle = slope(focus, point)
    d = distance(focus, point)
    dref = distance(focus, focus + polar(radius, angle))
    if d < dref
        k = rescale(d, 0.0, dref, max, min)
        ratio = easingfunction(k, 0.0, 1.0, 1.0)
    else
        ratio = 0.0
    end
    return ratio
end

"""
    mask(point::Point, focus::Point, width, height)
        max = 1.0,
        min = 0.0,
        easingfunction = easingflat)

Calculate a value between 0 and 1 for a `point` relative to a rectangular
area defined by `focus`, `width`, and `height`. The value will approach
`max` (1.0) at the center, and `min` (0.0) at the edges.
"""
function mask(point::Point, focus::Point, width, height;
    max = 1.0,
    min = 0.0,
    easingfunction = easingflat)
    bb = BoundingBox(box(focus, width, height, vertices = true))
    ptcross = pointcrossesboundingbox(point, bb)
    d = distance(focus, point)
    dref = distance(focus, ptcross)
    if d < dref
        k = rescale(d, 0.0, dref, max, min)
        ratio = easingfunction(k, 0.0, 1.0, 1.0)
    else
        ratio = 0.0
    end
    return ratio
end

"""
    get_current_hue()

As set by eg `sethue()`. Return an RGB colorant.

See also [`getcolor`](@ref), [`get_current_color`](@ref).
"""
function get_current_hue()
    (r, g, b, _) = _get_current_color()
    return RGB(r, g, b)
end

"""
    get_current_color()

Return an RGBA colorant, the current color, as set by `setcolor()` etc.

See also [`getcolor`](@ref), [`get_current_hue`](@ref).
"""
function get_current_color()
    (r, g, b, a) = _get_current_color()
    return RGBA(r, g, b, a)
end

"""
    getcolor()

Return an RGBA colorant, the current color, as set by `setcolor()` etc.

Calls [`get_current_color`](@ref). See also [`get_current_hue`](@ref).
"""
function getcolor()
    Luxor.get_current_color()
end

#!/usr/bin/env julia

using Luxor

using Test, Random

function drawbbox(apoly)
    gsave()
    setline(0.3)
    setdash("dotted")
    box(BoundingBox(apoly), :stroke)
    grestore()
end

function pretty_test1(p, x, y)
    prettypoly(p, :fill,
        vertexlabels = (n, l) -> (text(string(n, " of ", l))),
        # all these commands are executed for each vertex of the polygon
        () ->
        begin
            scale(0.5, 0.5)
            randomhue()
            opacity = Luxor._get_current_alpha()
            setopacity(rand(5:10)/10)
            ngon(0, 0, 15, rand(3:12), 0, :fill)
            setopacity(opacity)
            sethue("black")
        end,
    )
end

function pretty_test2(p)
    prettypoly(p,
        :fill,
        () ->
        begin
          ## all these commands are executed for each vertex of the polygon
            randomhue()
            scale(0.5, 0.5)
            rotate(pi/2)
            prettypoly(p, :fill,
                () ->
                begin
                # and all these commands are executed for each vertex of that polygon
                randomhue()
                scale(0.25, 0.25)
                rotate(pi/2)
                prettypoly(p, :fill)
                end
            )
        end
    )
end

function get_png_files()
    folder = dirname(dirname(pathof(Luxor))) * "/test/"
    imagelist = filter(f -> !startswith(f, ".") && endswith(f, "png"), readdir(folder))
    imagepathlist = map(fn -> folder * "/" * fn, imagelist)
    return imagepathlist
end

function test3(p)
    imagelist = get_png_files()
    shuffle!(imagelist)
    img = readpng(imagelist[1])
    w = img.width
    h = img.height
    prettypoly(p,
        :fill,
        () ->
        begin
            ## all these commands are executed for each vertex of the polygon
            placeimage(readpng(imagelist[rand(1:end)]), -w/2, -h/2)
        end
        )
end

function draw_lots_of_polys(pagewidth, pageheight)
    setopacity(0.75)
    pagetiles = Tiler(pagewidth, pageheight, 9, 9, margin=20)
    for (pos, n) in pagetiles
        if rand(Bool)
            p = randompointarray(rand(-140:-10), rand(-140:-10), rand(10:140), rand(10:140), rand(5:12))
        else
            p = ngon(0, 0, rand(50:100), rand(3:12), vertices=true)
        end
        gsave()
        translate(pos)
        setline(1)
        randomhue()
        if n % 3  == 0
            pretty_test1(p, pos.x, pos.y)
        elseif n % 3 == 1
            pretty_test2(p)
        elseif n % 3 == 2
            test3(p)
        end
        drawbbox(p)
        grestore()
    end
end

function test_pretty_poly(fname)
    width, height = 3000, 3000
    Drawing(width, height, fname)
    origin()
    background("ivory")
    # test empty prettypoly
    prettypoly(Point[], :stroke)
    draw_lots_of_polys(width, height)
    @test finish() == true
end

fname = "pretty-poly-test.pdf"
test_pretty_poly(fname)
println("...finished test: output in $(fname)")

# Extensions are modules that depend on Luxor and other modules.
# They are loaded when Luxor and these modules are loaded.

function latextextsize(arg::Any)
    error("The Modules LaTeXStrings and MathTeXEngine are not loaded.")
end

function latexboundingbox(arg::Any)
    error("The Modules LaTeXStrings and MathTeXEngine are not loaded.")
end

function rawlatexboundingbox(arg::Any)
    error("The Modules LaTeXStrings and MathTeXEngine are not loaded.")
end

# the typstry extension defines this function
"""
    render_typst_document(ts::TypstString)

Render the Typst string in `ts` to an array of SVG images, one 
for each page.

To use Typst:

```julia
using Luxor
using Typstry

@draw begin
    placeimage(
        first(
            render_typst_document(
                typst"
#set text(size: 100pt)
Hello world"
            )
        ), boxtopleft()
    )
end
```
"""
function render_typst_document(arg::Any)
    error("The Typstry module is not loaded.
    Try `using Pkg; Pkg.add(\"Typstry\"); using Typstry` first.
    This function expects a Typst string and returns an array of SVG images.
    ")
end

#!/usr/bin/env julia

using Luxor, Colors

using Test

using Random
Random.seed!(42)

function color_blend_test(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("blue")
    fontsize(20)

    # a linear blend
    redbluelinearblend = blend(Point(-100, 0), Point(100, 0))
    addstop(redbluelinearblend, 0, Colors.RGBA(1, 0, 0, 0.15))
    addstop(redbluelinearblend, 0.5, "white")
    addstop(redbluelinearblend, 1, Colors.RGBA(0, 0, 1, 0.15))

    # a radial blend
    redblueradialblend = blend(Point(0, 0), 0, Point(0, 0), 100)
    addstop(redblueradialblend, 0, Colors.RGBA(1, 0, 0, 0.15))
    addstop(redblueradialblend, 0.5, "white")
    addstop(redblueradialblend, 1, (0, 0, 1, 0.15))
    tiles = Tiler(1200, 1200, 5, 5, margin=20)
    for (pos, n) in tiles
        gsave()
        # take a Cairo matrix, convert it to Julia, apply scale, rotate, and translate matrix
        # transforms, convert back to Cairo, and apply it to the blend.
        # It doesn't seem right, does it...
        A = [1 0 0 1 0 0]
        Aj = cairotojuliamatrix(A)
        Sj = translationmatrix(0, -15) * rotationmatrix(rescale(n, 0, 25, 0, 2pi)) * scalingmatrix(1 - n/30, 1 - n/30) * Aj
        As = juliatocairomatrix(Sj)
        translate(pos)
        sethue("green")
        box(O, tiles.tilewidth/2, tiles.tilewidth/2, :fill)
        blendmatrix(redblueradialblend, As)
        setblend(redblueradialblend) # aligns pattern with current axes
        setblendextend(redblueradialblend, :reflect)
        ellipse(O, tiles.tilewidth-10, tiles.tileheight-10, :fill)
        blendrad = blend(O, 1, O, 25, RGBA(0, 1, 1, 0.5), RGBA(0, 1, 0, 0.0))
        blendlin = blend(O, Point(O.x + tiles.tilewidth/2, O.y), "orange", "magenta")
        setblend(blendlin)
        text("linear", O + Point(5,5))
        setblend(blendrad)
        text("radial", O - Point(5,5))
        grestore()
    end

    sethue("black")
    blend_gold_black = blend(
            Point(0, 0), 0,                   # first circle center and radius
            Point(0, 0), 1,                   # second circle center and radius
            "gold", "black")

    translate(0, -550)
    tiles = Tiler(1000, 200, 1, 15, margin=20)
    orangegreenlinearblend = blend(Point(-1, 0), Point(1, 0), "orange", "green")

    for (pos, n) in tiles
        blendadjust(orangegreenlinearblend, pos, tiles.tilewidth/2, tiles.tilewidth/2, rescale(n, 1, 15, 0, 2pi))
        setblend(orangegreenlinearblend)
        setblendextend(orangegreenlinearblend, "reflect")
        ellipse(pos, tiles.tilewidth, tiles.tilewidth, :fill)
        sethue("white")
        text(string(rescale(n, 1, 15, 0, 2pi)), pos)
    end
    @test finish() == true
end

fname = "color-blends-2.pdf"
color_blend_test(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Colors, Test, Random
Random.seed!(42)

Drawing(800, 800, "morepolytests.png")
origin()
background("white")

@testset "collinear points tests" begin
    pgon = box(BoundingBox(), vertices=true)
    @test length(pgon) == 4

    pgon = polysample(pgon, 12)
    @test length(pgon) == 12

    pgon1 = polyremovecollinearpoints(pgon)
    @test length(pgon1) == 4

    pgon = [Point(x, 0) for x in -250:1.4:250]
    pgon1 = polyremovecollinearpoints(pgon)
    # they've all gone!
    @test length(pgon1) == 0
    pgon = [Point(0, y) for y in -250:1.4:250]
    pgon1 = polyremovecollinearpoints(pgon)
    # they've all gone!
    @test length(pgon1) == 0

    badpgon = Point[O, O + (10, 0)]
    l = length(polyremovecollinearpoints(badpgon))
    @test l == 0

    badpgon = Point[O]
    l = length(polyremovecollinearpoints(badpgon))
    @test l == 0

end

@testset "clockwise tests" begin
    pgon = box(BoundingBox(), vertices=true)
    @test ispolyclockwise(pgon) == true
    pgon1 = reverse(pgon)
    @test ispolyclockwise(pgon1) == false

    pgon = star(O, 100, 21, 0.1, vertices=true)
    @test ispolyclockwise(pgon) == true
    pgon1 = reverse(pgon)
    @test ispolyclockwise(pgon1) == false

    pgon = [polar(100, θ) for θ in 0:π/12:2π]
    @test ispolyclockwise(pgon) == true
    pgon1 = reverse(pgon)
    @test ispolyclockwise(pgon1) == false

    pgon = [Point(x, 0) for x in -250:20:250]
    # move last point lower, makes it clockwise
    pgon[end] += (0, 50)
    @test ispolyclockwise(pgon) == true
    # move it back
    pgon[end] -= (0, 50)
    #  what should a straight line really be, clockwise or not?
    # looks like it's not clockwise
    @test ispolyclockwise(pgon) == false
    @test ispolyclockwise([O, O + (10, 0)]) == false
end

@testset "polyorientation tests" begin
    # clockwise
    orientations = Float64[]
    for i in 1.0:-0.1:0.1
        pgon = box(BoundingBox() * i, vertices=true)
        # polyarea and polyorientation are basically the same, but
        # the latter is doubled and carries sign
        @test polyarea(pgon) == polyorientation(pgon)/2
        push!(orientations, polyorientation(pgon))
    end
    # each polyorientation is area, and should all be clockwise...
    @test all(isequal(25600.00), diff(diff(orientations)))
    # not clockwise
    orientations = Float64[]
    for i in 1.0:-0.1:0.1
        pgon = reverse(box(BoundingBox() * i, vertices=true))
        @test polyarea(pgon) == -polyorientation(pgon)/2
        push!(orientations, polyorientation(pgon))
    end
    @test all(isequal(-25600.00), diff(diff(orientations)))

    # I don't like these, but we've never defined what a polygon _should_ be:
    badpgon = Point[O, O + (10, 0)]
    @test iszero(polyorientation(badpgon))
    @test !ispolyclockwise(badpgon)

    badpgon = Point[O, O + (0, 10)]
    @test iszero(polyorientation(badpgon))
    @test !ispolyclockwise(badpgon)

    badpgon = Point[O, O + (0, 0)]
    @test iszero(polyorientation(badpgon))
    @test !ispolyclockwise(badpgon)

    badpgon = Point[O, O]
    @test iszero(polyorientation(badpgon))
    @test !ispolyclockwise(badpgon)

    badpgon = Point[O]
    @test iszero(polyorientation(badpgon))
    @test !ispolyclockwise(badpgon)
end

@testset "point inside triangle tests" begin
    goodtriangle = Point[O, Point(100, 100), Point(-100, 100)]
    # ispointinsidetriangle() accepts points on the borders
    @test ispointinsidetriangle(O, goodtriangle)
    @test ispointinsidetriangle(Point(100, 100), goodtriangle)
    @test ispointinsidetriangle(Point(50, 100), goodtriangle)
    @test ispointinsidetriangle(Point(0, 100), goodtriangle)
    @test ispointinsidetriangle(Point(-100, 100), goodtriangle)
    @test ispointinsidetriangle(Point(0.00000000001, 0), goodtriangle)
    @test !ispointinsidetriangle(Point(-0.000000001, 0), goodtriangle)

    @test ispointinsidetriangle(Point(50, 50), goodtriangle)
    @test ispointinsidetriangle(Point(10e9, 50), goodtriangle)

    bigtriangle = Point[O, Point(10e9, 0), Point(-10e9, 10e9)]
    @test ispointinsidetriangle(Point(10e4, 10e4), bigtriangle)
    #shouldn't be able to fool this with an anticlockwise triangle
    @test ispointinsidetriangle(Point(10e4, 10e4), reverse(bigtriangle))

    badtriangle = Point[O, Point(100, 0), Point(200, 0)]
    # apparently this is OK... ;|
    @test ispointinsidetriangle(O, badtriangle)

    # perhaps we should catch these not-triangles better than throwing BoundsError
    badtriangle = Point[O, Point(100, 0)]
    @test_throws BoundsError ispointinsidetriangle(O, badtriangle)

    badtriangle = Point[O]
    @test_throws BoundsError ispointinsidetriangle(O, badtriangle)
end

@testset "insertvertices tests" begin
    pgon = star(Point(20, 20), 200, 12, 0.7, π/7, vertices=true)
    setline(5)
    sethue("magenta")
    prettypoly(pgon, :stroke, () -> circle(O, 20, :fill))
    originallength = length(pgon)
    @test length(insertvertices!(pgon)) == 2originallength
    sethue("black")
    setline(2)
    prettypoly(pgon, :stroke, () -> circle(O, 10, :stroke))
end

@test finish() == true

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function randomsine(func, vertscale, horizontalscale, pagewidth, pageheight, style, delta=0.1)
    # y is positive downwards...
    pl = Point[]
    xc=delta
    if rand(Bool)
        for i in -pagewidth/2:delta:pagewidth/2
            push!(pl, Point(i, vertscale * -func(i/horizontalscale) * func(3 * i/horizontalscale) * func(i/horizontalscale)))
        end
    else
        for i in -pagewidth/2:delta:pagewidth/2
            push!(pl, Point(i, vertscale * -func(i / horizontalscale)))
        end
    end
    #push!(pl, Point(pagewidth/2,  pl[end].y))
    #push!(pl, Point(-pagewidth/2, pl[1].y))
    poly(pl, close=false, style)
end

function random_sines(w, h, fname)
    Drawing(w, h, fname)
    origin()
    background("black")
    for i in 1:250
        setline(rand(0.02:0.01:3))
        setdash([
         "solid",
         "dotted",
         "dot",
         "dotdashed",
         "longdashed",
         "shortdashed",
         "dash",
         "dashed",
         "dotdotdashed",
         "dotdotdotdashed"
         ][rand(1:end)])
        gsave()
        sf = rand(1:15)
        scale(sf, sf)
        translate(0, rand(-h/2:h/2))
        randomhue()
        setopacity(rand(0.25:0.1:0.75))
        randomsine(
         [sin, cos][rand(1:end)],                    # random function
         rand(20:40),                               # random vertical scale
         rand(10:20),                                # horizontalscale
         w,                                          # pagewidth
         h,                                          # pageheight
         [:fill, :stroke, :stroke, :fillstroke][rand(1:end)], # random drawing style
         rand(0.1:0.1:0.5))
        grestore()
    end
    @test finish() == true
end

fname = "random-sines.pdf"
random_sines(2000, 2000, fname)
println("...finished test: output in $(fname)")

mutable struct BoundingBox
    corner1::Point
    corner2::Point
end

function Base.show(io::IO, bbox::BoundingBox)
    print(io, " ⤡ ", bbox.corner1, " : ", bbox.corner2)
end

"""
`BoundingBox()` with no arguments returns a BoundingBox that
includes the current drawing.

The default `BoundingBox(;centered=true)` returns a
BoundingBox the same size and position as the current
drawing, and assumes the origin (0, 0) is at the center.

If the `centered` option is `false`, the function assumes
that the origin is at the top left of the drawing. So this
function doesn't really work if the current matrix has been
modified (by `translate()`, `scale()`, `rotate()` etc.)

An instance of the BoundingBox type holds two Points,
`corner1` and `corner2`.

```julia
BoundingBox(;centered = true)   # the bounding box of the Drawing
```

```julia
BoundingBox(s::AbstractString)  # the bounding box of a text string at the origin
```

```julia
BoundingBox(pt::Array)          # the bounding box of a polygon
```

```julia
BoundingBox(circle(O, 100))     # the bounding box of a path added by circle()
```

```julia
BoundingBox(path::Path)         # the bounding box of a Path
```

You can use `BoundingBox()` with the functions that add
graphic shapes to the current path (eg `box()`, `circle()`,
`star()`, `ngon()`). But note that eg `BoundingBox(box(O, 100, 100))` adds a
shape to the current path as well as returning a bounding box.
"""
function BoundingBox(;
    centered = true)
    if currentdrawing() == false
        # return a default bounding box of 600×600
        r = BoundingBox(Point(-300, -300), Point(300, 300))
    elseif centered
        # ignore current matrix
        r = BoundingBox(
            Point(
                -_current_width() / 2,
                -_current_height() / 2,
            ),
            Point(
                _current_width() / 2,
                _current_height() / 2,
            ),
        )
    else
        b = getmatrix()
        setmatrix([1.0, 0.0, 0.0, 1.0, 0.0, 0.0])
        r = BoundingBox(
            Point(0, 0),
            Point(_current_width(), _current_height()),
        )
        setmatrix(b)
    end
    return r
end

"""
    BoundingBox(pointlist::Vector)

Return the BoundingBox of a polygon (array of points).
"""
function BoundingBox(pointlist::Vector{Point})
    lowx, lowy = pointlist[1].x, pointlist[1].y
    highx, highy = pointlist[end].x, pointlist[end].y
    for p in pointlist
        p.x < lowx && (lowx = p.x)
        p.y < lowy && (lowy = p.y)
        p.x > highx && (highx = p.x)
        p.y > highy && (highy = p.y)
    end
    return BoundingBox(
        Point(lowx, lowy),
        Point(highx, highy))
end

BoundingBox(pts::NTuple{2,Point}) = BoundingBox(pts...)

"""
    BoundingBox(str::AbstractString)

Return a BoundingBox that just encloses a text string, given the current font
selection. Uses the Toy text API (ie `text()` and `textextents()`).

Text is assumed to be placed at the origin (`0/0`).
"""
function BoundingBox(str::AbstractString)
    xbearing, ybearing, width, height, xadvance, yadvance =
        textextents(str)
    lcorner = Point(xbearing, ybearing)
    ocorner = Point(lcorner.x + width, lcorner.y + height)
    return BoundingBox(lcorner, ocorner)
end

#state is either 1 or 2!
function Base.iterate(bbox::BoundingBox)
    return (bbox.corner1, 2)
end

function Base.iterate(bbox::BoundingBox, state)
    if state > 2
        return
    end
    state == 1 ? (bbox.corner1, state + 1) :
    state == 2 ? (bbox.corner2, state + 1) :
    error("this should never happen")
end

Base.last(bbox::BoundingBox) = bbox.corner2

Base.size(bbox::BoundingBox) = (2)

function Base.length(bbox::BoundingBox)
    return 2
end

unsafe_length(bbox::BoundingBox) = length(bbox)

Base.eltype(::Type{BoundingBox}) = Point

Base.lastindex(bbox::BoundingBox) = 2

function Base.getindex(bbox::BoundingBox, i::Int)
    if i == 1
        return bbox.corner1
    else
        return bbox.corner2
    end
end

Base.getindex(bbox::BoundingBox, i::Number) =
    bbox[convert(Int, i)]
Base.getindex(bbox::BoundingBox, I) = [bbox[i] for i in I]

function Base.setindex(bbox::BoundingBox, v::Point, i::Number)
    if i == 1
        return BoundingBox(v, bbox.corner2)
    else
        return BoundingBox(bbox.corner1, v)
    end
end

# basics
# adding a number to a box makes the box larger all round
+(z::Number, bb1::BoundingBox) =
    BoundingBox(bb1.corner1 - Point(z,z), bb1.corner2 + Point(z,z))
+(bb1::BoundingBox, z::Number) =
    BoundingBox(bb1.corner1 - Point(z,z), bb1.corner2 + Point(z,z))

# subtracting a number makes the box smaller all round
-(z::Number, bb1::BoundingBox) =
    BoundingBox(bb1.corner1 + Point(z,z), bb1.corner2 - Point(z,z))
-(bb1::BoundingBox, z::Number) =
    BoundingBox(bb1.corner1 + Point(z,z), bb1.corner2 - Point(z,z))

function (*)(bb::BoundingBox, s::Real)
    c = midpoint(bb...)
    newcorner1 = between(c, bb.corner1, s)
    newcorner2 = between(c, bb.corner2, s)
    return BoundingBox(newcorner1, newcorner2)
end

(*)(s::Real, bb::BoundingBox) = bb * s

function (/)(bb::BoundingBox, s::Real)
    c = midpoint(bb...)
    newcorner1 = between(c, bb.corner1, 1 / s)
    newcorner2 = between(c, bb.corner2, 1 / s)
    return BoundingBox(newcorner1, newcorner2)
end

(/)(s::Real, bb::BoundingBox) = bb / s

# modifying with tuples shifts the box in x and y
+(bb1::BoundingBox, shift::NTuple{2,Real}) =
    BoundingBox(
        Point(
            bb1.corner1.x + shift[1],
            bb1.corner1.y + shift[2]),
        Point(
            bb1.corner2.x + shift[1],
            bb1.corner2.y + shift[2]))

-(bb1::BoundingBox, shift::NTuple{2,Real}) =
    BoundingBox(
        Point(
            bb1.corner1.x - shift[1],
            bb1.corner1.y - shift[2]),
        Point(
            bb1.corner2.x - shift[1],
            bb1.corner2.y - shift[2]))

# also add/subtract a point to a bounding box shifts the box
+(bb1::BoundingBox, pt::Point) =
    +(bb1::BoundingBox, (pt.x, pt.y))
+(pt::Point, bb1::BoundingBox) = +(bb1, pt)
-(bb1::BoundingBox, pt::Point) =
    -(bb1::BoundingBox, (pt.x, pt.y))
-(pt::Point, bb1::BoundingBox) = -(bb1, pt)

# if you add two bounding boxes, you get the biggest enclosing box
function +(bb1::BoundingBox, bb2::BoundingBox)
    pts = [bb1.corner1, bb1.corner2, bb2.corner1, bb2.corner2]
    lox, hix = sort!(pts, by = a -> a.x, lt = (a, b) -> a < b)[[1, end]]
    loy, hiy = sort!(pts, by = a -> a.y, lt = (a, b) -> a < b)[[1, end]]
    return BoundingBox(
        Point(lox.x, loy.y),
        Point(hix.x, hiy.y))
end

"""
    boxwidth(bb::BoundingBox=BoundingBox())

Return the width of bounding box `bb`.
"""
boxwidth(bb::BoundingBox = BoundingBox()) =
    abs(bb.corner1.x - bb.corner2.x)

"""
    boxheight(bb::BoundingBox=BoundingBox())

Return the height of bounding box `bb`.
"""
boxheight(bb::BoundingBox = BoundingBox()) =
    abs(bb.corner1.y - bb.corner2.y)

"""
    boxdiagonal(bb::BoundingBox=BoundingBox())

Return the length of the diagonal of bounding box `bb`.
"""
boxdiagonal(bb::BoundingBox = BoundingBox()) =
    hypot(boxwidth(bb), boxheight(bb))

"""
    boxaspectratio(bb::BoundingBox=BoundingBox())

Return the aspect ratio (the height divided by the width) of bounding box `bb`.
"""
boxaspectratio(bb::BoundingBox = BoundingBox()) =
    boxheight(bb) / boxwidth(bb)

"""
    convert(Point, bbox::BoundingBox)

Convert a BoundingBox to a four-point clockwise polygon.

    convert(Vector{Point}, BoundingBox())
"""
function Base.convert(::Type{Vector{Point}}, bbox::BoundingBox)
    return [
        bbox.corner1,
        Point(bbox.corner2.x, bbox.corner1.y),
        bbox.corner2,
        Point(bbox.corner1.x, bbox.corner2.y)]
end

"""
    box(bbox::BoundingBox;
        action   = :none,
        vertices = false)
    box(bbox::BoundingBox, action::Symbol;
        vertices=false)

Define a box using the bounds in `bbox`.

Use `vertices = true` to return an array of the four corner points: bottom left,
top left, top right, bottom right.
"""
function box(bbox::BoundingBox;
    action = :none,
    vertices = false)
    if vertices || action == :none
        botleft = Point(bbox.corner1.x, bbox.corner2.y)
        topleft = bbox.corner1
        topright = Point(bbox.corner2.x, bbox.corner1.y)
        botright = bbox.corner2
        return [botleft, topleft, topright, botright]
    else
        box(bbox.corner1, bbox.corner2, action)
    end
end

box(bbox::BoundingBox, action::Symbol) =
    box(bbox, action = action, vertices = false)

"""
    poly(bbox::BoundingBox, :action; kwargs...)

Make a polygon around the BoundingBox in `bbox`.
"""
poly(bbox::BoundingBox, action::Symbol = :none; kwargs...) =
    poly(convert(Vector{Point}, bbox), action; kwargs...)

"""
    prettypoly(bbox::BoundingBox, action; kwargs...)

Make a decorated polygon around the BoundingBox in `bbox`. The vertices are in
the order: bottom left, top left, top right, and bottom right.
"""
prettypoly(bbox::BoundingBox, a::Symbol = :none;
    action = a,
    close = false,
    reversepath = false,
    vertexlabels = (n, l) -> ()) =
    prettypoly(convert(Vector{Point}, bbox),
        action = action,
        close = close,
        reversepath = reversepath,
        vertexlabels = vertexlabels)

"""
    boundingboxesintersect(bbox1::BoundingBox, bbox2::BoundingBox)
    boundingboxesintersect(acorner1::Point, acorner2::Point, bcorner1::Point, bcorner2::Point)

Return true if the two bounding boxes intersect.
"""
function boundingboxesintersect(acorner1::Point,
    acorner2::Point,
    bcorner1::Point,
    bcorner2::Point)
    minax, maxax = minmax(acorner1.x, acorner2.x)
    minay, maxay = minmax(acorner1.y, acorner2.y)

    minbx, maxbx = minmax(bcorner1.x, bcorner2.x)
    minby, maxby = minmax(bcorner1.y, bcorner2.y)

    maxax < minbx && return false
    maxbx < minax && return false

    maxay < minby && return false
    maxby < minay && return false
    return true # boxes overlap
end

boundingboxesintersect(bbox1::BoundingBox, bbox2::BoundingBox) =
    boundingboxesintersect(bbox1.corner1,
        bbox1.corner2,
        bbox2.corner1,
        bbox2.corner2)

"""
    intersectboundingboxes(bb1::BoundingBox, bb2::BoundingBox)

Return a BoundingBox that's an intersection of the two bounding boxes.
"""
function intersectboundingboxes(bb1::BoundingBox, bb2::BoundingBox)
    !boundingboxesintersect(bb1, bb2) && return BoundingBox(O, O)
    minax, maxax = minmax(bb1.corner1.x, bb1.corner2.x)
    minay, maxay = minmax(bb1.corner1.y, bb1.corner2.y)

    minbx, maxbx = minmax(bb2.corner1.x, bb2.corner2.x)
    minby, maxby = minmax(bb2.corner1.y, bb2.corner2.y)
    return BoundingBox(
        Point(max(minax, minbx), max(minay, minby)),
        Point(min(maxax, maxbx), min(maxay, maxby)))
end

"""
    isinside(p::Point, bb:BoundingBox)

Returns `true` if `pt` is inside bounding box `bb`.
"""
isinside(p::Point, bb::BoundingBox) =
    (bb.corner1.x <= p.x <= bb.corner2.x) &&
    (bb.corner1.y <= p.y <= bb.corner2.y)

"""
    midpoint(bb::BoundingBox=BoundingBox())

Returns the point midway between the two points of the BoundingBox. This should
also be the center, unless I've been very stupid...
"""
midpoint(bb::BoundingBox = BoundingBox()) = midpoint(bb...)

"""
    between(bb::BoundingBox, x)

Find a point between the two corners of a BoundingBox corresponding to `x`,
where `x` is typically between 0 and 1.
"""
between(bb::BoundingBox, k = 0.5) = between(bb[1], bb[2], k)

"""
    boxtopleft(bb::BoundingBox=BoundingBox())

Return the point at the top left of the BoundingBox `bb`, defaulting to the drawing extent.

```
■ ⋅ ⋅
⋅ ⋅ ⋅
⋅ ⋅ ⋅
```
"""
boxtopleft(bb::BoundingBox = BoundingBox()) = bb[1]

"""
    boxtopcenter(bb::BoundingBox=BoundingBox())

Return the point at the top center of the BoundingBox `bb`, defaulting to the drawing extent.

```
⋅ ■ ⋅
⋅ ⋅ ⋅
⋅ ⋅ ⋅
```
"""
boxtopcenter(bb::BoundingBox = BoundingBox()) =
    midpoint(bb.corner1, bb.corner2) - (0, boxheight(bb) / 2)

"""
    boxtopright(bb::BoundingBox=BoundingBox())

Return the point at the top right of the BoundingBox `bb`, defaulting to the drawing extent.

```
⋅ ⋅ ■
⋅ ⋅ ⋅
⋅ ⋅ ⋅
```
"""
boxtopright(bb::BoundingBox = BoundingBox()) =
    Point(bb[2].x, bb[1].y)

"""
    boxmiddleleft(bb::BoundingBox=BoundingBox())

Return the point at the middle left of the BoundingBox `bb`, defaulting to the drawing extent.

```
⋅ ⋅ ⋅
■ ⋅ ⋅
⋅ ⋅ ⋅
```
"""
boxmiddleleft(bb::BoundingBox = BoundingBox()) =
    Point(bb[1].x, midpoint(bb[1], bb[2]).y)

"""
    boxmiddlecenter(bb::BoundingBox=BoundingBox())

Return the point at the center of the BoundingBox `bb`, defaulting to the drawing extent.

```
⋅ ⋅ ⋅
⋅ ■ ⋅
⋅ ⋅ ⋅
```
"""
boxmiddlecenter(bb::BoundingBox = BoundingBox()) =
    midpoint(bb[1], bb[2])

"""
    boxmiddleright(bb::BoundingBox=BoundingBox())

Return the point at the midde right of the BoundingBox `bb`, defaulting to the drawing extent.

```
⋅ ⋅ ⋅
⋅ ⋅ ■
⋅ ⋅ ⋅
```
"""
boxmiddleright(bb::BoundingBox = BoundingBox()) =
    Point(bb[2].x, midpoint(bb[1], bb[2]).y)

"""
    boxbottomleft(bb::BoundingBox=BoundingBox())

Return the point at the bottom left of the BoundingBox `bb`, defaulting to the drawing extent.

```
⋅ ⋅ ⋅
⋅ ⋅ ⋅
■ ⋅ ⋅
```
"""
boxbottomleft(bb::BoundingBox = BoundingBox()) =
    Point(bb[1].x, bb[2].y)

"""
    boxbottomcenter(bb::BoundingBox=BoundingBox())

Return the point at the bottom center of the BoundingBox `bb`, defaulting to the drawing extent.

```
⋅ ⋅ ⋅
⋅ ⋅ ⋅
⋅ ■ ⋅
```
"""
boxbottomcenter(bb::BoundingBox = BoundingBox()) =
    midpoint(bb.corner1, bb.corner2) +
    (0, boxheight(bb) / 2)

"""
    boxbottomright(bb::BoundingBox=BoundingBox())

Return the point at the bottom right of the BoundingBox `bb`, defaulting to the drawing extent.

```
⋅ ⋅ ⋅
⋅ ⋅ ⋅
⋅ ⋅ ■
```
"""
boxbottomright(bb::BoundingBox = BoundingBox()) = bb[2]

# legacy defs will be deprecated
boxtop(bb::BoundingBox) = boxtopcenter(bb)
boxbottom(bb::BoundingBox) = boxbottomcenter(bb)

"""
    pointcrossesboundingbox(pt, bbox::BoundingBox)

Find and return the point where a line from the center of bounding box
`bbox` to point `pt` would, if continued, cross the edges of the box.
"""
function pointcrossesboundingbox(pt, bbox::BoundingBox)
    minpt, maxpt = extrema(bbox)
    mp = midpoint(minpt, maxpt)
    midX, midY = mp.x, mp.y

    m = (midY - pt.y) / (midX - pt.x)
    if pt.x <= midX # left
        min_Xy = m * (minpt.x - pt.x) + pt.y
        if minpt.y <= min_Xy && min_Xy <= maxpt.y
            return Point(minpt.x, min_Xy)
        end
    end
    if pt.x >= midX # right
        max_Xy = m * (maxpt.x - pt.x) + pt.y
        if minpt.y <= max_Xy && max_Xy <= maxpt.y
            return Point(maxpt.x, max_Xy)
        end
    end
    if pt.y <= midY # top
        min_Yx = (minpt.y - pt.y) / m + pt.x
        if minpt.x <= min_Yx && min_Yx <= maxpt.x
            return Point(min_Yx, minpt.y)
        end
    end
    if pt.y >= midY # bottom
        max_Yx = (maxpt.y - pt.y) / m + pt.x
        if minpt.x <= max_Yx && max_Yx <= maxpt.x
            return Point(max_Yx, maxpt.y)
        end
    end
    if pt.x == midX && pt.y == midY
        return Point(pt.x, pt.y)
    end
    error("oh dear, something has gone wrong but I don't know what")
end

"""
    rand(bbox::BoundingBox)

Return a random `Point` that lies inside `bbox`.
"""
Base.rand(bb::BoundingBox) =
    Point((bb.corner2.x - bb.corner1.x) * rand() + bb.corner1.x,
        (bb.corner2.y - bb.corner1.y) * rand() + bb.corner1.y)

"""
    in(pt, bbox::BoundingBox)

Test whether `pt` is inside `bbox`.
"""
Base.in(pt::Point, bbox::BoundingBox) =
    isinside(pt, bbox::BoundingBox)

# for BoundingBox(path::Path) -> Path.jl

"""
    box(bbox::BoundingBox, cornerradii::Array;
        action = :none)

Make a box that is the size of the BoundingBox `bbox` with curved corners.
"""
function box(bbox::BoundingBox, cornerradii::Array;
    action = :none)
    centerpoint = boxmiddlecenter(bbox)
    width = boxwidth(bbox)
    height = boxheight(bbox)
    box(centerpoint, width, height, cornerradii::Array;
        action = action)
end

"""
    box(bbox::BoundingBox, cornerradius::Real;
        action = :none)

Make a box that is the size of the BoundingBox `bbox` with curved corners.
"""
function box(bbox::BoundingBox, cornerradius::Real;
    action = :none)
    box(bbox, fill(cornerradius, 4),
        action = action)
end

# luxor logo
# contibuted by cormullion

using Luxor, Colors

function set_gold_blend()
    gblend = blend(O, 0, O, 220, "gold", "gold3")
    setblend(gblend)
end

function draw_scarab_legs(pos)
    translate(pos)
    # legs
    @layer begin
        for i in 1:2
            move(O)
            rline.((polar(80, -π / 6),
                polar(70, -π / 2),
                polar(12, -5π / 6),
                polar(60, -π / 4)))

            #middle leg
            move(0, 40)
            rline.((
                polar(120, -π / 6),
                polar(40, π / 2)))

            #back leg
            move(0, 100)
            rline.((
                polar(130, -π / 6),
                polar(110, π / 2)))

            # flip for other leg
            transform([-1 0 0 1 0 0])
        end
    end
end

function draw_scarab_body()
    @layer begin
        squircle(Point(0, -25), 26, 75, action = :path)
        squircle(Point(0, 0), 50, 70, action = :path)
        squircle(Point(0, 40), 65, 90, action = :path)
    end
end

function draw(fname)
    Drawing(380, 520, fname)
    origin()
    setline(20)
    setlinecap("butt")
    setlinejoin("round")

    width = currentdrawing().width/2 - 15
    height = currentdrawing().height/2 - 15

    sethue("black")
    squircle(O, width, height - 10, rt = 0.4, action = :fill)
    set_gold_blend()
    squircle(O, width, height - 10, rt = 0.4, action = :path)

    translate(0, 50)
    draw_scarab_legs(O)
    strokepath()

    draw_scarab_body()
    fillpath()

    # julia dots === Ra egyptian sun deity
    @layer begin
        translate(0, -190)
        circle(O, 48, action = :fill)
        juliacircles(20)
    end

    finish()
    preview()
end

fname = dirname(dirname(pathof(Luxor))) * "/docs/src/assets/figures/luxor-logo.svg"

draw(fname)

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

CAIRO_PATH_MOVE_TO = 0
CAIRO_PATH_LINE_TO = 1
CAIRO_PATH_CURVE_TO = 2
CAIRO_PATH_CLOSE_PATH = 3

function get_path_flat(str)
    sethue("blue")
    setopacity(.7)
    setline(0.5)
    p = textpath(str)
    o = getpathflat()
    strokepath()
    sethue("red")
    x, y = 0, 0
    for e in o
        if e.element_type == CAIRO_PATH_MOVE_TO
            (x, y) = e.points
            move(x, y)
        elseif e.element_type == CAIRO_PATH_LINE_TO
            (x, y) = e.points
            # straight lines
            line(x, y)
            strokepath()
            circle(x, y, 1, :stroke)
        elseif e.element_type == CAIRO_PATH_CURVE_TO
            (x1, y1, x2, y2, x3, y3) = e.points
            # show bezier control lines
            circle(x1, y1, 1, :stroke)
            circle(x2, y2, 1, :stroke)
            circle(x3, y3, 1, :stroke)
            move(x, y)
            curve(x1, y1, x2, y2, x3, y3)
            strokepath()
            (x, y) = (x3, y3) # update current point
        elseif e.element_type == CAIRO_PATH_CLOSE_PATH
            closepath()
        else
            error("unknown CairoPathEntry " * repr(e.element_type))
            error("unknown CairoPathEntry " * repr(e.points))
        end
    end
end

function get_path_flat_test(fname)
    Drawing(500, 500, fname)
    origin()
    fontsize(80)
    get_path_flat("Luxor")
    @test finish() == true
    println("...finished test: output in $(fname)")
end

get_path_flat_test("get-path-flat-test.pdf")

import PrecompileTools

PrecompileTools.@compile_workload begin
    ngon(O, 100, 3, vertices=true)
    @draw circle(1.0, 1.2, 1.9, action=:fill)
    noise(1)
    noise(1, 2)
    noise(1, 2, 3)
    noise(1, 2, 3, 4)
    @draw text("snooping away", O)
    pgon = star(O, 201.9, 23, 0.8, π / 2, vertices = true)
    ps = polyportion(pgon, 3/10)
    pa = polydistances(pgon)
    sethue("red")
    polysortbyangle(pgon)
    polysortbydistance(pgon, pgon[1])
    polysmooth(pgon, 5, :none)
    polyremovecollinearpoints(pgon)
    polytriangulate(pgon)
    randompointarray(BoundingBox(Point(0, 0), Point(100, 100)), 10)
    randomhue()
    textoutlines("snoopy", Point(10, 10), action=:path)
    fillpath()
    _reset_all_drawings()
end

using Luxor, Test

function multi_draw()
    @test Luxor._reset_all_drawings() == true
    
    @test Luxor._drawing_indices() == 1:1
    @test Luxor._get_drawing_index() == 1
    @test Luxor._set_drawing_index(5) == 1
    @test Luxor._get_next_drawing_index() == 1
    @test Luxor._set_next_drawing_index() == 1

    Drawing(2, 2, :png)

    @test Luxor._has_drawing() == true

    @test Luxor._drawing_indices() == 1:1
    @test Luxor._get_drawing_index() == 1
    @test Luxor._set_drawing_index(5) == 1
    @test Luxor._get_next_drawing_index() == 2
    @test Luxor._set_next_drawing_index() == 2

    @test currentdrawing() == false
    
    d2 = Drawing(2, 2, :png)
    background(1.0,0,0,1.0)
    mat2=image_as_matrix()

    @test Luxor._drawing_indices() == 1:2
    @test Luxor._get_drawing_index() == 2
    @test Luxor._set_drawing_index(5) == 2

    @test Luxor._set_drawing_index(1) == 1
    @test finish()
    @test Luxor._get_next_drawing_index() == 1
    @test Luxor._set_next_drawing_index() == 1

    d3 = Drawing(2, 2, :png)
    @test currentdrawing(d2) == d2

    mat3=image_as_matrix()
    @test mat3[1] == mat2[1]
    @test mat3[2] == mat2[2]
    @test mat3[3] == mat2[3]
    @test mat3[4] == mat2[4]

    background(0.0,1,0,1.0)
    mat3=image_as_matrix()
    @test Luxor._set_drawing_index(2) == 2
    mat2=image_as_matrix()
    @test mat3[1] == mat2[1]
    @test mat3[2] == mat2[2]
    @test mat3[3] == mat2[3]
    @test mat3[4] == mat2[4]
    
    finish()

    @test Luxor._set_drawing_index(1) == 1
    finish()
end

multi_draw()

println("...finished multi-draw test")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function julia_logo_test(fname)
    Drawing(1000, 1000, fname)
    origin()
    background("white")
    for (pos, n) in Tiler(1000, 1000, 2, 2)
        gsave()
        translate(pos - Point(150, 100))
        if n == 1
            julialogo()
            fillpath()
        elseif n == 2
            randomhue()
            setline(0.3)
            julialogo(action=:stroke)
        elseif n == 3
            sethue("orange")
            julialogo(color=false)
        elseif n == 4
            julialogo(action=:clip)
            setopacity(0.6)
            for i in 1:400
                randomhue()
                gsave()
                box(Point(rand(0:250), rand(0:250)), 350, 5, :fill)
                grestore()
            end
            clipreset()
        end
        grestore()
    end
    @test finish() == true
end

fname="julia-logo-drawing.pdf"
julia_logo_test(fname)
println("...finished test: output in $(fname)")

using Luxor, Test, Random


# test empty drawings

Drawing()
[Drawing() for x in 1:10]
[Drawing(x, x) for x in 1:10]
Drawing(NaN, NaN, :rec)
[Drawing(x, x, :rec) for x in 1:10]
[Drawing(x, x, :image) for x in 1:10]


p = Point(1, 2)
x, y = p

@test x == 1.0
@test y == 2.0

bb = BoundingBox(p, 2p)

rp = rand(bb)

@test rp in bb

@testset "center3pts" begin
    @test center3pts(Point(1,1), Point(3,1), Point(2,0)) == (Point(2.0, 1.0), 1.0)
    Random.seed!(42)
    p1 = Point(rand(), rand())
    p2 = Point(rand(), rand())
    p3 = Point(rand(), rand())
    c, r = center3pts(p1, p2, p3)
    @test distance(p1, c) ≈ distance(p2, c) ≈ distance(p2, c)
end

@testset "concatenate" begin

    finish()

    
    d1 = Drawing(200,100,:svg)
    origin()
    circle(O,60,:fill)
    finish()

    d2 = Drawing(200,200,:svg)
    rect(O,200,200,:fill)
    finish()
    @test typeof(hcat(d1,d2; hpad=10, valign=:top, clip = true)) <: Drawing
    @test typeof(hcat(d1,d2; hpad=10, valign=:middle, clip = false)) <: Drawing
    @test typeof(hcat(d1,d2; hpad=10, valign=:bottom, clip = true)) <: Drawing

    @test typeof(vcat(d1,d2; vpad=10, halign=:left, clip = true)) <: Drawing
    @test typeof(vcat(d1,d2; vpad=10, halign=:center, clip = false)) <: Drawing
    @test typeof(vcat(d1,d2; vpad=10, halign=:right, clip = true)) <: Drawing

end

println("...finished basic-test")

using Luxor
using Test

# testing that functions that accept eg `:fill` also can be used with keyword `action=:fill`

const expressions = [
:(arc(O, 70, 0, π/2, :stroke)),
:(arc(O, 70, 0, π/2, action=:stroke)),

:(arc(O, 30, 0, π/2, :fill)),
:(arc(O, 30, 0, π/2, action=:fill)),

:(arc2r(O, Point(-30, 50), Point(20, 40), :stroke)),
:(arc2r(O, Point(-30, 50), Point(20, 40), action=:stroke)),

:(arc2sagitta(Point(30, 50), Point(20, 50), 40, :stroke)),
:(arc2sagitta(Point(30, 50), Point(20, 50), 40, action=:stroke)),

:(box(-30, -30, 50, 50, :fill)),
:(box(-30, -30, 50, 50, action=:fill)),

:(box([O, Point(24, 20), Point(20, 30)], :fill)),
:(box([O, Point(24, 20), Point(20, 30)], action=:fill)),

:(box(BoundingBox(box([O, Point(24, 20), Point(20, 30)])), :fill)),
:(box(BoundingBox(box([O, Point(24, 20), Point(20, 30)])), action=:fill)),

:(begin
    t = Table(3, 3)
    pts = box(t, 2, 1, action=:stroke, vertices=false, reversepath=true)
    pts = box(t, 2, 1, :stroke, vertices=false, reversepath=true)
    t = Tiler(50, 50, 3, 3)
    pts = box(t, 5, action=:stroke, vertices=false, reversepath=true)
    pts = box(t, 5, :stroke, vertices=false, reversepath=true)
end),

:(box(Point(-30, -50), Point(20, 50), :fill)),
:(box(Point(-25, -20), Point(23, 20), action=:fill)),

:(box(O, 30, 60, 10, :stroke)),
:(box(O, 35, 60, 10, action = :stroke)),

:(box(O, 30, 80, [10, 10, 20, 20], :stroke)),
:(box(O, 35, 80, [10, 10, 20, 20], action = :stroke)),

:(pts = box(O, 20, 20, :stroke; reversepath=true, vertices=true); poly(pts, :fill)),
:(pts = box(O, 20, 20, action=:stroke; reversepath=true, vertices=true); poly(pts, action=:fill)),

:(carc(O, 60, π, π/3, :stroke)),
:(carc(O, 60, π, π/3, action=:stroke)),

:(carc(O, 50, π, π/3, :stroke)),
:(carc(O, 50, π, π/3, action=:stroke)),

:(carc2r(O, Point(30, 30), Point(-20, -20), :stroke)),
:(carc2r(O, Point(30, 30), Point(-20, -20), action=:stroke)),

:(carc2sagitta(Point(-20, -20), Point(30, 30), 30, :stroke)),
:(carc2sagitta(Point(-20, -20), Point(30, 30), 30, action=:stroke)),
:(circle(O, 30, :stroke)),
:(circle(O, 30, action=:stroke)),
:(circle(20, 10, 30, :stroke)),
:(circle(20, 10, 30, action=:stroke)),
:(circle(O, Point(20, -20), :stroke)),
:(circle(O, Point(20, -20), action=:stroke)),
:(circle(O, Point(20, -20), Point(-10, 30), :stroke)),
:(circle(O, Point(20, -20), Point(-10, 30), action=:stroke)),
:(circlepath(O, 20, :stroke; reversepath=true)),
:(circlepath(O, 20, action=:stroke; reversepath=true)),
:(crescent(Point(10, 10), 18, 25, :stroke; vertices=false, reversepath=true, steps=20)),
:(crescent(Point(10, 10), 18, 25, action=:stroke; vertices=false, reversepath=true, steps=20)),
:(crescent(O, 20, Point(30, 30), 30, :stroke; vertices=false, reversepath=true)),
:(crescent(O, 20, Point(30, 30), 30, action=:stroke; vertices=false, reversepath=true)),

:(ellipse(10, 20, 30, 40, :stroke)),
:(ellipse(10, 20, 30, 40, action=:stroke)),

:(ellipse(O, 40, 50, :stroke)),
:(ellipse(O, 30, 30, action=:stroke)),

:(ellipse(O - (10, 10), O - (10, 10), 50, :stroke; stepvalue=π/30, vertices=false, reversepath=true)),
:(ellipse(O - (10, 10), O - (10, 10), 50, action=:stroke; stepvalue=π/30, vertices=false, reversepath=true)),

:(ellipse(O - (10, 10), O - (10, 10), O, :stroke; stepvalue=π/13, vertices=false, reversepath=true)),
:(ellipse(O - (10, 10), O - (10, 10), O, action=:stroke; stepvalue=π/13, vertices=false, reversepath=true)),

:(epitrochoid(41, 7, 23, :stroke; close=false, stepby=π/60, vertices=false)),
:(epitrochoid(41, 7, 23, action=:stroke; close=false, stepby=π/60, vertices=false)),

:(hypotrochoid(44, 7, 27, :stroke; close=false, stepby=π/39, vertices=false)),
:(hypotrochoid(44, 7, 27, action=:stroke; close=false, stepby=π/39, vertices=false)),

:(line(O, Point(30, -40), :stroke)),
:(line(O, Point(30, -40), action=:stroke)),

:(ngon(20, 10, 20, 5, :stroke)),
:(ngon(20, 10, 20, 5, action=:stroke)),
:(ngon(20, 20, 20, 6, π/3, :stroke)),
:(ngon(20, 20, 20, 6, π/3, action=:stroke)),
:(ngon(O, 23, 7, π/3, :fill, vertices=false, reversepath=true)),
:(ngon(O, 23, 7, π/3, action=:fill, vertices=false, reversepath=true)),

:(ngonside(O, 50, 7, π/3, :stroke)),
:(ngonside(O, 50, 7, π/3, action=:stroke)),
:(ngonside(O, 30, 7, :stroke)),
:(ngonside(O, 30, 7, action=:stroke)),

:(pie(O, 23, 0, π, :fill)),
:(pie(O, 23, 0, π, action=:fill)),
:(pie(20, 10, 50, π/3, 0, :stroke)),
:(pie(20, 10, 50, π/3, 0, action=:stroke)),
:(pie(50, 0, π/2, :stroke)),
:(pie(50, 0, π/2, action=:stroke)),

:(poly(BoundingBox(box(O, 20, 20)), :stroke)),
:(poly(BoundingBox(box(O, 20, 20)), action=:stroke)),

:(poly(ngon(O, 50, 7), :stroke, close=true, reversepath=false)),
:(poly(ngon(O, 50, 7), action=:stroke, close=true, reversepath=false)),

:(polycross(O, 23, 3, 0.7, π/3, :fill, vertices=false, reversepath=true)),
:(polycross(O, 23, 3, 0.7, π/3, action=:fill, vertices=false, reversepath=true)),

:(prettypoly(box(O, 20, 20), close=true, :stroke)),
:(prettypoly(box(O, 20, 20), action=:stroke, close=true)),

:(prettypoly(ngon(O, 30, 5, vertices=true), close=true, :none, () -> (star(O, 16, 7, 0.4, 0.0, action=:stroke)))),
:(prettypoly(ngon(O, 30, 5, vertices=true), close=true, action=:none, () -> (star(O, 16, 7, 0.4, 0.0, action=:stroke)))),

:(prettypoly(BoundingBox() * 0.05, :fill)),
:(prettypoly(BoundingBox() * 0.05, action=:fill)),

:(rect(-20, -30, 15, 29, :stroke)),
:(rect(-20, -30, 15, 29, action=:stroke)),

:(rect(O, 26, 31, :stroke; reversepath=true, vertices=false)),
:(rect(O, 26, 31, action=:stroke; reversepath=true, vertices=false)),

:(sector(O, 28, 45, 0, 3π/2, :stroke)),
:(sector(O, 28, 45, 0, 3π/2, action=:stroke)),

:(sector(18, 40, 0, 3π/2, :stroke)),
:(sector(18, 40, 0, 3π/2, action=:stroke)),

:(sector(O, 18, 45, 0, 3π/2, 10, :stroke)),
:(sector(O, 18, 45, 0, 3π/2, 10, action=:stroke)),

:(sector(18, 25, 0, 3π/2, 10, :stroke)),
:(sector(18, 25, 0, 3π/2, 10, action=:stroke)),

:(spiral(20, -2, :stroke; stepby=π/30, period=12π, vertices=false, log=false)),
:(spiral(20, -2, action=:stroke; stepby=π/30, period=12π, vertices=false, log=false)),

:(squircle(O, 23, 23, :stroke; rt=0.6, vertices=false, stepby=π/30, reversepath=true)),
:(squircle(O, 23, 23, action=:stroke; rt=0.6, vertices=false, stepby=π/30, reversepath=true)),

:(star(20, 10, 23, 6, 0.5, 0.0, :fill; vertices=false, reversepath=true)),
:(star(20, 10, 23, 6, 0.5, 0.0, action=:fill; vertices=false, reversepath=true)),

:(star(O, 33, 7, 0.3, π, :stroke; vertices=false, reversepath=true)),
:(star(O, 33, 7, 0.3, π, action=:stroke; vertices=false, reversepath=true)),

:(textoutlines("text", Point(0, 0), action=:path; halign=:left, valign=:middle, startnewpath=true); fillpath()),
:(textoutlines("text", Point(0, 0), :stroke, halign=:left, valign=:middle, startnewpath=true)),
]

fname = "action-dispatch-tests.png"
Drawing(2000, 2000, fname)
origin()
background("black")
fontsize(10)
tiles = Tiler(2000, 2000, 12, 12)
for (pos, n) in tiles
    @layer begin
        translate(pos)
        if n <= length(expressions)
            textwrap(string(expressions[n]), tiles.tilewidth * 0.7, O - (tiles.tilewidth/2, tiles.tileheight/2), leading=10)
            sethue("gold")
            eval(expressions[n])
        end
    end
end

@test finish() == true
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

# testing isinside(), is point inside polygon
# all the random points are drawn only if they're inside one of the polygons

using Luxor

using Test

using Random
Random.seed!(42)

function ngon_poly(x, y, radius, sides::Int, orientation = 0, action = :none; close = true)
    [Point(x + cos(orientation + n * 2pi / sides) * radius,
        y + sin(orientation + n * 2pi / sides) * radius) for n in 1:sides]
end

function bounding_b(x, y, o)
    return [Point(x - o, y - o), Point(x - o, y + o), Point(x + o, y + o), Point(x + o, y - o)]
end

function point_inside_polygon(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("grey20")
    polys = [ngon_poly(x, y, 60, 5, pi / 2) for x in -500:150:500, y in -500:150:500]
    for pol in polys
        randomhue()
        poly(pol, :fill)
    end
    # test whether random points are inside any of the polygons
    for i in 1:50
        pt = randompoint(-600, -600, 600, 600)
        for pol in polys
            randomsize = rand(4:12)
            bp = bounding_b(pt.x, pt.y, randomsize)
            # check that all four corners of a 5x5 bounding box are inside this polygon
            if isinside(bp[1], pol) && isinside(bp[2], pol) && isinside(bp[3], pol) && isinside(bp[4], pol)
                randomhue()
                circle(pt.x, pt.y, randomsize, :fill)
            end
        end
    end

    @test finish() == true
    println("...finished test: output in $(fname)")
end

point_inside_polygon("point-inside-polygon.png")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function subpath_clipping(fname)
    width, height = 1000, 1000
    Drawing(width, height, fname)
    origin()
    background("ivory")
    sethue("black")
    image = readpng(dirname(@__FILE__) * "/stackoverflow.png")
    w = image.width
    h = image.height
    # all these graphics will make up the clipping mask:
    # reversepath makes holes in the path
    b = false
    for i in 3:15
        randomhue()
        poly(ngon(0, 0, 50 + (i * 30), i, pi/2, vertices=true), :path, reversepath=b)
        if i < 15
            newsubpath()
        end
        b  = !b
    end
    # clip them
    clippreserve()
    # draw image 'through' clipping mask
    scale(40, 40)
    placeimage(image, Point(-w/2, -h/2), 1)
    clipreset()
    @test finish() == true
end

fname = "subpath-clip-image.pdf"
subpath_clipping(fname)
println("...finished test: output in $(fname)")

using Luxor
using Test
using Random
Random.seed!(42)

# from PolygonAlgorithms README
function quicktest()
    pgon = [
        Point(0.4, 0.5), Point(0.7, 2.0), Point(5.3, 1.4), Point(4.0, -0.6),
    ]
    @test polyarea(pgon) ≈ 7.855
    @test isinside(Point(2.0, 0.5), pgon) == true
    @test isinside(Point(10.0, 10.0), pgon) == false

    pgon2 = [
        Point(3.0, 3.0), Point(4.0, 1.0), Point(3.0, 0.5), Point(2.0, -0.5), Point(1.5, 0.9),
    ]
    intersection = polyintersect(pgon, pgon2)
    @test intersection[1][3] ≈ Point(1.5, 0.9)

    return @drawsvg begin
        sethue("white")
        scale(50)
        poly(pgon, :stroke, close = true)
        poly(pgon2, :stroke, close = true)
        sethue("grey30")
        poly.(intersection, :fill)
    end
end

function polyboolean(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("grey20")

    square = ngon(O, 100, 4, π / 4, vertices = true)
    diamond = ngon(O, 100, 4, 0, vertices = true)

    union_sd = polyunion(square, diamond)
    union_ss = polyunion(square, square)
    union_dd = polyunion(diamond, diamond)
    diff_sd = polydifference(square, diamond)
    diff_ds = polydifference(diamond, square)
    diff_ss = polydifference(square, square)
    diff_dd = polydifference(diamond, diamond)
    inter_sd = polyintersect(square, diamond)
    inter_ss = polyintersect(square, square)
    xor_sd = polyxor(square, diamond)
    xor_ss = polyxor(square, square)
    xor_ds = polyxor(diamond, square)

    # bools
    bools = [:union_sd, :union_ss, :union_dd, :diff_sd, :diff_ds, :diff_ss, :diff_dd, :inter_sd, :inter_ss, :xor_sd, :xor_ss, :xor_ds]

    # the corresponding n of polygons in each result
    lengths = [1, 1, 1, 4, 4, 0, 0, 1, 1, 6, 0, 6]

    areas = [
        23431.4,
        20000.0,
        20000.0,
        857.8,
        857.8,
        857.8,
        857.8,
        857.8,
        857.8,
        857.8,
        857.8,
        16568.5,
        20000.0,
        1715.7,
        857.8,
        857.8,
        857.8,
        857.8,
        1715.7,
        1715.7,
        857.8,
        857.8,
        857.8,
        857.8,
        1715.7,
    ]

    tbl = Table(4, 4, 260, 260)
    cell = 1
    polycounter = 1
    fontsize(20)
    for (n, ptest) in enumerate([union_sd, union_ss, union_dd, diff_sd, diff_ds, diff_ss, diff_dd, inter_sd, inter_ss, xor_sd, xor_ss, xor_ds])
        @layer begin
            @test length(ptest) == lengths[n]
            translate(tbl[cell])
            for p in ptest
                pc = polycentroid(p)
                @test isapprox(polyarea(p), areas[polycounter], atol = 1)
                randomhue()
                prettypoly(p, :fill, close = true)
                polycounter += 1
            end
            sethue("white")
            text(string(bools[n], " ", length(ptest)), halign = :center)
            cell += 1
        end
    end
    @test finish() == true
    return println("...finished test: output in $(fname)")
end
quicktest()
polyboolean("poly-boolean-tests.png")

using Luxor, Test

f1 = "tidy_svg_testing_1.svg"
@svg begin
    fontsize(100)
    text("hello")
    text("world", O + (0, 100))
end 500 500 f1

f2 = "tidy_svg_testing_2.svg"
@svg begin
    fontsize(100)
    text("hello")
    text("world", O + (0, 100))
end 500 500 f2

tidysvg(f1, "tidy_svg_testing_3.svg")

tidysvg(f2, "tidy_svg_testing_4.svg")

lines_1 = open("tidy_svg_testing_1.svg") do f
    readlines(f)
end

lines_2 = open("tidy_svg_testing_2.svg") do f
    readlines(f)
end

lines_3 = open("tidy_svg_testing_3.svg") do f
    readlines(f)
end

lines_4 = open("tidy_svg_testing_4.svg") do f
    readlines(f)
end

# without running tidysvg(), symbols are the same
for i in eachindex(lines_1)
    if occursin("<symbol", lines_1[i])
        @test lines_1[i] == lines_2[i]
    end
end

# after running tidysvg(), symbols should be different
for i in eachindex(lines_3)
    if occursin("<symbol", lines_3[i])
        @test lines_3[i] != lines_4[i]
    end
end

println("...finished tidysvg testing")

#!/usr/bin/env julia

using Luxor, Test, Random

Random.seed!(42)

function test_styles(fname)
    pagewidth, pageheight = 1200, 1400
    Drawing(pagewidth, pageheight, fname)
    background("antiquewhite")
    ds = Style()
    dark = Style(colorant"orange")
    jm = Style(colorant"green", "JuliaMono-Black", 20)
    applystyle(ds)
    box(O, 140, 140, :fill)
    applystyle(dark)
    box(O, 40, 240, :fill)
    text("hello world")
    applystyle(jm)
    text("hello world again", O + (20, 30))
    @test finish() == true
    println("...finished styles test, saved in $(fname)")
end
fname = "styles-test.png"
test_styles(fname)

using Luxor
using BenchmarkTools

function bm_text()
    Drawing(1000, 1000, :png)
    origin()
    t = Tiler(1000, 1000, 30, 30, margin=10)
    for (pos, n) in t
        text(string(n), pos, halign=:center)
    end
    finish()
end

function bm_graphics()
    Drawing(1000, 1000, :png)
    origin()
    t = Tiler(1000, 1000, 30, 30, margin=10)
    for (pos, n) in t
        @layer begin
            setcolor("red")
            setopacity(0.3)
            box(pos, t.tilewidth/2, t.tilewidth/2, :fill)
            circle(pos, t.tilewidth / 2, :stroke)
        end 
    end
    finish()
end

function bm_text_outlines()
    Drawing(1000, 1000, :png)
    background("white")
    origin()
    fontsize(30)
    t = Tiler(1000, 1000, 10, 10, margin=10)
    for (pos, n) in t
        textoutlines(string(n), pos, halign=:center, action=:path, startnewpath=false)
    end    
    sethue("black")
    strokepath()
    finish()
end

#!/usr/bin/env julia -

using Luxor

using Test

using Random
Random.seed!(42)

function star_test(fname)
    Drawing(1600, 1600, fname)
    origin()
    background("white")
    setopacity(0.5)
    sethue("grey40")
    fontsize(4)
    setline(0.5)
    tiles = Tiler(1600, 1600, 10, 10, margin=50)
    for (pos, n) in tiles
           randomsides = rand(3:8)
           randomratio = rand(2:8)/10
           randomsmoothing = rand(5:20)
           p = star(pos, tiles.tilewidth/2 - 10, randomsides, randomratio, 0, vertices=true)
           prettypoly(p, close=true, :stroke)
           polysmooth(p, randomsmoothing, :fill, debug=true)
           polysmooth(p, randomsmoothing, :fill, debug=true, close=false)
     end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

function random_test(fname)
    Drawing(1600, 1600, fname)
    origin()
    background("white")
    setopacity(0.5)
    sethue("black")
    fontsize(4)
    setline(0.25)
    tiles = Tiler(1600, 1600, 5, 5, margin=50)
    for (pos, n) in tiles
       randomsides = rand(3:8)
       randomratio = 0.5 * rand()
       randomsmoothradius = rand(5:20)
       p = randompointarray(pos.x - tiles.tilewidth/2 - 10, pos.y - tiles.tilewidth/2, pos.x + tiles.tilewidth/2, pos.y + tiles.tilewidth/2, 10)
       p = polysortbydistance(p, pos)
       p = simplify(p, 5)
       sethue("red")
       prettypoly(p, close=true, :stroke)
       randomhue()
       polysmooth(p, randomsmoothradius, :fill, debug=true)
       sethue("red")
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

star_test("polysmooth-stars.pdf")
random_test("polysmooth-random.pdf")

using Luxor, Test, Colors

#function convertmatrixtocolors(m)
#    return @. convert(Colors.RGBA{Float64}, m)
#end

function imagematrix2()

    img = zeros(ARGB32, 10, 2)
    Drawing(img)
    origin()
    finish()
    @test img == permutedims(image_as_matrix())

    img = zeros(ARGB32, 2, 2)
    Drawing(img)

    # get image as matrix
    mat = convertmatrixtocolors(image_as_matrix())
    @test mat[1] == RGBA{Float64}(0.0, 0.0, 0.0, 0.0)
    @test mat[1] == mat[2] == mat[3] == mat[4]
    @test img[1] == RGBA{Float64}(0.0, 0.0, 0.0, 0.0)
    @test img[1] == img[2] == img[3] == img[4]

    # make it red, then get image as matrix again
    setcolor("red")
    paint()
    mat = image_as_matrix()

    @test mat[1] == RGBA{Float64}(1.0, 0.0, 0.0, 1.0)
    @test mat[1] == mat[2] == mat[3] == mat[4]
    @test img[1] == RGBA{Float64}(1.0, 0.0, 0.0, 1.0)
    @test img[1] == img[2] == img[3] == img[4]

    # make it green, then get image as matrix again
    setcolor(0, 1, 0)
    paint()

    mat = image_as_matrix()
    @test mat[1] == RGBA{Float64}(0.0, 1.0, 0.0, 1.0)
    @test mat[1] == mat[2] == mat[3] == mat[4]
    @test img[1] == RGBA{Float64}(0.0, 1.0, 0.0, 1.0)
    @test img[1] == img[2] == img[3] == img[4]

    finish()

    # test alpha
    img = zeros(ARGB32, 2, 2)
    Drawing(img)

    setcolor(0, 0, 0, .5)
    paint()
    mat = image_as_matrix()

    @test red(img[1]) == 0.0
    @test red(mat[1]) == 0.0
    @test isapprox(alpha(img[1]), 0.5, atol=0.1)
    @test isapprox(alpha(mat[1]), 0.5, atol=0.1)

    @test finish() == true

    # make 20 by 20 (400) grid
    img = zeros(ARGB32, 5, 5)
    Drawing(img)

    Luxor.origin()
    tiles = Tiler(5, 5, 5, 5, margin=0)
    background("white")
    sethue("blue")
    # fill odd ones with blue
    for (pos, n) in tiles
        isodd(n) && box(pos, 1, 1, :fill)
    end
    mat = convertmatrixtocolors(image_as_matrix())

    # first square is blue
    @test blue(img[1]) == 1.0
    @test blue(mat[1]) == 1.0

    # second square is white
    @test red(img[2]) == blue(img[2]) == green(img[2])
    @test red(mat[2]) == blue(mat[2]) == green(mat[2])

    # third square is blue
    @test blue(img[2]) == 1.0
    @test blue(mat[2]) == 1.0

    @test finish() == true

    # test placeimage
    K = 100
    m1 = @imagematrix begin
        juliacircles(20)
    end K 100

    img = zeros(ARGB32, 100, 100)
    Drawing(img)
    Luxor.origin()
    rotate(π/2)
    placeimage(m1, centered=true)
    placeimage(Gray.(m1))
    @test finish() == true

    m1 = Drawing(40,40, :svg)
    origin()
    sethue("black")
    background(0,1,1,0)
    juliacircles(10)
    finish()

    img = zeros(ARGB32, 100, 100)
    Drawing(img)
    Luxor.origin()
    placeimage(m1, centered=true)
    @test finish() == true
    
    K = 100
    m2 = @imagematrix begin
        juliacircles(20)
    end K 100

    img = zeros(ARGB32, 100, 100)
    Drawing(img)
    Luxor.origin()
    placeimage(m2, alpha=1, centered=true)
    @test finish() == true
end

imagematrix2()

println("...finished imagematrix2 test")

#!/usr/bin/env julia

using Luxor

CAIRO_PATH_MOVE_TO = 0
CAIRO_PATH_LINE_TO = 1
CAIRO_PATH_CURVE_TO = 2
CAIRO_PATH_CLOSE_PATH = 3

using Test

using Random
Random.seed!(42)

function get_path(str)
    sethue("blue")
    setopacity(.7)
    setline(0.5)
    p = textpath(str)
    o = getpath()
    strokepath()
    sethue("red")
    x, y = 0, 0
    for e in o
        if e.element_type == CAIRO_PATH_MOVE_TO
            (x, y) = e.points
            move(x, y)
        elseif e.element_type == CAIRO_PATH_LINE_TO
            (x, y) = e.points
            # straight lines
            line(x, y)
            strokepath()
            circle(x, y, 1, :stroke)
        elseif e.element_type == CAIRO_PATH_CURVE_TO
            (x1, y1, x2, y2, x3, y3) = e.points
            # show bezier control lines
            circle(x1, y1, 1, :stroke)
            circle(x2, y2, 1, :stroke)
            circle(x3, y3, 1, :stroke)
            move(x, y)
            # Use point interface, to make sure that is also tested
            curve(Point(x1, y1), Point(x2, y2), Point(x3, y3))
            strokepath()
            (x, y) = (x3, y3) # update current point
        elseif e.element_type == CAIRO_PATH_CLOSE_PATH
            closepath()
        else
            error("unknown CairoPathEntry " * repr(e.element_type))
            error("unknown CairoPathEntry " * repr(e.points))
        end
    end
end

function get_path_test(fname)
    Drawing(500, 500, fname)
    origin()
    @layer begin
        fontsize(24)
        fontface("Times-Italic")
        setline(0.5)
        translate(-100, -100)
        for theta in range(0, length=20, stop=2π)
            @layer begin
                rotate(theta)
                translate(30, 0)
                sethue("red")
                textoutlines("Luxor", O, :fill, halign=:left, valign=:baseline)
                sethue("blue")
                textoutlines("Luxor", O, :stroke, halign=:left, valign=:baseline)
            end
        end
    end
    fontsize(80)
    get_path("Luxor")
    sethue("magenta")
    @test finish() == true
    println("...finished test: output in $(fname)")
end
get_path_test("get-path-test.pdf")

# text

# first, the 'toy' API... "Any serious application should avoid them." :)

"""
    text(str)
    text(str, pos)
    text(str, pos, angle = pi/2)
    text(str, x, y)
    text(str, pos, halign = :left)
    text(str, valign = :baseline)
    text(str, valign = :baseline, halign = :left)
    text(str, pos, valign = :baseline, halign = :left)
    text(latexstr, pos, valign = :baseline, halign = :left, rotationfixed = false, angle = 0)
    text(typststr, pos::Point, place=true, centered=false, preamble=typststr)

Draw the text in the string `str` at `x`/`y` or `pt`, placing the start of the
string at the point. If you omit the point, it's placed at the current `0/0`.

`angle` specifies the rotation of the text relative to the current x-axis.

Horizontal alignment `halign` can be `:left`, `:center`, (also `:centre`) or
`:right`.  Vertical alignment `valign` can be `:baseline`, `:top`, `:middle`, or
`:bottom`.

The default alignment is `:left`, `:baseline`.

This function uses Cairo's Toy text API.

Other text functions:

`textextents()` - find the dimensions of some text in the current font

`settext()` - like `text()` but using the Pro Api

`setfont()` - like `fontface()` but using the Pro Api

`label()` - draw text relative to a point with offset and leader lines

`textbox()` - draw an array of strings vertically downwards

`textcurve()` - draw text on a circular arc

`textfit()` - fit text into a BoundingBox by resizing it

`textlines()` - splits text into an array of strings so as to fit width

`textonpoly()` - draw text that sits on the edges of a polygon

`textpath()` - convert text to paths (straight lines and Bezier segments)

`textoutlines()` - Convert text to polygons (straight lines of varying lengths)

`textplace()` - draw text character by character with font/size/position specs

`texttrack()` - draw text tracked (tight or loose)

`textwrap()` - draw text to fit a box after re-justifying the lines to fit nicely
"""
function text(t::T where {T<:AbstractString}, pt::Point;
    halign=:left,
    valign=:baseline,
    angle=0.0)
    #= text can aligned by one of the following points
        top/left       top/center       top/right
        middle/left    middle/center    middle/right
        baseline/left  baseline/center  baseline/right
        bottom/left    bottom/center    bottom/right

    # left center right x coords are
    # [:xbearing, :width-:xbearing/2, :width]
    # top middle baseline bottom y coords are
    # [:ybearing, :ybearing/2, 0, :height + :ybearing]
    =#

    xbearing, ybearing, textwidth, textheight, xadvance, yadvance = textextents(t)
    halignment = findfirst(isequal(halign), [:left, :center, :right, :centre])

    # if unspecified or wrong, default to left, also treat UK spelling centre as center
    if halignment == nothing
        halignment = 1
    elseif halignment == 4
        halignment = 2
    end

    # was textpointx = pt.x - [0, textwidth/2, textwidth][halignment]
    textpointx = pt.x - [0, xadvance / 2, textwidth + xbearing][halignment]

    valignment = findfirst(isequal(valign), [:top, :middle, :baseline, :bottom])

    # if unspecified or wrong, default to baseline
    if valignment == nothing
        valignment = 3
    end

    textpointy = pt.y - [ybearing, ybearing / 2, 0, textheight + ybearing][valignment]

    # need to adjust for any rotation now
    # rotate around original point
    finalpt = rotatepoint(Point(textpointx, textpointy), pt, angle)

    gsave()
    translate(finalpt)
    rotate(angle)
    newpath()
    Cairo.show_text(_get_current_cr(), t)
    grestore()

    return Point(textpointx, textpointy)
end

text(t::String; kwargs...) = text(t, O; kwargs...)
text(t::String, xpos, ypos; kwargs...) = text(t, Point(xpos, ypos); kwargs...)

# deprecated probably
textcentered(t::String, x=0, y=0) = text(t, x, y, halign=:center)
textcentered(t::String, pt::Point) = textcentered(t, pt.x, pt.y)
textcentred = textcentered
textright(t::String, x=0, y=0) = text(t, x, y, halign=:right)
textright(t::String, pt::Point) = textright(t, pt.x, pt.y)

"""
    fontface(fontname)

Select a font to use. (Toy API)
"""
fontface(f) =
    Cairo.select_font_face(_get_current_cr(), f,
        Cairo.FONT_SLANT_NORMAL,
        Cairo.FONT_WEIGHT_NORMAL)

"""
    fontsize(n)

Set the font size to `n` units. The default size is 10 units. (Toy API)
"""
fontsize(n) = Cairo.set_font_size(_get_current_cr(), n)


"""
    get_fontsize()

Return the font size set by `fontsize` or. more precisely. the y-scale of the Cairo font matrix
if `Cairo.set_font_matrix` is used directly. (Toy API)

!!! note

    This only works if Cairo is at least at v1.0.5.
"""
function get_fontsize()
    if @isdefined get_font_matrix
        m = get_font_matrix(_get_current_cr())
        font_size = sign(m.yy) * sqrt(m.yx^2 + m.yy^2)
        return font_size
    else
        throw(ErrorException("Please use Cairo v1.0.5 or later to use this feature."))
    end
end

"""
    textextents(str)

Return an array of six Float64s containing the measurements of the string `str`
when set using the current font settings (Toy API):

1. x_bearing

2. y_bearing

3. width

4. height

5. x_advance

6. y_advance

The x and y bearings are the displacement from the reference point to the
upper-left corner of the bounding box. It is often zero or a small positive
value for x displacement, but can be negative x for characters like "j"; it's
almost always a negative value for y displacement.

The width and height then describe the size of the bounding box. The advance
takes you to the suggested reference point for the next letter. Note that
bounding boxes for subsequent blocks of text can overlap if the bearing is
negative, or the advance is smaller than the width would suggest.

Example:

    textextents("R")

returns

    [1.18652; -9.68335; 8.04199; 9.68335; 9.74927; 0.0]
"""
textextents(str::T where {T<:AbstractString}) = Cairo.text_extents(_get_current_cr(), str)

"""
    textpath(t)

Convert the text in string `t` to paths, adding them to the current path, for subsequent filling/stroking etc...

You can use `pathtopoly()` or `getpath()` or `getpathflat()` to convert the paths to polygons.

See also `textoutlines()`. `textpath()` retains Bezier curves, whereas `textoutlines()` returns flattened curves.
"""
function textpath(t::T where {T<:AbstractString})
    Cairo.text_path(_get_current_cr(), t)
end
"""
    textpath(s::String, pos::Point;
        action=:none,
        halign=:left,
        valign=:baseline,
        startnewpath=true)

Convert the text in string `s` to paths and apply the action. (ToyAPI)

TODO Return something more useful than a Boolean.
"""
function textpath(s::T where {T<:AbstractString}, pos::Point;
    action=:none,
    halign=:left,
    valign=:baseline,
    startnewpath=true)

    # TODO this duplicates text() too much; re-factor needed
    xbearing, ybearing, textwidth, textheight, xadvance, yadvance = textextents(s)
    halignment = findfirst(isequal(halign), [:left, :center, :right, :centre])
    if halignment == nothing
        halignment = 1
    elseif halignment == 4
        halignment = 2
    end
    textpointx = pos.x - [0, xadvance / 2, textwidth + xbearing][halignment]
    valignment = findfirst(isequal(valign), [:top, :middle, :baseline, :bottom])
    if valignment == nothing
        valignment = 3
    end
    textpointy = pos.y - [ybearing, ybearing / 2, 0, textheight + ybearing][valignment]
    @layer begin
        translate(Point(textpointx, textpointy))
        move(O)
        if startnewpath
            newpath() # forget any current path, start a new one
        end
        textpath(s)
    end
    do_action(action)
end

textpath(s::T where {T<:AbstractString}, pos::Point, action::Symbol;
    halign=:left,
    valign=:baseline,
    startnewpath=true) = textpath(s, pos, action=action, halign=halign, valign=valign, startnewpath=startnewpath)

"""
    textoutlines(s::String, pos::Point=O;
        action=:none,
        halign=:left,
        valign=:baseline,
        startnewpath=true)

Convert text to polygons and apply `action`. (ToyAPI)

By default this function discards any current path, unless you use `startnewpath=false`

See also `textpath()`. `textpath()` retains Bezier curves, whereas `textoutlines()` returns flattened curves.

TODO Return something more useful than a Boolean.
"""
function textoutlines(s::T where {T<:AbstractString}, pos::Point;
    action=:none,
    halign=:left,
    valign=:baseline,
    startnewpath=true)

    # TODO this duplicates text() too much; re-factor needed
    xbearing, ybearing, textwidth, textheight, xadvance, yadvance = textextents(s)
    halignment = findfirst(isequal(halign), [:left, :center, :right, :centre])
    if halignment == nothing
        halignment = 1
    elseif halignment == 4
        halignment = 2
    end
    textpointx = pos.x - [0, xadvance / 2, textwidth + xbearing][halignment]
    valignment = findfirst(isequal(valign), [:top, :middle, :baseline, :bottom])
    if valignment == nothing
        valignment = 3
    end
    textpointy = pos.y - [ybearing, ybearing / 2, 0, textheight + ybearing][valignment]
    @layer begin
        translate(Point(textpointx, textpointy))
        if startnewpath
            newpath() # forget any current path, start a new one
        end
        te = textextents(s)
        textpath(s)
        tp = pathtopoly()
        if length(tp) == 1
            poly.(tp, :path, close=true) # don't clip yet
        else
            newpath()
            for path in tp
                poly(path, :path, close=true)
                newsubpath()
            end
            closepath()
        end
    end
    do_action(action)
end

textoutlines(s::T where {T<:AbstractString}, pos::Point, action::Symbol;
    halign=:left,
    valign=:baseline,
    startnewpath=true) = textoutlines(s, pos;
    action=action,
    halign=halign,
    valign=valign,
    startnewpath=startnewpath)

textoutlines(s::T where {T<:AbstractString}; kwargs...) = textoutlines(s, O, kwargs...)

"""
    textcurve(the_text, start_angle, start_radius, pos;
          # optional keyword arguments:
          spiral_ring_step = 0,    # step out or in by this amount
          letter_spacing = 0,      # tracking/space between chars, tighter is (-), looser is (+)
          spiral_in_out_shift = 0, # + values go outwards, - values spiral inwards
          clockwise = true
          )

Place a string of text on a curve. It can spiral in or out.

`start_angle` is relative to +ve x-axis, arc/circle is centered on `pos` with
radius `start_radius`.
"""
function textcurve(the_text::T where {T<:AbstractString}, start_angle, start_radius, pos=O;
    spiral_ring_step=0,
    letter_spacing=0,
    spiral_in_out_shift=0,
    clockwise=true
)
    # TODO this is all very hacky and out of date...
    refangle = start_angle
    current_radius = start_radius
    spiral_space_step = 0
    xx = 0
    yy = 0
    angle_step = 0
    radius_step = 0
    for i in the_text
        glyph = string(i)
        glyph_x_bearing, glyph_y_bearing, glyph_width,
        glyph_height, glyph_x_advance, glyph_y_advance = textextents(glyph)
        spiral_space_step = glyph_x_advance + letter_spacing
        cnter = (2pi * current_radius) / spiral_space_step
        radius_step = (spiral_ring_step + spiral_in_out_shift) / cnter
        current_radius += radius_step
        angle_step += (glyph_x_advance / 2.0) + letter_spacing / 2.0
        if clockwise
            refangle += angle_step / current_radius
        else
            refangle -= angle_step / current_radius
        end
        angle_step = (glyph_x_advance / 2.0) + letter_spacing / 2.0
        xx = cos(refangle) * current_radius + pos.x
        yy = sin(refangle) * current_radius + pos.y
        gsave()
        translate(xx, yy)
        if clockwise
            rotate(pi / 2 + refangle)
        else
            rotate(-pi / 2 + refangle)
        end
        text(glyph, O, halign=:center)
        grestore()
        current_radius < 10 && break
    end
end

textcurve(the_text::String, start_angle, start_radius, centerx, centery; kwargs...) =
    textcurve(the_text, start_angle, start_radius, Point(centerx, centery); kwargs...)

"""
    textcurvecentered(the_text, the_angle, the_radius, center::Point;
          clockwise = true,
          letter_spacing = 0,
          baselineshift = 0

This version of the `textcurve()` function is designed for shorter text strings
that need positioning around a circle. (A cheesy effect much beloved of hipster
brands and retronauts.)

`letter_spacing` adjusts the tracking/space between chars, tighter is (-),
looser is (+)). `baselineshift` moves the text up or down away from the
baseline.

`textcurvecentred` (UK spelling) is a synonym.
"""
function textcurvecentered(the_text::T where {T<:AbstractString}, the_angle, the_radius, center::Point;
    clockwise=true,
    letter_spacing=0,
    baselineshift=0
)
    atextbox = textextents(the_text)
    atextwidth = atextbox[3]                         # width of text
    if clockwise
        baselineradius = the_radius + baselineshift  # could be adjusted if we knew font height
    else
        baselineradius = the_radius - baselineshift  # could be adjusted if we knew font height
    end

    # TODO
    # hack to adjust starting angle for the letter spacing
    # to do it accurately would take lots more code and brain cells
    lspaced = length(the_text) * letter_spacing
    lspacedangle = atan(lspaced, baselineradius)

    theta = atextwidth / baselineradius               # find angle
    if clockwise
        starttextangle = the_angle - (theta / 2) - lspacedangle / 2
    else
        starttextangle = the_angle + (theta / 2) + lspacedangle / 2
    end
    starttextxpos = baselineradius * cos(starttextangle)
    starttextypos = baselineradius * sin(starttextangle)
    textcurve(the_text, starttextangle, baselineradius, center,
        clockwise=clockwise, letter_spacing=letter_spacing)
end

textcurvecentred = textcurvecentered

# the professional interface

"""
    setfont(family, fontsize)

Select a font and specify the size. (ProAPI)

Example:
```julia
setfont("Helvetica", 24)
settext("Hello in Helvetica 24 using the Pro API", Point(0, 10))
```
"""
function setfont(family::T where {T<:AbstractString}, fontsize)
    # output is set relative to 96dpi
    # so it needs to be rescaled
    fsize = fontsize * 72 / 96
    set_font_face(_get_current_cr(), string(family, " ", fsize))
end

"""
    settext(text, pos;
        halign = "left",
        valign = "bottom",
        angle  = 0, # degrees!
        markup = false)

    settext(text;
        kwargs)

Draw the `text` at `pos` (if omitted defaults to `0/0`). If no font is
specified, on macOS the default font is Times Roman.

To align the text, use `halign`, one of "left", "center", or "right", and
`valign`, one of "top", "center", or "bottom".

`angle` is the rotation - in counterclockwise degrees, rather than Luxor's
default clockwise (+x-axis to +y-axis) radians.

If `markup` is `true`, then the string can contain some HTML-style markup.
Supported tags include:

`<b>`, `<i>`, `<s>`, `<sub>`, `<sup>`, `<small>`, `<big>`, `<u>`, `<tt>`, and `<span>`

The `<span>` tag can contains things like this:

    <span font='26' background='green' foreground='red'>unreadable text</span>
"""
settext(text::T where {T<:AbstractString}, pos::Point; kwargs...) =
    Cairo.text(_get_current_cr(), pos.x, pos.y, text; kwargs...)

settext(text::T where {T<:AbstractString}; kwargs...) = settext(text, O; kwargs...)

"""
    label(txt::T where T <: AbstractString, alignment::Symbol=:N, pos::Point=O;
        offset=5,
        leader=false,
        leaderoffsets=[0.0, 1.0])

Add a text label at a point, positioned relative to that point, for example, `:N` signifies
North and places the text directly above that point.

Use one of `:N`, `:S`, `:E`, `:W`, `:NE`, `:SE`, `:SW`, `:NW` to position the label
relative to that point.

```julia
label("text")          # positions text at North (above), relative to the origin
label("text", :S)      # positions text at South (below), relative to the origin
label("text", :S, pt)  # positions text South of pt
label("text", :N, pt, offset=20)  # positions text North of pt, offset by 20
```

The default offset is 5 units.

If `leader` is true, draw a line as well.

`leaderoffsts` uses normalized fractions (see `between()`)
to specify the gap between the designated points and the
start and end of the lines.

TODO: Negative offsets don't give good results.
"""
function label(txt::T where {T<:AbstractString}, alignment::Symbol=:N, pos::Point=O;
    offset=5,
    leader=false,
    leaderoffsets=[0.0, 1.0])
    # alignment one of :N, :S, :E, ;W, ;NE; :SE, :SW, :NW
    if in(alignment, [:N, :n])
        pt = Point(pos.x, pos.y - offset)
        text(txt, pt, halign=:center, valign=:bottom)
    elseif in(alignment, [:E, :e])
        pt = Point(pos.x + offset, pos.y)
        text(txt, pt, halign=:left, valign=:middle)
    elseif in(alignment, [:S, :s])
        pt = Point(pos.x, pos.y + offset)
        text(txt, pt, halign=:center, valign=:top)
    elseif in(alignment, [:W, :w])
        pt = Point(pos.x - offset, pos.y)
        text(txt, pt, halign=:right, valign=:middle)
    elseif in(alignment, [:NE, :ne])
        pt = Point(pos.x + (offset * cos(pi / 4)), pos.y - (offset * sin(pi / 4)))
        text(txt, pt, halign=:left, valign=:bottom)
    elseif in(alignment, [:SE, :se])
        pt = Point(pos.x + (offset * cos(pi / 4)), pos.y + (offset * sin(pi / 4)))
        text(txt, pt, halign=:left, valign=:top)
    elseif in(alignment, [:SW, :sw])
        pt = Point(pos.x - (offset * cos(pi / 4)), pos.y + (offset * sin(pi / 4)))
        text(txt, pt, halign=:right, valign=:top)
    elseif in(alignment, [:NW, :nw])
        pt = Point(pos.x - (offset * cos(pi / 4)), pos.y - (offset * sin(pi / 4)))
        text(txt, pt, halign=:right, valign=:bottom)
    end
    if leader
        line(between(pos, pt, leaderoffsets[1]), between(pos, pt, leaderoffsets[2]), :stroke)
    end
end

"""
    label(txt::T where T <: AbstractString, direction::Float64, pos::Point=O;
        offset=5,
        leader=false,
        leaderoffsets=[0.0, 1.0])

Add a text label at a point, positioned relative to that point, for example,
`0.0` is East, `pi` is West.

```julia
label("text", pi)          # positions text to the left of the origin
```
"""
function label(txt::T where {T<:AbstractString}, direction::Real, pos::Point=O;
    offset=5,
    leader=false,
    leaderoffsets=[0.0, 1.0])
    if 0 < direction <= pi / 4
        vertalign = :middle
        horizalign = :left
    elseif pi / 4 < direction <= 3pi / 4
        vertalign = :top
        horizalign = :center
    elseif 3pi / 4 < direction <= 5pi / 4
        vertalign = :middle
        horizalign = :right
    elseif 5pi / 4 < direction <= 7pi / 4
        vertalign = :bottom
        horizalign = :center
    else
        vertalign = :middle
        horizalign = :left
    end
    pt = pos + polar(offset, direction)
    if leader
        line(between(pos, pt, leaderoffsets[1]), between(pos, pt, leaderoffsets[2]), :stroke)
    end
    text(txt, pt, halign=horizalign, valign=vertalign)
end

"""
    splittext(s)

Split the text in string `s` into an array, but keep all the separators
attached to the preceding word.
"""
function splittext(s::T where {T<:AbstractString})
    # split text into array, keeping all separators
    # hyphens stay with first word
    result = Vector{String}()
    iobuffer = IOBuffer()
    for c in s
        if isspace(c)
            push!(result, String(take!(iobuffer)))
            iobuffer = IOBuffer()
        elseif c == '-' # hyphen splits words but needs keeping
            print(iobuffer, c)
            push!(result, String(take!(iobuffer)))
            iobuffer = IOBuffer()
        else
            print(iobuffer, c)
        end
    end
    push!(result, String(take!(iobuffer)))
    return result
end

"""
    textlines(s::T where T <: AbstractString, width::Real;
         rightgutter=5)

Split the text in `s` into lines up to `width` units wide (in the current font).

Returns an array of strings. Use `textwrap` to draw an array of strings.

TODO: A `rightgutter` optional keyword adds some padding to the right hand side
of the column. This appears to be needed sometimes -— perhaps the algorithm
needs improving to take account of the interaction of `textextents` and spaces?
"""
function textlines(s::T where {T<:AbstractString}, width::Real; rightgutter=5)
    result = String[]
    fields = splittext(s)
    textwidth = width - rightgutter
    # how to get the width of a space?
    spacewidth = textextents("m m")[3] - textextents("mm")[3]
    spaceleft = textwidth
    currentline = String[]
    for word in fields
        # hyphenation can leave an empty string field
        if word == ""
            word = " "
            push!(currentline, " ")
        end
        wordextents = textextents(word)
        widthofword = wordextents[1] + wordextents[3]
        isapprox(widthofword, 0.0, atol=0.1) && continue
        if (widthofword + spacewidth) > spaceleft
            # start a new line
            push!(result, strip(join(currentline)))
            currentline = []
            spaceleft = textwidth
        end
        if endswith(word, "-")
            push!(currentline, word)
        else
            push!(currentline, word * " ")
        end
        spaceleft -= (wordextents[5] + spacewidth)
    end
    push!(result, strip(join(currentline)))

    # strip trailing spaces
    for i in eachindex(result)
        result[i] = strip(result[i])
    end
    return result
end

"""
    textbox(lines::Array, pos::Point=O;
        leading = 12,
        linefunc::Function = (linenumber, linetext, startpos, height) -> (),
        alignment=:left)

Draw the strings in the array `lines` vertically downwards. `leading` controls
the spacing between each line (default 12), and `alignment` determines the
horizontal alignment (default `:left`).

Optionally, before each line, execute the function
`linefunc(linenumber, linetext, startpos, height)`.

Returns the position of what would have been the next line.

See also `textwrap()`, which modifies the text so that the lines fit into a
specified width.
"""
function textbox(lines::Array, pos::Point=O;
    leading=0,
    linefunc::Function=(linenumber, linetext, startpos, leading) -> (),
    alignment=:left)

    # abandon if empty
    isempty(lines) && return pos
    # find height of first non-empty line
    firstrealline = filter(!isempty, lines)[1]
    te = textextents(firstrealline)
    if leading == 0
        leading = te[4]
    end
    startpos = Point(pos.x, pos.y + leading)
    for (linenumber, linetext) in enumerate(lines)
        linefunc(linenumber, linetext, startpos, leading)
        text(linetext, startpos, halign=alignment)
        startpos = Point(startpos.x, startpos.y + leading)
    end
    return startpos
end

"""
    textbox(s::T where T <: AbstractString, pos::Point=O;
        leading = 12,
        linefunc::Function = (linenumber, linetext, startpos, height) -> (),
        alignment=:left)
"""
textbox(s::T where {T<:AbstractString}, pos::Point=O; kwargs...) = textbox([s], pos; kwargs...)

"""
    textwrap(s::T where T<:AbstractString, width::Real, pos::Point;
        rightgutter=5,
        leading=0)
    textwrap(s::T where T<:AbstractString, width::Real, pos::Point, linefunc::Function;
        rightgutter=5,
        leading=0)

Draw the string in `s` by splitting it at whitespace characters into lines, so that each
line is no longer than `width` units. The text starts at `pos` such that the first line of
text is drawn entirely below a line drawn horizontally through that position. Each line is
aligned on the left side, below `pos`.

See also `textbox()`.

Optionally, before each line, execute the function `linefunc(linenumber, linetext, startpos, leading)`.

If you don't supply a value for `leading`, the font's built-in extents are used.

Text with no whitespace characters won't wrap. You can write a simple chunking function
to split a string or array into chunks:

```julia
chunk(x, n) = [x[i:min(i+n-1,length(x))] for i in 1:n:length(x)]
```

For example:

```julia
textwrap(the_text, 300, boxtopleft(BoundingBox()) + 20,
    (ln, lt, sp, ht) -> begin
        c = count(t -> occursin(r"[[:punct:]]", t), split(lt, ""))
        @layer begin
            fontface("Menlo")
            sethue("darkred")
            text(string("[", c, "]"), sp + (310, 0))
        end
    end)
```

puts a count of the number of punctuation characters in each
line at the end of the line.

Returns the position of what would have been the next line.
"""
function textwrap(s::T where {T<:AbstractString}, width::Real, pos::Point, linefunc::Function;
    rightgutter=5,
    leading=0)
    lines = textlines(s, width; rightgutter=rightgutter)
    textbox(lines, pos, linefunc=linefunc, leading=leading)
end

textwrap(s::T where {T<:AbstractString}, width::Real, pos::Point; kwargs...) =
    textwrap(s, width, pos, (linenumber, linetext, startpos, height) -> ();
        kwargs...)

"""
    texttrack(txt, pos, tracking;
        action=:fill,
        halign=:left,
        valign=:baseline,
        startnewpath=true)
    texttrack(txt, pos, tracking, fontsize;
        action=:fill,
        halign=:left,
        valign=:baseline,
        startnewpath=true)

Place the text in `txt` at `pos`, left-justified, and letter
space ('track') the text using the value in `tracking`.

The tracking units depend on the current font size. In a 12‑point font,
1 em equals 12 points. A point is about 0.35mm, 1em is about 4.2mm, and a
1000 units of tracking are about 4.2mm. So a tracking value of 1000 for a
12 point font places about 4mm between each character.

A negative value tightens the letter spacing noticeably.

The text drawing action applied to each character defaults
to `textoutlines(... :fill)`.

If `startnewpath` is true, each character is acted on separately.
To clip and track text, specify the clip action and avoid resetting
the clipping path for each character.

```julia
newpath()
texttrack(t, O + (0, 80), 200, action=:clip, startnewpath=false)
...
clipreset()
```

TODO Is it possible to fix strings with combining characters such as "\u0308"?
"""
function texttrack(txt::T where {T<:AbstractString}, pos, tracking, fsize;
    action=:fill,
    halign=:left,
    valign=:baseline,
    startnewpath=true)

    advances = []
    emspacewidth = textextents(" ")[5]
    for c in txt
        xbearing, ybearing, textwidth, textheight, xadvance, yadvance = textextents(string(c))
        if c == ' '
            textwidth = emspacewidth
        end
        push!(advances, xadvance)
    end

    # adjust start position for alignment
    # first, horizontal alignment - 1, 2, 3
    halignment = findfirst(isequal(halign), [:left, :center, :right, :centre])

    # if unspecified or wrong, default to left, also treat UK spelling centre as center
    if halignment == nothing
        halignment = 1
    elseif halignment == 4
        halignment = 2
    end

    # calculate width of the final tracked string
    # need this to do alignment
    total_textwidth = sum(advances) + length(advances) * ((tracking / 1000) * fsize)
    textpointx = pos.x - [0, total_textwidth / 2, total_textwidth][halignment]
    # next vertical alignment
    valignment = findfirst(isequal(valign), [:top, :middle, :baseline, :bottom])
    # if unspecified or wrong, default to baseline
    if valignment == nothing
        valignment = 3
    end
    ybearing, textheight = textextents(txt)[[2, 4]]
    textpointy = pos.y - [ybearing, ybearing / 2, 0, textheight + ybearing][valignment]

    # this is the first point of the text string
    newpos = Point(textpointx, textpointy)

    # if clipping, clip the entire path, not individual characters
    if action == :clip
        _action = :path
    else
        _action = action
    end

    # draw the text
    for (n, c) in enumerate(txt)
        textpath(string(c), newpos, _action, halign=:left, startnewpath=startnewpath)
        # calculate new position based on precalculated widths plus the tracking
        newpos = Point(newpos.x + advances[n] + ((tracking / 1000) * fsize), newpos.y)
    end
    if action == :clip
        do_action(:clip)
    end
end

texttrack(txt::T where {T<:AbstractString}, pos, tracking;
    action=:fill,
    halign=:left,
    valign=:baseline,
    startnewpath=true) = texttrack(txt, pos, tracking, get_fontsize();
    action=action,
    halign=halign,
    valign=valign,
    startnewpath=startnewpath)

"""
    textplace(txt::T where T <: AbstractString, pos::Point, params::Vector;
        action = :fill,
        startnewpath = false)

A low-level function that places text characters one by one
according to the parameters in `params`. First character
uses the first tuple, second character uses the second, and
so on.

Returns the next text position.

A tuple of parameters is:

```julia
(face = "TimesRoman", size = 12, color=colorant"black", kern = 0, shift = 0, advance = true)
```

where

- `face` is fontface "string"                   # sticky

- `size` is fontsize # pts                      # sticky

- `color` is color                              # sticky

- `kern` amount (pixels) shifted to the right   # resets after each char

- `shift` = baseline shifted vertically         # resets after each char

- `advance` - whether to advance                # resets after each char

Some parameters are "sticky": once set, they apply for all
subsequent characters until a new value is supplied. Others
aren't sticky, and are reset for each character. So font
face, size, and color parameters need only be specified
once, whereas kern/shift/advance modifiers are reset for each
character.

## Example

Draw the Hogwarts Express Platform number 9 and 3/4:

```julia
txtpos = textplace("93—4!", O - (200, 0), [
    # format for 9:
    (size=120, face="Bodoni-Poster", color=colorant"grey10"),
    # format for 3:
    (size=60,  kern = 5, shift = 60,  advance=false,),
    # format for -:
    (          kern = 0, shift = 25,  advance=false,),
    # format for 4:
    (          kern = 5, shift = -20, advance=true),
    # format for !:
    (size=120, kern = 20,),
    ])
```
"""
function textplace(txt::T where {T<:AbstractString}, pos::Point, params::Vector;
    action=:fill,
    startnewpath=false)
    @layer begin
        textpos = Point(pos.x, pos.y)
        currentparams = (face="", size=12, color=colorant"black", kern=0, shift=0, advance=true,)
        for (n, c) in enumerate(txt)
            currentparams = merge(currentparams, (kern=0, shift=0, advance=true,))
            if n <= length(params)
                currentparams = merge(currentparams, params[n])
            end
            fontface(currentparams.face)
            fontsize(currentparams.size)
            sethue(currentparams.color)
            xbearing, ybearing, textwidth, textheight, xadvance, yadvance = textextents(string(c))
            temp_text_pos = Point(textpos.x + currentparams.kern, textpos.y - currentparams.shift)
            textoutlines(string(c), temp_text_pos, action=action, halign=:left, startnewpath=startnewpath)
            if currentparams.advance == true
                textpos += (xadvance + currentparams.kern, 0)
            end
        end
    end
    return textpos
end

"""
    textfit(str, bbox::BoundingBox, maxfontsize = 800;
         horizontalmargin=12,
         leading=100)

Fit the string `str` into the bounding box `bbox` by adjusting the font
size and line breaks.

Instead of using the current font size, the largest possible
value will be calculated. You can specify a size limit in
`maxfontsize`, such that the text will never be larger than this
value, although it may have to be smaller.

`horizontalmargin` is applied to each side.

Optionally, `leading` can be supplied, and this will be
interpreted as a percentage of the final calculated font
size. The default value is 110 (%).

The function returns a named tuple with information about
the calculated values:

```julia
(fontsize = 37.6, linecount = 5, finalpos = Point(-117.43, 92.60)
```

!!! note

    This function is in need of improvement. It's quite
    difficult to find out the height of a line of text in a
    specific font. (Unless we import FreeType.) Suggestions for
    improvements welcome!

"""
function textfit(s::T where {T<:AbstractString}, bbox::BoundingBox, maxfontsize=800;
    horizontalmargin=3,
    leading=110)
    @layer begin
        bbox = bbox - horizontalmargin
        width = boxwidth(bbox)
        requiredheight = boxheight(bbox)

        # we'll never go bigger than this:
        fsize = maxfontsize
        fontsize(fsize)

        # remove blank lines from rearranged lines
        lines = filter!(!isempty, textlines(s, width))

        te = textextents(lines[1])

        # set up our binary search
        foundminsize = 0.5
        foundmaxsize = maxfontsize
        totalattempts = 20
        attempts = 0

        # binary search for the closest fontsize that satisfies our requirements
        while foundmaxsize - foundminsize > 0.1
            attempts += 1
            if attempts > totalattempts
                throw(error("textfit(): couldn't fit the text with $maxfontsize maxfontsize after trying $(atttempts) times"))
            end

            fsize = foundminsize + (foundmaxsize - foundminsize) / 2.0
            fontsize(fsize)

            # split into lines
            lines = filter!(!isempty, textlines(s, width))

            # estimate the finish height with our current fontsize
            # since we don't know the height well enough, just hope that putting leading
            # between every line will work
            estimatedfinishheight = (fsize + (100 / leading)) * length(lines)

            # estimate finish width
            widestline = 0
            for l in lines
                te = textextents(l)
                if widestline <= te[3]
                    widestline = te[3]
                end
            end

            # is this estimated result good enough with this font size?
            if estimatedfinishheight < requiredheight && widestline < boxwidth(bbox)
                # estimated size is too small
                # search for a larger font size
                foundminsize = fsize
            else
                # estimated size is too large
                # search for a smaller font size.
                foundmaxsize = fsize
            end
        end # while

        # use the most recent font size
        fontsize(fsize * (100 / leading))
        lines = filter!(!isempty, textlines(s, width))

        # start below the top of the box

        te = textextents(lines[1])
        # we can't get the height of a text character, sadly
        # but we can guess
        # not all fonts will have these characters though?
        fontheight = textextents("AA⃰gg̲")[4]
        textpos = boxtopleft(bbox) + Point(0, max(te[4], fontheight))

        for (linenumber, linetext) in enumerate(lines)
            text(linetext, textpos)
            te = textextents(linetext)
            textpos = Point(textpos.x, textpos.y + (max(te[4], fontheight) * (leading / 100)))
        end
        # return top position, bottom position
    end
    return (fontsize=fsize, linecount=length(lines), finalpos=textpos)
end

"""
    textonpoly(str, pgon;
            tracking = 0,
            startoffset = 0.0,
            baselineshift = 0.0,
            closed = false)

Draw the text in `str` along the route of the polygon in
`pgon`.

The `closed` option determines whether the final edge of the
polygon (joining the last point to the first) is included or
not. Eg if you want to draw a string around all three sides
of a triangle, you'd use `closed=true`:

```julia
textonpoly("mèdeis ageômetrètos eisitô mou tèn
stegèn - let no one ignorant of geometry come under my roof
",
    ngon(O, 100, 3, vertices=true),
    closed=true)
```

If `false`, only two sides are considered.

Increase `tracking` from 0 to add space between the glyphs.

The `startoffset` value is a normalized percentage that
specifies the start position. So, to start drawing the text
halfway along the polygon, specify a start offset value of
0.5.

Positive values for `baselineshift` move the characters
upwards from the baseline.

Returns a tuple with the number of characters drawn, and the
final value of the index, between 0.0 and 1.0. If the
returned index value is less than 1, this means that the
text supplied ran out before the end of the polygon was reached.
"""
function textonpoly(str::T where {T<:AbstractString}, pgon;
    tracking=0,
    startoffset=0.0,
    baselineshift=0.0,
    closed=false)
    pdist = polydistances(pgon, closed=closed)
    pgondist = polyperimeter(pgon, closed=closed)
    currentindex = startoffset
    characters_drawn = 1

    # hack: we can't find the slope of the line at its end
    # kludge: extend last segment
    if !closed
        push!(pgon, between(pgon[end-1], pgon[end], 1.0001))
    end
    for (n, c) in enumerate(str)
        glyph = string(c)
        fs = get_fontsize()
        if glyph == " "
            # we need the dimensions of the space character
            glyph_x_bearing,
            glyph_y_bearing,
            glyph_width,
            glyph_height,
            glyph_x_advance,
            glyph_y_advance =
                textextents("m m") .- textextents("mm")
        else
            glyph_x_bearing,
            glyph_y_bearing,
            glyph_width,
            glyph_height,
            glyph_x_advance,
            glyph_y_advance = textextents(glyph)
        end

        currentindex += (glyph_width / 2 + glyph_x_bearing + tracking) / pgondist
        # find slope of line at the current location
        θ = slope(
            last(polyportion(
                pgon,
                mod(currentindex - 0.0001, 1.0),
                closed=false,
                pdist=pdist
            )),
            last(polyportion(
                pgon,
                mod(currentindex + 0.0001, 1.0),
                closed=false,
                pdist=pdist
            )),
        )
        # move to the position for the middle of the glyph
        @layer begin
            translate(last(polyportion(
                pgon,
                currentindex,
                closed=closed,
            )))
            rotate(θ)
            # draw the glyph
            text(glyph, O + (0, -baselineshift), halign=:center)
        end
        # move on
        currentindex +=
            (glyph_width / 2 + glyph_x_bearing + tracking) /
            pgondist

        characters_drawn = n
        if currentindex >= 1.0
            break
        end
    end
    return (characters_drawn, currentindex)
end

function _textformat(str::String, pos::Point, defaultparams)
    for wd in split(str)
        @layer begin
            tx = textextents(wd)
            text(wd, Point(pos.x, pos.y + -defaultparams.baseline))
            if isapprox(defaultparams.advance, 1.0)
                space = textextents(" ")
                pos = Point(pos.x + tx[5] + space[5], pos.y)
            else
                space = [0, 0, 0, 0, defaultparams.advance, 0]
                pos = Point(pos.x + tx[5] + space[5], pos.y)
            end
            # newline required?
            if pos.x > (defaultparams.position.x + defaultparams.width) - tx[3]
                # return to left edge of text block but one line down
                pos = Point(defaultparams.position.x, pos.y + defaultparams.fontsize * (defaultparams.leading/100))
            end
        end
    end # split
    return pos
end

function _textformat_tuple(str::String, pos::Point, tempparams, defaultparams)
    if tempparams.prolog isa Function
        # remember to use baseline shift when passing details to prolog function
        tempparams.prolog(Point(pos.x, pos.y + -tempparams.baseline), str)
    end
    for wd in split(str) # split the string into words
        tx = textextents(wd)
        text(wd, Point(pos.x, pos.y + -tempparams.baseline))
        if isapprox(tempparams.advance, 1.0)
            space = textextents(" ")
            pos = Point(pos.x + tx[5] + space[5], pos.y)
        else
            space = [0, 0, 0, 0, tempparams.advance, 0]
            pos = Point(pos.x + tx[5] + space[5], pos.y)
        end
        # newline required?
        if pos.x > (defaultparams.position.x + defaultparams.width) - tx[3]
            # return to left edge of text block but one 'line' down
            pos = Point(defaultparams.position.x, pos.y + (tempparams.fontsize * (tempparams.leading/100)))
        end
    end
    return pos
end

"""
    textformat(e1, e2, e3...;
        color=getcolor(),
        fontsize=get_fontsize(),
        fontface="Helvetica",
        leading=120,
        baseline=0,
        prolog=nothing,
        advance=1.0,
        position=Point(0, 0),
        width=300)

Draw the text in elements `e1`, `e2`, ... Each element can be either:

- a string

- a named tuple containing text and formatting parameters:

Text starts at `position` and is constrained by the `width`.

A named tuple element can be something like this:

```julia
(
    text= "a string",
    color = "blue",
    fontsize = 12,
    fontface = "JuliaMono-Italic",
    leading = 100,
    baseline = 0,
    advance = 1.0,
    prolog = nothing
)
```

If `advance` is 1.0, elements are separated by a space; otherwise by `advance`
units (positive shifts to the right).

`baseline` is usually 0, but positive values move the text upwards.

`leading` here is a percentage, relative to the font size; the default is 120%.

`prolog` calls a function with arguments `(position::Point,
str::String)`, which is called before the text is drawn.

Returns the point where the next text would be placed.

This function uses the Toy text API.

## Example

This example draws a bold heading in red, and a paragraph below in monospaced
text, in orange.

```julia
@draw begin
    background("black")
    fontsize(20)
    textformat(
        (text="Heading",
            fontface="AvenirNext-Heavy",
            fontsize=40,
            leading=100,
            color = "red",
        ),
        (text="The first paragraph.",
            fontface = "JuliaMono-Light",
            fontsize = 20,
            color="orange"
        ),
    position = boxtopleft() + (100, 100),
    width = 150
    )
end
```
"""
function textformat(args...; kwargs...)
    # add any keywords to the defaults
    defaultparams = merge((color=getcolor(),
            fontsize=get_fontsize(),
            fontface="Helvetica",
            leading=120,
            baseline=0, # shift upwards if positive
            prolog=nothing,
            advance=1.0, # always advance after string if 1.0
            position=Point(0, 0),
            width=300,), values(kwargs))
    @layer begin
        pos = defaultparams.position
        width = defaultparams.width
        leading = defaultparams.leading
        fontface(defaultparams.fontface)
        fontsize(defaultparams.fontsize)
        sethue(defaultparams.color)
        for arg in args
            # arg is either a string or a named tuple
            if arg isa NamedTuple
                # get the temporary parameters, use defaults for the others
                # righmost value takes priority
                tempparams = merge((color=defaultparams.color,
                        advance=defaultparams.advance,
                        prolog=defaultparams.prolog,
                        leading=defaultparams.leading,
                        baseline=defaultparams.baseline,
                        fontsize=defaultparams.fontsize,
                        fontface=defaultparams.fontface,),
                    arg)
                if !haskey(tempparams, :text)
                    throw(error("textformat(): there's no `text` field in the tuple $(arg)"))
                end
                str = tempparams.text
                # draw text according to the temporary params
                @layer begin
                    fontface(tempparams.fontface)
                    fontsize(tempparams.fontsize)
                    sethue(tempparams.color)
                    pos = _textformat_tuple(str, pos, tempparams, defaultparams)
                end # layer
            else
                str = arg
                @layer begin
                    pos = _textformat(str, pos, defaultparams)
                end
            end
        end # args
    end # layer
    return pos
end

using Luxor, Test

Drawing(700, 350, "dimensioning-test.svg")
origin()
background("white")
pentagon = ngonside(O, 120, 5, vertices=true)
sethue("black")
setline(.2)
poly(pentagon, :stroke, close=true)

@testset "dimensioning" begin
    d, t = dimension(O, pentagon[4],
    fromextension = [0, 0])

    @test isapprox(d, 102.0780970022448)
    @test t == "102.0780970022448"

    d, t = dimension(pentagon[1], pentagon[2],
        offset        = -60,
        fromextension = [20, 50],
        toextension   = [20, 50],
        textrotation  = 2π/5,
        textgap       = 20,
        format        = (d) -> string(round(d, digits=4), "pts"))

    @test isapprox(d, 119.99999999999997)
    @test t == "120.0pts"

    d, t = dimension(pentagon[2], pentagon[3],
         offset        = -40,
         format        =  string)

    @test isapprox(d, 120.0)
    @test t =="120.0"

    d, t = dimension(pentagon[5], Point(pentagon[5].x, pentagon[4].y),
        offset        = 60,
        format        = (d) -> string("approximately ", round(d, digits=4)),
        fromextension = [5, 5],
        toextension   = [80, 5])

    @test isapprox(d, 97.08203932499367)
    @test t ==  "approximately 97.082"

    d, t = dimension(pentagon[1], midpoint(pentagon[1], pentagon[5]),
        offset               = 70,
        fromextension        = [65, -5],
        toextension          = [65, -5],
        texthorizontaloffset = -5,
        arrowheadlength      = 5,
        format               = (d) ->
            begin
                if isapprox(d, 60.0)
                    string("exactly ", round(d, digits=4), "pts")
                else
                    string("≈ ", round(d, digits=4), "pts")
                end
            end)

    @test isapprox(d, 60.00000000000001)
    @test t == "exactly 60.0pts"

    d, t = dimension(pentagon[1], pentagon[5],
        offset               = 120,
        fromextension        = [5, 5],
        toextension          = [115, 5],
        textverticaloffset   = 0.5,
        texthorizontaloffset = 0,
        textgap              = 5)

    @test isapprox(d, 120.00000000000001)
    @test t == "120.00000000000001"

    finish()
    nothing
end

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function subroutine(🐢::Turtle)
    for i in 1:10
        Forward(🐢, 40)
        Turn(🐢, 51)
        Circle(🐢, 1)
    end
end

function test_turtles(fname)
    Drawing(1200, 1200, fname)
    origin()
    background("black")

    # let's have two turtles
    raphael = Turtle(0, 0, true, 0, (1.0, 0.25, 0.25))
    michaelangelo = Turtle(0, 0, true, 0, (1.0, 0.25, 0.25))

    Pencolor(raphael, 1.0, 0.4, 0.2);       Pencolor(michaelangelo, 0.2, 0.9, 1.0)
    Penwidth(raphael, 0.75);                Penwidth(michaelangelo, 1.5)
    Reposition(raphael, -400, -300);        Reposition(michaelangelo, 0, 200)

    Orientation(raphael, pi);               Orientation(michaelangelo, -pi)

    for 🐢 in [raphael, michaelangelo]
        setlinecap("round")
        setopacity(0.5)
        Penwidth(🐢, .5)
        n = 400
        Penup(🐢)
        Pendown(🐢)
        for i in 1:200
            Forward(🐢, n)
            Turn(🐢, 29)
            🐢 == raphael && HueShift(🐢, 1)
            n += 1.25
            subroutine(🐢)
        end
        Reposition(🐢, O)
        Rectangle(🐢, 10, 10)
    end
    
    for i in 150:250
        Reposition(raphael, Point(300, -2i))
        Towards(raphael, Point(400, -400))
        Forward(raphael, 200)
        HueShift(raphael, 5)
    end

    fontsize(30)
    Reposition(raphael, Point(400, -100));   Reposition(michaelangelo, 400, -50)
    Message(raphael, "Raphael");      Message(michaelangelo, "Michaelangelo")

    Push(raphael)
    Pop(raphael)

    Pencolor(raphael, "white")
    Randomize_saturation(michaelangelo)

    # test warnings
    @info("stack was already empty warning expected...")
    Pop(michaelangelo) # should get "stack empty" warning!
    @test finish() == true
end

fname = "turtles-all-the-way-down.png"
test_turtles(fname)
println("...finished test: output in $(fname)")

using Luxor, Test, Random
Random.seed!(42)

function polygon_intersection_test(fname)
    Drawing(2000, 2000, fname)
    origin()
    background("white")
    sethue("magenta")
    setline(2)
    fontsize(4)
    tiles = Tiler(2000, 2000, 5, 5)
    for (pos, n) in tiles
        @layer begin
            randomhue()
            translate(pos)
            p1 = randompointarray(BoundingBox(box(O, tiles.tilewidth, tiles.tileheight, vertices = true))..., 3)
            p2 = randompointarray(BoundingBox(box(O, tiles.tilewidth, tiles.tileheight, vertices = true))..., 3)

            sethue("grey50")
            poly(p1, close = true, :stroke)
            poly(p2, close = true, :stroke)

            pint = polyintersect(p1, p2)

            sethue("purple")
            setopacity(0.5)
            if length(pint) > 0
                for p in pint
                    prettypoly(p, :fill)
                end
            end
        end
    end
    @test finish() == true
end

function polygon_intersection_test_2(fname)
    Drawing(2000, 2000, fname)
    origin()
    background("white")
    sethue("magenta")
    setline(4)
    setlinejoin("round")
    fontsize(4)
    tiles = Tiler(2000, 2000, 5, 5)
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            p1 = star(O + (rand(-40:40), rand(-40:40)), 170, rand(3:6), rand(0.2:0.1:0.9), vertices = true)
            p2 = ngon(O + (rand(-40:40), rand(-40:40)), 120, rand(3:9), rand() * 2π, vertices = true)

            @layer begin
                setopacity(0.3)
                sethue("red")
                poly(p1, close = true, :fill)
                sethue("blue")
                poly(p2, close = true, :fill)
            end

            pint = polyintersect(p1, p2)

            sethue("black")
            for p in pint
                prettypoly(p, :stroke, close = true)
            end
        end
    end
    @test finish() == true
end

fname = "polygon_intersection_test.png"
polygon_intersection_test(fname)
println("...finished test: output in $(fname)")

fname = "polygon_intersection_test_2.png"
polygon_intersection_test_2(fname)
println("...finished test: output in $(fname)")

using Luxor
using Test
using Random

Random.seed!(42)

function polymorph_test_1(fname)
    Drawing(500, 500, fname)
    background("grey20")
    origin()
    sethue("white")

    poly1 = [Point(70x, -200 + 20sin(x)) for x in -π:0.1:π]
    poly2 = [Point(70x, 200 + 20sin(2x)) for x in -π:0.1:π]

    poly(poly1, :stroke)
    poly(poly2, :stroke)

    # test that first points and last points remain the same x
    for i in 0:0.02:1.0
        pm = polymorph(poly1, poly2, i, closed=false, samples=50)
        poly.(pm, :stroke)
        @test first(pm[1]).x ≈ poly1[1].x ≈ poly2[1].x
        @test poly1[end].x ≈ poly2[end].x ≈ last(pm[1]).x
    end

    @test finish() == true

    println("...finished test: output in $(fname)")
end

polymorph_test_1("polymorph-test-1.png")

using Luxor
using Test

function test_hex_grids(fname)
    ha = HexagonAxial(0, 0)
    ha = HexagonAxial(0, 0, Point(10, 10))
    ha = HexagonAxial(0, 0, Point(10, 10), 10)
    ha = HexagonAxial(0, 0, Point(50, 50), 10, 10)

    convert(HexagonCubic, ha)
    # HexagonCubic(0, 0, 0, Point(10.0, 10.0), 10.0, 10.0)

    convert(HexagonOffsetOddR, ha)
    # HexagonOffsetOddR(0, 0, Point(10.0, 10.0), 10.0, 10.0)

    convert(HexagonOffsetEvenR, ha)
    # HexagonOffsetEvenR(0, 0, Point(10.0, 10.0), 10.0, 10.0)

    ha = HexagonAxial(0, 0, Point(10, 10), 10)
    hexcenter(ha)
    # Point(10.0, 10.0)

    ha = HexagonAxial(0, 0, Point(50, 50), 10, 10)
    hexcenter(ha)
    # Point(10.0, 10.0)

    ha = HexagonAxial(-1, 1, Point(50, 50), 20, 10)
    hon = convert(HexagonOffsetOddR, ha)

    hneighbors = collect(hexneighbors(hon))

    @test hneighbors[1] == HexagonCubic(0, -1, 1, Point(50.0, 50.0), 20.0, 10.0)

    Drawing(700, 800, fname)
    origin()
    ha = HexagonAxial(-1, 1, Point(20, 30), 20, 10)
    ho = convert(HexagonOffsetOddR, ha)
    pgon = hextile(ho)
    poly(pgon, :stroke, close = true)
    @test 518 < polyarea(pgon) < 520
    @test hexcenter(ho) ≈ Point(2.679491924311229, 45.0)

    ho = HexagonOffsetEvenR(0, 0, 25)
    setopacity(0.3)
    for ring in 1:10
        randomhue()
        for i in hexring(ring, ho)
            poly(hextile(i), :fill)
        end
    end

    setopacity(1)
    ho = HexagonOffsetEvenR(0, 0, 70)
    sethue("red")
    setline(10)
    poly(hextile(ho), :stroke)
    for n in hexneighbors(ho)
        randomhue()
        poly(hextile(n), :stroke, close = true)
    end

    ho = HexagonOffsetOddR(0, 0, 30)
    sethue("cyan")
    for n in hexagons_within(2, ho)
        poly(hextile(n), :stroke, close = true)
    end

    sethue("red")
    for n in hexdiagonals(ho)
        randomhue()
        poly(hextile(n), :fill, close = true)
    end

    h1 = HexagonOffsetEvenR(-10, -10, 5)
    h2 = HexagonOffsetEvenR(4, 6, 5)
    sethue("purple")
    for h in hexcube_linedraw(h1, h2)
        poly(hextile(h), :fill)
    end
    @test finish() == true
end

fname = "hex-grid-test.png"
test_hex_grids(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_pie(fname)
  pagewidth, pageheight = 1200, 1400
  Drawing(pagewidth, pageheight, fname)
  origin() # move 0/0 to center
  background("ivory")
  setopacity(0.8)
  setline(0.4)

  pagetiles = Tiler(pagewidth, pageheight, 4, 5, margin=50)
  rad = 60
  for (pos, n) in pagetiles
    randomhue()
    fromA, toA = rand() * 2pi, rand() * 2pi
    fromA_str, toA_str = string(convert(Int, round(rad2deg(fromA), digits=0))),
                         string(convert(Int, round(rad2deg(toA), digits=0)))
    pie(pos, rad, fromA, toA, :fill)

    #label

    text(fromA_str, pos.x + 1.1rad  * cos(fromA), pos.y + 1.1rad  * sin(fromA))
    text(toA_str, pos.x + 1.1rad  * cos(toA), pos.y + 1.1rad  * sin(toA))
    sethue("black")
    text(string(fromA_str, "°/", toA_str, "°"), pos.x, pos.y)
  end
  @test finish() == true
end

fname = "pie-test1.pdf"
test_pie(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function test_pro_text(fname)
    Drawing(1600, 1800, fname)
    sethue("black")
    strings = [
        "<b>This is bold.</b>",
        "<i>This is italic.</i>",
        "<s>This is strikethrough.</s>",
        "<sub>This is subscript.</sub>",
        "<sup>This is superscript.</sup>",
        "<small>This makes the font smaller.</small>",
        "<big>This makes the font larger.</big>",
        "<u>This is underlined text.</u>",
        "<tt>This uses a monospaced font.</tt>",
        "<span foreground='blue'>Blue text!</span>",
        "<span size='x-large'>Extra Large Text</span>",
        "Well, time for a <span font='26' background ='green' foreground='red'>quick fontsize change.</span> I think!",
    ]
    col1 = 100
    col2 = 900
    row = 100

    # Pango-related text handling in Windows generates ReadOnlyMemory errors
    # skip until it can be investigated
    if !Sys.iswindows()
        counter = 1
        for i in 4:30
            # pro api:
            setfont("Georgia $i", i)
            settext(
                strings[mod1(counter, end)],
                Point(col1, row),
                halign = "left",
                valign = "top",
                angle = 0,
                markup = true)
            counter += 1

            # toy api:
            fontface("Georgia")
            fontsize(i)
            text("hello in Georgia $i using the Toy API", Point(col2, row))
            row += 30

            # TODO: A weird bug: the markup is applied when I don't think it should be
            # pro api again
            # setfont("Georgia $i", i)
            #settext("hello in Georgia $i using the Pro API", Point(col2, row))

            # row += 30
        end

        settext("Test with no row, col", halign = "left", valign = "top", angle = 0, markup = true)
    end

    @test finish() == true
end

fname = "pro-text-test.pdf"
test_pro_text(fname)
println("...finished test: output in $(fname)")

using Luxor
using Test
using LaTeXStrings
using MathTeXEngine
@testset "latexextension" begin
    @test length(methods(latextextsize)) == 2
    @test length(methods(latexboundingbox)) == 3
    @test length(methods(rawlatexboundingbox)) == 2
    @test_throws MethodError latextextsize(14.0)
    @test_throws MethodError latexboundingbox("14.0")
    @test_throws MethodError rawlatexboundingbox(:fourteen)
end

@testset "latex" begin
    d = Drawing(200, 200, :svg)
    background("black")
    origin()
    fontsize(18)
    sethue("gold")
    t = L"\sum^N_{n=1} \frac{x}{n}"

    for halign in [:left, :right, :center], valign in [:baseline, :bottom, :top, :middle]
        text(t, O, halign=halign, valign=valign)

        @test round.(latextextsize(t); digits=2) == (36.99, 46.69)

        if halign === :left
            @test round(latexboundingbox(t, halign=halign, valign=valign)[1][1]; digits=2) == 0.0
            @test round(latexboundingbox(t, halign=halign, valign=valign)[2][1]; digits=2) == 36.99
        elseif halign === :right
            @test round(latexboundingbox(t, halign=halign, valign=valign)[1][1]; digits=2) == -36.99
            @test round(latexboundingbox(t, halign=halign, valign=valign)[2][1]; digits=2) == 0.0
        elseif halign === :center
            @test round(latexboundingbox(t, halign=halign, valign=valign)[1][1]; digits=2) == -36.98 / 2
            @test round(latexboundingbox(t, halign=halign, valign=valign)[2][1]; digits=2) == 36.98 / 2
        end

        if valign === :baseline || valign === :bottom
            @test round(latexboundingbox(t, halign=halign, valign=valign)[1][2]; digits=2) == 18.72
            @test round(latexboundingbox(t, halign=halign, valign=valign)[2][2]; digits=2) == -27.97
        elseif valign === :top
            @test round(latexboundingbox(t, halign=halign, valign=valign)[1][2]; digits=2) == 46.69
            @test round(latexboundingbox(t, halign=halign, valign=valign)[2][2]; digits=2) == 0.0
        elseif valign === :middle
            @test round(latexboundingbox(t, halign=halign, valign=valign)[1][2]; digits=2) == 46.70 / 2
            @test round(latexboundingbox(t, halign=halign, valign=valign)[2][2]; digits=2) == -46.70 / 2
        end
    end

    finish()
end

function latex_test(fname)
    latexstrings = [
        L"\frac{𝔸}{2}",
        L"𝔸𝔹ℂ𝕬𝕭𝕮𝒜ℬ𝒞𝕒𝕓𝕔𝐚𝐛𝐜𝐀𝐁𝐂𝓐𝓑𝓒",
        L"e^x = \sum^\infty_{n=0} \frac{x^n}{n!} = \lim_{n\to\infty}(1+\frac{x}{n})^n",
        L"\sum^N_{n=1} \frac{x}{n}",
        L"Asset policy function $g(a,s)$",
        L"e^{i\pi} + 1 = 0",
        L"e^x = \sum^\infty_{n=0} \frac{x^n}{n!} = \lim_{n\to\infty}(1+\frac{x}{n})^n",
        L"\cos(\theta)",
        L"f(t) = [4\cos(t) + 2\cos(5t), 4\sin(t) + 2\sin(5t)]",
    ]
    Drawing(1600, 1200, fname)
    origin()
    background("black")
    sethue("orange")

    fontsize(30)
    pt = boxtopleft() + (400, 150)
    grid = GridRect(pt, 800, 100, 1600, 1200)
    for l in 1:length(latexstrings)
        randomhue()
        text(latexstrings[l], pt, halign = :center, paths=true)
        fillpath()
        pt = nextgridpoint(grid)
        randomhue()
        text(latexstrings[l], pt, halign = :center, paths=false)
        pt = nextgridpoint(grid)
    end
    @test finish() == true
end

fname = "latex-test.png"
latex_test(fname)
println("...finished latex test: output in $(fname)")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function arrow_line_test(fname)
  pagewidth, pageheight = 2000, 2000
  Drawing(pagewidth, pageheight, fname)
  origin() # move 0/0 to center
  background("ivory")
  setopacity(0.8)
  setline(2)
  pagetiles = Tiler(pagewidth, pageheight, 40, 8, margin=50)
  for (pos, n) in pagetiles
    setlinecap()
    setlinejoin()
    randomhue()
    gsave()
    arrow(pos, Point(pos.x + 200, pos.y),
      decorate = () -> begin
        setline(0.2)
        circle(O, 5, :stroke)
      end,
      decoration = range(0, stop=1, length=rand(2:10)),
      linewidth=rand(1:20),
      arrowheadlength=rand(1:30),
      arrowheadangle=rand(pi/20:pi/12:pi/3))
    # same length as a non-arrow line?
    line(Point(pos.x, pos.y + 10), Point(pos.x + 200, pos.y+10), :stroke)
    grestore()
  end
  @test finish() == true

end

Random.seed!(42)
fname = "arrow-line-test.pdf"
arrow_line_test(fname)
println("...finished test: output in $(fname)")

using Luxor

using Test

using Random
Random.seed!(42)

function test_polybspline()
    controlpoints = [Point(rand(), rand()) for _ in 1:10]

    resultClamped = polybspline(controlpoints, 10;clamped = true)
    resultUnClamped = polybspline(controlpoints, 10;clamped = false)
    # Check if the result is an array of the correct length
    @test length(resultClamped) == 10
    @test length(resultUnClamped) == 10

    # Check if the result is an array of Points
    @test all(x -> x isa Point, resultClamped)
    @test all(x -> x isa Point, resultUnClamped)

    # Check that all the values in the result points are non NaN
    @test all(x -> !isnan(x.x) && !isnan(x.y), resultClamped)
    @test all(x -> !isnan(x.x) && !isnan(x.y), resultUnClamped)
    
    # Check that all the result points lie within the bounding box of the control points
    min_x, max_x = extrema(p.x for p in controlpoints)
    min_y, max_y = extrema(p.y for p in controlpoints)

    @test all(min_x <= p.x <= max_x && min_y <= p.y <= max_y for p in resultClamped)
    @test all(min_x <= p.x <= max_x && min_y <= p.y <= max_y for p in resultUnClamped)
end

test_polybspline()
println("...finished polybspline test")

#!/usr/bin/env julia

# this test isn't run by Pkg.test

# it can be run to test Jupyter integration...

using Luxor

using Test

using Random
Random.seed!(42)

function draw_hypotrochoids()
    background("grey10")
    sethue("antiquewhite")
    setopacity(0.8)
    tiles = Tiler(1200, 1200, 6, 6)
    for (pos, n) in tiles
        gsave()
        setline(.5)
        translate(pos)

        R = 45; r = n; d = 20
        sethue("antiquewhite")
        poly(hypotrochoid(R, n, d, :stroke, stepby=pi/300, vertices=true), :stroke, close=true)
        text(string("R = $(R), r = $(r), d = $(d)"), halign=:center, O.x, O.y+tiles.tileheight/2)

        # test perimeterlength
        ptslist = hypotrochoid(R, n, d, :stroke, stepby=pi/300, vertices=true)
        polyperimeter(ptslist)

        R = 2n; r = 12; d = 5
        sethue("orange")
        (R == r) && (r += 1)
        p = hypotrochoid(R, r, d, :none, stepby=pi/305, vertices=true)
        polydistances(p) # just testing
        poly(p, :stroke, close=true)
        text(string("R = $(R), r = $(r), d = $(d)"), halign=:center, O.x, O.y+tiles.tileheight/2 + 10)

        # testing portions of polys
        portion = rand()
        setline(.25)
        sethue("magenta")
        section = polyportion(p, portion)
        poly(section, :stroke, close=false)
        sethue("green")
        circle(section[end], 2, :stroke)
        poly(polyremainder(p, portion), :stroke, close=false)

        text(string("portion ", round(portion, digits=2)), halign=:center, O.x, O.y+tiles.tileheight/2 + 30)

        sethue("cyan")
        setline(0.3)
        poly(offsetpoly(p, 15), :stroke, close=true)
        text("offset 15", halign=:center, O.x, O.y+tiles.tileheight/2 + 20)

        grestore()
    end
end

function test_hypotrochoid_at_png()
    @png begin
        draw_hypotrochoids()
    end 1200 1200
end
function test_hypotrochoid_at_svg()
    @svg begin
        draw_hypotrochoids()
    end 1200 1200
end
function test_hypotrochoid_at_pdf()
    @pdf begin
        draw_hypotrochoids()
    end 1200 1200
end

Random.seed!(42)

test_hypotrochoid_at_png() ; println("output PNG")
test_hypotrochoid_at_svg() ; println("output SVG")
test_hypotrochoid_at_pdf() ; println("output PDF")


#testing @manipulate

using Interact

function makecircle(r)
    d = Drawing(300, 300, :svg)
    sethue("black")
    setline(0.1)
    origin()
    hypotrochoid(150, r, 35, :stroke)
    finish()
    return d
end

@manipulate for r in 5:150
    makecircle(r)
end

struct PathCurve
    pt1::Point
    pt2::Point
    pt3::Point
end

struct PathMove
    pt1::Point
end

struct PathLine
    pt1::Point
end

struct PathClose end

const PathElement = Union{PathCurve,PathMove,PathLine,PathClose}

"""
A Path object contains, in the `.path` field, a vector of
`PathElement`s (`PathCurve`, `PathMove`, `PathLine`,
`PathClose`) that describe a Cairo path. Use `drawpath()` to
draw it.

```julia
Path([PathMove(Point(2.0, 90.5625)),
      PathCurve(Point(4.08203, 68.16015), Point(11.28, 45.28), Point(24.8828, 26.40234)),
      PathLine(Point(2.0, 90.5625)),
      PathClose()
     ])
```
"""
struct Path
    path::Vector{PathElement}
end

"""
    Path(ptlist::Vector{Point}; close=false))

Create a Path from the points in `ptlist`.
"""
function Path(ptlist::Vector{Point};
    close = false)
    p = Path(PathElement[])
    push!(p.path, PathMove(ptlist[1]))
    for pt in ptlist[2:end]
        push!(p.path, PathLine(pt))
    end
    if close
        push!(p.path, PathClose())
    end
    return p
end

Base.size(cp::Path) = length(cp.path)
Base.length(cp::Path) = length(cp.path)
Base.getindex(cp::Path, i::Int) = cp.path[i]
Base.IndexStyle(cp::Path) = IndexLinear()
Base.setindex!(cp::Path, el, e::Integer) = setindex!(cp.path, el, e)
Base.keys(cp::Path) = keys(cp.path)
Base.eltype(::Type{Path}) = PathElement

function Base.iterate(cp::Path)
    if length(cp.path) != 0
        return (first(cp.path), 2)
    else
        return nothing
    end
end

function Base.iterate(cp::Path, state)
    if state > length(cp.path)
        return nothing
    else
        return (cp.path[state], state + 1)
    end
end

Base.getindex(cp::Path, r::Union{LinRange,UnitRange,StepRangeLen}) = getindex(cp.path, r)
Base.lastindex(cp::Path) = length(cp.path)

function Base.show(io::IO, cp::Path)
    if iszero(length(cp))
        print(io, "Path is empty")
    else
        println(io, "Path([")
        for p in cp.path[1:(end - 1)]
            println(io, " $(p),")
        end
        println(io, " $(cp.path[end])")
        println(io, "])\n")
    end
end

function drawpath(cpe::PathMove)
    move(cpe.pt1)
    return currentpoint()
end

function drawpath(cpe::PathLine)
    line(cpe.pt1)
    return currentpoint()
end

function drawpath(cpe::PathCurve)
    curve(cpe.pt1, cpe.pt2, cpe.pt3)
    return currentpoint()
end

function drawpath(cpe::PathClose)
    closepath()
end

"""
    storepath()

Obtain the current Cairo path and make a Luxor Path object,
which is an array of PathElements.

Returns the Path object.

You can draw stored paths using `drawpath()`.

See also `getpath()`, `getpathflat()`, and `textpath()`.
"""
function storepath()
    path = PathElement[]
    for e in getpath()
        if e.element_type == 0
            (x, y) = e.points
            push!(path, PathMove(Point(x, y)))
        elseif e.element_type == 1
            (x, y) = e.points
            push!(path, PathLine(Point(x, y)))
        elseif e.element_type == 2
            (x1, y1, x2, y2, x3, y3) = e.points
            push!(path, PathCurve(Point(x1, y1), Point(x2, y2), Point(x3, y3)))
        elseif e.element_type == 3
            push!(path, PathClose())
        else
            error("unknown Cairo Path Entry " * repr(e.element_type))
            error("unknown Cairo Path Entry " * repr(e.points))
        end
    end
    return Path(path)
end

"""
    drawpath(cp::Path; action=:none, startnewpath=true)
    drawpath(cp::Path, action; startnewpath=true)

Make the Luxor path stored in `cp` and apply the `action`.

To make paths, follow some path construction functions such
as `move()`, `line()`, and `curve()` with the `storepath()`
function.

By default, `startnewpath=true`, which starts a new path,
discarding any existing path contents.
"""
function drawpath(cp::Path;
    action = :none, startnewpath = true)
    startnewpath && newpath()
    for p in cp
        drawpath(p)
    end
    do_action(action)
    return currentpoint()
end

drawpath(cp::Path, action::Symbol; startnewpath = true) =
    drawpath(cp::Path; action = action, startnewpath = startnewpath)

"""
    polytopath(ptlist)

Convert a polygon to a Path object.

```julia
@draw drawpath(polytopath(ngon(O, 145, 5, vertices = true)), action = :fill)
```
"""
function polytopath(ptlist::Vector{Point})
    path = PathElement[]
    push!(path, PathMove(ptlist[1]))
    for pt in ptlist[2:end]
        push!(path, PathLine(pt))
    end
    push!(path, PathClose())
    return Path(path)
end
"""
    bezierpathtopath(bp::BezierPath)

Convert a Bezier path to a Path object.

```julia
@draw drawpath(polytopath(ngon(O, 145, 5, vertices = true)), action = :fill)
```
"""
function bezierpathtopath(bp::BezierPath)
    path = PathElement[]
    push!(path, PathMove(first(first(bp))))
    for p in bp
        push!(path, PathCurve(p[2], p[3], p[4]))
    end
    return Path(path)
end

"""
    BoundingBox(path::Path)

Find bounding box of a stored Path (made with `storepath()`).
"""
function BoundingBox(path::Path)
    # start with empty bbox, grow it using points in path
    counter = 0
    bbox = BoundingBox(O, O)
    currentpoint = O
    for p in path
        counter += 1
        if p isa PathMove
            if isapprox(boxdiagonal(bbox), 0.0) # bbox empty?
                bbox = BoundingBox(p.pt1, p.pt1)
            else
                bbox += BoundingBox(currentpoint, p.pt1)
            end
            currentpoint = p.pt1
        elseif p isa PathLine
            if isapprox(boxdiagonal(bbox), 0.0) # bbox empty?
                bbox = BoundingBox(currentpoint, p.pt1)
            else
                bbox += BoundingBox(currentpoint, p.pt1)
            end
            currentpoint = p.pt1
        elseif p isa PathCurve
            phbbox = BoundingBox(Luxor.get_bezier_points(BezierPathSegment(currentpoint, p.pt1, p.pt2, p.pt3)))
            if isapprox(boxdiagonal(bbox), 0.0) # bbox empty?
                bbox = phbbox
            else
                bbox += phbbox
            end
            currentpoint = p.pt3
        end
    end
    return bbox
end

"""
    get_bezier_points(bps::BezierPathSegment;
        steps=10)

The flattening: return a list of all the points on the
Bezier curve, including start and end, using `steps` to
determine the accuracy.
"""
function get_bezier_points(bps::BezierPathSegment;
    steps = 10)
    return bezier.(range(0.0, 1.0, length = steps), Ref.(tuple(bps...))...)
end

"""
    get_bezier_length(bps::BezierPathSegment;
        steps=10)

Return the length of a BezierPathSegment, using `steps` to
determine the accuracy, by stepping  through the curve and
finding all the points,  and then measuring between them.

This is obviously just an approximation; the maths to do
it properly is too difficult for me. :(
"""
function get_bezier_length(bps::BezierPathSegment;
    steps = 10)
    LUT = get_bezier_points(bps, steps = steps)
    curvelength = 0.0
    for i in 1:(length(LUT) - 1)
        curvelength += distance(LUT[i], LUT[mod1(i + 1, end)])
    end
    return curvelength
end

"""
    pathlength(path::Path;
        steps=10)

Return the length of a Path.

The `steps` parameter is used when approximating the length of any curve (Bezier) sections.
"""
function pathlength(path::Path;
    steps = 10)
    currentpoint = O
    firstpoint = currentpoint
    plength = 0.0
    for pathelement in path
        if pathelement isa PathMove # pt1
            firstpoint = pathelement.pt1
            currentpoint = pathelement.pt1
        elseif pathelement isa PathCurve # pt1 pt2  pt3
            plength += get_bezier_length(BezierPathSegment(currentpoint, pathelement.pt1, pathelement.pt2, pathelement.pt3), steps = steps)
            currentpoint = pathelement.pt3
        elseif pathelement isa PathLine  # pt1
            plength += distance(currentpoint, pathelement.pt1)
            currentpoint = pathelement.pt1
        elseif pathelement isa PathClose
            # I think Close is just drawing to the point established by previous Move...
            plength += distance(firstpoint, currentpoint)
        end
    end
    return plength
end

"""
    drawpath(path::Path, k::Real;
        steps=10, # used when approximating Bezier curve segments
        action=:none,
        startnewpath=true,
        pathlength = 0.0)

Draw the path in `path` starting at the beginning and
stopping at `k` between 0 and 1. So if `k` is 0.5, half the
path is drawn.

Returns the last point processed.

The function calculates the length of the entire path before
drawing it. If you want to draw a large path more than once,
it might be more efficient to calculate the length of the
path first, and provide it to the `pathlength` keyword.

The `steps` parameter is used when approximating the length of any curve
(Bezier) sections. Higher values will be more accurate.
"""
function drawpath(path::Path, k::Real;
    steps = 20, # used when approximating Bezier curve segments
    action = :none,
    startnewpath = true,
    pathlength = 0.0)
    if iszero(pathlength)
        pathlength = Luxor.pathlength(path)
    end
    requiredlength = clamp(k, 0.0, 1.0) * pathlength
    currentlength = 0
    startnewpath && newpath()
    # firstpoint is the point we will return to for a Close
    # currentposition is our current position
    # mostrecentpoint is the point we last visited
    finished = false
    currentposition = mostrecentpoint = firstpoint = O
    for pathelement in path
        #info "path element is ", pathelement
        currentlength > requiredlength && (finished = true)
        if pathelement isa PathMove # pt1
            currentposition = firstpoint = pathelement.pt1
            drawpath(pathelement)
            # remember how far we've got
            mostrecentpoint = Luxor.currentpoint()
        elseif pathelement isa PathCurve # pt1 pt2 pt3
            plength = Luxor.get_bezier_length(BezierPathSegment(currentposition, pathelement.pt1, pathelement.pt2, pathelement.pt3), steps = steps)
            if (currentlength + plength) > requiredlength
                # we mustn't draw all of this curve, since it overshoots
                # just draw the overshoot fraction of the curve
                overshoot = (requiredlength - currentlength) / plength
                bps = BezierPathSegment(currentposition, pathelement.pt1, pathelement.pt2, pathelement.pt3)
                newbezier = trimbezier(bps, 0, overshoot)
                # using the last three for this Bezier
                # currentposition is the first pt
                drawpath(PathCurve(newbezier[2], newbezier[3], newbezier[4]))
                mostrecentpoint = newbezier[4]
                # don't do any more
                finished = true
            else
                drawpath(pathelement)
                mostrecentpoint = pathelement.pt3
                currentlength += plength
                # update currentposition
                currentposition = mostrecentpoint
            end
        elseif pathelement isa PathLine  # pt1
            plength = distance(currentposition, pathelement.pt1)
            currentlength += plength
            if currentlength > requiredlength
                # we mustn't draw all of this line, since it overshoots
                overshoot = (currentlength - requiredlength) / plength
                # just draw the overshoot fraction of the line
                drawpath(PathLine(between(currentposition, pathelement.pt1, 1 - overshoot)))
                # don't do any more
                finished = true
            else
                drawpath(pathelement)
            end
            mostrecentpoint = Luxor.currentpoint()
            currentposition = pathelement.pt1
        elseif pathelement isa PathClose
            # same as Line, want to animate the closing line too
            plength = distance(currentposition, firstpoint)
            currentlength += plength
            if currentlength > requiredlength
                # we mustn't draw all of this line, since it overshoots
                overshoot = (currentlength - requiredlength) / plength
                # just draw the overshoot fraction of the line
                drawpath(PathLine(between(currentposition, firstpoint, 1 - overshoot)))
            else
                drawpath(PathLine(firstpoint))
                closepath() # ???
            end
            mostrecentpoint = Luxor.currentpoint()
        end
        if finished == true
            break
        end
    end
    do_action(action)
    return mostrecentpoint
end
drawpath(path::Path, k::Real, act::Symbol;
    steps = 10, # used when approximating Bezier curve segments
    startnewpath = true,
    pathlength = 0.0) = drawpath(path, k;
        steps = steps,
        action = act,
        startnewpath = startnewpath,
        pathlength = pathlength)

"""
    pathsample(path::Path, spacing;
        steps=10)

Return a new Path that resamples the `path` such that each
line and curve of the original path is divided into sections
that are approximately `spacing` units long.

The `steps` parameter is used when approximating the length
of any curve (Bezier) sections. For measurement purposes,
each Bezier curve is divided in `steps` straight lines; the
error will be smaller for flatter curves and larger for more
curvy ones.
"""
function pathsample(path::Path, spacing;
    steps = 10)
    isapprox(spacing, 0.0) && throw(error("pathsample(): a spacing of $(spacing) is too close to zero"))
    newpath = PathElement[]
    currentpoint = O
    firstpoint = currentpoint
    for pathelement in path
        if pathelement isa PathMove # pt1
            push!(newpath, pathelement)
            firstpoint = pathelement.pt1
            currentpoint = pathelement.pt1
        elseif pathelement isa PathCurve # pt1 pt2 pt3
            bps = BezierPathSegment(currentpoint,
                pathelement.pt1,
                pathelement.pt2,
                pathelement.pt3)
            plength = Luxor.get_bezier_length(bps, steps = steps)
            _step = spacing / plength
            for i in range(0.0, 1.0 - _step, step = _step)
                bezsegment = trimbezier(bps, i, i + _step)
                push!(newpath, PathCurve(bezsegment.cp1, bezsegment.cp2, bezsegment.p2))
            end
            currentpoint = pathelement.pt3
        elseif pathelement isa PathLine  # pt1
            plength = distance(currentpoint, pathelement.pt1)
            _step = spacing / plength
            for i in range(0.0, 1.0, step = _step)
                push!(newpath, PathLine(between(currentpoint, pathelement.pt1, i)))
            end
            currentpoint = pathelement.pt1
        elseif pathelement isa PathClose
            # I think Close is just drawing to the point established by previous Move...
            plength = distance(currentpoint, firstpoint)
            if !iszero(plength)
                _step = spacing / plength
                for i in range(0.0, 1.0, step = _step)
                    push!(newpath, PathLine(between(currentpoint, firstpoint, i)))
                end
            end
            push!(newpath, PathLine(firstpoint))
        end
    end
    return Path(newpath)
end

#!/usr/bin/env julia

using Luxor, Random, Colors

Random.seed!(42)

using Test

function test_arc_two_points(fname)
    # paper size C
    Drawing("C", fname)
    origin()
    background(Colors.RGB(1, 1, 1))
    sethue("magenta")
    setopacity(0.6)
    setline(2)
    tiles = Tiler(1200, 1200, 8, 8, margin=20)
    for (pos, n) in tiles
        _, pt2, pt3 = ngon(pos, rand(10:tiles.tilewidth/2), 3, rand(0:pi/12:2pi), vertices = true)
        if n % 4 == 0
            pt3 *= 1.1 # test for points not on arc
        end
        randomhue()
        setdash("solid")
        if n % 2 == 0
            sethue("blue")
            arc2r(pos, pt2, pt3, :stroke)
        else
            sethue("cyan")
            carc2r(pos, pt2, pt3, :stroke)
        end
        sethue("magenta")
        arrow(pos, pt2)
        circle(pos, 2, :fill)
        circle(pt2, 3, :fill)
        # the point that may not be on the arc:
        sethue("grey30")
        setdash("dash")
        line(pos, pt3, :stroke)
        circle(pt3, 4, :fill)
    end
    @test finish() == true
end

fname = "arc-twopoints.pdf"
test_arc_two_points(fname)
println("...finished test: output in $(fname)")

export  Turtle,
        Forward,
        Turn,
        Pendown,
        Penup,
        Circle,
        Orientation,
        Rectangle,
        Push,
        Pop,
        Message,
        HueShift,
        Randomize_saturation,
        Pencolor,
        Penwidth,
        Pen_opacity_random,
        Reposition,
        Towards

"""
    Turtle()
    Turtle(O)
    Turtle(0, 0)
    Turtle(O, pendown=true, orientation=0, pencolor=(1.0, 0.25, 0.25))

Create a Turtle. You can command a turtle to move and draw "turtle graphics".

The commands (unusually for Julia) start with a capital letter, and angles are specified in degrees.

Basic commands are `Forward()`, `Turn()`, `Pendown()`, `Penup()`, `Pencolor()`,
`Penwidth()`, `Circle()`, `Orientation()`, `Rectangle()`, and `Reposition()`.

Others include `Push()`, `Pop()`, `Message()`, `HueShift()`, `Randomize_saturation()`,
`Reposition()`, and `Pen_opacity_random()`.
"""
mutable struct Turtle
    xpos::Union{Real, Int}
    ypos::Union{Real, Int}
    pendown::Bool
    orientation::Float64 # stored in radians but set in degrees
    pencolor::NTuple{3, Float64} # it's an RGB turtle
    function Turtle(xpos::Union{Real, Int}, ypos::Union{Real, Int},
                    pendown::Bool, orientation, pencolor=(0.0, 0.0, 0.0))
        new(xpos, ypos, pendown, orientation, pencolor)
    end
end

Turtle(x::Float64, y::Float64) = Turtle(x, y, true, 0, (0, 0, 0))
Turtle(pos::Point=O) = Turtle(pos.x, pos.y, true, 0, (0, 0, 0))
Turtle(pos::Point, pendown::Bool) = Turtle(pos.x, pos.y, pendown, 0, (0, 0, 0))
Turtle(pos::Point, pendown::Bool, orientation::Real) = Turtle(pos.x, pos.y, pendown, orientation, (0, 0, 0))
Turtle(pos::Point, pendown::Bool, orientation::Real, col::NTuple{3, Number}) = Turtle(pos.x, pos.y, pendown, orientation, col)
Turtle(pos::Point, pendown::Bool, orientation::Real, r, g, b) = Turtle(pos.x, pos.y, pendown, orientation, (r, g, b))

function Turtle(pos::Point, col::Colorant)
    r, g, b = getfield.(convert(RGB, col), 1:3)
    Turtle(pos.x, pos.y, true, 0, (r, g, b))
end 

function Turtle(col::Colorant)
    r, g, b = getfield.(convert(RGB, col), 1:3)
    Turtle(0.0, 0.0, true, 0, (r, g, b))
end 

Base.broadcastable(t::Turtle) = Ref(t)

# a stack to hold pushed/popped turtle positions and orientations
const _turtle_stack = Vector{Vector{Float64}}()

# users can define prolog and epilog functions to monitor turtle's progress
function _prolog(t::Turtle)
    if isdefined(Main, :turtleprolog)
        Main.turtleprolog(t)
    end 
end

function _epilog(t::Turtle)
    if isdefined(Main, :turtleepilog)
        Main.turtleepilog(t)
    end 
end

"""
    Forward(t::Turtle, d=1)

Move the turtle forward by `d` units. The stored position is updated.
"""
function Forward(t::Turtle, d=1)
    _prolog(t)
    oldx, oldy = t.xpos, t.ypos
    t.xpos += (d * cos(t.orientation))
    t.ypos += (d * sin(t.orientation))
    if t.pendown
        gsave()
        sethue(t.pencolor...)
        line(Point(oldx, oldy), Point(t.xpos, t.ypos), :stroke)
        grestore()
    end
    _epilog(t)
end

"""
    Turn(t::Turtle, r=5.0)

Increase the turtle's rotation by `r` degrees. See also `Orientation`.
"""
function Turn(t::Turtle, r=5.0)
    _prolog(t)
    t.orientation = mod2pi(t.orientation + deg2rad(r))
    _epilog(t)
end

"""
    Orientation(t::Turtle, r=0.0)

Set the turtle's orientation to `r` degrees. See also `Turn` and `Towards`.
"""
function Orientation(t::Turtle, r=0.0)
    _prolog(t)
    t.orientation = mod2pi(deg2rad(r))
    _epilog(t)
end

"""
    Towards(t::Turtle, pos::Point)

Rotate the turtle to face towards a given point.
"""
function Towards(t::Turtle, pos::Point)
    _prolog(t)
    x, y = pos

    dx = x - t.xpos
    dy = y - t.ypos

    t.orientation = atan(dy, dx)
    _epilog(t)
end

"""
    Pendown(t::Turtle)

Put that pen down and start drawing.
"""
function Pendown(t::Turtle)
    _prolog(t)
    t.pendown = true
    _epilog(t)
end

"""
    Penup(t::Turtle)

Pick that pen up and stop drawing.
"""
function Penup(t::Turtle)
    _prolog(t)
    t.pendown = false
    _epilog(t)
end

"""
    Circle(t::Turtle, radius=1.0)

Draw a filled circle centered at the current position with the given radius.
"""
function Circle(t::Turtle, radius=1.0)
    _prolog(t)
    gsave()
    sethue(t.pencolor...)
    if t.pendown
        circle(t.xpos, t.ypos, radius, :fill)
    end 
    grestore()
    _epilog(t)
end

"""
    Rectangle(t::Turtle, width=10.0, height=10.0)

Draw a filled rectangle centered at the current position with the given radius.
"""
function Rectangle(t::Turtle, width=10.0, height=10.0)
    _prolog(t)
    gsave()
    sethue(t.pencolor...)
    if t.pendown
        rect(t.xpos-width/2, t.ypos-height/2, width, height, :fill)
    end 
    grestore()
    _epilog(t)
end

"""
    Push(t::Turtle)

Save the turtle's position and orientation on the stack. 

Use `Pop()` to restore this position and orientation from the top value on the
stack, discarding the current position and orientation.

Turtles can be sociable creatures; there's just one stack, and it's shared by
all turtles, So it's possible for one turtle to pop the stack values that were
`pushed` by another turtle.
"""
function Push(t::Turtle)
    _prolog(t)
    # save xpos, ypos, turn in a queue
    global _turtle_stack
    push!(_turtle_stack, [t.xpos, t.ypos, t.orientation])
    _epilog(t)
end

"""
    Pop(t::Turtle)

Get the position and orientation off the stack, as previously saved with
`Push()`, and set the turtle to those values, discarding the current position
and orientation.

Turtles can be sociable creatures; there's just one stack, and it's shared by
all turtles, So it's possible for one turtle to pop the stack values that were
`pushed` by another turtle. 
"""
function Pop(t::Turtle)
    _prolog(t)
    # restore xpos, ypos, turn from queue
    global _turtle_stack
    if isempty(_turtle_stack)
        @info("turtle stack was already empty")
        t.xpos, t.ypos, t.orientation = 0.0, 0.0, 0.0
    else
        t.xpos, t.ypos, t.orientation = pop!(_turtle_stack)
    end
    _epilog(t)
end

"""
    Message(t::Turtle, txt)

Write some text at the current position.
"""
function Message(t::Turtle, txt)
    _prolog(t)
    gsave()
    sethue(t.pencolor...)
    if t.pendown
        text(txt, t.xpos, t.ypos)
    end 
    grestore()
    _epilog(t)
end

"""
    HueShift(t::Turtle, inc=1.0)

Shift the Hue of the turtle's pen by `inc`. Hue values range between 0 and 360.

If the turtle's `Pencolor` was "black" to start with, the saturation and
brightness will be 0, so changing just the hue won't make a color that's easily
distinguishable from black. The brightness and saturation of the new color will still be
0.
"""
function HueShift(t::Turtle, inc=1.0)
    _prolog(t)
    r, g, b = t.pencolor
    hsv = convert(Colors.HSV, Colors.RGB(r, g, b))
    newhsv = (mod(hsv.h + inc, 360), hsv.s, hsv.v)
    newrgb = convert(Colors.RGB, Colors.HSV(newhsv[1], newhsv[2], newhsv[3]))
    sethue(newrgb)
    t.pencolor = (newrgb.r, newrgb.g, newrgb.b)
    _epilog(t)
end

"""
    Randomize_saturation(t::Turtle)

Randomize the saturation of the turtle's pen color.
"""
function Randomize_saturation(t::Turtle)
    _prolog(t)
    r, g, b = t.pencolor
    hsv = convert(Colors.HSV, Colors.RGB(r, g, b))
    newhsv = (hsv.h, rand(0.5:0.05:1.0), hsv.v)
    newrgb= convert(Colors.RGB, Colors.HSV(newhsv[1], newhsv[2], newhsv[3]))
    sethue(newrgb)
    t.pencolor = (newrgb.r, newrgb.g, newrgb.b)
    _epilog(t)
end

"""
    Pencolor(t::Turtle, r, g, b)

Set the Red, Green, and Blue colors of the turtle.
"""
function Pencolor(t::Turtle, r, g, b)
    _prolog(t)
    sethue(r, g, b)
    t.pencolor = (r, g, b)
    _epilog(t)
end

function Pencolor(t::Turtle, col::Colors.Colorant)
    _prolog(t)
    temp = convert(RGBA, col)
    Pencolor(t::Turtle, temp.r, temp.g, temp.b)
    _epilog(t)
end

function Pencolor(t::Turtle, col::AbstractString)
    _prolog(t)
    temp = parse(RGBA, col)
    Pencolor(t::Turtle, temp.r, temp.g, temp.b)
    _epilog(t)
end

Pencolor(t::Turtle, col::NTuple{3, Number}) = Pencolor(t, col...)

"""
    Reposition(t::Turtle, pos::Point)
    Reposition(t::Turtle, x, y)

Reposition: pick the turtle up and place it at another position.
"""
function Reposition(t::Turtle, x, y)
    _prolog(t)
    t.xpos = x
    t.ypos = y
    _epilog(t)
end

Reposition(t::Turtle, pos::Point) = Reposition(t, pos.x, pos.y)

"""
    Penwidth(t::Turtle, w)

Set the width of the line drawn.
"""
Penwidth(t::Turtle, w) = setline(w)

"""
    Pen_opacity_random(t::Turtle)

Change the opacity of the pen to some value at random.
"""
Pen_opacity_random(t::Turtle) = setopacity(rand())

# end

using Luxor
using Test
using Random

Random.seed!(42)

e1 = PathLine(Point(100, 45))
e2 = PathMove(Point(0, 5))
e3 = PathClose()
e4 = PathCurve(Point(0, 45), Point(50, 10), Point(100, -15))

function path_test_1(fname)
    Drawing(500, 500, fname)
    background("grey30")
    origin()
    fontsize(40)
    sethue("gold")

    p = Path([e1, e2, e3, e4])
    drawpath(p, action=:stroke)

    pts = star(O, 200, 6, 0.5, vertices=true)
    p = Path(pts)
    drawpath(p, action=:stroke)

    textpath("hello", O, :stroke)
    p = storepath()
    drawpath(p, action=:stroke)

    textpath("hello", O + (0, 100), action=:stroke)
    p = storepath()
    drawpath(p, :stroke)

    textpath("hello", O + (0, 150), action=:fill)
    p = storepath()
    drawpath(p, action=:fill)

    sethue("cyan")
    scale(0.9)
    drawpath(polytopath(pts), action=:stroke)

    sethue("magenta")
    scale(0.8)
    drawpath(polytopath(pts), :stroke)

    bp = BezierPath([BezierPathSegment(
        rand(BoundingBox() ),
        rand(BoundingBox() ),
        rand(BoundingBox() ),
        rand(BoundingBox() ),
    ) for i in 1:10])

    sethue("white")
    setlinejoin("round")
    setline(15)
    drawbezierpath(bp, :stroke)

    setline(5)
    sethue("black")
    drawpath(bezierpathtopath(bp), :stroke)

    @test finish() == true
    println("...finished test: output in $(fname)")
end

function path_test(path)
    # path info
    @show size(path)
    @test size(path) == 12
    @test length(path) == 12
    @test typeof(path[1]) == PathMove
    @test typeof(path[end - 1]) == PathClose
    @test typeof(path[end]) == PathMove
    @test findfirst(pe -> pe isa PathClose, path) == 5
    @test findfirst(pe -> pe isa PathCurve, path) == 7
    @test findfirst(pe -> pe isa PathMove, path) == 1
    @test findfirst(pe -> pe isa PathLine, path) == 2

    # BoundingBox of path
    bbox = BoundingBox(path)
    @test boxwidth(bbox) == 300.0
    @test boxheight(bbox) == 300

    # length of path
    @test isapprox(pathlength(path), 2141, atol = 1)
    @test isapprox(pathlength(path, steps = 50), 2142.57, atol = 0.1)
    @test isapprox(pathlength(path, steps = 500), 2142.611, atol = 0.1)

    # resample path
    @test 210 < length(pathsample(path, 10)) < 225
    @test 28 < length(pathsample(path, 100)) < 32
end

function path_test_2(fname)
    Drawing(800, 800, fname)
    background("black")
    origin()

    newpath()
    box(O, 300, 300, :path)
    move(polar(150, 0))
    circle(O, 150, :path)

    path = storepath()
    #=
    Path([
     PathMove(Point(-150.0, 150.0)),
     PathLine(Point(-150.0, -150.0)),
     PathLine(Point(150.0, -150.0)),
     PathLine(Point(150.0, 150.0)),
     PathClose(),
     PathMove(Point(-150.0, 150.0)),
     PathLine(Point(150.0, 0.0)),
     PathCurve(Point(150.0, 82.84375), Point(82.84375, 150.0), Point(0.0, 150.0)),
     PathCurve(Point(-82.84375, 150.0), Point(-150.0, 82.84375), Point(-150.0, 0.0)),
     PathCurve(Point(-150.0, -82.84375), Point(-82.84375, -150.0), Point(0.0, -150.0)),
     PathCurve(Point(82.84375, -150.0), Point(150.0, -82.84375), Point(150.0, 0.0))
    ])
    =#

    path_test(path)

    sethue("gold")
    setline(2)
    drawpath(path, :stroke)

    setline(1)
    @layer begin
        for k in 0.0:0.05:1.0
            sethue("cyan")
            pt = drawpath(path, k, :stroke)
            scale(1.045)
            sethue("magenta")
            circle(pt, 5, :fill)
        end
    end

    @test finish() == true

end

path_test_1("path-test-1.png")
path_test_2("path-test-2.png")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function draweasingfunction(f, pos, w, h)
    @layer begin
        translate(pos)
        setline(0.5)
        box(O, w, h, :stroke)
        for i in 0:0.005:1.0
            circle(Point(-w/2, h/2) + Point(w * i, -f(i, 0, h, 1)), 1, :fill)
        end
        text(string(f), Point(w/2 - 20, h/2 - 20), halign=:right)
    end
end

function testeasingfunctions(fname)
    Drawing(1200, 1200, fname)
    background("white")
    origin()

    t = Tiler(1200, 1200, 5, 5)
    margin=5

    for (pos, n) in t
        sethue("black")
        n > length(Luxor.easingfunctions) && continue
        draweasingfunction(Luxor.easingfunctions[n], pos, t.tilewidth-margin, t.tileheight-margin)
    end

    @test finish() == true
end

fname = "easingfunctions.pdf"
testeasingfunctions(fname)
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Test, Random

Random.seed!(42)

function barfunc1(values, i, lowpos, highpos, barwidth, scaledvalue)
    extremes=extrema(values)
    barnumber=i
    bartotal=sum(values)
    @layer begin
        sethue(rescale(values[i], 0, extremes[2], 0, 1), rand(), rand())
        circle(lowpos, 2, :fill)
        box(Point(lowpos.x - 5, lowpos.y), Point(highpos.x + 5, highpos.y), :fill)
        fontsize(6)
        sethue("black")
        textbox([string(round(values[i], digits=2))], Point(lowpos.x, 100), leading=5, alignment=:center)
        sethue("gray80")
        setline(0.5)
        setdash("dot")
        line(lowpos, Point(lowpos.x, 100), :stroke)
    end
end

function barfunc2(values, i, lowpos, highpos, barwidth, scaledvalue)
    extremes=extrema(values)
    barnumber=i
    bartotal=sum(values)
    @layer begin
        sethue("red")
        randomhue()
        setline(4)
        setlinecap("round")
        line(lowpos, highpos, :stroke)
        circle(highpos, 2, :fill)

        arrow(highpos - (barwidth/2.0, 0), highpos + (barwidth/2.0, 0))
    end
end

emptylabelfunction(args...) = nothing

function mylabelfunction(values, i, lowpos, highpos, scaledvalue)
    t = string(values[i])
    textoffset = textextents(t)[4]
    @layer begin
        translate(highpos)
        rotate(-π/2)
        text(t, O, halign=:left, valign=:middle)
    end
end

function test_barchart(fname)
    pagewidth, pageheight = 1200, 1400
    Drawing(pagewidth, pageheight, fname)
    background("antiquewhite")
    fontsize(10)
    sethue("black")
    origin()
    tiles = Tiler(pagewidth, pageheight, 3, 2, margin=35)
    for (pos, n) in tiles
        @layer begin
            if n == 1
                v = randn(15)
                text("line bar function, grey label function",pos)
                barchart(v,
                    boundingbox=BoundingBox(box(tiles, n)),
                    barfunction = (values, i, lowpos, highpos, barwidth, scaledvalue) ->  begin
                      @layer begin
                        setline(rescale(values[i], extrema(values)..., 1, 50))
                        setgray(rand())
                        line(lowpos, highpos, :stroke)
                      end
                    end,
                    labelfunction = (values, i, lowpos, highpos, barwidth, scaledvalue) ->  begin
                      @layer begin
                        text(string(i), highpos, halign=:center)
                      end
                    end,
                    border = true)
                box(tiles, n, :stroke)
            elseif n == 2
                # no labels
                v = rand(1:10, 20)
                barchart(v,
                    boundingbox=BoundingBox(box(tiles, n)) * 0.8,
                    labelfunction=emptylabelfunction)
            elseif n == 3
                # a custom label function
                v = rand(20)
                barchart(v,
                    boundingbox=BoundingBox(box(pos, tiles.tilewidth, tiles.tileheight, vertices=true)) * 0.8,
                    labelfunction=mylabelfunction)
            elseif n == 4
                # a custom barfunction
                v = rand(5:0.1:10, 20)
                barchart(v,
                    boundingbox=BoundingBox(box(pos, tiles.tilewidth, tiles.tileheight, vertices=true)) * 0.8,
                    barfunction = barfunc1)
            elseif n == 5
                # another custom barfunction
                v = rand(-20:2:20, 30)
                barchart(v,
                    boundingbox=BoundingBox(box(pos, tiles.tilewidth, tiles.tileheight, vertices=true)) * 0.8,
                    barfunction=barfunc2)
            else
                v = randn(15)
                barchart(v,
                    boundingbox=BoundingBox(box(pos, tiles.tilewidth, tiles.tileheight, :none)) * 0.8,
                    barfunction=barfunc2)
            end
        end
    end
    @test finish() == true
    println("...finished barstest, saved in $(fname)")
end
fname = "bars-test.png"
test_barchart(fname)

using Luxor, Test

function rotate_points_test(fname)
    Drawing(300, 300, fname)
    origin()
    background("black")
    pts = ngon(O, 120, 5, vertices=true)

    sethue("red")
    circle.(pts, 10, :stroke)

    # rotate each point by 2π
    pts1 = rotatepoint.(pts, O, 2π)

    sethue("blue")
    circle.(pts1, 20, :stroke)

    # they should be equal
    for pr in zip(pts, pts1)
        @test isapprox(first(pr), last(pr), atol=1.0e-12)
    end

    # now rotate each point by π
    pts2 = rotatepoint.(pts, O, π)
    sethue("green")
    circle.(pts2, 30, :stroke)

    # they should not be equal
    for pr in zip(pts, pts2)
        @test !isapprox(first(pr), last(pr))
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

function tick_test(fname)

    Drawing(400, 400, fname)
    origin()
    background("antiquewhite")
    sethue("red")
    majorticks, minorticks = tickline(O - (100, 0), O + (100, 0), minor=1)

    @test length(majorticks) == 3
    @test length(minorticks) == 5

    @test majorticks[1] == Point(-100, 0)
    @test majorticks[2] == Point(0, 0)
    @test majorticks[3] == Point(100, 0)

    # all minor ticks should be 5.0 apart
    @test all(pt -> isapprox(pt, Point(50.0, 0.0)), diff(minorticks))

    translate(0, 100)

    majorticks, minorticks = tickline(O - (150, 0), O + (150, 0), major=10, minor=4, vertices=true)
    sethue("purple")
    setline(0.5)
    rule.(majorticks, π/2, boundingbox=BoundingBox(O - (200, 10), O + (200, 10)))
    rule.(minorticks, π/2, boundingbox=BoundingBox(O - (200, 5), O + (200, 5)))

    @test length(majorticks) == 12
    @test length(minorticks) == 56


    translate(0, 50)

    majorticks, minorticks = tickline(O - (150, 0), O + (150, 0), log = true, major=10, minor=4, vertices=true)

    sethue("black")
    setline(0.5)
    rule.(majorticks, -π/3, boundingbox=BoundingBox(O - (200, 10), O + (200, 10)))
    rule.(minorticks, -π/3, boundingbox=BoundingBox(O - (200, 5), O + (200, 5)))

    @test length(majorticks) == 12
    @test length(minorticks) == 56

    @test finish() == true
    println("...finished test: output in $(fname)")
end

rotate_points_test("rotatepoints.png")
tick_test("ticktest.png")

# algorithms from https://www.redblobgames.com/grids/hexagons/
# first adapted by GiovineItalia/Hexagons.jl
# then further tweaked for Julia v1 compatibility, Luxor use, etc.
"""
    Hexagon

To create a hexagon, use one of the constructor types:

- `HexagonOffsetOddR q r origin w h`
- `HexagonOffsetEvenR q r origin w h`
- `HexagonAxial q r origin w h`
- `HexagonCubic q r s origin w h`

where `q` and `r` (and `s`) are the grid axes. So if `(q, r)` = (0, 0)`,
this is the hexagon situated at the '0th' column and '0th' row of an imaginary
grid. The two types of `Offset...R` constructor determine whether odd or even
numbered 'rows' of the grid appear shifted to the right.

This code draws the hexagon at column 0, row 0 of a hexagonal grid,
radius 100, and also draws the matching polygon and circle.

```julia
q = 0
h = HexagonOffsetOddR(q, 0, 100)
poly(hextile(h), :fill) # polygon of all 6 points

ngon(O, 100, 6, π / 2, :stroke) # equivalent construction

circle(O, 100, :stroke) # a circle circumscribed

q = 1
h = HexagonOffsetOddR(q, 0, 100)
# draw the polygon in the next column
poly(hextile(h), :fill)
```

This code draws a 5 by 5 hexagonal grid: 

```julia
@draw begin
    for q in -2:2 # horizontal
        for r in -2:2 # vertical
            pgon = hextile(HexagonOffsetOddR(q, r, 40))
            poly(pgon, :stroke, close = true)
        end
    end
end
```

Functions:

- `hextile(hex::Hexagon)` - return the six vertices
- `hexcenter(hex::Hexagon)` - return  the center
- `hexring(n::Int, hex::Hexagon)` - return array of hexagons surrounding hex
- `hexspiral(hex::Hexagon, n)` - return array of hexagons in spiral
- `hexneighbors(hex::Hexagon)` - return array of neighbors of hexagon
"""
abstract type Hexagon end

"""
    HexagonOffsetOddR

odd rows shifted right
"""
struct HexagonOffsetOddR <: Hexagon
    q::Int64
    r::Int64
    origin::Point
    width::Float64
    height::Float64
end

"""
    HexagonOffsetEvenR

even rows shifted right
"""
struct HexagonOffsetEvenR <: Hexagon
    q::Int64
    r::Int64
    origin::Point
    width::Float64
    height::Float64
end

"""
    HexagonAxial

Two axes

- q:: first index

- r:: second index

- origin::Point

- width:: of tile

- height:: of tile
"""
struct HexagonAxial <: Hexagon
    q::Int64
    r::Int64
    origin::Point
    width::Float64
    height::Float64
end

"""
    HexagonCubic

Three axes

- q:: first index

- r:: second index

- s:: third index

- origin::Point

- width:: of tile

- height:: of tile
"""
struct HexagonCubic <: Hexagon
    q::Int64
    r::Int64
    s::Int64
    origin::Point
    width::Float64
    height::Float64
end

HexagonAxial(q, r) = HexagonAxial(q, r, Point(0, 0), 10.0, 10.0)
HexagonAxial(q, r, o::Point) = HexagonAxial(q, r, o, 10.0, 10.0)
HexagonAxial(q, r, w) = HexagonAxial(q, r, Point(0, 0), w, w)
HexagonAxial(q, r, o::Point, w) = HexagonAxial(q, r, o, w, w)
HexagonAxial(q, r, w, h) = HexagonAxial(q, r, Point(0, 0), w, h)

HexagonCubic(x, y, z) = HexagonCubic(x, y, z, Point(0, 0), 10.0, 10.0)
HexagonCubic(x, y, z, o::Point) = HexagonCubic(x, y, z, o, 10.0, 10.0)
HexagonCubic(x, y, z, w) = HexagonCubic(x, y, z, Point(0, 0), w, w)
HexagonCubic(x, y, z, o::Point, w) = HexagonCubic(x, y, z, o, w, w)
HexagonCubic(x, y, z, w, h) = HexagonCubic(x, y, z, Point(0, 0), w, h)

HexagonOffsetOddR(q, r) = HexagonOffsetOddR(q, r, Point(0, 0), 10.0, 10.0)
HexagonOffsetOddR(q, r, o::Point) = HexagonOffsetOddR(q, r, o::Point, 10.0, 10.0)
HexagonOffsetOddR(q, r, w) = HexagonOffsetOddR(q, r, Point(0, 0), w, w)
HexagonOffsetOddR(q, r, o::Point, w) = HexagonOffsetOddR(q, r, o::Point, w, w)
HexagonOffsetOddR(q, r, w, h) = HexagonOffsetOddR(q, r, Point(0, 0), w, h)

HexagonOffsetEvenR(q, r) = HexagonOffsetEvenR(q, r, Point(0, 0), 10.0, 10.0)
HexagonOffsetEvenR(q, r, o::Point) = HexagonOffsetEvenR(q, r, o::Point, 10.0, 10.0)
HexagonOffsetEvenR(q, r, w) = HexagonOffsetEvenR(q, r, Point(0, 0), w, w)
HexagonOffsetEvenR(q, r, o::Point, w) = HexagonOffsetEvenR(q, r, o::Point, w, w)
HexagonOffsetEvenR(q, r, w, h) = HexagonOffsetEvenR(q, r, Point(0, 0), w, h)

function Base.convert(::Type{HexagonAxial}, hex::HexagonCubic)
    HexagonAxial(hex.q, hex.s, hex.origin, hex.width, hex.height)
end

function Base.convert(::Type{HexagonAxial}, hex::HexagonOffsetOddR)
    convert(HexagonAxial, convert(HexagonCubic, hex))
end

function Base.convert(::Type{HexagonAxial}, hex::HexagonOffsetEvenR)
    convert(HexagonAxial, convert(HexagonCubic, hex))
end

function Base.convert(::Type{HexagonCubic}, hex::HexagonAxial)
    HexagonCubic(hex.q, -hex.q - hex.r, hex.r, hex.origin, hex.width, hex.height)
end

function Base.convert(::Type{HexagonCubic}, hex::HexagonOffsetOddR)
    q = hex.q - (hex.r >> 1)
    s = hex.r
    r = -q - s
    HexagonCubic(q, r, s, hex.origin, hex.width, hex.height)
end

function Base.convert(::Type{HexagonCubic}, hex::HexagonOffsetEvenR)
    q = hex.q - (hex.r >> 1) - Int(isodd(hex.r)) # ?
    s = hex.r
    r = -q - s
    HexagonCubic(q, r, s, hex.origin, hex.width, hex.height)
end

function Base.convert(::Type{HexagonOffsetOddR}, hex::HexagonCubic)
    q = hex.q + (hex.s >> 1)
    r = hex.s
    HexagonOffsetOddR(q, r, hex.origin, hex.width, hex.height)
end

function Base.convert(::Type{HexagonOffsetOddR}, hex::HexagonAxial)
    convert(HexagonOffsetOddR, convert(HexagonCubic, hex))
end

function Base.convert(::Type{HexagonOffsetEvenR}, hex::HexagonCubic)
    q = hex.q + (hex.s >> 1) + Int(isodd(hex.s))
    r = hex.s
    HexagonOffsetEvenR(q, r, hex.origin, hex.width, hex.height)
end

function Base.convert(::Type{HexagonOffsetEvenR}, hex::HexagonAxial)
    convert(HexagonOffsetEvenR, convert(HexagonCubic, hex))
end

struct HexagonNeighborIterator
    hex::HexagonCubic
end

const CUBIC_HEX_NEIGHBOR_OFFSETS = [
    1 -1 0
    1 0 -1
    0 1 -1
    -1 1 0
    -1 0 1
    0 -1 1
]

"""
    hexneighbors(hex::Hexagon)

Return the neighbors of `hex`.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).

## Example

```julia
julia> h = HexagonOffsetEvenR(0, 0, 70.0);

julia> hexneighbors(h)
HexagonNeighborIterator(HexagonCubic(0, 0, 0, Point(0.0, 0.0), 70.0, 70.0))

julia> collect(hexneighbors(h))
6-element Vector{Any}:
 HexagonCubic(1, -1, 0, Point(0.0, 0.0), 70.0, 70.0)
 HexagonCubic(1, 0, -1, Point(0.0, 0.0), 70.0, 70.0)
 HexagonCubic(0, 1, -1, Point(0.0, 0.0), 70.0, 70.0)
 HexagonCubic(-1, 1, 0, Point(0.0, 0.0), 70.0, 70.0)
 HexagonCubic(-1, 0, 1, Point(0.0, 0.0), 70.0, 70.0)
 HexagonCubic(0, -1, 1, Point(0.0, 0.0), 70.0, 70.0)
```
"""
hexneighbors(hex::Hexagon) = HexagonNeighborIterator(convert(HexagonCubic, hex))

Base.length(::HexagonNeighborIterator) = 6

function Base.iterate(it::HexagonNeighborIterator, state = 1)
    state > 6 && return nothing
    dq = CUBIC_HEX_NEIGHBOR_OFFSETS[state, 1]
    dr = CUBIC_HEX_NEIGHBOR_OFFSETS[state, 2]
    ds = CUBIC_HEX_NEIGHBOR_OFFSETS[state, 3]
    hexneighbor = HexagonCubic(it.hex.q + dq, it.hex.r + dr, it.hex.s + ds, it.hex.origin, it.hex.width, it.hex.height)
    return (hexneighbor, state + 1)
end

struct HexagonDiagonalIterator
    hex::HexagonCubic
end

const CUBIC_HEX_DIAGONAL_OFFSETS = [
    +2 -1 -1
    +1 +1 -2
    -1 +2 -1
    -2 +1 +1
    -1 -1 +2
    +1 -2 +1
]

"""
    hexdiagonals(hex::Hexagon)

Return the six hexagons that lie on the diagonals to `hex`.


For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).

"""
hexdiagonals(hex::Hexagon) = HexagonDiagonalIterator(convert(HexagonCubic, hex))

Base.length(::HexagonDiagonalIterator) = 6

function Base.iterate(it::HexagonDiagonalIterator, state = 1)
    state > 6 && return nothing
    dq = CUBIC_HEX_DIAGONAL_OFFSETS[state, 1]
    dr = CUBIC_HEX_DIAGONAL_OFFSETS[state, 2]
    ds = CUBIC_HEX_DIAGONAL_OFFSETS[state, 3]
    diagonal = HexagonCubic(it.hex.q + dq, it.hex.r + dr, it.hex.s + ds, it.hex.origin, it.hex.width, it.hex.height)
    return (diagonal, state + 1)
end

struct HexagonVertexIterator
    x_center::Float64
    y_center::Float64
    xsize::Float64
    ysize::Float64

    function HexagonVertexIterator(x, y, xsize = 10.0, ysize = 10.0)
        new(Float64(x),
            Float64(y),
            Float64(xsize),
            Float64(ysize))
    end

    function HexagonVertexIterator(hex::Hexagon,
        xsize = hex.width,
        ysize = hex.height,
        xoff = hex.origin.x,
        yoff = hex.origin.y)
        c = hexcenter(hex)
        new(Float64(c[1]),
            Float64(c[2]),
            xsize,
            ysize)
    end
end

"""
    hextile(hex::Hexagon)

Calculate the six vertices of the hexagon `hex` and return them in an array of Points.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function hextile(hex::Hexagon)
    c = hexcenter(hex)
    pgon = Point[]
    for vtx in HexagonVertexIterator(c.x, c.y, hex.width, hex.height)
        push!(pgon, Point(vtx[1], vtx[2]))
    end
    return pgon
end

Base.length(::HexagonVertexIterator) = 6

function Base.iterate(it::HexagonVertexIterator, state = 1)
    state > 6 && return nothing
    theta = 2 * pi / 6 * (state - 1 + 0.5)
    x_i = it.x_center + it.xsize * cos(theta)
    y_i = it.y_center + it.ysize * sin(theta)
    return ((x_i, y_i), state + 1)
end

struct HexagonDistanceIterator
    hex::HexagonCubic
    n::Int
end

"""
    hexagons_within(n::Int, hex::Hexagon)

Return all the hexagons within index distance `n` of `hex`. If `n` is 0, only
the `hex` itself is returned. If `n` is 1, `hex` and the six hexagons one index
away are returned. If `n` is 2, 19 hexagons surrounding `hex` are returned.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function hexagons_within(n::Int, hex::Hexagon)
    cubic_hex = convert(HexagonCubic, hex)
    HexagonDistanceIterator(cubic_hex, n)
end

hexagons_within(hex::Hexagon, n::Int) = hexagons_within(n, hex)

Base.length(it::HexagonDistanceIterator) = it.n * (it.n + 1) * 3 + 1

function Base.iterate(it::HexagonDistanceIterator, state = (-it.n, 0))
    q, r = state
    q > it.n && return nothing
    s = -q - r
    hex = HexagonCubic(q, r, s, it.hex.origin, it.hex.width, it.hex.height)
    r += 1
    if r > min(it.n, it.n - q)
        q += 1
        r = max(-it.n, -it.n - q)
    end
    return hex, (q, r)
end

function Base.collect(it::HexagonDistanceIterator)
    collect(HexagonCubic, it)
end

struct HexagonRingIterator
    hex::HexagonCubic
    n::Int
end

"""
    hexring(n::Int, hex::Hexagon)

Return the ring of hexagons that surround `hex`. If `n` is 1, the hexagons
immediately surrounding `hex` are returned.


For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function hexring(n::Int, hex::Hexagon)
    cubic_hex = convert(HexagonCubic, hex)
    HexagonRingIterator(cubic_hex, n)
end

hexring(hex::Hexagon, n::Int) = hexring(n, hex)

Base.length(it::HexagonRingIterator) = it.n * 6

function Base.iterate(it::HexagonRingIterator, state::(Tuple{Int,HexagonCubic}) = (1, hexneighbor(it.hex, 5, it.n)))
    hex_i, cur_hex = state
    hex_i > length(it) && return nothing
    ring_part = div(hex_i - 1, it.n) + 1
    next_hex = hexneighbor(cur_hex, ring_part)
    cur_hex, (hex_i + 1, next_hex)
end

function Base.collect(it::HexagonRingIterator)
    collect(HexagonCubic, it)
end

"""
    hexspiral(hex, n)

Return an array of hexagons to spiral around a central hexagon forming `n` rings.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function hexspiral(hex, nrings)
    result = Hexagon[]
    ringn = 0
    while ringn < nrings
        ringn += 1
        hexes = collect(hexring(hex, ringn))
        # circshift!(hexes, 1) doesn't work on < v1.7
        # replace with circshift! one day
        push!(hexes, popfirst!(hexes))
        append!(result, hexes)
    end
    return result
end

"""
    distance(h1::Hexagon, h2::Hexagon)

Find distance between hexagons h1 and h2.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function Luxor.distance(a::Hexagon, b::Hexagon)
    hexa = convert(HexagonCubic, a)
    hexb = convert(HexagonCubic, b)
    max(abs(hexa.q - hexb.q),
        abs(hexa.r - hexb.r),
        abs(hexa.s - hexb.s))
end

"""
    hexcenter(hex::Hexagon)

Find the center of the `hex` hexagon. Returns a Point.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function hexcenter(hex::Hexagon)
    xsize = hex.width
    ysize = hex.height
    xoff = hex.origin.x
    yoff = hex.origin.y
    axh = convert(HexagonAxial, hex)
    return Point(xoff + xsize * sqrt(3) * (axh.q + axh.r / 2), yoff + ysize * (3 / 2) * axh.r)
end

function hexneighbor(hex::HexagonCubic, direction::Int, distance::Int = 1)
    dq = CUBIC_HEX_NEIGHBOR_OFFSETS[direction, 1] * distance
    dr = CUBIC_HEX_NEIGHBOR_OFFSETS[direction, 2] * distance
    ds = CUBIC_HEX_NEIGHBOR_OFFSETS[direction, 3] * distance
    HexagonCubic(hex.q + dq, hex.r + dr, hex.s + ds, hex.origin, hex.width, hex.height)
end

"""
    hexcube_linedraw(hexa::Hexagon, hexb::Hexagon)

Find and return the hexagons that lie (mostly) on a straight line between
`hexa` and `hexb`. If you filled/stroked them appropriately, you'd get a
jagged line.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function hexcube_linedraw(a::Hexagon, b::Hexagon)
    hexa = convert(HexagonCubic, a)
    hexb = convert(HexagonCubic, b)
    o = hexa.origin
    w = hexa.width
    h = hexa.height
    N = distance(hexa, hexb)
    dx, dy, dz = hexb.q - hexa.q, hexb.r - hexa.r, hexb.s - hexa.s
    ax, ay, az = hexa.q + 1e-6, hexa.r + 1e-6, hexa.s - 2e-6
    map(i -> hexnearest_cubic(ax + i * dx, ay + i * dy, az + i * dz, o, w, h), 0:(1 / N):1)
end

"""
     hexnearest_cubic(x::Real, y::Real, z::Real, origin, width, height)

Find the nearest hexagon in cubic coordinates, ie as `q`, `r`, `s` integer indices,
given (x, y, z) as Real numbers, with the hexagonal grid centered at `origin`,
and with tiles of `width`/`height`.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function hexnearest_cubic(x::Real, y::Real, z::Real, origin, width, height)
    rx, ry, rz = round(Integer, x), round(Integer, y), round(Integer, z)
    x_diff, y_diff, z_diff = abs(rx - x), abs(ry - y), abs(rz - z)

    if x_diff > y_diff && x_diff > z_diff
        rx = -ry - rz
    elseif y_diff > z_diff
        ry = -rx - rz
    else
        rz = -rx - ry
    end
    HexagonCubic(rx, ry, rz, origin, width, height)
end

"""
    hexcube_round(x, y, origin, width = 10.0, height = 10.0)

Return the hexagon containing the point `x`, `y`, on the hexagonal grid centered at
`origin`, and with tiles of `width`/`height` point in Cartesian space can be
mapped to the index of the hexagon that contains it.

For more information about making hexagons and hexagonal grids, see [Luxor.Hexagon](@ref).
"""
function hexcube_round(x, y, origin = Point(0, 0), width = 10.0, height = 10.0)
    x /= width
    y /= height
    q = sqrt(3) / 3 * x - y / 3
    r = 2 * y / 3
    h = hexnearest_cubic(q, -q - r, r, origin, width, height)
    return h
end

module luxorgraphtools
export CanvasConfig
export PlottingArea
export lit_defaultcolorpalette
export lit_convert_x_imagecoor_to_cartesiancoor
export lit_convert_y_imagecoor_to_cartesiancoor
export lit_convert_xy_imagecoor_to_cartesiancoor
export lit_convert_x_cartesiancoor_to_imagecoor
export lit_convert_y_cartesiancoor_to_imagecoor
export lit_convert_xy_cartesiancoor_to_imagecoor
export lit_convert_cartesianpoint_to_imagepoint_noncenter
export lit_convert_cartesianpoint_to_imagepoint_center
export lit_convert_cartesianpoint_to_imagepoint_noncenter_as_center
export lit_cartesianpoint_noncenter
export lit_cartesianpoint_center
export lit_cartesianpoint_noncenter_as_center
export lit_RotationMatrix2D
export lit_ScaleMatrix2D
export lit_TranslationMatrix2D
export lit_CartTranslationMatrix2D
export lit_ReflectXaxisMatrix2D
export lit_ReflectYaxisMatrix2D
export lit_SetFakeCartesianSystem
export lit_FakeCartesianSystemMatrix2D
export lit_CalcPlottingArea
export lit_CalcInternalPlottingArea
export lit_ConvertInternalPlottingAreaToCartesian
export lit_calc_physical_y_in_graph
export lit_graphfuncplot
export lit_graphseriesplot
export lit_SetInternalPlottingAreaMatrix
export lit_create_graph_xticks
export lit_create_graph_yticks
export lit_create_graph_title
export lit_create_X_axis_title
export lit_create_Y_axis_title
export lit_convert_graph_xvalue_to_image_xcoor
export lit_convert_graph_xvalue_to_cart_xcoor
export lit_convert_graph_yvalue_to_image_ycoor
export lit_convert_graph_yvalue_to_cart_ycoor
export lit_graph_arrow_text_cart
export lit_graph_arrow_text_cart_NE
export lit_graph_arrow_text_cart_SE


using Luxor, Images

struct CanvasConfig
    width::Int64
    height::Int64
end

struct PlottingArea
    # All coordinates below are Image Coordinates
    xtopleft::Float64
    ytopleft::Float64
    xtopright::Float64
    ytopright::Float64
    xbotleft::Float64
    ybotleft::Float64
    xbotright::Float64
    ybotright::Float64
end

lit_defaultcolorpalette = [
    RGB{Float64}(0.0, 0.6056031611752245, 0.9786801175696073),
    RGB{Float64}(0.8888735002725198, 0.43564919034818994, 0.2781229361419438),
    RGB{Float64}(0.2422242978521988, 0.6432750931576305, 0.3044486515341153),
    RGB{Float64}(0.7644401754934356, 0.4441117794687767, 0.8242975359232758),
    RGB{Float64}(0.6755439572114057, 0.5556623322045815, 0.09423433626639477),
    RGB{Float64}(4.821181644776295e-7, 0.6657589812923561, 0.6809969518707945),
    RGB{Float64}(0.930767491919665, 0.3674771896571412, 0.5757699667547829),
    RGB{Float64}(0.7769816661712932, 0.5097431319944513, 0.1464252569555497),
    RGB{Float64}(3.8077343661790943e-7, 0.6642678029460116, 0.5529508754522481),
    RGB{Float64}(0.558464964115081, 0.5934846564332882, 0.11748125233232104),
    RGB{Float64}(5.947623898072685e-7, 0.6608785231434254, 0.7981787608414297),
    RGB{Float64}(0.6096707676128648, 0.49918492100827777, 0.9117812665042642),
    RGB{Float64}(0.3800016049820351, 0.5510532724353506, 0.9665056985227146),
    RGB{Float64}(0.942181647954218, 0.37516423354097583, 0.4518168202944593),
    RGB{Float64}(0.8684020893043971, 0.3959893639954845, 0.7135147524811879),
    RGB{Float64}(0.42314674364630817, 0.6224954944199981, 0.19877060252130468)
]

function lit_convert_x_imagecoor_to_cartesiancoor(canvasconfig::CanvasConfig, x)
    local x_cart
    x_cart = x
    return x_cart
end

function lit_convert_y_imagecoor_to_cartesiancoor(canvasconfig::CanvasConfig, y)
    local y_cart
    y_cart = (canvasconfig.height - 1) - y
    return y_cart
end

function lit_convert_xy_imagecoor_to_cartesiancoor(canvasconfig::CanvasConfig, x, y)
    return (lit_convert_x_imagecoor_to_cartesiancoor(canvasconfig, x),
        lit_convert_y_imagecoor_to_cartesiancoor(canvasconfig, y)
    )
end

function lit_convert_x_cartesiancoor_to_imagecoor(canvasconfig::CanvasConfig, x)
    local x_image
    x_image = x
    return x_image
end

function lit_convert_y_cartesiancoor_to_imagecoor(canvasconfig::CanvasConfig, y)
    local y_image
    y_image = (canvasconfig.height - 1) - y
    return y_image
end

function lit_convert_xy_cartesiancoor_to_imagecoor(canvasconfig::CanvasConfig, x, y)
    return (lit_convert_x_cartesiancoor_to_imagecoor(canvasconfig, x),
        lit_convert_y_cartesiancoor_to_imagecoor(canvasconfig, y)
    )
end

function lit_convert_cartesianpoint_to_imagepoint_noncenter(canvasconfig::CanvasConfig, p)
    return Point(
        lit_convert_xy_cartesiancoor_to_imagecoor(canvasconfig, p[1], p[2])...
    )
end

function lit_convert_cartesianpoint_to_imagepoint_center(canvasconfig::CanvasConfig, p)
    return Point(p[1], -1 * p[2])
end

function lit_convert_cartesianpoint_to_imagepoint_noncenter_as_center(canvasconfig::CanvasConfig, p)
    local xcenter = div(canvasconfig.width, 2)
    local ycenter = div(canvasconfig.height, 2)
    return Point(p[1] + xcenter, -1 * p[2] + ycenter)
end

function lit_cartesianpoint_noncenter(canvasconfig::CanvasConfig, x, y)
    return Point(lit_convert_xy_cartesiancoor_to_imagecoor(canvasconfig, x, y)...)
end

function lit_cartesianpoint_center(canvasconfig, x, y)
    return Point(x, -y)
end

function lit_cartesianpoint_noncenter_as_center(canvasconfig::CanvasConfig, x, y)
    local xcenter = div(canvasconfig.width, 2)
    local ycenter = div(canvasconfig.height, 2)
    return Point(x + xcenter, (-y) + ycenter)
end

function lit_RotationMatrix2D(theta_radian)
    local θ = Float64(theta_radian)
    return [cos(θ) -sin(θ) 0.0
        sin(θ) cos(θ) 0.0
        0.0 0.0 1.0]
end

function lit_ScaleMatrix2D(ScaleX, ScaleY)
    local scalex = Float64(ScaleX)
    local scaley = Float64(ScaleY)
    return [scalex 0.0 0.0
        0.0 scaley 0.0
        0.0 0.0 1.0]
end

function lit_TranslationMatrix2D(TransX, TransY)
    local transx = Float64(TransX)
    local transy = Float64(TransY)
    return [1.0 0.0 transx
        0.0 1.0 transy
        0.0 0.0 1.0]
end

function lit_CartTranslationMatrix2D(TransX, TransY)
    local transx = Float64(TransX)
    local transy = -1.0 * Float64(TransY)
    return [1.0 0.0 transx
        0.0 1.0 transy
        0.0 0.0 1.0]
end

function lit_ReflectXaxisMatrix2D()
    return [1.0 0.0 0.0
        0.0 -1.0 0.0
        0.0 0.0 1.0]
end

function lit_ReflectYaxisMatrix2D()
    return [-1.0 0.0 0.0
        0.0 1.0 0.0
        0.0 0.0 1.0]
end

function lit_SetFakeCartesianSystem(canvasconfig::CanvasConfig)
    local f_matrix = lit_ReflectXaxisMatrix2D()
    local t_matrix = lit_TranslationMatrix2D(0.0, canvasconfig.height - 1)

    local total_matrix = t_matrix * f_matrix
    local cm = juliatocairomatrix(total_matrix)
    setmatrix(cm)
end

function lit_FakeCartesianSystemMatrix2D(canvasconfig::CanvasConfig)
    local f_matrix = lit_ReflectXaxisMatrix2D()
    local t_matrix = lit_TranslationMatrix2D(0.0, canvasconfig.height - 1)

    local total_matrix = t_matrix * f_matrix
    return total_matrix
end

function lit_CalcPlottingArea(canvasconfig::CanvasConfig)
    # All coordinates below are Image Coordinates
    local xtopleft = round(65 / 600 * canvasconfig.width)
    local ytopleft = round(30 / 400 * canvasconfig.height)
    local xtopright = round(585 / 600 * canvasconfig.width)
    local ytopright = round(30 / 400 * canvasconfig.height)
    local xbotleft = round(65 / 600 * canvasconfig.width)
    local ybotleft = round(355 / 400 * canvasconfig.height)
    local xbotright = round(585 / 600 * canvasconfig.width)
    local ybotright = round(355 / 400 * canvasconfig.height)
    return PlottingArea(xtopleft, ytopleft, xtopright, ytopright,
        xbotleft, ybotleft, xbotright, ybotright)
end

function lit_CalcInternalPlottingArea(plottingarea::PlottingArea)
    # All coordinates below are Image Coordinates
    local xtopleft = plottingarea.xtopleft + 1.0
    local ytopleft = plottingarea.ytopleft + 1.0
    local xtopright = plottingarea.xtopright - 1.0
    local ytopright = plottingarea.ytopright + 1.0
    local xbotleft = plottingarea.xbotleft + 1.0
    local ybotleft = plottingarea.ybotleft - 1.0
    local xbotright = plottingarea.xbotright - 1.0
    local ybotright = plottingarea.ybotright - 1.0
    return PlottingArea(xtopleft, ytopleft, xtopright, ytopright,
        xbotleft, ybotleft, xbotright, ybotright)
end

function lit_ConvertInternalPlottingAreaToCartesian(
    canvasconfig::CanvasConfig,
    plottingarea::PlottingArea)
    local xtopleft = plottingarea.xtopleft
    local ytopleft = lit_convert_y_imagecoor_to_cartesiancoor(canvasconfig, plottingarea.ytopleft)
    local xtopright = plottingarea.xtopright
    local ytopright = lit_convert_y_imagecoor_to_cartesiancoor(canvasconfig, plottingarea.ytopright)
    local xbotleft = plottingarea.xbotleft
    local ybotleft = lit_convert_y_imagecoor_to_cartesiancoor(canvasconfig, plottingarea.ybotleft)
    local xbotright = plottingarea.xbotright
    local ybotright = lit_convert_y_imagecoor_to_cartesiancoor(canvasconfig, plottingarea.ybotright)
    return PlottingArea(xtopleft, ytopleft, xtopright, ytopright,
        xbotleft, ybotleft, xbotright, ybotright)
end

function lit_calc_physical_y_in_graph(yval, ylimits, physicalheight)
    local y_val_bot = ylimits[1]
    local y_val_range = ylimits[2] - ylimits[1]
    local y_ratio = (yval - y_val_bot) / y_val_range
    local y = y_ratio * physicalheight
    return y
end

function lit_graphfuncplot(func, xlims, ylims, internalcartPA)
    local x_val_range = xlims[2] - xlims[1]
    local x_prev, x_val_prev, x_val
    local y_prev, y_physical_prev, y, y_physical
    local physicalheight = internalcartPA.ytopleft - internalcartPA.ybotleft
    local physicalwidth = internalcartPA.xtopright - internalcartPA.xtopleft
    box(Point(0, 0), Point(physicalwidth, physicalheight), :clip)
    for x_pixel = 1:physicalwidth
        x_prev = x_pixel - 1
        x_val_prev = xlims[1] + (x_prev / physicalwidth) * x_val_range
        y_prev = func(x_val_prev)
        y_physical_prev = lit_calc_physical_y_in_graph(y_prev, ylims, physicalheight)

        x_val = xlims[1] + (x_pixel / physicalwidth) * x_val_range
        y = func(x_val)
        y_physical = lit_calc_physical_y_in_graph(y, ylims, physicalheight)

        line(Point(x_prev, y_physical_prev), Point(x_pixel, y_physical), :stroke)
    end
    clipreset()
end

function lit_graphseriesplot(x::AbstractArray, y::AbstractArray, xlims, ylims, internalcartPA)
    local x_val_range = xlims[2] - xlims[1]
    local y_val_range = ylims[2] - ylims[1]
    local len_x = length(x)
    local len_y = length(y)
    local physicalheight = internalcartPA.ytopleft - internalcartPA.ybotleft
    local physicalwidth = internalcartPA.xbotright - internalcartPA.xbotleft
    # Sanity check: Make sure x and y have the same length
    if len_x != len_y
        println("Error in lit_graphseriesplot : len_x != len_y")
        return nothing
    end
    box(Point(0, 0), Point(physicalwidth, physicalheight), :clip)
    # Figure out points
    mypoints = Point[]

    local count = 0
    while count < len_x
        x_value = x[begin+count]

        x_proportion = (x_value - xlims[1]) / x_val_range
        x_pixel = x_proportion * physicalwidth

        y_value = y[begin+count]

        y_proportion = (y_value - ylims[1]) / y_val_range
        y_pixel = y_proportion * physicalheight

        # Push Point into mypoints
        push!(mypoints, Point(x_pixel, y_pixel))
        # Increment countX
        count += 1
    end
    # Plot points
    for count = 2:length(mypoints)
        line(mypoints[count-1], mypoints[count], :stroke)
    end

    # Finish plotting
    clipreset()
end

function lit_SetInternalPlottingAreaMatrix(canvasconfig, internalcartPA)
    local matrix = lit_FakeCartesianSystemMatrix2D(canvasconfig)
    local total_matrix = lit_CartTranslationMatrix2D(internalcartPA.xbotleft, internalcartPA.ybotleft) * matrix
    local cm = juliatocairomatrix(total_matrix)
    setmatrix(cm)
end

function lit_create_graph_xticks(majortick::Integer, xlims, plottingarea;
    font="Courier", fontsize=12,
    ticklength=10, textoffset=25, debug=false)
    local stepamount = (xlims[2] - xlims[1]) / (majortick + 2.0)
    hstep = ((plottingarea.xbotright - 0.5) - (plottingarea.xbotleft + 0.5)) / (majortick + 2.0)
    for loopcounter in 0:majortick+2
        p = Point((plottingarea.xbotleft + 0.5) + loopcounter * hstep, plottingarea.ybotleft)
        line(p, Point(p[1], p[2] + ticklength), :stroke)
        setfont(font, fontsize)
        settext("$(round(xlims[1] + loopcounter * stepamount, digits=2))", p + (0, textoffset), halign="center", valign="bottom")
    end
end

function lit_create_graph_xticks(arr::Union{AbstractArray,StepRange{T,T} where T<:Number},
    xlims, plottingarea; font="Courier", fontsize=12, ticklength=10, textoffset=25, debug=false)
    local physicalwidth = (plottingarea.xbotright - 0.5) - (plottingarea.xbotleft + 0.5)
    local x_proportion
    for tick in arr
        x_proportion = (tick - xlims[1]) / (xlims[2] - xlims[1])
        if 0.0 <= x_proportion <= 1.0
            p = Point((plottingarea.xbotleft + 0.5) + x_proportion * physicalwidth, plottingarea.ybotleft)
            line(p, Point(p[1], p[2] + ticklength), :stroke)
            setfont(font, fontsize)
            settext("$(round(tick, digits=2))", p + (0, textoffset), halign="center", valign="bottom")
        else
            if debug
                println("Tick Point out of range of bottom axis")
            end
        end
    end
end

function lit_create_graph_yticks(majortick, ylims, plottingarea;
    font="Courier", fontsize=12,
    ticklength=10, textoffset=20, debug=false)
    local stepamount = (ylims[2] - ylims[1]) / (majortick + 2.0)
    vstep = ((plottingarea.ybotleft - 0.5) - (plottingarea.ytopleft + 0.5)) / (majortick + 2.0)
    for loopcounter in 0:majortick+2
        p = Point(plottingarea.xbotleft, (plottingarea.ytopleft + 0.5) + loopcounter * vstep)
        line(Point(p[1] - ticklength, p[2]), p, :stroke)
        setfont(font, fontsize)
        settext("$(round(ylims[2] - loopcounter * stepamount, digits=2))", p + (-1 * textoffset, 0), halign="right", valign="center")
    end
end

function lit_create_graph_yticks(arr::Union{AbstractArray,StepRange{T,T} where T<:Number},
    ylims, plottingarea; font="Courier", fontsize=12, ticklength=10, textoffset=25, debug=false)
    local physicalheight = (plottingarea.ybotright - 0.5) - (plottingarea.ytopright + 0.5)
    local y_proportion
    for tick in arr
        y_proportion = (tick - ylims[1]) / (ylims[2] - ylims[1])
        if 0.0 <= y_proportion <= 1.0
            p = Point(plottingarea.xbotleft,
                (plottingarea.ybotleft - 0.5) - y_proportion * physicalheight)
            line(Point(p[1] - ticklength, p[2]), p, :stroke)
            setfont(font, fontsize)
            settext("$(round(tick, digits=2))", p + (-1 * textoffset, 0), halign="right", valign="center")
        else
            if debug
                println("Tick Point out of range of vertical axis")
            end
        end
    end
end

function lit_create_graph_title(canvasconfig, plottingarea, title; font="Times", fontsize=30, debug=false)
    p = Point((plottingarea.xtopleft + plottingarea.xtopright) / 2.0, plottingarea.ytopleft / 2.0)
    setfont(font, fontsize)
    settext(title, p + (0, 0), halign="center", valign="center")
end

function lit_create_X_axis_title(canvasconfig, plottingarea, title; font="Helvetica", fontsize=18, debug=false)
    p = Point((plottingarea.xbotleft + plottingarea.xbotright) / 2.0, plottingarea.ybotleft)
    setfont(font, fontsize)
    settext(title, p + (0, (40 / 63) * (canvasconfig.height - plottingarea.ybotleft)), halign="center", valign="center")
end

function lit_create_Y_axis_title(canvasconfig, plottingarea, title; font="Helvetica", fontsize=18, debug=false)
    p = Point(plottingarea.xbotleft, (plottingarea.ytopleft + plottingarea.ybotleft) / 2.0)
    setfont(font, fontsize)
    settext(title, p + (-1 * (46 / 63) * plottingarea.xbotleft, 0), halign="center", valign="center", angle=90)
end

function lit_convert_graph_xvalue_to_image_xcoor(xvalue, xlims, plottingarea)
    local physicalwidth = (plottingarea.xbotright - 1) - (plottingarea.xbotleft + 1)
    local x_proportion
    x_proportion = (xvalue - xlims[1]) / (xlims[2] - xlims[1])
    return (plottingarea.xbotleft) + x_proportion * physicalwidth - 0.5
end

function lit_convert_graph_xvalue_to_cart_xcoor(canvasconfig, xvalue, xlims, plottingarea)
    local xcoor_image = lit_convert_graph_xvalue_to_image_xcoor(xvalue, xlims, plottingarea)
    local xcoor_image2 = xcoor_image - plottingarea.xbotleft
    return lit_convert_x_imagecoor_to_cartesiancoor(canvasconfig, xcoor_image2)
end

function lit_convert_graph_yvalue_to_image_ycoor(yvalue, ylims, plottingarea)
    local physicalheight = (plottingarea.ybotright - 1) - (plottingarea.ytopright + 1)
    local y_proportion
    y_proportion = (yvalue - ylims[1]) / (ylims[2] - ylims[1])
    return (plottingarea.ybotleft) - y_proportion * physicalheight - 0.5
end

function lit_convert_graph_yvalue_to_cart_ycoor(canvasconfig, yvalue, ylims, plottingarea)
    local ycoor_image = lit_convert_graph_yvalue_to_image_ycoor(yvalue, ylims, plottingarea)
    return lit_convert_y_imagecoor_to_cartesiancoor(canvasconfig, ycoor_image) - (canvasconfig.height - plottingarea.ybotleft)
end

function lit_graph_arrow_text_cart(
    text, x, y; arrow_length=50, arrowgap=2, blankgap=5,
    text_shiftup=1, headangle=pi / 10,
    font="Courier", fontsize=12)
    arrow(Point(x + arrow_length, y), Point(x + arrowgap, y), arrowheadlength=12, arrowheadangle=headangle, linewidth=2)
    setfont(font, fontsize)
    settext(text, Point(x, y) + (arrow_length + blankgap, text_shiftup), halign="left", valign="center")
end

function lit_graph_arrow_text_cart_NE(
    text, x, y; arrow_length=50, arrowgap=2, blankgap=5,
    text_shiftup=1, headangle=pi / 10, horizontal_length=40,
    font="Courier", fontsize=12)
    local diagonal_length = arrow_length / 1.4142135623730951
    arrow(Point(x + diagonal_length, y + diagonal_length), Point(x + arrowgap, y), arrowheadlength=12, arrowheadangle=headangle, linewidth=2)
    line(Point(x + diagonal_length, y + diagonal_length),
        Point(x + diagonal_length + horizontal_length, y + diagonal_length), :stroke)
    setfont(font, fontsize)
    settext(text, Point(x, y) +
                  (diagonal_length + horizontal_length + blankgap, diagonal_length + text_shiftup), halign="left", valign="center")
end

function lit_graph_arrow_text_cart_SE(
    text, x, y; arrow_length=50, arrowgap=2, blankgap=5,
    text_shiftup=1, headangle=pi / 10, horizontal_length=40,
    font="Courier", fontsize=12)
    local diagonal_length = arrow_length / 1.4142135623730951
    arrow(Point(x + diagonal_length, y - diagonal_length), Point(x + arrowgap, y), arrowheadlength=12, arrowheadangle=headangle, linewidth=2)
    line(Point(x + diagonal_length, y - diagonal_length),
        Point(x + diagonal_length + horizontal_length, y - diagonal_length), :stroke)
    setfont(font, fontsize)
    settext(text, Point(x, y) +
                  (diagonal_length + horizontal_length + blankgap, -1 * diagonal_length + text_shiftup), halign="left", valign="center")
end

end









"""
     I originally used the font "Menlo Bold" but since it is not a popular font
     I have changed it to "Courier"

     The Fonts used in this source code are
     1) Times
     2) Helvetica
     3) Courier
"""

using .luxorgraphtools

function plotfigure(fname)
    println("running plotfigure()")

    widthheight = (840, 560)
    Drawing(widthheight..., fname)
    canvasconfig = CanvasConfig(widthheight...)
    background("white")
    sethue("red")

    # Start with coordinates transformation back to Normal
    setmatrix([1, 0, 0, 1, 0, 0])

    myplottingarea = lit_CalcPlottingArea(canvasconfig)
    myinternalPA = lit_CalcInternalPlottingArea(myplottingarea)
    myinternalcartPA = lit_ConvertInternalPlottingAreaToCartesian(canvasconfig, myinternalPA)

    sethue("grey30")
    setline(1)
    """ Draw the outline of the graph box """
    points = [Point(myplottingarea.xtopleft, myplottingarea.ytopleft),
        Point(myplottingarea.xbotleft, myplottingarea.ybotleft),
        Point(myplottingarea.xbotright, myplottingarea.ybotright)]
    poly(points, :stroke, close=false)
    setline(2)

    # Now prepare to plot sine, cosine and multi-trig graph
    xlims = (0.0, 2.0 * pi)
    ylims = (-1.1, 1.1)

    # Set the coordinates to Cartesian which is inside the
    # Plotting Area of the graph
    lit_SetInternalPlottingAreaMatrix(canvasconfig, myinternalcartPA)

    x = range(0, 2π, length=100)
    y1 = sin.(x)
    y2 = cos.(x)
    y3 = -1 .* (sin.(2x) .+ cos.(π * x)) .* exp.(-0.2x)

    # Now plot Series Y1
    sethue(colorant"darkblue")
    lit_graphseriesplot(x, y1, xlims, ylims, myinternalcartPA)

    # Now plot the Cosine series
    sethue(colorant"purple")
    #
    #  lit_graphseriesplot(x,y2,xlims,ylims,myinternalcartPA)
    #
    """
            Instead of using x and y2 series
            We can just plot the cosine series using
            the Cosine function directly
    """
    lit_graphfuncplot(cos, xlims, ylims, myinternalcartPA)

    # Now plot Series Y3
    sethue(colorant"deeppink")
    lit_graphseriesplot(x, y3, xlims, ylims, myinternalcartPA)

    # Now draw the arrows as you please
    sethue(colorant"black")
    """ Draw Arrow for Series Y1 """
    xvalue = 0.95
    xcoor = lit_convert_graph_xvalue_to_cart_xcoor(canvasconfig, xvalue, xlims, myplottingarea)
    yvalue = sin(xvalue)
    ycoor = lit_convert_graph_yvalue_to_cart_ycoor(canvasconfig, yvalue, ylims, myplottingarea)
    lit_graph_arrow_text_cart("Series Y1", xcoor, ycoor, arrow_length=40)

    """ Draw Arrow for Series Y2 """
    xvalue = 1.0
    xcoor = lit_convert_graph_xvalue_to_cart_xcoor(canvasconfig, xvalue, xlims, myplottingarea)
    yvalue = cos(xvalue)
    ycoor = lit_convert_graph_yvalue_to_cart_ycoor(canvasconfig, yvalue, ylims, myplottingarea)
    lit_graph_arrow_text_cart("Series Y2", xcoor, ycoor, arrow_length=40)

    """ Draw Arrow for Series Y3 """
    xvalue = 0.7
    xcoor = lit_convert_graph_xvalue_to_cart_xcoor(canvasconfig, xvalue, xlims, myplottingarea)
    yvalue = -1 * (sin(2 * xvalue) + cos(pi * xvalue)) * exp(-0.2 * xvalue)
    ycoor = lit_convert_graph_yvalue_to_cart_ycoor(canvasconfig, yvalue, ylims, myplottingarea)
    lit_graph_arrow_text_cart("Series Y3", xcoor, ycoor)

    """ Draw Arrow for Sine Function """
    xvalue = 2.7
    xcoor = lit_convert_graph_xvalue_to_cart_xcoor(canvasconfig, xvalue, xlims, myplottingarea)
    yvalue = sin(xvalue)
    ycoor = lit_convert_graph_yvalue_to_cart_ycoor(canvasconfig, yvalue, ylims, myplottingarea)
    lit_graph_arrow_text_cart_NE("Sine Function", xcoor, ycoor, arrow_length=40)

    """ Draw Arrow for Cosine Function """
    xvalue = 4.05
    xcoor = lit_convert_graph_xvalue_to_cart_xcoor(canvasconfig, xvalue, xlims, myplottingarea)
    yvalue = cos(xvalue)
    ycoor = lit_convert_graph_yvalue_to_cart_ycoor(canvasconfig, yvalue, ylims, myplottingarea)
    lit_graph_arrow_text_cart_SE("Cosine Function", xcoor, ycoor, arrow_length=40, horizontal_length=10)

    # Set coordinates transformation back to Normal
    setmatrix([1, 0, 0, 1, 0, 0])

    # Now produce a tickline
    """ X ticklines """
    sethue(colorant"darkblue")
    lit_create_graph_xticks(0:1:10, xlims, myplottingarea)

    """ Y ticklines """
    sethue(colorant"midnightblue")
    lit_create_graph_yticks(-1.1:0.1:1.1, ylims, myplottingarea)

    """ Graph Title """
    sethue(colorant"black")
    lit_create_graph_title(canvasconfig, myplottingarea, "Trigonometry curves", font="Times")

    """ X-axis title """
    lit_create_X_axis_title(canvasconfig, myplottingarea, "X-axis : rotational angle in radians")

    """ Y-axis title """
    lit_create_Y_axis_title(canvasconfig, myplottingarea, "Y-axis : voltage in volts")

    # finish off the picture
    finish()
    preview()
    # The end
end

fname = dirname(dirname(pathof(Luxor))) * "/docs/src/assets/figures/graphdemo.svg"
plotfigure(fname)

# PNG, SVG, array placement

# 1 PNG

"""
    readpng(pathname)

Read a PNG file.

This returns a image object suitable for placing on the current drawing with `placeimage()`.
You can access its `width` and `height` fields:

    image = readpng("test-image.png")
    w = image.width
    h = image.height
"""
function readpng(pathname)
    im = Cairo.read_from_png(pathname)
    if iszero(im.width) || iszero(im.height)
        throw(error("can't read this PNG image from $(pathname). Either it's not a valid PNG file, or the format is different from what Cairo is expecting."))
    end
    return im
end

function paint_with_alpha(ctx::Cairo.CairoContext, a = 0.5)
    Cairo.paint_with_alpha(_get_current_cr(), a)
end

"""
    placeimage(pngimg, pos=O; centered=false)
    placeimage(pngimg, xpos, ypos; centered=false)

Place the PNG image on the drawing at `pos`, or (`xpos`/`ypos`). The image `img` has been previously
read using `readpng()`.

Use keyword `centered=true` to place the center of the image at the position.
"""
function placeimage(img::Cairo.CairoSurface, xpos, ypos; centered = false)
    if centered == true
        w, h = img.width, img.height
        xpos, ypos = xpos - (w / 2), ypos - (h / 2)
    end
    @layer begin
        Cairo.set_source_surface(_get_current_cr(), img, xpos, ypos)
        # no alpha
        Cairo.paint(_get_current_cr())
    end
end

placeimage(img::Cairo.CairoSurface, pt::Point = O; kwargs...) = placeimage(img, pt.x, pt.y; kwargs...)

"""
    placeimage(img, pt::Point=O, alpha; centered=false)
    placeimage(pngimg, xpos, ypos, alpha; centered=false)

Place a PNG image `pngimg` on the drawing at `pt` or `Point(xpos, ypos)`
with opacity/transparency `alpha`. The image has been
previously loaded using `readpng()`.

Use keyword `centered=true` to place the center of the image at the position.
"""
function placeimage(img::Cairo.CairoSurface, xpos, ypos, alpha; centered = false)
    if centered == true
        w, h = img.width, img.height
        xpos, ypos = xpos - (w / 2), ypos - (h / 2)
    end
    @layer begin
        Cairo.set_source_surface(_get_current_cr(), img, xpos, ypos)
        paint_with_alpha(_get_current_cr(), alpha)
    end
end

placeimage(img::Cairo.CairoSurface, pt::Point, alpha; kwargs...) =
    placeimage(img::Cairo.CairoSurface, pt.x, pt.y, alpha; kwargs...)

# 2 SVG

struct SVGimage
    im::RsvgHandle
    xpos::Float64
    ypos::Float64
    width::Float64
    height::Float64
end

function _readsvgfile(fname)
    if Base.stat(fname).size == 0
        throw(error("readsvg: file $fname not found"))
    end
    r = Rsvg.handle_new_from_file(fname)

    if r.ptr == C_NULL
        throw(error("readsvg: couldn't read the file $fname"))
    end

    d = Rsvg.handle_get_dimensions(r)
    if iszero(d.width) || iszero(d.height)
        throw(error("readsvg(): can't get dimensions of this SVG image in $(fname). Perhaps it's not a valid SVG file."))
    end

    return Luxor.SVGimage(r, d.em, d.ex, d.width, d.height)
end

function _readsvgstring(str)
    if length(str) == 0
        throw(error("readsvg: can't read SVG from string $(str)."))
    end

    r = Rsvg.handle_new_from_data(str)

    if r.ptr == C_NULL
        throw(error("readsvg: can't read SVG from string starting $(str[1:20])."))
    end

    d = Rsvg.handle_get_dimensions(r)
    if iszero(d.width) || iszero(d.height)
        throw(error("readsvg_string(): can't get dimensions of this SVG image. Perhaps it's not valid SVG."))
    end
    return SVGimage(r, d.em, d.ex, d.width, d.height)
end

"""
    readsvg(str)

Read an SVG image. `str` is either pathname or pure SVG
code. This returns an SVG image object suitable for placing
on the current drawing with `placeimage()`.

Placing an SVG file:

```julia
@draw begin
    mycoollogo = readsvg("mylogo.svg")
    placeimage(mycoollogo)
end
```

Placing SVG code:

```julia
# from https://github.com/edent/SuperTinyIcons
julialogocode = \"\"\"<svg xmlns="http://www.w3.org/2000/svg"
    aria-label="Julia" role="img"
    viewBox="0 0 512 512">
    <rect width="512" height="512" rx="15%" fill="#fff"/>
    <circle fill="#389826" cx="256" cy="137" r="83"/>
    <circle fill="#cb3c33" cx="145" cy="329" r="83"/>
    <circle fill="#9558b2" cx="367" cy="329" r="83"/>
</svg>\"\"\"

@draw begin
    julia_logo = readsvg(julialogocode)
    placeimage(julia_logo, centered=true)
end
```
"""
function readsvg(str)
    # str is either pathname or pure SVG code
    # unfortunately ispath fails on Mac if the string is longer than 255 characters
    if length(str) > 255 # don't check ispath, assume SVG string
        _readsvgstring(str)
    elseif ispath(str) # check is a file
        _readsvgfile(str)
    else
        _readsvgstring(str)
    end
end

"""
    placeimage(svgimg, pos=O; centered=false)

Place an SVG image stored in `svgimg` on the drawing at `pos`. Use `readsvg()`
to read an SVG image from file, or from SVG code.

Use keyword `centered=true` to place the center of the image
at the position.
"""
function placeimage(im::SVGimage, pos = O; centered = false)
    if centered == true
        w, h = im.width, im.height
        pos = pos - ((w / 2), (h / 2))
    end
    @layer begin
        @layer begin
            translate(pos)
            @layer begin
                # hack - do these extra saves prevent the UTM breakage? (#267)
                # no, I think they don't
                Rsvg.handle_render_cairo(Luxor._get_current_cr(), im.im)
            end
        end
    end
end

# 3 array

#=
premultiply alpha utilities

In a premultiplied image array ARGB, a 50% transparent red pixel
is stored as 0x80800000, rather than 0x80ff0000. This
function multiplies each RGB value by the alpha value.
=#

_premultiplied_rgba(r::Luxor.Colors.RGBA) = Luxor.Colors.RGBA(r.r * r.alpha, r.g * r.alpha, r.b * r.alpha, r.alpha)
_premultiplied_rgba(c::Luxor.Colors.Colorant) = _premultiplied_rgba(Luxor.Colors.RGBA(c))

function _premultiplied_rgba(a::AbstractArray)
    map(_premultiplied_rgba, a)
end

_to_uint32_color(c) = reinterpret(Luxor.Colors.UInt32, convert(Luxor.Colors.ARGB32, _premultiplied_rgba(c)))

"""
    placeimage(matrix::AbstractMatrix{UInt32}, pos=O;
        alpha=1, centered=false)

Place an image matrix on the drawing at `pos` with opacity/transparency `alpha`.

Use keyword `centered=true` to place the center of the image
at the position.
"""
function placeimage(buffer::AbstractMatrix{UInt32}, pt = O;
    alpha = 1, centered = false)
    if centered == true
        w, h = size(buffer)
        pt = Point(pt.x - (w / 2), pt.y - (h / 2))
    end
    @layer begin
        Cairo.set_source_surface(Luxor._get_current_cr(), Cairo.CairoImageSurface(buffer, Cairo.FORMAT_ARGB32), pt.x, pt.y)
        paint_with_alpha(_get_current_cr(), alpha)
    end
end

"""
    placeimage(buffer::AbstractMatrix{ARGB32}, args...;
        kargs...)

Place an array of ARGB32 lements on the drawing at `pos` with opacity/transparency `alpha`.
Values are "alpha-premultiplied" before being placed.

Use keyword `centered=true` to place the center of the image
at the position.
"""
function placeimage(buffer::AbstractMatrix{ARGB32}, args...; kargs...)
    # premultiply alpha
    @layer begin
        placeimage(reinterpret(Luxor.Cairo.UInt32, _to_uint32_color.(buffer)), args...; kargs...)
    end
end

placeimage(buffer::AbstractMatrix{<:Colorant}, args...; kargs...) = placeimage(convert.(ARGB32, buffer), args...; kargs...)

function placeimage(d::Drawing, args...; kargs...)
    if d.surfacetype == :svg
        @layer begin
            seekstart(d.buffer)
            drawingdata = read(d.buffer, String)
            placeimage(_readsvgstring(drawingdata), args...; kargs...)
        end
    else
        throw(error("surfacetype `$(buffer.surfacetype)` is not supported. Use `image` instead."))
    end
end

#!/usr/bin/env julia

using Luxor

using Random
Random.seed!(42)

using Test

function offset_poly_test(fname)
    Drawing("A2", fname)
    origin()
    background("white")
    setline(1.5)

    tiles = Tiler(Luxor._current_width(), Luxor._current_height(), 6, 6, margin=20)
    randomoffset = 18
    for (pos, n) in tiles
        gsave()
        translate(pos)
        radius =  tiles.tilewidth/4
        p = star(O, radius, 5, 0.25, 0, vertices=true)
        sethue("red")
        setdash("dot")
        poly(p, :stroke, close=true)
        setdash("solid")
        sethue("black")
        randomoffset -= 1
        poly(offsetpoly(p, randomoffset), :stroke, close=true)
        text(string(randomoffset), O.x, O.y + tiles.tilewidth/2, halign=:center)
        grestore()
    end
    @test finish() == true
end

fname="offsetpolys.pdf"
offset_poly_test(fname)
println("...finished test: output in $(fname)")

using Documenter, Luxor
using DocumenterTools: Themes

# Setup for doctests in docstrings
DocMeta.setdocmeta!(Luxor, :DocTestSetup, :(using Luxor))

println("Starting makedocs")

makedocs(
    modules  = [Luxor],
    sitename = "Luxor",
    warnonly = true,
    format   = Documenter.HTML(
        size_threshold = nothing,
        prettyurls = get(ENV, "CI", nothing) == "true",
        assets = ["assets/luxor-docs.css"],
        collapselevel = 1,
    ),
    pages = [
        "Introduction to Luxor" => "index.md",
        "Tutorials" => [
            "Hello World"         => "tutorial/helloworld.md",
            "Turtle graphics"     => "tutorial/turtle.md",
            "Basic path building" => "tutorial/basicpath.md",
            "Design a logo"       => "tutorial/quickstart.md",
            "Geometry tutorial"   => "tutorial/basictutorial.md",
            "Playing with pixels" => "tutorial/pixels.md",
            "Simple animation"    => "tutorial/simple-animation.md",
        ],
        "Examples" => [
            "Simple examples" => "example/examples.md",
            "More examples"   => "example/moreexamples.md",
            "Gallery"         => "example/gallery.md",
        ],
        "How to guides" => [
            "Create drawings"                  => "howto/createdrawings.md",
            "Draw simple shapes"               => "howto/simplegraphics.md",
            "Use geometry tools"               => "howto/geometrytools.md",
            "Work with tables and grids"       => "howto/tables-grids.md",
            "Use colors and styles"            => "howto/colors-styles.md",
            "Work with polygons"               => "howto/polygons.md",
            "Add text"                         => "howto/text.md",
            "Clip graphics"                    => "howto/clipping.md",
            "Placing images"                   => "howto/images.md",
            "Turtle graphics"                  => "howto/turtle.md",
            "Make animations"                  => "howto/animation.md",
            "Snapshots"                        => "howto/snapshots.md",
            "Interactive graphics and Threads" => "howto/livegraphics.md",
        ],
        "Explanations" => [
            "Basic concepts"                 => "explanation/basics.md",
            "Paths vs Polygon"               => "explanation/pathspolygons.md",
            "Perfect pixels and antialising" => "explanation/perfectpixels.md",
            "Transforms and matrices"        => "explanation/transforms.md",
            "Image matrix"                   => "explanation/imagematrix.md",
            "Fonts on Linux"                 => "explanation/fonts.md",
            "Luxor and Cairo"                => "explanation/luxorcairo.md",
            "Customize strokepath/fillpath"  => "explanation/strokepathdispatch.md",
            "Contributing"                   => "explanation/contributing.md",
        ],
        "Reference" => [
            "Alphabetical function list" => "reference/functionindex.md",
            "Function reference"         => "reference/api.md",
        ],
    ],
)

println("Finished makedocs")

repo = "github.com/JuliaGraphics/LuxorManual.git"
withenv("GITHUB_REPOSITORY" => repo) do
    deploydocs(
        repo = repo,
        target = "build",
        push_preview = true,
        forcepush = true,
    )
end

#!/usr/bin/env julia -

using Luxor

using Test

using Random
Random.seed!(42)

function polysampletest(fname)
    Drawing(400, 400, fname)
    origin()
    background("white")

    p = ngon(O, 100, 6, vertices=true)
    setline(12)
    sethue("grey70")
    prettypoly(p, :stroke, close=true, ()->circle(O, 10, :fill))

    upsample = polysample(p, 12)
    setline(3)
    sethue("cyan")
    prettypoly(upsample, :stroke, close=true, ()->circle(O, 7, :fill))

    resample = polysample(p, 6)
    setline(2)
    sethue("magenta")
    prettypoly(upsample, :stroke, close=true, ()->circle(O, 4, :fill))

    @test p == circshift(resample, 1)

    downsample = polysample(p, 3)
    setline(1)
    sethue("orange")
    prettypoly(downsample, :stroke, close=true, ()->circle(O, 2, :fill))

    @test length(findall(pt -> pt == downsample[1], p)) == 1

    @test finish() == true
    println("...finished test: output in $(fname)")

end

polysampletest("polysample.svg")

#!/usr/bin/env julia

using Luxor

using Test

using Colors

using Random

Random.seed!(42)

demomovie = Movie(400, 400, "test", 0:359)

function backdrop(scene, framenumber)
    background("black")
end

function frame(scene, framenumber)
    sethue(Colors.HSV(framenumber, 1, 1))
    p = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(polar(100, -pi / 2 - p * 2pi), 80, :fill)
    text(string("frame $framenumber of $(length(scene.movie.movieframerange))"), Point(O.x, O.y - 190))
end

mktempdir() do tmpdir
    @test animate(demomovie, [Scene(demomovie, backdrop), Scene(demomovie, frame, 0:359, easingfunction = easeinoutquad)], creategif = false) == true
end

demo = Movie(400, 100, "test")

function frame1(scene, framenumber)
    sethue("purple")
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(Point(-180 + (360 * eased_n), -20), 10, :fill)
end

function frame2(scene, framenumber)
    sethue("green")
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(Point(-180 + (360 * eased_n), 0), 10, :fill)
end

function frame3(scene, framenumber)
    sethue("red")
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(Point(-180 + (360 * eased_n), 20), 10, :fill)
end

function frame4(scene, framenumber)
    sethue("red")
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(Point(-180 + (360 * eased_n), 20), 10, :fill)
    sethue("white")
    fontsize(20)
    text(string(scene.opts))
end

mktempdir() do tmpdir
    @test animate(demo, [
            Scene(demo, backdrop, 0:200),
            Scene(demo, frame1, 0:200, easingfunction = easeinsine),
            Scene(demo, frame2, 0:200, easingfunction = easeinoutcubic),
            Scene(demo, frame3, 0:200, easingfunction = easeinoutquint),
            Scene(demo, frame4, 0:200, easingfunction = easeinoutquint, optarg = 42),
        ],
        creategif = false) == true
end

@testset "test pathname parameter of animate()" begin
    mktempdir() do tmpdir
        # test that animation is saved to 'pathname' if valid pathname is given
        testfile = joinpath(tmpdir, "test.gif")

        #= ffmpeg is not supported on travis and co -> disable gif generation
        # dependent test
        @test !isfile(testfile)
        =#
        @test animate(demo, Scene(demo, backdrop, 0:200),
            creategif = false,
            pathname = testfile) == true

        touch(testfile)
        @test isfile(testfile)

        # test that error is thrown if the passed pathname points to a directory
        # and that the content of that directory is not removed (ticket #57)
        @test isdir(tmpdir)
        @warn "This is about to error..."
        @test animate(demo, Scene(demo, backdrop, 0:200),
            creategif = false,
            pathname = tmpdir) == false
        @test isfile(testfile)
    end
end

@testset "test output" begin
    demo = Movie(100, 100, "test")
    function frame(scene, framenumber)
        sethue("purple")
        eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
        circle(Point(-180 + (360 * eased_n), -20), 10, :fill)
    end
    mktempdir() do tmpdir
        cd(tmpdir) do
            # true if no gif
            @test animate(demo, [Scene(demo, frame, 0:20, easingfunction = easeinsine)],
                creategif = false) == true
            # return gif 
            ag = animate(demo, [Scene(demo, frame, 0:20, easingfunction = easeinsine)], creategif = true)
            @test ag isa Luxor.AnimatedGif
            # true if movie
            @test animate(demo, [Scene(demo, frame, 0:10)], createmovie = true) == true
            @test animate(demo, [Scene(demo, frame, 0:10)], createmovie = true, creategif = false) == true
            animate(demo, [Scene(demo, frame, 0:10)], createmovie = true, pathname = "temp")
            @test isfile("temp.mkv")
            animate(demo, [Scene(demo, frame, 0:10)], createmovie = true, pathname = "temp.mp4")
            @test isfile("temp.mp4")
            animate(demo, [Scene(demo, frame, 0:10)], createmovie = true, pathname = "temp.webm")
            @test isfile("temp.mp4")
        end
    end
end

println("...finished animation tests")

#!/usr/bin/env julia

using Luxor

using Test

using Random
Random.seed!(42)

function text_wrap_tests(fname)
    Drawing(1400, 1400, fname)
    origin()
    setopacity(0.8)
    sethue("black")
    fontface("Impact")
    tiles = Tiler(1000, 1000, 4, 3, margin=50)
    for (pos, n) in tiles
        fsize = 12
        opacity = 1.0
        fontsize(fsize)
        try
            # does not work with Cairo < 1.0.5
            received_fsize = get_fontsize()
            @test received_fsize == fsize
        catch
            # should throw with Cairo < 1.0.5
            @test_throws ErrorException get_fontsize()
        end
        @layer begin
            translate(pos)
            sethue("antiquewhite")
            box(O, tiles.tilewidth-2, tiles.tileheight-2, :fill)
            sethue("black")
            if iseven(n)
                textwrap("Luxor is a city in Upper (southern) Egypt. " ^ 12,
                tiles.tilewidth,
                O - (tiles.tilewidth/2 - 2, tiles.tileheight/2 - 2),
                rightgutter=20)
            else
                # textwrap(s::AbstractString, width::Real, pos::Point, linefunc::Function; rightgutter=5)
               textwrap("Luxor is a city in Upper (southern) Egypt. " ^ 12,
                    tiles.tilewidth,
                    O - (tiles.tilewidth/2 - 2,  tiles.tileheight/2 - 2),
                    # l is the text of a line, p is the position of the start of the line, h is the interline height
                    (n, l, p, h) -> begin
                            text(string(length(l)), p + (tiles.tilewidth - 20, 0))
                            opacity *= 0.8
                            setopacity(opacity)
                        end,
                    rightgutter=40)
            end
        end
    end
    @test finish() == true
    println("...finished test: output in $(fname)")
end

text_wrap_tests("text-wrap-tests.svg")

#!/usr/bin/env julia

using Luxor, Test, Random

Random.seed!(42)

w, h = 600, 600

fname = "polycross-test.png"
Drawing(w, h, fname)
background("white")
origin()
setline(0.5)
for i in 100:-1:1
    rotate(0.01)
    polycross(O, 250, 4, i/100, 0, :stroke)
end

@test finish() == true
println("...finished test: output in $(fname)")

#!/usr/bin/env julia

using Luxor, Colors

using Test

using Random
Random.seed!(42)

function drawlogoclip(x, y)
    foregroundcolors = diverging_palette(rand(0:360), rand(0:360), 200, s = 0.99, b=0.8)
    gsave()
    translate(x-100, y)
    julialogo(action=:clip)
    for i in 1:500
        sethue(foregroundcolors[rand(1:end)])
        circle(rand(-50:350), rand(0:300), 15, :fill)
    end
    #  to test clippreserve(), draw a path, and it is intersected with clip region (julia logo)
    # then filled with solid red
    gsave()
        circle(O, 200, :path)
        clippreserve()
        setcolor("red")
        fillpath()
    grestore()
    clipreset()
    grestore()
end

function clipping_test(fname)
    Drawing(500, 500, fname)
    origin()
    setopacity(.4)
    foregroundcolors = diverging_palette(rand(0:360), rand(0:360), 200, s = 0.99, b=0.8)
    drawlogoclip(0, 0)
    @test finish() == true
    println("...finished test: output in $(fname)")
end

clipping_test("clipping-tests.png")

"""
    barchart(values;
            boundingbox = BoundingBox(O + (-250, -120), O + (250, 120)),
            bargap=10,
            margin = 5,
            border=false,
            labels=false,
            labelfunction = (values, i, lowpos, highpos, barwidth, scaledvalue) -> begin
                    label(string(values[i]), :n, highpos, offset=10)
              end,
            barfunction =  (values, i, lowpos, highpos, barwidth, scaledvalue) -> begin
                @layer begin
                    setline(barwidth)
                    line(lowpos, highpos, :stroke)
                end
              end)

Draw a barchart where each bar is the height of a value in the `values` array. The bars
will be scaled to fit in a bounding box.

Text labels are drawn if the keyword `labels=true`.

# Extended help

The function returns a vector of points; each is the bottom center of a bar.

Draw a Fibonacci sequence as a barchart:

```julia
fib(n) = n > 2 ? fib(n - 1) + fib(n - 2) : 1
fibs = fib.(1:15)
@draw begin
    fontsize(12)
    barchart(fibs, labels=true)
end
```
To control the drawing of the text and bars, define functions that process the
end points:

`mybarfunction(values, i, lowpos, highpos, barwidth, scaledvalue)`

`mylabelfunction(values, i, lowpos, highpos, barwidth, scaledvalue)`

and pass them like this:

```julia
barchart(vals, barfunction=mybarfunction)
barchart(vals, labelfunction=mylabelfunction)
```

```julia
function myprologfunction(values, basepoint, minbarrange, maxbarrange, barchartheight)
    @layer begin
        setline(0.2)
        for i in 0:10:maximum(values)
            rule(boxbottomcenter(basepoint) + (0, -(rescale(i, minbarrange, maxbarrange) * barchartheight)))
        end
    end
end
```
"""
function barchart(values;
    boundingbox = BoundingBox(O + (-250, -120), O + (250, 120)),
    bargap=10,
    margin = 5,
    border=false,
    labels=false,
    labelfunction = (values, i, lowpos, highpos, barwidth, scaledvalue) -> begin
        label(string(values[i]), :n, highpos, offset=10)
    end,
    barfunction =  (values, i, lowpos, highpos, barwidth, scaledvalue) -> begin
        @layer begin
            setline(barwidth)
            line(lowpos, highpos, :stroke)
        end
    end,
    prologfunction = (values, basepoint, minbarrange, maxbarrange, barchartheight) -> ()
    )
    minvalue, maxvalue = extrema(values)
    barchartwidth  = boxwidth(boundingbox)  - 2bargap - 2margin
    barchartheight = boxheight(boundingbox) - 2margin
    barwidth = (barchartwidth - 2bargap)/length(values)
    if barwidth < 0.1
        throw(error("barchart() - bars are too small (< 0.1) at $(barwidth)"))
    end
    # if all bars are equal height, this will force a range
    minbarrange = minvalue - abs(minvalue)
    maxbarrange = maxvalue + abs(maxvalue)
    basepoint = boundingbox - (0, margin)
    hpositions = between.(
        boxbottomleft(basepoint),
        boxbottomright(basepoint),
        # skip first and last, then take every other one, which is at halfway
        range(0.0, stop=1.0, length=2length(values) + 1))[2:2:end-1]
    @layer begin
        if border
            box(boundingbox, :stroke)
        end
        prologfunction(values, basepoint, minbarrange, maxbarrange, barchartheight)
        for i in 1:length(values)
            scaledvalue = rescale(values[i], minbarrange, maxbarrange) * barchartheight
            lowposition = hpositions[i]
            highposition = lowposition - (0, scaledvalue) # -y coord
            barfunction(values, i, lowposition, highposition, barwidth, scaledvalue)
            labels && labelfunction(values, i, lowposition, highposition, barwidth, scaledvalue)
        end
    end
    return (positions = hpositions)
end

# Perfect pixels and anti-aliasing

## Anti-aliasing

The process of converting precise graphic shapes to a grid
of pixels is automatically performed by Luxor when you save
the drawing as a PNG file. If you make an SVG or PDF
drawing, this process is carried out at a later stage, by
the application you use to view or display the file.

It's usually better to defer this conversion as long as
possible. Of course, eventually - unless you're using a pen
plotter or laser cutter - your smooth outlines will have to
be converted ("rasterized") to a grid of colored pixels for
their final journey to the analogue world.

The conversion to PNG includes "anti-aliasing", which
gradually changes the colors of pixels along a boundary so
as to avoid the grid-like "staircase" effect. You can, to
some extent, adjust the amount of anti-aliasing used when
you make drawings in Luxor.

```@setup draw_matrix
using Luxor, Colors
function make_matrix(;
        antialias=0)
    d = Drawing(20, 20, :image)
    setantialias(antialias)
    origin()
    setcolor("red")
    circle(Point(0, 0), 5, :fill)
    mat = image_as_matrix()
    finish()
    return mat
end

function drawmatrix(A;
        cellsize = (10, 10))
    table = Table(size(A)..., cellsize...)
    for i in CartesianIndices(A)
        r, c = Tuple(i)
        sethue(A[r, c])
        box(table, r, c, :fill)
        sethue("black")
        box(table, r, c, :stroke)
    end
end

function draw(antialias)
    mat = make_matrix(antialias=antialias)
    @drawsvg begin
        background("black")
        drawmatrix(mat, cellsize = 1 .* size(mat))
        c = length(unique(color.(mat)))
        sethue("white")
        fontsize(8)
        text("number of colors used: $c", boxbottomcenter(BoundingBox() * 0.9), halign=:center)
    end 300 300
end
```

The [`setantialias`](@ref) function lets you specify the anti-aliasing amount as an integer constant between 0 and 6 to be used for rendering subsequent paths. The Cairo documentation describes the different values as follows:

| Value  | Name                      | Description     |
|:-----  |:----                      |:----            |
|0       |`CAIRO_ANTIALIAS_DEFAULT`  |Use the default anti-aliasing for the subsystem and target device|
|1       |`CAIRO_ANTIALIAS_NONE`     |Use a bilevel alpha mask|
|2       |`CAIRO_ANTIALIAS_GRAY`     |Perform single-color anti-aliasing (using shades of gray for black text on a white background, for example)|
|3       |`CAIRO_ANTIALIAS_SUBPIXEL` |Perform anti-aliasing by taking advantage of the order of subpixel elements on devices such as LCD panels|
|4       |`CAIRO_ANTIALIAS_FAST`     |Hint that the backend should perform some anti-aliasing but prefer speed over quality|
|5       |`CAIRO_ANTIALIAS_GOOD`     |The backend should balance quality against performance|
|6       |`CAIRO_ANTIALIAS_BEST`     |Hint that the backend should render at the highest quality, sacrificing speed if necessary|

To show the anti-aliasing in action, the following code generates a red circle:

```julia
Drawing(20, 20, :image)
setantialias(0)
origin()
setcolor("red")
circle(Point(0, 0), 5, :fill)
mat = image_as_matrix()
finish()
```

This matrix is now redrawn larger to show the effects of anti-aliasing better. Here's the default anti-aliasing value of 0:

```@example draw_matrix
draw(0) # hide
```

and you can see that Luxor used 18 different shades of red
to add some smoothness to this circle.

Here’s the result of the bilevel mask or “none” setting (`setantialias(1)`):

```@example draw_matrix
draw(1) # hide
```

Here Luxor used just two colors to draw the circle.

The other values produce the same effects as the default (0), apart from 4 ("speed over quality"):

```@example draw_matrix
draw(4) # hide
```

which uses 12 rather than 16 colors.

The anti-aliasing process can vary according to the OS and device you're using. The [Cairo documentation](https://www.cairographics.org/manual/cairo-cairo-t.html) stresses this more than once:

> The value is a hint, and a particular backend may or may not support a particular value. [...] The values make no guarantee on how the backend will perform its rasterisation (if it even rasterises!) [...] The interpretation of `CAIRO_ANTIALIAS_DEFAULT` is left entirely up to the backend [...]

## Text

The anti-aliasing described above does not apply to text.

Text rendering is much more platform-dependent than graphics; Windows, MacOS, and Linux all have their own methods for rendering and rasterizing fonts, and currently there is no interface to the underlying font rendering APIs in Luxor.

Consider the following code, which makes an image of the letter "a" and redraws it larger:

```julia
using Luxor

function make_matrix()
    Drawing(40, 40, :image)
    background(1, 1, 1, 1)
    setantialias(0)
    origin()
    setcolor(0, 0, 0, 1)
    fontsize(40)
    text("a", halign=:center, valign=:middle)
    matrix = image_as_matrix()
    finish()
    return matrix
end

function draw()
    matrix = make_matrix()
    @png begin
        background(0, 0, 0, 1)
        table = Table(size(matrix)..., (15, 15))
        for i in CartesianIndices(matrix)
            r, c = Tuple(i)
            setcolor(matrix[r, c])
            box(table, r, c, :fillstroke)
        end
    end 400 400 "alias-test.png"
end
```

The output varies depending on the computer, operating system, and rendering settings.

Here’s the MacOS standard rendering:

![macos alias text](../assets/figures/textrendering-macos-alias-test.png)

Here’s Linux Gnome’s standard anti-aliasing:

![linux gnome alias text](../assets/figures/textrendering-linux-gnome-greyscale-aaa .png)

On Windows systems, and on some Linux desktops, text can be
displayed using a _subpixel_ rendering process, which
switches the red, green, and blue components of pixels on or
off where they meet the edges of text in an attempt to
provide a “smoother” appearance.

Here’s Linux KDE RGB anti-aliasing:

![linux kde rgb alias text](../assets/figures/textrendering-linux-kde-rgb-subpixel-aa.png)

Windows Cleartype anti-aliasing:

![windows cleartype alias text](../assets/figures/textrendering-windows-cleartype.png)

In addition, Windows and some Linux systems use
_font hinting_, a process in which the outlines of text glyphs
are shifted so as to align better on the rectangular grid of
pixels.

If you want text to be rendered precisely (and in a
specified color) it might be worth investigating Luxor’s
[`textoutlines`](@ref) function, which converts text to
vector-based outlines. These are then rendered with the
anti-aliasing settings described above for graphics.

```@meta
DocTestSetup = quote
    using Luxor, Colors
    end
```
# Colors and styles

## Color and opacity

For color definitions and conversions, you can use
[Colors.jl](https://github.com/JuliaGraphics/Colors.jl).

[`setcolor`](@ref) and [`sethue`](@ref) will apply a single
color to all new graphics.

[`setblend`](@ref) will apply a smooth transition between
two or more colors to all new graphics.

[`setmesh`](@ref) will apply a color mesh to all new graphics.

The difference between the [`setcolor`](@ref) and
[`sethue`](@ref) functions is that [`sethue`](@ref) doesn't
change the current alpha opacity (transparency), so you can change the
current color without changing the current alpha opacity
(transparency) value.

Named colors, such as "gold", or "lavender", can be found in
`Colors.color_names` dictionary.

```@example
using Luxor, Colors # hide
Drawing(800, 800, "../assets/figures/colors.svg") # hide

origin() # hide
background("white") # hide
fontsize(8)
cols = sort(collect(Colors.color_names))
ncols = 15
nrows = convert(Int, ceil(length(cols) / ncols))
table = Table(nrows, ncols, 800/ncols, 800/nrows)
gamma = 2.2
for n in 1:length(cols)
    col = cols[n][1]
    r, g, b = sethue(col)
    box(table[n], table.colwidths[1], table.rowheights[1], action=:fill)
    luminance = 0.2126 * r^gamma + 0.7152 * g^gamma + 0.0722 * b^gamma
    (luminance > 0.5^gamma) ? sethue("black") : sethue("white")
    text(string(cols[n][1]), table[n], halign=:center, valign=:middle)
end
finish() # hide

nothing #hide
```

![line endings](../assets/figures/colors.svg)

(To make the label stand out against the background, the
luminance is calculated, then used to choose the label's
color.)

## Line styles

There are `set-` functions for controlling subsequent lines'
width, end shape, join behavior, and dash pattern:

```@example
using Luxor # hide
Drawing(400, 250, "../assets/figures/line-ends.png") # hide
background("white") # hide
origin() # hide
translate(-100, -60) # hide
fontsize(18) # hide
for l in 1:3
    sethue("black")
    setline(20)
    setlinecap(["butt", "square", "round"][l])
    textcentred(["butt", "square", "round"][l], 80l, 80)
    setlinejoin(["round", "miter", "bevel"][l])
    textcentred(["round", "miter", "bevel"][l], 80l, 120)
    poly(ngon(Point(80l, 0), 20, 3, 0, vertices=true), action=:strokepreserve, close=false)
    sethue("white")
    setline(1)
    strokepath()
end
finish() # hide
nothing # hide
```

![line endings](../assets/figures/line-ends.png)

```@example
using Luxor # hide
Drawing(600, 250, "../assets/figures/dashes.png") # hide
background("white") # hide
origin() # hide
fontsize(14) # hide
sethue("black") # hide

patterns = ["solid", "dotted", "dot", "dotdashed", "longdashed",
  "shortdashed", "dash", "dashed", "dotdotdashed", "dotdotdotdashed"]
setline(12)

table = Table(fill(20, length(patterns)), [50, 300])
text.(patterns, table[:, 1], halign=:right, valign=:middle)

for p in 1:length(patterns)
    setdash(patterns[p])
    pt = table[p, 2]
    line(pt - (150, 0), pt + (150, 0), :stroke)
end
finish() # hide
nothing # hide
```

![dashes](../assets/figures/dashes.png)

To define more complicated dash patterns, pass a vector to [`setdash`](@ref).

```julia
dashes = [50.0,  # ink
          10.0,  # skip
          10.0,  # ink
          10.0   # skip
          ]
setdash(dashes)
```

```@example
using Luxor # hide
Drawing(600, 180, "../assets/figures/moredashes.svg") # hide
background("white") # hide
origin() # hide
function dashing()
    fontsize(12) # hide
    sethue("black") # hide
    setline(8)
    setlinecap("butt")
    patterns = [10, 4, 50, 25, 14, 100]
    table = Table(fill(20, length(patterns)), [40, 325])
    for p in 1:length(patterns)
        setdash(patterns)
        pt = table[p, 2]
        text(string(patterns), table[p, 1], halign=:right, valign=:middle)
        line(pt - (150, 0), pt + (200, 0), :stroke)
        patterns = circshift(patterns, 1)
        pop!(patterns)
    end
end

dashing()

finish() # hide
nothing # hide
```

![more dashes](../assets/figures/moredashes.svg)

Notice that odd-numbered patterns flip the ink and skip values each time through.

## Gradient blends

In Luxor, a blend is a smoothly changing color gradient.

Use [`setblend`](@ref) to select a blend in the same way
that you'd use [`setcolor`](@ref) and [`sethue`](@ref) to
select a solid color.

You can make linear or radial blends. Use [`blend`](@ref) in either case.

After `setblend()`, the current blend affects all subsequent stroked and filled graphics.

To create a simple linear blend between two colors, supply two points and two colors to [`blend`](@ref):

```@example
using Luxor # hide
Drawing(600, 200, "../assets/figures/color-blends-basic.png") # hide
origin() # hide
background("white") # hide
orangeblue = blend(Point(-200, 0), Point(200, 0), "orange", "blue")
setblend(orangeblue)
box(O, 400, 100, action = :fill)
rulers()

translate(0, -70)
rule(O) # stroked line

finish() # hide
nothing # hide
```

![linear blend](../assets/figures/color-blends-basic.png)

And for a radial blend, provide two point/radius pairs and two colors:

```@example
using Luxor # hide
Drawing(600, 200, "../assets/figures/color-blends-radial.png") # hide
origin() # hide
background("white") # hide
greenmagenta = blend(Point(0, 0), 5, Point(0, 0), 150, "green", "magenta")
setblend(greenmagenta)
box(O, 400, 200, action = :fill)
rulers()
finish() # hide
nothing # hide
```
![radial blends](../assets/figures/color-blends-radial.png)

You can also use [`blend`](@ref) to create an empty blend. Then you use [`addstop`](@ref) to define the locations of specific colors along the blend, where `0` is the start, and `1` is the end.

```@example
using Luxor # hide
Drawing(600, 200, "../assets/figures/color-blends-scratch.png") # hide
origin() # hide
background("white") # hide
goldblend = blend(Point(-200, 0), Point(200, 0))
addstop(goldblend, 0.0,  "gold4")
addstop(goldblend, 0.25, "gold1")
addstop(goldblend, 0.5,  "gold3")
addstop(goldblend, 0.75, "darkgoldenrod4")
addstop(goldblend, 1.0,  "gold2")
setblend(goldblend)
box(O, 400, 200, action = :fill)
rulers()
finish() # hide
nothing # hide
```

![blends from scratch](../assets/figures/color-blends-scratch.png)

When you define blends, the location of the x/y axes (eg the current workspace as defined by [`translate`](@ref), etc.), is important. In the first of the two following examples, the blend is selected before the axes are moved with `translate(pos)`. The blend 'samples' the original location of the blend's definition.

```@example
using Luxor # hide
Drawing(600, 200, "../assets/figures/color-blends-translate-1.png") # hide
origin() # hide
background("white") # hide
goldblend = blend(Point(0, 0), Point(200, 0))
addstop(goldblend, 0.0,  "gold4")
addstop(goldblend, 0.25, "gold1")
addstop(goldblend, 0.5,  "gold3")
addstop(goldblend, 0.75, "darkgoldenrod4")
addstop(goldblend, 1.0,  "gold2")
setblend(goldblend)
tiles = Tiler(600, 200, 1, 5, margin=10)
for (pos, n) in tiles
    gsave()
    setblend(goldblend)
    translate(pos)
    ellipse(O, tiles.tilewidth, tiles.tilewidth, action = :fill)
    grestore()
end
finish() # hide
nothing # hide
```

![blends 1](../assets/figures/color-blends-translate-1.png)

By default, outside the range of the original blend's definition, the same color is used, no matter how far away from the origin you go. But in the next example, the blend is relocated to the current axes, which have just been moved to the center of the tile. The blend refers to `0/0` each time, which is at the center of shape.

```@example
using Luxor # hide
Drawing(600, 200, "../assets/figures/color-blends-translate-2.png") # hide
origin() # hide
background("white") # hide
goldblend = blend(Point(0, 0), Point(200, 0))
addstop(goldblend, 0.0,  "gold4")
addstop(goldblend, 0.25, "gold1")
addstop(goldblend, 0.5,  "gold3")
addstop(goldblend, 0.75, "darkgoldenrod4")
addstop(goldblend, 1.0,  "gold2")
setblend(goldblend)
tiles = Tiler(600, 200, 1, 5, margin=10)
for (pos, n) in tiles
    gsave()
    translate(pos)
    setblend(goldblend)
    ellipse(O, tiles.tilewidth, tiles.tilewidth, action = :fill)
    grestore()
end
finish() # hide
nothing # hide
```
![blends 2](../assets/figures/color-blends-translate-2.png)

### Using [`blendadjust`](@ref)

You can use [`blendadjust`](@ref) to modify the blend so that objects scaled and positioned after the blend was defined are rendered correctly.

```@example
using Luxor # hide
Drawing(600, 250, "../assets/figures/blend-adjust.png") # hide
origin() # hide
background("white") # hide
setline(20)

# first line
blendgoldmagenta = blend(Point(-100, 0), Point(100, 0), "gold", "magenta")
setblend(blendgoldmagenta)
line(Point(-100, -50), Point(100, -50))
strokepath()

# second line
blendadjust(blendgoldmagenta, Point(50, 0), 0.5, 0.5)
line(O, Point(100, 0))
strokepath()

# third line
blendadjust(blendgoldmagenta, Point(-50, 50), 0.5, 0.5)
line(Point(-100, 50), Point(0, 50))
strokepath()

# fourth line
gsave()
translate(0, 100)
scale(0.5, 0.5)
setblend(blendgoldmagenta)
line(Point(-100, 0), Point(100, 0))
strokepath()
grestore()

finish() # hide
nothing # hide
```

![blends adjust](../assets/figures/blend-adjust.png)

The blend is defined to span 200 units, horizontally
centered at 0/0. The top line is also 200 units long and
centered horizontally at 0/0, so the blend is rendered
exactly as you'd hope.

The second line is only half as long, at 100 units, centered
at 50/0, so [`blendadjust`](@ref) is used to relocate the
blend's center to the point 50/0 and scale it by 0.5
(`100/200`).

The third line is also 100 units long, centered at -50/0, so
again [`blendadjust`](@ref) is used to relocate the blend's
center and scale it.

The fourth line shows that you can translate and scale the
axes instead of adjusting the blend, if you use
[`setblend`](@ref) again in the new scene.

### Blend extensions

Use `setblendextend()` to control what happens when the
shape you're drawing occupies an area larger than the blend
you're using. In this example, the four possible modes are
used to draw the same 150 unit radius circle using a much
smaller 30 unit radial blend that starts at orange, and
passes through green, to blue. If the blend is smaller than
the shape, then a mode of "none" won't fill the entire
shape, just the area inside the boundary of the blend.

```@example
using Luxor, Colors # hide

function drawcircle_with_mode(extendmode)
    setdash("dot")
    circle(O, 150, :stroke)
    a_blend = blend(O, 0,  O, 30, "orange", "midnightblue")
    addstop(a_blend, 0.5, "green")
    setblend(a_blend)
    setblendextend(a_blend, extendmode)
    circle(O, 150, action = :fill)
    sethue("black")
    text(string(extendmode), Point(0, -tiles.tileheight/2), halign=:center)
end

d = Drawing(800, 800, :png) # hide
origin() # hide
background("grey40") # hide
tiles = Tiler(750, 750, 2, 2) # hide
fontsize(30) # hide

@layer begin
    translate(first(tiles[1]))
    drawcircle_with_mode("none")
end

@layer begin
    translate(first(tiles[2]))
    drawcircle_with_mode("repeat")
end

@layer begin
    translate(first(tiles[3]))
    drawcircle_with_mode("reflect")
end

@layer begin
    translate(first(tiles[4]))
    drawcircle_with_mode("pad")
end
finish() # hide
d # hide
```

## Compositing operators

Graphics software provides ways to modify how the virtual
"ink" is applied to previously-drawn graphic elements. In
PhotoShop and other software, the compositing process is
done using what are called [blend
modes](https://en.wikipedia.org/wiki/Blend_modes).

Use [`setmode`](@ref) to set the blending/compositing mode
of subsequent graphics.

The following examples place a blue circle with 0.7 opacity
on top of a red circle.

```@example
using Luxor # hide
d = Drawing(600, 600, :png) # hide
origin()
# transparent, no background
fontsize(15)
setline(1)
tiles = Tiler(600, 600, 4, 5, margin=30)
modes = length(Luxor.blendingmodes)
setcolor("black")
for (pos, n) in tiles
    n > modes && break
    gsave()
    translate(pos)
    box(O, tiles.tilewidth-10, tiles.tileheight-10, :clip)

    # calculate points for circles
    diag = (Point(-tiles.tilewidth/2, -tiles.tileheight/2),
            Point(tiles.tilewidth/2,  tiles.tileheight/2))
    upper = between(diag, 0.45)
    lower = between(diag, 0.55)

    # first red shape uses default blend operator
    setcolor(0.7, 0, 0, .7)
    circle(upper, tiles.tilewidth/4, action = :fill)

    # second blue shape shows results of blend operator
    setcolor(0, 0, 0.9, 0.7)
    blendingmode = Luxor.blendingmodes[mod1(n, modes)]
    setmode(blendingmode)
    circle(lower, tiles.tilewidth/4, action = :fill)

    clipreset()
    grestore()

    gsave()
    translate(pos)
    sethue("antiquewhite")
    txt = Luxor.blendingmodes[mod1(n, modes)]
    pos = O + (0, tiles.tilewidth/2)
    box(pos, textextents(txt)[3] + 5, 25, action = :fill)
    sethue("black")
    text(txt, pos, halign=:center, valign=:middle)
    grestore()
end
finish() # hide
d # hide
```

Notice in this example that clipping was used to restrict
the area affected by the blending process.

In Cairo, these blend modes are called *operators*. For a
more detailed explanation, refer to [the Cairo
documentation](https://www.cairographics.org/operators/).

You can access the list of modes with the unexported symbol
`Luxor.blendingmodes`.

## Meshes

A mesh provides smooth shading between three or four colors
across a region defined by lines or curves.

To create a mesh, use the [`mesh`](@ref) function and assign
the resulting mesh object to a variable. To use a mesh, pass
the mesh object variable to the [`setmesh`](@ref) function.

The [`mesh`](@ref) function accepts either an array of
Bézier paths or a polygon.

This basic example obtains a polygon from the drawing area
using `box(BoundingBox()...` and uses the four corners of
the mesh and the four colors in the array to build the mesh.
The [`paint`](@ref) function fills the drawing.

```@example
using Luxor, Colors # hide
Drawing(600, 600, "../assets/figures/mesh-basic.png") # hide
origin() # hide

garishmesh = mesh(
    box(BoundingBox(), vertices=true),
    ["purple", "green", "yellow", "red"])

setmesh(garishmesh)

paint()

setline(2)
sethue("white")
hypotrochoid(180, 81, 130, :stroke)
finish() # hide
nothing # hide
```

![mesh 1](../assets/figures/mesh-basic.png)

The next example uses a Bézier path conversion of a square
as the outline of the mesh. Because the box to be filled is
larger than the mesh's outlines, not all the box is filled.

```@example
using Luxor, Colors # hide
Drawing(600, 600, "../assets/figures/mesh1.png") # hide
origin() # hide
background("white") # hide
setcolor("grey50")
circle.([Point(x, y) for x in -200:25:200, y in -200:25:200], 10, action = :fill)

bp = makebezierpath(box(O, 300, 300, vertices=true), smoothing=.4)
setline(3)
sethue("black")

drawbezierpath(bp, :stroke)
mesh1 = mesh(bp, [
    Colors.RGBA(1, 0, 0, 1),   # bottom left, red
    Colors.RGBA(1, 1, 1, 0.0), # top left, transparent
    Colors.RGB(0, 0, 1),       # top right, blue
    Colors.RGB(1, 0, 1)        # bottom right, purple
    ])
setmesh(mesh1)
box(O, 500, 500, action = :fillpreserve)
sethue("grey50")
strokepath()

finish() # hide
nothing # hide
```

![mesh 1](../assets/figures/mesh1.png)

The second example uses a polygon defined by [`ngon`](@ref)
as the outline of the mesh. The mesh is drawn when the path
is stroked.

```@example
using Luxor # hide
Drawing(600, 600, "../assets/figures/mesh2.png") # hide
origin() # hide
background("white") # hide
pl = ngon(O, 250, 3, π/6, vertices=true)
mesh1 = mesh(pl, [
    "purple",
    "green",
    "yellow"
    ])
setmesh(mesh1)
setline(180)
poly(pl, :strokepreserve, close=true)
setline(5)
sethue("black")
strokepath()
finish() # hide
nothing # hide
```

![mesh 2](../assets/figures/mesh2.png)

So far these meshes have contained a single defined area - a
single 'patch'. It's possible to construct a mesh that
consists of more than one patch. The following example uses
[`add_mesh_patch`](@ref) to build a single mesh consisting of
100 smaller patches, which are placed next to each other but
don't always define the same colors at identical control
points.

```@example
using Luxor, Colors, Random # hide

d = Drawing(500, 500, :png) # hide
origin() # hide
Random.seed!(1) # hide
tiles = Tiler(500, 500, 10, 10, margin=0)

the_mesh = mesh(rect(first(tiles[1]), 10, 10), ["red"])

col1 = RGB(rand(), rand(), rand())
col2 = RGB(rand(), rand(), rand())
col3 = RGB(rand(), rand(), rand())
col4 = RGB(rand(), rand(), rand())
for (pos, n) in tiles
    bx = box(
        pos - (tiles.tilewidth/2, tiles.tileheight/2),
        pos + (tiles.tilewidth/2, tiles.tileheight/2),
        vertices = true)
    add_mesh_patch(the_mesh, bx,
        Random.shuffle!([col1, col2, col3, col4]))
end
setmesh(the_mesh)
paint()
finish() # hide
d # hide
```

The next example constructs a conical mesh from many
triangular patches, where each patch shows a different area
of the HSB color space. Any graphic drawn after `setmesh()`, such as the hypotrochoid, is drawn using the mesh.

```@example
using Luxor, Colors
@draw begin
    background("grey10")
    radius = 300
    L = 300
    mesh1 = mesh([Point(0, 0), polar(radius, 0), polar(radius, 2π / 100)], [RGBA(0, 0, 0, 0)])
    sethue("red")
    for θ in range(0, 2π, length=L)
        t = [O, O + polar(radius, θ), O + polar(radius, θ + 2π / L)]
        add_mesh_patch(mesh1, t,
            [
                HSB(rescale(θ, 0, 2π, 0, 360), 0.9, 1),
                HSB(rescale(θ, 0, 2π, 0, 360), 0.9, 1),
                HSB(rescale(θ, 0, 2π, 0, 360), 0.9, 1),
            ])
    end
    setmesh(mesh1)
    hypotrochoid(350, 155, 100, :stroke)
end
```

## Masks

A simple mask function lets you use a circular or
rectangular shape to control graphics that are drawn over
it. [`mask`](@ref) takes a position and a shape, and returns
a value between 0 and 1 for that position, depending on its
position relative to the shape.

In the first example, the gray color of each tile is
determined by its location relative to the center of the
masking circle `(O, bw/2)`; the value is `1.0` at the
center, and `0.0` at the circumference. The value could be
used to control opacity, shape, or anything else that is
relevant to graphics at a particular position.

```@example
using Luxor # hide
Drawing(610, 610, "../assets/figures/mask.png") # hide
origin() # hide
tiles = Tiler(600, 600, 15, 15, margin=0)
bw = boxwidth(BoundingBox())
for (pos, n) in tiles
    setgray(mask(pos, O, bw/2))
    box(pos, tiles.tilewidth, tiles.tileheight, action = :fillstroke)
end

sethue("white")
circle(O, bw/2, :stroke)
finish() # hide
nothing # hide
```

![mask](../assets/figures/mask.png)

The second example uses the distance of each tile relative to the rectangle `O, bw, bw` to determine the gray color.

```@example
using Luxor # hide
Drawing(600, 600, "../assets/figures/mask1.png") # hide
origin() # hide

tiles = Tiler(600, 600, 30, 30)

bw = boxwidth(BoundingBox())
bh = boxheight(BoundingBox())
for (pos, n) in tiles
    mv = mask(pos, O, bw, bh, easingfunction=easeinoutcubic)
    setgray(mv)
    box(pos, tiles.tilewidth, tiles.tileheight, action = :fillstroke)
end

finish() # hide
nothing # hide
```

![mask1](../assets/figures/mask1.png)

# Drawings as image matrices

# Images as matrices

While drawing a PNG drawing, you can at any time copy the current graphics in a drawing as a matrix of colored pixels, using the [`image_as_matrix`](@ref) function.

With the
[`@imagematrix`](@ref) macro, you can create a drawing
in the usual way, and then return the
result as a matrix of colored pixels.

This code draws a very small PNG image and also uses the `image_as_matrix()` function to stores the pixels in `mat` as a `25×25 reinterpret(ColorTypes.ARGB32, ::Matrix{UInt32}):`.

```julia
using Luxor
Drawing(25, 25, :png)
origin()
background(randomhue()...)
sethue("red")
fontsize(20)
fontface("Georgia")
text("42", halign=:center, valign=:middle)
mat = image_as_matrix()
finish()
preview()
```

The next example draws an ampersand and then processes the
pixels further in Images.jl.

```julia
using Luxor, Colors, Images, ImageFiltering

m = @imagematrix begin
        background("black")
        sethue("white")
        fontface("Georgia")
        fontsize(180)
        text("&", halign=:center, valign=:middle)
end 200 200

function convertmatrixtocolors(m)
    return convert.(Colors.RGBA, m)
end

img = convertmatrixtocolors(m)

imfilter(img, Kernel.gaussian(10))
```

![image matrix](../assets/figures/ampersand-matrix.png)

[`image_as_matrix`](@ref) returns a array of ARGB32
(AlphaRedGreenBlue) values. Each ARGB value encodes the Red,
Green, Blue, and Alpha 8-bit values of a pixel into a single 32
bit integer.

You can display the matrix using, for example, Images.jl.

```julia
using Luxor, Images

# in Luxor

Drawing(250, 250, :png)
origin()
background(randomhue()...)
sethue("red")
fontsize(200)
fontface("Georgia")
text("42", halign=:center, valign=:middle)
mat = image_as_matrix()
finish()

# in Images

img = RGB.(mat)
# img = Gray.(mat) # for greyscale

imfilter(img, Kernel.gaussian(10))
```

In Luxor:

![42 image array](../assets/figures/42.png)

In Images:

![42 image array](../assets/figures/42gaussian.png)

The next example makes two drawings. The first draws a red rectangle, then copies the
drawing in its current state into a matrix called `mat1`. Next it adds a blue
triangle, and copies the updated drawing state into `mat2`.

In the second drawing, values from these two matrices are
tested, and table cells are randomly colored depending on
the corresponding values ... this is a primitive Boolean
operation.

```@example
using Luxor, Colors, Random # hide
Random.seed!(42) # hide

# first drawing

Drawing(40, 40, :png)
origin()
background("black")
sethue("red")
box(Point(0, 0), 40, 15, :fill)
mat1 = image_as_matrix()
sethue("blue")
setline(10)
setopacity(0.6)
ngon(Point(0, 0), 10, 3, 0, :stroke)
mat2 = image_as_matrix()
finish()

# second drawing

Drawing(400, 400, "../assets/figures/image-drawings.svg")
background("grey20")
origin()
t = Table(40, 40, 4, 4)
sethue("white")
rc = CartesianIndices(mat1)
for i in rc
    r, c = Tuple(i)
    pixel1 = convert(Colors.RGBA, mat1[r, c])
    pixel2 = convert(Colors.RGBA, mat2[r, c])
    if red(pixel1) > .5 && blue(pixel2) > .5
        randomhue()
        box(t, r, c, :fillstroke)
    end
end
finish() # hide
nothing # hide
```

The first image (enlarged) shows the `mat1` matrix as red, `mat2` as blue.

![intermediate](../assets/figures/image-drawing-intermediate.png)

In the second drawing, a table with 1600 squares is colored according to the values in the matrices.

![image drawings](../assets/figures/image-drawings.svg)

(You can use `collect` to gather the re-interpreted values together.)

```@meta
DocTestSetup = quote
    using Luxor, Dates, Colors
end
```

# Introduction to Luxor

Luxor is a Julia package for drawing simple static 2D vector graphics. It provides basic drawing functions and utilities for working with shapes, polygons, clipping masks, PNG and SVG images, turtle graphics, and simple animations.

!["luxor gallery"](assets/figures/luxorgallery.svg)

The focus of Luxor is on simplicity and ease of use: it should be easier to use than plain [Cairo.jl](https://github.com/JuliaLang/Cairo.jl), with shorter names, fewer underscores, default contexts, and simplified functions.

For more complex and sophisticated graphics in 2D and 3D, [Makie.jl](https://docs.makie.org/stable/) is the best choice.

Luxor is thoroughly procedural and static: your code issues a sequence of simple graphics 'commands' until you've completed a drawing, then the results are saved into a PDF, PNG, SVG, or EPS file.

There are some Luxor-related videos on [YouTube](https://www.youtube.com/channel/UCfd52kTA5JpzOEItSqXLQxg), and some Luxor-related blog posts at [cormullion.github.io/](https://cormullion.github.io/).

Luxor is designed primarily for drawing static pictures and simple animations. If you want to build complex or elaborate animations, use [Javis.jl](https://github.com/JuliaAnimators/Javis.jl) and [Makie](https://docs.makie.org/stable/).

Luxor isn't interactive: for building interactivity, look at [Pluto.jl](https://github.com/fonsp/Pluto.jl) and [Makie](https://docs.makie.org/stable/).


Please submit issues and pull requests on [GitHub](https://github.com/JuliaGraphics/Luxor.jl). Original version by [cormullion](https://github.com/cormullion), much improved with contributions from the Julia community.

## Installation and basic usage

Install the package using the package manager:

```julia-repl
] add Luxor
```

To use Luxor, type:

```julia
using Luxor
```

To test:

```julia-repl
julia> @svg juliacircles()
```

or

```julia-repl
julia> @png juliacircles()
```

which should create a graphic file and possibly also display and/or open it, depending on your environment.

## Documentation

This documentation was built using [Documenter.jl](https://github.com/JuliaDocs).

```@example
using Dates # hide
println("Documentation built $(Dates.now()) with Julia $(VERSION) on $(Sys.KERNEL)") # hide
```

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Tables and grids

You often want to position graphics at regularly-spaced locations on the drawing. These positions can be provided by:

- `Tiler`: a rectangular grid iterator which you specify by enclosing area, and the number of rows and columns
- `Partition`: a rectangular grid iterator which you specify by enclosing area, and the width and height of each cell
- `Grid` a rectangular grid iterator, where points are supplied on demand
- `Table`: a rectangular grid iterator which you specify by providing row and column numbers, row heights and column widths

These are types which act as iterators. Their job is to provide you with centerpoints; you'll probably want to use these in combination with the cell's widths and heights.

There are also functions to make hexagonal grids ([Hexagonal grids](@ref) grids and [EquilateralTriangleGrid](@ref) grids.

## Tiles and partitions

The drawing area (or any other area) can be divided into rectangular tiles (as rows and columns) using the `Tiler` and `Partition` iterators.

The [`Tiler`](@ref) iterator returns the center point and tile number of each tile in turn.

In this example, every third tile is divided up into subtiles and colored:

```@example
using Luxor, Random # hide
Drawing(800, 500, "../assets/figures/tiler.png") # hide
background("white") # hide
origin() # hide
Random.seed!(1) # hide
fontsize(20) # hide
tiles = Tiler(800, 500, 4, 5, margin=5)
for (pos, n) in tiles
    randomhue()
    box(pos, tiles.tilewidth, tiles.tileheight, action=:fill)
    if n % 3 == 0
        gsave()
        translate(pos)
        subtiles = Tiler(tiles.tilewidth, tiles.tileheight, 4, 4, margin=5)
        for (pos1, n1) in subtiles
            randomhue()
            box(pos1, subtiles.tilewidth, subtiles.tileheight, action=:fill)
        end
        grestore()
    end
    sethue("white")
    textcentered(string(n), pos + Point(0, 5))
end
finish() # hide
nothing # hide
```

![tiler](../assets/figures/tiler.png)

[`Partition`](@ref) is like `Tiler`, but you specify the width and height of the tiles, rather than
how many rows and columns of tiles you want.

You can obtain the centerpoints of all the tiles in one go with:

```julia
first.(collect(tiles))
```

or obtain ranges with:

```julia
tiles[1:2:end]
```

## Tables

The [`Table`](@ref) iterator can be used to define tables: rectangular grids with a specific number of rows and columns.

Unlike a `Tiler`, the `Table` iterator lets you have columns with different widths, and rows with different heights.

!!! note

    Luxor generally tries to keep to the Julia convention of
    ‘width’ then ‘height’, ‘row’ then ‘column’. This flavour of
    consistency can sometimes be confusing if you’re
    expecting other kinds of consistency, such as ‘x before
    y’ or ‘column major’.)

Tables don't store data, of course, but are designed to help you draw tabular data.

To create a simple table with 3 rows and 4 columns, using the default width and height (100):

```julia-repl
julia> t = Table(3, 4);
```

When you use this as an iterator, you can get the coordinates of the center of each cell, and its number:

```julia-repl
julia> for i in t
           println("row: $(t.currentrow), column: $(t.currentcol), center: $(i[1])")
       end
row: 1, column: 1, center: Luxor.Point(-150.0, -100.0)
row: 1, column: 2, center: Luxor.Point(-50.0, -100.0)
row: 1, column: 3, center: Luxor.Point(50.0, -100.0)
row: 1, column: 4, center: Luxor.Point(150.0, -100.0)
row: 2, column: 1, center: Luxor.Point(-150.0, 0.0)
row: 2, column: 2, center: Luxor.Point(-50.0, 0.0)
row: 2, column: 3, center: Luxor.Point(50.0, 0.0)
row: 2, column: 4, center: Luxor.Point(150.0, 0.0)
row: 3, column: 1, center: Luxor.Point(-150.0, 100.0)
row: 3, column: 2, center: Luxor.Point(-50.0, 100.0)
row: 3, column: 3, center: Luxor.Point(50.0, 100.0)
row: 3, column: 4, center: Luxor.Point(150.0, 100.0)
```

You can also access row and column information:

```julia-repl
julia> for r in 1:size(t)[1]
           for c in 1:size(t)[2]
               @show t[r, c]
           end
       end
t[r, c] = Luxor.Point(-150.0, -100.0)
t[r, c] = Luxor.Point(-50.0, -100.0)
t[r, c] = Luxor.Point(50.0, -100.0)
t[r, c] = Luxor.Point(150.0, -100.0)
t[r, c] = Luxor.Point(-150.0, 0.0)
t[r, c] = Luxor.Point(-50.0, 0.0)
t[r, c] = Luxor.Point(50.0, 0.0)
t[r, c] = Luxor.Point(150.0, 0.0)
t[r, c] = Luxor.Point(-150.0, 100.0)
t[r, c] = Luxor.Point(-50.0, 100.0)
t[r, c] = Luxor.Point(50.0, 100.0)
t[r, c] = Luxor.Point(150.0, 100.0)
```

The next example creates a table with 10 rows and 10 columns, where each cell is 50 units wide and 35 high.

```@example
using Luxor, Random # hide
@drawsvg begin # hide
background("white") # hide
origin() # hide
Random.seed!(42) # hide
fontface("Helvetica-Bold") # hide
fontsize(20) # hide
sethue("black")

t = Table(10, 10, 50, 35) # 10 rows, 10 columns, 50 wide, 35 high

hundred = 1:100

for n in 1:length(t)
   text(string(hundred[n]), t[n], halign=:center, valign=:middle)
end

setopacity(0.5)
sethue("thistle")
# row 3, every column
markcells(t, getcells(t, 3, :), func = (args...) -> (
        circle(args[1], args[2]/2, :fill)
    ), action=:stroke)

end 800 400 # hide
```

You can access rows or columns in the usual Julian way. See [Selecting and highlighting cells](@ref) for details about how to select and mark cells.

Notice that the table is drawn row by row, whereas 2D Julia arrays are usually accessed column by column.

### Varying row heights and column widths

To specify varying row heights and column widths, supply arrays or ranges to the `Table` constructor. The next example has logarithmically increasing row heights, and four columns of width 130 points:

```@example
using Luxor # hide
Drawing(600, 400, "../assets/figures/table1.png") # hide
background("white") # hide
origin() # hide

t = Table(10 .^ range(0.7, length=25, stop=1.5), fill(130, 4))

for (pt, n) in t
    setgray(rescale(n, 1, length(t), 0, 1))
    box(pt, t.colwidths[t.currentcol], t.rowheights[t.currentrow], :fill)
    sethue("white")
    fontsize(t.rowheights[t.currentrow])
    text(string(n), pt, halign=:center, valign=:middle)
end

finish() # hide
nothing # hide
```

![table 1](../assets/figures/table1.png)

To fill table cells, it's useful to be able to access the table's row and column specifications (using the `colwidths` and `rowheights` fields), and iteration can also provide information about the current row and column being processed (`currentrow` and `currentcol`).

To ensure that graphic elements don't stray outside the cell walls, you can use a clipping region.

### Drawing arrays and dataframes

With a little bit of extra work you can write code that draws objects like arrays and dataframes combining text with graphic features. For example, this code draws arrays visually and numerically.

```@example
using Luxor, Random # hide
function drawbar(t::Table, data, row, column, minvalue, maxvalue, barheight)
    setline(1.5)
    cellwidth = t.colwidths[column] - 10
    leftmargin = t[row, column] - (cellwidth/2, 0)
    sethue("gray70")
    box(leftmargin - (0, barheight/2), leftmargin + (cellwidth, barheight/2), :fill)
    boxwidth = rescale(data[row, column], minvalue, maxvalue, 0, cellwidth)
    sethue("red")
    box(leftmargin - (0, barheight/2), leftmargin + (boxwidth, barheight/2), :fill)
    sethue("black")
    line(leftmargin + (boxwidth, -barheight/2),
         leftmargin + (boxwidth, +barheight/2),
         :stroke)
    text(string(round(data[row, column], digits=3)), t[row, column] - (cellwidth/2, 10),
         halign=:left)
end

Drawing(700, 250, "../assets/figures/arraytable.svg")  # hide
origin() # hide
background("white") # hide
Random.seed!(42) # hide
A = rand(6, 6)
l, h = extrema(A)
rt, ct = size(A)
t = Table(size(A), (80, 30))
fontface("Georgia")
fontsize(12)
for r in 1:rt
    for c in 1:ct
        drawbar(t, A, r, c, l, h, 10)
    end
end
finish() # hide
nothing # hide
```

![array table](../assets/figures/arraytable.svg)

## Selecting and highlighting cells

With [`getcells()`](@ref) and [`markcells()`](@ref) you can select and apply graphics to cells of Tables and Tilers.

`getcells()` has two ways to select cells: either by their single index value, or by specifying rows and columns.
Remember, unlike with typical Julia arrays, in a 2 row by 4 column table, the cell at row 1, column 4 will have the index number 4, not 7:

```plain
 ┌───┬───┬───┬───┐
 │ 1 │ 2 │ 3 │ 4 │
 ├───┼───┼───┼───┤
 │ 5 │ 6 │ 7 │ 8 │
 └───┴───┴───┴───┘
```

The function returns an array of cells in Tuples, each Tuple holding the coordinate of the cell center and its index number.

The `markcells()` function takes a Table or Tiler, and the selected cells made by `getcells()`, and, by default, draws a box around each one. You can instead choose the `:fill` action, or supply a four-argument function that adds graphics relevant to the cell's position, width, height, and number.

```@example
using Luxor # hide
@drawsvg begin
    background("grey10")
    fontsize(10)

    t = Tiler(600, 300, 6, 6)

    sethue("cyan")
    # mark even cells
    markcells(t, getcells(t, 2:2:36))

    sethue("orange")
    setopacity(0.5)
    # fill odd cells orange
    markcells(t, getcells(t, 1:2:35), action=:fill)

    sethue("blue")
    setopacity(0.5)
    # fill cells in rows 2:5, columns 3:4 blue
    markcells(t, getcells(t, 2:5, 3:4), action=:fill)
    setopacity(1)

    # draw circles and index numbers for primes
    primes = filter(n -> all(i -> n % i != 0, 2:floor(Int, sqrt(n))), 2:36)
    markcells(t, getcells(t, primes), func=(pt, w, h, n) -> begin
        sethue("purple")
        circle(pt, h / 2, :fill)
        sethue("white")
        text(string(n), pt, halign=:center, valign=:middle)
    end)
end 600 300
```

## Grids

You might also find a use for a grid. Luxor provides a simple grid utility. Grids are lazy: they'll supply the next point on the grid when you ask for it.

Define a rectangular grid with `GridRect`. Get the next grid point from a grid with `nextgridpoint(grid)`.

```@example
using Luxor, Random # hide
Drawing(700, 250, "../assets/figures/grids.png")  # hide
background("white") # hide
fontsize(14) # hide
translate(50, 50) # hide
Random.seed!(42) # hide
grid = GridRect(O, 40, 80, (10 - 1) * 40)
for i in 1:20
    randomhue()
    p = nextgridpoint(grid)
    squircle(p, 20, 20, :fill)
    sethue("white")
    text(string(i), p, halign=:center)
end
finish() # hide
nothing # hide
```

![grids](../assets/figures/grids.png)

## Hexagonal grids

Use the hexagon constructors `HexagonOffsetOddR`, `HexagonOffsetEvenR`, `HexagonAxial`, and `HexagonCubic` to define a hexagonal tile on a grid, using _hexagon index values_ to specify their location.

You can use [`hexcenter()`](@ref) to find the Cartesian coordinates of the center of a hexagonal tile on the grid, and [`hextile()`](@ref) to return the Cartesian coordinates of the vertices of the tile.

For example, this code draws a hexagon with the hexagonal indices `0 0` on a grid centred at the origin with grid spacing of 100 units:

```@example
using Luxor, Colors # hide
@drawsvg begin  # hide
sethue("purple")
poly(hextile(HexagonOffsetOddR(0, 0, 100)), :fill)
end 600 300  # hide
```

By default the hexagonal grid indices `0 0` are located at the drawing's origin (`Point(0, 0)`). You can change this, and also specify the width and height of the hexagonal grid.

By using different index values you can draw hexagons at other locations on the hexagonal grid.

```@example
using Luxor, Colors  # hide
@drawsvg begin  # hide
sethue("purple")
poly(hextile(HexagonOffsetOddR(-1, -1, 40)), :fill)
sethue("orange")
poly(hextile(HexagonOffsetOddR(-1, 1, 40)), :fill)
sethue("green")
poly(hextile(HexagonOffsetOddR(1, 1, 40)), :fill)
sethue("blue")
poly(hextile(HexagonOffsetOddR(1, -1, 40)), :fill)
end 600 300  # hide
```

### Hexagonal grid indexing

Whereas rectangular grids can be indexed using x ("column") and y ("row") integers, hexagonal grids can be indexed in various ways. For example, odd-numbered "rows" can be shifted to the right:

```@example
using Luxor, Colors, Random  # hide
@drawsvg begin  # hide
fontsize(16)
for q in -2:2 # vertical
    for r in -2:2 # horizontal
        pgon = hextile(HexagonOffsetOddR(q, r, 40))
        sethue(HSB(rand(1:360), 0.6, 0.7))
        poly(pgon, :fill)
        sethue("white")
        text("$q", hexcenter(HexagonOffsetOddR(q, r, 40)),
            halign=:left, valign=:top)
        text("$r", hexcenter(HexagonOffsetOddR(q, r, 40)),
            halign=:right, valign=:bottom)
    end
end
end 600 350  # hide
```

Alternatively, even-numbered "rows" can be shifted to the right:

```@example
using Luxor, Colors, Random  # hide
@drawsvg begin # hide
fontsize(16)
for q in -2:2 # vertical
    for r in -2:2 # horizontal
        pgon = hextile(HexagonOffsetEvenR(q, r, 40))
        sethue(HSB(rand(1:360), 0.6, 0.7))
        poly(pgon, :fill)
        sethue("white")
        text("$q", hexcenter(HexagonOffsetEvenR(q, r, 40)),
            halign=:left, valign=:top)
        text("$r", hexcenter(HexagonOffsetEvenR(q, r, 40)),
            halign=:right, valign=:bottom)
    end
end
end 600 350 # hide
```

The cubic hexagon constructor accepts three coordinates:

```@example
using Luxor, Colors, Random  # hide
@drawsvg begin # hide
for q in -2:2
    for r in -2:2
        pgon = hextile(HexagonCubic(q, r, -q - r, 25))
        sethue(HSB(rand(1:360), 0.6, 0.7))
        poly(pgon, :fill)
    end
end
end 600 350 # hide
```

The axial constructor accepts two:

```@example
using Luxor, Colors, Random  # hide
@drawsvg begin # hide
for q in -2:2
    for r in -2:2
        pgon = hextile(HexagonAxial(q, r, 25))
        sethue(HSB(rand(1:360), 0.6, 0.7))
        poly(pgon, :fill)
    end
end
end 600 350 # hide
```

### Hexagonal rings

The `hexring()` function finds the `n`th ring of adjacent hexagons surrounding a hexagon.

The first ring consists of six hexagons. Ring `n` consists of `6n` hexagons.

```@example
using Luxor # hide
using Colors # hide

@drawsvg begin # hide
hexa = HexagonOffsetOddR(0, 0, 10)
for i in 1:15
    ring = hexring(i, hexa)
    sethue(HSB(rescale(i, 1, 15, 0, 360), 0.8, 0.8))
    for (n, h) in enumerate(ring)
        poly(hextile(h), :fillpreserve)
    end
end
end # hide
```

### Neighbouring hexagons

To find the six hexagons that surround a hexagon, use `hexneighbors()`.

```@example
using Luxor # hide
using Colors # hide

@drawsvg begin # hide
for i in 1:10
    sethue(HSB(rand(0:360), 0.8, 0.8))
    hex1 = HexagonOffsetOddR(rand(-7:7), rand(-7:7), 15)
    for neighbor in hexneighbors(hex1)
        poly(hextile(neighbor), :fill)
        circle(hexcenter(neighbor), 25, :stroke)
    end
end
end # hide
```

### Spiralling hexagons

The [`hexspiral()`](@ref) function generates a spiral of hexagons around a central hexagon to form `n` rings of hexagons.

```@example
using Luxor, Colors
@drawsvg begin # hide
background("black")
hexagon = HexagonOffsetEvenR(0, 0, 16)
setline(0.75)
for (n, h) in enumerate(hexspiral(hexagon, 10))
    sethue(HSB(mod1(5n, 360), 0.8, 0.8))
    poly(hextile(h), :fillpreserve)
    sethue("black")
    text(string(n), hexcenter(h), halign=:center)
    strokepath()
end
end # hide
```

## EquilateralTriangleGrid

To create a grid of equilateral triangles, you can use
[`EquilateralTriangleGrid`](@ref). Provide the starting point, the side length,
and the number of rows and columns. The iterator provides a tuple of the
vertices and number for each triangle.

```@example
using Luxor, Colors
@drawsvg begin # hide
    background("black")
    nrows = 12
    ncols = 20
    side = 45
    startpoint = boxtopleft() + (50, 50)
    eqtg = EquilateralTriangleGrid(startpoint, side, nrows, ncols)

    for e in eqtg
        vertices, trianglenumber = e
        sethue(HSB(rescale(trianglenumber, 0, nrows * ncols, 0, 360), 
            0.7, 0.8))
        poly(vertices, :fillpreserve, close=true)
        sethue("black")
        strokepath()
        text(string(trianglenumber), halign=:center, polycentroid(vertices))
    end
end # hide
```

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```

# Fonts available on Linux CI systems

When this docmnent is built on Github CI, the following fonts are available.

```@raw html
<details closed><summary>Code for this figure</summary>
```

This code generates the figure below.

```@example fonts
using Luxor
fonts = [
    "DejaVuMathTeXGyre Regular",
    "DejaVuMathTeXGyre",
    "DejaVuSans Bold",
    "DejaVuSans BoldOblique",
    "DejaVuSans ExtraLight",
    "DejaVuSans Oblique",
    "DejaVuSans",
    "DejaVuSans Bold",
    "DejaVuSans Bold Oblique",
    "DejaVuSans Condensed Bold",
    "DejaVuSans Condensed BoldOblique",
    "DejaVuSans Condensed Oblique",
    "DejaVuSans Condensed",
    "DejaVuSans Condensed Bold",
    "DejaVuSans Condensed Bold Oblique",
    "DejaVuSans Condensed Oblique",
    "DejaVuSans ExtraLight",
    "DejaVuSansMono Bold",
    "DejaVuSansMono Bold Oblique",
    "DejaVuSansMono Oblique",
    "DejaVuSansMono",
    "DejaVuSansMono Bold",
    "DejaVuSansMono Bold Oblique",
    "DejaVuSansMono Oblique",
    "DejaVuSans Oblique",
    "DejaVuSerif Bold",
    "DejaVuSerif Bold Italic",
    "DejaVuSerif Italic",
    "DejaVuSerif",
    "DejaVuSerif Bold",
    "DejaVuSerif Bold Italic",
    "DejaVuSerif Condensed Bold",
    "DejaVuSerif Condensed Bold Italic",
    "DejaVuSerif Condensed Italic",
    "DejaVuSerif Condensed",
    "DejaVuSerif Condensed Bold",
    "DejaVuSerif Condensed Bold Italic",
    "DejaVuSerif Condensed Italic",
    "DejaVuSerif Italic",
    "Lato Black",
    "Lato BlackItalic",
    "Lato Bold",
    "Lato BoldItalic",
    "Lato Hairline",
    "Lato HairlineItalic",
    "Lato Heavy",
    "Lato HeavyItalic",
    "Lato Italic",
    "Lato Light",
    "Lato LightItalic",
    "Lato Medium",
    "Lato MediumItalic",
    "Lato Regular",
    "Lato Semibold",
    "Lato Semibold Italic",
    "Lato Thin",
    "Lato Thin Italic",
    "Lato Black",
    "Lato Black Italic",
    "Lato Bold",
    "Lato Bold Italic",
    "Lato Hairline",
    "Lato Hairline Italic",
    "Lato Heavy",
    "Lato Heavy Italic",
    "Lato Italic",
    "Lato Light",
    "Lato Light Italic",
    "Lato Medium",
    "Lato Medium Italic",
    "Lato Regular",
    "Lato Regular Italic",
    "Lato Semibold",
    "Lato Semibold Italic",
    "Lato Thin",
    "Lato Thin Italic",
    "LiberationMono Bold",
    "LiberationMono Bold Italic",
    "LiberationMono Italic",
    "LiberationMono",
    "LiberationMono Bold",
    "LiberationMono Bold Italic",
    "LiberationMono Italic",
    "LiberationMono Regular",
    "LiberationSans Bold",
    "LiberationSans Bold Italic",
    "LiberationSans Italic",
    "LiberationSans",
    "LiberationSans Bold",
    "LiberationSans Bold Italic",
    "LiberationSans Italic",
    "LiberationSansNarrow Bold",
    "LiberationSansNarrow Bold Italic",
    "LiberationSansNarrow Italic",
    "LiberationSansNarrow",
    "LiberationSansNarrow Bold",
    "LiberationSansNarrow Bold Italic",
    "LiberationSansNarrow Italic",
    "LiberationSansNarrow Regular",
    "LiberationSans Regular",
    "LiberationSerif Bold",
    "LiberationSerif Bold Italic",
    "LiberationSerif Italic",
    "LiberationSerif",
    "LiberationSerif Bold",
    "LiberationSerif Bold Italic",
    "LiberationSerif Italic",
    "LiberationSerif Regular",
]
function drawfonts()
    d = @drawsvg begin
        background("black")
        @layer begin
            translate(-150, 0)
            sethue("white")
            tableheader = Table([5], [400, 400], boxtopcenter() + (0, 50))
            fontsize(30)
            text("Toy API", tableheader[1])
            text("Pro APi", tableheader[2])
            table = Table(fill(30, length(fonts)), [400, 400])
            fsize = 20
            fontsize(fsize)
            n = 1
            for font in fonts
                @layer begin
                    fontface(font)
                    text(font, table[n])
                end
                @layer begin
                    fface = replace(font,
                        "Serif" => " Serif",
                        "Bold" => " Bold",
                        "Semibold" => " Semibold",
                        "Black" => " Black",
                        "Heavy" => " Heavy",
                        "Medium" => " Medium",
                        "Light" => " Light",
                        "Thin" => " Thin",
                        "Hairline" => " Hairline",
                        "Narrow" => " Narrow",
                        "Regular" => " Regular",
                        "Sans" => " Sans",
                        "Mono" => " Mono",
                        "Italic" => " Italic",
                        "Oblique" => " Oblique",
                        "Condensed" => " Condensed",
                        "Extra" => " Extra",
                        "-" => " ",
                        )
                    setfont(fface, fsize)
                    settext(fface, table[n+1])
                end
                @layer begin
                    setopacity(0.5)
                    line(table[n] + (0, 8), table[n+1] + (table.colwidths[2], 8), :stroke)
                end
                n += 2
            end
        end
        sethue("white")
        fontsize(40)
        text("--------:--------", boxbottomcenter() + (0, -30), halign=:center)
    end 1200 3400
    return d
end
nothing # hide
```

```@raw html
</details>
```

```@example fonts
drawfonts()
```

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Animation helper functions

!!! note

    [Javis.jl](https://github.com/JuliaAnimators/Javis.jl) is the best way to make animated graphics  with Julia.

Luxor provides some functions to help you create simple animations. It provides some assistance in creating lots of individual frames, and you have the option of stitching these together to form a moving animation, as an animated GIF or video file.

If you're looking for a way to display animations in another window, with live updates, see the [Interactive graphics and Threads](@ref) section.

There are four steps to creating an animation.

1. Use `Movie` to create a Movie object which determines the title and dimensions.

2. Define some functions that draw the graphics for specific frames.

3. Define one or more Scenes that call these functions for specific frames.

4. Call the [`animate()`](@ref) function, passing in the movie and the scenes. This creates all the frames and saves them in a temporary directory.

You can also use the `creategif = true` option to make an animated GIF, or the `createmovie = true` option to make a video file.

## Example

```julia
using Luxor, Colors
demo = Movie(400, 400, "test")

function backdrop(scene, framenumber)
    background("black")
end

function frame(scene, framenumber)
    sethue(Colors.HSV(framenumber, 1, 1))
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(polar(100, -π/2 - (eased_n * 2π)), 80, :fill)
    text(string("frame $framenumber of $(scene.framerange.stop)"),
        Point(O.x, O.y-190),
        halign=:center)
    text(scene.opts,
        boxbottomcenter(BoundingBox()),
        halign=:center,
        valign=:bottom)
end

animate(demo, [
    Scene(demo, backdrop, 0:359),
    Scene(demo, frame, 0:359,
        easingfunction=easeinoutcubic,
        optarg="made with Julia")
    ],
    creategif=true)
```

![animation example](../assets/figures/animation.gif)

In this example, the movie uses two scenes, each specifying a function to draw frames from 0 to 359. For each frame numbered 0 to 359, the graphics are drawn by both the `backdrop` and `frame` functions, in that order. A drawing is automatically created (in PNG format) and centered ([`origin`](@ref)) so you can start drawing immediately. The [`finish`](@ref) function is automatically called when all the drawing functions in the scenes have completed, and the process starts afresh for the next frame. The second scene, calling the `frame` function, shows how you can pass optional information to the function.

## Making the animation

You can request that animations are made automatically:

- the `creategif` keyword when set to `true` makes an animated GIF

- the `createmovie` keyword when set to `true` makes an animated video file

The `pathname` keyword argument lets you specify a pathname; if you don't provide one, it will be saved in a temporary folder (and listed in the REPL).

Many movie editing programs, such as Final Cut Pro, will also let you import sequences of still images into a movie timeline.

If you want to use a custom `ffmpeg` command, you can use load the FFMPEG module, and write code such as this:

```julia
using Luxor, FFMPEG

...

# store the frames in a temp directory
tempdirectory = "/tmp/temp/"

animate(movie, [
        Scene(movie, frame, 1:50)
    ], 
    tempdirectory=tempdirectory)

# run a custom ffmpeg command
FFMPEG.exe(`-r 30 -f image2 -i $(tempdirectory)/%10d.png -c:v libx264 -r 30 -pix_fmt yuv420p -y /tmp/animation.mp4`)

```

`ffmpeg` has literally hundreds of options, which include codec selection, framerate adjustment, and color palette tweaking.

### Passing information to the frame() function

If you want to pass information to the `frame` function, such as an array of values, try these two approaches.

Either, call the enhanced `frame()` function with extra arguments with `(s, f) -> frame(s, f, databuffer)`:

```julia
function frame(scene, framenumber, databuffer)
    eased_n = scene.easingfunction(framenumber - scene.framerange.start,
        0, 1, scene.framerange.stop - scene.framerange.start)
    w = size(databuffer, 1)
    h = size(databuffer, 2)
    for c in 1:w, r in 1:h
        rs = rescale(r, 1, h, 0, 2π)
        cs = rescale(c, 1, h, 0, 2π)
        databuffer[r, c] = HSV(360((sin(2rs) * cos(2cs)) * sin(eased_n * 2π)), 0.7, 0.7)
    end
    placeimage(databuffer, Point(-w / 2, -h / 2))
end

function main()
    databuffer = zeros(ARGB32, 250, 250)
    demo = Movie(250, 250, "buffer")
    animate(demo, [
            Scene(demo, (s, f) -> frame(s, f, databuffer),
                0:100)
        ],
        tempdirectory="/tmp/tempdir",
        createmovie=true,
        pathname="/tmp/t.mkv")
end
```

Or, use the `optarg` keyword argument for `Scene()`, and access it using `scene.opts
` keyword.

```julia
using Luxor, Colors
function frame(scene, framenumber)
    databuffer = scene.opts
    eased_n = scene.easingfunction(framenumber - scene.framerange.start,
        0, 1, scene.framerange.stop - scene.framerange.start)
    w = size(databuffer, 1)
    h = size(databuffer, 2)
    for c in 1:w, r in 1:h
        rs = rescale(r, 1, h, 0, 2π)
        cs = rescale(c, 1, h, 0, 2π)
        databuffer[r, c] = HSV(360((sin(2rs) * cos(2cs)) * sin(eased_n * 2π)), 0.7, 0.7)
    end
    placeimage(databuffer, Point(-w / 2, -h / 2))
end

function main()
    databuffer = zeros(ARGB32, 250, 250)
    demo = Movie(250, 250, "buffer")
    animate(demo, [Scene(demo, frame, optarg=databuffer, 0:100)],
        tempdirectory="/tmp/tempdir",
        createmovie=true,
        pathname="/tmp/t.mp4")
end
```

## Animating paths

A useful function to help with animations is [`drawpath`](@ref). This has
a method that accepts a value between 0 and 1 that draws a
portion of a Path object.

For example, the purple stroke is about half the length of the path.

```@example
using Luxor # hide

d = Drawing(600, 250, :svg) # hide
background("antiquewhite") # hide
origin() # hide

fontsize(300)
textpath("s", O, halign=:center, valign=:middle)
s = storepath()
drawpath(s, action=:stroke)

sethue("purple")
setline(10)
setopacity(0.5)
pt = drawpath(s, 0.5, action=:stroke) # return final pt

setcolor("red")
circle(pt, 5, :fill)
finish() # hide
d # hide
```

It's also useful for animating text paths.

![text animation](../assets/figures/textanimation.gif)

which uses code like this:

```julia
...
f =  # a value between 0 and 1
textpath("Thank you for using", pt, halign=:center)
tp = storepath()
drawpath(tp, f, :stroke)
...
```

## Easing functions

Transitions for animations often use non-constant and
non-linear motions, and these are usually provided by
*easing* functions. Luxor defines some of the basic easing
functions and they're listed in the (unexported) array
`Luxor.easingfunctions`. Each scene can have one easing
function.


|List of easing functions|
|:---                    |
|easingflat|
|lineartween|
|easeinquad|
|easeoutquad|
|easeinoutquad|
|easeincubic|
|easeoutcubic|
|easeinoutcubic|
|easeinquart|
|easeoutquart|
|easeinoutquart|
|easeinquint|
|easeoutquint|
|easeinoutquint|
|easeinsine|
|easeoutsine|
|easeinoutsine|
|easeinexpo|
|easeoutexpo|
|easeinoutexpo|
|easeincirc|
|easeoutcirc|
|easeinoutcirc|
|easeinoutinversequad|
|easeinoutbezier|

Most easing functions have names constructed like this:

```julia
ease[in|out|inout][expo|circ|quad|cubic|quart|quint]
```

and there's an [`easingflat`](@ref) linear transition.

```@example
using Luxor # hide
function draweasingfunction(f, pos, w, h)
    @layer begin
        translate(pos)
        setline(0.5)
        sethue("black")
        box(O, w, h, :stroke)
        sethue("purple")
        for i in 0:0.005:1.0
            circle(Point(-w/2, h/2) + Point(w * i, -f(i, 0, h, 1)), 1, :fill)
        end
        sethue("black")
        text(replace(string(f), "Luxor." => ""), Point(0, h/2 - 20), halign=:center)
    end
end

Drawing(800, 650, "../assets/figures/easingfunctions.png") # hide
background("white") # hide
origin() # hide
t = Tiler(650, 650, 5, 5)
margin=5
fontsize(10)
fontface("JuliaMono-Regular")
for (pos, n) in t
    n > length(Luxor.easingfunctions) && continue
    draweasingfunction(Luxor.easingfunctions[n], pos,
        t.tilewidth-margin, t.tileheight-margin)
end

finish() # hide
nothing # hide
```

In these graphs, the horizontal axis is time (between 0 and 1), and the vertical axis is the parameter value (between 0 and 1).

![easing function summary](../assets/figures/easingfunctions.png)

One way to use an easing function in a frame-making function is like this:

```julia
function moveobject(scene, framenumber)
    background("white")
    ...
    easedframenumber = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    ...
```

This takes the current frame number, compares it with the end frame number of the scene, then adjusts it.

In the next example, the purple dot has sinusoidal easing motion, the green has cubic, and the red has quintic. They all traverse the drawing extent in the same time, but have different accelerations and decelerations.

![animation easing example](../assets/figures/animation-easing.gif)

```julia
fastandfurious = Movie(400, 100, "easingtests")
backdrop(scene, framenumber) =  background("black")
function frame1(scene, framenumber)
    sethue("purple")
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(Point(-180 + (360 * eased_n), -20), 10, :fill)
end
function frame2(scene, framenumber)
    sethue("green")
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(Point(-180 + (360 * eased_n), 0), 10, :fill)
end
function frame3(scene, framenumber)
    sethue("red")
    eased_n = scene.easingfunction(framenumber, 0, 1, scene.framerange.stop)
    circle(Point(-180 + (360 * eased_n), 20), 10, :fill)
end
animate(fastandfurious, [
    Scene(fastandfurious, backdrop, 0:200),
    Scene(fastandfurious, frame1,   0:200, easingfunction=easeinsine),
    Scene(fastandfurious, frame2,   0:200, easingfunction=easeinoutcubic),
    Scene(fastandfurious, frame3,   0:200, easingfunction=easeinoutquint)
    ],
    creategif=true)
```

Here's the definition of one of the easing functions:

```julia
function easeoutquad(t, b, c, d)
    t /= d
    return -c * t * (t - 2) + b
end
```

Here:

- `t` is the current time (framenumber) of the transition

- `b` is the beginning value of the property

- `c` is the change between the beginning and destination value of the property

- `d` is the total length of the transition

The [`easeinoutbezier`](@ref) function accepts two additional arguments, two normalized control points of a normalized Bezier curve from Point(0, 0) to Point(1, 1). You can use these to define the shape of a custom easing transition. The Bezier curve's `y` coordinate determines the acceleration. [?]

![animation of bezier easing](../assets/figures/animation-bezier-easing.gif)

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Clipping

There's two types of clipping in Luxor: polygon clipping and visual clipping.

## Polygon clipping

Use [`polyclip`](@ref) to clip one polygon by another. The clipping polygon must
be convex (every interior angle is less than or equal to 180°).

```@example
using Luxor # hide
@drawsvg begin # hide
s = hypotrochoid(160, 48, 88, vertices=true)
setline(0.5)
sethue("grey60")
poly(s, :stroke)
c = box(O, 260, 250)
poly(c, :stroke, close=true)
sethue("gold")
setline(2)
poly(polyclip(s, c), :stroke, close=true)
end 600 400  # hide
```

See also `[polyintersect()](@ref)`.

## Visual clipping

Use [`clip`](@ref) to turn the current path into a clipping region, masking any graphics outside the path. [`clippreserve`](@ref) keeps the current path, but also uses it as a clipping region. [`clipreset`](@ref) resets it. `:clip` is also an action for drawing functions like [`circle`](@ref).

```@example
using Luxor # hide
Drawing(400, 250, "../assets/figures/simpleclip.png") # hide
background("white") # hide
origin() # hide
setline(3) # hide
sethue("grey50")
setdash("dotted")
circle(O, 100, :stroke)
circle(O, 100, :clip)
sethue("magenta")
box(O, 125, 200, :fill)
finish() # hide
nothing # hide
```
![simple clip](../assets/figures/simpleclip.png)

This example uses the built-in function that draws the Julia logo. The `clip` action lets you use the shapes as a mask for clipping subsequent graphics, which in this example are randomly-colored circles:

![julia logo mask](../assets/figures/julia-logo-mask.png)

```julia
function draw(x, y)
    foregroundcolors = Colors.diverging_palette(rand(0:360), rand(0:360), 200, s = 0.99, b=0.8)
    gsave()
    translate(x-100, y)
    julialogo(action=:clip)
    for i in 1:500
        sethue(foregroundcolors[rand(1:end)])
        circle(rand(-50:350), rand(0:300), 15, :fill)
    end
    grestore()
end

currentwidth = 500 # pts
currentheight = 500 # pts
Drawing(currentwidth, currentheight, "clipping-tests.pdf")
origin()
background("white")
setopacity(.4)
draw(0, 0)
finish()
preview()
```

```@meta
DocTestSetup = quote
    using Luxor, Colors, Random
end
```

# Geometry tools

## Lines and distances

You can find the midpoint between two points using
[`midpoint`](@ref).

The following code places a small pentagon (using
[`ngon`](@ref)) at the midpoint of each side of a larger
pentagon:

```@example
using Luxor # hide
Drawing(700, 220, "../assets/figures/midpoint.png") # hide
origin() # hide
background("white") # hide
sethue("red")
ngon(O, 100, 5, 0, action = :stroke)

sethue("darkgreen")
p5 = ngon(O, 100, 5, 0, vertices=true)

for i in eachindex(p5)
    pt1 = p5[mod1(i, 5)]
    pt2 = p5[mod1(i + 1, 5)]
    ngon(midpoint(pt1, pt2), 20, 5, 0, action = :fill)
end
finish() # hide
nothing # hide
```
![arc](../assets/figures/midpoint.png)

A more general function, [`between`](@ref), finds for a value `x` between 0 and 1 the corresponding point on a line defined by two points. So `midpoint(p1, p2)` and `between(p1, p2, 0.5)` should return the same point.

```@example
using Luxor # hide
Drawing(700, 150, "../assets/figures/betweenpoint.png") # hide
origin() # hide
background("white") # hide
sethue("red")
p1 = Point(-150, 0)
p2 = Point(150, 40)
line(p1, p2)
strokepath()
for i in -0.5:0.1:1.5
    randomhue()
    circle(between(p1, p2, i), 5, action = :fill)
end
finish() # hide
nothing # hide
```
![arc](../assets/figures/betweenpoint.png)

Values less than 0.0 and greater than 1.0 appear to work well too, placing the point on the line if extended.

[`center3pts`](@ref) finds the radius and center point of a circle passing through three points which you can then use with functions such as [`circle`](@ref) or [`arc2r`](@ref).

[`perpendicular`](@ref) finds the foot of a perpendicular line which lies on a line through two points perpendicular to a another point.

```@example
using Luxor # hide
d = @drawsvg begin # hide
A, B = Point(-150, 0), Point(150, 50)

sethue("grey50")
fontsize(18)
setline(4)

line(A, B, action = :stroke)

# point perpendicular to line
C = Point(-50, -80)
D = perpendicular(A, B, C)

# line perpendicular to line
E, F = perpendicular(A, B)

# point perpendicular to extended line
G = Point(230, -200)
H = perpendicular(A, B, G)

sethue("grey50")
label.(string.(["A", "B", "C", "D", "E", "F", "G", "H"]),
    :ne, offset=10,
    (A, B, C, D, E, F, G, H))

sethue("red")
arrow(C, D)
sethue("green")
arrow(E, F)
sethue("orange")
arrow(G, H)
sethue("purple")
circle.([A, B, C, D, E, F, G, H], 4, action = :fill)
end # hide
d # hide
```

## Points and arcs

Use `isarcclockwise(c, p1, p2)` to check whether an arc centered at `c` running from `p1` to `p2` is clockwise.

The [`pointinverse`](@ref) function finds the inverse of a point relative to a reference circle (centerpoint and radius). In the following example, each vertex on the shape inside the circle is linked by an arrow to its inverse outside the circle.

```@example
using Luxor, Colors # hide
d = @drawsvg begin
    origin() # hide
    background("antiquewhite") # hide
    setline(1) # hide
    radius = 60
    circle(O, radius + 20, action = :stroke)

    points = polycross(O, radius, 7, vertices=true)
    poly(points, action = :stroke, close=true)

    antipoints = last.([pointinverse(pt, O, radius + 20) for pt in points])

    #antipoints = last.(pointinverse.(points, O, radius+20))

    for (n, ptpair) in enumerate(zip(points, antipoints))
        pt1, pt2, = ptpair
        sethue(HSB(length(points) * n, 0.8, 0.8))
        circle(pt1, distance(O, pt1)/6, action = :fill)
        circle(pt2, distance(O, pt2)/6, action = :fill)
        sethue("black")
        arrow(pt1, pt2)
    end
end 800 500
d # hide
```

Use [`anglethreepoints`](@ref) to find the angle formed by two lines connecting three points:

```@example
using Luxor # hide
Drawing(800, 800, "../assets/figures/anglethreepoints.png") # hide
origin() # hide

function showangle(pt1, pt2, pt3)
    θ = anglethreepoints(pt1, pt2, pt3)
    label(string(round(rad2deg(θ), digits=2), "°"), :w, pt2)
    newpath()
    carc(pt2, 50, 0, -θ)
    strokepath()
end

let
    background("grey20")
    sethue("white")
    fontsize(12)
    tiles = Tiler(800, 800, 4, 4)
    for (pos, n) in tiles
        @layer begin
            translate(pos)
            pg = [polar(50, 0), O, polar(50, n * -2π/16)]
            poly(pg, action = :stroke)
            for n in 1:3
                pt1 = pg[1]
                pt2 = pg[2]
                pt3 = pg[3]
                showangle(pt1, pt2, pt3)
            end
        end
    end
    finish() # hide
end

nothing # hide
```

![angle three points](../assets/figures/anglethreepoints.png)

## Round corners

The [`roundcorner`](@ref) function takes three points that define a corner, plus a radius. The function returns three points and a Boolean flag: the first and third define the ends of the circular arc, the second defines the center of the circle with the given radius. The Boolean flag indicates whether the arc should be drawn clockwise.

```@example
using Luxor # hide
@drawsvg begin # hide
    background(0.8, 0.7, 0.7)
    fontsize(25)
    
    p1, corner, p3 = ngon(O, 250, 3, vertices=true)
    
    label.(("p1", "corner", "p3"), :NE, (p1, corner, p3))
    circle.((p1, corner, p3), 5, :fill)
    
    p1c, cp, p2c, clockwise = roundcorner(p1, corner, p3, 80)
    
    label.(("p1c", "cp", "p2c"), :NW, (p1c, cp, p2c))
    circle.((p1c, cp, p2c), 5, :fill)

    @layer begin setdash("dot"); circle(cp, 80, :stroke) end

    move(p1)
    line(p1c)
    arc2r(cp, p1c, p2c)
    line(p3)
    strokepath()
end 800 600 # hide
```

## Other functions

Other functions that help with geometry include:

- [`distance`](@ref) distance between two points

- [`getnearestpointonline`](@ref) drop perpendicular

- [`pointlinedistance`](@ref) distance of point from line between two points

- [`slope`](@ref) angle of line between two points

- [`perpendicular`](@ref) find perpendicular

- [`dotproduct`](@ref) scalar dot product of two points

- [`@polar`](@ref) convert radius and angle to point

- [`polar`](@ref) convert radius and angle to point

- [`ispointonline`](@ref) true if point lies on line

- [`ispointonpoly`](@ref) true if point lies on any edge of polygon

- [`isarcclockwise`](@ref) true if arc is clockwise

- [`pointinverse`](@ref) inverse of point with respect to circle

- [`anglethreepoints`](@ref) angle formed by two lines defined by three points

- [`determinant3`](@ref) find determinant of matrix of 3 points

- [`rotatepoint`](@ref) rotate point around another by angle

## Triangle centers

To find the center of a triangle, use one of:

- [`trianglecircumcenter`](@ref) center of circumcircle/intersection of the perpendicular bisectors.

- [`triangleincenter`](@ref) intersection of the interior angle bisectors

- [`trianglecenter`](@ref) centroid

- [`triangleorthocenter`](@ref) intersection of the altitudes

```@example
using Luxor # hide

Drawing(350, 350, "../assets/figures/trianglecenters.svg") # hide
origin() # hide
background("white") # hide
setline(0.4) # hide
fontsize(11) # hide
▲ = Point[Point(-100.0, 0.0), Point(110.0, 30.0), Point(65.0, 90.0)]

@layer begin
    sethue("red")
    setline(2)
    poly(▲, :stroke, close=true)
end

# circumcenter
circle(▲..., action = :stroke)
cp = trianglecircumcenter(▲...)
circle(cp, 2, action = :fill)
label("circumcenter", :N, cp)

# incenter
cp = triangleincenter(▲...)
circle(cp, 2, action = :fill)
pt1 = getnearestpointonline(▲[1], ▲[2], cp)
@layer begin
    sethue("black")
    circle(cp, distance(cp, pt1), action = :stroke)
    label("incenter", :S, cp)
end

# center
cp = trianglecenter(▲...)
circle(cp, 2, action = :fill)
label("center", :w, cp)

# orthocenter
cp = triangleorthocenter(▲...)
circle(cp, 2, action = :fill)
label("orthocenter", :e, cp)

finish() # hide
nothing # hide
```

![triangle centers](../assets/figures/trianglecenters.svg)

## Intersections

[`intersectionlines`](@ref) finds the intersection of two lines.

```@example
using Luxor # hide
Drawing(700, 220, "../assets/figures/intersection.png") # hide
background("white") # hide
origin() # hide

sethue("black")
P1, P2, P3, P4 = ngon(O, 100, 5, vertices=true)
label.(["P1", "P2", "P3", "P4"], :N, [P1, P2, P3, P4])
line(P1, P2, action = :stroke)
line(P4, P3, action = :stroke)

flag, ip =  intersectionlines(P1, P2, P4, P3)
if flag
    circle(ip, 5, action = :fill)
end

finish() # hide
nothing # hide
```

![arc](../assets/figures/intersection.png)

[`intersectionlinecircle`](@ref) finds the intersection of a line and a circle. There can be 0, 1, or 2 intersection points.

```@example
using Luxor # hide
Drawing(700, 220, "../assets/figures/intersection_line_circle.png") # hide
origin() # hide
background("white") # hide
sethue("chocolate2") # hide
l1 = Point(-100.0, -75.0)
l2 = Point(300.0, 100.0)
rad = 100
cpoint = Point(0, 0)
line(l1, l2, action = :stroke)
sethue("darkgreen") # hide
circle(cpoint, rad, action = :stroke)
nints, ip1, ip2 =  intersectionlinecircle(l1, l2, cpoint, rad)
sethue("black")
if nints == 2
    circle(ip1, 8, action = :stroke)
    circle(ip2, 8, action = :stroke)
end
finish() # hide
nothing # hide
```
![arc](../assets/figures/intersection_line_circle.png)

[`intersection2circles`](@ref) finds the area of the intersection of two circles, and [`intersectioncirclecircle`](@ref) finds the points where they cross.

This example shows the areas of two circles, and the area of their intersection.

```@example
using Luxor # hide
Drawing(700, 310, "../assets/figures/intersection2circles.png") # hide
origin() # hide
background("white") # hide
fontsize(14) # hide
sethue("black") # hide

c1 = (O, 150)
c2 = (O + (100, 0), 150)

circle(c1... , action = :stroke)
circle(c2... , action = :stroke)

sethue("purple")
circle(c1... , action = :clip)
circle(c2... , action = :fill)
clipreset()

sethue("black")

text(string(150^2 * π |> round), c1[1] - (125, 0))
text(string(150^2 * π |> round), c2[1] + (100, 0))
sethue("white")
text(string(intersection2circles(c1..., c2...) |> round),
     midpoint(c1[1], c2[1]), halign=:center)

sethue("red")
flag, C, D = intersectioncirclecircle(c1..., c2...)
if flag
    circle.([C, D], 5, action = :fill)
end
finish() # hide
nothing # hide
```
![intersection of two circles](../assets/figures/intersection2circles.png)

## Bounding boxes

The `BoundingBox` type allows you to use rectangular extents
to organize and interact with the 2D drawing area. A
`BoundingBox` holds two points, the opposite corners of a
bounding box.

You can make a BoundingBox from:

- the current drawing
- two points
- a text string
- an existing polygon
- a stored path
- a table or table cell

and by modifying an existing bounding box, or using the results of functions such
as `circle()` or `box()`.

[`BoundingBox`](@ref) without arguments defines an extent that
encloses the drawing (assuming that the origin is at the
center of the drawing—see [`origin`](@ref)). Use
`centered=false` if the drawing origin is still at the top
left corner.

This example draws circles at three points: at two of the
drawing's corners and at the midway point between them:

```@example
using Luxor # hide
Drawing(700, 400, "../assets/figures/bbox.png") # hide
background("white") # hide

origin()

bb = BoundingBox()
setline(10)
sethue("orange")

circle(bb[1], 150, action = :stroke) # first corner

circle(bb[2], 150, action = :stroke) # second corner

circle(midpoint(bb...), 150, action = :stroke) # midpoint

sethue("blue")
circle.([bb[1], midpoint(bb[1:2]), bb[2]], 130, action = :fill)

sethue("red")
circle.([first(bb), midpoint(bb...), last(bb)], 100, action = :fill)

finish() # hide
nothing # hide
```

![bounding box](../assets/figures/bbox.png)

You can make a bounding box from a polygon:

```@example
using Luxor # hide
Drawing(400, 200, "../assets/figures/bboxpoly.png") # hide
background("white") # hide
origin() # hide

p = star(O, 100, 5, 0.1, π/3.3, vertices=true)
sethue("antiquewhite")
box(BoundingBox(p), action = :fill)

sethue("black")
poly(p, action = :stroke, close=true)

finish() # hide
nothing # hide
```

![bounding box of polygon](../assets/figures/bboxpoly.png)

The resulting bounding boxes can be passed to [`box`](@ref) or [`poly`](@ref) to be drawn.

To convert a bounding box `b` into a box, use `box(b, vertices=true)` or `convert(Vector{Point}, BoundingBox())`.

To obtain the coordinates of the corners or key points on the bounding box, use the functions with names combining `box` and `top|middle|bottom` and `left|center|right`. So `boxtopleft(bbox)` finds the top left corner of the bounding box `bbox`.

You can also do some arithmetic on bounding boxes. In the next example, the bounding box is created from the text "good afternoon". The bounding box is filled with purple, then increased by 40 units on all sides (blue), also scaled by 1.3 (green), and also shifted by `(0, 100)` (orange).

```@example
using Luxor # hide
Drawing(500, 300, "../assets/figures/bbox2.png") # hide
background("white") # hide
origin() # hide

translate(-130,0)
fontsize(40)
str = "good afternoon"
sethue("purple")
box(BoundingBox(str), action = :fill)
sethue("white")
text(str)

sethue("blue")
modbox = BoundingBox(str) + 40 # add 40 units to all sides
poly(modbox, action = :stroke, close=true)

sethue("green")
modbox = BoundingBox(str) * 1.3
poly(modbox, action = :stroke, close=true)

sethue("orange")
modbox = BoundingBox(str) + (0, 100)
poly(modbox, action = :fill, close=true)

finish() # hide
nothing # hide
```

![bounding boxes 2](../assets/figures/bbox2.png)

You can find the union and intersection of BoundingBoxes, and also find whether a point lies inside one. The following code creates, shrinks, and shifts two bounding boxes (colored yellow and pink), and then draws: their union (a bounding box that includes both), in black outline; and their intersection (a bounding box of their common areas), in red. Then some random points are created (you can pass a bounding box to `rand()` to get a random point inside the box) and drawn differently depending on whether they're inside the intersection or outside.

```@example
using Luxor, Random # hide
Drawing(600, 400, "../assets/figures/bbox3.png") # hide
background("white") # hide
Random.seed!(42) # hide

origin()
setopacity(0.75)
setline(8)

bbox1 = BoundingBox()/2 - (50, 30)
sethue("yellow")
box(bbox1, action = :fill)

bbox2 = BoundingBox()/2  + (50, 30)
sethue("pink")
box(bbox2, action = :fill)

sethue("black")
box(bbox1 + bbox2, action = :stroke)

sethue("red")
bothboxes = intersectboundingboxes(bbox1, bbox2)
box(bothboxes, action = :fill)

for i in 1:500
    pt = rand(bbox1 + bbox2)
    if isinside(pt, bothboxes)
        sethue("white")
        circle(pt, 3, action = :fill)
    else
        sethue("black")
        circle(pt, 2, action = :fill)
    end
end

finish() # hide
nothing # hide
```

![intersecting bounding boxes](../assets/figures/bbox3.png)

To find out where a line starting at the center of a bounding box passing through a point crosses or would cross the edges of the box, use [`pointcrossesboundingbox`](@ref).

```@example
using Luxor, Random # hide
Drawing(600, 400, "../assets/figures/bbox4.png") # hide
background("antiquewhite") # hide
Random.seed!(42) # hide
origin() # hide
bx = BoundingBox(box(O, 200, 200))
setline(1)
sethue("black") # hide
box(bx, action = :stroke)
for i in 1:10
    pt = randompoint((1.5bx)...)
    pt2 = pointcrossesboundingbox(pt, bx)

    sethue("grey50")
    arrow(O, pt)
    sethue("red")
    circle(pt2, 3, action = :stroke)
end

finish() # hide
nothing # hide
```

![point crosses bounding box](../assets/figures/bbox4.png)

## Random points

You can use [`randompointarray`](@ref) to create an array of randomly placed points.

The `randompointarray(boundingbox, distance)` method fills
the boundingbox with random points up to `distance` units apart
using a Poisson Disk sampling method.

```@example
using Luxor, Colors # hide
@drawsvg begin # hide
background("black")
b = blend(
        boxtopleft(BoundingBox()),
        boxbottomright(BoundingBox()),
        "red",
        "green")

addstop(b, 0.3, "orange")
addstop(b, 0.4, "magenta")
addstop(b, 0.5, "cyan")
addstop(b, 0.7, "yellow")
setblend(b)

for pt in randompointarray(BoundingBox() * 0.9, 15)
    d = rescale(distance(pt, O), 0, sqrt(800 * 500), 1, 0)
    circle(pt, 1 + 7d, action = :fill)
end
end 800 500 # hide
```

The `randompointarray(point1, point2, n)` method generates
`n` random points in the area bounded by two points, using Julia's
random number generator.

```@example
using Luxor, Random # hide
@drawsvg begin # hide
background("white") # hide
Random.seed!(42) # hide
origin() # hide

pt1 = Point(-300, -150)
pt2 = Point(300, 150)

sethue("purple")
map(pt -> circle(pt, 6, action = :fill), (pt1, pt2))
box(pt1, pt2, action = :stroke)

sethue("blue")
map(pt -> circle(pt, 4, action = :fill), randompointarray(pt1, pt2, 200))

end 800 400 # hide
```

Use `rand(BoundingBox())` to return a single point somewhere inside a bounding box.

## Noise

For artistic graphics you might prefer noisy input values to purely random ones. Use the [`noise`](@ref) function to obtain smoothly changing random values corresponding to input coordinates. The returned values wander slowly rather than jump about everywhere.

In this example, the gray value varies gradually as the [`noise`](@ref) function returns values between 0 and 1 depending on the location of the two input values `pos.x` and `pos.y`.

The top two quadrants use a lower value for the `detail` keyword argument, an integer ()>= 1) specifying how many "octaves" of noise you want.

The left two quadrants use a lower value for the `persistence` keyword argument, a floating point number specifying how the amplitude diminishes for each successive level of detail. There is more fine detail when the persistence is higher, particularly when the `detail` setting is also high.

```@example
using Luxor, Colors # hide
Drawing(800, 400, "../assets/figures/noise.png") # hide

background("white") # hide
origin() # hide

tiles = Tiler(800, 400, 200, 200)
sethue("black")
for (pos, n) in tiles
    freq = 0.05
    d    = pos.y < 0 ? 1   : 4
    pers = pos.x < 0 ? 0.3 : 1.0
    ns = noise(freq * pos.x, freq * pos.y,
        detail=d,
        persistence=pers)
    setgray(ns)
    box(pos, tiles.tilewidth, tiles.tileheight, action = :fillstroke)
end

finish() # hide
nothing # hide
```

![noise](../assets/figures/noise.png)

Use [`initnoise`](@ref) to initialize the noise behaviour.

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```

# Transforms and matrices

Graphics are placed on the current drawing according to the *current transformation matrix*. You can either modify this indirectly, using functions, or set the matrix directly.

For basic transformations, use [`translate(tx, ty)`](@ref), [`scale(sx, sy)`](@ref), and [`rotate(a)`](@ref).

## Translation

`translate(pos)` (and `translate(x, y)`) shift the current origin to `pos` or by the specified amounts in x and y. It's relative and cumulative, rather than absolute:

```@example
using Luxor, Colors, Random # hide
Drawing(800, 200, "../assets/figures/translate.png") # hide
background("antiquewhite") # hide
Random.seed!(1) # hide
setline(1) # hide
origin()  # hide
for i in range(0, step=30, length=6)
    sethue(HSV(i, 1, 1)) # from Colors
    setopacity(0.5)
    circle(Point(0, 0), 40, :fillpreserve)
    setcolor("black")
    strokepath()
    translate(50, 0)
end
finish() # hide
nothing # hide
```

![translate](../assets/figures/translate.png)

## Scaling

`scale(x, y)` and `scale(n)` scale the current workspace by the specified amounts. It's relative to the current scale, not to the drawing's original.

```@example
using Luxor, Colors, Random # hide
Drawing(800, 300, "../assets/figures/scale.png") # hide
background("antiquewhite") # hide
Random.seed!(1) # hide
setline(1) # hide
origin()
for i in range(0, step=30, length=6)
    sethue(HSV(i, 1, 1)) # from Colors
    circle(Point(0, 0), 130, :fillpreserve)
    setcolor("black")
    strokepath()
    scale(0.8)
end
finish() # hide
nothing # hide
```

![scale](../assets/figures/scale.png)

## Rotation

[`rotate`](@ref) rotates the current workspace by the specified amount about the current 0/0 point. It's relative to the previous rotation - "rotate by".

```@example
using Luxor, Random # hide
Drawing(800, 200, "../assets/figures/rotate.png") # hide
background("antiquewhite") # hide
Random.seed!(1) # hide
setline(1) # hide
origin()
setopacity(0.7) # hide
for i in 1:8
    randomhue()
    squircle(Point(40, 0), 20, 30, :fillpreserve)
    sethue("black")
    strokepath()
    rotate(π/4)
end
finish() # hide
nothing # hide
```

![rotate](../assets/figures/rotate.png)

[`origin`](@ref) resets the matrix then moves the origin to the center of the page.

Use the [`getscale`](@ref), [`gettranslation`](@ref), and [`getrotation`](@ref) functions to find the current values.

To quickly return home after many changes, you can use `setmatrix([1, 0, 0, 1, 0, 0])` to reset the matrix to the default.

## Linear interpolation ("lerp")

[`rescale`](@ref) is a convenient utility function for
linear interpolation. An easy way to visualize it is by
imagining two number lines. A value relative to a pair of low and high
values is rescaled to have the equivalent value relative to
another pair of low and high values.

```@setup lerp
using Luxor

reddot(pos) = @layer begin
    sethue("red")
    circle(pos, 8, :fill)
end

diagram = @drawsvg begin
    background("antiquewhite")
    sethue("black")
    setline(1)
    fontsize(14)

    n = 35
    dot′′ = between(O + (-200, 40), O + (200, 40), rescale(n, 30, 40, 0, 1))
    reddot(dot′′)

    text(string("n = $(n)"), O + (0, -60), halign=:center)
    text("rescale(n, 30, 40, 1, 2) = $(rescale(n, 30, 40, 1, 2))", dot′′ + (0, -60), halign=:center)

    pts = (O + (-200, 40), O + (200, 40))

    tickline(pts...,
        startnumber = 1,
        finishnumber = 2,
        minor=0,
        major=9)
    tickline(pts...,
        startnumber = 30,
        finishnumber = 40,
        minor=0,
        major=9,
        major_tick_function = (n, pos; startnumber=30, finishnumber=40, nticks=10) -> begin
            @layer begin
                translate(pos)
                line(O, O + polar(5, 3π/2), :stroke)
                k = rescale(n, 0, nticks - 1, startnumber, finishnumber)
                ticklength = get_fontsize() * 1.3
                text("$(round(k, digits=2))", O + (0, -ticklength), halign=:center, valign=:middle, angle = -getrotation())
            end
        end)
    finish()
end 800 200
```

```@example lerp
diagram # hide
```

This function is sometimes called “lerp” in other systems.
For example, in Processing, the `lerp()` function takes the
form `lerp(low, high, value)`, where the returned value
lies between `low` and `high` corresponding to how `value`
lies between 0 and 1.

The equivalent to `lerp(10, 20, 0.5)` in Luxor is
`rescale(0.5, 0, 1, 10, 20)`. Luxor requires a ‘from’ scale
(here `... 0, 1, ...`) although the ‘to’ scale is optional and
defaults to `0, 1`.

## Scaling of line thickness

Line thicknesses are not scaled by default. For example, with a current line thickness set by `setline(1)`, lines drawn before and after `scale(2)` will be the same thickness. If you want line thicknesses to respond to the current scale, so that a line thickness of 1 is scaled by `n` after calls to `scale(n)`, you can call [`setstrokescale`](@ref) with `true` to enable stroke scaling, and `setstrokescale(false)` to disable it. You can also enable stroke scaling when creating a new `Drawing` by passing the named argument `strokescale` during `Drawing` construction (i.e., `Drawing(400, 400, strokescale=true)`).

## Matrices

In Luxor, there's always a *current matrix* that determines how coordinates are interpreted in the current workspace. In Cairo, it's a six element array:

```math
\begin{bmatrix}
1 & 0 & 0 \\
0 & 1 & 0 \\
\end{bmatrix}
```

and Luxor/Cairo matrix functions accept and return simple 6-element vectors:

```julia-repl
julia> getmatrix()
6-element Vector{Float64}:
 1.0
 0.0
 0.0
 1.0
 0.0
 0.0
```

!!! note

    You can convert between the 6-element and 3x3 versions of a transformation matrix using the functions [`cairotojuliamatrix`](@ref) and [`juliatocairomatrix`](@ref).

[`transform(a)`](@ref) transforms the current workspace by ‘multiplying’ the current matrix with matrix `a`. For example, `transform([1, 0, xskew, 1, 50, 0])` skews the current matrix by `xskew` radians and moves it 50 in x and 0 in y.

```@example
using Luxor # hide
fname = "../assets/figures/transform.png" # hide
pagewidth, pageheight = 800, 100 # hide
Drawing(pagewidth, pageheight, fname) # hide
origin() # hide
background("antiquewhite") # hide
translate(-200, 0) # hide

function boxtext(p, t)
    sethue("grey30")
    box(p, 30, 50, :fill)
    sethue("white")
    textcentered(t, p)
end

for i in 0:5
    xskew = tand(i * 5.0)
    transform([1, 0, xskew, 1, 50, 0])
    boxtext(O, string(round(rad2deg(xskew), digits=1), "°"))
end

finish() # hide
nothing # hide
```

![transform](../assets/figures/transform.png)

[`getmatrix`](@ref) gets the current matrix, `setmatrix(a)` sets the matrix to array `a`.

Other functions include [`getmatrix`](@ref),
[`setmatrix`](@ref), [`transform`](@ref), [`crossproduct`](@ref), [`blendmatrix`](@ref), [`rotationmatrix`](@ref), [`scalingmatrix`](@ref), and [`translationmatrix`](@ref).

Use the [`getscale`](@ref), [`gettranslation`](@ref), and [`getrotation`](@ref) functions to find the current values of the current matrix. These can also find the values of arbitrary 3x3 matrices.


## World position

If you use [`translate`](@ref) to move the origin to different places on a drawing, you can use [`getworldposition`](@ref) to find the "true" world coordinates of points. In the following example, we temporarily translate to a random point, and "drop a pin" that remembers the new origin in terms of the drawing's world coordinates. After the temporary translation is over, we have a record of where it was.

```@example
using Luxor, Random # hide
Drawing(800, 400, "../assets/figures/getworldposition.png") # hide
background("antiquewhite") # hide
Random.seed!(3) # hide
setline(1) # hide
origin()

@layer begin
    translate(0.7rand(BoundingBox()))
    pin = getworldposition()
end

label("you went ... ", :n, O, offset = 10)
label("... here", :n, pin, offset = 20)
arrow(O, pin)

finish() # hide
nothing # hide
```

![translate](../assets/figures/getworldposition.png)

## Coordinate conventions

In Luxor, by convention, the y axis points downwards, and the x axis points to the right.

There are basically two conventions for computer graphics:

- most computer graphics systems (HTML, SVG, Processing, Cairo, Luxor, image processing, most GUIs, etc) use the “y downwards” convention

- mathematical illustrations, such as graphs, figures, Plots.jl, plots, etc. use the “y upwards” convention

```@setup conventions
using Luxor
diagram = @drawsvg begin
    background("antiquewhite")
    table = Table(1, 2, 300, 400)
    fontsize(16)
    @layer begin
        translate(table[1])
        arrow(O, O  + (0, -200))
        text("y", O  + (20, -200))
        arrow(O, O  + (200, 0))
        text("x", O  + (200, 20))

        text("maths: y upwards", O  + (0, 100), halign=:center)
    end

    @layer begin
        translate(table[2])
        text("computing: y downwards", O  + (0, 100), halign=:center)
        rulers()
    end

end 800 450
```

```@example conventions
diagram # hide
```

You could use a transformation matrix to reflect the Luxor drawing space in the x axis.

```@example
using Luxor # hide
@drawsvg begin # hide
    background("antiquewhite") # hide
    table = Table(1, 2, 300, 400) # hide
    fontsize(30) # hide
    pts = (Point(0, 0), Point(50, 100))
    @layer begin
        translate(table[1])
        arrow(pts...)
        rulers()
    end

    @layer begin
        translate(table[2])
        transform([1 0 0 -1 0 0])           # <--
        arrow(pts...)
        rulers()
    end
end 800 450 # hide
```

!!! note

    If you do this and try to place text, all your text will be incorrectly drawn upside down, so you'd need to enclose any text placement with another matrix transformation.

## Advanced transformations

For more powerful transformations of graphic elements,
consider using Julia packages which are designed
specifically for the purpose.

The following example uses the Rotations and
CoordinateTransformations packages. It sets up some transformations
which can then be composed in the correct order to transform
points.

```julia
using CoordinateTransformations, Rotations, StaticArrays, LinearAlgebra

rawpts = [
    [0.1, 0.1],
    [0.1, -0.1],
    [-0.1, -0.1],
    [-0.1, 0.1]
]

function transform_point(pt, transformation)
    x, y, _ = transformation(SVector(pt[1], pt[2], 1.0))
    return Point(x, y)
end

𝕊1 = LinearMap(UniformScaling(60))
𝕋1 = Translation(20, 30, 0)
ℝ1 = LinearMap(RotZ(π/3))
pts = map(pt -> transform_point(pt, 𝕋1 ∘ ℝ1 ∘ 𝕊1), rawpts)
...

```

# Paths versus polygons

When drawing in Luxor you'll usually be creating _paths_ and
_polygons_. It can be easy to confuse the two.

## Drawing graphics as paths

Luxor draws graphics onto the current drawing using paths.

There's always a current path. It starts off being empty.

A path can contain one or more sequences of straight lines
and Bézier curves. You add straight lines to the current
path using functions like `line()`, and add Bezier curves
using functions like `curve()`. You can continue the
path at a different location of the drawing using `move()`.

Luxor keeps track of the current path, the current point,
and the current graphics state (color, line thickness, and
so on), in response to the functions you call.

When called, the following function creates a single path consisting of three separate
shapes - a line, a rectangular box, and a circle. The [`move()`](@ref) function
as used here is essentially a "pick up the pen and move it elsewhere"
instruction. [`line()`](@ref) adds a straight line segment to the current path.
The `circle()` function adds four Bézier curves that provide a good approximation to a circle.

```julia
function make_path()
    move(Point(-220, 50))
    line(Point(-170, -50))
    line(Point(-120, 50))
    move(Point(0, 0))
    box(O, 100, 100, :path)
    move(Point(180, 0) + polar(40, 0)) # pt on circumference
    circle(Point(180, 0), 40, :path)
end
```

```@setup pathexample
using Luxor

function make_path()
    move(Point(-220, 50))
    line(Point(-170, -50))
    line(Point(-120, 50))
    move(Point(0, 0))
    box(O, 100, 100, :path)
    move(Point(180, 0) + polar(40, 0))
    circle(Point(180, 0), 40, :path)
end

d = @drawsvg begin
    background("antiquewhite")

    sethue("rebeccapurple")
    translate(0, -120)
    make_path()
    strokepath()

    translate(0, 120)
    sethue("orange")
    make_path()
    fillpath()

    translate(0, 120)
    make_path()
    clip()
    sethue("green")
    # Luxor <= "v3.8"
    # rule.(between.(O - (250, 0), O + (250, 0), 0:0.01:1), -π/3)
    # Luxor >= "v4.0"
    rule.(between(O - (250, 0), O + (250, 0), 0:0.01:1), -π/3)
end 800 500
```

```@example pathexample
d # hide
```

When you run this function, the path is added to the drawing.
The top path, in purple, is drawn when [`strokepath()`](@ref) is called.
Each of the three shapes is stroked with the same current settings
(color, line thickness, dash pattern, and so on).

After calling the function again, the middle row shows the effect of calling
[`fillpath()`](@ref) on the new path. It fills each of
the three shapes in the path with orange.

Finally, after calling the function again,
the [`clip()`](@ref) function turns this new path into a clipping path. The
[`rule()`](@ref) function draws green ruled lines, which are
clipped by the outlines of the shapes in the path.

You can construct paths using functions like [`move()`](@ref),
[`line()`](@ref), [`arc()`](@ref), and [`curve()`](@ref), plus any Luxor function
that lets you specify the `:path` ("add to path") action as a
keyword argument or parameter.

Many functions in Luxor have an `action` keyword argument or
parameter. If you want to add that shape to the current
path, use `:path`. If you want to both add the shape _and_
finish and draw the current path, use one of `stroke`,
`fill`, etc.

After the path is stroked or filled, it's emptied out, ready
for you to start over again. There's always a current path. But you can also use one of the
'-preserve' varsions, [`fillpreserve()`](@ref)/`:fillpreserve` or
[`strokepreserve()`](@ref)/`:strokepreserve` to continue working
with the currently defined path after drawing it. You can
also convert the path to a clipping path using
`:clip`/[`clip()`](@ref).

As you can see, a single path can contain multiple separate graphic shapes.

### Holes
If you want a path to contain holes,
you add the hole shapes to the current path after reversing
their direction. For example, to put a square hole inside a
circle, first create a circular shape, then draw a square
shape inside, making sure that the square runs in the
opposite direction to the circle. When you finally fill the
path, the interior shape forms a hole.

```@example
using Luxor # hide
d = @drawsvg begin # hide
background("antiquewhite") # hide
sethue("purple")
circle(O, 200, :path)
box(O, 100, 100, :path, reversepath=true)
fillpath()
end 800 500 # hide
d # hide
```

If you're constructing the path from simple path commands,
this is easy, and the functions that provide a `reversepath`
keyword argument can help. If not, you can do things like
this:

```julia
circle(O, 100, :path)                 # add a circle to the current path
poly(reverse(box(O, 50, 50)), :path)  # create polygon, add to current path after reversing
fillpath()                            # finally fill the two-part path
```

Many methods, including [`box()`](@ref), [`crescent()`](@ref),
[`ellipse()`](@ref), [`epitrochoid()`](@ref),
[`hypotrochoid()`](@ref), [`ngon()`](@ref),
[`polycross()`](@ref), [`rect()`](@ref),
[`squircle()`](@ref), and [`star()`](@ref), offer a
`vertices` keyword argument. With these you can specify
`vertices=true` to return a list of points _instead of_
constructing a path.

## Path objects

Sometimes it's useful to be able to store a path, rather
than just construct it on the drawing. It might also be
useful to draw it later, under different circumstances, and
perhaps more than once. To do this, you can use the `storepath()`
and `drawpath()` functions.

Consider this code that uses `storepath()`:

```julia
move(Point(-220, 50))
line(Point(-170, -50))
line(Point(-120, 50))
move(Point(0, 0))
box(O, 100, 100, :path)
move(Point(180, 0) + polar(40, 0)) # pt on circumference
circle(Point(180, 0), 40, :path)

pathexample # save Path
```

`pathexample` now contains the path, stored in a Luxor object of type `Path`. The current path is still present.

```julia-repl
julia> pathexample
Path([
 PathMove(Point(-220.0, 50.0)),
 PathLine(Point(-170.0, -50.0)),
 PathLine(Point(-120.0, 50.0)),
 PathMove(Point(-50.0, 50.0)),
 PathLine(Point(-50.0, -50.0)),
 PathLine(Point(50.0, -50.0)),
 PathLine(Point(50.0, 50.0)),
 PathClose(),
 PathMove(Point(220.0, 0.0)),
 PathCurve(Point(220.0, 22.08984375), Point(202.08984375, 40.0), Point(180.0, 40.0)),
 PathCurve(Point(157.91015625, 40.0), Point(140.0, 22.08984375), Point(140.0, 0.0)),
 PathCurve(Point(140.0, -22.08984375), Point(157.91015625, -40.0), Point(180.0, -40.0)),
 PathCurve(Point(202.08984375, -40.0), Point(220.0, -22.08984375), Point(220.0, 0.0))
])
```

It's now possible to draw this stored path at a later time. For example, this code builds a path, saves it as `pathexample`, then draws a number of rotated copies:

```@example
using Luxor
d = @draw begin
    move(Point(-220, 50))
    line(Point(-170, -50))
    line(Point(-120, 50))
    move(Point(0, 0))
    box(O, 100, 100, :path)
    move(Point(180, 0) + polar(40, 0))
    circle(Point(180, 0), 40, :path)

    pathexample = storepath() # store the path

    rotate(-π/2)
    for i in -200:50:200
        @layer begin
            randomhue()
            translate(0, i)
            drawpath(pathexample, :stroke)
        end
    end
end
d # hide
```

See also [Stored paths](@ref).

## Polygons

A polygon is a plain Vector (Array) of `Point`s.
There are no lines or curves, just 2D coordinates in the
form of `Point`s. When a polygon is eventually drawn, it's
converted into a path, and the points are connected
with short straight lines.

One important difference between polygons and paths is that
paths can contain Bézier curves.

The [`pathtopoly()`](@ref) function extracts the current
path that Luxor is in the process of constructing and
returns an array of Vectors of points - a set of one or more
polygons (remember that a single path can contain multiple
shapes). Internally this function uses
[`getpathflat()`](@ref), which is similar to
[`getpath()`](@ref) but it returns a Luxor path object in
which all Bézier curve segments have been reduced to
sequences of short straight lines.

So:

```julia
circle(O, 100, :path)
p = pathtopoly()
poly(first(p), :stroke)
```

is more or less equivalent to:

```julia
ngon(O, 100, 129, 0, :stroke)    # a 129agon with radius 100
```

Luxor draws as many short straight lines as necessary (here
about 129) so as to render the curve smooth at reasonable
magnifications.

Note that methods to functions might vary in how they
operate: whereas `box(Point(0, 0), 50, 50)` returns a
polygon (a list of points), `box(Point(0, 0), 50, 50,
:path)` adds a rectangle to the current path _and_ returns a
polygon. However, `box(Point(0, 0), 50, 50, 5 ... )`
constructs a path with Bézier-curved corners, so this
method doesn't return any vertex information - you'll have
to flatten the Béziers via [`getpathflat()`](@ref) or
obtain the path with intact Béziers via
[`getpath()`](@ref).

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Basic path construction

This tutorial covers the basics of drawing paths in Luxor. If you're familiar with the basics of Cairo, PostScript, Processing, HTML canvas, or similar graphics applications, you can probably glance through these tutorials and then refer to the How To sections. For much more information about how paths are built, refer to the [Cairo API documentation](https://cairographics.org/manual/cairo-Paths.html); Luxor hides the details behind friendly Julia syntax, but the underlying mechanics are the same.

## How to build a path

Consider the following drawing. (We'll use the quick `@drawsvg ...end` macro syntax for simplicity.) The point `(0, 0)` is at the center of the drawing canvas, and, as with most graphics software applications, the *y direction is downwards*.

!!! warning

    Mathematicians and people who like making plots say that the y axis goes up the page. Most graphics software is written with the assumption that the y axis goes downwards.

```@setup example_2
using Luxor
svgimage = @drawsvg begin
background("black")

@layer begin
    setopacity(0.8)
    setline(0.5)
    sethue(Luxor.Colors.colorant"green")
    circle(O, 5, :stroke)
    dimension(O, Point(200, 0), offset=0,textgap=0, textrotation = -π/2, texthorizontaloffset=5)
    dimension(Point(200, 0), Point(200, 100), offset=0,textgap=0, textrotation = -π/2, texthorizontaloffset=5)
    dimension(Point(200, 0), Point(250, 0), offset=0,textgap=0, textrotation = -π/2, texthorizontaloffset=5)
    dimension(Point(0, -200), Point(-200, -200), offset=0,textgap=0, textrotation = π/2, texthorizontaloffset=5)
    dimension(Point(-220, 0), Point(-220, -200), offset=0,textgap=10, textrotation = 0, texthorizontaloffset=5)
    circle.([Point(150, 150), Point(0, 100), Point(-200, -200)], 2, :fill)
    line(Point(150, 150), Point(250, 100), :stroke)
    line(Point(0, 100), Point(-200, -200), :stroke)
end
sethue("white")
move(Point(200, 0))
line(Point(250, 100))
curve(Point(150, 150), Point(0, 100), Point(-200, -200))
closepath()

strokepath()
end 520 520
```

```julia
using Luxor
@drawsvg begin
    background("black")

    sethue("white")
    move(Point(200, 0))
    line(Point(250, 100))
    curve(Point(150, 150), Point(0, 100), Point(-200, -200))
    closepath()

    strokepath()
end
```

```@example example_2
svgimage # hide
```

(Some annotations have been added (in green) to help you visualize the coordinate system.)

This drawing constructs and renders a path, using basic building blocks.

In Luxor, there's always a current path. At the start, just after we set the color to white, the current path is empty. The `move()` function call starts the path by moving  from (0, 0) to (200, 0), ie 200 units in x (right). This sets the *current point* to `Point(200, 0)`.

Next, the `line(Point(250, 100))` function call adds a straight line from the current point down to the point (250, 100). The current point is now set to (250, 100), and the current path now has two entries. We've reached the bottom right corner of this particular path.

The `curve()` function takes three point arguments, and adds a cubic Bézier curve to the current path. The curve runs from the current point to the third point argument, with the first and second point arguments defining the Bézier curve's control points. These don't lie on the curve, they just 'influence' the shape of the curve. Finally, the current point is updated to the point supplied as the third argument. We're now at the top left of the path.

!!! note

    To learn about Bézier curves, read [A Primer on Bézier Curves](https://pomax.github.io/Bézierinfo/).

Finally, the `closepath()` function adds a straight line to the path, joining the current point to the beginning of the path. (More precisely, it goes to the most recent point that you `move`d to). The current point is then updated to this point.

We could have used `line(Point(200, 0))` rather than `closepath()`, but `closepath()` is usually better than just drawing to the same point, because it will make a mitred join between the two line segments.

So, now we've constructed and finished a path - but now we must decide what to do with it. Above, we used `strokepath()` to draw the path using a line with the current settings (width, color, etc). But an alternative is to use `fillpath()` to fill the shape with the current color. `fillstroke()` does both. To change colors and styles, see [Colors and styles](@ref).

After you've rendered the path by stroking or filling it, the current path is empty again, ready for the next set of instructions.

And that's how you draw paths in Luxor.

However, you'd be right if you're thinking that constructing every single shape like this would be a lot of work. This is why there are so many other functions in Luxor, such as `circle()`, `ngon()`, `star()`, `rect()`, `box()`, `rule`, `crescent`, `squircle`, etc. See [Simple graphics](@ref) for a few of the more basic ones.

## Arcs

There are `arc()` and `carc()` (counterclockwise arc) functions that provide the ability to add circular arcs to the current path, just as `curve()` adds a Bézier curve. However, these need careful handling, because Luxor will insert lines sometimes that you didn't expect. Consider this drawing:

```@example
using Luxor
@drawsvg begin
    background("black")
    sethue("white")
    move(Point(100, 200))
    arc(Point(0, 0), 70, 0, 3π / 2)
    line(Point(-200, -200))
    strokepath()
end
```

The `arc()` function arguments are: the center point, the radius, the start angle, and the end angle.

But you'll notice that there are two straight lines, not just one. After moving down to (100, 200), the calculated start point for the arc isn't (100, 200), but (70, 0). So an extra straight line had to be inserted to go from the current point (100, 200) back up to the arc's starting point (70, 0) - this was automatically added to the path, even though you didn't specify it.

Internally, circular arcs are converted to Bézier curves by the Cairo engine.

## Relative coordinates

The `move()` and `line()` functions require absolute coordinates, which always refer to the current origin, (0, 0). You might prefer to define the positions with reference to the current path's current point. Use `rmove()` and `rline()` to do this.

This drawing draws two boxes with 120 unit sides.

```@example
using Luxor
@drawsvg begin
    background("black")
    sethue("white")

    move(0, 0)

    rline(Point(120, 0)) 
    rline(Point(0, 120))
    rline(Point(-120, 0))
    rline(Point(0, -120))

    closepath()

    rmove(150, 0)

    rline(Point(120, 0)) 
    rline(Point(0, 120))
    rline(Point(-120, 0))
    rline(Point(0, -120))

    closepath()

    strokepath()
end
```

The drawing instructions to make the two shapes are the same, the second set are applied shifted 150 units in x.

`rmove()` requires a current point to be "relative to". This is why the first drawing function is `move()` rather than `rmove()`.

Notice that this code draws two shapes, but there was only one `strokepath()` function call. These two shapes are in fact *subpaths*. A path can contain a number of separate shapes.

## Subpaths

A path consists of one or more of these move-line-curve-arc-closepath sequences. Each is a subpath. When you call a `strokepath()` or `fillpath()` function, all the subpaths in the entire path are rendered in the same way, and then the current path is emptied.

You can create a new subpath either by doing a `move()` or `rmove()` in the middle of building a path (before you render it), or with the specific `newsubpath()` function.

An important feature of subpaths is that they can form holes in paths.

```@example
using Luxor
@drawsvg begin
    background("black")
    sethue("white")

    move(0, 0)
    line(Point(0, 100))
    line(Point(100, 100))
    line(Point(100, 0))
    closepath()

    newsubpath()
    move(25, 25)
    line(Point(75, 25))
    line(Point(75, 75))
    line(Point(25, 75))
    closepath()

    fillpath()
end
```

The first subpath is counterclockwise, the second subpath is clockwise and thus forms a hole when you fill the path. (See [Nonzero winding rule](https://en.wikipedia.org/wiki/Nonzero-rule) for details.)

## Not just fill and stroke

As well as `strokepath()` or `fillpath()`, you can:

- `fillstroke()`: fill and stroke the path
- `clip()`:  turn the path into a clipping path
- `strokepreserve()`: stroke the path but don't empty the current path
- `fillpreserve()`: fill the path but don't empty the current path

The `-preserve()` functions are useful for using different styles for fill and stroke:

```@example
using Luxor
@drawsvg begin
    background("black")

    move(0, 0)
    line(Point(0, 100))
    line(Point(100, 100))
    line(Point(100, 0))
    closepath()

    # purple fill
    sethue("purple")
    fillpreserve()

    # current path is still here!

    # cyan stroke
    sethue("cyan")
    strokepath()
end
```

## Translate, scale, rotate

Suppose you want to repeat a path in various places on the drawing. Obviously you don't want to write the same code over and over again.

In this example, the `t()` function draws a triangle path relative to the current (0, 0) point.

```@example
using Luxor
function t()
    move(Point(100, 0))
    line(Point(0, -100))
    line(Point(-100, 0))
    closepath()
    strokepath()
end

@drawsvg begin
    background("black")
    sethue("white")
    t()
end
```

Inside `t()`, the coordinates, and other settings, are interpreted relative to the current graphics state: the current origin position (0, 0), scale (1), and rotation (0°), and so on.

To draw the triangle in another location, you first use `translate()` to shift the (0, 0) origin to another location. Now the `move()` and `line()` calls inside the `t()` function all automatically refer to the new location.

```@example
using Luxor
function t()
    move(Point(100, 0))
    line(Point(0, -100))
    line(Point(-100, 0))
    closepath()
    strokepath()
end

@drawsvg begin
    background("black")
    sethue("white")
    t()

    translate(Point(150, 150))
    t()
end
```

You can also use the `scale()` and `rotate()` functions to modify the current state:

```@example
using Luxor
function t()
    move(Point(100, 0))
    line(Point(0, -100))
    line(Point(-100, 0))
    closepath()
    strokepath()
end

@drawsvg begin
    background("black")
    sethue("white")
    t()

    translate(Point(150, 150))
    t()

    translate(Point(30, 30))
    scale(0.5)
    t()

    translate(Point(120, 120))
    rotate(π/3)
    t()
end
```

As you experiment with these three functions, you'll notice that the changes are always *relative* to the previous state. So if you do `scale(0.5)` twice, the next path will be drawn a quarter of the size.

So how do you return to a default initial state? You could of course keep a record of each transformation and apply the opposites, making sure you do this in the right order.

But a better way is to enclose a sequence of changes of position, scale, and orientation in a pair of functions (`gsave()` and `grestore()`). After `gsave()`, you can change position, scale, orientation, and set styling information, draw and render as many paths as you want, but then all the changes to position, scale, orientation, etc. will be discarded when you call `grestore()`.

The following code generates a grid of points in a nested loop. At each iteration:

1. `gsave()` saves the current position, scale, and orientation on an internal stack.

2. The graphics state is translated, scaled, and rotated.

3. The `t()` function is called, and draws the triangular path with the new settings - scaled, rotated, and translated relative to the current values of the `x` and `y` coordinates defined by the loop variables.

4. `grestore()` discards any changes to position, scale, and rotation, and restores them to the values they had just before the most recent `gsave()`.

```@example
using Luxor

function t()
    move(Point(100, 0))
    line(Point(0, -100))
    line(Point(-100, 0))
    closepath()
    strokepath()
end

@drawsvg begin
    background("black")
    sethue("white")
    for x in -250:20:250, y in -250:20:250
        gsave()
            translate(Point(x, y))
            scale(0.1)
            rotate(rand() * 2π)
            t()
        grestore()
    end
end
```

!!! note

    As an alternative to `gsave()` and `grestore()` you can use the `@layer begin ... end` macro, which does the same thing.

The other way to manipulate the graphics state (position, translation, rotation, scale) is to learn about the current transformation matrix. See [Transforms and matrices](@ref) for more.

## Useful tools

You can use `currentpoint()` to get the current point.

`rulers()` is useful for drawing the current x and y axes before you start a path. (For obvious reasons it's not useful while you're in the middle of drawing your path, becaause it applies its own set of paths.)

`storepath()` grabs the current path and saves it as a Path object. This feature is intended to make Luxor paths more like other Julia objects, which you can save and manipulate before drawing them.

There's another method for `line()` which takes two points and a rendering instruction. For example:

```julia
line(Point(0, 0), Point(100, 100), :stroke)
```

is just a quicker way of typing:

```julia
move(Point(0, 0))
line(Point(100, 100))
strokepath()
```

## Polygonal thinking

In Luxor, a polygon is an array (a standard Julia vector) of Points. You can treat it like any standard Julia array. When you want to draw it (or use it for clipping), you use the `poly()` function to make a path.

It's all straight lines, no curves, so you might have to use a lot of points to get smooth curves.

```@example
using Luxor
@drawsvg begin
    background("black")
    sethue("white")
    pts = 30 .* [Point(x, sin(x)) for x in -2π:0.1:2π]
    poly(pts, :stroke)

    translate(0, 100)

    poly(pts, :fill)
end
```

You might find it easier to generate your graphics using polygons than to generate paths by issuing lots of path functions. But, of course, there are no curves. If you need arcs and Bézier curves, stick to paths.

The `poly()` function simply builds a path with straight lines, and then does the `:fill` or `:stroke` action, depending on which you provide.

There are some Luxor functions that let you modify all the points in a polygon in various ways:

- `polymove!(pgon, pt1, pt2)`

  move all points by `pt1` -> `pt2`

- `polyreflect!(pgon, pt1, pt2)`

  reflect all points in line between `pt1` and `pt2`

- `polyrotate!(pgon, θ)`

  rotate all points by `θ`

- `polyscale!(pgon, s)`

  scale all points by `s`

```@meta
DocTestSetup = quote
    using Luxor, Colors, Random
    end
```
# Simple graphics

In Luxor, there are different ways of working with graphical
items:

- Draw them immediately. Add points and control points defining curves to build a **path** on the drawing. When you paint the path, the graphics are drawn, and ‘fixed’, and you move on to the next.

- Construct arrays of points - **polygons** - which you can draw at some later stage. Watch out for a `vertices=true` option, which returns coordinate data rather than adding shapes to the current path. Polygons are copied to paths when they're drawn.

- You can combine these two approaches: create a path from lines and curves (and jumps), then store the path, ready for drawing later on.

## Line width

The default line width in Luxor is 2 points. (Typically 1 point is 0.352777mm, 1/72.0inch.) Set the line width with [`setline`](@ref). Find the current line width with [`getline`](@ref). By default, line widths don't vary depending on the current drawing scale, but you can ask for them to be scaled - see [Scaling-of-line-thickness](@ref).

## Rectangles and boxes

Simple rectangle and box shapes can be made in different ways.

```@example
using Luxor # hide
Drawing(800, 220, "../assets/figures/basicrects.png") # hide
background("antiquewhite") # hide
origin() # hide
rulers()
sethue("grey40")
rect(Point(0, 0), 100, 100, action = :stroke)
sethue("blue")
box(Point(0, 0), 100, 100, action=:stroke)
finish() # hide
nothing # hide
```

![rect vs box](../assets/figures/basicrects.png)

[`rect`](@ref) rectangles are positioned by a corner, a box made with [`box`](@ref) can be defined either by its center and dimensions, or by two opposite corners.

```@setup boxrect
using Luxor
d = @drawsvg begin
    background("antiquewhite")
    panes = Table(fill(100, 1), fill(200, 4))

    fontsize(14)
    fontface("JuliaMono-Bold")
    @layer begin
        translate(panes[1])
        p1 = Point(-70, -70)
        p2 = Point(70, 70)
        box(p1, p2, action = :stroke)
        text("box(p1, p2", boxbottomcenter(BoundingBox(box(O, 140, 140)) + (0, 20)), halign=:center)
        sethue("purple")
        circle.((p1, p2), 8, action = :fill)
        label.(["p1", "p2"], [:N, :S], [p1, p2], offset=20)
    end
    @layer begin
        translate(panes[2])
        p = Point(0, 0)
        box(p, 140, 140, action = :stroke)
        text("box(p, w, h", boxbottomcenter(BoundingBox(box(O, 140, 140)) + (0, 20)), halign=:center)
        sethue("purple")
        circle(p, 8, action = :fill)
        label("p", :S, p, offset=20)
        corners = box(BoundingBox(box(p, 140, 140))...)
        arrow(corners[2] + (0, -15), corners[3] + (0, -15), decorate = () -> text("w", O + (0, -10)))
        arrow(corners[2] + (-15, 0), corners[1] + (-15, 0), decorate = () -> text("h", O + (0, 10), angle=-π/2))
    end
    @layer begin
        translate(panes[3])
        pt = Point(-70, -70)
        rect(pt, 140, 140, action = :stroke)
        text("rect(pt, w, h", boxbottomcenter(BoundingBox(box(O, 140, 140)) + (0, 20)), halign=:center)
        sethue("purple")
        circle(pt, 8, action = :fill)
        label("pt", :SE, pt, offset=20)
        corners = box(BoundingBox(box(O, 140, 140))...)
        arrow(corners[2] + (0, -15), corners[3] + (0, -15), decorate = () -> text("w", O + (0, -10)))
        arrow(corners[2] + (-15, 0), corners[1] + (-15, 0), decorate = () -> text("h", O + (0, 10), angle=-π/2))
    end
    @layer begin
        translate(panes[4])
        sethue("purple")
        s = star(O, 70, 5, 0.5, 0, action = :stroke)
        sethue("black")
        box(BoundingBox(s), action = :stroke)
        text("BoundingBox(poly...)", boxbottomcenter(BoundingBox(box(O, 140, 140)) + (0, 20)), halign=:center)
    end
end 800 250
```

```@example boxrect
d # hide
```

If you want the coordinates of the corners of a box, rather than draw one immediately, use:

```julia
box(centerpoint, width, height, vertices=true)
```

or

```julia
box(corner1,  corner2, vertices=true)
```

[`box`](@ref) is also able to draw some of the other Luxor objects, such as BoundingBoxes and Table cells, and usually also returns the coordinates of the corners.

```@example
using Luxor # hide
box(Point(0, 0), 100, 100)
```

To draw a box/rectangle with rounded corners, supply one or
four values for corner radii.

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/round-rect-1.png") # hide
origin() # hide
background("antiquewhite") # hide
setline(6)
sethue("black") # hide
box(O, 200, 150, 10, action = :stroke) # 1 value for all corners
sethue("purple")
box(O, 260, 220, [0, 15, 40, 80], action = :stroke) # different for each
finish() # hide
nothing # hide
```

![rounded rect 1](../assets/figures/round-rect-1.png)

Or you could smooth the sharp corners of a box, like so:

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/round-rect.png") # hide
origin() # hide
background("antiquewhite") # hide
sethue("black") # hide
setline(4)
polysmooth(box(O, 200, 150, vertices=true), 10, action = :stroke)
finish() # hide
nothing # hide
```

![rounded rect](../assets/figures/round-rect.png)

The [`squircle`](@ref) function makes nicer shapes.

## Triangles, pentagons, and regular polygons

For regular polygons, pentagons, and so on, see the section on [Polygons and paths](@ref). If you like drawing hexagons, you could also read [Hexagonal grids](@ref). Eqilateral Triangular grids are also provided ([EquilateralTriangleGrid](@ref)).

## Circles and ellipses

There are various ways to make circles, including by center and radius, or passing through two or three points:

```@example
using Luxor # hide
Drawing(800, 200, "../assets/figures/circles.png") # hide
background("antiquewhite") # hide

origin() # hide
setline(3) # hide
sethue("black")
p1 = Point(0, -50)
p2 = Point(100, 0)
p3 = Point(0, 65)
map(p -> circle(p, 4, action = :fill), [p1, p2, p3])
sethue("orange")
circle(center3pts(p1, p2, p3)..., action = :stroke)

sethue("red")
p1 = Point(0, 30)
p2 = Point(20, -40)
p3 = Point(50, 5)
circle.((p1, p2, p3), 3, action = :stroke)
circle(p1, p2, p3, action = :stroke)

finish() # hide
nothing # hide
```

![circles](../assets/figures/circles.png)

The [`center3pts`](@ref) function returns the center position and radius of a circle passing through three points:

```@example
using Luxor, Random # hide
Drawing(800, 200, "../assets/figures/center3.png") # hide
background("antiquewhite") # hide
origin() # hide
setline(3) # hide
sethue("black")
p1 = Point(0, -50)
p2 = Point(100, 0)
p3 = Point(0, 65)
map(p -> circle(p, 4, action = :fill), [p1, p2, p3])
sethue("orange")
circle(center3pts(p1, p2, p3)..., action = :stroke)
finish() # hide
nothing # hide
```

![center and radius of 3 points](../assets/figures/center3.png)

With [`ellipse`](@ref) you can place ellipses and circles by defining the center point and the width and height.

```@example
using Luxor, Random # hide
Drawing(800, 300, "../assets/figures/ellipses.png") # hide
background("antiquewhite") # hide
fontsize(11) # hide
Random.seed!(1) # hide
origin() # hide
tiles = Tiler(500, 300, 5, 5)
width = 20
height = 25
for (pos, n) in tiles
    global width, height
    randomhue()
    ellipse(pos, width, height, action = :fill)
    sethue("black")
    label = string(round(width/height, digits=2))
    textcentered(label, pos.x, pos.y + 25)
    width += 2
end
finish() # hide
nothing # hide
```

![ellipses](../assets/figures/ellipses.png)

[`ellipse`](@ref) can also construct polygons that are approximations to ellipses. You supply two focal points and a length which is the sum of the distances of a point on the perimeter to the two focii.

```@example
using Luxor, Random # hide
Drawing(800, 220, "../assets/figures/ellipses_1.png") # hide
origin() # hide
background("antiquewhite") # hide

Random.seed!(42) # hide
sethue("black") # hide
setline(1) # hide
fontface("Menlo")

f1 = Point(-100, 0)
f2 = Point(100, 0)

circle.([f1, f2], 3, action = :fill)

epoly = ellipse(f1, f2, 250, vertices=true)
poly(epoly, action = :stroke,  close=true)

pt = epoly[rand(1:end)]

poly([f1, pt, f2], action = :stroke)

label("f1", :W, f1, offset=10)
label("f2", :E, f2, offset=10)

label(string(round(distance(f1, pt), digits=1)), :SE, midpoint(f1, pt))
label(string(round(distance(pt, f2), digits=1)), :SW, midpoint(pt, f2))

label("ellipse(f1, f2, 250)", :S, Point(0, 75))

finish() # hide
nothing # hide
```

![more ellipses](../assets/figures/ellipses_1.png)

The advantage of this method is that there's a `vertices=true` option, allowing further scope for polygon manipulation.

```@example
using Luxor # hide
Drawing(800, 450, "../assets/figures/ellipses_2.png") # hide
origin() # hide
background("antiquewhite") # hide
sethue("gray30") # hide
setline(1) # hide
f1 = Point(-100, 0)
f2 = Point(100, 0)
ellipsepoly = ellipse(f1, f2, 170, :none, vertices=true)
[ begin
    setgray(rescale(c, 150, 1, 0, 1))
    poly(offsetpoly(ellipsepoly, c), close=true, action = :fill);
    rotate(π/20)
  end
     for c in 150:-10:1 ]
finish() # hide
nothing # hide
```

![even more ellipses](../assets/figures/ellipses_2.png)

The [`ellipseinquad`](@ref) function constructs an ellipse that fits inside a four-sided quadrilateral.

```@example
using Luxor # hide
Drawing(800, 600, "../assets/figures/ellipseinquad.png") # hide
origin() # hide
background("antiquewhite") # hide
sethue("gray30") # hide
setline(1) # hide

pg = ngon(O, 250, 6, π/6, vertices=true)

top = vcat(O, pg[[3, 4, 5]])
left = vcat(O, pg[[1, 2, 3]])
right = vcat(O, pg[[5, 6, 1]])
sethue("red")
poly(top, action = :fill, close=true)

sethue("green")
poly(left, action = :fill, close=true)

sethue("blue")
poly(right, action = :fill, close=true)

sethue("orange")
ellipseinquad.((top, left, right), action = :fill)

finish() # hide
nothing # hide
```

![ellipse in quadrilateral](../assets/figures/ellipseinquad.png)

[`circlepath`](@ref) constructs a circular path from Bézier curves.

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/circle-path.png") # hide
origin() # hide
background("antiquewhite") # hide
sethue("black") # hide
setline(4)
tiles = Tiler(600, 250, 1, 5)
for (pos, n) in tiles
    randomhue()
    circlepath(pos, tiles.tilewidth/2, action = :path)
    newsubpath()
    circlepath(pos, rand(5:tiles.tilewidth/2 - 1), action = :fill, reversepath=true)
end
finish() # hide
nothing # hide
```

![circles as paths](../assets/figures/circle-path.png)

## Circles and tangents

Functions to find tangents to circles include:

- [`pointcircletangent`](@ref) finds a point on a circle that lies on line through another point
- [`circlecircleoutertangents`](@ref) finds the points that lie on outer tangents to two circles
- [`circlecircleinnertangents`](@ref) finds the points that lie on inner tangents to two circles
- [`circletangent2circles`](@ref) makes circles of a particular radius tangential to two circles
- [`circlepointtangent`](@ref) makes circles of a particular radius passing through a point and tangential to another circle

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/point-circle-tangents.png") # hide
origin() # hide
background("antiquewhite") # hide
setline(1) # hide
sethue("black") # hide

point = Point(-150, 0)
circlecenter = Point(150, 0)
circleradius = 80

circle.((point, circlecenter), 5, action = :fill)
circle(circlecenter, circleradius, action = :stroke)
pt1, pt2 = pointcircletangent(point, circlecenter, circleradius)
circle.((pt1, pt2), 5, action = :fill)

sethue("grey65")
rule(point, slope(point, pt1))
rule(point, slope(point, pt2))

finish() # hide
nothing # hide
```

![point circle tangents](../assets/figures/point-circle-tangents.png)

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/circle-circle-outer-tangents.png") # hide
origin() # hide
background("antiquewhite") # hide
setline(1) # hide
sethue("black") # hide

circle1center = Point(-150, 0)
circle1radius = 60
circle2center = Point(150, 0)
circle2radius = 80

circle.((circle1center, circle2center), 5, action = :fill)
circle(circle1center, circle1radius, action = :stroke)
circle(circle2center, circle2radius, action = :stroke)

p1, p2, p3, p4 = circlecircleoutertangents(
    circle1center, circle1radius,
    circle2center, circle2radius)

sethue("orange")
rule(p1, slope(p1, p2))
rule(p3, slope(p3, p4))

finish() # hide
nothing # hide
```

![circle circle outer tangents](../assets/figures/circle-circle-outer-tangents.png)

Finding the inner tangents requires a separate function.

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/circle-circle-inner-tangents.png") # hide
origin() # hide
background("antiquewhite") # hide
setline(1) # hide
sethue("black") # hide

circle1center = Point(-150, 0)
circle1radius = 60
circle2center = Point(150, 0)
circle2radius = 80

circle.((circle1center, circle2center), 5, action = :fill)
circle(circle1center, circle1radius, action = :stroke)
circle(circle2center, circle2radius, action = :stroke)

p1, p2, p3, p4 = circlecircleinnertangents(
    circle1center, circle1radius,
    circle2center, circle2radius)

label.(("p1", "p2", "p3", "p4"), :n, (p1, p2, p3, p4))
sethue("orange")
rule(p1, slope(p1, p2))
rule(p3, slope(p3, p4))

sethue("purple")
circle.((p1, p2, p3, p4), 3, action = :fill)

finish() # hide
nothing # hide
```

![circle circle inner tangents](../assets/figures/circle-circle-inner-tangents.png)

[`circletangent2circles`](@ref) takes the required radius and two existing circles:

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/circle-tangents.png") # hide
origin() # hide
background("antiquewhite") # hide
sethue("black") # hide
setline(1) # hide

circle1 = (Point(-100, 0), 90)
circle(circle1..., action = :stroke)
circle2 = (Point(100, 0), 90)
circle(circle2..., action = :stroke)

requiredradius = 25
ncandidates, p1, p2 = circletangent2circles(requiredradius, circle1..., circle2...)

if ncandidates == 2
    sethue("orange")
    circle(p1, requiredradius, action = :fill)
    sethue("green")
    circle(p2, requiredradius, action = :fill)
    sethue("purple")
    circle(p1, requiredradius, action = :stroke)
    circle(p2, requiredradius, action = :stroke)
end

# the circles are 10 apart, so there should be just one circle
# that fits there

requiredradius = 10
ncandidates, p1, p2 = circletangent2circles(requiredradius, circle1..., circle2...)

if ncandidates == 1
    sethue("blue")
    circle(p1, requiredradius, action = :fill)
    sethue("cyan")
    circle(p1, requiredradius, action = :stroke)
end

finish() # hide
nothing # hide
```

![circle tangents](../assets/figures/circle-tangents.png)

[`circlepointtangent`](@ref) looks for circles of a specified radius that pass through a point and are tangential to a circle. There are usually two candidates.

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/circle-point-tangent.png") # hide
origin() # hide
background("antiquewhite") # hide
sethue("black") # hide
setline(1) # hide

circle1 = (Point(-100, 0), 90)
circle(circle1..., action = :stroke)

requiredradius = 50
requiredpassthrough = O + (80, 0)
ncandidates, p1, p2 = circlepointtangent(requiredpassthrough, requiredradius, circle1...)

if ncandidates == 2
    sethue("orange")
    circle(p1, requiredradius, action = :stroke)
    sethue("green")
    circle(p2, requiredradius, action = :stroke)
end

sethue("black")
circle(requiredpassthrough, 4, action = :fill)

finish() # hide
nothing # hide
```

![circle tangents 2](../assets/figures/circle-point-tangent.png)

These last two functions can return 0, 1, or 2 points (since there are often two solutions to a specific geometric layout).

[`circlering`](@ref) constructs `n` circles inside an outer circle and tangent to it. It returns both an array of 'circles' (`(pt, radius)` tuples), and details of the circle that fits inside them.

```@example
using Luxor # hide
@drawsvg begin # hide
    background("antiquewhite")
    sethue("rebeccapurple")
    setline(3)
    circle(Point(0, 0), 200, :stroke)
    cs, ic = circlering(Point(0, 0), 200, 10)
    for c in cs
        circle(first(c), last(c), :stroke)
    end
    circle(first(ic), last(ic), :stroke)
end 800 450 # hide
```

## Crescents

Use [`crescent`](@ref) to construct crescent shapes. There are two methods.
The first method allows the two arcs to have the same radius.
The second method allows the two arcs to share the same centers.

```@example
using Luxor # hide
Drawing(800, 500, "../assets/figures/crescents.png") # hide
background("antiquewhite") # hide
origin() # hide

# method 1: same radius, different centers

sethue("purple")
crescent(Point(-200, 0), 200, Point(-150, 0), 200, action = :fill)

# method 2: same center, different radii

sethue("orange")
crescent(O, 100, 200, action = :fill)

finish() # hide
nothing # hide
```

![crescents](../assets/figures/crescents.png)

## Paths and positions

A path is a sequence of lines and curves. You can add lines and curves to the current path with various functions, then use [`closepath`](@ref) to join the last point to the first. Once you fill or stroke it, the path is emptied, and you start again.

A path can have subpaths, created with[` newsubpath`](@ref), which can form holes.

There is a 'current point' which you can set with [`move`](@ref), and which is updated after functions like [`line`](@ref), [`rline`](@ref), [`rmove`](@ref), [`text`](@ref), [`newpath`](@ref), [`closepath`](@ref), [`arc`](@ref), and [`curve`](@ref). Use [`currentpoint`](@ref) and [`hascurrentpoint`](@ref) to find out about it.

You can store a path for later use with [`storepath`](@ref) and draw it with [`drawpath`](@ref). See [Stored paths](@ref).

For more about paths, see [Polygons and paths](@ref) and [Paths versus polygons](@ref).

## Lines

Use [`line`](@ref) and [`rline`](@ref) to draw straight lines. `line(pt1, pt2, action)` makes a path consisting of a line between two points. `line(pt)` adds a line to the current path going from the most recent current point to `pt`. `rline(pt)` adds a line relative to the current point.

You can use [`rule`](@ref) to draw a horizontal line through a point. Supply an angle for lines at an angle to the current x-axis. This example rules lines at an angle of -π/2 to the current x-axis.

```@example
using Luxor # hide
Drawing(800, 200, "../assets/figures/rule.png") # hide
background("antiquewhite") # hide
sethue("black") # hide
setline(0.5) # hide
y = 10
for x in 10 .^ range(0, length=100, stop=3)
    global y
    circle(Point(x, y), 2, action = :fill)
    rule(Point(x, y), -π/2, boundingbox=BoundingBox(centered=false))
    y += 2
end

finish() # hide
nothing # hide
```

![ruling lines](../assets/figures/rule.png)

Use the `boundingbox` keyword argument to crop the ruled lines where they cross the boundaries of a BoundingBox.

```@example
using Luxor # hide
Drawing(800, 200, "../assets/figures/rulebbox.png") # hide
origin()
background("antiquewhite") # hide
sethue("black") # hide
setline(0.75) # hide
box(BoundingBox() * 0.9, action = :stroke)
for x in 10 .^ range(0, length=100, stop=3)
    rule(Point(x, 0), π/2,  boundingbox=BoundingBox() * 0.9)
    rule(Point(-x, 0), π/2, boundingbox=BoundingBox() * 0.9)
end
finish() # hide
nothing # hide
```

![ruling lines clipped to bounding boxes](../assets/figures/rulebbox.png)

Another method of `rule()` draws a line through two points. 

```@example
using Luxor, Colors # hide

@drawsvg begin
    background("antiquewhite")
    sethue("black")
    pt1 = Point(-100, -50)
    pt2 = Point(200, 120)
    circle.((pt1, pt2), 10, :fill)
    rule(pt1, pt2)
end 800 500
```

This next example rules lines passing through each pair of adjacent points of the edge of a squircle curve.

```@example
using Luxor, Colors

@drawsvg begin
    background("black")
    fontsize(500)
    fontface("Times-Bold")
    pts = polybspline(squircle(O, 140, 140, vertices=true), 120)
    setline(0.5)
        for i in eachindex(pts)
            sethue(HSL(rescale(i, 1, length(pts), 1, 360), 0.8, 0.8))
            rule(pts[i], pts[mod1(i + 1, end)])
        end
end 800 500
d1 = svgstring()

@drawsvg begin
    background("grey10")
    # draw image 
    im = readsvg(d1)
    placeimage(im, centered=true, O)

    # define "loupe"
    point_of_interest = Point(120, -120)
    radius_of_interest = 25

    point_of_display = Point(350, -50)
    radius_of_display = 140
    # "magnification is $(radius_of_display / radius_of_interest)"

    # draw contents of loupe
    @layer begin
        translate(point_of_display)
        setline(2)
        circle(O, radius_of_display, :clip)
        scale(radius_of_display / radius_of_interest)
        placeimage(im, centered=true, -point_of_interest)
        clipreset()
    end

    # draw loupe itself
    sethue("white")
    setline(2)
    circle(point_of_interest, radius_of_interest, :stroke)
    circle(point_of_display, radius_of_display, :stroke)
    d = distance(point_of_interest, point_of_display)
    line(
        between(point_of_display, point_of_interest, radius_of_display / d),
        between(point_of_display, point_of_interest, 1 - radius_of_interest / d),
        :stroke)
end 1200 500
```

## Arrows

You can draw lines, arcs, and curves with arrows at the end with [`arrow`](@ref).

|type                            |function call                     |
|:---                            |:---                              |
| straight between two points    |arrow(pt, pt)                     |
| curved: radius + two angles    |arrow(pt, rad, θ1, θ2)            |
| Bezier 4 points                |arrow(pt1, pt2, pt3, pt4, action) |
| Bezier start finish + box      |arrow(pt1, pt2, [ht1, ht2])       |

For straight arrows, supply the start and end points. For arrows as circular arcs, you provide center, radius, and start and finish angles. You can optionally provide dimensions for the `arrowheadlength` and `arrowheadangle` of the tip of the arrow (angle in radians between side and center). The default line weight is 1.0, equivalent to `setline(1)`, but you can specify another.

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/arrow.png") # hide
background("antiquewhite") # hide
origin() # hide
sethue("steelblue4") # hide
setline(2) # hide
arrow(Point(0, 0), Point(0, -65))
arrow(Point(0, 0), Point(100, -65), arrowheadlength=20, arrowheadangle=pi/4, linewidth=.3)
arrow(Point(0, 0), 100, π, π/2, arrowheadlength=25,   arrowheadangle=pi/12, linewidth=1.25)
finish() # hide
nothing # hide
```
![arrows](../assets/figures/arrow.png)

If you provide four points, you can draw a Bézier curve with optional arrowheads at each end. Use the various options to control their presence and appearance.

```@example
using Luxor # hide
Drawing(800, 400, "../assets/figures/arrowbezier.png") # hide
background("antiquewhite") # hide
origin() # hide
setline(2) # hide
pts = ngon(Point(0, 0), 100, 8, vertices=true)
sethue("mediumvioletred")
arrow(pts[2:5]..., :stroke, startarrow=false, finisharrow=true)
sethue("cyan4")
arrow(pts[3:6]..., startarrow=true, finisharrow=true)
sethue("midnightblue")
arrow(pts[[4, 2, 6, 8]]..., :stroke,
    startarrow=true,
    finisharrow=true,
    arrowheadangle = π/6,
    arrowheadlength = 35,
    linewidth = 1.5)
finish() # hide
nothing # hide
```
![arrows](../assets/figures/arrowbezier.png)

### Decoration

The [`arrow`](@ref) functions allow you to specify
**decorations** - graphics at one or more points somewhere along
the shaft. For example, say you want to draw a number and a
circle at the midpoint of an arrow's shaft, you can define a
function that draws text `t` in a circle of radius `r` like
this:

```julia
function marker(r, t)
    @layer begin
        sethue("purple")
        circle(Point(0, 0), r,  :fill)
        sethue("white")
        fontsize(30)
        text(string(t), halign=:center, valign=:middle)
    end
end
```

and then pass this to the `decorate` keyword argument of
`arrow`. By default, the graphics origin when the function
is called is placed at the midpoint (0.5) of the arrow's
shaft.

```@example
using Luxor # hide
Drawing(800, 400, "../assets/figures/arrowbezierdecoration.png") # hide
background("antiquewhite") # hide
origin() # hide
setline(2) # hide

function marker(r, t) #hide
    @layer begin #hide
        sethue("purple") #hide
        circle(Point(0, 0), r,  :fill) #hide
        sethue("white") #hide
        fontsize(25) #hide
        text(string(t), halign=:center, valign=:middle) # hide
    end #hide
end #hide

pts = ngon(Point(0, 0), 100, 5, vertices=true)

sethue("mediumvioletred")

# using an anonymous function
arrow(pts[1:4]..., decorate = () -> marker(10, 3))

sethue("olivedrab")

# no arrow, just a graphic, at 0.75
arrow(pts[1:4]...,
    decorate = () -> ngon(Point(0, 0), 20, 4, 0, action = :fill),
    decoration = 0.75, :none) # default action is :stroke

finish() # hide
nothing # hide
```
![arrows with decoration](../assets/figures/arrowbezierdecoration.png)

Use the `decoration` keyword to specify one or more
locations other than the default 0.5.

The graphics environment provided by the `decorate` function
is centered at each decoration point in turn, and rotated to
the slope of the shaft at that point.

```@example
using Luxor

function fletcher()
    line(O, polar(30, deg2rad(220)), action = :stroke)
    line(O, polar(30, deg2rad(140)), action = :stroke)
end

@drawsvg begin
    background("antiquewhite")
        arrow(O, 150, 0, π + π/3,
            linewidth=5,
            arrowheadlength=50,
            decorate=fletcher,
            decoration=range(0., .1, length=3))
end 800 350
```

### Custom arrowheads

To make custom arrowheads, you can define a three-argument
function that draws them to your own design. This function
takes the arguments:

- the point at the end of the arrow's shaft

- the point where the tip of the arrowhead would be

- the angle of the shaft at the end

You can then use any code to draw the arrow. Pass this
function to the [`arrow`](@ref) function's
`arrowheadfunction` keyword.

```@example
using Luxor # hide

function redbluearrow(shaftendpoint, endpoint, shaftangle)
    @layer begin
        sethue("red")
        sidept1 = shaftendpoint  + polar(10, shaftangle + π/2 )
        sidept2 = shaftendpoint  - polar(10, shaftangle + π/2)
        poly([sidept1, endpoint, sidept2], action=:fill)
        sethue("blue")
        poly([sidept1, endpoint, sidept2], action=:stroke, close=false)
    end
end

@drawsvg begin
    background("antiquewhite")
    arrow(O, O + (120, 120),
        linewidth=4,
        arrowheadlength=40,
        arrowheadangle=π/7,
        arrowheadfunction = redbluearrow)

    arrow(O, 100, 3π/2, π,
        linewidth=4,
        arrowheadlength=20,
        clockwise=false,arrowheadfunction=redbluearrow)
end 800 250
```

## Arcs and curves

There are a few standard arc-drawing commands, such as
[`curve`](@ref), [`arc`](@ref), [`carc`](@ref), and
[`arc2r`](@ref). Because these are often used when building
complex paths, they usually add arc sections to the current
path. To construct a sequence of lines and arcs, use the
`:path` action, followed by a final `:stroke` or similar.

[`curve`](@ref) constructs Bézier curves from control points:

```@example
using Luxor # hide
Drawing(800, 275, "../assets/figures/curve.png") # hide
origin() # hide
background("antiquewhite") # hide

sethue("black") # hide

setline(.5)
pt1 = Point(0, -125)
pt2 = Point(200, 125)
pt3 = Point(200, -125)

label.(string.(["O", "control point 1", "control point 2", "control point 3"]),
    :e,
    [O, pt1, pt2, pt3])

sethue("red")
map(p -> circle(p, 4, action=:fill), [O, pt1, pt2, pt3])

line(Point(0, 0), pt1, action=:stroke)
line(pt2, pt3, action = :stroke)

sethue("black")
setline(3)

# start a path
move(Point(0, 0))
curve(pt1, pt2, pt3) #  add to current path
strokepath()

finish()  # hide
nothing # hide
```

![curve](../assets/figures/curve.png)

[`arc2r`](@ref) draws a circular arc centered at a point
that passes through two other points:

```@example
using Luxor, Random # hide
Drawing(800, 200, "../assets/figures/arc2r.png") # hide
origin() # hide
Random.seed!(42) # hide
background("antiquewhite") # hide
tiles = Tiler(700, 200, 1, 6)
for (pos, n) in tiles
    c1, pt2, pt3 = ngon(pos, rand(10:50), 3, rand(0:pi/12:2pi), vertices=true)
    sethue("black")
    map(pt -> circle(pt, 4, action = :fill), [c1, pt3])
    sethue("red")
    circle(pt2, 4, action = :fill)
    randomhue()
    arc2r(c1, pt2, pt3, action = :stroke)
end
finish() # hide
nothing # hide
```

![arc](../assets/figures/arc2r.png)

[`arc2sagitta`](@ref) and [`carc2sagitta`](@ref) make
circular arcs based on two points and the
[sagitta](https://en.wikipedia.org/wiki/Sagitta_(geometry)).

```@example
using Luxor, Colors # hide
Drawing(800, 250, "../assets/figures/arc2sagitta.svg") # hide
origin() # hide
background("antiquewhite") # hide
setline(.5) # hide
translate(0, 50) # hide
pt1 = Point(-100, 0)
pt2 = Point(100, 0)
for n in reverse(range(1, length=7, stop=120))
    sethue("red")
    rule(Point(0, -n))
    sethue(LCHab(70, 80, rescale(n, 120, 1, 0, 359)))
    pt, r = arc2sagitta(pt1, pt2, n, action = :fillpreserve)
    sethue("black")
    strokepath()
    text(string(round(n)), O + (120, -n))
end
circle.((pt1, pt2), 5, action = :fill)
finish() # hide
nothing # hide
```

![arc](../assets/figures/arc2sagitta.svg)

## More curved shapes: sectors, spirals, and squircles

A sector (technically an "annular sector") has an inner and outer radius, as well as start and end angles.

```@example
using Luxor # hide
Drawing(800, 200, "../assets/figures/sector.png") # hide
background("antiquewhite") # hide
origin() # hide
sethue("tomato")
sector(50, 90, π/2, 0, action=:fill)
sethue("olive")
sector(Point(O.x + 200, O.y), 50, 90, 0, π/2, action=:fill)
finish() # hide
nothing # hide
```

![sector](../assets/figures/sector.png)

You can also supply a value for a corner radius. The same sector is drawn but with rounded corners.

```@example
using Luxor # hide
Drawing(800, 200, "../assets/figures/sectorrounded.png") # hide
background("antiquewhite") # hide
origin() # hide
sethue("tomato")
sector(50, 90, π/2, 0, 15, action = :fill)
sethue("olive")
sector(Point(O.x + 200, O.y), 50, 90, 0, π/2, 15, action = :fill)
finish() # hide
nothing # hide
```

![sector](../assets/figures/sectorrounded.png)

A pie (or wedge) has start and end angles.

```@example
using Luxor # hide
Drawing(800, 300, "../assets/figures/pie.png") # hide
background("antiquewhite") # hide
origin() # hide
sethue("magenta") # hide
pie(0, 0, 100, π/2, π, action = :fill)
finish() # hide
nothing # hide
```

![pie](../assets/figures/pie.png)

To construct spirals, use the [`spiral`](@ref) function. These can be drawn directly, or used as polygons. The default is to draw Archimedean (non-logarithmic) spirals.

```@example
using Luxor # hide
Drawing(800, 300, "../assets/figures/spiral.png") # hide
background("antiquewhite") # hide
origin() # hide
sethue("black") # hide
setline(.5) # hide
fontface("Avenir-Heavy") # hide
fontsize(15) # hide

spiraldata = [
  (-2, "Lituus",      50),
  (-1, "Hyperbolic", 100),
  ( 1, "Archimedes",   1),
  ( 2, "Fermat",       5)]

grid = GridRect(O - (200, 0), 130, 50)

for aspiral in spiraldata
    @layer begin
        translate(nextgridpoint(grid))
        spiral(last(aspiral), first(aspiral), period=20π, action = :stroke)
        label(aspiral[2], :S, offset=100)
    end
end

finish() # hide
nothing # hide
```

![spiral](../assets/figures/spiral.png)

Use the `log=true` option to draw logarithmic (Bernoulli or Fibonacci) spirals.

```@example
using Luxor # hide
Drawing(800, 400, "../assets/figures/spiral-log.png") # hide
background("antiquewhite") # hide
origin() # hide
setline(.5) # hide
sethue("black") # hide
fontface("Avenir-Heavy") # hide
fontsize(15) # hide

spiraldata = [
    (10,  0.05),
    (4,   0.10),
    (0.5, 0.17)]

grid = GridRect(O - (200, 0), 175, 50)
for aspiral in spiraldata
    @layer begin
        translate(nextgridpoint(grid))
        spiral(first(aspiral), last(aspiral), log=true, period=10π, action = :stroke)
        label(string(aspiral), :S, offset=100)
    end
end

finish() # hide
nothing # hide
```

Modify the `stepby` and `period` parameters to taste, or collect the vertices for further processing.

![spiral log](../assets/figures/spiral-log.png)

A *squircle* is a cross between a square and a circle. You can adjust the squariness and circularity of it to taste by supplying a value for the root (keyword `rt`):

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/squircle.png") # hide
background("antiquewhite") # hide
origin() # hide
fontsize(20) # hide
setline(2)
tiles = Tiler(600, 250, 1, 3)
for (pos, n) in tiles
    sethue("lavender")
    squircle(pos, 80, 80, rt=[0.3, 0.5, 0.7][n], action = :fillpreserve)
    sethue("grey20")
    strokepath()
    textcentered("rt = $([0.3, 0.5, 0.7][n])", pos)
end
finish() # hide
nothing # hide
```
![squircles](../assets/figures/squircle.png)

`squirclepath()` builds a squircle shape using Bézier curves as paths, rather than using polygons. Here, `kappa` determines the circularity. 

```@example
using Luxor # hide
@drawsvg begin # hide
    background("grey10") # hide
    setfillrule(:even_odd)
    sethue("white")
    for x in 280:-10:10
    squirclepath(O, x, x;
        kappa = x/150, action=:path)
    end 
    fillpath()
end 800 700 # hide
```

## Stars and crosses

Use [`star`](@ref) to make a star. You can draw it immediately, or use the array of points it can create.

```@example
using Luxor # hide
Drawing(800, 300, "../assets/figures/stars.png") # hide
background("antiquewhite") # hide
origin() # hide
tiles = Tiler(400, 300, 4, 6, margin=5)
for (pos, n) in tiles
    randomhue()
    star(pos, tiles.tilewidth/3, rand(3:8), 0.5, 0, action = :fill)
end
finish() # hide
nothing # hide
```

![stars](../assets/figures/stars.png)

The `ratio` determines the length of the inner radius compared with the outer.

```@example
using Luxor # hide
@drawsvg begin # hide
background("antiquewhite") # hide
fontsize(10) # hide
tiles = Tiler(800, 250, 1, 6, margin=10)
sethue("black") # hide
for (pos, n) in tiles
    s = star(pos, tiles.tilewidth/2, 5, 1/n, 0, action = :stroke)
    l2 = distance(pos, s[1])
    l1 = distance(pos, s[2])
    text(string(round(l1/l2, digits=2)), pos, halign=:center)
end
end 800 200 # hide
```

Use [`polycross`](@ref) to draw a cross-shaped polygon.

```@example
using Luxor # hide
Drawing(800, 600, "../assets/figures/polycross.png") # hide
origin() # hide
background("antiquewhite") # hide
sethue("black") # hide
setline(2) # hide
tiles = Tiler(600, 600, 4, 4, margin=10)
for (pos, n) in tiles
    randomhue()
    polycross(pos, min(tiles.tileheight/3, tiles.tilewidth/3),
        n + 2, # number of points
        rescale(n, 1, length(tiles), 0.9, 0.1), # ratio
        0, # orientation
        action=:fill)
end
finish() # hide
nothing # hide
```

![polycross](../assets/figures/polycross.png)

## Stored paths

It's possible to store the current path in a Path object. For example, this code:

```julia
fontsize(160)
fontface("Bodoni-Poster")
textpath("†", O, halign=:center, valign=:middle)
dagger = storepath()
```

stores the instructions to build the current path (which describe the dagger symbol) in `dagger`.

The `dagger` is a Luxor Path type, and contains:

```julia
PathMove(Point(2.0, 90.5625)),
PathCurve(Point(4.08203125, 68.16015625), Point(11.28125, 45.28125), Point(24.8828125, 26.40234375)),
PathCurve(Point(17.51953125, 22.87890625), Point(2.0, 14.71875), Point(2.0, 5.12109375)),
PathCurve(Point(2.0, 2.5625), Point(3.12109375, 0.640625), Point(5.83984375, 0.640625)),
PathCurve(Point(12.8828125, 0.640625), Point(11.6015625, 14.2421875), Point(26.16015625, 14.2421875)),
PathCurve(Point(35.76171875, 14.2421875), Point(42.0, 7.83984375), Point(42.0, -1.59765625)),
PathCurve(Point(42.0, -10.3984375), Point(34.9609375, -17.4375), Point(26.16015625, -17.4375)),
PathCurve(Point(10.9609375, -17.4375), Point(13.04296875, -3.6796875), Point(6.48046875, -3.6796875)),
PathCurve(Point(3.6015625, -3.6796875), Point(1.83984375, -6.3984375), Point(1.83984375, -9.12109375)),
PathCurve(Point(1.83984375, -14.3984375), Point(12.2421875, -23.6796875), Point(15.44140625, -26.87890625)),
PathCurve(Point(18.640625, -30.078125), Point(19.76171875, -34.3984375), Point(19.76171875, -38.71875)),
PathCurve(Point(19.76171875, -49.7578125), Point(10.9609375, -56.640625), Point(0.40234375, -56.640625)),
PathCurve(Point(-11.1171875, -56.640625), Point(-19.91796875, -49.7578125), Point(-19.91796875, -38.71875)),
PathCurve(Point(-19.91796875, -34.3984375), Point(-18.80078125, -30.078125), Point(-15.59765625, -26.87890625)),
PathCurve(Point(-12.3984375, -23.6796875), Point(-2.0, -14.3984375), Point(-2.0, -9.12109375)),
PathCurve(Point(-2.0, -6.3984375), Point(-3.7578125, -3.6796875), Point(-6.640625, -3.6796875)),
PathCurve(Point(-13.19921875, -3.6796875), Point(-11.1171875, -17.4375), Point(-26.3203125, -17.4375)),
PathCurve(Point(-35.1171875, -17.4375), Point(-42.16015625, -10.3984375), Point(-42.16015625, -1.59765625)),
PathCurve(Point(-42.16015625, 7.83984375), Point(-35.91796875, 14.2421875), Point(-26.3203125, 14.2421875)),
PathCurve(Point(-11.7578125, 14.2421875), Point(-13.0390625, 0.640625), Point(-6.0, 0.640625)),
PathCurve(Point(-3.27734375, 0.640625), Point(-2.16015625, 2.5625), Point(-2.16015625, 5.12109375)),
PathCurve(Point(-2.16015625, 14.71875), Point(-17.6796875, 22.87890625), Point(-25.0390625, 26.40234375)),
PathCurve(Point(-11.4375, 45.28125), Point(-4.23828125, 68.16015625), Point(-2.16015625, 90.5625)),
PathClose(),
PathMove(Point(48.87890625, 56.640625))
```

You can draw this later:

```@setup gpath
using Luxor
d = @drawsvg begin
    dagger  = Path([
         PathMove(Point(2.0, 90.5625)),
         PathCurve(Point(4.08203125, 68.16015625), Point(11.28125, 45.28125), Point(24.8828125, 26.40234375)),
         PathCurve(Point(17.51953125, 22.87890625), Point(2.0, 14.71875), Point(2.0, 5.12109375)),
         PathCurve(Point(2.0, 2.5625), Point(3.12109375, 0.640625), Point(5.83984375, 0.640625)),
         PathCurve(Point(12.8828125, 0.640625), Point(11.6015625, 14.2421875), Point(26.16015625, 14.2421875)),
         PathCurve(Point(35.76171875, 14.2421875), Point(42.0, 7.83984375), Point(42.0, -1.59765625)),
         PathCurve(Point(42.0, -10.3984375), Point(34.9609375, -17.4375), Point(26.16015625, -17.4375)),
         PathCurve(Point(10.9609375, -17.4375), Point(13.04296875, -3.6796875), Point(6.48046875, -3.6796875)),
         PathCurve(Point(3.6015625, -3.6796875), Point(1.83984375, -6.3984375), Point(1.83984375, -9.12109375)),
         PathCurve(Point(1.83984375, -14.3984375), Point(12.2421875, -23.6796875), Point(15.44140625, -26.87890625)),
         PathCurve(Point(18.640625, -30.078125), Point(19.76171875, -34.3984375), Point(19.76171875, -38.71875)),
         PathCurve(Point(19.76171875, -49.7578125), Point(10.9609375, -56.640625), Point(0.40234375, -56.640625)),
         PathCurve(Point(-11.1171875, -56.640625), Point(-19.91796875, -49.7578125), Point(-19.91796875, -38.71875)),
         PathCurve(Point(-19.91796875, -34.3984375), Point(-18.80078125, -30.078125), Point(-15.59765625, -26.87890625)),
         PathCurve(Point(-12.3984375, -23.6796875), Point(-2.0, -14.3984375), Point(-2.0, -9.12109375)),
         PathCurve(Point(-2.0, -6.3984375), Point(-3.7578125, -3.6796875), Point(-6.640625, -3.6796875)),
         PathCurve(Point(-13.19921875, -3.6796875), Point(-11.1171875, -17.4375), Point(-26.3203125, -17.4375)),
         PathCurve(Point(-35.1171875, -17.4375), Point(-42.16015625, -10.3984375), Point(-42.16015625, -1.59765625)),
         PathCurve(Point(-42.16015625, 7.83984375), Point(-35.91796875, 14.2421875), Point(-26.3203125, 14.2421875)),
         PathCurve(Point(-11.7578125, 14.2421875), Point(-13.0390625, 0.640625), Point(-6.0, 0.640625)),
         PathCurve(Point(-3.27734375, 0.640625), Point(-2.16015625, 2.5625), Point(-2.16015625, 5.12109375)),
         PathCurve(Point(-2.16015625, 14.71875), Point(-17.6796875, 22.87890625), Point(-25.0390625, 26.40234375)),
         PathCurve(Point(-11.4375, 45.28125), Point(-4.23828125, 68.16015625), Point(-2.16015625, 90.5625)),
         PathClose(),
         PathMove(Point(48.87890625, 56.640625))
        ])
end 800 250
```

```@example gpath
@drawsvg begin # hide
background("antiquewhite")  # hide
sethue("black") # hide
for θ in range(0, step=2π/10, length=10)
    @layer begin
        rotate(θ)
        translate(150, 0)
        rotate(π/2)
        drawpath(dagger, action = :fill)
    end
end
end # hide
```

!!! note

    After you've stored the current path, it's still
    active. You might want to use `newpath()` before starting the next
    one. The `drawpath()` function will by default start a new path but
    there is an option to continue drawing the current one.

Other functions for working with stored paths include:

- [`drawpath`](@ref) draw all or part of a stored path using the current graphics state

- [`pathsample`](@ref) resample the stored path

- [`pathlength`](@ref) find the length of a stored path

- [`BoundingBox`](@ref) find the bounding box of a stored path

## Julia logos

A couple of functions, [`julialogo`](@ref) and [`juliacircles`](@ref), provide you with instant access to the Julia logo and the three colored circles/dots:

```@example
using Luxor, Random # hide
Drawing(800, 300, "../assets/figures/julia-logo.png")  # hide
Random.seed!(42) # hide
origin()  # hide
background("antiquewhite") # hide

cells = Table([300], [350, 350])

@layer begin
    translate(cells[1])
    translate(-165, -114)
    rulers()
    julialogo()
end

@layer begin
    translate(cells[2])
    translate(-165, -114)
    rulers()
    julialogo(action=:clip)
    for i in 1:500
        @layer begin
            translate(rand(0:400), rand(0:250))
            juliacircles(10)
        end
    end
    clipreset()
end

finish() # hide
nothing # hide
```

![julia logo and circles](../assets/figures/julia-logo.png)

There are various options for `julialogo()` to control coloring and positioning.

The four standard Julia colors are available as RGB tuples as `Luxor.julia_blue`, `Luxor.julia_green`, `Luxor.julia_purple`,  `Luxor.julia_red`:

```julia-repl
julia> Luxor.julia_red
(0.796, 0.235, 0.2)
```

## Hypotrochoids

[`hypotrochoid`](@ref) makes hypotrochoids. The result is a polygon. You can either draw it directly, or pass it on for further polygon fun, as here, which uses [`offsetpoly`](@ref) to trace round it a few times.

```@example
using Luxor # hide
Drawing(800, 300, "../assets/figures/hypotrochoid.png")  # hide
origin()
background("grey15")
sethue("antiquewhite")
setline(1)
p = hypotrochoid(100, 25, 55, action = :stroke, stepby=0.01, vertices=true)
for i in 0:3:15
    poly(offsetpoly(p, i), action = :stroke, close=true)
end
finish() # hide
nothing # hide
```

![hypotrochoid](../assets/figures/hypotrochoid.png)

There's a matching [`epitrochoid`](@ref) function.

## Ticks

The [`tickline`](@ref) function lets you divide the space
between two points by drawing ‘ticks’, short parallel lines
positioned equidistant between the two points.

In its simplest form the function can used to draw basic
number lines, complete with automatic text labels.

```@example
using Luxor # hide
@drawsvg begin # hide
background("antiquewhite")

# major defaults to 1
tickline(Point(-350, -100), Point(350, -100))

# three major ticks inserted
tickline(Point(-350, 0), Point(350, 0),
    major=3,
    startnumber=0, finishnumber=100)

# four minor ticks inserted between each major
tickline(Point(-350, 100), Point(350, 100), major=3, minor=4)

end 800 350  # hide
```

The function returns the positions of the generated ticks in
two arrays of points - the locations of the major and minor
ticks.

The spaced positions (linear or logarithmic) are useful even
when you switch off the display of text using
`vertices=true`, which just returns vertices.

```@example
using Luxor # hide
@drawsvg begin # hide
background("antiquewhite") # hide

# no axis
tickline(Point(-350, -100), Point(350, -100), minor=9, axis=false)

# logarithmic
majticks, minticks = tickline(Point(-350, 0), Point(350, 0),
    major=9,
    startnumber=1,
    finishnumber=10,
    log=true,
    vertices=false)

# just the vertices
majticks, minticks = tickline(Point(-350, 100), Point(350, 100),
    major=9,
    minor=4,
    log=true,
    axis=false,
    vertices=true)
circle.(majticks, 5, action = :fill)
box.(minticks, 1, 25, action = :fill)
end 800 350  # hide
```

You can pass a function that generates custom graphics and text for each tick.

```@example
using Luxor, Colors # hide
function color_temp(n, pos;
          startnumber  = 0,
          finishnumber = 1,
          nticks = 1)
    k = rescale(n, 0, nticks - 1, startnumber, finishnumber)
    sethue(RGB(colormatch(k)))
    circle(pos, 20, action = :fillpreserve)
    sethue("white")
    strokepath()
    text("$(convert(Int, floor(k))) nm", pos - (0, 30), halign=:left, angle=-π/4)
end

@drawsvg begin # hide
background("black") # hide
fontsize(16) # hide
tickline(Point(-350, 0), Point(350, 0),
    startnumber=350,
    finishnumber=750,
    major=10,
    major_tick_function=color_temp)
end 800 300 # hide
```

Sometimes you just want a sequence of spaced points.

```@example
using Luxor, Colors # hide

_, minticks = tickline(Point(-400, 0), Point(260, 0),
        major=0, minor=40,
        log=true,
        axis=false,
        vertices=true)

@drawsvg begin # hide
background("black") # hide
for (n, pt) in enumerate(minticks)
    k = rescale(n, 1, length(minticks), 0, 1)
    sethue(LCHab(60, 100, 360k))
    setline(1/k)
    wave = [pt + Point(120k * sin(y), 600/2π * y) for y in -π:π/20:π]
    poly(wave, action = :stroke)
end

end 800 600  # hide
```

## Cropmarks

If you want cropmarks (aka trim marks), use the [`cropmarks`](@ref) function, supplying the centerpoint, followed by the width and height:

    cropmarks(O, 1200, 1600)
    cropmarks(O, paper_sizes["A0"]...)

```@example
using Luxor # hide
Drawing(800, 250, "../assets/figures/cropmarks.png")  # hide
origin() # hide
background("antiquewhite") # hide
sethue("red")
box(O, 150, 150, action = :stroke)
cropmarks(O, 150, 150)
finish() # hide
nothing # hide
```

![cropmarks](../assets/figures/cropmarks.png)

## Dimensioning

Simple dimensioning graphics can be generated with [`dimension`](@ref). To convert from the default unit (PostScript points), or to modify the dimensioning text, supply a function to the `format` keyword argument.

![dimensioning](../assets/figures/dimensioning.svg)

```@example
using Luxor # hide
Drawing(800, 350, "../assets/figures/dimensioning.svg")  # hide
origin() # hide
background("antiquewhite") # hide
setline(0.75)
sethue("purple")
pentagon = ngonside(O, 120, 5, vertices=true)
poly(pentagon, action = :stroke, close=true)
circle.(pentagon, 2, action = :fill)
fontsize(6)
label.(split("12345", ""), :NE, pentagon)
fontface("Menlo")
fontsize(10)
sethue("grey30")

dimension(O, pentagon[4],
    fromextension = [0, 0])

dimension(pentagon[1], pentagon[2],
    offset        = -60,
    fromextension = [20, 50],
    toextension   = [20, 50],
    textrotation  = 2π/5,
    textgap       = 20,
    format        = (d) -> string(round(d, digits=4), "pts"))

dimension(pentagon[2], pentagon[3],
     offset = -40,
     format =  string)

dimension(pentagon[5], Point(pentagon[5].x, pentagon[4].y),
    offset        = 60,
    format        = (d) -> string("approximately ",round(d, digits=4)),
    fromextension = [5, 5],
    toextension   = [80, 5])

dimension(pentagon[1], midpoint(pentagon[1], pentagon[5]),
    offset               = 70,
    fromextension        = [65, -5],
    toextension          = [65, -5],
    texthorizontaloffset = -5,
    arrowheadlength      = 5,
    format               = (d) ->
        begin
            if isapprox(d, 60.0)
                string("exactly ", round(d, digits=4), "pts")
            else
                string("≈ ", round(d, digits=4), "pts")
            end
        end)

dimension(pentagon[1], pentagon[5],
    offset               = 120,
    fromextension        = [5, 5],
    toextension          = [115, 5],
    textverticaloffset   = 0.5,
    texthorizontaloffset = 0,
    textgap              = 5)

finish() # hide
nothing # hide
```

## Barcharts

For simple barcharts, use the [`barchart`](@ref) function, supplying an array of numbers:

```@example
using Luxor # hide
Drawing(800, 420, "../assets/figures/bars.png")  # hide
origin() # hide
background("antiquewhite") # hide
fontsize(7)
sethue("black")
v = rand(-100:100, 25)
barchart(v, labels=true)
finish() # hide
nothing # hide
```

![bars](../assets/figures/bars.png)

To change the way the bars and labels are drawn, define some functions and pass them as keyword arguments:

```@example
using Luxor, Colors, Random # hide
Drawing(800, 450, "../assets/figures/bars1.png")  # hide

Random.seed!(2) # hide
origin() # hide
background("antiquewhite") # hide
setopacity(0.8) # hide
fontsize(8) # hide
fontface("Helvetica-Bold") # hide
sethue("black") # hide

function mybarfunction(values, i, low, high, barwidth, scaledvalue)
    @layer begin
        extremes = extrema(values)
        sethue(Colors.HSB(rescale(values[i], extremes[1], extremes[2], 0, 360), 1.0, 0.5))
        csize = rescale(values[i], extremes[1], extremes[2], 5, 15)
        circle(high, csize, action = :fill)
        setline(1)
        sethue("blue")
        line(low, high, action = :stroke)
        sethue("white")
        text(string(values[i]), high, halign=:center, valign=:middle)
    end
end

function mylabelfunction(values, i, low, high, barwidth, scaledvalue)
    @layer begin
        translate(low)
        text(string(values[i]), O + (0, 10), halign=:center, valign=:middle)
    end
end

v = rand(1:100, 15)

bbox = BoundingBox() * 0.8
box(bbox, action = :clip)
p = barchart(v, boundingbox=bbox, barfunction=mybarfunction, labelfunction=mylabelfunction)

rule(p[1])

finish() # hide
nothing # hide
```

![bars 1](../assets/figures/bars1.png)

## Box maps

The [`boxmap`](@ref) function divides a rectangular area into a sorted arrangement of smaller boxes or tiles based on the values of elements in an array.

This example uses the Fibonacci sequence to determine the area of the boxes. Notice that the values are sorted in reverse, and are scaled to fit in the available area.

You specify the top left corner of the graphic, the width, and the height.

```@example
using Luxor, Colors, Random # hide
Drawing(800, 450, "../assets/figures/boxmap.png")  # hide
Random.seed!(13) # hide
origin() # hide
background("antiquewhite") # hide

fib = [1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144]

# make a boxmap and store the tiles
tiles = boxmap(fib, BoundingBox()[1], 800, 450)

for (n, t) in enumerate(tiles)
    randomhue()
    bb = BoundingBox(t)
    sethue("black")
    box(bb - 5, action = :stroke)

    randomhue()
    box(bb - 8, action = :fill)

    # text labels
    sethue("white")

    # rescale text to fit better
    fontsize(boxwidth(bb) > boxheight(bb) ? boxheight(bb)/4 : boxwidth(bb)/4)
    text(string(sort(fib, rev=true)[n]),
        midpoint(bb[1], bb[2]),
        halign=:center,
        valign=:middle)
end

finish() # hide
nothing # hide
```
![boxmap](../assets/figures/boxmap.png)

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Turtle graphics

Luxor provides some basic "turtle graphics" functions. Functions to control the turtle begin (somewhat unusually) with a capital letter: Forward, Turn, Circle, Orientation, Towards, Rectangle, Pendown, Penup, Pencolor, Penwidth, and Reposition. 

Angles are specified in clockwise degrees rather than radians.

```@example
using Luxor, Colors
Drawing(600, 400, "../assets/figures/turtles.png")
origin()
background("midnightblue")

🐢 = Turtle() # you can type the turtle emoji with \:turtle:
Pencolor(🐢, "cyan")
Penwidth(🐢, 1.5)
n = 5
for i in 1:400
    global n
    Forward(🐢, n)
    Turn(🐢, 89.5)
    HueShift(🐢)
    n += 0.75
end
fontsize(20)
Message(🐢, "finished")
finish()
nothing # hide
```

![turtles](../assets/figures/turtles.png)

|List of words the turtle knows | Arguments | Action                                         |
|:---                           | :---      | :---                                           |
|[`Forward`](@ref)              | n (1)     |  More forward by d units                       |
|[`Turn`](@ref)                 | θ (5°)    |  Increase the turtle's rotation by n°          |
|[`Circle`](@ref)               | r (1)     |  Draw filled circle centered at current pos    |
|[`HueShift`](@ref)             | n (1)     |  Shift the Hue of the turtle's pen color by n  |
|[`Message`](@ref)              | t ("")    |  Output text `t`                               |
|[`Orientation`](@ref)          | θ (5°)    |  Set the turtle's orientation to θ degrees     |
|[`Pen_opacity_random`](@ref)   |           |  Set opacity to random value                   |
|[`Pencolor`](@ref)             | r g b     |  Set the Red, Green, and Blue values           |
|[`Pendown`](@ref)              |           |  Start drawing                                 |
|[`Penup`](@ref)                |           |  Stop drawing                                  |
|[`Penwidth`](@ref)             | w         |  Set the width of the line to w                |
|[`Pop `](@ref)                 |           |  Move turtle to the value stored on the stack  |
|[`Push`](@ref)                 |           |  Save the turtle's position on the stack       |
|[`Randomize_saturation`](@ref) |           |  Randomize the saturation of the current color |
|[`Rectangle`](@ref)            | w h       |  Draw filled rectangle centered at current pos |
|[`Reposition`](@ref)           | pt        |  Place turtle at new position `pt`             |
|[`Towards`](@ref)              | pt        |  Rotate turtle to face towards a point         |

The turtle commands expect a reference to a turtle as the first argument (it doesn't have to be a turtle emoji!).

You can have any number of turtles active at a time. 

```@example
using Luxor, Colors # hide
Drawing(800, 800, "../assets/figures/manyturtles.svg") # hide
origin() # hide
background("white") # hide
quantity = 9
turtles = [Turtle(O, true, 2π * rand(), (rand(), rand(), 0.5)...) for i in 1:quantity]
Reposition.(turtles, first.(collect(Tiler(800, 800, 3, 3))))
n = 10
Penwidth.(turtles, 0.5)
for i in 1:300
    global n
    Forward.(turtles, n)
    HueShift.(turtles)
    Turn.(turtles, [60.1, 89.5, 110, 119.9, 120.1, 135.1, 145.1, 176, 190])
    n += 0.5
end
finish() # hide
nothing # hide
```

![many turtles](../assets/figures/manyturtles.svg)

A turtle graphics approach lends itself well to recursive programming. This short recursive function draws a Hilbert curve.

```@example
using Luxor, Colors # hide
Drawing(400, 400, "../assets/figures/hilbertturtle.svg") # hide
origin() # hide
background("black") # hide

function hilbert(t::Turtle, level, angle, lengthstep)
    level == 0 && return

    HueShift(t, 0.1)

    Turn(t, angle)
    hilbert(t, level-1, -angle, lengthstep)

    Forward(t, lengthstep)
    Turn(t, -angle)
    hilbert(t, level-1, angle, lengthstep)

    Forward(t, lengthstep)
    hilbert(t, level-1, angle, lengthstep)

    Turn(t, -angle)
    Forward(t, lengthstep)
    hilbert(t, level-1, -angle, lengthstep)

    Turn(t, angle)
end

@draw begin
background("black")
setline(2)
setlinecap("round")

hilbert(Turtle(first(BoundingBox()) + (12, 12), true, 0, (1, 0, 0)),
        6,  # level
        90, # turn angle, in degrees
        6   # steplength
        )
end
nothing # hide
```

![hilbert turtle](../assets/figures/hilbertturtle.svg)

#  Snapshots

A _snapshot_ is a view of the current Luxor drawing in its current state, before it's been closed via [`finish`](@ref). You can take a snapshot, then continue drawing on the current drawing.

!!! note

    You can take a snapshot only for drawings created using the `:rec` (recording) format.

The following code exports a series of snapshots made with [`snapshot`](@ref), showing the state of the computation for different values of the `stepby` parameter. (This image is a composite of all the snapshots.)

![juliaset](../assets/figures/julia-set-set.png)

```julia
using Luxor, ColorSchemes, Colors

function julia(z, c, maxiter::Int64)
    for n = 1:maxiter
        abs(z) > 2 ? (return n) : z = z^3 + c
    end
    return maxiter
end

function drawjulia(c::Complex, pwidth, pheight;
        klo = 0.0,
        khi = 1.0,
        cpos = Point(0, 0),
        w = 4,
        stepby=1,
        maxiterations = 300)
    xmin = cpos.x - w/2; ymin = cpos.y - w/2
    xmax = cpos.x + w/2; ymax = cpos.y + w/2
    lo = 10; hi = 2
    for col = -pwidth/2:stepby:pwidth/2
        for row = -pheight/2:stepby:pheight/2
            imagex = rescale(col, -pwidth/2, pwidth/2, xmin, xmax)
            imagey = rescale(row, -pheight/2, pheight/2, ymin, ymax)
            pixelcolor = julia(complex(imagex, imagey), c, maxiterations)
            if pixelcolor > hi
                hi = pixelcolor
            end
            if pixelcolor < lo
                lo = pixelcolor
            end
            s = rescale(pixelcolor, klo, khi)
            a = slope(Point(row, col), O)
            h, sa, l = getfield.(convert(HSL, get(ColorSchemes.inferno, s)), 1:3)
            sethue(HSL(mod(180 + 360 * a/2π, 360), sa , 2l))
            box(Point(row, -col), stepby,  stepby, :fillstroke)
        end
    end
    sethue("white")
    text("$(stepby)", boxbottomcenter(BoundingBox()) + (0, -20), halign=:center)
    snapshot(fname = "/tmp/temp-$(stepby).png")
    return lo, hi
end

function main()
    w = h = 500
    Drawing(w, h, :rec)
    fontsize(20)
    fontface("JuliaMono-Bold")
    origin()
    circle(O, w/2, :clip)
    for s in vcat(50:-5:1,1)
        l, h = drawjulia(-0.5368 + 0.0923im, w, w, maxiterations = 250,
            w=3, stepby=s, klo=1, khi=100)
    end
    finish()
    preview()
end

main()
```

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Hello World

If you're familiar with the basics of Cairo, PostScript, Processing, or similar graphics applications, you can probably glance at these tutorials, then move on to the How To sections.

## What you need

If you've already downloaded Julia, and have added the Luxor package successfully (using `] add Luxor`):

```julia-repl
$ julia
               _
   _       _ _(_)_     |  Documentation: https://docs.julialang.org
  (_)     | (_) (_)    |
   _ _   _| |_  __ _   |  Type "?" for help, "]?" for Pkg help.
  | | | | | | |/ _` |  |
  | | |_| | | | (_| |  |  Version 1.10.3 (2024-04-30)
 _/ |\__'_|_|_|\__'_|  |  Official https://julialang.org/ release
|__/                   |

(@v1.10) pkg> add Luxor
```

then you're ready to start.

You can work in a Jupyter or Pluto notebook, or use the VSCode editor/development environment. It's also possible to work in a text editor (make sure you know how to run a file of Julia code), or, at a pinch, you could use the Julia REPL directly, although the graphics will disappoint.

Ready? Let's begin.

## First steps

We'll load just one package for this tutorial:

```julia
using Luxor
```

Here's an easy shortcut for making drawings in Luxor. It's a Julia macro, and it's a good way to test that your system's working. Evaluate this code:

```julia
@png begin
    text("Hello world")
    circle(Point(0, 0), 200, action = :stroke)
end
```

```@setup hw
using Luxor
Drawing(725, 600, "../assets/figures/tutorial-hello-world.png")
background("white")
origin()
sethue("black")
text("Hello world")
circle(Point(0, 0), 200, action = :stroke)
finish()
```

What happened? Can you see this image somewhere?

![point example](../assets/figures/tutorial-hello-world.png)

If you're using VS-Code and run the file in the Julia REPL, the image should appear in the Plots window. The preview will not be shown if there is any executed code following the macro. 

If you're working in a Jupyter or Pluto notebook, the image should appear below or above the code. If you're using Julia in a terminal or text editor, the image should have opened up in some other application, or, at the very least, it should have been saved in your current working directory (as `luxor-drawing-(time stamp).png`). 

If you're working in the REPL or an editor, you should see the text-only representation: `Luxor drawing: (type = :png, width = 100.0, height = 100.0, location = in memory)`.

If nothing happened, or if something bad happened, we've got some set-up or installation issues probably unrelated to Luxor...

!!! note

    In this example we've used a macro, [`@png`](@ref). This macro is an easy way to make a drawing, because it saves a lot of typing. (The macro expands to enclose your drawing commands with calls to the [`Drawing()`](@ref), [`origin`](@ref), [`background`](@ref), [`finish`](@ref), and [`preview`](@ref) functions.) There are also [`@svg`](@ref), [`@pdf`](@ref), [`@draw`](@ref), and [`@drawsvg`](@ref) macros, which do similar things.

PNGs and SVGs are good because they show up in VS-Code, Jupyter, and Pluto. Lines in SVG graphics are usually drawn in higher quality, but the SVG contents of the files are readable text, and can become very large and difficult to load if the image is complex. PDF documents are always high quality, like SVGs, and usually open up in a separate application.

This example illustrates a few things about Luxor drawings:

- There are default values which you don't have to set if you don't want to (file names, colors, font sizes, and so on).

- With the short-cut macros, the default is to draw black graphics on a solid white background.

- Positions on the drawing are specified with x and y coordinates stored in the Point type, and you can sometimes omit positions altogether.

- the origin (0, 0) is at the centre of the drawing

- by default, the text is placed at the origin, and by default it's left aligned

- The circle wasn't filled, but `stroked`. We passed the `:stroke` symbol as an action to the [`circle`](@ref) function. Many drawing functions expect some action, such as `:fill` or `:stroke`, and sometimes `:clip` or `:fillstroke`. This works either as an argument (`:fill`) or as a keyword argument (`action=:fill`).

- Did the first drawing takes a few seconds to appear? The drawing engine takes a little time to warm up. Once it's running, drawings appear much faster.

Once more, with more black, and some rulers:

```julia
@png begin
    text("Hello again, world!", Point(0, 250))
    circle(Point(0, 0), 200, action = :fill)
    rulers()
end
```

```@setup hw2
using Luxor
Drawing(725, 502, "../assets/figures/tutorial-hello-world-2.png")
background("white")
origin()
sethue("black")
text("Hello again, world!", Point(0, 250))
circle(Point(0, 0), 200, action = :fill)
rulers()
finish()
```

![point example](../assets/figures/tutorial-hello-world-2.png)

The x-coordinates usually run from left to right, the y-coordinates from top to bottom. So here, `Point(0, 250)` is a point at the left/right center, but at the bottom of the drawing.

The `rulers()` function draws CAD-style x and y rulers at the origin.

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Text and fonts

## A tale of two APIs

There are two ways to draw text in Luxor. You can use either the so-called 'toy' API or the 'pro' API. Both have their advantages and disadvantages. Also, font selection and availability varies a lot across the three operating systems. You may have to experiment to find code patterns that work for you.

#### The Toy API

Use:
- `text(string, [position])` to place text at a position, otherwise at `0/0`, and optionally specify the horizontal and vertical alignment
- `fontface(fontname)` to specify the fontname
- `fontsize(fontsize)` to specify the fontsize

```julia
fontsize(16)
fontface("Georgia-Bold")
text("Georgia: a serif typeface designed in 1993 by Matthew Carter.", halign=:center)
```

![text placement](../assets/figures/toy-text-example.png)

(If the specified font is unavailable on the current system configuration, the default, usually Times/Helvetica or DejaVu, is used.)

The [`label`](@ref) function also uses the Toy API.

#### The Pro API

Use:

- `setfont(fontname, fontsize)` to specify the fontname and size
- `settext(text, [position])` to place the text at a position, and optionally specify horizontal and vertical alignment, rotation (in degrees counterclockwise!), and the presence of any pseudo-Pango-flavored markup.

```julia
setfont("Georgia Bold", 16)
settext("Georgia: a serif typeface designed in 1993 by Matthew Carter.", halign="center")
```

![text placement](../assets/figures/pro-text-example.png)

## Specifying the font ("Toy" API)

Use `fontface(fontname)` to choose a font, and `fontsize(n)` to set the font size. [`get_fontsize`](@ref) finds the current font size.

## Specifying the font ("Pro" API)

To select a font in the Pro text API, use [`setfont`](@ref) and supply both the font name and a size.

## Placing text ("Toy" API)

Use [`text`](@ref) to place a string. The left edge is placed at the origin, by default. Or you can supply a position. Use `halign` and/or `valign` to align the string at the position.

```@example
using Luxor # hide
@drawsvg begin # hide
background("black") # hide
fontsize(20) # hide
pt1 = Point(-100, 0)
pt2 = Point(0, 0)
pt3 = Point(100, 0)
sethue("white")
text("text 1",  pt1, halign=:left,   valign = :bottom)
text("text 2",  pt2, halign=:center, valign = :bottom)
text("text 3",  pt3, halign=:right,  valign = :bottom)
text("text 4",  pt1, halign=:left,   valign = :top)
text("text 5",  pt2, halign=:center, valign = :top)
text("text 6",  pt3, halign=:right,  valign = :top)
sethue("red")
map(p -> circle(p, 5, :fill), [pt1, pt2, pt3])
end 600 100 # hide
```

```julia
sethue("black") # hide
fontsize(10)
fontface("Georgia")
[text(string(θ), Point(40cos(θ), 40sin(θ)), angle=θ) for θ in 0:π/12:47π/24]
```

![text rotation](../assets/figures/text-rotation.png)

## Placing text ("Pro" API)

Use [`settext`](@ref) to place text. You can include some pseudo-HTML markup with the keyword argument `markup=true`.

```@example
using Luxor # hide
Drawing(400, 150, "../assets/figures/pro-text-placement.png") # hide
origin() # hide
background("white") # hide
rulers()
sethue("black")
settext("<span font='26' background ='green' foreground='red'> Hey</span>
    <i>italic</i> <b>bold</b> <sup>superscript</sup>
    <tt>monospaced</tt>",
    halign="center",
    markup=true,
    angle=10) # degrees counterclockwise!
finish() # hide
nothing # hide
```

![pro text placement](../assets/figures/pro-text-placement.png)

## Writing LaTeX and Typst

Luxor allows you to use LaTeX to add equations to drawings, and Typst to add equations and other typeset text to drawings.

### LaTeX

It's possible to write math equations in ``\LaTeX`` by
passing a `LaTeXString` to the `text` function. Luxor uses
[MathTeXEngine.jl](https://github.com/Kolaru/MathTeXEngine.jl)
to parse the `LaTeXString`. You should load MathTeXEngine.jl
(`using MathTeXEngine`) before accessing this feature.

!!! note

    MathTeXEngine.jl is a package that renders many
    `LaTeXString`s without requiring a ``\LaTeX`` compiler.
    The package uses the fonts _Computer Modern_ and _New
    Computer Modern_. They're included with the
    MathTeXEngine package, and you can find them in your
    `julia` folder in
    `packages/MathTeXEngine/.../assets/fonts`. You should
    make sure these have been copied to your system's
    font directories before running Luxor and writing
    ``\LaTeX`` strings.

```@example
using Luxor
using MathTeXEngine
path_svg = "latexexample.svg"
path_svg = "../assets/figures/latexexample.svg" # hide
Drawing(600, 400, path_svg)
origin()
background("grey6")
fontsize(26)
sethue("white")
t₁ = L"e^{i\pi} + 1 = 0"
t₂ = L"e^x = \sum^\infty_{n=0} \frac{x^n}{n!} = \lim_{n\to\infty}(1+\frac{x}{n})^n"
t₃ = L"\cos(\theta)"

text(t₁, Point(0, -100), halign=:center, valign=:baseline, angle=0)
text(t₂, Point(0, -20), halign=:center, valign=:top, angle=0)

line(Point(0, 132), Point(50, 132), action = :stroke)
line(Point(0, 132), Point(50cos(π/4), 132 - 50sin(π/4)), action = :stroke)

fontsize(18)
text(t₃, Point(0, 120), halign = :left, valign = :baseline, angle = -π/4, rotationfixed = false)
finish()
nothing # hide
```

![textbox](../assets/figures/latexexample.svg)

!!! note

    The string macros in the
    [LaTeXStrings.jl](https://github.com/stevengj/LaTeXStrings.jl)
    package allow you to enter LaTeX equations
    without having to escape backslashes and dollar signs
    (and they'll add the dollar signs for you if you omit
    them).

### Typst

You can use [Typst](https://typst.app) to add equations and other typeset text to Luxor drawings. This feature is provided by the Julia package [Typstry.jl](https://github.com/jakobjpeters/Typstry.jl).

```julia
using Luxor
using Typstry

ts = typst""" $a + b/c = sum_i x^i $""";

ty_preamble = typst"""
#set page(fill: rgb("#eeffdd"), height: 200pt, width: 400pt, margin: 0pt);
#set text(fill: purple, size: 60pt)
"""

@draw begin
    text(ts, O, preamble=ty_preamble, centered=true)
end
```

![typst example](../assets/figures/typst.svg)

In this example, the string in `ts` is a TypstString containing the equation to be typeset. The contents of `ty_preamble` passed as the `preamble` keyword argument is also a TypstString. It contains general formatting instructions for the Typst document. It can be omitted, and the default preamble is used.

#### Multipage Typst documents

The `render_typst_document()` function converts a TypstString containing the source for a Typst document into an array of SVGimages. Each page is saved as a single SVG image. You can place any or all of these on the Luxor drawing with `placeimage()`.

```julia
using Luxor
using Typstry

ts = typst"""
#set text(size: 12pt, fill: black)
#set page(numbering: "1", 
    fill: none, 
    height: 240pt, width: 240pt)
#lorem(200)
#rect(width: 1em, height: 1em, fill: red)
"""

@draw begin
    pages = render_typst_document(ts)
    centers = first.(Tiler(600, 600, 2, 2))
    for n in eachindex(pages)
        n > length(centers) && break
        @layer begin
            setopacity(0.2)
            randomhue()
            box(centers[n], 250, 250, :fill)
        end
        @layer begin
            placeimage(pages[n], centers[n], centered=true)
        end
    end
end
```

![typst example 2 ](../assets/figures/typst2.png)

## Notes on fonts

Fonts are loaded when you first start using Luxor/Cairo in a Julia session. This partly explains why starting a Luxor/Cairo session can take a few seconds.

On macOS, the fontname required by the Toy API's [`fontface`](@ref) should be the PostScript name of a currently activated font. You can find this out using, for example, the FontBook application.

On macOS, a list of currently activated fonts can be found (after a while) with the shell command:

```bash
system_profiler SPFontsDataType
```

Fonts currently activated by a Font Manager can be found and used by the Toy API but not by the Pro API (at least on my macOS computer currently).

On macOS, you can obtain a list of fonts that `fontconfig` considers are installed and available for use (via the Pro Text API with [`setfont`](@ref)) using the shell command:

```bash
fc-list | cut -f 2 -d ":"
```

although typically this lists only those fonts in `/System/Library/Fonts` and `/Library/Fonts`, and not `~/Library/Fonts`.

(There is a Julia interface to `fontconfig` at [Fontconfig.jl](https://github.com/JuliaGraphics/Fontconfig.jl).
See also [FreeTypeAbstraction.jl](https://github.com/JuliaGraphics/FreeTypeAbstraction.jl))

In the Pro API, the default font is Times Roman (on macOS). In the Toy API, the default font is Helvetica (on macOS).

One difference between [`settext`](@ref) and [`text`](@ref) (on macOS) is that many more missing Unicode glyphs are automatically substituted by other fonts when you use the former.

Cairo.jl (and hence Luxor.jl) doesn't support emoji currently. 😢 But you can use [Typst](@ref) () to render text containing emojis.

Text is rasterized (converted from outlines to pixels)
only when you output to the PNG format. For SVG formats, text
is converted to outlines (curves and lines). For PDF and EPS formats, the fonts
you use are stored inside the output file ("embedded"), and the
text is displayed using that font only when the file is
viewed.

For PNG files, the appearance of fonts when output is controlled to some extent by the operating system. For example, on Windows, if ClearType is active, differently-colored pixels are used to display fonts, because of the use of subpixel rendering. These colored pixels will be visible in the PNG output.

## Text to paths

`textoutlines(string, position)` converts the text into graphic path(s), places them starting at `position`, and applies the `action`.

```julia
fontface("Times-Roman")
fontsize(500)
setline(4)
sethue("maroon2")
textoutlines("&", O, :path, valign=:middle, halign=:center)
fillpreserve()
sethue("black")
strokepath()
```

![text outlines](../assets/figures/textoutlines.png)

[`textpath`](@ref) converts the text into graphic paths suitable for further manipulation.

`textpath` preserves the Bézier curves, whereas `textoutlines` flattens all curves and converts them to polygons.

## Text and font dimensions ("Toy" API only)

The `textextents(str)` function returns the dimensions of the string `str`, given the current font. There has to be a current drawing before this function is called.

`width` and `height` are stored in elements 3 and 4. The first two elements are the offsets ("bearings") from the reference point (green) to the bounding box. The last two elements determine where the next ("advance") character should start (blue).

![textextents](../assets/figures/textextents.png)

!!! note

    There is currently no equivalent of this function for the "Pro" API.

## Labels

The [`label`](@ref) function places text relative to a specific point, and you can use compass
points or angles to indicate where it should be. So `:N` (for North) places a text label directly above the point, as does `3π/2`.

```julia
fontsize(15)
octagon = ngon(O, 100, 8, 0, vertices=true)

compass = [:SE, :S, :SW, :W, :NW, :N, :NE, :E, :SE]

for i in 1:8
    circle(octagon[i], 5, :fill)
    label(string(compass[i]), compass[i], octagon[i], leader=true, leaderoffsets=[0.2, 0.9], offset=50)
end
```

![labels](../assets/figures/labels.png)

## Text on a circle

Use `textcurve(str)` to draw a string `str` on a circular arc or spiral.

```julia
sethue("royalblue4") # hide
fontsize(7)
fontface("Menlo")
textstring = join(names(Base), " ")
textcurve("this spiral contains every word in julia names(Base): " * textstring,
    -π/2,
    350, 0, 0,
    spiral_in_out_shift = -8.0,
    letter_spacing = 0,
    spiral_ring_step = 0)
fontsize(35)
fontface("Avenir-Black")
textcentered("julia names(Base)", 0, 0)
```

![text on a curve or spiral](../assets/figures/text-spiral.png)

For shorter strings, [`textcurvecentered`](@ref) tries to place the text on a circular arc by its center point.

```julia
fontface("Arial-Black")
fontsize(24) # hide
sethue("black") # hide
setdash("dot") # hide
setline(0.25) # hide
circle(O, 100, action = :stroke)
textcurvecentered("hello world", -π/2, 100, O;
    clockwise = true,
    letter_spacing = 0,
    baselineshift = -20
    )
textcurvecentered("hello world", π/2, 100, O;
    clockwise = false,
    letter_spacing = 0,
    baselineshift = 10
    )
```

![text centered on curve](../assets/figures/text-centered.png)

## Text on a polygon

Use [`textonpoly()`](@ref) to draw a string `str` that follows the route of a polygon.

```@example
using Luxor, Colors # hide

d = @draw begin # hide
origin() # hide
background("black") # hide
setmesh(mesh(
    box(BoundingBox()),
    [
        RGB(0.2, 0.2, 0.99),
        RGB(0.9, 0.2, 0.3),
        RGB(0.9, 0.9, 0.4),
        RGB(0.2, 0.8, 0.99),
    ],
))

fontsize(15)

for y = -250:20:250
    points = [
        Point(
            65x,
            y + 30sin(x + rescale(y, -260, 250, 0, 2π)),
        ) for x = -2π:π/10:2π
    ]
    textonpoly("WAVES " ^ 15, points)
end

end 800 500 # hide
d # hide
```

## Text clipping

You can use newly-created text paths as a clipping region - here the text paths are filled with names of randomly chosen Julia functions:

![text clipping](../assets/figures/text-path-clipping.png)

```julia
fontsize(600)                             # big fontsize to use for clipping
fontface("Agenda-Black")
str = "julia"                             # string to be clipped
w, h = textextents(str)[3:4]              # get width and height

translate(-(currentwidth/2) + 50, -(currentheight/2) + h)

textpath(str)                             # make text into a path
setline(3)
setcolor("black")
fillpreserve()                            # fill but keep
clip()                                    # and use for clipping region

fontface("Monaco")
fontsize(10)
namelist = map(x->string(x), names(Base)) # get list of function names in Base.

x = -20
y = -h
while y < currentheight
    sethue(rand(7:10)/10, rand(7:10)/10, rand(7:10)/10)
    s = namelist[rand(1:end)]
    text(s, x, y)
    se = textextents(s)
    x += se[5]                            # move to the right
    if x > w
        x = -20                            # next row
        y += 10
    end
end
```

## Text blocks, boxes, and wrapping

Longer lines of text can be made to wrap inside an imaginary rectangle with [`textwrap`](@ref). Specify the required width of the rectangle, and the location of the top left corner.

```julia
fontface("Georgia")
fontsize(12) # hide
sethue("black") # hide

loremipsum = """Lorem ipsum dolor sit amet, consectetur
adipiscing elit. Nunc placerat lorem ullamcorper,
sagittis massa et, elementum dui. Sed dictum ipsum vel
commodo pellentesque. Aliquam erat volutpat. Nam est
dolor, vulputate a molestie aliquet, rutrum quis lectus.
Sed lectus mauris, tristique et tempor id, accumsan
pharetra lacus. Donec quam magna, accumsan a quam
quis, mattis hendrerit nunc. Nullam vehicula leo ac
leo tristique, a condimentum tortor faucibus."""

setdash("dot")
box(O, 200, 200, action = :stroke)
textwrap(loremipsum, 200, O - (200/2, 200/2))
```

![text wrapping](../assets/figures/text-wrapping.png)

[`textwrap`](@ref) accepts a function that allows you to insert code that responds to the next line's linenumber, contents, position, and height.

```julia
fontface("Georgia")
fontsize(12) # hide
sethue("black") # hide

loremipsum = """Lorem ipsum dolor sit amet, consectetur
adipiscing elit. Nunc placerat lorem ullamcorper,
sagittis massa et, elementum dui. Sed dictum ipsum vel
commodo pellentesque. Aliquam erat volutpat. Nam est
dolor, vulputate a molestie aliquet, rutrum quis lectus.
Sed lectus mauris, tristique et tempor id, accumsan
pharetra lacus. Donec quam magna, accumsan a quam
quis, mattis hendrerit nunc. Nullam vehicula leo ac
leo tristique, a condimentum tortor faucibus."""

textwrap(loremipsum, 200, O - (200/2, 200/2),
    (lnumber, str, pt, l) -> begin
        sethue(Colors.HSB(rescale(lnumber, 1, 15, 0, 360), 1, 1))
        text(string("line ", lnumber), pt - (50, 0))
    end)
```

![text wrapped](../assets/figures/text-wrapping-1.png)

The [`textbox`](@ref) function also draws text inside a box, but doesn't alter the lines, and doesn't force the text to a specific width. Supply an array of strings and the top left position. The `leading` argument specifies the distance between the lines, so should be set relative to the current font size (as set with [`fontsize`](@ref)).

This example counts the number of characters drawn, using a simple closure. The function returns the position of the start of what would have been the next line.

```julia
fontface("Georgia")
fontsize(30)

loremipsum = """Lorem ipsum dolor sit amet, consectetur
adipiscing elit. Nunc placerat lorem ullamcorper,
sagittis massa et, elementum dui. Sed dictum ipsum vel
commodo pellentesque. Aliquam erat volutpat. Nam est
dolor, vulputate a molestie aliquet, rutrum quis lectus.
Sed lectus mauris, tristique et tempor id, accumsan
pharetra lacus. Donec quam magna, accumsan a quam
quis, mattis hendrerit nunc. Nullam vehicula leo ac
leo tristique, a condimentum tortor faucibus."""

_counter() = (a = 0; (n) -> a += n)
counter = _counter()

translate(boxtopleft(BoundingBox()))
fontface("Georgia")
fontsize(20)

finishpos = textbox(filter(!isempty, split(loremipsum, "\n")),
    O + (5, 0),
    leading = 28,
    linefunc = (lnumber, str, pt, h) -> begin
        text(string(lnumber), pt - (30, 0))
        counter(length(str))
    end)

fontsize(10)
text(string(counter(0), " characters"), finishpos)
```

![textbox](../assets/figures/textbox.png)

## Text formatting

Use [`textformat`](@ref) to draw text with inline formatting. You can specify the color and font of strings as they're displayed in a block.

`textformat()` accepts any number of arguments, each of which can be either a plain string or a named tuple containing both text and formatting information. The arguments are drawn, separated with spaces.

```@example
using Luxor
@drawsvg begin
    background("black")
    sethue("white")
    textformat("to be,", "or", "not", "to", "be", fontsize=30)
end 800 200
```

Mix strings and tuples as required:

```@example
using Luxor
@drawsvg begin
    background("black")
    sethue("white")
    fontsize(30)
    textformat(
        (text="that", fontsize=60),
        "is the",
        (text="question", color="magenta"))
end 800 200
```

The `advance` and `baseline` keywords can determine the position of the text  horizontally and vertically.

```@example
using Luxor
@drawsvg begin
    background("grey10")
    setopacity(0.5)
    textformat(
        (text="R",
            color="red",
            advance=-80,
            ),
        (text="G",
            color="green",
            advance=-80,
            baseline =  50,
            ),
            (text="B",
            color="blue",
            advance=-80,
            baseline =  -50,
            ),
    fontsize=200,
    position=midpoint(boxmiddleleft(), boxbottomcenter())
    )
end 800 300
```

With named tuples, remember to insert the trailing `,` where necessary:

```julia
textformat((text="oops"))

textformat((text="yes",))
```

A `prolog` keyword lets you specify a function `(pos, str)` that will be called before the text is drawn. You can use this, for example, to draw colored boxes and other graphics relative to the text.

```@example
using Luxor, Colors # hide
function bullet(pos, str::String)
    @layer begin
        translate(pos + (-80, -15))
        juliacircles(15)
    end
    @layer begin
        tx = textextents(str)
        bxwidth = tx[5] + 5
        bxheight = tx[4] - tx[2]
        hpos = pos.x + tx[5] / 2
        vpos = pos.y - tx[6] / 2 + tx[2] / 2
        bxcenter = Point(hpos, vpos)
        sethue("blue")
        box(bxcenter, bxwidth, bxheight, :stroke)
    end
end

@drawsvg begin
    background("black")
    sethue("white")
    fontsize(50)
    textformat(
        (text="programming", prolog=bullet),
        (text="in Julia", prolog=bullet),
        (text="is fun", prolog=bullet),
        (text="for all", prolog=bullet),
        width=150,
        leading=150,
        position=Point(-100, -100))
end 800 400
```

## Text tracking

Use [`texttrack`](@ref) to track or letter-space text, i.e.
vary the spacing between every letter. ("Kerning" is when
you do this for just a pair of letters.)

The tracking units depend on the current font size. In a
12‑point font, 1 em equals 12 points. A point is about
0.35mm, so a 1000 units of tracking for 12 point text
produces about 4.2mm of space between each character.

```julia
function text_tracking_example()
    fonts = [
        "Verdana",
        "TrebuchetMS",
        "Times-Roman",
        "Georgia",
        "Monaco"]
    fsize = 16
    grid = GridRect(boxtopleft(BoundingBox() * 0.9), 0, 20)
    tracking = 50
    for f in fonts
        fontsize(fsize)
        fontface(f)
        texttrack("This is some text in $(f): it’s been tracked by +$(tracking)",
            nextgridpoint(grid), tracking, fsize)
        text("This is some text in $(f): it’s not been tracked",
            nextgridpoint(grid))
        texttrack("This is some text in $(f): it’s been tracked by -$(tracking)",
            nextgridpoint(grid), -tracking, fsize)
    end
    finish()
end

text_tracking_example()
```

![textbox](../assets/figures/texttrack.svg)

## Text fitting

Sometimes you want to fit some text into a specific area, rather than use a specific font size.

To do this, use [`textfit`](@ref), and supply the text and a bounding box.

```@example
using Luxor # hide
d = Drawing(800, 800, :svg) # hide
origin() # hide
background("grey7") # hide
rh = 700 .* [4//11, 2//11, 4//11, 1//11]
cw = 700 .* [6//11, 2//11, 3//11, 1//11]
cells = Table(rh, cw)
for (pos, n) in cells
    setgrey(rand()/2)
    box(cells, n, :fill)
    setgrey(1)
    textfit("The sound of one hand clapping", BoundingBox(box(cells, n)), horizontalmargin=10)
end
finish() # hide
d # hide
```

You can supply a value for `maximumfontsize` as an optional
argument, such that the text never exceeds that size
(although it will probably be smaller).

!!! note

    The algorithm used by this function doesn't always
    produce ideal results. Suggestions for improvements
    welcome!

## Animating text

To animate the drawing of text, you can obtain and store the paths, and then build an animation using `drawpath()`.

![text animation](../assets/figures/textanimation.gif)

```julia
function frame(scene, framenumber)
    background("black")
    sethue("gold")
    fontface("BigMummy")
    fontsize(40)
    textpath("Thank you for using", boxtopcenter() + (0, 80) , halign=:center)
    tp1 = storepath()
    fontsize(130)
    textpath("Luxor", O + (0, 80), halign=:center)
    tp2 = storepath()

    eased_n = scene.easingfunction(framenumber - scene.framerange.start,
        0, 1, scene.framerange.stop - scene.framerange.start)

    for tp in (tp1, tp2)
        drawpath(tp, eased_n, action = :stroke)
    end
end

amovie = Movie(600, 250, "a movie")
animate(amovie, Scene(amovie, frame, 1:150), creategif=true, pathname="/tmp/textanimation.gif")
```

# Make simple animations

Luxor.jl can help you build simple animations, by assembling
a series of PNG images into an animated movie.

!!! note

    To make richer and more complex animations, use [Javis.jl](https://github.com/Wikunia/Javis.jl), which is designed specifically for the purpose.
    [Makie.jl](https://docs.makie.org/stable/) is also a good choice.

## 1: A Julia spinner

The first thing to do is to create a `Movie` object. This acts as a useful way to pass information from function to function.

```julia
using Luxor
mymovie = Movie(400, 400, "mymovie")
```

The resulting animation will be 400 × 400 pixels.

To make the graphics, define a function called `frame()` (it doesn't have to be called that, but it's a good name) which accepts two arguments, a Scene object, and a framenumber (which  will be an integer).

A movie consists of one or more scenes. A scene determines how many Luxor drawings should be made into a sequence and what function should be used to make them. The framenumber lets you keep track of where you are in a scene.

Here's a simple `frame` function which creates a drawing.

```julia
function frame(scene::Scene, framenumber::Int64)
    background("white")
    norm_framenumber = rescale(framenumber,
        scene.framerange.start,
        scene.framerange.stop,
        0, 1)
    rotate(norm_framenumber * 2π)
    juliacircles(100)
end
```

This function is responsible for drawing all the graphics
for a single frame. The incoming frame number is converted
(normalized) to lie between 0 and 1 - ie. between the first
frame and the last frame of the scene. It's multiplied by 2π
and used as input to `rotate`. So, as the framenumber goes from 1 to the last
frame in the scene, each drawing will be rotated by an increasing angle from 0
to 2π. For example, for a scene with 60 frames, framenumber 30 will set a
rotation value of about `2π * 0.5`.

The Scene object has details about the number of frames for this scene, including the number of times the `frame` function is called.

To actually build the animation, the [`animate`](@ref) function takes a movie and an array of one or more scenes and creates all the drawings required. It can also build a GIF or movie file.

```julia
animate(mymovie,
        [
            Scene(mymovie, frame, 1:60)
        ],
    creategif=true,
    pathname="juliaspinner.gif")
```

![julia spinner](../assets/figures/juliaspinner.gif)

Obviously, if you increase the range from 1:60 to, say,
1:300, you'll generate 300 drawings rather than 60, and the
rotation will take longer and will be much
smoother. Of course, you could change the framerate to be
something other than the default `30`.

Use `createmovie = true` instead of `creategif = true` if you want to make a video file. Specify the location and format for the video file in `pathname`:

```julia
...
    createmovie = true,
    pathname = "/tmp/juliaspinner.mkv"
...
```

## 2: Combining scenes

In the next example, we'll construct an animation that uses different scenes.

Consider this animation, showing the sun’s position for each hour of a 24 hour day. (It’s only a model...)

![sun24 animation](../assets/figures/sun24.gif)

Again, start by creating a movie, a useful handle that we can pass from function to function. We'll specify 24 frames for the entire animation.

```julia
sun24demo = Movie(400, 400, "sun24", 0:23)
```

We'll define a simple `backgroundfunction` function that draws a
background that will be used for all frames (since animated
GIFs like constant backgrounds):

```julia
function backgroundfunction(scene::Scene, framenumber)
    background("black")
end
```

A `nightskyfunction` draws the night sky, covering the entire drawing:

```julia
function nightskyfunction(scene::Scene, framenumber)
    sethue("midnightblue")
    box(O, 400, 400, action = :fill)
end
```

A `dayskyfunction` draws the daytime sky:

```julia
function dayskyfunction(scene::Scene, framenumber)
    sethue("skyblue")
    box(O, 400, 400, action = :fill)
end
```

The `sunfunction` draws a sun at 24 positions during the day. Since the framenumber will be a number between 0 and 23, this can be easily converted to lie between 0 and 2π.

```julia
function sunfunction(scene::Scene, framenumber)
    t = rescale(framenumber, 0, 23, 2pi, 0)
    gsave()
    sethue("yellow")
    circle(polar(150, t), 20, action = :fill)
    grestore()
end
```

And finally, tere's a `groundfunction` that draws the ground, the lower half of the drawing:

```julia
function groundfunction(scene::Scene, framenumber)
    gsave()
    sethue("brown")
    box(Point(O.x, O.y + 100), 400, 200, action = :fill)
    grestore()
    sethue("white")
end
```

To combine these together, we'll define a group of Scenes
that make up the movie. The scenes specify which functions
are to be used, and for which frames:

```julia
backdrop  = Scene(sun24demo, backgroundfunction, 0:23)   # every frame
nightsky  = Scene(sun24demo, nightskyfunction, 0:6)      # midnight to 06:00
nightsky1 = Scene(sun24demo, nightskyfunction, 17:23)    # 17:00 to 23:00
daysky    = Scene(sun24demo, dayskyfunction, 5:19)       # 05:00 to 19:00
sun       = Scene(sun24demo, sunfunction, 6:18)          # 06:00 to 18:00
ground    = Scene(sun24demo, groundfunction, 0:23)       # every frame
```

Finally, the `animate` function scans all the scenes in the
scenelist for the movie, and calls the specified functions for each
frame to build the animation:

```julia
animate(sun24demo, [
       backdrop, nightsky, nightsky1, daysky, sun, ground
   ],
   framerate=5,
   creategif=true)
```

![sun24 animation](../assets/figures/sun24.gif)

Notice that, for some frames, such as frame 0, 1, or 23, three of the functions are called: for others, such as 7 and 8, four or more functions are called.

### An alternative

As this is a very simple example, there is of course an easier way to make this particular animation.

We can use the incoming framenumber, rescaled, as the master
parameter that determines the position and appearance of all
the graphics.

```julia
function frame(scene, framenumber)
    background("black")
    n   = rescale(framenumber, scene.framerange.start, scene.framerange.stop, 0, 1)
    n2π = rescale(n, 0, 1, 0, 2π)
    sethue(n, 0.5, 0.5)
    box(BoundingBox(), action = :fill)
    if 0.25 < n < 0.75
        sethue("yellow")
        circle(polar(150, n2π + π/2), 20, action = :fill)
    end
    if n < 0.25 || n > 0.75
        sethue("white")
        circle(polar(150, n2π + π/2), 20, action = :fill)
    end
end
```

## Live graphics

Although Luxor is designed primarily for creating static graphics, it's possible to run it with an external buffer to display moving graphics. This example finds an approximation to π, updating the window continually with the latest estimate:

```julia
using Luxor
using MiniFB
include(dirname(pathof(Luxor)) * "/play.jl")

function run()
    within_circle = 0
    total_points = 0
    @play 400 400 begin
        pt = Point(rand(), rand())
        total_points += 1
        d = distance(O, pt)
        if d <= 1
            randomhue()
            circle(200pt, 1, :fill)
            within_circle += 1
        end
        pi_estimate = 4.0within_circle / total_points
        # show estimate
        sethue("black")
        box(boxtopleft(), boxmiddleright(), :fill)
        sethue("white")
        fontsize(30)
        text(string(pi_estimate), boxtopleft() + (10, 50), halign=:left)
        fontsize(20)
        text(string(total_points), boxtopleft() + (10, 100), halign=:left)
        sleep(0.05)
    end
end

run()
```

![pi live drawing](../assets/figures/minifb-pi.png) ![a few moments later...](../assets/figures/minifb-pi-1.png)

For more information, see [Interactive graphics and Threads](@ref). 

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Placing images

## Loading and placing images on drawings

Luxor lets you place existing images on the drawing. You can place PNG, SVG, and EPS images. (JPEGs aren't supported.)

For PNG and SVG, first load the image and create a reference to it. For example:

- for PNG images, use `img = readpng(filename)`
- for SVG images, use `img = readsvg(filename)` or `img = readsvg(string)`

You can access this image's dimensions with `img.width` and `img.height`.

Use [`placeimage(img)`](@ref) to place the image by its top
left corner at point `pt`. Use the `centered=true`
keyword to place the image's center point there.

```@example
using Luxor # hide
Drawing(600, 350, "../assets/figures/images.png") # hide
origin() # hide
background("grey40") # hide
img = readpng("../assets/figures/julia-logo-mask.png")
w = img.width
h = img.height
rulers()
scale(0.3, 0.3)
rotate(π/4)
placeimage(img, Point(-w/2, -h/2), .5)
sethue("red")
circle(-w/2, -h/2, 15, :fill)
finish() # hide
nothing # hide
```
!["Images"](../assets/figures/images.png)

PNG images can be placed with varying opacity or transparency. For example, the image is placed with 0.5 opacity with:

```julia
placeimage(img, Point(100, 100), 0.5)
```

SVG images do their own thing in terms of opacity.

[`readsvg`](@ref) also lets you supply raw (or pure) SVG code in a string.

You can use `placeimage()` to place an array of RGB or RGBA pixels on a drawing.

```@example
using Luxor, Colors # hide
N = 500
i = reshape([RGBA(rand(4)...) for p in 1:N^2], N, N)
# i is Matrix{RGBA{Float64}}
# (alias for Array{RGBA{Float64}, 2})
@draw begin
    origin()
    sethue("orange")
    box(O, N/2, N/2, :fill)
    placeimage(i, O, centered=true, alpha=0.5)
end 500 500
```

Or you can load an image as an array and place it on a drawing.

```julia
using Luxor, Colors, FileIO
img = load(dirname(dirname(pathof(Luxor))) * "/docs/src/assets/figures/42.png")
@draw begin
    img[1:50, :] .= colorant"cyan"
    img[200:end, :] .= colorant"magenta"
    placeimage(img, O, centered=true, alpha=0.5)
end 250 250
```

!["Images"](../assets/figures/42mod.png)

## SVG images

To output a drawing as an SVG image, using the `Drawing(... :svg)` or specify an SVG filename.
To obtain the SVG source of a _completed_ SVG drawing, use [`svgstring`](@ref).

For example, if you draw the Julia logo like this:

```julia
Drawing(500, 500, :svg)
origin()
julialogo()
finish()
s = svgstring()
```

You'll get the SVG source code stored, as a string, in `s`. You can examine or process it further. For example, the five colors used for the logo were:

```julia-repl
julia> eachmatch(r"rgb\\(.*?\\)", s) |> collect
5-element Vector{RegexMatch}:
 RegexMatch("rgb(0%,0%,0%)")
 RegexMatch("rgb(79.6%,23.5%,20%)")
 RegexMatch("rgb(25.1%,38.8%,84.7%)")
 RegexMatch("rgb(58.4%,34.5%,69.8%)")
 RegexMatch("rgb(22%,59.6%,14.9%)")
```

To display the image in a Jupyter or Pluto notebook, use the `HTML` function, or you can use the [`readsvg`](@ref) and [`placeimage`](@ref) functions in combination.

## EPS images

EPS (Encapsulated PostScript) files created by Luxor (or any Cairo-based package) can be re-imported and placed on the current drawing with the [`placeeps`](@ref) function. This function converts the EPS commands to the equivalent Luxor commands and evaluates them immediately in the context of the current drawing.

!!! warning

    This function is designed to extract just the coordinates of paths from an EPS
    file. An EPS file can contain much more information about an image than
    coordinates: there migth be image and pixel data, font data, linear color
    gradients, and so on. These are _not_ translated into equivalent Luxor
    functions. This function interprets the EPS commands in a Cairo-generated EPS
    "Prolog"; EPS files created by other applications will likely not contain this
    Cairo-generated Prolog, and so won't be interpreted at all (or will go wrong in
    interesting ways).

In this example, an SVG file `linnux.svg` is placed and exported to an EPS file `linux.eps`, then this EPS file is imported and placed on a new SVG drawing using Luxor functions instead of EPS commands, respecting the current scale and orientation. Finally, when the SVG document is finished, the graphics will be in SVG format again.

```@example
using Luxor

svgfile = dirname(@__FILE__) * "../assets/figures/linux.svg"
epsfile = dirname(@__FILE__) * "../assets/figures/linux.eps"

@eps begin
    img = readsvg(svgfile)
    placeimage(img, centered = true)
end 500 500 epsfile

@drawsvg begin
    translate(midpoint(boxtopleft(), O))
    scale(0.5)
    rotate(π/12)
    placeeps(epsfile)
    rulers()
end
```

If you want to obtain the paths and coordinates for use elsewhere, you can use the `log=true` function, which sends the commands to the REPL as well:

```julia
placeeps("/tmp/linux.eps", log=true)

# start EPS import
gsave()
setgray(1.0)
move(Point(70.801, -6.0))
line(Point(429.199, -6.0))
curve(Point(471.617, -6.0), Point(506.0, 28.383), Point(506.0, 70.801))
line(Point(506.0, 429.199))
curve(Point(506.0, 471.617), Point(471.617, 506.0), Point(429.199, 506.0))
line(Point(70.801, 506.0))
curve(Point(28.383, 506.0), Point(-6.0, 471.617), Point(-6.0, 429.199))
line(Point(-6.0, 70.801))
curve(Point(-6.0, 28.383), Point(28.383, -6.0), Point(70.801, -6.0))
closepath()
move(Point(70.801, -6.0))
fillpath()
...
```

Once you have a sequence of Luxor commands, you can edit them into new creations:

!["drawing a penguin animation"](../assets/figures/linux.gif)

## Placing an image matrix

You can use [`placeimage`](@ref) to put pixel images on a drawing.

This example uses noise to define the RGB values in a matrix of ARGB32 color values:

```@example
using Luxor # hide
D = 600
mat = [Luxor.ARGB32(
    noise(0.01r, 0.01c),
    noise(0.1r, 0.02c),
    noise(0.1r, 0.01c)) for r in 1:D ÷ 2, c in 1:D]

@draw begin
    background("grey60")
    placeimage(mat, boxtopleft())
    fontsize(80)
    sethue("white")
    setopacity(0.5)
    text("woah", halign=:center)
end D D ÷ 2
```

The next example saves vector graphics into an image matrix, then places that matrix at random on another drawing.

```julia
using Luxor

mat = @imagematrix begin
    juliacircles(6)
end 40 40

@draw begin
    for i in 1:500
        pos = rand(BoundingBox())
        @layer begin
            translate(pos)
            rotate(rand() * 2π)
            placeimage(mat, centered = rand(Bool))
        end
    end
end
```

![place image matrix](../assets/figures/place-image-matrix.png)

[`placeimage`](@ref) can also take in an optional argument `alpha` to change the opacity of the image matrix.

![place image matrix alpha](../assets/figures/place-image-matrix-alpha.png)

## Clipping images

You can clip images. The following script repeatedly places the image using a circle to define a clipping path:

!["Images"](../assets/figures/test-image.png)

```julia
using Luxor

width, height = 4000, 4000
margin = 500

fname = "test-image.pdf"
Drawing(width, height, fname)
origin()
background("grey25")

setline(5)
sethue("green")

image = readpng(dirname(@__FILE__) * "../assets/figures/julia-logo-mask.png")

w = image.width
h = image.height

pagetiles = Tiler(width, height, 7, 9)
tw = pagetiles.tilewidth/2
for (pos, n) in pagetiles
    circle(pos, tw, :stroke)
    circle(pos, tw, :clip)
    gsave()
    translate(pos)
    scale(.95, .95)
    rotate(rand(0.0:π/8:2π))
    placeimage(image, O, centered=true)
    grestore()
    clipreset()
end

finish()
```

## Transforming images

You can transform images by setting the current matrix, either with [`scale`](@ref) and [`rotate`](@ref) and similar, or by modifying it directly. This code scales and rotates an image made in an earlier chapter of this document around in a circle:

```@example
using Luxor # hide
Drawing(600, 400, "../assets/figures/transform-images.png") # hide
origin() # hide
img = readpng(dirname(dirname(pathof(Luxor))) * "/docs/src/assets/figures/textoutlines.png")
w = img.width
h = img.height
for θ in 0:π/6:2π-π/6
    gsave()
    scale(.4, .4)
    rotate(θ)
    translate(300, 0)
    placeimage(img, -w/2, -h/2, 0.9)
    grestore()
end
finish() # hide
nothing # hide
```
![transforming images](../assets/figures/transform-images.png)

## Combining images and vector graphics

You sometimes want to combine vector graphics and images, for example, to annotate them with text or vector graphics.

There are two ways you can do this:

- by adding the image with `placeimage()` and then drawing vector graphics on top.

- by opening the image as a drawing, and adding vector graphics into the image.

The things to be aware of are mostly to do with coordinates and transforms.

### Adding graphics on top

In this example, we'll annotate a PNG file.

```@example
using Luxor # hide

image = readpng("../assets/figures/julia-logo-mask.png")

w = image.width
h = image.height

# create a drawing surface of the same size

fname = "../assets/figures/drawing_on_images.png"
Drawing(w, h, fname)

# place the image on the Drawing - it's positioned by its top/left corner

placeimage(image, 0, 0)

# now you can annotate the image. The (0/0) is at the top left.

sethue("red")
setline(1)
fontsize(16)
circle(Point(150, 50), 2, :fill)
label("(150/50)", :NE, Point(150, 50), leader=true, offset=25)

arrow(Point(w/2, 90), Point(0, 90))
arrow(Point(w/2, 90), Point(w, 90))
text("width $w", Point(w/2, 70), halign=:center)

# to divide up the image into rectangular areas and number them,
# temporarily position the axes at the center:

@layer begin
    setline(0.5)
    sethue("green")
    fontsize(12)
    translate(w/2, h/2)
    tiles = Tiler(w, h, 8, 8, margin=0)
    for (pos, n) in tiles
        box(pos, tiles.tilewidth, tiles.tileheight, :stroke)
        text(string(n-1), pos, halign=:center)
    end
end
finish() # hide
nothing # hide
```

![drawing on images](../assets/figures/drawing_on_images.png)

#### Adding text to transformed placed images

The above approach works well, but suppose you want to locate the working origin
at the lower left of the image, i.e. you want all coordinates to be relative to the
bottom left corner of the image?

To do this, use [`translate`](@ref) and [`transform`](@ref) to modify the drawing space:

```@example
using Luxor # hide

image = readpng("../assets/figures/julia-logo-mask.png")
w = image.width
h = image.height
fname = "../assets/figures/drawing_on_images_2.png"
Drawing(w, h, fname)
placeimage(image, 0, 0)

# Move the axes to the bottom:

translate(0, h)

# and reflect in the x-axis

transform([1 0 0 -1 0 0])

# now 0/0 is at the bottom left corner, and 100/100 is up and to the right.

sethue("blue")
arrow(Point(200, 300), Point(160, 300))

# However, don't draw text while flipped, because it will be reversed!

fontsize(20)
sethue("black")
text("Oh no!", Point(30, 250))

# To work around this, define a text function
# that flips the workspace over the x-axis just for the text:

function textoverlay(t, pos; kwargs...)
    @layer begin
        translate(pos)
        transform([1 0 0 -1 0 0])
        text(t, O; kwargs...)
    end
end

textoverlay("a tittle!", Point(200, 300), halign=:left, valign=:middle)
textoverlay("0/0", O)
arrow(Point(130, 400), Point(130, 340))

finish() # hide

finish() # hide
nothing # hide
```

![drawing on transformed images](../assets/figures/drawing_on_images_2.png)

### Opening the image as drawing

An alternative way to work with images is to open the image as a drawing. Let's open the well-known mandrill image in Luxor. (I'll call him Marvin, because I couldn't find out whether or not the model had a name, but I think he should have one.)

```julia
using Luxor, Colors, Images, TestImages

marvin = testimage("mandrill")
M = Luxor.Colors.ARGB32.(marvin)
Drawing(M)
```

The current drawing is now a 512 × 512 array, where each pixel is an ARGB32 (an unsigned 32-bit integer holding 4 8-bit vaalues).

Marvin's right eye (on the left side of the drawing) is located at about 60 rows down, 175 columns across. Let's fill in his pupil with a white square:

```julia
M[55:65, 170:180] .= colorant"white"
M
```

![drawing into image](../assets/figures/marvin-1.png)

Using `M` on its own should show the image in your notebook or code editor (but not the REPL). If you want to save it, using the standard Images.jl functions.

We can use these indices as x and y coordinates, since the drawing origin is also currently at the top left.

```julia
sethue("white")
circle(Point(60, 175), 20, :stroke)
M
```

If we want to draw, say, a 10 by 10 numbered grid overlay on top of Marvin, and highlight four numbered cells, it's easier to just add a `transform()` function that flips the x/cols and y/rows convention, then create a table centered at the center of the drawing:

```julia
fontsize(15)
sethue("white")
setline(1)
transform([0 1 1 0 0 0])
t = Table(10, 10, 512 / 10, 512 / 10, Point(512 / 2, 512 / 2))
for (pos, n) in t
    text(string(n), pos, halign = :center, valign = :middle)
    box(pos, 512 / 10, 512 / 10, :stroke)
end
setline(5)
sethue("blue")
markcells(t, getcells(t, [2, 4, 35, 69]))
M
```

![drawing into image](../assets/figures/marvin-2.png)

## Image compositing

You should be using [Images.jl](https://github.com/JuliaImages) for most tasks involving image editing. But if you just need to composite images together, you can use the blending modes provided by [`setmode`](@ref).

```@example
using Luxor # hide
Drawing(600, 400, "../assets/figures/image-compositing.png") # hide
origin() # hide
img = readpng("../assets/figures/textoutlines.png")
w = img.width
h = img.height

placeimage(img, -w/2, -h/2, .5)
setmode("saturate")
translate(50, 0)
placeimage(img, -w/2, -h/2, .5)

finish() # hide
nothing # hide
```

![transforming images](../assets/figures/image-compositing.png)

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Design a logo

## Logo beginnings

The new (and currently fictitious) organization JuliaFission
has just asked you to design a new logo for them. They’re
something to do with atoms and particles, perhaps? So we’ll
design a new logo for them using some basic shapes; perhaps
colored circles in some kind of spiral formation would look
suitably “atomic”.

Let's try out some ideas.

```@setup example_1
using Luxor
svgimage = @drawsvg begin
setcolor("red")
circle(Point(0, 0), 100, action = :fill)
end 500 500
```

```julia
using Luxor
Drawing(500, 500, "my-drawing.svg")
origin()
setcolor("red")
circle(Point(0, 0), 100, action = :fill)
finish()
preview()
```

```@example example_1
svgimage # hide
```

This short piece of code does the following things:

- makes a new drawing 500 units square, and will save it in the file "my-drawing.svg" in SVG format.

- moves the zero point from the top left to the center. Graphics applications usually start measuring from the top left (occasionally from the bottom left), but it's easier to work out the positions of things if you start at the center. The `origin()` function moves the `0/0` point to the center of the drawing.

- selects one of the 200 or so named colors (defined in [Colors.jl](http://juliagraphics.github.io/Colors.jl/stable/))

- draws a circle at x = 0, y = 0, with radius 100 units, and fills it with the current color

- finishes the drawing and displays it on the screen

In case you’re wondering, the units are *points* (as in font sizes), and there are 72 points in an inch, just over 3 per millimeter. The y-axis points down the page. If you want to be reminded of where the x and y axes are, use the [`rulers`](@ref) function.

The `action=:fill` at the end of [`circle`](@ref) uses one of a set of symbols that let you use the shape you've created in different ways. There's the `:stroke` action, which draws around the edges but doesn't fill the shape with color. You might also meet the `:fillstroke`, `:fillpreserve`, `:strokepreserve`, `:clip`, and `:path` actions.

## Circles in a spiral

We want more than just one circle. We'll define a triangular shape, and place a circle at each corner. The [`ngon`](@ref) function creates regular polygons (eg triangles, squares, pentagons, etc.), and the `vertices=true` keyword doesn't draw the shape, it just provides the corner points - just what we want.

```@setup example_2
using Luxor
svgimage = @drawsvg begin

setcolor("red")
corners = ngon(Point(0, 0), 80, 3, vertices=true)
circle.(corners, 10, action = :fill)

end 500 500
```

```julia
# using Luxor
Drawing(500, 500, "my-drawing.svg")
origin()
setcolor("red")
corners = ngon(Point(0, 0), 80, 3, vertices=true)
circle.(corners, 10, action = :fill)
finish()
preview()
```

```@example example_2
svgimage # hide
```

Notice the "." after `circle`. This broadcasts the `circle()` function over the `corners`, thus drawing a 10-unit red-filled circle at every point.

The arguments to `ngon` are centerpoint, radius, and the number of sides. Try changing the third argument from 3 (triangle) to 4 (square) or 31 (traikontagon?).

To create a spiral of circles, we want to repeat this “draw a circle at each vertex of a triangle” procedure more than once. A simple loop will do: we’ll rotate the current drawing context by `i * ` 5° (`deg2rad(5)` radians) each time (so 5°, 10°, 15°, 20°, 25°, and 30°), and at the same time increase the size of the polygon by multiples of 10:

```@setup example_3
using Luxor
svgimage = @drawsvg begin

setcolor("red")
for i in 1:6
    rotate(i * deg2rad(5))
    corners = ngon(Point(0, 0), 80 + 10i, 3, vertices=true)
    circle.(corners, 10, action = :fill)
end

end 500 500
```

```julia
Drawing(500, 500, "my-drawing.svg")
origin()

setcolor("red")
for i in 1:6
    rotate(i * deg2rad(5))
    corners = ngon(Point(0, 0), 80 + 10i, 3, vertices=true)
    circle.(corners, 10, action = :fill)
end

finish()
preview()
```

```@example example_3
svgimage # hide
```

## Just add color

The colors used in the Julia logo are available as constants in Luxor, so we can make two changes that cycle through them. The first new line creates the set of Julia colors; then the [`setcolor`](@ref) function then works through them. `mod1` (get the `nth` element of an array) is the 1-based version of the `mod` function, essential for working with Julia and its 1-based indexing, such that `mod1(4, end)` gets the last value of a four element array (whereas `mod(4, end)` would fail, since it would return 0, and `colors[0]` would be an error).

```@setup example_4
using Luxor, Colors
svgimage = @drawsvg begin

const colors = (Luxor.julia_green, Luxor.julia_red,Luxor.julia_purple, Luxor.julia_blue)

for i in 1:6
    setcolor(colors[mod1(i, end)])
    rotate(i * deg2rad(5))
    corners = ngon(Point(0, 0), 80 + 10i, 3, vertices=true)
    circle.(corners, 10, action = :fill)
end

end 500 500
```

```julia
using Luxor
using Colors

Drawing(500, 500, "my-drawing.svg")
origin()

const colors = (Luxor.julia_green, Luxor.julia_red,Luxor.julia_purple, Luxor.julia_blue)

for i in 1:6
    setcolor(colors[mod1(i, end)])
    rotate(i * deg2rad(5))
    corners = ngon(Point(0, 0), 80 + 10i, 3, vertices=true)
    circle.(corners, 10, action = :fill)
end

finish()
preview()

```

```@example example_4
svgimage # hide
```

## Taking particles seriously

The flat circles are a bit dull, so let's write a function that draws the
circles as ‘particles’.

The `drawcircle()` function draws lots of circular disks on top of each other, but each
one is drawn with a slightly smaller radius and a slightly lighter shade of the
incoming color. The [`rescale`](@ref) function in Luxor provides an easy way to
map or adjust values from one range to another. Here, it's used to change both
the color and the size of the disks as the loop counter goes from 5 down to 1.

Also, let's make them get larger as they spiral outwards, by adding `4i` to the
radius when called by `drawcircle()`.

```@setup example_5
using Luxor, Colors

const colors = (Luxor.julia_green, Luxor.julia_red,Luxor.julia_purple, Luxor.julia_blue)

function drawcircle(pos, radius, n)
    c = colors[mod1(n, end)]
    for i in 5:-0.1:1
        setcolor(rescale(i, 5, 1, 0.5, 3) .* c)
        circle(pos + (i/2, i/2), rescale(i, 5, 1, radius, radius/6), action = :fill)
    end
end

svgimage = @drawsvg begin
    for i in 1:6
        rotate(i * deg2rad(5))
        corners = ngon(Point(0, 0), 80 + 10i, 3, vertices=true)
        drawcircle.(corners, 10 + 4i, i)
    end
end 500 500
```

```julia
function drawcircle(pos, radius, n)
    c = colors[mod1(n, end)]
    for i in 5:-0.1:1
        # increase color from 0.5 to 3 as i drops from 5 to 1
        setcolor(rescale(i, 5, 1, 0.5, 3) .* c)
        # decrease radius from radius to radius/6
        diskradius = rescale(i, 5, 1, radius, radius/6)
        circle(pos + (i/2, i/2), diskradius, action = :fill)
    end
end

Drawing(500, 500, "my-drawing.svg")
origin()

for i in 1:6
    rotate(i * deg2rad(5))
    corners = ngon(Point(0, 0), 80 + 10i, 3, vertices=true)
    drawcircle.(corners, 10 + 4i, i)
end

finish()
preview()
```

```@example example_5
svgimage # hide
```

This is looking quite promising. But here’s the thing: in a
parallel universe, you might already have made this in no
time at all using Adobe Illustrator or Inkscape. But with
this Luxor code, you can try all kinds of different
variations with almost immediate results - you can “walk through
the parameter space”, either manually or via code, and see
what effects you get. You don’t have to redraw everything
with different angles and radii...

So here's what a pentagonal theme with more circles looks like:

```@setup example_6
using Luxor, Colors

const colors = (Luxor.julia_green, Luxor.julia_red,Luxor.julia_purple, Luxor.julia_blue)

function drawcircle(pos, radius, n)
    c = colors[mod1(n, end)]
    for i in 5:-0.1:1
        setcolor(rescale(i, 5, 1, 0.5, 3) .* c)
        circle(pos + (i/2, i/2), rescale(i, 5, 1, radius, radius/6), action = :fill)
    end
end

svgimage = @drawsvg begin
    for i in 1:12
        rotate(i * deg2rad(1.5))
        corners = ngon(Point(0, 0), 10 + 12i, 5, vertices=true)
        drawcircle.(corners, 5 + 2i, i)
    end
end 500 500
```

```julia
Drawing(500, 500, "my-drawing.svg")
origin()

for i in 1:12
    rotate(i * deg2rad(1.5))
    corners = ngon(Point(0, 0), 10 + 12i, 5, vertices=true)
    drawcircle.(corners, 5 + 2i, i)
end

finish()
preview()
```

```@example example_6
svgimage # hide
```

To tidy up, it's a good idea to move the code into functions (to avoid running too much in global scope), and do a bit of housekeeping.

Also, a background for the icon would look good. [`squircle`](@ref) is useful for drawing shapes that occupy the space between pointy dull rectangles and space-inefficient circles.

The complete final script looks like this:

```@setup example_7
using Luxor, Colors

const colors = (Luxor.julia_green, Luxor.julia_red, Luxor.julia_purple, Luxor.julia_blue)

function drawcircle(pos, radius, n)
    c = colors[mod1(n, end)]
    for i in 5:-.1:1
        setcolor(rescale(i, 5, 1, 0.5, 3) .* c)
        circle(pos + (i/2, i/2), rescale(i, 5, 1, radius, radius/6), action = :fill)
    end
end

function main(filename)
    @drawsvg begin
        setcolor(0.2, 0.2, 0.3)
        squircle(O, 240, 240, rt=0.5, action = :fill)
        for i in 1:12
            rotate(i * deg2rad(1.5))
            corners = ngon(Point(0, 0), 10 + 12i, 5, vertices=true)
            drawcircle.(corners, 5 + 2i, i)
        end
    end 500 500
end

svgimage = main("my-drawing.svg")
```

```julia
using Luxor, Colors

const colors = (Luxor.julia_green, Luxor.julia_red,Luxor.julia_purple, Luxor.julia_blue)

function drawcircle(pos, radius, n)
    c = colors[mod1(n, end)]
    for i in 5:-.1:1
        setcolor(rescale(i, 5, 1, 0.5, 3) .* c)
        diskradius = rescale(i, 5, 1, radius, radius/6)
        circle(pos + (i/2, i/2), diskradius, action = :fill)
    end
end

function main(filename)
    Drawing(500, 500, filename)
    origin()
    setcolor(0.2, 0.2, 0.3)
    squircle(O, 240, 240, rt=0.5, action = :fill)
    for i in 1:12
        rotate(i * deg2rad(1.5))
        corners = ngon(Point(0, 0), 10 + 12i, 5, vertices=true)
        drawcircle.(corners, 5 + 2i, i)
    end
    finish()
    preview()
end

main("my-drawing.svg")
```

```@example example_7
svgimage # hide
```

So, did the JuliaFission organization like their logo? Who
knows? - they may still be debating how accurate the
representation of an atom should be... But if not, we can
always recycle some of these ideas for future projects. 😃

## Extra credit

### 1. Randomize

Try refactoring your code so that you can automatically run through various parameter ranges. You could create many drawings with automatically-generated  filenames...

### 2. Remember the random values

Using random numbers is a great way to find new patterns and
shapes; but unless you know what values were used, you can't
easily reproduce them. It's frustrating to produce something
really good but not know what values were used to make it.
So modify the code so that the random numbers are
remembered, and drawn on the screen (you can use the
`text(string, position)` function),

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# A tutorial

## Euclidean eggs

The goal of this tutorial is to do a bit of basic 'compass and ruler' Euclidean geometry, to introduce the basic concepts of Luxor drawings. For the main section of this tutorial, we'll attempt to draw Euclid's egg, which involves a bit of geometry.

For now, you can continue to store all the drawing instructions between the `@png` macro's `begin` and `end` markers without using too many functions. Technically, however, working like this at the top-level in Julia (ie without storing instructions in functions which Julia can compile) isn't considered to be 'best practice', because the unit of compilation in Julia is the function. (Look up 'global scope' in the documentation.) But speed isn't going to be a priority in this section.

```julia
@png begin
```

Define the variable `radius` to hold a value of 80 units (there are 72 units in a traditional inch):

```julia
    radius = 80
```

Select gray dotted lines. To specify a color you can supply RGB (or HSB or LAB or LUV) values or use named colors, such as "red" or "green". "gray0" is black, and "gray100" is white. (For more information about colors, see [Colors.jl](https://github.com/JuliaGraphics/Colors.jl).)

```julia
    setdash("dot")
    sethue("gray30")
```

(You can use [`setcolor`](@ref) instead of [`sethue`](@ref) — the latter doesn't affect the current opacity setting.)

Next, make two points, A and B, which will lie either side of the origin point. This line uses an array comprehension - notice the square brackets enclosing a `for` loop.

```julia
    A, B = [Point(x, 0) for x in [-radius, radius]]
```

`x` uses two values from the inner array, and a Point using each value is created and stored in its own variable. It seems hardly worth doing for two points, but it shows how you can assign more than one variable at the same time, and also how to generate points.

With two points defined, draw a line from A to B, and stroke it.

```julia
    line(A, B, action = :stroke)
```

Draw a stroked circle too. The center of the circle is placed at the origin. You can use the letter **O** as a short cut for Origin, ie the `Point(0, 0)`.

```julia
    circle(O, radius, action = :stroke)
end
```

```@setup te1
using Luxor
Drawing(725, 300, "../assets/figures/tutorial-egg-1.png")
background("white")
origin()
radius=80
setdash("dot")
sethue("gray30")
A, B = [Point(x, 0) for x in [-radius, radius]]
line(A, B, action = :stroke)
circle(O, radius, action = :stroke)
finish()
nothing
```
![point example](../assets/figures/tutorial-egg-1.png)

### Labels and dots

It's a good idea to label points in geometrical constructions, and to draw small dots to indicate their location clearly. For the latter task, small filled circles will do. For labels, there's a special [`label`](@ref) function we can use, which positions a text string close to a point, using angles or points of the compass, so `:N` places the label to the north of a point.

Edit your previous code by adding instructions to draw some labels and circles:

```julia
@png begin
    radius=80
    setdash("dot")
    sethue("gray30")
    A, B = [Point(x, 0) for x in [-radius, radius]]
    line(A, B, action = :stroke)
    circle(Point(0, 0), radius, action = :stroke)
# >>>>
    label("A", :NW, A)
    label("O", :N,  O)
    label("B", :NE, B)

    circle.([A, O, B], 2, action = :fill)
    circle.([A, B], 2radius, action = :stroke)
end
```

```@setup te2
using Luxor
Drawing(725, 400, "../assets/figures/tutorial-egg-2.png")
background("white")
origin()
radius=80
setdash("dot")
sethue("gray30")

A, B = [Point(x, 0) for x in [-radius, radius]]
line(A, B, action = :stroke)
circle(O, radius, action = :stroke)
label("A", :NW, A)
label("O", :N, O)
label("B", :NE, B)
circle.([A, O, B], 2, action = :fill)
circle.([A, B], 2radius, action = :stroke)
finish()
```
![point example](../assets/figures/tutorial-egg-2.png)

While we could have drawn all the circles as usual, we've taken the opportunity to introduce a powerful Julia feature called _broadcasting_. The dot (`.`) just after the function name in the last two [`circle`](@ref) function calls tells Julia to apply the function to all the arguments. We supplied an array of three points, and filled circles were placed at each one. Then we supplied an array of two points and stroked circles were placed there. Notice that we didn't have to supply an array of radius values or an array of actions — in each case Julia did the necessary broadcasting (from scalar to vector) for us.

### Intersect this

We're now ready to tackle the job of finding the coordinates of the two points where two circles intersect. There's a Luxor function called [`intersectionlinecircle`](@ref) that finds the point or points where a line intersects a circle. So we can find the two points where one of the circles crosses an imaginary vertical line drawn through O. Because of the symmetry, we'll only have to do circle A.

```julia
@png begin
    # as before
    radius=80
    setdash("dot")
    sethue("gray30")
    A, B = [Point(x, 0) for x in [-radius, radius]]
    line(A, B, action = :stroke)
    circle(O, radius, action = :stroke) # use letter O for Point(0, 0)

    label("A", :NW, A)
    label("O", :N,  O)
    label("B", :NE, B)

    circle.([A, O, B], 2, action = :fill)
    circle.([A, B], 2radius, action = :stroke)
```

The [`intersectionlinecircle`](@ref) takes four arguments: two points to define the line and a point/radius pair to define the circle. It returns the number of intersections (probably 0, 1, or 2), followed by the two points.

The line is specified with two points with an x value of 0 and y values of ± twice the radius, written in Julia's math-friendly style. The circle is centered at A and has a radius of AB (which is `2radius`). Assuming that there are two intersections, we feed these to [`circle`](@ref) and [`label`](@ref) for drawing and labeling using our new broadcasting superpowers.

```julia
# >>>>
    nints, C, D =
        intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)

    if nints == 2
        circle.([C, D], 2, action = :fill)
        label.(["D", "C"], :N, [D, C])
    end

end
```

```@setup te3
using Luxor
Drawing(725, 400, "../assets/figures/tutorial-egg-3.png")
background("white")
origin()
radius=80
setdash("dot")
sethue("gray30")

A, B = [Point(x, 0) for x in [-radius, radius]]
line(A, B, action = :stroke)
circle(O, radius, action = :stroke)
label("A", :NW, A)
label("O", :N, O)
label("B", :NE, B)
circle.([A, O, B], 2, action = :fill)
circle.([A, B], 2radius, action = :stroke)

nints, C, D = intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)
if nints == 2
    circle.([C, D], 2, action = :fill)
    label.(["D", "C"], :N, [D, C])
end

finish()
```
![point example](../assets/figures/tutorial-egg-3.png)

### The upper circle

Now for the trickiest part of this construction: a small circle whose center point sits on top of the inner circle and that meets the two larger circles near the point D.

Finding this new center point C1 is easy enough, because we can again use [`intersectionlinecircle`](@ref) to find the point where the central circle crosses a line from O to D.

Add some more lines to your code:

```julia
@png begin

# >>>>

    nints, C1, C2 = intersectionlinecircle(O, D, O, radius)
    if nints == 2
        circle(C1, 3, action = :fill)
        label("C1", :N, C1)
    end

end
```

```@setup te4
using Luxor
Drawing(725, 400, "../assets/figures/tutorial-egg-4.png")
background("white")
origin()
radius=80
setdash("dot")
sethue("gray30")

A, B = [Point(x, 0) for x in [-radius, radius]]
line(A, B, action = :stroke)
circle(O, radius, action = :stroke)
label("A", :NW, A)
label("O", :N, O)
label("B", :NE, B)
circle.([A, O, B], 2, action = :fill)
circle.([A, B], 2radius, action = :stroke)

nints, C, D = intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)
if nints == 2
    circle.([C, D], 2, action = :fill)
    label.(["D", "C"], :N, [D, C])
end

nints, C1, C2 = intersectionlinecircle(O, D, O, radius)
if nints == 2
    circle(C1, 3, action = :fill)
    label("C1", :N, C1)
end
finish()
```
![point example](../assets/figures/tutorial-egg-4.png)

The two other points that define this circle lie on the intersections of the large circles with imaginary lines through points A and B passing through the center point C1. We're looking for the lines `A-C1-ip`, where `ip` is somewhere on the circle between D and B, and `B-C1-ip`, where `ip` is somewhere between A and D.

To find (and draw) these points is straightforward. We'll mark these as intermediate for now, because there are in fact four intersection points but we want just the two nearest the top:

```julia
# >>>>

    nints, I3, I4 = intersectionlinecircle(A, C1, A, 2radius)
    nints, I1, I2 = intersectionlinecircle(B, C1, B, 2radius)

    circle.([I1, I2, I3, I4], 2, action = :fill)
```

So we can use the [`distance`](@ref) function to find the distance between two points, and it's simple enough to compare the values and choose the shortest.

```julia
# >>>>

    if distance(C1, I1) < distance(C1, I2)
       ip1 = I1
    else
       ip1 = I2
    end
    if distance(C1, I3) < distance(C1, I4)
       ip2 = I3
    else
       ip2 = I4
    end

    label("ip1", :N, ip1)
    label("ip2", :N, ip2)
    circle(C1, distance(C1, ip1), action = :stroke)

end
```

```@setup te5
using Luxor
Drawing(725, 400, "../assets/figures/tutorial-egg-5.png")
background("white")
origin()
radius=80
setdash("dot")
sethue("gray30")

A, B = [Point(x, 0) for x in [-radius, radius]]
line(A, B, action = :stroke)
circle(O, radius, action = :stroke)
label("A", :NW, A)
label("O", :N, O)
label("B", :NE, B)
circle.([A, O, B], 2, action = :fill)
circle.([A, B], 2radius, action = :stroke)

nints, C, D = intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)
if nints == 2
    circle.([C, D], 2, action = :fill)
    label.(["D", "C"], :N, [D, C])
end

nints, C1, C2 = intersectionlinecircle(O, D, O, radius)
if nints == 2
    circle(C1, 3, action = :fill)
    label("C1", :N, C1)
end

# finding two more points on the circumference

nints, I3, I4 = intersectionlinecircle(A, C1, A, 2radius)
nints, I1, I2 = intersectionlinecircle(B, C1, B, 2radius)

circle.([I1, I2, I3, I4], 2, action = :fill)

if distance(C1, I1) < distance(C1, I2)
    ip1 = I1
else
   ip1 = I2
end
if distance(C1, I3) < distance(C1, I4)
   ip2    = I3
else
   ip2 = I4
end

label("ip1", :N, ip1)
label("ip2", :N, ip2)
circle(C1, distance(C1, ip1), action = :stroke)

finish()
```
![point example](../assets/figures/tutorial-egg-5.png)

### Eggs at the ready

We now know all the points on the egg's perimeter, and the centers of the circular arcs. To draw the outline, we'll use the [`arc2r`](@ref) function four times. This function takes: a center point and two points that together define a circular arc, plus an action.

The shape consists of four curves, so we'll use the `:path` action. Instead of immediately drawing the shape, like the `:fill` and `:stroke` actions do, this action adds a section to the current path.

```julia

    label("ip1", :N, ip1)
    label("ip2", :N, ip2)
    circle(C1, distance(C1, ip1), action = :stroke)

# >>>>

    setline(5)
    setdash("solid")

    arc2r(B,    A,  ip1, :path) # centered at B, from A to ip1
    arc2r(C1, ip1,  ip2, :path)
    arc2r(A,  ip2,    B, :path)
    arc2r(O,    B,    A, :path)
```

Finally, once we've added all four sections to the path we can stroke and fill it. If you want to use separate styles for the stroke and fill, you can use a `preserve` version of the first action. This applies the action but keeps the path available for more actions.

```julia
    strokepreserve()
    setopacity(0.8)
    sethue("ivory")
    fillpath()
end
```

```@setup te6
using Luxor
Drawing(725, 400, "../assets/figures/tutorial-egg-6.png")
background("white")
origin()
radius=80
setdash("dot")
sethue("gray30")

A, B = [Point(x, 0) for x in [-radius, radius]]
line(A, B, action = :stroke)
circle(O, radius, action = :stroke)
label("A", :NW, A)
label("O", :N, O)
label("B", :NE, B)
circle.([A, O, B], 2, action = :fill)
circle.([A, B], 2radius, action = :stroke)

nints, C, D =
    intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)
if nints == 2
    circle.([C, D], 2, action = :fill)
    label.(["D", "C"], :N, [D, C])
end

nints, C1, C2 = intersectionlinecircle(O, D, O, radius)
if nints == 2
    circle(C1, 3, action = :fill)
    label("C1", :N, C1)
end

# finding two more points on the circumference

nints, I3, I4 = intersectionlinecircle(A, C1, A, 2radius)
nints, I1, I2 = intersectionlinecircle(B, C1, B, 2radius)

circle.([I1, I2, I3, I4], 2, action = :fill)

if distance(C1, I1) < distance(C1, I2)
    ip1 = I1
else
   ip1 = I2
end
if distance(C1, I3) < distance(C1, I4)
   ip2    = I3
else
   ip2 = I4
end

label("ip1", :N, ip1)
label("ip2", :N, ip2)
circle(C1, distance(C1, ip1), action = :stroke)

setline(5)
setdash("solid")

arc2r(B, A, ip1, :path)
arc2r(C1, ip1, ip2, :path)
arc2r(A, ip2, B, :path)
arc2r(O, B, A, :path)
strokepreserve()
setopacity(0.8)
sethue("ivory")
fillpath()
finish()
```
![point example](../assets/figures/tutorial-egg-6.png)

## Egg stroke

To be more generally useful, the above code can be boiled into a single function.

```julia
function egg(radius, action=:none)
    A, B = [Point(x, 0) for x in [-radius, radius]]
    nints, C, D =
        intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)

    flag, C1 = intersectionlinecircle(C, D, O, radius)
    nints, I3, I4 = intersectionlinecircle(A, C1, A, 2radius)
    nints, I1, I2 = intersectionlinecircle(B, C1, B, 2radius)

    if distance(C1, I1) < distance(C1, I2)
        ip1 = I1
    else
        ip1 = I2
    end
    if distance(C1, I3) < distance(C1, I4)
        ip2 = I3
    else
        ip2 = I4
    end

    newpath()
    arc2r(B, A, ip1, :path)
    arc2r(C1, ip1, ip2, :path)
    arc2r(A, ip2, B, :path)
    arc2r(O, B, A, :path)
    closepath()

    do_action(action)
end
```

This keeps all the intermediate code and calculations safely hidden away, and it's now possible to draw a Euclidean egg by calling `egg(100, action = :stroke)`, for example, where `100` is the required width (radius), and `:stroke` is the required action.

(Of course, there's no error checking. This should be added if the function is to be used for any serious applications...!)

Notice that this function doesn't define anything about what color it is, or where it's placed. When called, the function inherits the current drawing environment: scale, rotation, position of the origin, line thickness, color, style, and so on. This lets us write code like this:

```julia
@png begin
    setopacity(0.7)
    for θ in range(0, step=π/6, length=12)
        gsave()
            rotate(θ)
            translate(0, -150)
            egg(50, :path)
            setline(10)
            randomhue()
            fillpreserve()

            randomhue()
            strokepath()
        grestore()
    end
end 800 800 "eggstravaganza.png"
```

```@setup te7
using Luxor, Random
Random.seed!(42)
Drawing(725, 500, "../assets/figures/tutorial-egg-7.png")
function egg(radius, action=:none)
    A, B = [Point(x, 0) for x in [-radius, radius]]
    nints, C, D =
        intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)

    flag, C1 = intersectionlinecircle(C, D, O, radius)
    nints, I3, I4 = intersectionlinecircle(A, C1, A, 2radius)
    nints, I1, I2 = intersectionlinecircle(B, C1, B, 2radius)

    if distance(C1, I1) < distance(C1, I2)
        ip1 = I1
    else
        ip1 = I2
    end
    if distance(C1, I3) < distance(C1, I4)
        ip2 = I3
    else
        ip2 = I4
    end

    newpath()
    arc2r(B, A, ip1, :path)
    arc2r(C1, ip1, ip2, :path)
    arc2r(A, ip2, B, :path)
    arc2r(O, B, A, :path)
    closepath()
    do_action(action)
end
background("white")
origin()
setopacity(0.7)
for θ in range(0, step=π/6, length=12)
    gsave()
        rotate(θ)
        translate(0, -150)
        egg(50, :path)
        setline(10)
        randomhue()
        fillpreserve()

        randomhue()
        strokepath()
    grestore()
end
finish()
```
![point example](../assets/figures/tutorial-egg-7.png)

The loop runs 12 times, with `theta` increasing from 0 upwards in steps of π/6. But before each egg is drawn, the entire drawing environment is rotated by `theta` radians and then shifted along the y-axis away from the origin by -150 units (the y-axis values usually increase downwards, so, before any rotation takes place, a shift of -150 looks like an upwards shift). The [`randomhue`](@ref) function does what you expect, and the `egg` function is passed the `:fill` action and the radius.

Notice that the four drawing instructions are encased in a `gsave()`/`grestore()` pair. Any change made to the drawing environment inside this pair is discarded after the `grestore()`. This allows us to make temporary changes to the scale and rotation, etc. and discard them easily once the shapes have been drawn.

Rotations and angles are typically specified in radians. The positive x-axis (a line from the origin increasing in x) starts off heading due east from the origin, and the y-axis due south, and positive angles are clockwise (ie from the positive x-axis towards the positive y-axis). So the second egg in the previous example was drawn after the axes were rotated by π/6 radians clockwise.

If you look closely you can tell which egg was drawn first — it's overlapped on each side by subsequent eggs.

#### Thought experiments

1. What would happen if the translation was `translate(0, 150)` rather than `translate(0, -150)`?

2. What would happen if the translation was `translate(150, 0)` rather than `translate(0, -150)`?

3. What would happen if you translated each egg *before* you rotated the drawing context?

Some useful tools for investigating the important aspects of coordinates and transformations include:

- [`rulers`](@ref) to draw the current x and y axes
- [`getrotation`](@ref) to get the current rotation
- [`getscale`](@ref) to get the current scale

## Polyeggs

As well as stroke and fill actions, you can use the path as a clipping region (`:clip`), or as the basis for more shape shifting.

The `egg` function creates a path and lets you apply an action to it. It's also possible to convert the path into a polygon (an array of points), which lets you do more things with it. The following code converts the egg's path into a polygon, and then moves every other point of the polygon halfway towards the centroid.

```julia
@png begin
    egg(160, :path)
    pgon = first(pathtopoly())
```

The [`pathtopoly`](@ref) function converts the current path made by `egg(160, :path)` into a polygon. Those smooth curves have been approximated by a series of straight line segments. The `first` function is used because [`pathtopoly`](@ref) returns an array of one or more polygons (paths can consist of a series of loops), and we know that we need only the single path here.

```julia
    pc = polycentroid(pgon)
    circle(pc, 5, action = :fill)
```

[`polycentroid`](@ref) finds the centroid of the new polygon.

This loop steps through the points and moves every odd-numbered one halfway towards the centroid. [`between`](@ref) finds a point midway between two specified points. Finally the [`poly`](@ref) function draws the array of points.

```julia
    for pt in 1:2:length(pgon)
        pgon[pt] = between(pc, pgon[pt], 0.5)
    end
    poly(pgon, action = :stroke)
end
```

```@setup te8
using Luxor
Drawing(725, 500, "../assets/figures/tutorial-egg-8.png")
function egg(radius, action=:none)
    A, B = [Point(x, 0) for x in [-radius, radius]]
    nints, C, D =
        intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)

    flag, C1 = intersectionlinecircle(C, D, O, radius)
    nints, I3, I4 = intersectionlinecircle(A, C1, A, 2radius)
    nints, I1, I2 = intersectionlinecircle(B, C1, B, 2radius)

    if distance(C1, I1) < distance(C1, I2)
        ip1 = I1
    else
        ip1 = I2
    end
    if distance(C1, I3) < distance(C1, I4)
        ip2    = I3
    else
        ip2 = I4
    end

    newpath()
    arc2r(B, A, ip1, :path)
    arc2r(C1, ip1, ip2, :path)
    arc2r(A, ip2, B, :path)
    arc2r(O, B, A, :path)
    closepath()
    do_action(action)
end
background("white")
origin()
egg(160, :path)
sethue("black")
pgon = first(pathtopoly())
pc = polycentroid(pgon)
circle(pc, 5, action = :fill)

for pt in 1:2:length(pgon)
    pgon[pt] = between(pc, pgon[pt], 0.5)
end
poly(pgon, action = :stroke)
finish()
```
![point example](../assets/figures/tutorial-egg-8.png)

The uneven appearance of the interior points here looks to be a result of the default line join settings. Experiment with `setlinejoin("round")` to see if this makes the geometry look tidier.

For a final experiment with our `egg` function, here's Luxor's [`offsetpoly`](@ref) function struggling to draw around the spiky egg-based polygon.

```julia
@png begin
    egg(80, :path)
    pgon = first(pathtopoly()) |> unique
    pc = polycentroid(pgon)

    for pt in 1:2:length(pgon)
        pgon[pt] = between(pc, pgon[pt], 0.8)
    end

    for i in 30:-3:-8
        randomhue()
        op = offsetpoly(pgon, i)
        poly(op, action = :stroke, close=true)
    end
end 800 800 "spike-egg.png"
```

```@setup te9
using Luxor, Random
Drawing(725, 600, "../assets/figures/tutorial-egg-9.png")
function egg(radius, action=:none)
    A, B = [Point(x, 0) for x in [-radius, radius]]
    nints, C, D =
        intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)

    flag, C1 = intersectionlinecircle(C, D, O, radius)
    nints, I3, I4 = intersectionlinecircle(A, C1, A, 2radius)
    nints, I1, I2 = intersectionlinecircle(B, C1, B, 2radius)

    if distance(C1, I1) < distance(C1, I2)
        ip1 = I1
    else
        ip1 = I2
    end
    if distance(C1, I3) < distance(C1, I4)
        ip2    = I3
    else
        ip2 = I4
    end

    newpath()
    arc2r(B, A, ip1, :path)
    arc2r(C1, ip1, ip2, :path)
    arc2r(A, ip2, B, :path)
    arc2r(O, B, A, :path)
    closepath()
    do_action(action)
end
background("white")
origin()
Random.seed!(42)
egg(80, :path)
pgon = first(pathtopoly()) |> unique
pc = polycentroid(pgon)
circle(pc, 5, action = :fill)

for pt in 1:2:length(pgon)
    pgon[pt] = between(pc, pgon[pt], 0.8)
end

for i in 30:-3:-8
    randomhue()
    op = offsetpoly(pgon, i)
    poly(op, action = :stroke, close=true)
end

finish()
```
![point example](../assets/figures/tutorial-egg-9.png)

The small changes in the regularity of the points created by the path-to-polygon conversion and the varying number of samples it made are continually amplified in successive outlinings.

## Clipping

A useful feature of Luxor is that you can use shapes as a clipping mask. Graphics can be hidden when they stray outside the boundaries of the mask.

In this example, the egg (assuming you're still in the same Julia session in which you've defined the `egg` function) isn't drawn, but is defined to act as a clipping mask. Every graphic shape that you draw now is clipped where it crosses the mask. This is specified by the `:clip` action which is passed to the [`do_action`](@ref) function at the end of the `egg`.

Here, the graphics are provided by the [`ngon`](@ref) function, which draws regular `n`-sided polygons.

```julia
using Luxor, Colors
@svg begin
    setopacity(0.5)
    eg(a) = egg(150, a)
    sethue("gold")
    eg(:fill)
    eg(:clip)
    gsave()
       for i in 360:-4:1
           sethue(Colors.HSV(i, 1.0, 0.8))
           rotate(π/30)
           ngon(O, i, 5, 0, action = :stroke)
       end
    grestore()
    clipreset()
    sethue("red")
    eg(:stroke)
end
```

```@setup te10
using Luxor, Colors
Drawing(725, 620, "../assets/figures/tutorial-egg-10.png")
origin()
background("white")
function egg(radius, action=:none)
    A, B = [Point(x, 0) for x in [-radius, radius]]
    nints, C, D =
        intersectionlinecircle(Point(0, -2radius), Point(0, 2radius), A, 2radius)

    flag, C1 = intersectionlinecircle(C, D, O, radius)
    nints, I3, I4 = intersectionlinecircle(A, C1, A, 2radius)
    nints, I1, I2 = intersectionlinecircle(B, C1, B, 2radius)

    if distance(C1, I1) < distance(C1, I2)
        ip1 = I1
    else
        ip1 = I2
    end
    if distance(C1, I3) < distance(C1, I4)
        ip2    = I3
    else
        ip2 = I4
    end

    newpath()
    arc2r(B, A, ip1, :path)
    arc2r(C1, ip1, ip2, :path)
    arc2r(A, ip2, B, :path)
    arc2r(O, B, A, :path)
    closepath()
    do_action(action)
end
setopacity(0.5)
eg(a) = egg(150, a)
sethue("gold")
eg(:fill)
eg(:clip)
gsave()
   for i in 360:-4:1
       sethue(Colors.HSV(i, 1.0, 0.8))
       rotate(π/30)
       ngon(O, i, 5, 0, action = :stroke)
   end
grestore()
clipreset()
sethue("red")
eg(:stroke)
finish()
```
![clip example](../assets/figures/tutorial-egg-10.png)

It's good practice to add a matching [`clipreset`](@ref) after the clipping has been completed. Unbalanced clipping can lead to unpredictable results.

Good luck with your explorations!

# Polygons and paths

For drawing shapes, Luxor provides polygons and paths.

A polygon is an ordered collection of Points stored in an array. To draw a polygon, you can use the [`poly()`](@ref) function, which converts the points to a path.

A path is a sequence of one or more straight and curved (circular arc or Bézier curve) segments. Paths can consist of subpaths. Luxor maintains a 'current path', to which you can add lines and curves until you finish with a stroke or fill instruction.

You can store a path in a Path type, which contains path elements.

Luxor also provides a BezierPath type, which is an array of four-point tuples, each of which is a Bézier cubic curve section.

|create                        |convert                    |draw                     |info                      |edit                        |
|:---                          |:---                       |:---                     |:---                      |:---                        |
| *polygons*                   |                           |                         |                          |                            |
|[`ngon`](@ref)                |[`polysmooth`](@ref)       |[`poly`](@ref)           |[`isinside`](@ref)        |[`simplify`](@ref)          |
|[`ngonside`](@ref)            |[`polytopath`](@ref)       |[`prettypoly`](@ref)     |[`polyperimeter`](@ref)   |[`polysplit`](@ref)         |
|[`star`](@ref)                |[`polyintersect`](@ref)    |[`polysmooth`](@ref)     |[`polyarea`](@ref)        |[`polyportion`](@ref)       |
|[`polycross`](@ref)           |                           |                         |[`polycentroid`](@ref)    |[`polyremainder`](@ref)     |
|[`offsetpoly`](@ref)          |                           |                         |[`BoundingBox`](@ref)     |[`polysortbyangle`](@ref)   |
|[`hypotrochoid`](@ref)        |                           |                         |[`ispolyclockwise`](@ref) |[`polysortbydistance`](@ref)|
|[`epitrochoid`](@ref)         |                           |                         |[`ispolyconvex`](@ref)    |[`polyclip`](@ref)          |
|[`polyrotate!`](@ref)         |                           |                         |[`ispointonpoly`](@ref)   |[`polymove!`](@ref)         |
|[`polyfit`](@ref)             |                           |                         |[`polysidelengths`](@ref) |[`polyscale!`](@ref)        |
|[`polyhull`](@ref)            |                           |                         |                          |[`polyreflect!`](@ref)      |
|[`polysuper`](@ref)           |                           |                         |                          |[`polysample`](@ref)        |
|[`polybspline`](@ref)         |                           |                         |                          |[`polytriangulate`](@ref)   |
|                              |                           |                         |                          |[`insertvertices!`](@ref)   |
|                              |                           |                         |                          |[`polymorph`](@ref)         |
|                              |                           |                         |                          |                            |
|                              |                           |                         |                          |                            |
| *paths*                      |                           |                         |                          |                            |
|[`storepath`](@ref)           |                           |                         |                          |                            |
|[`getpath`](@ref)             |[`pathtopoly`](@ref)       |[`drawpath`](@ref)       |[`pathlength`](@ref)      |[`pathsample`](@ref)        |
|[`getpathflat`](@ref)         |                           |                         |                          |                            |
| *Bezier paths*               |                           |                         |                          |                            |
|[`makebezierpath`](@ref)      |[`pathtobezierpaths`](@ref)|[`drawbezierpath`](@ref) |                          |[`trimbezier`](@ref)        |
|[`pathtobezierpaths`](@ref)   |[`bezierpathtopoly`](@ref) |[`brush`](@ref)          |                          |[`splitbezier`](@ref)       |
|`BezierPath`                  |[`bezierpathtopath`](@ref) |[`bezigon`](@ref)        |                          |                            |
|`BezierPathSegment`           |                           |                         |                          |                            |
|[`beziersegmentangles`](@ref) |                           |                         |                          |                            |

## Regular polygons ("ngons")

A polygon is an array of points. The points can be joined with straight lines.

You can make regular polygons — from triangles, pentagons, hexagons, septagons, heptagons, octagons, nonagons, decagons, and on-and-on-agons — with [`ngon`](@ref).

```@example
using Luxor, Colors # hide
Drawing(700, 600, "../assets/figures/n-gon.png") # hide

origin() # hide
background("white") # hide
cols = distinguishable_colors(10)
setline(2)
fontsize(12)
tiles = Tiler(700, 600, 3, 3)

for (pos, n) in tiles
    @layer begin
        translate(pos)

        plist = ngon(Point(0, 0), 80, n, vertices=true)

        sethue(cols[n])

        poly(plist, action=:fill, close=true)
        sethue("grey10")
        poly(plist, action=:stroke, close=true)

        circle(Point(0, 0), 4, action=:fill)

        label.([string(i) for i in 1:n], slope.(O, plist), plist, offset=5)
    end
end

finish() # hide

nothing # hide
```

The initial orientation of the polygon defaults to 0.

![n-gons](../assets/figures/n-gon.png)

If you want to specify the side length rather than the circumradius, use [`ngonside`](@ref).

```@example
using Luxor # hide
Drawing(500, 600, "../assets/figures/ngonside.png") # hide
background("white") # hide
origin() # hide

setline(2) # hide
for i in 20:-1:3
    sethue(i/20, 0.5, 0.7)
    ngonside(Point(0, 0), 75, i, 0, action = :fill)
    sethue("grey10")
    ngonside(Point(0, 0), 75, i, 0, action = :stroke)
end

finish() # hide
nothing # hide
```

![stars](../assets/figures/ngonside.png)

The functions return the vertices, or you can use the `vertices=true` option.

```@example
using Luxor # hide
Drawing() # hide
ngon(Point(0, 0), 10, 5)
```

## Polygons

Use [`poly`](@ref) to draw lines connecting the points and/or just fill the area:

```@example
using Luxor, Random # hide
Drawing(600, 250, "../assets/figures/simplepoly.png") # hide
background("white") # hide
Random.seed!(42) # hide
origin() # hide
sethue("orchid4") # hide
tiles = Tiler(600, 250, 1, 2, margin=20)
tile1, tile2 = collect(tiles)

randompoints = [Point(rand(-100:100), rand(-100:100)) for i in 1:10]

gsave()
translate(tile1[1])
poly(randompoints, action = :stroke)
grestore()

gsave()
translate(tile2[1])
poly(randompoints, action = :fill)
grestore()

finish() # hide
nothing # hide
```

![simple poly](../assets/figures/simplepoly.png)

### Holes

To form a hole in a polygon, you reverse the direction of the hole compared to the outer shape. When converted to paths (which happens as part of the drawing process), the reversed polygon forms a hole when drawn.

In this example, the first nut is made by reversing the list of points, the second by using the keyword argument when constructing the shape, and the third when drawing the polygon as a path.

```@example
using Luxor # hide
d = Drawing(600, 300, :svg) # hide
background("antiquewhite") # hide
origin() # hide

# nut 1

translate(-100, 0)

nut = ngon(O, 120, 6, vertices=true)
hole = reverse(ngon(O, 70, 6, vertices=true))

poly.((nut, hole), action = :path)
fillpath()

# nut 2

translate(100, 0)

sethue("purple")
nut = ngon(O, 120, 6, vertices=true)
hole = ngon(O, 70, 6, reversepath=true, vertices=true)

poly(nut, action = :path)
poly(hole, action = :path)
fillpath()

# nut 3

translate(100, 0)

sethue("orange")
nut = ngon(O, 120, 6, vertices=true)
hole = ngon(O, 70, 6, vertices=true)

poly(nut, action = :path)
newsubpath()
poly(hole, reversepath=true, action = :path)
fillpath()

finish() # hide
d # hide
```

### Fill rule

You can have more control over the hole business by using the `setfillrule()` function. This allows you to set the fill rule for subpaths to either `:winding` or `:even_odd`. The fill rule is used to select how paths that contain subpaths are filled. The default rule (which determines the behaviour we usually see for the current drawing) is `:winding`.

See the wikipedia entry for [Even–odd_rule](https://en.wikipedia.org/wiki/Even–odd_rule) for more details.

In the following example, the default `:winding` rule is shown in cyan, on the left, and the `reverse` flag controls whether the subpath is reversed or not. Without it, the boxes would just be drawn on top of each other and you'd just see a big cyan box.

The `:even_odd` rule is shown in operation in magenta, on the right. The results are the same, but the code can be simpler, because `reverse`-ing every other subpath is not required.

```@example
using Luxor # hide
@drawsvg begin # hide
fontsize(69)
panes = Tiler(800, 400, 1, 2)

setfillrule(:winding)
sethue("cyan")

@layer begin
    translate(first(panes[1]))
    let
        reverse = false
        for s in 300:-20:30
            box(O, s, s, reversepath=reverse, :path)
            reverse = !reverse
        end
    end
    fillpath()
end

setfillrule(:even_odd)
sethue("magenta")

@layer begin
    translate(first(panes[2]))
    for s in 300:-20:30
        box(O, s, s, :path)
    end
    fillpath()
end

end 800 400 # hide
```

### Pretty polygons

The [`prettypoly`](@ref) function can place graphics at each vertex of a polygon. After the polygon action, the supplied `vertexfunction` function is evaluated at each vertex. For example, to mark each vertex of a polygon with a randomly-colored circle:

```@example
using Luxor # hide
Drawing(400, 250, "../assets/figures/prettypolybasic.png") # hide
background("white") # hide
origin() # hide
sethue("steelblue4") # hide

apoly = star(O, 70, 7, 0.6, 0, vertices=true)
prettypoly(apoly, action=:fill, () ->
        begin
            randomhue()
            circle(O, 10, action=:fill)
        end,
    close=true)
finish() # hide
nothing # hide
```

![prettypoly](../assets/figures/prettypolybasic.png)

An optional keyword argument `vertexlabels` lets you pass a
function that can number each vertex. The function can use
two arguments, the current vertex number, and the total
number of points in the polygon:

```@example
using Luxor # hide
Drawing(400, 250, "../assets/figures/prettypolyvertex.png") # hide
background("white") # hide
origin() # hide
sethue("steelblue4") # hide

apoly = star(O, 80, 5, 0.6, 0, vertices=true)
prettypoly(apoly,
    :stroke,
    vertexlabels = (n, l) -> (text(string(n, " of ", l), halign=:center)),
    close=true)
finish() # hide
nothing # hide
```

![prettypoly](../assets/figures/prettypolyvertex.png)

Recursive decoration is possible:

```@example
using Luxor, Random # hide
Drawing(400, 260, "../assets/figures/prettypolyrecursive.png") # hide
background("white") # hide
Random.seed!(42) # hide
origin() # hide
sethue("magenta") # hide
setopacity(0.5) # hide

decorate(pos, p, level) = begin
    if level < 4
        randomhue()
        scale(0.25, 0.25)
        prettypoly(p, action = :fill, () -> decorate(pos, p, level+1), close=true)
    end
end

apoly = star(O, 100, 7, 0.6, 0, vertices=true)
prettypoly(apoly, action = :fill, () -> decorate(O, apoly, 1), close=true)
finish() # hide
nothing # hide
```

![prettypoly](../assets/figures/prettypolyrecursive.png)

Polygons can be simplified using the Douglas-Peucker algorithm (non-recursive version), via [`simplify`](@ref).

```@example
using Luxor # hide
Drawing(600, 500, "../assets/figures/simplify.png") # hide
background("white") # hide
origin() # hide
sethue("grey10") # hide
setline(1) # hide
fontsize(20) # hide
translate(0, -120) # hide
sincurve = [Point(6x, 80sin(x)) for x in -5π:π/20:5π]
prettypoly(collect(sincurve), action = :stroke,
    () -> begin
            sethue("red")
            circle(O, 3, action = :fill)
          end)
text(string("number of points: ", length(collect(sincurve))), 0, 100)
translate(0, 200)
simplercurve = simplify(collect(sincurve), 0.5)
prettypoly(simplercurve, action = :stroke,
    () -> begin
            sethue("red")
            circle(O, 3, action = :fill)
          end)
text(string("number of points: ", length(simplercurve)), 0, 100)
finish() # hide
nothing # hide
```
![simplify](../assets/figures/simplify.png)

### Quickly changing polygons

If you want to quickly and permanently modify a polygon, there's [`polymove!`](@ref), [`polyscale!`](@ref), [`polyreflect!`](@ref), and [`polyrotate!`](@ref).

```@example
using Luxor # hide
Drawing(400, 350, "../assets/figures/polychange.png") # hide
origin() # hide

sethue("magenta") # hide
shape = star(O, 10, 5, 0.5, 0, vertices=true)

circle(O, 3, action = :stroke)

polymove!(shape, O, O + (0, 50))

poly(shape, action = :stroke, close=true)

for i in 1:20
    poly(polyrotate!(shape, π/5), action = :fill, close=true)
    polyscale!(shape, 19//18)
end

finish() # hide
nothing # hide
```

The polygon is continually modified (notice the `!` in the function names).

![poly changing](../assets/figures/polychange.png)

```@example
using Luxor, Random # hide
Drawing(400, 350, "../assets/figures/polyreflect.png") # hide
origin() # hide
Random.seed!(34) # hide
setopacity(0.7) # hide
sethue("grey60") # hide
pgon = randompointarray(BoundingBox()/2 ..., 10)
polymove!(pgon, O, Point(-80, 0))
poly(pgon, action = :fill, close=true)
# reflect in y axis:
polyreflect!(pgon, Point(0, 0), Point(0, 100))
sethue("blue")
poly(pgon, action = :fill, close=true)
finish() # hide
nothing # hide
```

![poly reflect](../assets/figures/polyreflect.png)

### Other functions

There are a number of experimental polygon functions. These won't work well for polygons that aren't simple or where the sides intersect each other, but they sometimes do a reasonable job. For example, here's [`polysplit`](@ref):

```@example
using Luxor, Random # hide
Drawing(400, 150, "../assets/figures/polysplit.png") # hide
origin() # hide
setopacity(0.7) # hide
Random.seed!(42) # hide
sethue("grey10") # hide
s = squircle(O, 60, 60, vertices=true)
pt1 = Point(0, -120)
pt2 = Point(0, 120)
line(pt1, pt2, action = :stroke)
poly1, poly2 = polysplit(s, pt1, pt2)
randomhue()
poly(poly1, action = :fill)
randomhue()
poly(poly2, action = :fill)
finish() # hide
nothing # hide
```
![polysplit](../assets/figures/polysplit.png)

### Smoothing polygons

Because polygons can have sharp corners, the experimental [`polysmooth`](@ref) function attempts to insert arcs at the corners and draw the result.

The original polygon is shown in red; the smoothed polygon is shown on top:

```@example
using Luxor, Random # hide
Drawing(600, 250, "../assets/figures/polysmooth.svg") # hide
origin() # hide
background("white") # hide
setopacity(0.5) # hide
Random.seed!(42) # hide
setline(0.7) # hide
tiles = Tiler(600, 250, 1, 5, margin=10)
for (pos, n) in tiles
    p = star(pos, tiles.tilewidth/2 - 2, 5, 0.3, 0, vertices=true)
    sethue("red")
    poly(p, close=true, action = :stroke)
    sethue("grey10")
    polysmooth(p, n * 2, action = :fill)
end

finish() # hide
nothing # hide
```

![polysmooth](../assets/figures/polysmooth.svg)

The final polygon shows that you can get unexpected results if you attempt to smooth corners by more than the possible amount. The `debug=true` option draws the circles if you want to find out what's going wrong, or if you want to explore the effect in more detail.

```@example
using Luxor, Random # hide
Drawing(600, 250, "../assets/figures/polysmooth-pathological.svg") # hide
origin() # hide
background("white") # hide
setopacity(0.75) # hide
Random.seed!(42) # hide
setline(1) # hide
p = star(O, 60, 5, 0.35, 0, vertices=true)
setdash("dot")
sethue("red")
prettypoly(p, close=true, action = :stroke)
setdash("solid")
sethue("grey10")
polysmooth(p, 40, action = :fill, debug=true)
finish() # hide
nothing # hide
```

![polysmooth](../assets/figures/polysmooth-pathological.svg)

## Offsetting polygons

There are three methods for [`offsetpoly`](@ref), a function which
constructs a new polygon that's offset from an existing one.

- `offsetpoly(plist, d)` treats the `plist` of points as a polygon
   with `n` vertices joined by `n` lines with offset `d` on both
   sides.

- `offsetpoly(plist, startoffset=d1, endoffset=d2)` treats
  the `plist` of points as a polyline with `n` vertices
  joined by `n-1` lines, where the offset varies from
  `startoffset` to `endoffset`.

- `offsetpoly(plist, f::function)` applies a function f at
  each vertex of the polyline to determine the width of the
  offset polygon at that point.

The first method is good for making closed shapes larger or smaller.
The other methods are useful for building shapes around an open
linear spine.

#### 1: `n` vertices joined by `n` lines

The `offsetpoly(plist, d)` method constructs a closed
polygon outside or inside an existing polygon, at distance `d`.  The last
vertex in `plist` as assumed to be be connected to the
first.

In the following example, the dotted red polygon is the
original, the black polygons have positive offsets and
surround the original, the cyan polygons have negative
offsets and run inside the original. Use [`poly`](@ref) to draw
the result.

```@example
using Luxor, Random # hide
Drawing(600, 250, "../assets/figures/polyoffset-simple.png") # hide
origin() # hide
background("white") # hide
Random.seed!(42) # hide
setline(1.5) # hide

p = star(O, 45, 5, 0.5, 0, vertices=true)
sethue("red")
setdash("dot")
poly(p, action = :stroke, close=true)
setdash("solid")
sethue("black")

poly(offsetpoly(p, 20), action = :stroke, close=true)
poly(offsetpoly(p, 25), action = :stroke, close=true)
poly(offsetpoly(p, 30), action = :stroke, close=true)
poly(offsetpoly(p, 35), action = :stroke, close=true)

sethue("darkcyan")

poly(offsetpoly(p, -10), action = :stroke, close=true)
poly(offsetpoly(p, -15), action = :stroke, close=true)
poly(offsetpoly(p, -20), action = :stroke, close=true)
finish() # hide
nothing # hide
```

![offset poly 2](../assets/figures/polyoffset-simple.png)

The function is intended for simple cases, and it can go
wrong if pushed too far. Sometimes the offset distances can
be larger than the polygon segments, and things will start
to go wrong. In this example, the offset goes so far
negative that the polygon overshoots the origin, becomes
inverted and starts getting larger again.

![offset poly problem](../assets/figures/polygon-offset.gif)

#### 2: `n` vertices joined by `n-1` lines

The `offsetpoly(plist)` method constructs a polygon around a
line joining the lines in `plist`. At the start of the line,
the polygon will be `startoffset` units on each side; by the
end of the line, the polygon will be `endoffset` units on
each side. The last vertex isn't joined to the first, hence `n-1`.

In the following example, the original spine is drawn in
orange, on top of the black polygon that's constructed to be
offset 2 units on each side at the start and 30 units on
each side at the end.

```@example
using Luxor # hide

Drawing(800, 500, "../assets/figures/polyoffset-open.png") # hide
origin() # hide
background("purple") # hide
setline(2) # hide

spine = [Point(20 + 40x, 15sin(2x)) for x in 0:.1:4π]

for θ in range(0, 2π, step=π/12)
    @layer begin
        sethue("black")
        rotate(θ)
        poly(offsetpoly(spine, startoffset=1, endoffset=30), action = :fill)
        sethue("orange")
        poly(spine, action = :stroke)
    end
end

finish() # hide

nothing # hide
```

![offset poly open](../assets/figures/polyoffset-open.png)

##### Using an offset-control function

This method accepts a keyword argument that allows you to
control the way the offsets are applied, using the easing
functionality built in to Luxor (see [Animation helper functions](@ref)).

By default the function is `lineartween`, so the offset
changes linearly between the `startoffset` and the
`endoffset` values. With other easing functions, this change
is modulated. For example, the `easeinoutquad` function
moves between start and end values using a quadratic motion.

```@example
using Luxor # hide
Drawing(800, 500, "../assets/figures/polyoffset-easing.png") # hide
origin() # hide
background("white") # hide
setline(2) # hide
setlinejoin("round") # hide

spine = between.(O - (200, 0), O + (200, 0), 0:0.025:1)

sethue("red")
prettypoly(spine, action = :stroke)

sethue("black")
pg = offsetpoly(spine, startoffset=0, endoffset=200, easingfunction=easeinoutquad)
prettypoly(pg, action = :stroke, close=true)

finish() # hide
nothing # hide
```

![offset poly easing](../assets/figures/polyoffset-easing.png)

But in the next example, the function `f(t, b, c, d)` (the
Luxor standard four-argument easing function) is defined to run
from 0 to 2 and back again as `t` goes from  0 to 1, so the initial and final offsets
are 'eased' to 0, and at the middle of the polygon the offsets
at that location are 'eased' to 2 × the offset value at that point.

```@example
using Luxor # hide
Drawing(800, 200, "../assets/figures/polyoffset-easing1.png") # hide
origin() # hide
background("white") # hide
setline(2) # hide
setlinejoin("round") # hide

spine = [Point(20x, 15sin(x)) for x in -4π:pi/24:4pi]

f(t, b, c, d) = 2sin(t * π)

pg = offsetpoly(spine, startoffset=1, endoffset=10, easingfunction=f)
sethue("black")
poly(pg, action = :fill)

sethue("white")
poly(spine, action = :stroke)

finish() # hide
nothing # hide
```

![offset poly easing 1](../assets/figures/polyoffset-easing1.png)

#### 3: Applying a function

This method generates offset widths using the supplied function. The value of the supplied function `f` at `f(0, θ)` determines the start offset on each side, and `f(1, θ)` determines the finishing offset on each side. The width at the middle vertex will be `f(0.5, θ)` (on each side). `θ` is provided as the current slope of the polyline at that point.

This example uses a simple sine curve in `f()` to vary the width of the spiral from beginning to end.

```@example
using Luxor, Colors # hide

f(x, θ) =  10 + 40sin(x * π)

@draw begin # hide

spine = spiral(30, 1.3, vertices=true)
ps = polysample(spine, 250, include_first=true, closed=false)
pgon = offsetpoly(ps, f)
poly(pgon, action = :stroke)

setmesh(mesh(box(BoundingBox(pgon)),
    [
    RGB(Luxor.julia_red...),
    RGB(Luxor.julia_blue...),
    RGB(Luxor.julia_green...),
    RGB(Luxor.julia_purple...),
    ]))
poly(pgon, action = :fill)

end # hide
```

### Fitting splines

The experimental [`polyfit`](@ref) function constructs a B-spline that follows the points approximately.

```@example
using Luxor, Random # hide
Drawing(600, 250, "../assets/figures/polyfit.png") # hide
origin() # hide
background("white") # hide
Random.seed!(42) # hide

pts = [Point(x, rand(-100:100)) for x in -280:30:280]
setopacity(0.7)
sethue("red")
prettypoly(pts, () -> circle(O, 5, action = :fill))
sethue("darkmagenta")
poly(polyfit(pts, 200), action = :stroke)

finish() # hide
nothing # hide
```

![offset poly](../assets/figures/polyfit.png)

There is also the [`polybspline`](@ref) function, which constructs a B-spline curve based on the control points and desired degree with the option of being unclamped.

```@example
using Luxor, Random # hide
Drawing(600, 250, "../assets/figures/polyfit.png") # hide
origin() # hide
background("white") # hide
Random.seed!(42) # hide

pts = [Point(x, rand(-100:100)) for x in -280:30:280] # hide
setopacity(0.7) # hide
sethue("red") # hide
prettypoly(pts, () -> circle(O, 5, action = :fill)) # hide
sethue("darkmagenta") # hide
poly(polybspline(pts, 200; degree = 5), action = :stroke)

finish() # hide
nothing # hide
```

![B-Spline](../assets/figures/polybspline.png)

## Converting paths to polygons

You can convert the current path to an array of polygons, using [`pathtopoly`](@ref).

In the next example, the path consists of a number of paths, some of which are subpaths, which form the holes.

```@example
using Luxor # hide
Drawing(800, 300, "../assets/figures/path-to-poly.png") # hide
background("white") # hide
origin() # hide
fontsize(60) # hide
translate(-300, -50) # hide
textpath("get polygons from paths")
plist = pathtopoly()
setline(0.5) # hide
for (n, pgon) in enumerate(plist)
    randomhue()
    prettypoly(pgon, action = :stroke, close=true)
    gsave()
    translate(0, 100)
    poly(polysortbyangle(pgon, polycentroid(pgon)), action = :stroke, close=true)
    grestore()
end
finish() # hide
nothing # hide
```

![path to polygon](../assets/figures/path-to-poly.png)

The [`pathtopoly`](@ref) function calls [`getpathflat`](@ref) to convert the current path to an array of polygons, with each curved section flattened to line segments.

The [`getpath`](@ref) function gets the current path as an array of elements, lines, and unflattened curves.

## Bezigons

A bezigon is like a polygon, but the sides can be Bézier paths instead of straight lines. Supply the corners and sides to the [`bezigon`](@ref) function.

```@example
using Luxor, Colors # hide
@drawsvg begin # hide
background("grey10") # hide
corners = [Point(10, 0), Point(200, 0)]
sides = [
    [Point(70, -40), Point(150, -50)],
    [Point(150, 50), Point(70, 40)],
]
for i in 1:10
    sethue(HSV(36i, .7, .7))
    rotate(2π / 10)
    bezigon(corners, sides, :fill)
end
sethue("white")
circle.([corners..., sides[1]..., sides[2]...], 7, :fill)
end 600 400 # hide
```

## Polygons to Bézier paths and back again

Use the [`makebezierpath`](@ref) and [`drawbezierpath`](@ref) functions to make and draw Bézier paths, and [`pathtobezierpaths`](@ref) to convert the current path to an array of Bézier paths.

A BezierPath type contains a sequence of `BezierPathSegment`s; each curve segment is defined by four points: two end points and their control points.

```julia
    (Point(-129.904, 75.0),        # start point
     Point(-162.38, 18.75),        # ^ control point
     Point(-64.9519, -150.0),      # v control point
     Point(-2.75546e-14, -150.0)), # end point
    (Point(-2.75546e-14, -150.0),
     Point(64.9519, -150.0),
     Point(162.38, 18.75),
     Point(129.904, 75.0)),
    (Point(129.904, 75.0),
     Point(97.4279, 131.25),
     Point(-97.4279, 131.25),
     Point(-129.904, 75.0)
     ),
     ...
```

Bézier paths are different from ordinary paths in that they don't usually contain straight line segments. However, by setting the two control points to be the same as their matching start/end points, you create straight line sections.

[`makebezierpath`](@ref) takes the points in a polygon and converts each line segment into one Bézier curve. [`drawbezierpath`](@ref) draws the resulting sequence.

```@example
using Luxor # hide
Drawing(600, 320, "../assets/figures/abezierpath.png") # hide
background("white") # hide
origin() # hide
setline(1.5) # hide
setgray(0.5) # hide
pts = ngon(O, 150, 3, pi/6, vertices=true)
bezpath = makebezierpath(pts)
poly(pts, action = :stroke)
for (p1, c1, c2, p2) in bezpath[1:end-1]
    circle.([p1, p2], 4, action = :stroke)
    circle.([c1, c2], 2, action = :fill)
    line(p1, c1, action = :stroke)
    line(p2, c2, action = :stroke)
end
sethue("black")
setline(3)
drawbezierpath(bezpath, action = :stroke, close=false)
finish() # hide
nothing # hide
```
![path to polygon](../assets/figures/abezierpath.png)

```@example
using Luxor, Random # hide
Drawing(600, 320, "../assets/figures/bezierpaths.png") # hide
background("white") # hide
origin() # hide
Random.seed!(3) # hide
tiles = Tiler(600, 300, 1, 4, margin=20)
for (pos, n) in tiles
    @layer begin
        translate(pos)
        pts = polysortbyangle(
                randompointarray(
                    Point(-tiles.tilewidth/2, -tiles.tilewidth/2),
                    Point(tiles.tilewidth/2, tiles.tilewidth/2),
                    4))
        setopacity(0.7)
        sethue("black")
        prettypoly(pts, action = :stroke, close=true)
        randomhue()
        drawbezierpath(makebezierpath(pts), action = :fill)
    end
end
finish() # hide
nothing # hide
```
![path to polygon](../assets/figures/bezierpaths.png)

You can convert a Bézier path to a polygon (an array of points), using the [`bezierpathtopoly`](@ref) function. This chops up the curves into a series of straight line segments. An optional `steps` keyword lets you specify how many line segments are used to approximate each Bézier segment.

In this example, the original star is drawn in a dotted gray line, then converted to a Bézier path (drawn in orange), then the Bézier path is converted (with low resolution) to a polygon but offset by 20 units before being drawn (in blue).

```@example
using Luxor, Random # hide
Drawing(600, 600, "../assets/figures/bezierpathtopoly.png") # hide
background("white") # hide
origin() # hide
Random.seed!(3) # hide

pgon = star(O, 250, 5, 0.6, 0, vertices=true)

@layer begin
    setgrey(0.5)
    setdash("dot")
    poly(pgon, action = :stroke, close=true)
    setline(5)
end

setline(4)

sethue("orangered")

np = makebezierpath(pgon)
drawbezierpath(np, action = :stroke)

sethue("steelblue")
p = bezierpathtopoly(np, steps=3)

q1 = offsetpoly(p, 20)
prettypoly(q1, action = :stroke, close=true)

finish() # hide
nothing # hide
```
![path to polygon](../assets/figures/bezierpathtopoly.png)

You can convert the current path to an array of BezierPaths using the [`pathtobezierpaths`](@ref) function.

In the next example, the letter "a" is placed at the current position (set by [`move`](@ref)) and then converted to an array of Bézier paths. Each Bézier path is drawn first of all in gray, then the control points of segment are drawn (in orange) showing how they affect the curvature.

```@example
using Luxor # hide
Drawing(600, 400, "../assets/figures/pathtobezierpaths.png") # hide
background("ivory") # hide
origin() # hide
st = "a"
thefontsize = 500
fontsize(thefontsize)
sethue("red")
tex = textextents(st)
move(-tex[3]/2, tex[4]/2)
textpath(st)
nbps = pathtobezierpaths()
setline(1.5)
for nbp in nbps
    sethue("grey80")
    drawbezierpath(nbp, action = :stroke)
    for p in nbp
        sethue("darkorange")
        circle(p[2], 2.0, action = :fill)
        circle(p[3], 2.0, action = :fill)
        line(p[2], p[1], action = :stroke)
        line(p[3], p[4], action = :stroke)
        if p[1] != p[4]
            sethue("black")
            circle(p[1], 2.0, action = :fill)
            circle(p[4], 2.0, action = :fill)
        end
    end
end
finish() # hide
nothing # hide
```

![path to polygon](../assets/figures/pathtobezierpaths.png)

[`beziersegmentangles`](@ref) lets you define a Bézier path segment by specifying the angles the control handles make with the base line.

```@example
using Luxor # hide

Drawing(600, 400, "../assets/figures/beziersegmentangles.svg") # hide
background("ivory") # hide
origin() # hide

setline(0.5)

@layer begin
    rule.(O, (0, (π / 2)))
end

P = O
Q = O + (200, 0)
sethue("black")

pts = beziersegmentangles(P, Q,
    out=deg2rad(60),
    in=2π - deg2rad(45))

@layer begin
    setline(2)
    sethue("purple")
    drawbezierpath(pts, action=:stroke)
end

sethue("grey50")
line(O, pts[2], action=:stroke)
line(Q, pts[3], action=:stroke)
fontsize(15)
circle.((P, pts[2], pts[3], Q), 5, action=:fill)
label.(("P", "Q"), Ref(:ne), (P, Q))
text("60°", P + (40, 20))
text("135°", Q + (10, 20))
finish() # hide
nothing # hide
```

![bezier segment angles](../assets/figures/beziersegmentangles.svg)

There are some functions that can modify Bezier path segments. For example, [`trimbezier`](@ref) chops portions off each end:

```@example
using Luxor # hide
d = Drawing(600, 400, :svg) # hide
background("ivory") # hide
origin() # hide

setline(2)

bez  = BezierPathSegment(ngon(O, 150, 4, vertices=true)...)
drawbezierpath(bez, action = :stroke)

setopacity(0.4)
sethue("red")
setline(20)
trimbez = trimbezier(bez, 0.2, 0.8)
drawbezierpath(trimbez, action = :stroke)

setline(40)
sethue("purple")
trimbez = trimbezier(trimbez, 0.2, 0.8)
drawbezierpath(trimbez, action = :stroke)

finish() # hide
d # hide
```

When working with Bézier curves it's usual to consider the curve in terms of a parameter `t` going from 0.0 to 1.0.

[`splitbezier`](@ref) can split a segment into two shorter segments.

## Brush strokes

The [`brush`](@ref) function builds Bezier paths in a quasi-random fashion, that could look like brush strokes. The optional keyword arguments allow a range of different effects.

You can pass a function that can adjust various drawing settings before the shapes are drawn.

```@example
using Luxor, Random # hide

brushα(nbpb) = begin
    setline(1)
    setopacity(0.3)
    drawbezierpath(nbpb, action = :stroke)
    sethue(0.2, 0.3, rand(0.3:0.01:0.65))
    return nbpb
end

function numberit(pos, n)
    @layer begin
        sethue("black")
        text(string(n), pos)
    end
end

Drawing(800, 700, "../assets/figures/brush1.png") # hide
origin() # hide
background("white") # hide
Random.seed!(42) # hide
t = Tiler(800, 700, 5, 1)
sethue("orange3")
fontsize(20)
for (pos, n) in t
    start, finish = pos - (200, 0), pos + (200, 0)
    if n == 1
        # five brush strokes
        brush(start, finish, 1)
        numberit(pos, n)
    elseif n == 2
        # minwidth and maxwidth control the, er, width
         brush(start, finish, 5, minwidth = -5, maxwidth = 2)
         numberit(pos, n)
    elseif n == 3
        # dont have to have transparent strokes
         brush(start, finish, 20, minwidth = .2, randomopacity = false)
         numberit(pos, n)
    elseif n == 4
        # twist and adjust handles to taste
         brush(start, finish, minwidth = -.1, maxwidth = .2,
             twist = 2, highhandle = 2, tidystart=false)
         numberit(pos, n)
    elseif n == 5
        # call a function to modify each stroke
        brush(start, finish, 1, minwidth = -2.2, maxwidth = .8,
            lowhandle = -.4, highhandle = 1.5, twist = .5,
            strokefunction = brushα)
        numberit(pos, n)
    end
end
finish() # hide
nothing # hide
```

![brush 1](../assets/figures/brush1.png)

For more information (and more than you probably wanted to know) about Luxor's Bézier paths, visit [https://cormullion.github.io/pages/2018-06-20-bezier/](https://cormullion.github.io/pages/2018-06-20-bezier/).

## Polygon information

`polyperimeter` calculates the length of a polygon's perimeter.

```@example
using Luxor, Random # hide

Drawing(600, 250, "../assets/figures/polyperimeter.png") # hide
origin() # hide
background("white") # hide
Random.seed!(42) # hide
setline(1.5) # hide
sethue("black") # hide
fontsize(20) # hide
p = box(O, 50, 50, vertices=true)
poly(p, action = :stroke)
text(string(round(polyperimeter(p, closed=false))), O.x, O.y + 60)

translate(200, 0)

poly(p, action = :stroke, close=true)
text(string(round(polyperimeter(p, closed=true))), O.x, O.y + 60)

finish() # hide
nothing # hide
```

![polyperimeter](../assets/figures/polyperimeter.png)

To find the "left-most" point, ie the point with the lowest x coordinate, you can use built-in `extrema()` function, to return the left-most and right-most points. (This is because, when you compare points, the x coordinate is tested first.) To find the "lowest" points, ie the points with the lowest y value, you could find the y extrema and use it to find the index:

```julia
findfirst(pt -> isequal(pt.y, first(extrema(pt -> pt.y, pts))), pts)
# 13
```

### Point inside polygon

The [`isinside`](@ref) function returns true if a point is inside a polygon.

```@example
using Luxor # hide

Drawing(500, 500, "../assets/figures/isinside.png") # hide

background("white") # hide

origin() # hide

apolygon = star(O, 200, 8, 0.5, 0, vertices=true)
for pt in collect(first.(Table(30, 30, 15, 15)))
    sethue(noise(pt.x/600, pt.y/600), noise(pt.x/300, pt.y/300), noise(pt.x/250, pt.y/250))
    isinside(pt, apolygon, allowonedge=true) ?
        circle(pt, 8, action = :fill) : circle(pt, 3, action = :fill)
end

finish() # hide

nothing # hide
```

![isinside](../assets/figures/isinside.png)

### Convex hull

A convex hull of a polygon is the subset of points such that, when connected with straight lines, the resulting shape contains every point of the polygon.

Use [`polyhull`](@ref) to find the convex hull of an array of points.

This code obtains all the points in the Julia logo's circles, combines them into a single array, and then calculates the convex hull that encloses them all.

```@example
using Luxor # hide

d = Drawing(800, 500, :svg) # hide

origin() # hide

setline(4)

juliacircles(130) # draw in color

# get all the points
juliacircles(130, action=:path)
points = collect(Iterators.flatten(vcat(pathtopoly())))

hull = polyhull(points)

sethue("gold2")

prettypoly(hull, close=true, action = :stroke)

finish() # hide

d # hide
```

## Polygon selection and modification

There are Luxor functions to return the first part or last part of a polygon. You can also ask for a resampling of a polygon, choosing either to increase the number of points (which places new points to the "lines" joining the vertices) or decrease them (which changes the shape of the polygon). It's also possible to insert vertices automatically.

[`polyportion`](@ref) and [`polyremainder`](@ref) return part of a polygon depending on the fraction you supply. For example, `polyportion(p, 0.5)` returns the first half of polygon `p`, `polyremainder(p, .75)` returns the last quarter of it.

```@example
using Luxor, Random # hide

Drawing(600, 250, "../assets/figures/polyportion.png") # hide

origin() # hide

background("white") # hide

Random.seed!(42) # hide

setline(1.5) # hide

sethue("black") # hide

fontsize(20) # hide

p = ngon(O, 100, 7, 0, vertices=true)
poly(p, action = :stroke, close=true)
setopacity(0.75)

setline(20)
sethue("red")
poly(polyportion(p, 0.25), action = :stroke)

setline(10)
sethue("green")
poly(polyportion(p, 0.5), action = :stroke)

setline(5)
sethue("blue")
poly(polyportion(p, 0.75), action = :stroke)

setline(1)
circle(polyremainder(p, 0.75)[1], 5, action = :stroke) # first point

finish() # hide
nothing # hide
```

![polyportion](../assets/figures/polyportion.png)

You can insert vertices in the edges of a polygon with [`insertvertices!`](@ref). For example, this code inserts a new vertex into each side of a polygon five times. The polygon ends up with 128 vertices.

```@example
using Luxor # hide

Drawing(600, 250, "../assets/figures/insertvertices.png") # hide

origin() # hide

background("white") # hide

setline(1) # hide

sethue("black") # hide

pts = box(O, 500, 200, vertices=true)
prettypoly(pts, action = :stroke, close=true)

for i in 1:5
    insertvertices!(pts)
    prettypoly(pts, action = :stroke, close=true)
    fontsize(16)
    label(string(length(pts)), :ne, pts[1], offset=10)
    scale(0.8)
end

finish() # hide
nothing # hide
```

![poly insert vertices](../assets/figures/insertvertices.png)

To resample a polygon, use [`polysample`](@ref). In this example, the same four-sided polygon is resampled at multiples of 4, with different circle radii at each multiple. This adds more points to the new copy of the original polygon.

```@example
using Luxor # hide

Drawing(600, 250, "../assets/figures/polysample.png") # hide
origin() # hide
background("white") # hide
setline(1) # hide
sethue("black") # hide

pts = ngon(O, 100, 4, vertices=true)
for (n, npoints) in enumerate(reverse([4, 8, 16, 32, 48]))
    prettypoly(polysample(pts, npoints),
        :stroke, close=true,
        () -> begin
                circle(O, 2n, action = :stroke)
              end)
end

finish() # hide
nothing # hide
```

![polysampling](../assets/figures/polysample.png)

There is a `closed` option, which determines whether or not the final edge (the one that would join the final vertex to the first), is included in the sampling. In the following example, the original polygon is drawn in black, then sampled as a closed polygon (in blue), then as a non-closed one (magenta).

```@example
using Luxor # hide
Drawing(600, 250, "../assets/figures/polysample2.png") # hide
origin() # hide
background("white") # hide
setline(1) # hide
sethue("black") # hide
fontsize(8) # hide

translate(0, -50) # hide
setline(1) # hide
sethue("black") # hide

# original polygon

numbervertices(l, n) = label(string(l), :N, O)
drawvertices() = ngon(O, 3, 4, 0, action = :fill)

pts = [Point(30x, 20sin(x)) for x in -2π:π/6:2π]

# 1: drawn as defined

prettypoly(pts, action = :stroke, drawvertices, vertexlabels = numbervertices)

translate(0, 50)


# 2: resampled as closed

npoints = 40

sethue("cornflowerblue")
prettypoly(polysample(pts, npoints, closed=true), action = :stroke, drawvertices,
    vertexlabels = numbervertices)

translate(0, 50)

# 3: resampled as open

sethue("magenta")
prettypoly(polysample(pts, npoints, closed=false), action = :stroke, drawvertices,
    vertexlabels = numbervertices)


finish() # hide
nothing # hide
```

![polysampling 2](../assets/figures/polysample2.png)

!!! note

    In Luxor, you'll meet `close` and `closed` options.
    `close` is an instruction to path-drawing functions,
    that says "join the most recent point to the first
    point". Whereas, `closed` is an indication that the
    polygons or paths should be treated as being closed
    rather than open, ie whether that last segment joining
    the end point to the first is used for calculations.

### Polygon sides

`polydistances` returns an array of the accumulated side lengths of a polygon. `polysidelengths()` returns an array of the side lengths without summing them.

```julia-repl
julia> p = ngon(O, 100, 7, 0, vertices=true);
julia> polydistances(p)
8-element Vector{Float64}:
   0.0
  86.77674782351163
 173.55349564702325
 260.33024347053487
 347.10699129404645
 433.8837391175581
 520.6604869410697
 607.4372347645814

julia> polysidelengths(p)
7-element Vector{Float64}:
 86.77674782351163
 86.77674782351163
 86.77674782351161
 86.77674782351161
 86.77674782351163
 86.77674782351161
 86.77674782351166

julia> sum(polysidelengths(p))
607.4372347645814
```

`polydistances()` is used by [`polyportion`](@ref) and [`polyremainder`](@ref), and you can pre-calculate and pass them to these functions via keyword arguments for performance. By default the result includes the final closing segment (`closed=true`).

These functions also make use of the [`nearestindex`](@ref), which returns a tuple of: the index of the nearest value in an array of distances to a given value; and the excess value.

In this example, we want to find a point halfway round the perimeter of a triangle. Use [`nearestindex`](@ref) to find the index of the nearest vertex (`nidx`, 2), and the surplus length, (`over`, 100).

```@example
using Luxor # hide
Drawing(650, 250, "../assets/figures/nearestindex.png") # hide
origin() # hide
background("white") # hide

sethue("black") # hide
setline(0.5) # hide

p = ngonside(O, 200, 3, vertices=true)
prettypoly(p, action = :stroke, close=true,
    vertexlabels = (n, l) -> label(string(n), :NW, offset=10))

# distances array
da = polydistances(p)

nidx, over = nearestindex(da, polyperimeter(p)/2)

sethue("red")
circle(p[nidx], 5, action = :stroke)

arrow(p[nidx],
      between(p[nidx], p[nidx+1], over/distance(p[nidx], p[nidx+1])),
      linewidth=2)

finish() # hide
nothing # hide
```

![nearestindex](../assets/figures/nearestindex.png)

Of course, it's much easier to do `polyportion(p, 0.5)`.

### Area of polygon

Use [`polyarea`](@ref) to find the area of a polygon. Of course, this only works for simple polygons; polygons that intersect themselves or have holes are not correctly processed.

This code draws some regular polygons and calculates their area, perimeter, and shows how near the ratio of perimeter over radius approaches 2π.

```@example
using Luxor # hide

Drawing(650, 500, "../assets/figures/polyarea.png") # hide

origin() # hide
background("white") # hide
fontsize(13) # hide
fontface("Georgia")
sethue("black")
setline(0.25)
outerframe = Table([500], [400, 200])
total = 30
properties = Table(fill(15, total), [20, 85, 85], outerframe[1, 2])
radius = 55
sethue("grey20")
for i in 3:total
    global radius
    text(string(i), properties[i, 1], halign=:right)
    p = ngon(outerframe[1], radius, i, 0, vertices=true)
    prettypoly(p, action = :stroke, close=true, () -> (sethue("red"); circle(O, 2, action = :fill)))
    pa = polyarea(p)
    pp = polyperimeter(p)
    ppoverradius = pp/radius
    text(string(Int(round(pa, digits=0))), properties[i, 2], halign=:left)
    text(string(round(ppoverradius, digits=6)), properties[i, 3], halign=:left)
    radius += 5
end

fontsize(10)
[text(["Sides", "Area", "Perimeter/Radius"][n], pt, halign=:center)
    for (pt, n) in Table([20], [20, 85, 85], outerframe[2] - (0, 220))]

finish() # hide
nothing # hide
```

![poly area](../assets/figures/polyarea.png)

## Morphing polygons

"morph" means to make one thing turn into another. The experimental [`polymorph`](@ref) function can gradually turn one polygon into another.

You supply two polygons and a value between 0 and 1. For example, if the value is 0.5, the shape is about halfway between the two polygons.

!!! note
    `polymorph()` always returns an array of polygons. Arguments can be arrays of polygons, or single polygons.

By default, the polygons are assumed to be closed, suitable for filling.

```@example
using Luxor, Colors # hide

@drawsvg begin # hide
background("grey10") # hide

fromshape = ngon(O, 50, 4, vertices=true)
toshape = ngon(O, 350, 4, π/4, vertices=true)

setline(8)
for i in range(0, 1, length=10)
    sethue(HSB(360i, 0.8, 0.8))
    morph = polymorph(fromshape, toshape, i)
    for p in morph
        poly(p, close=true, action=:stroke)
    end
end
end 800 600 # hide
```

In the next example, each of the two wavy-line polygons are open rather than closed, so you can pass `false` values to the `closed` argument, and the polygons won't be treated as closed shapes.

```@example
using Luxor # hide

@drawsvg begin # hide
background("grey10") # hide
setline(1.5) # hide
rotate(π/2)
fromshape = [Point(90x, -230 + 50sin(3x)) for x in range(-π, π, length=250)]
toshape = [Point(90x, 230 + 50sin(-3x)) for x in range(-π, π, length=250)]
for i in 0:0.03:1
    sethue(1 - i, i/4 + 0.2, 1 - i/4)
    morph = polymorph(fromshape, toshape, i,
        easingfunction=easeinoutcubic,
        closed=(false, false))
    poly(first(morph), action = :stroke)
end
end # hide
```

Sometimes polygons consist of two or more loops - this is how holes work. So `polymorph()` accepts both simple polygons and arrays of polygons, but always returns an array of polygons.

`polymorph()` accepts easing functions that determine the 'speed' and 'acceleration' of the changes. These are the same functions that are described in more detail in the Animation section, [Easing-functions](@ref). In the previous example, the `easeinoutcubic` function made the earlier and later changes small (lines closer together), but the changes at the middle of the morph were larger.

Here are all the easing functions used to `polymorph()` between two polygons:

```@example
using Luxor, Colors # hide

@drawsvg begin # hide
background("grey10")
setline(1)
w, h = 450, 20
a = [[Point(-w / 2, -h / 2), Point(-w / 2, 0), Point(-w / 2, h / 2)]]
b = [[Point(w / 2, -h / 2), Point(w / 2, 0), Point(w / 2, h / 2)]]
translate(boxtopcenter() + (50, 30))
for (i, ef) in enumerate(Luxor.easingfunctions)
    sethue(HSB(12i, .7, .8))
    for i in range(0, 1, length=20)
        pm = polymorph(a, b, i, easingfunction=ef)
        poly(pm[1], :stroke)
    end
    sethue("white")
    text(string(ef), Point(-w/2 - 20, 0), halign=:right, valign=:middle)
    translate(0, 22)
end
end # hide
```

In the next example, `fromshape`, the circle, is an array holding a single vector of Points (`pathtopoly()` returns an array of polygons), and `toshape`, the line, is a simple vector of points (the minimum of three points). In this case, with just simple polygons, only the first element of the result of the `polymorph()` function is needed.

```@example
using Luxor # hide
@drawsvg begin # hide
background("grey10") # hide
setline(0.5) # hide
circlepath(O, 200, action = :path)
fromshape = pathtopoly()
toshape = [Point(0, -250), O, Point(0, 250)] # minimum of 3
for i in 0:0.015:1
    sethue(i, 1 - i, i/2 + 0.5)
    morph = polymorph(fromshape, toshape, i, easingfunction=easeinoutsine)
    poly(first(morph), action = :stroke, close=true)
end
end # hide
```

In the next example, a square morphs into a hexagon.

```@example
using Luxor # hide

@drawsvg begin # hide
background(0.15, 0.15, 0.1) # hide
pgon1 = ngon(O, 80, 4,  vertices = true)
pgon2 = ngon(O, 270, 6, vertices = true)
sethue("cyan")
setline(1)
for i in 0:0.05:1.0
    sethue(i, 1 - i, 0.5)
    poly(first(polymorph(pgon1, pgon2, i)),
        action = :stroke,
        close = true)
end
end 600 600 # hide
```

In the next example, an octagon with a square hole morphs into a square with an octagonal hole.

```@example
using Luxor # hide

@drawsvg begin # hide
background(0.15, 0.15, 0.1) # hide
# build first polygon
ngon(O + (-350, 0), 40, 8, π, action = :path)
newsubpath()
box(O + (-350, 0), 30, 30, reversepath=true, action = :path)
pgon1 = pathtopoly()

# build second polygon
newpath()
box(O + (350, 0), 60, 60, action = :path)
newsubpath()
ngon(O + (350, 0), 20, 8, π, reversepath=true, action = :path)
pgon2 = pathtopoly()

# draw morphs
sethue("cyan")
setline(1)
for i in 0:0.1:1.0
    sethue(i, 1 - i, 0.5)
    poly.(polymorph(pgon1, pgon2, i),
        action=:path,
        close=true)
    fillpath()
end
end 850 250 # hide
```

Because both polygons have reversed subpaths (holes), the polygons should be drawn using `:path` and `fillpath()`.

The next example animates a morph between two programming languages.

```julia
using Luxor, Colors # hide

function frame(scene, framenumber)
    background("grey10")

    fontface("JuliaMono")
    fontsize(120)

    textoutlines("", O + (0, 0), halign=:center, valign=:middle)
    python_logo = pathtopoly()

    textoutlines("", O + (0, 0), halign=:center, valign=:middle)
    julia_logo = pathtopoly()

    fontface("WorkSans-Black")
    fontsize(130)
    textoutlines("Python", O + (0, -100), halign=:center, valign=:middle, action = :path)
    fromtext = pathtopoly()

    textoutlines("Julia", O + (0, 100), halign=:center, valign=:middle, action = :path)
    totext   = pathtopoly()

    newpath()
    sethue("cyan")

    eased_n = scene.easingfunction(framenumber - scene.framerange.start,
      0, 1, scene.framerange.stop - scene.framerange.start)

    i = sin(eased_n * π)
    poly.(polymorph(fromtext, totext, i, easingfunction=easingflat, samples=200),
        action=:path,
        close=true)
    strokepath()

    pm = polymorph(python_logo, julia_logo, i)
    for p in pm
        poly(p, action = :path)
    end
    fillpath()
end

amovie = Movie(600, 400, "p to j")
animate(amovie,
    Scene(amovie, frame, 1:200,
        easingfunction = easeinoutsine),
    creategif = true,
    pathname = "/tmp/python-julia.gif")
```

![python julia animation](../assets/figures/python-julia.gif)

The "Python" path has 9 loops, whereas "Julia" has 8. The `polymorph()` function tries to work around this - notice how the ninth loop, "n", morphs down to nothing. If you don't want this to happen, set the `kludge` keyword to false. In this particular case, you could increase the number of loops in `totext` to match by using a lower-case "j".

## Other polygon operations

These functions are still in development. Expect varying degrees of success when using them.

[`polyclip()`](@ref) returns the region of a source polygon that lies inside a clipping polygon. In this example, each intersecting piece is created by clipping one of the "circles" with another (each circle is an 80-sided polygon).

```@example
using Luxor, Colors # hide

@drawsvg begin
    background("grey10")

    npoints = 80
    D = 140
    pts = ngon(O, 110, 3, π / 6, vertices=true)

    circle1 = ngon(pts[1], D, npoints, vertices=true)
    circle2 = ngon(pts[2], D, npoints, vertices=true)
    circle3 = ngon(pts[3], D, npoints, vertices=true)

    sethue("cyan"); poly(circle1, :fill)
    sethue("magenta"); poly(circle2, :fill)
    sethue("yellow"); poly(circle3, :fill)

    sethue("blue")
    pc1 = polyclip(circle1, circle2)
    poly(pc1, :fill, close=true)

    sethue("red")
    pc2 = polyclip(circle1, circle3)
    poly(pc2, :fill, close=true)

    sethue("green")
    pc3 = polyclip(circle2, circle3)
    poly(pc3, :fill, close=true)

    pc4 = polyclip(pc1, pc2) # or polyclip(pc1, pc3) ...

    sethue("white")
    poly(pc4, :fill, close=true)
end
```

## Polygon/line Intersections

`intersectlinepoly(pt1, pt2, polygon)` returns an array containing the points where a line from `pt1` to `pt2` crosses the perimeter of the `polygon`.

```@example
using Luxor, Random # hide

Drawing(600, 550, "../assets/figures/linepolyintersections.png") # hide

origin() # hide
background("white") # hide
Random.seed!(5) # hide
setline(0.3)
sethue("thistle")
c = star(O, 120, 7, 0.2, vertices=true)
poly(c, action = :fillstroke, close=true)
for n in 1:15
    pt1 = Point(rand(-250:250, 2)...)
    pt2 = Point(rand(-250:250, 2)...)
    ips = intersectlinepoly(pt1, pt2, c)
    if !isempty(ips)
            sethue("grey20")
            line(pt1, pt2, action = :stroke)
            randomhue()
            circle.(ips, 2, action = :fill)
    else
        sethue("grey80")
        line(pt1, pt2, action = :stroke)
    end
end
finish() # hide
nothing # hide
```

![line/polygon intersections](../assets/figures/linepolyintersections.png)

## Boolean operations with polygons

The functions  [`polyintersect()`](@ref) ,  [`polyunion()`](@ref) ,  [`polydifference()`](@ref) , and [`polyxor()`](@ref) carry out Boolean comparisons of polygons, and return differences or intersections.

- `polyintersect(p1, p2)` finds all polygonal areas that are inside both polygon `p1` and `p2`.

- `polyunion(p1, p2)` finds all polygonal areas that are inside polygon `p1` and/or inside polygon `p2`, or both.

- `polydifference(p1, p2)` finds all polygonal areas that are inside polygon `p1` but not inside polygon `p2`.

- `polyxor(p1, p2)` finds all polygonal areas that are inside polygon `p1`, inside polygon `p2`, but not inside both.

Each command returns an array of polygons, which may contain any number of polygons, including 0.

Documentation for the code run by these functions can be found at the [PolygonAlgorithms.jl](https://github.com/lin/2023/09/30/polygon-clipping.html) page.

### Intersection: polyintersect

Use [`polyintersect()`](@ref) to find the areas where the two polygons intersect.

The returned result is an array of polygons. The number of
polygons in the array depends on how the two polygons intersect - there could be anything from 0 to a lot.

```@example
using Luxor, Colors # hide

@drawsvg begin
    background("grey10")

    sector(O, 50, 100, 0 + π / 8, 2π - π / 8, :path)
    pg1 = pathtopoly()[1]
    pg2 = box(O, 250, 120)

    setopacity(0.6)

    translate(-200, 0)
    sethue("lightpink")
    poly(pg1, :fill)

    sethue("yellowgreen")
    poly(pg2, :fill)

    result = polyintersect(pg2, pg1)

    translate(400, 0)
    for (i, p) in enumerate(result)
        sethue(HSB(30i, 0.9, 0.9))
        poly(p, :fill)
        sethue("grey90")
        poly(p, :stroke, close=true)
    end
end 800 300
```

In case there's no intersection, the returned result is empty: `Vector{Point}[]`.

### Union: polyunion

Use [`polyunion()`](@ref) to find the polygonal areas in either or both of the two polygons.

The returned result is an array of polygons.

```@example
using Luxor, Colors # hide
@drawsvg begin
    background("grey10")

    sector(O, 50, 100, 0 + π / 8, 2π - π / 8, :path)
    pg1 = pathtopoly()[1]
    pg2 = box(O, 250, 120)

    setopacity(0.6)

    translate(-200, 0)
    sethue("lightpink")
    poly(pg1, :fill)

    sethue("yellowgreen")
    poly(pg2, :fill)

    result = polyunion(pg2, pg1)

    translate(400, 0)
    for (i, p) in enumerate(result)
        sethue(HSB(30i, 0.9, 0.9))
        poly(p, :fill)
        sethue("grey90")
        poly(p, :stroke, close=true)
    end
end 800 300
```

### Xor (exclusive OR): polyxor

Use [`polyunion()`](@ref) to find the polygonal areas that are inside either the first polygon or the second, but not both.

The returned result is an array of polygons.

```@example
using Luxor, Colors # hide
@drawsvg begin
    background("grey10")

    sector(O, 50, 100, 0 + π / 8, 2π - π / 8, :path)
    pg1 = pathtopoly()[1]
    pg2 = box(O, 250, 120)

    setopacity(0.6)

    translate(-200, 0)
    sethue("lightpink")
    poly(pg1, :fill)

    sethue("yellowgreen")
    poly(pg2, :fill)

    result = polyxor(pg2, pg1)

    translate(400, 0)
    for (i, p) in enumerate(result)
        sethue(HSB(30i, 0.9, 0.9))
        poly(p, :fill)
        sethue("grey90")
        poly(p, :stroke, close=true)
    end
end 800 300
```


### Difference: polydifference

Use [`polydifference()`](@ref) to find the polygonal areas that are inside the first polygon but not the second.

The returned result is an array of polygons.

```@example
using Luxor, Colors # hide
@drawsvg begin
    background("grey10")

    sector(O, 50, 100, 0 + π / 8, 2π - π / 8, :path)
    pg1 = pathtopoly()[1]
    pg2 = box(O, 250, 120)

    setopacity(0.6)

    translate(-200, 0)
    sethue("lightpink")
    poly(pg1, :fill)

    sethue("yellowgreen")
    poly(pg2, :fill)

    result = polydifference(pg1, pg2)

    translate(400, 0)
    for (i, p) in enumerate(result)
        sethue(HSB([0, 180, 310][i], 0.9, 0.9))
        poly(p, :fill)
        sethue("grey90")
        poly(p, :stroke, close=true)
    end
end 800 300
```

## Triangulation

Use [`polytriangulate`](@ref) to join the vertices of a polygon to form triangles. It returns an array of triangular polygons.

```@example
using Luxor, Random # hide
Drawing(600, 550, "../assets/figures/polytriangulate.png") # hide

origin() # hide
background("white") # hide
fontsize(18) # hide

pts = ngon(O, 200, 7, vertices=true)
triangles = polytriangulate(pts)

for (n, tri) in enumerate(triangles)
    sethue([Luxor.julia_purple,
            Luxor.julia_blue,
            Luxor.julia_red,
            Luxor.julia_green
            ][mod1(n, end)])
    poly(offsetpoly(tri, -2), action = :fill, close = true)
    sethue("white")
    text(string(n), polycentroid(tri), halign=:center)
end

sethue("red")
setline(3)
poly(pts, action = :stroke, close=true)

finish() # hide
nothing # hide
```

![polygon triangulation](../assets/figures/polytriangulate.png)

## How can you contribute?

If you _know any geometry_ you probably know more than me,
so there are plenty of improvements to algorithms waiting to
be made. There are some _TODO_ comments sprinkled through
the code, but plenty more opportunities for improvement.

_Update the code_, most of which was written for Julia
versions 0.2, v0.3 and 0.4 (remember when broadcasting
wasn't a thing?) so there are probably many areas where the
code could take more advantage of version 1.

There can always be _more tests_, as the present tests are
mainly visual, showing that something works, but there
should be much more testing of things that shouldn't work -
inappropriate input, overlapping polygons, coincident or
collinear points, anticlockwise polygons, etc.

More _systematic error-handling_ particularly of geometry
errors would be a good idea, rather than sprinkling
`throw(error())`s around when things look wrong.

# Create a Drawing

In Luxor you always work with a current drawing, so the first thing to do is to create one.

To create a drawing, and optionally specify the filename, type, and dimensions, use the [`Drawing`](@ref) constructor function.

To finish a drawing and close the file, use [`finish`](@ref).

If the drawing doesn't appear automatically in your notebook or editing environment, you can type [`preview`](@ref) to see it.

![jupyter](../assets/figures/jupyter.png)

If you're using VS Code, then PNG and SVG drawings should automatically appear in the Plots pane, if it's enabled. In a Pluto notebook, output appears above the cell. In a notebook environment, output appears in the next notebook cell.

![juno](../assets/figures/juno.png)

!!! note

    SVGs are text-based, and can get quite big. Up to a certain size, SVGs will preview as easily and quickly as PNGs. As they get larger, though, they'll take longer, and it won't be long before they'll take longer to preview than to create in the first place. Very large drawings in SVG format might not display at all.

In Julia, the result of the most recently evaluated expression is usually displayed in a suitable form for the current environment. If the most recent expression was a Luxor drawing, it will probably be displayed somewhere, unless you're working in the REPL. So  this code:

```julia
Drawing(100, 100, :png)
origin()
sethue("green")
circle(O, 10, :fill)
finish()
preview()
println("finished")
```

won't display a drawing with a circle - the most recent result is returned by `println()`, not `preview()`. 

## Quick drawings with macros

The [`@draw`](@ref), [`@svg`](@ref), [`@drawsvg`](@ref), [`@png`](@ref), and [`@pdf`](@ref) macros are designed to let you quickly create graphics without having to provide the usual boiler-plate functions.

!!! note

    The macros are shortcuts, designed to make it quick and easy to get started. You can save keystrokes and time, but, for full control over all parameters, use [`Drawing`](@ref).

For example, this:

```julia
@svg circle(Point(0, 0), 20, action = :stroke) 50 50
```

is equivalent to this:

```julia
Drawing(50, 50, "luxor-drawing-(timestamp).svg")
origin()
background("white")
sethue("black")
circle(Point(0, 0), 20, action = :stroke)
finish()
preview()
```

You can omit the width and height (thus defaulting to 600 by 600, except for `@imagematrix`), and you don't have to specify a filename (you'll get time-stamped files in the current working directory). For multiple lines, use either:

```julia
@svg begin
    setline(10)
    sethue("purple")
    circle(Point(0, 0), 20, action = :fill)
end
```

or (less nicely):

```julia
@svg (setline(10);
      sethue("purple");
      circle(Point(0, 0), 20, action = :fill)
     )
```

If you don't specify a size, the defaults are usually 600 by 600. If you don't specify a file name, files created with the macros are placed in your current working directory as `luxor-drawing-` followed by a time stamp. You don't even have to specify the suffix:

```julia
@svg juliacircles(150) 400 400 "test" # saves in "test.svg"
```

If you want to create drawings with transparent backgrounds, or work with the (0, 0) point at the top left, use the longer form, rather than the macros.

```julia
Drawing()
background(1, 1, 1, 0)
origin()
setline(30)
sethue("green")
box(BoundingBox() - 50, action = :stroke)
finish()
preview()
```

![transparent background](../assets/figures/transparentbackground.png)

### In-memory drawings

You can choose to store drawings in memory rather than use files. The advantage is that in-memory drawings are quicker, and the results can be passed as Julia data. Also, it's useful in some restricted environments to not have to worry about writing files.

This syntax for the [`Drawing`](@ref) function:

```julia
Drawing(width, height, surfacetype, [filename])
```

lets you supply `surfacetype` as a symbol (`:svg`, `:png`, `:image`, or `:rec`). This creates a new drawing of the given surface type and stores the image only in memory if no `filename` is supplied.

The [`@draw`](@ref) macro (equivalent to `Drawing(..., :png)`) creates a PNG drawing in-memory (not saved in a file). You should see it displayed if you're working in a suitable environment (VSCode, Jupyter, Pluto).

The SVG equivalent of `@draw` is [`@drawsvg`](@ref).

Use [`svgstring()`](@ref) to extract the SVG drawing's source as text.

If you want to generate SVG code without making a drawing, use `@savesvg` instead of `@drawsvg`.

### Concatenating SVG drawings

The Julia functions `hcat()` and `vcat()` can concatenate two SVG drawings horizontally or vertically.

```@example
using Luxor

d1 = @drawsvg begin
    sethue("blue")
    paint()
end 200 100

d2 = @drawsvg begin
    sethue("yellow")
    paint()
end 200 100

vcat(d1, d2)
```

### Creating many drawings

You can create many drawings in a loop by specifying the filenames. For example, this creates separate PNG drawings of every glyph in the Unicode range 0x20 to 0xff.

```julia
for (i, glyph) in enumerate(0x20:0xff)
    @png begin
        background("white")
        fontsize(300)
        fontface("JuliaMono-Black")
        text(string(Char(glyph)),
            halign=:center, valign=:middle)
    end 512 512 "/tmp/glyph-$(string(i))-0x$(string(glyph, base=16)).png"
end
```

## Interactive drawings

### Using Pluto

Pluto notebooks typically display the final result of a piece of code in a cell. So there are various ways you can organize your drawing code. For example:

```julia
using Luxor, PlutoUI, Colors

@bind x Slider(0:0.1:12)

@bind y Slider(1:12)

@draw begin
    setopacity(0.8)
    for i in 0:0.1:1
        sethue(HSB(360i, .8, .8))
        squircle(O, 50, 50, action = :fill, rt = x * i)
        rotate(2π/y)
    end
end 100 100
```

or

```julia
begin
    d = Drawing(800, 800, :svg)
    origin()
    for (n, m) in enumerate(exp10.(range(0.0, 2, step=0.2)))
        setmesh(mesh(convert(Vector{Point}, BoundingBox()/m),
            ["darkviolet","gold2", "firebrick2", "slateblue4"]))
        rotate(π/7)
        paint()
    end
    finish()
    d
end
```

![pluto examples](../assets/figures/pluto-example.png)

### Using Jupyter notebooks (IJulia and Interact)

This example uses Interact.jl to provide an HSB color widget.

!!! note
    
    Interact.jl may be obsolete by the time you read this.

```julia
using Interact, Colors, Luxor
@manipulate for h in 0:360, s in 0:0.01:1, b in 0:0.01:1
    d = Drawing(300, 300, :svg)
    sethue(Colors.HSB(h, s, b))
    origin()
    circle(Point(0, 0), 100, action = :fill)
    circle(polar(110, deg2rad(h)), 10, action = :fill)
    sethue("black")
    label(string(h, "°"), deg2rad(h), polar(120, deg2rad(h)))
    finish()
    d
end
```

![interactive](../assets/figures/interact.png)

## Drawing pixels

The `Drawing()` function accepts an array of ARGB32 values as a drawing surface.

ARGB32 is a type of 32 bit unsigned integer that combines four values (8 bits for alpha, 8 bits for Red, 8 for Green, and 8 for Blue) into a 32-bit number between 0 and 4,294,967,296. ARGB32 is defined in ColorTypes.jl, and is available in Luxor.jl via Colors.jl, as `Luxor.Colors.ARGB32`, or, if you're using Colors.jl or Images.jl, directly as `ARGB32`.

```julia
using Luxor

A = zeros(Luxor.Colors.ARGB32, 150, 600) # 150 rows, 600 columns

Drawing(A)

for i in 1:15:150
    A[i:i+10, 1:600] .= Luxor.Colors.RGB(rand(), rand(), rand())
end

origin()

for i in 1:100
    randomhue()
    ngon(rand(BoundingBox()), 15, 4, 0, :fill)
end

finish()
```

![buffer drawing](../assets/figures/buffer-drawing.png)

As a standard Julia array, `A` will be shown as an image in your notebook or editor if you're using Images.jl.

!!! note
    
    In this example the array uses Julian "column-major" array addressing. Luxor functions use the `Point` type on a Cartesian coordinate system, where the origin is (by default) at the top left of the drawing. Locations along the x-axis correspond to the column indices of the array, locations along the y-axis correspond to the rows of the array (until you use the `origin()` function, for example).

You can also create a pixel array on a PNG drawing when saved as a file:

```julia
using Luxor
using Images

A = zeros(ARGB32, 50, 50)

Drawing(A, "/tmp/t.png")
for p in eachindex(A)
    A[p] = RGBA(rand(), rand(), rand(), 1)
end
finish()
preview()
```

## Extracting the drawing as an image

If you create a drawing using `Drawing(w, h, :png)`, you can use the [`image_as_matrix`](@ref) function at any stage in the drawing process to extract the drawing in its current state as a matrix of pixels.

See the [Drawings as image matrices](@ref) section for more information.

## Recordings

The `:rec` option for `Drawing()` creates a recording surface in memory. You can then use `snapshot(filename, ...)` to copy the drawing into a file. See [Snapshots](@ref).

# Custom behavior for strokepath and fillpath

There are four functions that "paint" the current path to the drawing:
they are `strokepath` , `strokepreserve` , `fillpath`, and `fillpreserve`.
Other mechanisms to draw on the canvas are `clip` , `clippreserve` and `paint`.
(`text` is another function that draws on the canvas but is not considered here)

If you would like to have some custom behavior for these functions, such as adding a way to extract or modify paths etc.), Luxor provides a way to do so.

These four functions are basically defined as:

`funcname() = funcname(DISPATCHER[1])`
`funcname(::DefaultLuxor) = {...do_some_graphics_work...}`
`funcname(::LDispatcher) = funcname(DefaultLuxor())`

`DISPATCHER[1]` is defined as an instance of a struct (with no fields)
`DefaultLuxor`. The datatype `DefaultLuxor` is a subtype of `LDispatcher`.
`DISPATCHER` as such is defined as an array of `LDispatcher`. This is to make
it mutable. Only the first element ie. `DISPATCHER[1]` is ever used.

You can make custom behavior for the functions in the following way:

1. Define a new struct `MyDispatcher <: Luxor.LDispatcher` (it needn't have any fields).

2. Define a function that dispatches on the above struct.

3. Change `Luxor.DISPATCHER[1]` to an instance of your struct.

Here's an example of a method that changes the behavior of all calls
to `strokepath()` such that the current color is printed to the terminal as the path is drawn.

```julia
struct MyDispatcher <: Luxor.LDispatcher end
function Luxor.strokepath(::MyDispatcher)
    println("$(Luxor.get_current_color())")
    return Luxor.strokepath(Luxor.DefaultLuxor())
end
Luxor.DISPATCHER[1] = MyDispatcher()

@draw begin
    for i in 1:20
        randomhue()
        star(rand(BoundingBox()), 30, 6, 0.5, action = :stroke)
    end
end
```

Now, all calls to `strokepath()` whether explicitly called or through other
functions (for example, with the :stroke action) will print the current color
just before the path is stroked.

Similar dispatches can be written for `strokepreserve`, `fillpath`,
`fillpreserve`, `clip`, `clippreserve`, and `paint`.

Functions which don't have methods defined for the types will default
to calling `funcname(Luxor.DefaultLuxor())`

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Playing with pixels

As well as working with PNG, SVG, and PDF drawings, Luxor lets you play directly with pixels, and combine these freely with vector graphics and text.

This section is a quick walkthrough of some functions you can use to control pixels. You'll probably need the Images.jl package as well as Luxor.jl.

When you create a new Luxor drawing with [`Drawing()`](@ref), you can choose to use the contents of an existing Julia array as the drawing surface, rather than ask for a new PNG or SVG.

```@julia
using Luxor, Colors
A = zeros(ARGB32, 400, 800)
Drawing(A)
nothing # hide
```

The array `A` should be a matrix where each element is an *ARGB32& value. ARGB32 is a way of fitting four small integers (using 8 bits for alpha, 8 bits for Red, 8 for Green, and 8 for Blue) into a 32-bit number between 0 and 4,294,967,296 - each element is a 32 bit unsigned integer that represents a colored pixel. The ARGB32 type is provided by the Images.jl package (or ColorTypes.jl).

You can set and get the values of pixels by treating the drawing's array like a standard Julia array. So we can inspect pixels like this:

```julia
using Luxor, Colors # hide
A[10, 200]  # row 10, column 200

ARGB32(0.0N0f8,0.0N0f8,0.0N0f8,0.0N0f8)
```

and set them like this:

```julia
using Luxor, Colors # hide
A[10, 200] = colorant"red"

```

or even like this:

```julia
using Luxor, Colors # hide
A[:] = colorant"purple"
A[200:250, 100:250] .= colorant"green";
A[300:350, 50:450] .= colorant"blue";
[A[rand(1:(400 * 800))] = RGB(rand(), rand(), rand()) for i in 1:800]
```

Because this is an array rather than a PNG/SVG, we must either use Images.jl to display it in a notebook or code editor such as VS-Code.

```julia
A
```

![playing with pixels tutorial 1](../assets/figures/playing-pixels-1.png)

Or, to display it in Luxor, start a new drawing, and use [`placeimage()`](@ref) to position the array on the drawing:

```julia
using Luxor, Colors # hide
A = zeros(ARGB32, 400, 800)
Drawing(A)
A[200:250, 100:250] .= colorant"green"
A[300:350, 50:450] .= colorant"blue"
[A[rand(1:(400 * 800))] = RGB(rand(), rand(), rand()) for i in 1:800]
finish()
Drawing(800, 400, :png)
background("brown")
origin()
placeimage(A, Point(-400, -200))
rulers()
finish()
preview()
```

![playing with pixels tutorial 2](../assets/figures/playing-pixels-2.png)

Here's some code that sets the HSV color of each pixel to the value of some arbitrary maths function operating on complex numbers:

```julia
using Luxor, Colors, Images
A = zeros(ARGB32, 400, 800)
Drawing(A)
f(z) = (z + 3)^3 / ((z + 2im) * (z - 2im)^2)

function pixelcolor(r, c;
        rows = 100,
        cols = 100)
    z = rescale(r, 1, rows, -2π, 2π) + rescale(c, 2π, cols, -2π, 2π) * im
    n = f(z)
    h = 360rescale(angle(n), 0, 2π)
    s = abs(sin(π / 2 * real(f(z))))
    v = abs(sin(2π * real(f(z))))
    return HSV(h, s, v)
end
for r in 1:size(A, 1), c in 1:size(A, 2)
    A[r, c] = pixelcolor(r, c, rows = 400, cols = 800)
end
finish()
A
```

![playing with pixels tutorial 3](../assets/figures/playing-pixels-3.png)

## Rows and columns, height and width

A note about the two coordinate systems at work here.

Locations in arrays and images are typically specified with row and column values, or perhaps just a single index value. Because arrays are column-major in Julia, the address `A[10, 200]` is "row 10, column 200 of A", with a single index `A[79610]`.

Locations on plots and Luxor drawings are typically specified as Cartesian x and y coordinates. So `Point(10, 200)` would identify a point 10 units along the x-axis and 200 along the y-axis from the origin, In Luxor, like most computer graphics systems, the y-axis points vertically *down* the drawing.

The origin point of an array or image is the first pixel - usually drawn at the top left. In Luxor, the origin point (0/0) of a drawing (if created by `Drawing()`) is also at the top left, until you move it, or use the `origin()` function. (The `@draw` macros also set the origin at the centre of the drawing, for your convenience.)

When you're working on a pixel array drawing, you might find it useful to define a transformation matrix that converts vector graphics coordinates from the conventional `x/across/width` - `y/down/height` to the pixel array's `row/down/height`, `column/across/width` convention, as used for array access.

In this next example, the [`transform()`](@ref) function defines a matrix that flips the x and y coordinates, and shifts the origin to the "center" of the array.

Now you can specify the location of text and graphics using more typical vector-graphics coordinates - the text is placed at `Point(0, h/2 - 30)`, ie centered, 30 units above the bottom edge.

```@example
using Luxor, Colors
A = zeros(ARGB32, 400, 800)
Drawing(A)
f(z) = (z + 3)^3 / ((z + 2im) * (z - 2im)^2)
function pixelcolor(r, c;
        rows=100,
        cols=100)
    z = rescale(r, 1, rows, -2π, 2π) + rescale(c, 2π, cols, -2π, 2π) * im
    n = f(z)
    h = 360rescale(angle(n), 0, 2π)
    s = abs(sin(π / 2 * real(f(z)))) # * (sin(π * imag(f(z)))))
    v = abs(sin(2π * real(f(z))))
    return HSV(h, s, v)
end
for r in 1:size(A, 1), c in 1:size(A, 2)
    A[r, c] = pixelcolor(r, c, rows=400, cols=800)
end
w, h = 800, 400
transform([0 1 1 0 h/2 w/2])
fontsize(18)
sethue("white")
text("f(z) = (z + 3)^3 / ((z + 2im) * (z - 2im)^2)",
    Point(0, h/2 - 30), halign=:center)
A
nothing # hide
```

![playing with pixels tutorial 4](../assets/figures/playing-pixels-4.png)

A disadvantage is that `BoundingBox()` functions don't work, because they're not yet aware of transformation matrices.

## Array as image

An alternative way of using pixel arrays is to add them to a PNG or SVG drawing using [`placeimage`](@ref).

For example, create a new drawing, and this time place the array A on the drawing. You can use it like any other image, such as clipping it by the Julia logo:

```julia
# with A defined as above
w, h = 800, 400
Drawing(800, 400, :png)
origin()
placeimage(A, O - (w / 2, h / 2), alpha=0.3)
julialogo(centered=true, action=:clip)
placeimage(A, O - (w / 2, h / 2))
clipreset()
julialogo(centered=true, action=:path)
sethue("white")
strokepath()
finish()
preview()
```

![playing with pixels tutorial 5](../assets/figures/playing-pixels-5.png)

# Interactive graphics and Threads

## Continuous display

With the help of an external appication to manage windows, it's possible to use Luxor to create continuously changing graphics in a window.

### The `@play` macro

This example uses the [MiniFB](https://github.com/aviks/MiniFB.jl) package, which you can add using `] add MiniFB`.

The file `play.jl` defines a simple macro, `@play`, which continuously evaluates and draws the graphics in a window. For example, this code:

```julia
using Luxor

include(dirname(pathof(Luxor)) * "/play.jl")

let θ = 0
    @play 400 400 begin
    #
        background("black")
        sethue("white")
        rotate(θ)
        hypotrochoid(200, 110, 37, :stroke)
        θ += π/120
        sleep(0.01)
    #
    end
end
```

draws a continuously rotating hypotrochoid.

![live hypo](../assets/figures/live-hypo.gif)

### Clock

This code also imports the `@play` macro.

The call to `sleep` reduces the CPU time, and allows other processes to run, but the millisecond
animation will be less smooth as a result.

![clock](../assets/figures/clock.gif)

```julia
using Luxor, Colors, Dates, ColorSchemes

include(dirname(pathof(Luxor)) * "/play.jl")

function clock(cscheme=ColorSchemes.leonardo)
    @play 400 600 begin

        # background
        sethue(get(cscheme, .0))
        paint()

        # 24hour sector
        fontsize(30)
        sethue(get(cscheme, .2))
        h = Dates.hour(now())
        sector(O, 180, 200, π/2, π/2 + rescale(h, 0, 24, 0, 2pi), :fill)

        @layer begin
            fontsize(12)
            sethue("white")
            @. text(["0", "6", "12", "18"], polar(190, [i * π/2 for i in 1:4]),
                halign=:center,
                valign=:middle)
        end

        # minute sector
        sethue(get(cscheme, .4))
        m = Dates.minute(now())
        sector(O, 160, 180, 3π/2, 3π/2 + rescale(m, 0, 60, 0, 2pi), :fill)

        # second sector
        sethue(get(cscheme, .6))
        s = Dates.second(now())
        sector(O, 140, 160, 3π/2, 3π/2 + rescale(s, 0, 60, 0, 2pi), :fill)

        # millisecond indicator
        @layer begin
            setopacity(0.5)
            sethue(get(cscheme, .8))
            ms = Dates.value(Dates.Millisecond(Dates.now()))
            circle(polar(120, 3π/2 + rescale(ms, 0, 1000, 0, 2pi)), 20, :fill)
        end

        # central text
        fontface("JuliaMono-Black")
        sethue(get(cscheme, 1.0))
        text(Dates.format(Dates.now(), "HH:MM:SS"), halign=:center)

        sleep(0.05)
    end
end

clock(ColorSchemes.klimt)
```

## Live coding with MiniFB

Here are some examples of how to use Luxor with MiniFB as the display window, without using the simple `@play` macro.

### Interactivity

This example lets you type graphic commands at the REPL and see the results instantly displayed in a window.

First, run this code to connect a Luxor drawing to a MiniFB buffer:

```julia
using Luxor
using Colors
using MiniFB

function window_update_task(window, buffer, showFPS=false)
    state = mfb_update(window, buffer)
    updateCount = 0
    startTime = floor(Int, time())
    fps = "0"
    while state == MiniFB.STATE_OK
        if showFPS
            elapsedTime = floor(Int, time()) - startTime
            if elapsedTime > 1
                fps = string(round(Int, updateCount / elapsedTime))
                startTime = floor(Int, time())
                updateCount = 0
            end
            @layer begin
                setcolor("black")
                circle(boxtopleft() + (15, 15), 15, :fill)
                setcolor("white")
                fontsize(20)
                text(fps, boxtopleft() + (15, 15), halign=:center, valign=:middle)
            end
        end
        state = mfb_update(window, buffer)
        sleep(1.0 / 120.0)
        updateCount += 1
    end
    println("\nWindow closed\n")
end

const WIDTH = 800
const HEIGHT = 600

buffer = zeros(ARGB32, WIDTH, HEIGHT)
d = Drawing(buffer)
window = mfb_open_ex("MiniFB", WIDTH, HEIGHT, MiniFB.WF_RESIZABLE)
@async window_update_task(window, buffer, true)
```

Now, the window will display the results of any expressions you type at the REPL:

![live graphics 1](../assets/figures/live-coding-1.png)

### Live animations

If you want to do live animations in the window in a "while" loop, you need to call `sleep()` for a while to allow the `window_update_task()` to get some execution time.

In this example you can enter "q" and "return" in the REPL to stop the animation's while loop. Using "ctrl-c" to stop the animation could also stop the window update task by chance.

![live graphics 2](../assets/figures/livegraphics.gif)

```@raw html
<details closed>
<summary>Code for this example</summary>
```

```julia
mutable struct Ball
    position::Point
    velocity::Point
end
function sticks(w, h)
    channel = Channel(10)
    #enter "q" and "return" to stop the while loop
    @async while true
        kb = readline(stdin)
        if contains(kb, "q")
            put!(channel, 1)
            break
        end
    end
    colors = [ rand(1:255), rand(1:255), rand(1:255) ]
    newcolors  = [ rand(1:255), rand(1:255), rand(1:255) ]
    c = ARGB(colors[1]/255, colors[2]/255, colors[3]/255, 1.0)
    balls = [ Ball( rand(BoundingBox(Point(-w/2, -h/2), Point(w/2, h/2))), rand(BoundingBox(Point(-10, -10), Point(10, 10))) ) for _ in 1:2 ]
    while true
        background(0, 0, 0, 0.05)
        if colors == newcolors
            newcolors = [ rand(1:255), rand(1:255), rand(1:255) ]
        end
        for (index, (col, newcol)) in enumerate(zip(colors, newcolors))
            if col != newcol
                col > newcol ? col -= 1 : col += 1
                colors[index] = col
            end
        end
        c = ARGB(colors[1]/255, colors[2]/255, colors[3]/255, 1.0)
        for ball in balls
            if !(-w/2 < ball.position.x < w/2)
                ball.velocity = Point(-ball.velocity.x, ball.velocity.y)
            end
            if !(-h/2 < ball.position.y < h/2)
                ball.velocity = Point(ball.velocity.x, -ball.velocity.y)
            end
            ball.position = ball.position + ball.velocity
        end
        setcolor(c)
        line(balls[1].position, balls[2].position, :stroke)
        sleep(1.0/120.0)
        if isready(channel)
            break
        end
    end
end

origin()
sticks(WIDTH, HEIGHT)
```

```@raw html
</details>
```

### Interactive graphics with multiple drawings

This next example shows how to work with multiple drawings. We'll create three windows, then combine (`AND`) the contents of the first two and display them in the third.

![multiple drawings](../assets/figures/multiple-drawings.png)

First, we'll setup our display buffers and MiniFB windows, one for each Luxor drawing:

```julia
using MiniFB, Luxor, Colors, FixedPointNumbers

WIDTH = 500
HEIGHT = 500

function window_update_task(window,buffer)
    state = mfb_update(window,buffer)
    while state == MiniFB.STATE_OK
        state = mfb_update(window, buffer)
        sleep(1.0/120.0)
    end
    println("\nWindow closed\n")
end

window1 = mfb_open_ex("1", WIDTH, HEIGHT, MiniFB.WF_RESIZABLE)
buffer1 = zeros(ARGB32, WIDTH, HEIGHT)
@async window_update_task(window1,buffer1)

window2 = mfb_open_ex("2", WIDTH, HEIGHT, MiniFB.WF_RESIZABLE)
buffer2 = zeros(ARGB32, WIDTH, HEIGHT)
@async window_update_task(window2,buffer2)

window3 = mfb_open_ex("3=1+2", WIDTH, HEIGHT, MiniFB.WF_RESIZABLE)
buffer3 = zeros(ARGB32, WIDTH, HEIGHT)
@async window_update_task(window3,buffer3)
```

Buffers 1, 2, and 3 are the buffers for the three MiniFB windows. They'll appear on your display.

Next we'll create three Luxor drawings that connect to these buffers.

```julia
d1 = Drawing(buffer1)

Luxor._set_next_drawing_index()
d2 = Drawing(buffer2)

Luxor._set_next_drawing_index()
d3 = Drawing(buffer3, "julia.png")
```

We now have three drawings which are continuously updated and visible in three separate windows.
Let's start by drawing on drawing 1.

```julia
Luxor._set_drawing_index(1)
origin()
setopacity(0.4)
foregroundcolors = Colors.diverging_palette(
    rand(0:360),
    rand(0:360),
    200, s=0.99, b=0.8)
gsave()
for i in 1:500
    sethue(foregroundcolors[rand(1:end)])
    circle(Point(rand(-300:300), rand(-300:300)), 15, :fill)
end
grestore()
```

Now let's switch to drawing 2 and draw the Julia logo:

```julia
Luxor.set_drawing_index(2)
origin()
setopacity(1.0)
gsave()
julialogo(centered=true, bodycolor=colorant"white")
grestore()
```

Finally, we'll switch to drawing 3, and set its contents by ANDing the buffers of drawings 1 and 2:

```julia
Luxor.set_drawing_index(3)
background("black")
buffer3 .= reinterpret(ARGB{N0f8},
    (reinterpret.(UInt32,buffer1) .&
     reinterpret.(UInt32,buffer2)))
```

To finish, we'll set the opacity of each pixel to 1.0:

```julia
buffer3.=ARGB32.(RGB24.(buffer3))

finish()
preview()
```

## Threads

Luxor is thread safe. To run the examples below, [start Julia with more than 1 thread](https://docs.julialang.org/en/v1/manual/multi-threading/#Starting-Julia-with-multiple-threads). To see how many threads you have available, ask Julia:

```julia-repl
julia> Threads.nthreads()
4
```

As a first example, we'll produce multiple PNG files in parallel:

```julia
using Luxor # hide

tempdir = mktempdir(; cleanup=false)
cd(tempdir)

function make_drawings(i::Int)
    println("Working on thread ", Threads.threadid())
    w = 300
    h = 300
    filename = "sample" * string(i) * ".png"
    Drawing(w, h, filename)
    origin()
    background("black")
    setopacity(0.5)
    fontsize(250)
    sethue("grey40")
    text(string(i), halign=:center, valign=:middle)
    for k in 1:50
        pg1 = polycross(rand(BoundingBox()), rand(60:120), 4, vertices=true)
        pg2 = polycross(rand(BoundingBox()), rand(60:120), 4, vertices=true)
        pg3 = polyintersect(pg1, pg2)
        for p in pg3
            randomhue()
            poly(p, :fill)
        end
    end
    finish()
    return
end

Threads.@threads for i = 1:(2*Threads.nthreads())
    make_drawings(i)
end
```

```plain
Working on thread 2
Working on thread 3
Working on thread 4
Working on thread 2
Working on thread 1
Working on thread 3
Working on thread 1
Working on thread 4
```

![threads drawing](../assets/figures/threads.png)

## Advanced threads with live view

To demonstrate what is possible, we again show live graphics in MiniFB windows,
but this time in different threads.

There are two ways to use threads with Luxor.

One way is to use a single thread for
each window we want to show, i.e each window we spawn and the Luxor graphics inside
is a different thread.

The other way to use threads is e.g. a single window, with
several threads all drawing into the same buffer, which is shown in the single window.
For this you need to utilize locks as shown in the second example below.

### A thread for each window

First, here's an example where each window and its graphics is
a single thread. No locks or channels are needed.

Let's start with the header and a helper function for our animation:

```julia
using ThreadPools
# the low level Threads.@spawn macro can not be used, because threads are scheduled
# randomly into available threadids. If a thread is spawned into an already running
# threadid, the former thread # is closed by the scheduler. So we use the better
# ThreadPools.spawnbg to spawn the threads.

using MiniFB, Luxor, Colors, FixedPointNumbers

mutable struct Ball
    position::Point
    velocity::Point
end

function step_ball(ball, w, h, r)
    if ball.position.x - r < -w / 2 || ball.position.x + r > w / 2
        ball.velocity = Point(-ball.velocity.x, ball.velocity.y)
    end
    if ball.position.y - r < -h / 2 || ball.position.y + r > h / 2
        ball.velocity = Point(ball.velocity.x, -ball.velocity.y)
    end
    ball.position = ball.position + ball.velocity
    return ball
end
```

Open and run the first window in its own thread:

```julia
function window_ball()
    w = 500
    h = 500
    r = 50
    buffer = zeros(RGB24, w, h)
    ball = Ball(Point(0, 0), rand(BoundingBox(Point(-10, -10), Point(10, 10))))
    Drawing(buffer)
    origin()
    window = mfb_open_ex("Ball", w, h, MiniFB.WF_RESIZABLE)
    state = MiniFB.STATE_OK
    while state == MiniFB.STATE_OK
        ball = step_ball(ball, w, h, r)
        background(0.0, 0.0, 0.0, 1.0)
        setcolor("red")
        circle(ball.position.x, ball.position.y, r, :fill)
        state = mfb_update(window, buffer)
        sleep(1.0/120.0)
    end
    println("\nWindow closed\n")
end
spawnbg(window_ball)
```

Open and run a second window in its own thread:

```julia
function window_stick()
    w = 500
    h = 500
    r = 0
    buffer = zeros(RGB24, w, h)
    balls = [Ball(rand(BoundingBox(Point(-w/2, -h/2),
        Point(w/2, h/2))),
        rand(BoundingBox(Point(-10, -10), Point(10, 10)))) for _ in 1:2]
    Drawing(buffer)
    origin()
    background(0.0,0.0,0.0,1.0)
    window = mfb_open_ex("Sticks", w, h, MiniFB.WF_RESIZABLE)
    state = MiniFB.STATE_OK
    while state == MiniFB.STATE_OK
        background(0.0, 0.0, 0.0, 0.05)
        setcolor("green")
        for ball in balls
            ball=step_ball(ball, w, h, r)
        end
        line(balls[1].position, balls[2].position, :stroke)
        state=mfb_update(window, buffer)
        sleep(1.0/120.0)
    end
    println("\nWindow closed\n")
end
spawnbg(window_stick)
```

If you have threads left you can start another thread with a third window:

```julia
spawnbg(window_stick)
```

If you run out of threadids, the command `spawnbg(window_stick)` will block
the REPL until a thread is freed, e.g. by closing one of the windows.

### A single window with graphics of several threads

The next example shows a single window/buffer where several threads are
drawing into it. This needs some extra caution by utilizing locks, because
every thread uses the same drawing buffer. Therefore all drawing
commands needs to be synchronized with `lock`/`unlock`:

```julia
using ThreadPools

using MiniFB, Luxor, Colors

struct Window
    c::ReentrantLock
    w::Int
    h::Int
    d::Drawing
    buffer::Matrix{ARGB32}
    function Window(w,h)
        c = ReentrantLock()
        b = zeros(ARGB32, w, h)
        d = Drawing(b)
        origin()
        new(c,w,h,d,b)
    end
end

function window_update_task(win::Window, showFPS=true)
    w = win.w
    h = win.h
    updateCount = 0
    startTime = floor(Int, time())
    fps = "0"
    sb = zeros(ARGB32, 105, 55)
    window = mfb_open_ex("MiniFB", w, h, MiniFB.WF_RESIZABLE)
    state=MiniFB.STATE_OK
    set_drawing = true
    while state == MiniFB.STATE_OK
        lock(win.c)
        if set_drawing
            currentdrawing(win.d)
            set_drawing = false
        end
        if showFPS
            elapsedTime=floor(Int,time())-startTime
            if elapsedTime > 1
                fps=string(round(Int,updateCount/elapsedTime))
                startTime=floor(Int,time())
                updateCount=0
            end
            sb.=win.buffer[1:105, 1:55]
            @layer begin
                (dx,dy) = Point(0.0, 0.0) - getworldposition(Point(0.0, 0.0);centered=false)
                setcolor(1.0, 0, 0, 0.5)
                fontsize(50)
                text(fps, Point(5+dx, 5+dy), halign=:left, valign = :top)
            end
        end
        state=mfb_update(window,win.buffer)
        if showFPS
            win.buffer[1:105, 1:55].=sb
        end
        background(0, 0, 0, 0.05)
        unlock(win.c)
        sleep(1.0/120.0)
        updateCount+=1
    end
    println("\nWindow closed\n")
end
```

That's all we need to define a window with a fps display. Let's define it and run it as a new thread:

```julia
win = Window(800, 600)    # the window definition

# we need a function without parameter, that's what we create here:
let window=win
   global t_window_update_task
   function t_window_update_task()
       window_update_task(window)
   end
end

# run the task as a new thread:
spawnbg(t_window_update_task)
```

The window with a FPS display shows up. It runs in its own thread so we can still
use the REPL to create new threads which draw into this window. The most important
special code here is:

```julia
currentdrawing(win.d)
```

We start a new thread for every drawing and because the Luxor drawings of different
threads are separated from each other to ensure thread safety, we overwrite the
drawing in each thread with the drawing started with

```julia
win=Window(800, 600)
```

and stored in the `win`-object. See the constructor in `struct Window`.

Let's show it:

```julia
mutable struct Ball
    position::Point
    velocity::Point
end

function stick(win)
    w = win.w
    h = win.h
    colors = [rand(1:255), rand(1:255), rand(1:255)]
    newcolors = [rand(1:255), rand(1:255), rand(1:255)]
    c = ARGB(colors[1] / 255, colors[2] / 255, colors[3] / 255, 1.0)
    balls = [Ball(
        rand(BoundingBox(Point(-w / 2, -h / 2), Point(w / 2, h / 2))),
        rand(BoundingBox(Point(-10, -10), Point(10, 10))))
            for _ in 1:2]
    set_drawing = true
    while true
        if colors == newcolors
            newcolors = [rand(1:255), rand(1:255), rand(1:255)]
        end
        for (index, (col, newcol)) in enumerate(zip(colors, newcolors))
            if col != newcol
                col > newcol ? col -= 1 : col += 1
                colors[index] = col
            end
        end
        c = ARGB(colors[1] / 255, colors[2] / 255, colors[3] / 255, 1.0)
        for ball in balls
            if !(-w / 2 < ball.position.x < w / 2)
                ball.velocity = Point(-ball.velocity.x, ball.velocity.y)
            end
            if !(-h / 2 < ball.position.y < h / 2)
                ball.velocity = Point(ball.velocity.x, -ball.velocity.y)
            end
            ball.position = ball.position + ball.velocity
        end
        lock(win.c)
        if set_drawing
            currentdrawing(win.d)
            set_drawing = false
        end
        setcolor(c)
        line(balls[1].position, balls[2].position, :stroke)
        unlock(win.c)
        sleep(1.0 / 60.0)
    end
end

# again a function for calling without parameter:
let window=win
   global t_stick
   function t_stick()
       stick(window)
   end
end

# run the thread and let the sticks fly:
spawnbg(t_stick)
```

Because our threads are synchronized via `lock`/`unlock` we can spawn
low-level threads as much as we want and our machine allows:

```julia
function spawn_many()
    tid=1:Threads.nthreads()
    for i in tid
        t=Task(t_stick)
        ccall(:jl_set_task_tid, Cvoid, (Any, Cint), t, i-1)
        schedule(t)
    end
end
```

Now you can repeat it as much as you dare:

```julia
spawn_many()
```

# Luxor and Cairo

The aim of Luxor is to provide an easy to use
"scripting-like" interface to Cairo.jl.

!!! note

    Luxor.jl doesn't implement every function provided in
    Cairo.jl. Cairo.jl doesn't implement every function
    provided by the Cairo API.

As an example of the difference between Luxor and Cairo,
compare the two scripts below. Below left is one of
the original example files in the Cairo.jl repository. On the
right is a fairly literal conversion into a Luxor script.

![luxor and cairo](../assets/figures/luxor-cairo.png)

They both produce this image:

![sample arc](../assets/figures/sample_arc.png)

For convenience, and to provide a simpler interface, Luxor
introduces `Point`s and dispenses with `Context`s.

Both Cairo and Luxor use the same coordinate system (although the
Luxor `@-` macros position the `0/0` origin at the center of the
canvas). So although Cairo has to calculate the midpoint of
the drawing in line 13, Luxor has to calculate the position
of the top left corner in line 28.

A slighty more Luxor-idiomatic version of the code would be:

```julia
using Luxor

@png begin
    background(0.8, 0.8, 0.8)

    setline(10)
    setcolor("black")
    arc(centerpt, 100, π/4, π, :stroke)

    setcolor(1, 0.2, 0.2, 0.6)
    setline(6.0)

    circle(centerpt, 10.0, :fill)

    poly([polar(100, π), O, polar(100, π/4)], :stroke)

    setcolor("black")
    text(Libc.strftime(time()), boxtopleft(BoundingBox()) + (0,12))

end 256 256 "/tmp/sample_arc_luxor_2.png"
```

If you want to know more about how drawing in Cairo (and
by extension, Luxor) works, refer to the [Cairo
documentation](https://cairographics.org/documentation/).

## Adding Cairo functions

If a Cairo function isn't yet supported in Cairo.jl or Luxor.jl, a temporary workround is to add a direct call to the Cairo library in your Luxor script.

For example, the Cairo function to return the extents of the current path when stroked ([`cairo_stroke_extents`](https://cairographics.org/manual/cairo-cairo-t.html#cairo-stroke-extents)) isn't yet available in Julia's Cairo.jl, but you can add it with code like this:

```julia
using Luxor

function stroke_extents()
    dx1 = Cdouble[0]
    dx2 = Cdouble[0]
    dy1 = Cdouble[0]
    dy2 = Cdouble[0]
    ccall((:cairo_stroke_extents, Luxor.Cairo.libcairo),
        Nothing, (Ptr{Nothing}, Ptr{Cdouble}, Ptr{Cdouble},
            Ptr{Cdouble}, Ptr{Cdouble}),
        Luxor._get_current_cr().ptr, dx1, dy1, dx2, dy2)

    return BoundingBox(Point(dx1[1], dy1[1]), Point(dx2[1], dy2[1]))
end
```

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Introducing turtle graphics

![turtle splash](../assets/figures/turtle-splash.svg)

Luxor includes "turtle graphics". This is a way of making drawings by steering an imaginary turtle around a 2D drawing surface. The turtle holds (somehow) a pen, and draws lines behind it, as it wanders around the drawing obeying your instructions.

## How to type the turtle emoji

Luxor's turtles have names. You can call your turtles anything. If you like, you can create and name your turtle with a suitable emoji:

```julia
using Luxor

🐢 = Turtle() # type the turtle emoji \:turtle: TAB
```

That's "backslash colon turtle colon tab" in VS-Code, for example. (It's Unicode character `U+1F422`.)

Or you can use any simple Julia variable name if you'd prefer:

```julia
raphael = Turtle()
```

Then, you create a new drawing, and give the turtle some instructions.

## A very simple turtle graphics drawing

Here's a very simple example:

```julia
using Luxor, Colors # hide

@drawsvg begin
    background("honeydew")
    🐢 = Turtle()          # we create the turtle
    Forward(🐢, 100)       # go forward by 100 'steps'
    Turn(🐢, 90)           # turn 90° clockwise   
    Forward(🐢, 100)       # go forward by 100 'steps'
    Turn(🐢, 90)           # turn 90° clockwise  
    Forward(🐢, 100)       # go forward by 100 'steps'    
end
```

Or - with the same result, without using the drawing-creation macro (which saves a few keystrokes):

```@example
using Luxor, Colors # hide

Drawing(500, 500, :png)
origin()
background("honeydew")
🐢 = Turtle() 
Forward(🐢, 100)
Turn(🐢, 90)
Forward(🐢, 100)
Turn(🐢, 90)
Forward(🐢, 100)
finish()
preview()
```

- `Forward(🐢, 100)` tells the turtle called 🐢 to move forward 100 units. It's moved across the drawing, to the right.

- `Turn(🐢, 90)` tells the turtle called 🐢 to turn through 90° (clockwise)

and the two function calls are repeated, to give another line, and another turn, and another line.

Here's an animated view of how the image was made (I added the turtle):

![turtle first steps](../assets/figures/turtle-steps-1.gif)

Even with just these two instructions, you can make the turtle draw quite interesting things:

![turtle more steps](../assets/figures/turtle-steps-2.gif)

```julia
using Luxor, Colors # hide

@drawsvg begin
background("honeydew")
🐢 = Turtle()
for i in 1:200
    Forward(🐢, 50 + i)
    Turn(🐢, 85)
end 
end
```

The smaller turn angle of 85° makes the pattern more interesting.

!!! note

    All the turtle instructions in Luxor.jl start with an uppercase letter. This isn't considered good practice in Julia code; initial capitalization is supposed to be restricted to module and type names. In Luxor, this bad habit (I was young once) at least helps to distinguish between turtle graphics commands and non-turtle graphics commands.

The idea of turtle graphics is that it's easy to build up complicated pictures just by repeating very simple instructions such as moving along a line and turning through angles.

Here's a function that draws a pentagon; move forward five times, turn through 72° after each move:

```@example
using Luxor, Colors # hide

function a_pentagon(t::Turtle, s)
    for i in 1:5
        Forward(t, s)
        Turn(t, 72.0)
    end
end

@drawsvg begin
    background("honeydew")
    🐢 = Turtle()
    Penwidth(🐢, 10)
    Pencolor(🐢, "red")
    for i in 1:5
        a_pentagon(🐢, 100.0)
        HueShift(🐢, 30)
        Turn(🐢, 72)
    end
end
```

After the first pentagon is drawn by `a_pentagon`, the turtle rotates 72° - so the next pentagon doesn't overlap the previous one. We've used `HueShift()` as well, so that each pentagon is drawn in a different color, starting with red.

## More instructions

Turtles understand more instructions than just `Forward` and `Turn`:

- `Pendown(🐢)` (the default)
- `Penup(🐢)`  lift the pen from the drawing
- `Pencolor(🐢, r, g, b)` change the color (default is (0, 0, 0) i.e. "black")
- `Penwidth(🐢, w)` change the pen width to `w`
- `Circle(🐢, r)` draw a filled circle with radius `r`
- `Orientation(🐢, θ)` face θ°
- `Rectangle(🐢, w, h)` draw a rectangle with width `w` and height `h`
- `Reposition(🐢, pt)` move the turtle to a new location 
- `Message(🐢, t)` draw the text in `t`
- `HueShift(🐢, h)` change the hue of the pen's color by a `h`

plus a few more. All these require a turtle name as the first argument. The full list is here: [Turtle graphics](@ref).

This next drawing is also simple, but the gradual shifting hue - again thanks to `HueShift()` - is effective:

```@example
using Luxor, Colors # hide

function draw_graphics()
    🐢 = Turtle()
    Pencolor(🐢, "cyan")
    Penwidth(🐢, 1.5)
    n = 5
    for i in 1:400
        Forward(🐢, n)
        Turn(🐢, 89.5)
        HueShift(🐢)
        n += 1
    end
    fontsize(40)
    Reposition(🐢, Point(-250, -250))
    Pencolor(🐢, 1.0, 0.5, 0.0)
    Message(🐢, "finished")
end

@drawsvg begin
    draw_graphics()
end
```

You don't have to restrict yourself to drawing lines. With `Circle()` and `Rectangle()` you can create all kinds of images. 

Here's a visualization of two ways to draw the Julia logo with a turtle.

![comparing two methods](../assets/figures/turtle-logo-comparison.gif)

The version on the left is drawn by the turtle on a journey:

```julia
using Luxor, Colors # hide

@drawsvg begin
    colors = [Luxor.julia_purple, Luxor.julia_red, Luxor.julia_green]
    🐢 = Turtle()
    S = 50
    Penup(🐢)
    Turn(🐢, 30) ; Forward(🐢, S) ; 
        Pencolor(🐢, colors[1]); Pendown(🐢) ; 
        Circle(🐢, 40) ; Penup(🐢)
    Turn(🐢, 150) ; Forward(🐢, 2S) ; 
        Pencolor(🐢, colors[2]) ; Pendown(🐢) ; 
        Circle(🐢, 40) ; Penup(🐢)
    Turn(🐢, 120) ; Forward(🐢, 2S) ; 
        Pencolor(🐢, colors[3]) ; Pendown(🐢) ; 
        Circle(🐢, 40) ; Penup(🐢)
end 
```

THe version on the right repeats the same action three times:

```julia
using Luxor, Colors # hide

@drawsvg begin
    colors = [Luxor.julia_purple, Luxor.julia_red, Luxor.julia_green]
    🐢 = Turtle()
    for i in 1:3
        Push(🐢)
        Orientation(🐢, [30, 150, 270][i])
        Penup(🐢)
        Forward(🐢, 120)
        Pencolor(🐢, colors[i])
        Pendown(🐢)
        Circle(🐢, 80)
        Pop(🐢)    
    end
end
```

The `Push()` instruction tells the turtle to remember the current position and rotation on a *stack* and continue. `Pop()` gets information from the stack and then teleports the turtle to that position and orientation - forgetting where it was and where it was heading. This way, the same task - turn-forward-pencolor-pendown-circle - is easily repeated in different directions.

## Adding new commands

There's isn't a `Back()` instruction as you might expect - because it's not clear how it should work. For example, is it like putting a car in reverse and reversing, when you don't change the direction you're facing? Or is it like turning through 180° and then going forward? And do you turn round afterwards? But it's easy to add your own `Back()` command that does exactly what you want it to:

```@example
using Luxor, Colors # hide

function Back(t::Turtle, n)
    Turn(t, 180)
    Forward(t, n)
    Turn(t, 180) # looking forward again
end 

function draw_graphics(🐢::Turtle)
    for i in 1:8
        Forward(🐢, 150)
        Circle(🐢, 15)
        Back(🐢, 100)
        Turn(🐢, 45)
        HueShift(🐢, 30)
        Circle(🐢, 5)
    end
end

@drawsvg begin
    background("black")
    🐢 = Turtle()
    Penwidth(🐢, 30)
    Pencolor(🐢, "blue")
    draw_graphics(🐢)
end
```

## More turtles

Here's the code for the abstract splash image at the top of this section:

```julia
using Luxor, Colors # hide

Drawing(800, 300, "/tmp/turtles.svg")
origin()
background("black")
turtles = Turtle[]
for i in 1:100
    turtle = Turtle(rand(BoundingBox()))
    Pencolor(turtle, HSL(30rand(), 0.8, 0.7))
    Orientation(turtle, 360rand())
    Penwidth(turtle, .5)
    push!(turtles, turtle)
    for t in turtles
        HueShift(t, 5)
        Forward(t, rand(5:10))
        Turn(t, rand(-15:15))
        rand(Bool) ? Circle(t, 2) : Rectangle(t, 2, 2)
        Pen_opacity_random(t)
        pt = Point(t.xpos, t.ypos)
        if !isinside(pt, box(BoundingBox()))
            Towards(t, Point(0, 0))
        end
    end
end
finish()
preview()
```

This code generates a hundred turtles in random positions and moves and turns them randomly. When a turtle reaches the edge, its orientation is changed so that it points back to the center.

If you enjoy drawing with turtles, you might enjoy the [Lindenmayer.jl](https://github.com/cormullion/Lindenmayer.jl) package.

```julia
using Lindenmayer
using Luxor
using Colors

@draw begin
    background("black")
    setlinecap("round")
    penrose = LSystem(["X" => "PM++QM----YM[-PM----XM]++t",
            "Y" => "+PM--QM[---XM--YM]+t",
            "P" => "-XM++YM[+++PM++QM]-t",
            "Q" => "--PM++++XM[+QM++++YM]--YMt",
            "M" => "F",
            "F" => ""],
        "[Y]++[Y]++[Y]++[Y]++[Y]")

    # evaluate the LSystem
    Lindenmayer.evaluate(penrose, 5)

    # create a turtle
    🐢 = Turtle(colorant"purple")
    Penwidth(🐢, 5)
    Pencolor(🐢, "cyan")

    # render the LSystem's evaluation to the drawing 
    # forward 35, turn angle 36
    Lindenmayer.render(penrose, 🐢, 35, 36)
end
```

![penrose](../assets/figures/penrose.svg)

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```

# The drawing model

The underlying drawing model is that you build paths, and
these are filled and/or stroked, using the current *graphics
state*, which specifies colors, line thicknesses, scale,
orientation, opacity, and so on.

You can modify the current graphics state by
transforming/rotating/scaling it, setting color and style
parameters, and so on. Subsequent graphics use the new
state, but the graphics you've already drawn are unchanged.

Many of the drawing functions have an *action* argument,
supplied as a
keyword argument (eg `action=:fill`). This action determines
what happens to the current path. It can be `:fill`,
`:stroke`, `:fillstroke`, `:fillpreserve`,
`:strokepreserve`, `:clip`, or `:path`. The default is
usually `:path`, ie. add the graphics to the current path.

The main Julia data types you'll encounter in Luxor are:

| Name of type      | Purpose |
|:---               |:---     |
| Drawing           | holds the current drawing |
| Point             | specifies 2D points |
| BoundingBox       | defines a bounding box |
| Table             | defines a table with different column widths and row  heights |
| Partition         | defines a table defined by cell width and height |
| Tiler             | defines a rectangular grid of tiles |
| BezierPathSegment | a Bezier path segment defined by 4 points |
| BezierPath        | contains a series of BezierPathSegments |
| GridRect          | defines a rectangular grid |
| GridHex           | defines a hexagonal grid |
| Scene             | used to define a scene for an animation |
| Turtle            | represents a turtle for drawing turtle graphics |
| Path              | contains a complete path |

## Points and coordinates

You specify points on the drawing surface using `Point(x, y)`.

The default _origin_ (ie the `x = 0, y = 0` point) is at the
top left corner: the x axis runs left to right across the
page, and the y axis runs top to bottom down the page, so Y
coordinates increase downwards.

By default, `Point(0, 100)` is below `Point(0, 0)`.

```@setup origin_demo
using Luxor
svgimage = @drawsvg begin
sethue("antiquewhite")
box(boxtopleft(BoundingBox() + (40, 40)), boxbottomright(BoundingBox() - (40, 40)), action = :fill)
translate(boxtopleft(BoundingBox() + (40, 40)))
sethue("black")
circle(Point(0, 0), 6, action = :fill)
label("(0, 0)", :se, Point(0, 0), offset=15)
circle(Point(0, 100), 6, action = :fill)
label("(0, 100)", :se, Point(0, 100), offset=15)
rulers()
end
```

```@example origin_demo
svgimage # hide
```

!!! note

    Although this is the preferred coordinate system for most computer graphics
    software, including Luxor and Cairo, but mathematicians and scientists may
    well be used to the other convention, where the origin is in the center of
    the drawing and the y-axis increases up the page. See the macros such as
    [`@png`](@ref), [`@svg`](@ref), and [`@pdf`](@ref) which will put the origin
    at the center for you.

You can reposition the origin at any time, using [`origin`](@ref). The 'user
space' can be modified by functions such as [`scale`](@ref),
[`translate`](@ref), and [`rotate`](@ref), or more directly using matrix
transforms.

The Point type holds two coordinates, `x` and `y`. For example:

```@setup points
using Luxor
```

```@repl points
P = Point(12.0, 13.0)
P.x
P.y
```

Points are immutable, so you can't change `P`'s `x` or `y` values directly.
But it's easy to make new points based on existing ones.

Points can be added together:

```@repl points
Q = Point(4, 5)
P + Q
```

You can multiply Points and scalars:

```@repl points
10P
```

You can also make new points by mixing Points and tuples:

```@repl points
P + (10, 0)
Q * (0.5, 0.5)
```

You can also create points from tuples:

```@repl points
Point((1.0, 14))
plist = [(1.0, 2.0), (-10, 10), (14.2, 15.4)];
Point.(plist)
```

You can use the letter **O** as a shortcut to refer to the
current Origin, `Point(0, 0)`. Most coding fonts clearly
show the difference between the letter `O` and the digit `0`.

```@example
using Luxor # hide
Drawing(600, 300, "../assets/figures/point-ex.png") # hide
background("white") # hide
origin() # hide
sethue("blue") # hide
rulers()
box.([O + (i, 0) for i in range(0, stop=200, length=5)], 20, 20, action = :stroke)
finish() # hide
nothing # hide
```

![point example](../assets/figures/point-ex.png)

Angles are usually supplied in radians, measured starting at the positive x-axis turning towards the positive y-axis (which usually points 'down' the page or canvas). So rotations look ‘clockwise’. (The main exception is for turtle graphics, which conventionally let you supply angles in degrees.)

Coordinates are usually interpreted as PostScript points, where a point is 1/72 of an inch, or as pixels, at a DPI of 72ppi.

Because Julia allows you to combine numbers and variables directly, you can supply units with dimensions and have them converted to points (assuming the current scale is 1:1):

- inch (`in` is unavailable, being used by `for` syntax)
- cm   (centimeters)
- mm   (millimeters)

For example:

```julia
rect(Point(20mm, 2cm), 5inch, (22/7)inch, action = :fill)
```

# The drawing surface

The [`origin`](@ref) function moves the 0/0 point to the center of the drawing. It's often convenient to do this at the beginning of a program.

You can use functions like [`scale`](@ref), [`rotate`](@ref), and [`translate`](@ref) to change the coordinate system.

[`background`](@ref) fills the drawing with a color, covering any previous contents. By default, drawings have no backgrounds - they're transparent - but the short-cut macros `@draw`, `@svg`, `@eps`, and `@pdf` add a white background before drawing starts.  Use `Drawing()` to generate drawings with transparent backgrounds.

If there is a current clipping region, [`background`](@ref) fills just that region. In the next example, the first [`background`](@ref) fills the entire drawing with magenta, but the calls in the loop fill only the active clipping region, a table cell defined by the `Table` iterator:

```@example
using Luxor # hide
Drawing(600, 400, "../assets/figures/backgrounds.png") # hide
background("magenta")
origin()
table = Table(5, 5, 100, 50)
for (pos, n) in table
    box(pos,
        table.colwidths[table.currentcol],
        table.rowheights[table.currentrow],
        action = :clip)
    background(randomhue()...)
    clipreset()
end
finish() # hide
nothing # hide
```

![background](../assets/figures/backgrounds.png)

The [`rulers`](@ref) function draws a couple of rulers to indicate the position and orientation of the current axes.

```@example
using Luxor # hide
Drawing(400, 400, "../assets/figures/axes.png") # hide
background("gray80")
origin()
rulers()
finish() # hide
nothing # hide
```

![axes](../assets/figures/axes.png)

# Save and restore: layers and state

[`gsave`](@ref) saves a copy of the current graphics settings (current axis rotation, position, scale, line and text settings, color, and so on). When the next [`grestore`](@ref) is called, all changes you've made to the graphics settings will be discarded, and the previous settings are restored, so things return to how they were when you last used [`gsave`](@ref). [`gsave`](@ref) and [`grestore`](@ref) should always be balanced in pairs, enclosing the functions.

```julia
@svg begin
    circle(Point(0, 0), 100, action = :stroke)
    gsave()
        sethue("red")
        rule(Point(0, 0))
        rule(Point(0, 0), pi/2)
    grestore()
    circle(Point(0, 0), 200, action = :stroke)
end
```

The `@layer` macro is a shorter synonym for a [`gsave`](@ref)...[`grestore`](@ref) pair.

```julia
@svg begin
    circle(Point(0, 0), 100, action = :stroke)
    @layer (sethue("red"); rule(Point(0, 0)); rule(O, π/2))
    circle(Point(0, 0), 200, action = :stroke)
end
```

or

```julia
@svg begin
    circle(Point(0, 0), 100, action = :stroke)
    @layer begin
        sethue("red")
        rule(Point(0, 0))
        rule(Point(0, 0), pi/2)
    end
    circle(Point(0, 0), 200, action = :stroke)
end
```

## Return the current drawing

In some situations you'll want to explicitly return the current drawing to the calling function. Use [`currentdrawing`](@ref) or assign the result of `Drawing()` to a variable.

# Working in IDEs and notebooks

You can use an environment such as a Jupyter or Pluto notebook or VS Code IDEs, and load Luxor at the start of a session. The first drawing will take a few seconds, because the Cairo graphics engine needs to warm up. Subsequent drawings are then much quicker. (This is true of much graphics and plotting work. Julia compiles each function when it first encounters it, and then calls the compiled versions for the rest of the session.)

## Working in Jupyter

![Jupyter](../assets/figures/jupyter-basic.png)

## Working in VS Code

![VS Code](../assets/figures/vscode.png)

## Working in Pluto

![Pluto](../assets/figures/pluto.png)

# SVG images

Luxor can create new SVG images, either in a file or in
memory, and can also place existing SVG images on a drawing.
See [Placing images](@ref) for more. It's also possible to
obtain the source of the current SVG drawing as a string. For example,
this code draws the Julia logo using SVG code and stores the SVG in `s`:

```julia
Drawing(500, 500, :svg)
origin()
julialogo()
finish()
s = svgstring()
```

You can now examine the SVG elements in `s` programmatically:

```julia-repl
julia> eachmatch(r"rgb\(.*?\)", s) |> collect
5-element Vector{RegexMatch}:
 RegexMatch("rgb(0%,0%,0%)")
 RegexMatch("rgb(79.6%,23.5%,20%)")
 RegexMatch("rgb(25.1%,38.8%,84.7%)")
 RegexMatch("rgb(58.4%,34.5%,69.8%)")
 RegexMatch("rgb(22%,59.6%,14.9%)")
```

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```

# More examples

One place to look for examples is the `Luxor/test` directory.

!["tiled images"](../assets/figures/tiled-images.png)

## Other packages that work with Luxor

### 3D with Thebes.jl

Some limited 3D graphics capabilities can be added to Luxor using the [Thebes.jl](https://github.com/cormullion/Thebes.jl) package.

!["mobius band"](../assets/figures/mobius-band.svg)

```julia
using Luxor
using Thebes
using Colors

function makemobius()
    x(u, v) = (1 + (v / 2 * cos(u / 2))) * cos(u)
    y(u, v) = (1 + (v / 2 * cos(u / 2))) * sin(u)
    z(u, v) = v / 2 * sin(u / 2)
    w = 1
    st = 2π / 150
    Δ = 0.2
    result = Array{Point3D,1}[]
    for u in 0:st:2π-st
        for v in -w:Δ:w
            p1 = Point3D(
                x(u, v + Δ / 2),
                y(u, v + Δ / 2),
                z(u, v + Δ / 2))
            p2 = Point3D(
                x(u + st, v + Δ / 2),
                y(u + st, v + Δ / 2),
                z(u + st, v + Δ / 2))
            p3 = Point3D(
                x(u + st, v - Δ / 2),
                y(u + st, v - Δ / 2),
                z(u + st, v - Δ / 2))
            p4 = Point3D(
                x(u, v - Δ / 2),
                y(u, v - Δ / 2),
                z(u, v - Δ / 2))
            push!(result, [p1, p2, p3, p4])
        end
    end
    return result
end

@svg begin
    background("grey20")
    eyepoint(300, 250, 400)
    setline(0.5)
    setopacity(0.8)
    mb = makemobius()
    for pgon in mb
        randomhue()
        pin(100pgon, gfunction = (pt3, pt2)
        -> begin
            a = cartesiantospherical(pt3[1])
            sethue(HSL(rescale(a[2], 0, 2π, 0, 360), 0.8, 0.5))
            poly(pt2, :fillpreserve, close=true)
            sethue("white")
            strokepath()
        end 
        )
    end
end 800 600 "mobius-band.svg"
```

### Graphs with Karnak

Luxor provides the drawing tools for the graph visualization package [Karnak](https://github.com/cormullion/Karnak.jl).

!["karnak graph"](../assets/figures/karnak-barabasi.svg)

```julia

using Karnak
using Graphs
using Colors
g = barabasi_albert(100, 1)
@drawsvg begin
    background("black")
    sethue("grey40")
    fontsize(8)
    drawgraph(g, 
        layout=stress, 
        vertexlabels = 1:nv(g),
        vertexfillcolors = 
            [RGB(rand()/2, rand()/2, rand()/2) 
               for i in 1:nv(g)]
    )
end 600 400
```


## Illustrating this document

This documentation was built with [Documenter.jl](https://github.com/JuliaDocs/Documenter.jl), which is an amazingly powerful and flexible documentation generator written in Julia. The illustrations are mostly created when the HTML pages are built: the Julia source for the image is stored in the Markdown source document, and the code to create the images runs each time the documentation is generated.

The Markdown markup looks like this:

`````
```@example
using Luxor, Random # hide
Drawing(600, 250, "../assets/figures/polysmooth-pathological.png") # hide
origin() # hide
background("white") # hide
setopacity(0.75) # hide
Random.seed!(42) # hide
setline(1) # hide
p = star(O, 60, 5, 0.35, 0, vertices=true)
setdash("dot")
sethue("red")
prettypoly(p, close=true, action = :stroke)
setdash("solid")
sethue("black")
polysmooth(p, 40, :fill, debug=true)
finish() # hide
```

![polysmooth](../assets/figures/polysmooth-pathological.png)
`````

and after you run Documenter's build process the HTML output looks like this:

```@example
using Luxor, Random # hide
Drawing(600, 250, "../assets/figures/polysmoothy.png") # hide
origin() # hide
background("white") # hide
setopacity(0.75) # hide
Random.seed!(42) # hide
setline(1) # hide
p = star(O, 60, 5, 0.35, 0, vertices=true)
setdash("dot")
sethue("red")
prettypoly(p, close=true, action = :stroke)
setdash("solid")
sethue("black")
polysmooth(p, 40, :fill, debug=true)
finish() # hide
nothing # hide
```

![polysmooth](../assets/figures/polysmoothy.png)

## Why turtles?

An interesting application for turtle-style graphics is for drawing Lindenmayer systems (l-systems). Here's an example of how a complex pattern can emerge from a simple set of rules, taken from [Lindenmayer.jl](https://github.com/cormullion/Lindenmayer.jl):

![penrose](../assets/figures/penrose.png)

The definition of this figure is:

```julia
penrose = LSystem(Dict("X"  =>  "PM++QM----YM[-PM----XM]++t",
                       "Y"  => "+PM--QM[---XM--YM]+t",
                       "P"  => "-XM++YM[+++PM++QM]-t",
                       "Q"  => "--PM++++XM[+QM++++YM]--YMt",
                       "M"  => "F",
                       "F"  => ""),
                  "1[Y]++[Y]++[Y]++[Y]++[Y]")
```

where some of the characters—eg "F", "+", "-", and "t"—issue turtle control commands, and others—"X,", "Y", "P", and "Q"—refer to specific components of the design. The execution of the l-system involves replacing every occurrence in the drawing code of every dictionary key with the matching values.

## Strange

It's usually better to draw fractals and similar images
using pixels and image processing tools. But just for fun
it's an interesting experiment to render a strange attractor
image using vector drawing rather than placing pixels.

```@example
using Luxor, Colors
function strange(dotsize, w=800.0)
    xmin = -2.0; xmax = 2.0; ymin= -2.0; ymax = 2.0
    Drawing(w, w, "../assets/figures/strange-vector.png")
    origin()
    background("grey5")
    xinc = w / (xmax - xmin)
    yinc = w / (ymax - ymin)
    # control parameters
    a = 2.24
    b = 0.43
    c = -0.65
    d = -2.43
    e1 = 1.0
    x = y = z = 0.0
    wover2 = w / 2 - 50 # margin
    for j = 1:w
        for i = 1:w
            xx = sin(a * y) - z * cos(b * x)
            yy = z * sin(c * x) - cos(d * y)
            zz = e1 * sin(x)
            x = xx
            y = yy
            z = zz
            if xx < xmax && xx > xmin
                if yy < ymax && yy > ymin
                    xpos = rescale(
                        xx,
                        xmin,
                        xmax,
                        -wover2,
                        wover2,
                    ) # scale to range
                    ypos = rescale(
                        yy,
                        ymin,
                        ymax,
                        -wover2,
                        wover2,
                    ) # scale to range
                    rcolor = rescale(xx, -1, 1, 0.0, 0.6)
                    gcolor = rescale(yy, -1, 1, 0.2, 0.5)
                    bcolor = rescale(zz, -1, 1, 0.6, 0.9)
                    setcolor(rcolor, gcolor, bcolor)
                    move(Point(xpos, ypos))
                    line(Point(xpos + dotsize, ypos))
                    line(Point(
                        xpos + dotsize,
                        ypos + dotsize,
                    ))
                    line(Point(xpos, ypos + dotsize))
                    fillpath()
                end
            end
        end
    end
    finish()
end

strange(.5, 800)
nothing # hide
```

![strange attractor in vectors](../assets/figures/strange-vector.png)

This example generates about 650,000 paths, which is why
it’s better to target PNG rather than SVG or PDF for this
example. Also for speed, the “dots” are actually simple
square paths, which are slightly quicker to draw than circles or
polygons.

## More animations

[![strange attractor in vectors](../assets/figures/animation-screengrab.jpg)](https://youtu.be/1FA2FgJU6dM)

Most of the animations on [this YouTube channel](https://www.youtube.com/channel/UCfd52kTA5JpzOEItSqXLQxg) are made with Luxor.

# Gallery

Here are some more examples of Luxor in action. Please send your contributions for inclusion here!

## Luxor logo

Contributed by @cormullion.

![luxor logo](../assets/figures/luxor-logo.svg)

Code is here: Luxor > data > gallery > luxor-logo.jl

## A Japanese-style Temple scene

Contributed by **kfung**, a student that participated in [Google Code-in](https://codein.withgoogle.com/about/) 2019 competition.

![temple](../assets/figures/temple.png)

Code is here: Luxor > data > gallery > temple.jl

## A plot

Contributed by @stevensiew.

![graph](../assets/figures/graphdemo.svg)

Code is here: Luxor > data > gallery > graphdemo.jl

```@meta
DocTestSetup = quote
    using Luxor, Colors
end
```
# Simple examples

## The obligatory "Hello World"

Here's the "Hello world":

!["Hello world"](../assets/figures/hello-world.png)

```julia
using Luxor
Drawing(1000, 1000, "hello-world.png")
origin()
background("black")
sethue("red")
fontsize(50)
text("hello world")
finish()
preview()
```

`Drawing(1000, 1000, "hello-world.png")` defines the width,
height, location, and format of the finished image.
[`origin`](@ref) moves the 0/0 point to the centre of the
drawing surface (by default it's at the top left corner).
Thanks to `Colors.jl` we can specify colors by name as well
as by numeric value: [`background("black")`](@ref) defines
the color of the background of the drawing.
`text("helloworld")` draws the text. It's placed at the
current 0/0 point and left-justified if you don't specify
otherwise. [`finish`](@ref) completes the drawing and saves
the PNG image in the file. [`preview`](@ref) tries to
display the saved file, perhaps using another application
(eg Preview on macOS).

The macros `@png`, `@svg`, `@pdf`, `@draw`, and
`@imagematrix` provide shortcuts for making and previewing
graphics without you having to provide the usual set-up and
finish instructions:

So this macro:

```julia
using Luxor

@png begin
    fontsize(50)
    circle(Point(0, 0), 150, action = :stroke)
    text("hello world", halign=:center, valign=:middle)
end
```

![background](../assets/figures/hello-world-macro.png)

expands the 140 or so characters into this 250+ character source:

```julia
Drawing(600, 600, "luxor-drawing-072453_822.png")
origin()
background("white")
sethue("black")
fontsize(50)
circle(Point(0, 0), 150, action=:stroke)
text("hello world", halign=:center, valign=:middle)
finish()
preview()
```

The `@drawsvg` macro returns SVG code of the drawing which, in this Documenter-generated document, will be inserted into the HTML source of the page.

```@example
using Luxor

@drawsvg begin
    background("black")
    sethue("red")
    randpoint = Point(rand(-300:300), rand(-300:300))
    circle(randpoint, 5, action = :fill)
    sethue("white")
    foreach(f -> arrow(f, between(f, randpoint, .1), arrowheadlength=6),
        first.(collect(Table(fill(30, 20), fill(30, 20)))))
end
```

The `@draw` and `drawsvg` macros create a PNG or SVG format drawing in memory, rather than saved in a file, and the result of executing the code is returned and, in many editing environments, included and displayed as a graphic. For VS Code, the graphic is usually displayed in the plot pane. In Pluto, it appears above the cell.

```julia
using Luxor

@draw begin
    setopacity(0.85)
    steps = 20
    gap   = 2
    for (n, θ) in enumerate(range(0, step=2π/steps, length=steps))
        sethue([Luxor.julia_green,
            Luxor.julia_red,
            Luxor.julia_purple,
            Luxor.julia_blue][mod1(n, 4)])
        sector(Point(0, 0), 50, 250 + 2n, θ, θ + 2π/steps - deg2rad(gap), action = :fill)
    end
end
```

![background](../assets/figures/drawmacro.png)

![pluto logo](../assets/figures/plutodrawsvgmacro.png)

## The Julia logos

Luxor contains built-in functions that draw the Julia logo, either in color or a single color, and the three Julia circles.

```@example
using Luxor
Drawing(600, 400, "../assets/figures/julia-logos.png")
origin()
background("white")

for θ in range(0, step=π/8, length=16)
    gsave()
    scale(0.2)
    rotate(θ)
    translate(350, 0)
    julialogo(action=:fill, bodycolor=randomhue())
    grestore()
end

gsave()
scale(0.3)
juliacircles()
grestore()

translate(150, -150)
scale(0.3)
julialogo()
finish()

# preview()
nothing # hide
```

![background](../assets/figures/julia-logos.png)

The [`gsave`](@ref) function saves the current drawing environment temporarily, and any subsequent changes such as the [`scale`](@ref) and [`rotate`](@ref) operations are discarded when you call the next [`grestore`](@ref) function.

Use the extension to specify the format: for example, change `julia-logos.png` to `julia-logos.svg` or `julia-logos.pdf` or `julia-logos.eps` to produce SVG, PDF, or EPS format output.

## Something a bit more complicated: a Sierpinski triangle

Here's a version of the Sierpinski recursive triangle, clipped to a circle.

![Sierpinski](../assets/figures/sierpinski.png)

```julia
using Luxor, Colors
Drawing()
background("white")
origin()

function triangle(points, degree)
    sethue(cols[degree])
    poly(points, action = :fill)
end

function sierpinski(points, degree)
    triangle(points, degree)
    if degree > 1
        p1, p2, p3 = points
        sierpinski([p1, midpoint(p1, p2),
                        midpoint(p1, p3)], degree-1)
        sierpinski([p2, midpoint(p1, p2),
                        midpoint(p2, p3)], degree-1)
        sierpinski([p3, midpoint(p3, p2),
                        midpoint(p1, p3)], degree-1)
    end
end

function draw(n)
    circle(Point(0, 0), 75, :clip)
    points = ngon(Point(0, 0), 150, 3, -π/2, vertices=true)
    sierpinski(points, n)
end

depth = 8 # 12 is ok, 20 is right out (on my computer, at least)
cols = distinguishable_colors(depth) # from Colors.jl
draw(depth)

finish()
preview()
```

The Point type is an immutable composite type containing `x` and `y` fields that specify a 2D point.

## Formatted text

Use [`textformat()`](@ref) to display text with formatting:

```@example
using Luxor, Colors

function textbackground(pos, str;
        fillcolor="grey20",
        strokecolor="grey80",
        )
    @layer begin
        tx = textextents(str)
        bxwidth = tx[5] + 5
        bxheight = tx[4] - tx[2]
        hpos = pos.x + tx[5] / 2
        vpos = pos.y - tx[6] / 2 + tx[2] / 2
        bxcenter = Point(hpos, vpos)
        sethue(fillcolor)
        box(bxcenter, bxwidth, bxheight, :fillpreserve)
        sethue(strokecolor)
        strokepath()
    end
end

@drawsvg begin
background("black")
sethue("white")
fontsize(30)
textformat(
    (text="We", fontsize=40),
    "want a language that’s",
    (text="open source",
        prolog = textbackground,
        color = HSV(10, 0.9, 0.9)),
    (text="with a liberal license.",
        # fontface="Georgia-Bold"
        ),
    (text="We want the speed of",
        color = "orange",
        # fontface = "Georgia-Italic"
        ),
    (text="C",
        color="cyan", fontsize=30),
    (text="with the",),
    (text="d y n a m i s m", baseline=10),
    "of",
    (text="Ruby",
        advance=0,
        prolog=(a, b) -> textbackground(a, b, 
            strokecolor="orange", 
            fillcolor="#A91401"),
        # fontface="Courier",
        fontsize=40),
    ".",
    (text="We want a language that's",
        color="grey80",
        fontsize = 30),
        #fontface="Georgia-Bold",
    (text="homoiconic",
        # fontface="Courier-Bold",
        color="orange",
        fontsize=35,
        baseline=-15),
    (text="with true macros like",
        color="green"),
    (text="Lisp,",
        # fontface="CourierNewPS-BoldItalicMT",
        fontsize=40),
    (text="but with obvious, familiar mathematical notation like", 
        color="magenta",
        advance=30),
    (text="Matlab.",
        color="grey70",
        prolog=textbackground),
    position=boxtopleft() * 0.75,
    width=650,
    leading=200)
end 800 400
```

(but hopefully not quite as garish as this.)

## Simple numberlines

[`tickline()`](@ref) is useful for generating spaced points along a line:

```@example
using Luxor
@drawsvg begin
background("black")
fontsize(12)
sethue("white")
tickline(Point(-350, 0), Point(350, 0),
    finishnumber=100,
    log=true,
    major=7)
end 800 150
```

The [`arrow`](@ref) functions let you add decoration to the arrow shafts, so it's possible to use this function to create more complicated spacings. Here's how a curved number line could be made:

```@example
using Luxor
@drawsvg begin
    background("antiquewhite")
    _counter() = (a = -1; () -> a += 1)
    counter = _counter() # closure
    fontsize(15)
    arrow(O +  (0, 100), 200, π, 2π,
        arrowheadlength=0,
        decoration=range(0, 1, length=61),
        decorate = () -> begin
                d = counter()
                if d % 5 == 0
                    text(string(d), O + (0, -20), halign=:center)
                    setline(3)
                end
                line(O - (0, 5), O + (0, 5), action = :stroke)
            end
        )
end 800 300
```

The `decorate` function here adds graphics and text at the origin, which is located at each point along the shaft.

## Draw a matrix

To draw the contents of a matrix, you can use a Table to generate the
positions for the numbers.

It's sometimes useful to be able to highlight particular
cells. Here, numbers that have already been used once
are drawn in orange.

```@example
using Luxor

function drawmatrix(A::Matrix;
        cellsize = (10, 10))
    table = Table(size(A)..., cellsize...)
    used = Set()
    for i in CartesianIndices(A)
        r, c = Tuple(i)
        if A[r, c] ∈ used
            sethue("orange")
        else
            sethue("purple")
            push!(used, A[r, c])
        end
        text(string(A[r, c]), table[r, c],
            halign=:center,
            valign=:middle)
        sethue("white")
        box(table, r, c, action = :stroke)
    end
end

A = rand(1:99, 5, 8)

@drawsvg begin
    background("black")
    fontsize(30)
    setline(0.5)
    sethue("white")
    drawmatrix(A, cellsize = 10 .* size(A))
end
```

## Simple ``\LaTeX`` equations

You can draw simple ``\LaTeX`` equations by passing a string to `text()`, using the formats provided by the LaTeXStrings.jl package.

```@example
# drawing with 800×300 canvas
using Luxor
using MathTeXEngine
d = Drawing(800, 300, :svg)
origin()
background("khaki")
f(t) = Point(4cos(t) + 2cos(5t), 4sin(t) + 2sin(5t))
setline(15)
fontsize(35)
@layer begin
    setopacity(0.4)
    sethue("purple")
    poly(20f.(range(0, 2π, length=160)), action = :stroke)
end
sethue("grey5")
text(L"f(t) = [4\cos(t) + 2\cos(5t), 4\sin(t) + 2\sin(5t)]", O, halign=:center)
fontsize(5) # hide 
text(Libc.strftime(time()), boxtopleft(BoundingBox()) + (0, 12)) # hide
finish()
d # hide
```

![LaTeX text](../assets/figures/latexequation.svg)

See the [Writing LaTeX and Typst](@ref) section for more information. You'll have to install the fonts that MathTeXEngine.jl requires. 

## Basic typesetting with Typst

You can typeset text, including equations, onto Luxor drawings using the [Typstry](https://github.com/jakobjpeters/Typstry.jl) package, which uses the [Typst](https://typst.app) typesetting engine. Pass the text to be typeset as a `TypstString` to the `text()` function. General formatting and configuration information can be passed via the `preamble` keyword.

```julia
using Luxor
using Typstry

ts = typst"""$ f(t) = [4 cos(t) + 2 cos(5t), 4 sin(t) + 2 sin(5t)] $""";

ty_preamble = typst"""
    #set page(fill: none, 
        height: 300pt, width: 800pt, 
        margin: 140pt);
    #set text(fill: black, size: 35pt)
"""

d = Drawing(800, 300, "/tmp/typst.svg")
origin()
background("khaki")
f(t) = Point(4cos(t) + 2cos(5t), 4sin(t) + 2sin(5t))
setline(15)
@layer begin
    setopacity(0.4)
    sethue("purple")
    poly(20f.(range(0, 2π, length=160)), action=:stroke)
end
text(ts, O, preamble=ty_preamble, centered=true)
finish()
preview()
```

![Typst equation](../assets/figures/typstequation.svg)

You can render multipage Typst documents with the [`render_typst_document()`](@ref) function.

## Drawing pixels

You can use Luxor to draw into an array of ARGB32 values, which are essentially colored pixels. This example uses Images.jl to display the array.

```julia
using Luxor, Colors, Images

# a matrix of 150 rows, 600 columns
buffer = zeros(ARGB32, 150, 600) 

Drawing(buffer)
origin()

for i in 1:15:150
    buffer[i:i+10, 1:600] .= RGB(rand(), rand(), rand())
end

for i in 1:100
    randomhue()
    ngon(rand(BoundingBox()), 15, 4, 0, :fill)
end

finish()
buffer
```

![buffer drawing](../assets/figures/buffer-drawing.png)

## Triangulations

This example shows how a Delaunay triangulation of a set of
random points can be used to derive a set of Voronoi cells.

```@example
# Inspired by @TheCedarPrince!
using Luxor, Colors, Random
Random.seed!(42)

d = @drawsvg begin
background("black")
setlinejoin("bevel")
verts = randompointarray(BoundingBox(), 40)

triangles = polytriangulate(verts) # create Delaunay

@layer begin
    for tri in triangles
        sethue(HSB(rand(120:320), 0.7, 0.7))
        poly(tri, action = :stroke, close=true)
    end
end

dict = Dict{Point, Vector{Int}}()

for (n, t) in enumerate(triangles)
    for pt in t
        if haskey(dict, pt)
            push!(dict[pt], n)
        else
            dict[pt] = [n]
        end
    end
end

setopacity(0.9)
setline(3)
for v in verts
    hull = Point[]
    tris = dict[v]
    # vertex v belongs to all triangles tris
    for tri in tris
        push!(hull, trianglecenter(triangles[tri]...))
    end
    sethue(HSB(rand(120:320), 0.7, 0.7))
    if length(hull) >= 3
        ph = polyhull(hull)
        poly(ph, action = :fillpreserve, close=true)
        sethue("black")
        strokepath()
    end
end
end 800 500
d
```
